/* ex: set ro:
** !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
**
** This file is generated automatically from 'vtable.tbl' by
** tools/build/vtable_extend.pl
*/

/*
Copyright (C) 2001-2007, The Perl Foundation.

=head1 NAME

src/extend.c - Parrot extension interface

=head1 DESCRIPTION

These are the functions that Parrot extensions (that is, Parrot subroutines
written in C, or some other compiled language, rather than in Parrot
bytecode) may access.

There is a deliberate distancing from the internals here. Don't go
peeking inside -- you've as much access as bytecode does, but no more,
so we can provide backwards compatibility for as long as we possibly
can.

=head2 Functions

=over 4

=cut

*/

/* Some internal notes. Parrot will die a horrible and bizarre death
   if the stack start pointer's not set and a DOD run is
   triggered. The pointer *will* be set by the interpreter if the
   interpreter calls code which calls these functions, so most
   extension code is safe, no problem.

   The problem comes in if these routines are called from *outside*
   an interpreter. This happens when an embedding application calls
   them to do stuff with PMCs, STRINGS, interpreter contents, and
   suchlike things. This is perfectly legal -- in fact it's what
   we've documented should be done -- but the problem is that the
   stack base pointer will be NULL. This is Very Bad.

   To deal with this there are two macros that are defined to handle
   the problem.

   PARROT_CALLIN_START(interpreter) will figure out if the stack
   anchor needs setting and, if so, will set it. It must *always*
   come immediately after the last variable declared in the block
   making the calls into the interpreter, as it declares a variable
   and has some code.

   PARROT_CALLIN_END(interpreter) will put the stack anchor back to
   the way it was, and should always be the last statement before a
   return. (If you have multiple returns have it in multiple times)

   Not doing this is a good way to introduce bizarre heisenbugs, so
   just do it. This is the only place they ought to have to be put
   in, and most of the functions are already written, so it's not
   like it's an onerous requirement.

*/

#include "parrot/parrot.h"
#include "parrot/extend.h"

/* HEADER: none */ /* XXX Ideally the headerizer can run on this file as well. */

/*

=item C<Parrot_PMC
absolute(Parrot_Interp interp, Parrot_PMC pmc, Parrot_PMC dest)>

=cut

*/

PARROT_API Parrot_PMC
Parrot_PMC_absolute( Parrot_Interp interp, Parrot_PMC pmc, Parrot_PMC dest )
{
    Parrot_PMC retval;
    PARROT_CALLIN_START( interp );
    retval = VTABLE_absolute( interp, pmc, dest );
    PARROT_CALLIN_END( interp );
    return retval;
}

/*

=item C<void
add_attribute(Parrot_Interp interp, Parrot_PMC pmc, Parrot_String name, Parrot_PMC type)>

=cut

*/

PARROT_API void
Parrot_PMC_add_attribute( Parrot_Interp interp, Parrot_PMC pmc, Parrot_String name, Parrot_PMC type )
{
    PARROT_CALLIN_START( interp );
    VTABLE_add_attribute( interp, pmc, name, type );
    PARROT_CALLIN_END( interp );
    return;
}

/*

=item C<void
add_method(Parrot_Interp interp, Parrot_PMC pmc, Parrot_String method_name, Parrot_PMC sub_pmc)>

=cut

*/

PARROT_API void
Parrot_PMC_add_method( Parrot_Interp interp, Parrot_PMC pmc, Parrot_String method_name, Parrot_PMC sub_pmc )
{
    PARROT_CALLIN_START( interp );
    VTABLE_add_method( interp, pmc, method_name, sub_pmc );
    PARROT_CALLIN_END( interp );
    return;
}

/*

=item C<void
add_parent(Parrot_Interp interp, Parrot_PMC pmc, Parrot_PMC parent)>

=cut

*/

PARROT_API void
Parrot_PMC_add_parent( Parrot_Interp interp, Parrot_PMC pmc, Parrot_PMC parent )
{
    PARROT_CALLIN_START( interp );
    VTABLE_add_parent( interp, pmc, parent );
    PARROT_CALLIN_END( interp );
    return;
}

/*

=item C<void
add_role(Parrot_Interp interp, Parrot_PMC pmc, Parrot_PMC role)>

=cut

*/

PARROT_API void
Parrot_PMC_add_role( Parrot_Interp interp, Parrot_PMC pmc, Parrot_PMC role )
{
    PARROT_CALLIN_START( interp );
    VTABLE_add_role( interp, pmc, role );
    PARROT_CALLIN_END( interp );
    return;
}

/*

=item C<void
assign_pmc(Parrot_Interp interp, Parrot_PMC pmc, Parrot_PMC value)>

=cut

*/

PARROT_API void
Parrot_PMC_assign_pmc( Parrot_Interp interp, Parrot_PMC pmc, Parrot_PMC value )
{
    PARROT_CALLIN_START( interp );
    VTABLE_assign_pmc( interp, pmc, value );
    PARROT_CALLIN_END( interp );
    return;
}

/*

=item C<void
assign_string_native(Parrot_Interp interp, Parrot_PMC pmc, Parrot_String value)>

=cut

*/

PARROT_API void
Parrot_PMC_assign_string_native( Parrot_Interp interp, Parrot_PMC pmc, Parrot_String value )
{
    PARROT_CALLIN_START( interp );
    VTABLE_assign_string_native( interp, pmc, value );
    PARROT_CALLIN_END( interp );
    return;
}

/*

=item C<Parrot_PMC
bitwise_not(Parrot_Interp interp, Parrot_PMC pmc, Parrot_PMC dest)>

=cut

*/

PARROT_API Parrot_PMC
Parrot_PMC_bitwise_not( Parrot_Interp interp, Parrot_PMC pmc, Parrot_PMC dest )
{
    Parrot_PMC retval;
    PARROT_CALLIN_START( interp );
    retval = VTABLE_bitwise_not( interp, pmc, dest );
    PARROT_CALLIN_END( interp );
    return retval;
}

/*

=item C<Parrot_PMC
bitwise_nots(Parrot_Interp interp, Parrot_PMC pmc, Parrot_PMC dest)>

=cut

*/

PARROT_API Parrot_PMC
Parrot_PMC_bitwise_nots( Parrot_Interp interp, Parrot_PMC pmc, Parrot_PMC dest )
{
    Parrot_PMC retval;
    PARROT_CALLIN_START( interp );
    retval = VTABLE_bitwise_nots( interp, pmc, dest );
    PARROT_CALLIN_END( interp );
    return retval;
}

/*

=item C<Parrot_Int
can(Parrot_Interp interp, Parrot_PMC pmc, Parrot_String method)>

=cut

*/

PARROT_API Parrot_Int
Parrot_PMC_can( Parrot_Interp interp, Parrot_PMC pmc, Parrot_String method )
{
    Parrot_Int retval;
    PARROT_CALLIN_START( interp );
    retval = VTABLE_can( interp, pmc, method );
    PARROT_CALLIN_END( interp );
    return retval;
}

/*

=item C<Parrot_Int
class_type(Parrot_Interp interp, Parrot_PMC pmc)>

=cut

*/

PARROT_API Parrot_Int
Parrot_PMC_class_type( Parrot_Interp interp, Parrot_PMC pmc )
{
    Parrot_Int retval;
    PARROT_CALLIN_START( interp );
    retval = VTABLE_class_type( interp, pmc );
    PARROT_CALLIN_END( interp );
    return retval;
}

/*

=item C<Parrot_PMC
clone(Parrot_Interp interp, Parrot_PMC pmc)>

=cut

*/

PARROT_API Parrot_PMC
Parrot_PMC_clone( Parrot_Interp interp, Parrot_PMC pmc )
{
    Parrot_PMC retval;
    PARROT_CALLIN_START( interp );
    retval = VTABLE_clone( interp, pmc );
    PARROT_CALLIN_END( interp );
    return retval;
}

/*

=item C<Parrot_PMC
clone_pmc(Parrot_Interp interp, Parrot_PMC pmc, Parrot_PMC args)>

=cut

*/

PARROT_API Parrot_PMC
Parrot_PMC_clone_pmc( Parrot_Interp interp, Parrot_PMC pmc, Parrot_PMC args )
{
    Parrot_PMC retval;
    PARROT_CALLIN_START( interp );
    retval = VTABLE_clone_pmc( interp, pmc, args );
    PARROT_CALLIN_END( interp );
    return retval;
}

/*

=item C<void
decrement(Parrot_Interp interp, Parrot_PMC pmc)>

=cut

*/

PARROT_API void
Parrot_PMC_decrement( Parrot_Interp interp, Parrot_PMC pmc )
{
    PARROT_CALLIN_START( interp );
    VTABLE_decrement( interp, pmc );
    PARROT_CALLIN_END( interp );
    return;
}

/*

=item C<Parrot_Int
defined(Parrot_Interp interp, Parrot_PMC pmc)>

=cut

*/

PARROT_API Parrot_Int
Parrot_PMC_defined( Parrot_Interp interp, Parrot_PMC pmc )
{
    Parrot_Int retval;
    PARROT_CALLIN_START( interp );
    retval = VTABLE_defined( interp, pmc );
    PARROT_CALLIN_END( interp );
    return retval;
}

/*

=item C<Parrot_Int
defined_keyed(Parrot_Interp interp, Parrot_PMC pmc, Parrot_PMC key)>

=cut

*/

PARROT_API Parrot_Int
Parrot_PMC_defined_keyed( Parrot_Interp interp, Parrot_PMC pmc, Parrot_PMC key )
{
    Parrot_Int retval;
    PARROT_CALLIN_START( interp );
    retval = VTABLE_defined_keyed( interp, pmc, key );
    PARROT_CALLIN_END( interp );
    return retval;
}

/*

=item C<Parrot_Int
defined_keyed_int(Parrot_Interp interp, Parrot_PMC pmc, Parrot_Int key)>

=cut

*/

PARROT_API Parrot_Int
Parrot_PMC_defined_keyed_int( Parrot_Interp interp, Parrot_PMC pmc, Parrot_Int key )
{
    Parrot_Int retval;
    PARROT_CALLIN_START( interp );
    retval = VTABLE_defined_keyed_int( interp, pmc, key );
    PARROT_CALLIN_END( interp );
    return retval;
}

/*

=item C<Parrot_Int
defined_keyed_str(Parrot_Interp interp, Parrot_PMC pmc, Parrot_String key)>

=cut

*/

PARROT_API Parrot_Int
Parrot_PMC_defined_keyed_str( Parrot_Interp interp, Parrot_PMC pmc, Parrot_String key )
{
    Parrot_Int retval;
    PARROT_CALLIN_START( interp );
    retval = VTABLE_defined_keyed_str( interp, pmc, key );
    PARROT_CALLIN_END( interp );
    return retval;
}

/*

=item C<void
delete_keyed(Parrot_Interp interp, Parrot_PMC pmc, Parrot_PMC key)>

=cut

*/

PARROT_API void
Parrot_PMC_delete_keyed( Parrot_Interp interp, Parrot_PMC pmc, Parrot_PMC key )
{
    PARROT_CALLIN_START( interp );
    VTABLE_delete_keyed( interp, pmc, key );
    PARROT_CALLIN_END( interp );
    return;
}

/*

=item C<void
delete_keyed_int(Parrot_Interp interp, Parrot_PMC pmc, Parrot_Int key)>

=cut

*/

PARROT_API void
Parrot_PMC_delete_keyed_int( Parrot_Interp interp, Parrot_PMC pmc, Parrot_Int key )
{
    PARROT_CALLIN_START( interp );
    VTABLE_delete_keyed_int( interp, pmc, key );
    PARROT_CALLIN_END( interp );
    return;
}

/*

=item C<void
delete_keyed_str(Parrot_Interp interp, Parrot_PMC pmc, Parrot_String key)>

=cut

*/

PARROT_API void
Parrot_PMC_delete_keyed_str( Parrot_Interp interp, Parrot_PMC pmc, Parrot_String key )
{
    PARROT_CALLIN_START( interp );
    VTABLE_delete_keyed_str( interp, pmc, key );
    PARROT_CALLIN_END( interp );
    return;
}

/*

=item C<void
delprop(Parrot_Interp interp, Parrot_PMC pmc, Parrot_String key)>

=cut

*/

PARROT_API void
Parrot_PMC_delprop( Parrot_Interp interp, Parrot_PMC pmc, Parrot_String key )
{
    PARROT_CALLIN_START( interp );
    VTABLE_delprop( interp, pmc, key );
    PARROT_CALLIN_END( interp );
    return;
}

/*

=item C<void
destroy(Parrot_Interp interp, Parrot_PMC pmc)>

=cut

*/

PARROT_API void
Parrot_PMC_destroy( Parrot_Interp interp, Parrot_PMC pmc )
{
    PARROT_CALLIN_START( interp );
    VTABLE_destroy( interp, pmc );
    PARROT_CALLIN_END( interp );
    return;
}

/*

=item C<Parrot_Int
does(Parrot_Interp interp, Parrot_PMC pmc, Parrot_String method)>

=cut

*/

PARROT_API Parrot_Int
Parrot_PMC_does( Parrot_Interp interp, Parrot_PMC pmc, Parrot_String method )
{
    Parrot_Int retval;
    PARROT_CALLIN_START( interp );
    retval = VTABLE_does( interp, pmc, method );
    PARROT_CALLIN_END( interp );
    return retval;
}

/*

=item C<Parrot_Int
elements(Parrot_Interp interp, Parrot_PMC pmc)>

=cut

*/

PARROT_API Parrot_Int
Parrot_PMC_elements( Parrot_Interp interp, Parrot_PMC pmc )
{
    Parrot_Int retval;
    PARROT_CALLIN_START( interp );
    retval = VTABLE_elements( interp, pmc );
    PARROT_CALLIN_END( interp );
    return retval;
}

/*

=item C<Parrot_Int
exists_keyed(Parrot_Interp interp, Parrot_PMC pmc, Parrot_PMC key)>

=cut

*/

PARROT_API Parrot_Int
Parrot_PMC_exists_keyed( Parrot_Interp interp, Parrot_PMC pmc, Parrot_PMC key )
{
    Parrot_Int retval;
    PARROT_CALLIN_START( interp );
    retval = VTABLE_exists_keyed( interp, pmc, key );
    PARROT_CALLIN_END( interp );
    return retval;
}

/*

=item C<Parrot_Int
exists_keyed_int(Parrot_Interp interp, Parrot_PMC pmc, Parrot_Int key)>

=cut

*/

PARROT_API Parrot_Int
Parrot_PMC_exists_keyed_int( Parrot_Interp interp, Parrot_PMC pmc, Parrot_Int key )
{
    Parrot_Int retval;
    PARROT_CALLIN_START( interp );
    retval = VTABLE_exists_keyed_int( interp, pmc, key );
    PARROT_CALLIN_END( interp );
    return retval;
}

/*

=item C<Parrot_Int
exists_keyed_str(Parrot_Interp interp, Parrot_PMC pmc, Parrot_String key)>

=cut

*/

PARROT_API Parrot_Int
Parrot_PMC_exists_keyed_str( Parrot_Interp interp, Parrot_PMC pmc, Parrot_String key )
{
    Parrot_Int retval;
    PARROT_CALLIN_START( interp );
    retval = VTABLE_exists_keyed_str( interp, pmc, key );
    PARROT_CALLIN_END( interp );
    return retval;
}

/*

=item C<Parrot_PMC
find_method(Parrot_Interp interp, Parrot_PMC pmc, Parrot_String method_name)>

=cut

*/

PARROT_API Parrot_PMC
Parrot_PMC_find_method( Parrot_Interp interp, Parrot_PMC pmc, Parrot_String method_name )
{
    Parrot_PMC retval;
    PARROT_CALLIN_START( interp );
    retval = VTABLE_find_method( interp, pmc, method_name );
    PARROT_CALLIN_END( interp );
    return retval;
}

/*

=item C<Parrot_PMC
get_attr(Parrot_Interp interp, Parrot_PMC pmc, Parrot_Int idx)>

=cut

*/

PARROT_API Parrot_PMC
Parrot_PMC_get_attr( Parrot_Interp interp, Parrot_PMC pmc, Parrot_Int idx )
{
    Parrot_PMC retval;
    PARROT_CALLIN_START( interp );
    retval = VTABLE_get_attr( interp, pmc, idx );
    PARROT_CALLIN_END( interp );
    return retval;
}

/*

=item C<Parrot_PMC
get_attr_str(Parrot_Interp interp, Parrot_PMC pmc, Parrot_String idx)>

=cut

*/

PARROT_API Parrot_PMC
Parrot_PMC_get_attr_str( Parrot_Interp interp, Parrot_PMC pmc, Parrot_String idx )
{
    Parrot_PMC retval;
    PARROT_CALLIN_START( interp );
    retval = VTABLE_get_attr_str( interp, pmc, idx );
    PARROT_CALLIN_END( interp );
    return retval;
}

/*

=item C<Parrot_PMC
get_bignum(Parrot_Interp interp, Parrot_PMC pmc)>

=cut

*/

PARROT_API Parrot_PMC
Parrot_PMC_get_bignum( Parrot_Interp interp, Parrot_PMC pmc )
{
    Parrot_PMC retval;
    PARROT_CALLIN_START( interp );
    retval = VTABLE_get_bignum( interp, pmc );
    PARROT_CALLIN_END( interp );
    return retval;
}

/*

=item C<Parrot_Int
get_bool(Parrot_Interp interp, Parrot_PMC pmc)>

=cut

*/

PARROT_API Parrot_Int
Parrot_PMC_get_bool( Parrot_Interp interp, Parrot_PMC pmc )
{
    Parrot_Int retval;
    PARROT_CALLIN_START( interp );
    retval = VTABLE_get_bool( interp, pmc );
    PARROT_CALLIN_END( interp );
    return retval;
}

/*

=item C<Parrot_PMC
get_class(Parrot_Interp interp, Parrot_PMC pmc)>

=cut

*/

PARROT_API Parrot_PMC
Parrot_PMC_get_class( Parrot_Interp interp, Parrot_PMC pmc )
{
    Parrot_PMC retval;
    PARROT_CALLIN_START( interp );
    retval = VTABLE_get_class( interp, pmc );
    PARROT_CALLIN_END( interp );
    return retval;
}

/*

=item C<Parrot_Int
get_integer(Parrot_Interp interp, Parrot_PMC pmc)>

=cut

*/

PARROT_API Parrot_Int
Parrot_PMC_get_integer( Parrot_Interp interp, Parrot_PMC pmc )
{
    Parrot_Int retval;
    PARROT_CALLIN_START( interp );
    retval = VTABLE_get_integer( interp, pmc );
    PARROT_CALLIN_END( interp );
    return retval;
}

/*

=item C<Parrot_Int
get_integer_keyed(Parrot_Interp interp, Parrot_PMC pmc, Parrot_PMC key)>

=cut

*/

PARROT_API Parrot_Int
Parrot_PMC_get_integer_keyed( Parrot_Interp interp, Parrot_PMC pmc, Parrot_PMC key )
{
    Parrot_Int retval;
    PARROT_CALLIN_START( interp );
    retval = VTABLE_get_integer_keyed( interp, pmc, key );
    PARROT_CALLIN_END( interp );
    return retval;
}

/*

=item C<Parrot_Int
get_integer_keyed_int(Parrot_Interp interp, Parrot_PMC pmc, Parrot_Int key)>

=cut

*/

PARROT_API Parrot_Int
Parrot_PMC_get_integer_keyed_int( Parrot_Interp interp, Parrot_PMC pmc, Parrot_Int key )
{
    Parrot_Int retval;
    PARROT_CALLIN_START( interp );
    retval = VTABLE_get_integer_keyed_int( interp, pmc, key );
    PARROT_CALLIN_END( interp );
    return retval;
}

/*

=item C<Parrot_Int
get_integer_keyed_str(Parrot_Interp interp, Parrot_PMC pmc, Parrot_String key)>

=cut

*/

PARROT_API Parrot_Int
Parrot_PMC_get_integer_keyed_str( Parrot_Interp interp, Parrot_PMC pmc, Parrot_String key )
{
    Parrot_Int retval;
    PARROT_CALLIN_START( interp );
    retval = VTABLE_get_integer_keyed_str( interp, pmc, key );
    PARROT_CALLIN_END( interp );
    return retval;
}

/*

=item C<Parrot_PMC
get_iter(Parrot_Interp interp, Parrot_PMC pmc)>

=cut

*/

PARROT_API Parrot_PMC
Parrot_PMC_get_iter( Parrot_Interp interp, Parrot_PMC pmc )
{
    Parrot_PMC retval;
    PARROT_CALLIN_START( interp );
    retval = VTABLE_get_iter( interp, pmc );
    PARROT_CALLIN_END( interp );
    return retval;
}

/*

=item C<Parrot_Float
get_number(Parrot_Interp interp, Parrot_PMC pmc)>

=cut

*/

PARROT_API Parrot_Float
Parrot_PMC_get_number( Parrot_Interp interp, Parrot_PMC pmc )
{
    Parrot_Float retval;
    PARROT_CALLIN_START( interp );
    retval = VTABLE_get_number( interp, pmc );
    PARROT_CALLIN_END( interp );
    return retval;
}

/*

=item C<Parrot_Float
get_number_keyed(Parrot_Interp interp, Parrot_PMC pmc, Parrot_PMC key)>

=cut

*/

PARROT_API Parrot_Float
Parrot_PMC_get_number_keyed( Parrot_Interp interp, Parrot_PMC pmc, Parrot_PMC key )
{
    Parrot_Float retval;
    PARROT_CALLIN_START( interp );
    retval = VTABLE_get_number_keyed( interp, pmc, key );
    PARROT_CALLIN_END( interp );
    return retval;
}

/*

=item C<Parrot_Float
get_number_keyed_int(Parrot_Interp interp, Parrot_PMC pmc, Parrot_Int key)>

=cut

*/

PARROT_API Parrot_Float
Parrot_PMC_get_number_keyed_int( Parrot_Interp interp, Parrot_PMC pmc, Parrot_Int key )
{
    Parrot_Float retval;
    PARROT_CALLIN_START( interp );
    retval = VTABLE_get_number_keyed_int( interp, pmc, key );
    PARROT_CALLIN_END( interp );
    return retval;
}

/*

=item C<Parrot_Float
get_number_keyed_str(Parrot_Interp interp, Parrot_PMC pmc, Parrot_String key)>

=cut

*/

PARROT_API Parrot_Float
Parrot_PMC_get_number_keyed_str( Parrot_Interp interp, Parrot_PMC pmc, Parrot_String key )
{
    Parrot_Float retval;
    PARROT_CALLIN_START( interp );
    retval = VTABLE_get_number_keyed_str( interp, pmc, key );
    PARROT_CALLIN_END( interp );
    return retval;
}

/*

=item C<Parrot_PMC
get_pmc(Parrot_Interp interp, Parrot_PMC pmc)>

=cut

*/

PARROT_API Parrot_PMC
Parrot_PMC_get_pmc( Parrot_Interp interp, Parrot_PMC pmc )
{
    Parrot_PMC retval;
    PARROT_CALLIN_START( interp );
    retval = VTABLE_get_pmc( interp, pmc );
    PARROT_CALLIN_END( interp );
    return retval;
}

/*

=item C<Parrot_PMC
get_pmc_keyed(Parrot_Interp interp, Parrot_PMC pmc, Parrot_PMC key)>

=cut

*/

PARROT_API Parrot_PMC
Parrot_PMC_get_pmc_keyed( Parrot_Interp interp, Parrot_PMC pmc, Parrot_PMC key )
{
    Parrot_PMC retval;
    PARROT_CALLIN_START( interp );
    retval = VTABLE_get_pmc_keyed( interp, pmc, key );
    PARROT_CALLIN_END( interp );
    return retval;
}

/*

=item C<Parrot_PMC
get_pmc_keyed_int(Parrot_Interp interp, Parrot_PMC pmc, Parrot_Int key)>

=cut

*/

PARROT_API Parrot_PMC
Parrot_PMC_get_pmc_keyed_int( Parrot_Interp interp, Parrot_PMC pmc, Parrot_Int key )
{
    Parrot_PMC retval;
    PARROT_CALLIN_START( interp );
    retval = VTABLE_get_pmc_keyed_int( interp, pmc, key );
    PARROT_CALLIN_END( interp );
    return retval;
}

/*

=item C<Parrot_PMC
get_pmc_keyed_str(Parrot_Interp interp, Parrot_PMC pmc, Parrot_String key)>

=cut

*/

PARROT_API Parrot_PMC
Parrot_PMC_get_pmc_keyed_str( Parrot_Interp interp, Parrot_PMC pmc, Parrot_String key )
{
    Parrot_PMC retval;
    PARROT_CALLIN_START( interp );
    retval = VTABLE_get_pmc_keyed_str( interp, pmc, key );
    PARROT_CALLIN_END( interp );
    return retval;
}

/*

=item C<void*
get_pointer(Parrot_Interp interp, Parrot_PMC pmc)>

=cut

*/

PARROT_API void*
Parrot_PMC_get_pointer( Parrot_Interp interp, Parrot_PMC pmc )
{
    void* retval;
    PARROT_CALLIN_START( interp );
    retval = VTABLE_get_pointer( interp, pmc );
    PARROT_CALLIN_END( interp );
    return retval;
}

/*

=item C<void*
get_pointer_keyed(Parrot_Interp interp, Parrot_PMC pmc, Parrot_PMC key)>

=cut

*/

PARROT_API void*
Parrot_PMC_get_pointer_keyed( Parrot_Interp interp, Parrot_PMC pmc, Parrot_PMC key )
{
    void* retval;
    PARROT_CALLIN_START( interp );
    retval = VTABLE_get_pointer_keyed( interp, pmc, key );
    PARROT_CALLIN_END( interp );
    return retval;
}

/*

=item C<void*
get_pointer_keyed_int(Parrot_Interp interp, Parrot_PMC pmc, Parrot_Int key)>

=cut

*/

PARROT_API void*
Parrot_PMC_get_pointer_keyed_int( Parrot_Interp interp, Parrot_PMC pmc, Parrot_Int key )
{
    void* retval;
    PARROT_CALLIN_START( interp );
    retval = VTABLE_get_pointer_keyed_int( interp, pmc, key );
    PARROT_CALLIN_END( interp );
    return retval;
}

/*

=item C<void*
get_pointer_keyed_str(Parrot_Interp interp, Parrot_PMC pmc, Parrot_String key)>

=cut

*/

PARROT_API void*
Parrot_PMC_get_pointer_keyed_str( Parrot_Interp interp, Parrot_PMC pmc, Parrot_String key )
{
    void* retval;
    PARROT_CALLIN_START( interp );
    retval = VTABLE_get_pointer_keyed_str( interp, pmc, key );
    PARROT_CALLIN_END( interp );
    return retval;
}

/*

=item C<Parrot_String
get_repr(Parrot_Interp interp, Parrot_PMC pmc)>

=cut

*/

PARROT_API Parrot_String
Parrot_PMC_get_repr( Parrot_Interp interp, Parrot_PMC pmc )
{
    Parrot_String retval;
    PARROT_CALLIN_START( interp );
    retval = VTABLE_get_repr( interp, pmc );
    PARROT_CALLIN_END( interp );
    return retval;
}

/*

=item C<Parrot_String
get_string(Parrot_Interp interp, Parrot_PMC pmc)>

=cut

*/

PARROT_API Parrot_String
Parrot_PMC_get_string( Parrot_Interp interp, Parrot_PMC pmc )
{
    Parrot_String retval;
    PARROT_CALLIN_START( interp );
    retval = VTABLE_get_string( interp, pmc );
    PARROT_CALLIN_END( interp );
    return retval;
}

/*

=item C<Parrot_String
get_string_keyed(Parrot_Interp interp, Parrot_PMC pmc, Parrot_PMC key)>

=cut

*/

PARROT_API Parrot_String
Parrot_PMC_get_string_keyed( Parrot_Interp interp, Parrot_PMC pmc, Parrot_PMC key )
{
    Parrot_String retval;
    PARROT_CALLIN_START( interp );
    retval = VTABLE_get_string_keyed( interp, pmc, key );
    PARROT_CALLIN_END( interp );
    return retval;
}

/*

=item C<Parrot_String
get_string_keyed_int(Parrot_Interp interp, Parrot_PMC pmc, Parrot_Int key)>

=cut

*/

PARROT_API Parrot_String
Parrot_PMC_get_string_keyed_int( Parrot_Interp interp, Parrot_PMC pmc, Parrot_Int key )
{
    Parrot_String retval;
    PARROT_CALLIN_START( interp );
    retval = VTABLE_get_string_keyed_int( interp, pmc, key );
    PARROT_CALLIN_END( interp );
    return retval;
}

/*

=item C<Parrot_String
get_string_keyed_str(Parrot_Interp interp, Parrot_PMC pmc, Parrot_String key)>

=cut

*/

PARROT_API Parrot_String
Parrot_PMC_get_string_keyed_str( Parrot_Interp interp, Parrot_PMC pmc, Parrot_String key )
{
    Parrot_String retval;
    PARROT_CALLIN_START( interp );
    retval = VTABLE_get_string_keyed_str( interp, pmc, key );
    PARROT_CALLIN_END( interp );
    return retval;
}

/*

=item C<Parrot_PMC
getprop(Parrot_Interp interp, Parrot_PMC pmc, Parrot_String key)>

=cut

*/

PARROT_API Parrot_PMC
Parrot_PMC_getprop( Parrot_Interp interp, Parrot_PMC pmc, Parrot_String key )
{
    Parrot_PMC retval;
    PARROT_CALLIN_START( interp );
    retval = VTABLE_getprop( interp, pmc, key );
    PARROT_CALLIN_END( interp );
    return retval;
}

/*

=item C<Parrot_PMC
getprops(Parrot_Interp interp, Parrot_PMC pmc)>

=cut

*/

PARROT_API Parrot_PMC
Parrot_PMC_getprops( Parrot_Interp interp, Parrot_PMC pmc )
{
    Parrot_PMC retval;
    PARROT_CALLIN_START( interp );
    retval = VTABLE_getprops( interp, pmc );
    PARROT_CALLIN_END( interp );
    return retval;
}

/*

=item C<Parrot_Int
hash(Parrot_Interp interp, Parrot_PMC pmc, size_t seed)>

=cut

*/

PARROT_API Parrot_Int
Parrot_PMC_hash( Parrot_Interp interp, Parrot_PMC pmc, size_t seed )
{
    Parrot_Int retval;
    PARROT_CALLIN_START( interp );
    retval = VTABLE_hash( interp, pmc, seed );
    PARROT_CALLIN_END( interp );
    return retval;
}

/*

=item C<void
i_absolute(Parrot_Interp interp, Parrot_PMC pmc)>

=cut

*/

PARROT_API void
Parrot_PMC_i_absolute( Parrot_Interp interp, Parrot_PMC pmc )
{
    PARROT_CALLIN_START( interp );
    VTABLE_i_absolute( interp, pmc );
    PARROT_CALLIN_END( interp );
    return;
}

/*

=item C<void
i_bitwise_not(Parrot_Interp interp, Parrot_PMC pmc)>

=cut

*/

PARROT_API void
Parrot_PMC_i_bitwise_not( Parrot_Interp interp, Parrot_PMC pmc )
{
    PARROT_CALLIN_START( interp );
    VTABLE_i_bitwise_not( interp, pmc );
    PARROT_CALLIN_END( interp );
    return;
}

/*

=item C<void
i_bitwise_nots(Parrot_Interp interp, Parrot_PMC pmc)>

=cut

*/

PARROT_API void
Parrot_PMC_i_bitwise_nots( Parrot_Interp interp, Parrot_PMC pmc )
{
    PARROT_CALLIN_START( interp );
    VTABLE_i_bitwise_nots( interp, pmc );
    PARROT_CALLIN_END( interp );
    return;
}

/*

=item C<void
i_logical_not(Parrot_Interp interp, Parrot_PMC pmc)>

=cut

*/

PARROT_API void
Parrot_PMC_i_logical_not( Parrot_Interp interp, Parrot_PMC pmc )
{
    PARROT_CALLIN_START( interp );
    VTABLE_i_logical_not( interp, pmc );
    PARROT_CALLIN_END( interp );
    return;
}

/*

=item C<void
i_neg(Parrot_Interp interp, Parrot_PMC pmc)>

=cut

*/

PARROT_API void
Parrot_PMC_i_neg( Parrot_Interp interp, Parrot_PMC pmc )
{
    PARROT_CALLIN_START( interp );
    VTABLE_i_neg( interp, pmc );
    PARROT_CALLIN_END( interp );
    return;
}

/*

=item C<void
increment(Parrot_Interp interp, Parrot_PMC pmc)>

=cut

*/

PARROT_API void
Parrot_PMC_increment( Parrot_Interp interp, Parrot_PMC pmc )
{
    PARROT_CALLIN_START( interp );
    VTABLE_increment( interp, pmc );
    PARROT_CALLIN_END( interp );
    return;
}

/*

=item C<void
init(Parrot_Interp interp, Parrot_PMC pmc)>

=cut

*/

PARROT_API void
Parrot_PMC_init( Parrot_Interp interp, Parrot_PMC pmc )
{
    PARROT_CALLIN_START( interp );
    VTABLE_init( interp, pmc );
    PARROT_CALLIN_END( interp );
    return;
}

/*

=item C<void
init_pmc(Parrot_Interp interp, Parrot_PMC pmc, Parrot_PMC initializer)>

=cut

*/

PARROT_API void
Parrot_PMC_init_pmc( Parrot_Interp interp, Parrot_PMC pmc, Parrot_PMC initializer )
{
    PARROT_CALLIN_START( interp );
    VTABLE_init_pmc( interp, pmc, initializer );
    PARROT_CALLIN_END( interp );
    return;
}

/*

=item C<Parrot_PMC
inspect(Parrot_Interp interp, Parrot_PMC pmc)>

=cut

*/

PARROT_API Parrot_PMC
Parrot_PMC_inspect( Parrot_Interp interp, Parrot_PMC pmc )
{
    Parrot_PMC retval;
    PARROT_CALLIN_START( interp );
    retval = VTABLE_inspect( interp, pmc );
    PARROT_CALLIN_END( interp );
    return retval;
}

/*

=item C<Parrot_PMC
inspect_str(Parrot_Interp interp, Parrot_PMC pmc, Parrot_String what)>

=cut

*/

PARROT_API Parrot_PMC
Parrot_PMC_inspect_str( Parrot_Interp interp, Parrot_PMC pmc, Parrot_String what )
{
    Parrot_PMC retval;
    PARROT_CALLIN_START( interp );
    retval = VTABLE_inspect_str( interp, pmc, what );
    PARROT_CALLIN_END( interp );
    return retval;
}

/*

=item C<Parrot_PMC
instantiate(Parrot_Interp interp, Parrot_PMC pmc, Parrot_PMC sig)>

=cut

*/

PARROT_API Parrot_PMC
Parrot_PMC_instantiate( Parrot_Interp interp, Parrot_PMC pmc, Parrot_PMC sig )
{
    Parrot_PMC retval;
    PARROT_CALLIN_START( interp );
    retval = VTABLE_instantiate( interp, pmc, sig );
    PARROT_CALLIN_END( interp );
    return retval;
}

/*

=item C<Parrot_Opcode*
invoke(Parrot_Interp interp, Parrot_PMC pmc, void* next)>

=cut

*/

PARROT_API Parrot_Opcode*
Parrot_PMC_invoke( Parrot_Interp interp, Parrot_PMC pmc, void* next )
{
    Parrot_Opcode* retval;
    PARROT_CALLIN_START( interp );
    retval = VTABLE_invoke( interp, pmc, next );
    PARROT_CALLIN_END( interp );
    return retval;
}

/*

=item C<Parrot_Int
is_same(Parrot_Interp interp, Parrot_PMC pmc, Parrot_PMC value)>

=cut

*/

PARROT_API Parrot_Int
Parrot_PMC_is_same( Parrot_Interp interp, Parrot_PMC pmc, Parrot_PMC value )
{
    Parrot_Int retval;
    PARROT_CALLIN_START( interp );
    retval = VTABLE_is_same( interp, pmc, value );
    PARROT_CALLIN_END( interp );
    return retval;
}

/*

=item C<Parrot_Int
isa(Parrot_Interp interp, Parrot_PMC pmc, Parrot_String _class)>

=cut

*/

PARROT_API Parrot_Int
Parrot_PMC_isa( Parrot_Interp interp, Parrot_PMC pmc, Parrot_String _class )
{
    Parrot_Int retval;
    PARROT_CALLIN_START( interp );
    retval = VTABLE_isa( interp, pmc, _class );
    PARROT_CALLIN_END( interp );
    return retval;
}

/*

=item C<Parrot_PMC
logical_not(Parrot_Interp interp, Parrot_PMC pmc, Parrot_PMC dest)>

=cut

*/

PARROT_API Parrot_PMC
Parrot_PMC_logical_not( Parrot_Interp interp, Parrot_PMC pmc, Parrot_PMC dest )
{
    Parrot_PMC retval;
    PARROT_CALLIN_START( interp );
    retval = VTABLE_logical_not( interp, pmc, dest );
    PARROT_CALLIN_END( interp );
    return retval;
}

/*

=item C<void
mark(Parrot_Interp interp, Parrot_PMC pmc)>

=cut

*/

PARROT_API void
Parrot_PMC_mark( Parrot_Interp interp, Parrot_PMC pmc )
{
    PARROT_CALLIN_START( interp );
    VTABLE_mark( interp, pmc );
    PARROT_CALLIN_END( interp );
    return;
}

/*

=item C<void
morph(Parrot_Interp interp, Parrot_PMC pmc, Parrot_Int type)>

=cut

*/

PARROT_API void
Parrot_PMC_morph( Parrot_Interp interp, Parrot_PMC pmc, Parrot_Int type )
{
    PARROT_CALLIN_START( interp );
    VTABLE_morph( interp, pmc, type );
    PARROT_CALLIN_END( interp );
    return;
}

/*

=item C<Parrot_String
name(Parrot_Interp interp, Parrot_PMC pmc)>

=cut

*/

PARROT_API Parrot_String
Parrot_PMC_name( Parrot_Interp interp, Parrot_PMC pmc )
{
    Parrot_String retval;
    PARROT_CALLIN_START( interp );
    retval = VTABLE_name( interp, pmc );
    PARROT_CALLIN_END( interp );
    return retval;
}

/*

=item C<Parrot_PMC
neg(Parrot_Interp interp, Parrot_PMC pmc, Parrot_PMC dest)>

=cut

*/

PARROT_API Parrot_PMC
Parrot_PMC_neg( Parrot_Interp interp, Parrot_PMC pmc, Parrot_PMC dest )
{
    Parrot_PMC retval;
    PARROT_CALLIN_START( interp );
    retval = VTABLE_neg( interp, pmc, dest );
    PARROT_CALLIN_END( interp );
    return retval;
}

/*

=item C<Parrot_PMC
new_from_string(Parrot_Interp interp, Parrot_PMC pmc, Parrot_String rep, Parrot_Int flags)>

=cut

*/

PARROT_API Parrot_PMC
Parrot_PMC_new_from_string( Parrot_Interp interp, Parrot_PMC pmc, Parrot_String rep, Parrot_Int flags )
{
    Parrot_PMC retval;
    PARROT_CALLIN_START( interp );
    retval = VTABLE_new_from_string( interp, pmc, rep, flags );
    PARROT_CALLIN_END( interp );
    return retval;
}

/*

=item C<Parrot_PMC
nextkey_keyed(Parrot_Interp interp, Parrot_PMC pmc, Parrot_PMC key, Parrot_Int what)>

=cut

*/

PARROT_API Parrot_PMC
Parrot_PMC_nextkey_keyed( Parrot_Interp interp, Parrot_PMC pmc, Parrot_PMC key, Parrot_Int what )
{
    Parrot_PMC retval;
    PARROT_CALLIN_START( interp );
    retval = VTABLE_nextkey_keyed( interp, pmc, key, what );
    PARROT_CALLIN_END( interp );
    return retval;
}

/*

=item C<Parrot_PMC
nextkey_keyed_int(Parrot_Interp interp, Parrot_PMC pmc, Parrot_Int key, Parrot_Int what)>

=cut

*/

PARROT_API Parrot_PMC
Parrot_PMC_nextkey_keyed_int( Parrot_Interp interp, Parrot_PMC pmc, Parrot_Int key, Parrot_Int what )
{
    Parrot_PMC retval;
    PARROT_CALLIN_START( interp );
    retval = VTABLE_nextkey_keyed_int( interp, pmc, key, what );
    PARROT_CALLIN_END( interp );
    return retval;
}

/*

=item C<Parrot_PMC
nextkey_keyed_str(Parrot_Interp interp, Parrot_PMC pmc, Parrot_String key, Parrot_Int what)>

=cut

*/

PARROT_API Parrot_PMC
Parrot_PMC_nextkey_keyed_str( Parrot_Interp interp, Parrot_PMC pmc, Parrot_String key, Parrot_Int what )
{
    Parrot_PMC retval;
    PARROT_CALLIN_START( interp );
    retval = VTABLE_nextkey_keyed_str( interp, pmc, key, what );
    PARROT_CALLIN_END( interp );
    return retval;
}

/*

=item C<Parrot_PMC
pmc_namespace(Parrot_Interp interp, Parrot_PMC pmc)>

=cut

*/

PARROT_API Parrot_PMC
Parrot_PMC_pmc_namespace( Parrot_Interp interp, Parrot_PMC pmc )
{
    Parrot_PMC retval;
    PARROT_CALLIN_START( interp );
    retval = VTABLE_pmc_namespace( interp, pmc );
    PARROT_CALLIN_END( interp );
    return retval;
}

/*

=item C<Parrot_Float
pop_float(Parrot_Interp interp, Parrot_PMC pmc)>

=cut

*/

PARROT_API Parrot_Float
Parrot_PMC_pop_float( Parrot_Interp interp, Parrot_PMC pmc )
{
    Parrot_Float retval;
    PARROT_CALLIN_START( interp );
    retval = VTABLE_pop_float( interp, pmc );
    PARROT_CALLIN_END( interp );
    return retval;
}

/*

=item C<Parrot_Int
pop_integer(Parrot_Interp interp, Parrot_PMC pmc)>

=cut

*/

PARROT_API Parrot_Int
Parrot_PMC_pop_integer( Parrot_Interp interp, Parrot_PMC pmc )
{
    Parrot_Int retval;
    PARROT_CALLIN_START( interp );
    retval = VTABLE_pop_integer( interp, pmc );
    PARROT_CALLIN_END( interp );
    return retval;
}

/*

=item C<Parrot_PMC
pop_pmc(Parrot_Interp interp, Parrot_PMC pmc)>

=cut

*/

PARROT_API Parrot_PMC
Parrot_PMC_pop_pmc( Parrot_Interp interp, Parrot_PMC pmc )
{
    Parrot_PMC retval;
    PARROT_CALLIN_START( interp );
    retval = VTABLE_pop_pmc( interp, pmc );
    PARROT_CALLIN_END( interp );
    return retval;
}

/*

=item C<Parrot_String
pop_string(Parrot_Interp interp, Parrot_PMC pmc)>

=cut

*/

PARROT_API Parrot_String
Parrot_PMC_pop_string( Parrot_Interp interp, Parrot_PMC pmc )
{
    Parrot_String retval;
    PARROT_CALLIN_START( interp );
    retval = VTABLE_pop_string( interp, pmc );
    PARROT_CALLIN_END( interp );
    return retval;
}

/*

=item C<void
push_float(Parrot_Interp interp, Parrot_PMC pmc, Parrot_Float value)>

=cut

*/

PARROT_API void
Parrot_PMC_push_float( Parrot_Interp interp, Parrot_PMC pmc, Parrot_Float value )
{
    PARROT_CALLIN_START( interp );
    VTABLE_push_float( interp, pmc, value );
    PARROT_CALLIN_END( interp );
    return;
}

/*

=item C<void
push_integer(Parrot_Interp interp, Parrot_PMC pmc, Parrot_Int value)>

=cut

*/

PARROT_API void
Parrot_PMC_push_integer( Parrot_Interp interp, Parrot_PMC pmc, Parrot_Int value )
{
    PARROT_CALLIN_START( interp );
    VTABLE_push_integer( interp, pmc, value );
    PARROT_CALLIN_END( interp );
    return;
}

/*

=item C<void
push_pmc(Parrot_Interp interp, Parrot_PMC pmc, Parrot_PMC value)>

=cut

*/

PARROT_API void
Parrot_PMC_push_pmc( Parrot_Interp interp, Parrot_PMC pmc, Parrot_PMC value )
{
    PARROT_CALLIN_START( interp );
    VTABLE_push_pmc( interp, pmc, value );
    PARROT_CALLIN_END( interp );
    return;
}

/*

=item C<void
push_string(Parrot_Interp interp, Parrot_PMC pmc, Parrot_String value)>

=cut

*/

PARROT_API void
Parrot_PMC_push_string( Parrot_Interp interp, Parrot_PMC pmc, Parrot_String value )
{
    PARROT_CALLIN_START( interp );
    VTABLE_push_string( interp, pmc, value );
    PARROT_CALLIN_END( interp );
    return;
}

/*

=item C<void
remove_attribute(Parrot_Interp interp, Parrot_PMC pmc, Parrot_String name)>

=cut

*/

PARROT_API void
Parrot_PMC_remove_attribute( Parrot_Interp interp, Parrot_PMC pmc, Parrot_String name )
{
    PARROT_CALLIN_START( interp );
    VTABLE_remove_attribute( interp, pmc, name );
    PARROT_CALLIN_END( interp );
    return;
}

/*

=item C<void
remove_method(Parrot_Interp interp, Parrot_PMC pmc, Parrot_String method_name)>

=cut

*/

PARROT_API void
Parrot_PMC_remove_method( Parrot_Interp interp, Parrot_PMC pmc, Parrot_String method_name )
{
    PARROT_CALLIN_START( interp );
    VTABLE_remove_method( interp, pmc, method_name );
    PARROT_CALLIN_END( interp );
    return;
}

/*

=item C<void
remove_parent(Parrot_Interp interp, Parrot_PMC pmc, Parrot_PMC parent)>

=cut

*/

PARROT_API void
Parrot_PMC_remove_parent( Parrot_Interp interp, Parrot_PMC pmc, Parrot_PMC parent )
{
    PARROT_CALLIN_START( interp );
    VTABLE_remove_parent( interp, pmc, parent );
    PARROT_CALLIN_END( interp );
    return;
}

/*

=item C<void
remove_role(Parrot_Interp interp, Parrot_PMC pmc, Parrot_PMC role)>

=cut

*/

PARROT_API void
Parrot_PMC_remove_role( Parrot_Interp interp, Parrot_PMC pmc, Parrot_PMC role )
{
    PARROT_CALLIN_START( interp );
    VTABLE_remove_role( interp, pmc, role );
    PARROT_CALLIN_END( interp );
    return;
}

/*

=item C<void
set_attr(Parrot_Interp interp, Parrot_PMC pmc, Parrot_Int idx, Parrot_PMC value)>

=cut

*/

PARROT_API void
Parrot_PMC_set_attr( Parrot_Interp interp, Parrot_PMC pmc, Parrot_Int idx, Parrot_PMC value )
{
    PARROT_CALLIN_START( interp );
    VTABLE_set_attr( interp, pmc, idx, value );
    PARROT_CALLIN_END( interp );
    return;
}

/*

=item C<void
set_attr_str(Parrot_Interp interp, Parrot_PMC pmc, Parrot_String idx, Parrot_PMC value)>

=cut

*/

PARROT_API void
Parrot_PMC_set_attr_str( Parrot_Interp interp, Parrot_PMC pmc, Parrot_String idx, Parrot_PMC value )
{
    PARROT_CALLIN_START( interp );
    VTABLE_set_attr_str( interp, pmc, idx, value );
    PARROT_CALLIN_END( interp );
    return;
}

/*

=item C<void
set_bignum_int(Parrot_Interp interp, Parrot_PMC pmc, Parrot_Int value)>

=cut

*/

PARROT_API void
Parrot_PMC_set_bignum_int( Parrot_Interp interp, Parrot_PMC pmc, Parrot_Int value )
{
    PARROT_CALLIN_START( interp );
    VTABLE_set_bignum_int( interp, pmc, value );
    PARROT_CALLIN_END( interp );
    return;
}

/*

=item C<void
set_bignum_num(Parrot_Interp interp, Parrot_PMC pmc, Parrot_Float value)>

=cut

*/

PARROT_API void
Parrot_PMC_set_bignum_num( Parrot_Interp interp, Parrot_PMC pmc, Parrot_Float value )
{
    PARROT_CALLIN_START( interp );
    VTABLE_set_bignum_num( interp, pmc, value );
    PARROT_CALLIN_END( interp );
    return;
}

/*

=item C<void
set_bignum_str(Parrot_Interp interp, Parrot_PMC pmc, Parrot_String value)>

=cut

*/

PARROT_API void
Parrot_PMC_set_bignum_str( Parrot_Interp interp, Parrot_PMC pmc, Parrot_String value )
{
    PARROT_CALLIN_START( interp );
    VTABLE_set_bignum_str( interp, pmc, value );
    PARROT_CALLIN_END( interp );
    return;
}

/*

=item C<void
set_bool(Parrot_Interp interp, Parrot_PMC pmc, Parrot_Int value)>

=cut

*/

PARROT_API void
Parrot_PMC_set_bool( Parrot_Interp interp, Parrot_PMC pmc, Parrot_Int value )
{
    PARROT_CALLIN_START( interp );
    VTABLE_set_bool( interp, pmc, value );
    PARROT_CALLIN_END( interp );
    return;
}

/*

=item C<void
set_integer_keyed(Parrot_Interp interp, Parrot_PMC pmc, Parrot_PMC key, Parrot_Int value)>

=cut

*/

PARROT_API void
Parrot_PMC_set_integer_keyed( Parrot_Interp interp, Parrot_PMC pmc, Parrot_PMC key, Parrot_Int value )
{
    PARROT_CALLIN_START( interp );
    VTABLE_set_integer_keyed( interp, pmc, key, value );
    PARROT_CALLIN_END( interp );
    return;
}

/*

=item C<void
set_integer_keyed_int(Parrot_Interp interp, Parrot_PMC pmc, Parrot_Int key, Parrot_Int value)>

=cut

*/

PARROT_API void
Parrot_PMC_set_integer_keyed_int( Parrot_Interp interp, Parrot_PMC pmc, Parrot_Int key, Parrot_Int value )
{
    PARROT_CALLIN_START( interp );
    VTABLE_set_integer_keyed_int( interp, pmc, key, value );
    PARROT_CALLIN_END( interp );
    return;
}

/*

=item C<void
set_integer_keyed_str(Parrot_Interp interp, Parrot_PMC pmc, Parrot_String key, Parrot_Int value)>

=cut

*/

PARROT_API void
Parrot_PMC_set_integer_keyed_str( Parrot_Interp interp, Parrot_PMC pmc, Parrot_String key, Parrot_Int value )
{
    PARROT_CALLIN_START( interp );
    VTABLE_set_integer_keyed_str( interp, pmc, key, value );
    PARROT_CALLIN_END( interp );
    return;
}

/*

=item C<void
set_integer_native(Parrot_Interp interp, Parrot_PMC pmc, Parrot_Int value)>

=cut

*/

PARROT_API void
Parrot_PMC_set_integer_native( Parrot_Interp interp, Parrot_PMC pmc, Parrot_Int value )
{
    PARROT_CALLIN_START( interp );
    VTABLE_set_integer_native( interp, pmc, value );
    PARROT_CALLIN_END( interp );
    return;
}

/*

=item C<void
set_integer_same(Parrot_Interp interp, Parrot_PMC pmc, Parrot_PMC value)>

=cut

*/

PARROT_API void
Parrot_PMC_set_integer_same( Parrot_Interp interp, Parrot_PMC pmc, Parrot_PMC value )
{
    PARROT_CALLIN_START( interp );
    VTABLE_set_integer_same( interp, pmc, value );
    PARROT_CALLIN_END( interp );
    return;
}

/*

=item C<void
set_number_keyed(Parrot_Interp interp, Parrot_PMC pmc, Parrot_PMC key, Parrot_Float value)>

=cut

*/

PARROT_API void
Parrot_PMC_set_number_keyed( Parrot_Interp interp, Parrot_PMC pmc, Parrot_PMC key, Parrot_Float value )
{
    PARROT_CALLIN_START( interp );
    VTABLE_set_number_keyed( interp, pmc, key, value );
    PARROT_CALLIN_END( interp );
    return;
}

/*

=item C<void
set_number_keyed_int(Parrot_Interp interp, Parrot_PMC pmc, Parrot_Int key, Parrot_Float value)>

=cut

*/

PARROT_API void
Parrot_PMC_set_number_keyed_int( Parrot_Interp interp, Parrot_PMC pmc, Parrot_Int key, Parrot_Float value )
{
    PARROT_CALLIN_START( interp );
    VTABLE_set_number_keyed_int( interp, pmc, key, value );
    PARROT_CALLIN_END( interp );
    return;
}

/*

=item C<void
set_number_keyed_str(Parrot_Interp interp, Parrot_PMC pmc, Parrot_String key, Parrot_Float value)>

=cut

*/

PARROT_API void
Parrot_PMC_set_number_keyed_str( Parrot_Interp interp, Parrot_PMC pmc, Parrot_String key, Parrot_Float value )
{
    PARROT_CALLIN_START( interp );
    VTABLE_set_number_keyed_str( interp, pmc, key, value );
    PARROT_CALLIN_END( interp );
    return;
}

/*

=item C<void
set_number_native(Parrot_Interp interp, Parrot_PMC pmc, Parrot_Float value)>

=cut

*/

PARROT_API void
Parrot_PMC_set_number_native( Parrot_Interp interp, Parrot_PMC pmc, Parrot_Float value )
{
    PARROT_CALLIN_START( interp );
    VTABLE_set_number_native( interp, pmc, value );
    PARROT_CALLIN_END( interp );
    return;
}

/*

=item C<void
set_number_same(Parrot_Interp interp, Parrot_PMC pmc, Parrot_PMC value)>

=cut

*/

PARROT_API void
Parrot_PMC_set_number_same( Parrot_Interp interp, Parrot_PMC pmc, Parrot_PMC value )
{
    PARROT_CALLIN_START( interp );
    VTABLE_set_number_same( interp, pmc, value );
    PARROT_CALLIN_END( interp );
    return;
}

/*

=item C<void
set_pmc(Parrot_Interp interp, Parrot_PMC pmc, Parrot_PMC value)>

=cut

*/

PARROT_API void
Parrot_PMC_set_pmc( Parrot_Interp interp, Parrot_PMC pmc, Parrot_PMC value )
{
    PARROT_CALLIN_START( interp );
    VTABLE_set_pmc( interp, pmc, value );
    PARROT_CALLIN_END( interp );
    return;
}

/*

=item C<void
set_pmc_keyed(Parrot_Interp interp, Parrot_PMC pmc, Parrot_PMC key, Parrot_PMC value)>

=cut

*/

PARROT_API void
Parrot_PMC_set_pmc_keyed( Parrot_Interp interp, Parrot_PMC pmc, Parrot_PMC key, Parrot_PMC value )
{
    PARROT_CALLIN_START( interp );
    VTABLE_set_pmc_keyed( interp, pmc, key, value );
    PARROT_CALLIN_END( interp );
    return;
}

/*

=item C<void
set_pmc_keyed_int(Parrot_Interp interp, Parrot_PMC pmc, Parrot_Int key, Parrot_PMC value)>

=cut

*/

PARROT_API void
Parrot_PMC_set_pmc_keyed_int( Parrot_Interp interp, Parrot_PMC pmc, Parrot_Int key, Parrot_PMC value )
{
    PARROT_CALLIN_START( interp );
    VTABLE_set_pmc_keyed_int( interp, pmc, key, value );
    PARROT_CALLIN_END( interp );
    return;
}

/*

=item C<void
set_pmc_keyed_str(Parrot_Interp interp, Parrot_PMC pmc, Parrot_String key, Parrot_PMC value)>

=cut

*/

PARROT_API void
Parrot_PMC_set_pmc_keyed_str( Parrot_Interp interp, Parrot_PMC pmc, Parrot_String key, Parrot_PMC value )
{
    PARROT_CALLIN_START( interp );
    VTABLE_set_pmc_keyed_str( interp, pmc, key, value );
    PARROT_CALLIN_END( interp );
    return;
}

/*

=item C<void
set_pointer(Parrot_Interp interp, Parrot_PMC pmc, void* value)>

=cut

*/

PARROT_API void
Parrot_PMC_set_pointer( Parrot_Interp interp, Parrot_PMC pmc, void* value )
{
    PARROT_CALLIN_START( interp );
    VTABLE_set_pointer( interp, pmc, value );
    PARROT_CALLIN_END( interp );
    return;
}

/*

=item C<void
set_pointer_keyed(Parrot_Interp interp, Parrot_PMC pmc, Parrot_PMC key, void* value)>

=cut

*/

PARROT_API void
Parrot_PMC_set_pointer_keyed( Parrot_Interp interp, Parrot_PMC pmc, Parrot_PMC key, void* value )
{
    PARROT_CALLIN_START( interp );
    VTABLE_set_pointer_keyed( interp, pmc, key, value );
    PARROT_CALLIN_END( interp );
    return;
}

/*

=item C<void
set_pointer_keyed_int(Parrot_Interp interp, Parrot_PMC pmc, Parrot_Int key, void* value)>

=cut

*/

PARROT_API void
Parrot_PMC_set_pointer_keyed_int( Parrot_Interp interp, Parrot_PMC pmc, Parrot_Int key, void* value )
{
    PARROT_CALLIN_START( interp );
    VTABLE_set_pointer_keyed_int( interp, pmc, key, value );
    PARROT_CALLIN_END( interp );
    return;
}

/*

=item C<void
set_pointer_keyed_str(Parrot_Interp interp, Parrot_PMC pmc, Parrot_String key, void* value)>

=cut

*/

PARROT_API void
Parrot_PMC_set_pointer_keyed_str( Parrot_Interp interp, Parrot_PMC pmc, Parrot_String key, void* value )
{
    PARROT_CALLIN_START( interp );
    VTABLE_set_pointer_keyed_str( interp, pmc, key, value );
    PARROT_CALLIN_END( interp );
    return;
}

/*

=item C<void
set_string_keyed(Parrot_Interp interp, Parrot_PMC pmc, Parrot_PMC key, Parrot_String value)>

=cut

*/

PARROT_API void
Parrot_PMC_set_string_keyed( Parrot_Interp interp, Parrot_PMC pmc, Parrot_PMC key, Parrot_String value )
{
    PARROT_CALLIN_START( interp );
    VTABLE_set_string_keyed( interp, pmc, key, value );
    PARROT_CALLIN_END( interp );
    return;
}

/*

=item C<void
set_string_keyed_int(Parrot_Interp interp, Parrot_PMC pmc, Parrot_Int key, Parrot_String value)>

=cut

*/

PARROT_API void
Parrot_PMC_set_string_keyed_int( Parrot_Interp interp, Parrot_PMC pmc, Parrot_Int key, Parrot_String value )
{
    PARROT_CALLIN_START( interp );
    VTABLE_set_string_keyed_int( interp, pmc, key, value );
    PARROT_CALLIN_END( interp );
    return;
}

/*

=item C<void
set_string_keyed_str(Parrot_Interp interp, Parrot_PMC pmc, Parrot_String key, Parrot_String value)>

=cut

*/

PARROT_API void
Parrot_PMC_set_string_keyed_str( Parrot_Interp interp, Parrot_PMC pmc, Parrot_String key, Parrot_String value )
{
    PARROT_CALLIN_START( interp );
    VTABLE_set_string_keyed_str( interp, pmc, key, value );
    PARROT_CALLIN_END( interp );
    return;
}

/*

=item C<void
set_string_native(Parrot_Interp interp, Parrot_PMC pmc, Parrot_String value)>

=cut

*/

PARROT_API void
Parrot_PMC_set_string_native( Parrot_Interp interp, Parrot_PMC pmc, Parrot_String value )
{
    PARROT_CALLIN_START( interp );
    VTABLE_set_string_native( interp, pmc, value );
    PARROT_CALLIN_END( interp );
    return;
}

/*

=item C<void
set_string_same(Parrot_Interp interp, Parrot_PMC pmc, Parrot_PMC value)>

=cut

*/

PARROT_API void
Parrot_PMC_set_string_same( Parrot_Interp interp, Parrot_PMC pmc, Parrot_PMC value )
{
    PARROT_CALLIN_START( interp );
    VTABLE_set_string_same( interp, pmc, value );
    PARROT_CALLIN_END( interp );
    return;
}

/*

=item C<void
setprop(Parrot_Interp interp, Parrot_PMC pmc, Parrot_String key, Parrot_PMC value)>

=cut

*/

PARROT_API void
Parrot_PMC_setprop( Parrot_Interp interp, Parrot_PMC pmc, Parrot_String key, Parrot_PMC value )
{
    PARROT_CALLIN_START( interp );
    VTABLE_setprop( interp, pmc, key, value );
    PARROT_CALLIN_END( interp );
    return;
}

/*

=item C<void
share(Parrot_Interp interp, Parrot_PMC pmc)>

=cut

*/

PARROT_API void
Parrot_PMC_share( Parrot_Interp interp, Parrot_PMC pmc )
{
    PARROT_CALLIN_START( interp );
    VTABLE_share( interp, pmc );
    PARROT_CALLIN_END( interp );
    return;
}

/*

=item C<Parrot_PMC
share_ro(Parrot_Interp interp, Parrot_PMC pmc)>

=cut

*/

PARROT_API Parrot_PMC
Parrot_PMC_share_ro( Parrot_Interp interp, Parrot_PMC pmc )
{
    Parrot_PMC retval;
    PARROT_CALLIN_START( interp );
    retval = VTABLE_share_ro( interp, pmc );
    PARROT_CALLIN_END( interp );
    return retval;
}

/*

=item C<Parrot_Float
shift_float(Parrot_Interp interp, Parrot_PMC pmc)>

=cut

*/

PARROT_API Parrot_Float
Parrot_PMC_shift_float( Parrot_Interp interp, Parrot_PMC pmc )
{
    Parrot_Float retval;
    PARROT_CALLIN_START( interp );
    retval = VTABLE_shift_float( interp, pmc );
    PARROT_CALLIN_END( interp );
    return retval;
}

/*

=item C<Parrot_Int
shift_integer(Parrot_Interp interp, Parrot_PMC pmc)>

=cut

*/

PARROT_API Parrot_Int
Parrot_PMC_shift_integer( Parrot_Interp interp, Parrot_PMC pmc )
{
    Parrot_Int retval;
    PARROT_CALLIN_START( interp );
    retval = VTABLE_shift_integer( interp, pmc );
    PARROT_CALLIN_END( interp );
    return retval;
}

/*

=item C<Parrot_PMC
shift_pmc(Parrot_Interp interp, Parrot_PMC pmc)>

=cut

*/

PARROT_API Parrot_PMC
Parrot_PMC_shift_pmc( Parrot_Interp interp, Parrot_PMC pmc )
{
    Parrot_PMC retval;
    PARROT_CALLIN_START( interp );
    retval = VTABLE_shift_pmc( interp, pmc );
    PARROT_CALLIN_END( interp );
    return retval;
}

/*

=item C<Parrot_String
shift_string(Parrot_Interp interp, Parrot_PMC pmc)>

=cut

*/

PARROT_API Parrot_String
Parrot_PMC_shift_string( Parrot_Interp interp, Parrot_PMC pmc )
{
    Parrot_String retval;
    PARROT_CALLIN_START( interp );
    retval = VTABLE_shift_string( interp, pmc );
    PARROT_CALLIN_END( interp );
    return retval;
}

/*

=item C<Parrot_PMC
slice(Parrot_Interp interp, Parrot_PMC pmc, Parrot_PMC key, Parrot_Int flag)>

=cut

*/

PARROT_API Parrot_PMC
Parrot_PMC_slice( Parrot_Interp interp, Parrot_PMC pmc, Parrot_PMC key, Parrot_Int flag )
{
    Parrot_PMC retval;
    PARROT_CALLIN_START( interp );
    retval = VTABLE_slice( interp, pmc, key, flag );
    PARROT_CALLIN_END( interp );
    return retval;
}

/*

=item C<void
splice(Parrot_Interp interp, Parrot_PMC pmc, Parrot_PMC value, Parrot_Int offset, Parrot_Int count)>

=cut

*/

PARROT_API void
Parrot_PMC_splice( Parrot_Interp interp, Parrot_PMC pmc, Parrot_PMC value, Parrot_Int offset, Parrot_Int count )
{
    PARROT_CALLIN_START( interp );
    VTABLE_splice( interp, pmc, value, offset, count );
    PARROT_CALLIN_END( interp );
    return;
}

/*

=item C<Parrot_PMC
subclass(Parrot_Interp interp, Parrot_PMC pmc, Parrot_PMC name)>

=cut

*/

PARROT_API Parrot_PMC
Parrot_PMC_subclass( Parrot_Interp interp, Parrot_PMC pmc, Parrot_PMC name )
{
    Parrot_PMC retval;
    PARROT_CALLIN_START( interp );
    retval = VTABLE_subclass( interp, pmc, name );
    PARROT_CALLIN_END( interp );
    return retval;
}

/*

=item C<void
substr(Parrot_Interp interp, Parrot_PMC pmc, Parrot_Int offset, Parrot_Int length, Parrot_PMC dest)>

=cut

*/

PARROT_API void
Parrot_PMC_substr( Parrot_Interp interp, Parrot_PMC pmc, Parrot_Int offset, Parrot_Int length, Parrot_PMC dest )
{
    PARROT_CALLIN_START( interp );
    VTABLE_substr( interp, pmc, offset, length, dest );
    PARROT_CALLIN_END( interp );
    return;
}

/*

=item C<Parrot_String
substr_str(Parrot_Interp interp, Parrot_PMC pmc, Parrot_Int offset, Parrot_Int length)>

=cut

*/

PARROT_API Parrot_String
Parrot_PMC_substr_str( Parrot_Interp interp, Parrot_PMC pmc, Parrot_Int offset, Parrot_Int length )
{
    Parrot_String retval;
    PARROT_CALLIN_START( interp );
    retval = VTABLE_substr_str( interp, pmc, offset, length );
    PARROT_CALLIN_END( interp );
    return retval;
}

/*

=item C<Parrot_Int
subtype(Parrot_Interp interp, Parrot_PMC pmc, Parrot_Int type)>

=cut

*/

PARROT_API Parrot_Int
Parrot_PMC_subtype( Parrot_Interp interp, Parrot_PMC pmc, Parrot_Int type )
{
    Parrot_Int retval;
    PARROT_CALLIN_START( interp );
    retval = VTABLE_subtype( interp, pmc, type );
    PARROT_CALLIN_END( interp );
    return retval;
}

/*

=item C<Parrot_Int
type_keyed(Parrot_Interp interp, Parrot_PMC pmc, Parrot_PMC key)>

=cut

*/

PARROT_API Parrot_Int
Parrot_PMC_type_keyed( Parrot_Interp interp, Parrot_PMC pmc, Parrot_PMC key )
{
    Parrot_Int retval;
    PARROT_CALLIN_START( interp );
    retval = VTABLE_type_keyed( interp, pmc, key );
    PARROT_CALLIN_END( interp );
    return retval;
}

/*

=item C<Parrot_Int
type_keyed_int(Parrot_Interp interp, Parrot_PMC pmc, Parrot_Int key)>

=cut

*/

PARROT_API Parrot_Int
Parrot_PMC_type_keyed_int( Parrot_Interp interp, Parrot_PMC pmc, Parrot_Int key )
{
    Parrot_Int retval;
    PARROT_CALLIN_START( interp );
    retval = VTABLE_type_keyed_int( interp, pmc, key );
    PARROT_CALLIN_END( interp );
    return retval;
}

/*

=item C<Parrot_Int
type_keyed_str(Parrot_Interp interp, Parrot_PMC pmc, Parrot_String key)>

=cut

*/

PARROT_API Parrot_Int
Parrot_PMC_type_keyed_str( Parrot_Interp interp, Parrot_PMC pmc, Parrot_String key )
{
    Parrot_Int retval;
    PARROT_CALLIN_START( interp );
    retval = VTABLE_type_keyed_str( interp, pmc, key );
    PARROT_CALLIN_END( interp );
    return retval;
}

/*

=item C<void
unshift_float(Parrot_Interp interp, Parrot_PMC pmc, Parrot_Float value)>

=cut

*/

PARROT_API void
Parrot_PMC_unshift_float( Parrot_Interp interp, Parrot_PMC pmc, Parrot_Float value )
{
    PARROT_CALLIN_START( interp );
    VTABLE_unshift_float( interp, pmc, value );
    PARROT_CALLIN_END( interp );
    return;
}

/*

=item C<void
unshift_integer(Parrot_Interp interp, Parrot_PMC pmc, Parrot_Int value)>

=cut

*/

PARROT_API void
Parrot_PMC_unshift_integer( Parrot_Interp interp, Parrot_PMC pmc, Parrot_Int value )
{
    PARROT_CALLIN_START( interp );
    VTABLE_unshift_integer( interp, pmc, value );
    PARROT_CALLIN_END( interp );
    return;
}

/*

=item C<void
unshift_pmc(Parrot_Interp interp, Parrot_PMC pmc, Parrot_PMC value)>

=cut

*/

PARROT_API void
Parrot_PMC_unshift_pmc( Parrot_Interp interp, Parrot_PMC pmc, Parrot_PMC value )
{
    PARROT_CALLIN_START( interp );
    VTABLE_unshift_pmc( interp, pmc, value );
    PARROT_CALLIN_END( interp );
    return;
}

/*

=item C<void
unshift_string(Parrot_Interp interp, Parrot_PMC pmc, Parrot_String value)>

=cut

*/

PARROT_API void
Parrot_PMC_unshift_string( Parrot_Interp interp, Parrot_PMC pmc, Parrot_String value )
{
    PARROT_CALLIN_START( interp );
    VTABLE_unshift_string( interp, pmc, value );
    PARROT_CALLIN_END( interp );
    return;
}

/*

=back

=head1 SEE ALSO

See F<include/parrot/extend.h> and F<docs/pdds/pdd11_extending.pod>.

=head1 HISTORY

Initial version by Dan Sugalski.

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
