/*
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/bigint.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

#line 1 "./src/pmc/bigint.pmc"
/*
Copyright (C) 2004-2007, The Perl Foundation.
$Id: bigint.pmc 18435 2007-05-06 15:11:30Z rgrjr $

=head1 NAME

src/pmc/bigint.pmc - BigInt PMC class

=head1 DESCRIPTION

C<BigInt> provides arbitrary precision integer mathematic functions.

=head2 Functions

=over 4

=item C<static void bigint_set_long(Interp*, PMC*, long value)>

=item C<static void bigint_set_double(Interp*, PMC*, double value)>

=cut

*/

#include "parrot/parrot.h"

/*
 * TODO split that out into a separate file
 */

#ifdef PARROT_HAS_GMP
#  include <gmp.h>
typedef struct BIGINT {
    mpz_t b;
} BIGINT;

#  define BN(x) ((BIGINT*)PMC_struct_val(x))->b

static void
bigint_init(Interp *interp, PMC *self) {
    PMC_struct_val(self) = malloc(sizeof (BIGINT));
    mpz_init(BN(self));
}
static void
bigint_clear(Interp *interp, PMC *self) {
    mpz_clear(BN(self));
}

static void
bigint_set(Interp *interp, PMC *dest, PMC *src) {
    mpz_set(BN(dest), BN(src));
}

static void
bigint_set_long(Interp *interp, PMC *self, long value) {
    mpz_set_si(BN(self), value);
}

static void
bigint_set_double(Interp *interp, PMC *self, double value) {
    mpz_set_d(BN(self), value);
}

static void
bigint_set_str(Interp *interp, PMC *self, char* value, int base) {
    mpz_set_str(BN(self), value, base);
}

static BIGNUM*
bigint_get_self(Interp *interp, PMC *self) {
    return PMC_struct_val(self);
}

static void
bigint_set_self(Interp *interp, PMC *self, BIGNUM *value) {
    mpz_set(BN(self), (mpz_srcptr)value);
}

static long
bigint_get_long(Interp *interp, PMC *self) {
    if (mpz_fits_slong_p(BN(self)))
        return mpz_get_si(BN(self));
    real_exception(interp, NULL, 1, "bigint_get_long: number too big");
    return 0;
}

static int
bigint_get_bool(Interp *interp, PMC *self) {
    if (mpz_sgn(BN(self)) != 0) {
        return 1;
    }
    else {
        return 0;
    }
}
static char *
bigint_get_string(Interp *interp, PMC *self, int base) {
    size_t n = mpz_sizeinbase(BN(self), base) + 2;
    char  *s  = (char *)mem_sys_allocate(n);
    return mpz_get_str(s, base, BN(self));
}

static double
bigint_get_double(Interp *interp, PMC *self) {
    return mpz_get_d(BN(self));
}

static void
bigint_add_bigint(Interp *interp, PMC* self, PMC *value, PMC *dest)
{
    mpz_add(BN(dest), BN(self), BN(value));
}

static void
bigint_add_bigint_int(Interp *interp, PMC* self, INTVAL value,
        PMC *dest)
{
    int n = value < 0;
    if (n) {
        mpz_sub_ui(BN(dest), BN(self), -value);
    }
    else
        mpz_add_ui(BN(dest), BN(self), value);
}
static void
bigint_sub_bigint(Interp *interp, PMC* self, PMC *value, PMC *dest)
{
    mpz_sub(BN(dest), BN(self), BN(value));
}

static void
bigint_sub_bigint_int(Interp *interp, PMC* self, INTVAL value,
        PMC *dest)
{
    int n = value < 0;
    if (n)
        mpz_add_ui(BN(dest), BN(self), -value);
    else
        mpz_sub_ui(BN(dest), BN(self), value);
}
static void
bigint_mul_bigint(Interp *interp, PMC* self, PMC *value, PMC *dest)
{
    mpz_mul(BN(dest), BN(self), BN(value));
}

static void
bigint_mul_bigint_int(Interp *interp, PMC* self, INTVAL value,
        PMC *dest)
{
    mpz_mul_si(BN(dest), BN(self), value);
}

static void
bigint_pow_bigint_int(Interp *interp, PMC* self, INTVAL value,
        PMC *dest)
{
    mpz_pow_ui(BN(dest), BN(self), value);
}

static void
int_check_divide_zero(Interp *interp, INTVAL value)
{
    if (value == 0) {
        real_exception(interp, NULL, E_ZeroDivisionError,
                       "Divide by zero");
    }
}

static void
bigint_check_divide_zero(Interp *interp, PMC *value)
{
    /* Throw an exception if we are dividing by zero. */
    if (mpz_cmp_si(BN(value), 0) == 0) {
        real_exception(interp, NULL, E_ZeroDivisionError,
                       "Divide by zero");
    }
}

static void
bigint_div_bigint(Interp *interp, PMC* self, PMC *value, PMC *dest)
{
    bigint_check_divide_zero(interp, value);
    /* this is mpz_fdiv_q */
    mpz_div(BN(dest), BN(self), BN(value));
}
static void
bigint_div_bigint_int(Interp *interp, PMC* self, INTVAL value, PMC *dest)
{
    int n;
    int_check_divide_zero(interp, value);
    /* this is mpz_fdiv_q */
    n = value < 0;
    if (n) {
        mpz_div_ui(BN(dest), BN(self), -value);
        mpz_neg(BN(dest), BN(dest));
    }
    else
        mpz_div_ui(BN(dest), BN(self), value);
}
static void
bigint_fdiv_bigint(Interp *interp, PMC* self, PMC *value, PMC *dest)
{
    bigint_check_divide_zero(interp, value);
    mpz_fdiv_q(BN(dest), BN(self), BN(value));
}
static void
bigint_fdiv_bigint_int(Interp *interp, PMC* self, INTVAL value, PMC *dest)
{
    int n;
    int_check_divide_zero(interp, value);
    n = value < 0;
    if (n) {
        mpz_fdiv_q_ui(BN(dest), BN(self), -value);
        mpz_neg(BN(dest), BN(dest));
    }
    else
        mpz_fdiv_q_ui(BN(dest), BN(self), value);
}

static void
bigint_mod_bigint(Interp *interp, PMC* self, PMC *value, PMC *dest)
{
    bigint_check_divide_zero(interp, value);
    mpz_mod(BN(dest), BN(self), BN(value));
}

static void
bigint_mod_bigint_int(Interp *interp, PMC* self, INTVAL value, PMC *dest)
{
    int n;
    int_check_divide_zero(interp, value);
    n = value < 0;
    if (n) {
        mpz_mod_ui(BN(dest), BN(self), -value);
    }
    else
        mpz_mod_ui(BN(dest), BN(self), value);
}
static INTVAL
bigint_cmp(Interp *interp, PMC* self, PMC *value)
{
    return mpz_cmp(BN(self), BN(value));
}

static INTVAL
bigint_cmp_int(Interp *interp, PMC* self, INTVAL value)
{
    return mpz_cmp_si(BN(self), value);
}

static void
bigint_abs(Interp *interp, PMC* self, PMC *dest)
{
    VTABLE_morph(interp, dest, enum_class_BigInt);
    mpz_abs(BN(dest), BN(self));
}

static void
bigint_neg(Interp *interp, PMC* self, PMC *dest)
{
    VTABLE_morph(interp, dest, enum_class_BigInt);
    mpz_neg(BN(dest), BN(self));
}

static void
bigint_bitwise_shl_bigint_int(Interp *interp, PMC* self,
                              INTVAL value, PMC *dest)
{
    /* The third args to mpz_mul_2exp and mpz_tdiv_q_2exp are unsigned, so we
       need to do something sensible with negative values. */
    if (value >= 0)
        mpz_mul_2exp(BN(dest), BN(self), value);
    else
        mpz_tdiv_q_2exp(BN(dest), BN(self), -value);
}
static void
bigint_bitwise_shr_bigint_int(Interp *interp, PMC* self,
                              INTVAL value, PMC *dest)
{
    /* The third args to mpz_mul_2exp and mpz_tdiv_q_2exp are unsigned, so we
       need to do something sensible with negative values. */
    if (value >= 0)
        mpz_tdiv_q_2exp(BN(dest), BN(self), value);
    else
        mpz_mul_2exp(BN(dest), BN(self), -value);
}

#else /* ifdef PARROT_HAS_GMP */

static void
bigint_init(Interp *interp, PMC *self) {
    real_exception(interp, NULL, E_LibraryNotLoadedError,
        "no bigint lib loaded");
}
static void
bigint_clear(Interp *interp, PMC *self) {
    real_exception(interp, NULL, E_LibraryNotLoadedError,
        "no bigint lib loaded");
}
static void
bigint_set_long(Interp *interp, PMC *self, long value) {
    real_exception(interp, NULL, E_LibraryNotLoadedError,
        "no bigint lib loaded");
}
static void
bigint_set(Interp *interp, PMC *dest, PMC *src) {
    real_exception(interp, NULL, E_LibraryNotLoadedError,
        "no bigint lib loaded");
}
static void
bigint_set_double(Interp *interp, PMC *self, double value) {
    real_exception(interp, NULL, E_LibraryNotLoadedError,
        "no bigint lib loaded");
}
static void
bigint_set_str(Interp *interp, PMC *self, char* value, int base) {
    real_exception(interp, NULL, E_LibraryNotLoadedError,
        "no bigint lib loaded");
}
static void
bigint_set_self(Interp *interp, PMC *self, BIGNUM *value) {
    real_exception(interp, NULL, E_LibraryNotLoadedError,
        "no bigint lib loaded");
}
static BIGNUM*
bigint_get_self(Interp *interp, PMC *self) {
    real_exception(interp, NULL, E_LibraryNotLoadedError,
        "no bigint lib loaded");
    return NULL;
}

static char *
bigint_get_string(Interp *interp, PMC *self, int base) {
    real_exception(interp, NULL, E_LibraryNotLoadedError,
        "no bigint lib loaded");
    return NULL;
}

static long
bigint_get_long(Interp *interp, PMC *self) {
    real_exception(interp, NULL, E_LibraryNotLoadedError,
        "no bigint lib loaded");
    return 0L;
}
static long
bigint_get_bool(Interp *interp, PMC *self) {
    real_exception(interp, NULL, E_LibraryNotLoadedError,
        "no bigint lib loaded");
    return 0L;
}
static double
bigint_get_double(Interp *interp, PMC *self) {
    real_exception(interp, NULL, E_LibraryNotLoadedError,
        "no bigint lib loaded");
    return 0.0;
}
static void
bigint_add_bigint(Interp *interp, PMC* self, PMC *value, PMC *dest)
{
    real_exception(interp, NULL, E_LibraryNotLoadedError,
        "no bigint lib loaded");
}
static void
bigint_add_bigint_int(Interp *interp, PMC* self, INTVAL value, PMC *dest)
{
    real_exception(interp, NULL, E_LibraryNotLoadedError,
        "no bigint lib loaded");
}
static void
bigint_sub_bigint(Interp *interp, PMC* self, PMC *value, PMC *dest)
{
    real_exception(interp, NULL, E_LibraryNotLoadedError,
        "no bigint lib loaded");
}
static void
bigint_sub_bigint_int(Interp *interp, PMC* self, INTVAL value, PMC *dest)
{
    real_exception(interp, NULL, E_LibraryNotLoadedError,
        "no bigint lib loaded");
}
static void
bigint_mul_bigint(Interp *interp, PMC* self, PMC *value, PMC *dest)
{
    real_exception(interp, NULL, E_LibraryNotLoadedError,
        "no bigint lib loaded");
}
static void
bigint_mul_bigint_int(Interp *interp, PMC* self, INTVAL value,
        PMC *dest)
{
    real_exception(interp, NULL, E_LibraryNotLoadedError,
        "no bigint lib loaded");
}
static void
bigint_pow_bigint_int(Interp *interp, PMC* self, INTVAL value,
        PMC *dest)
{
    real_exception(interp, NULL, E_LibraryNotLoadedError,
        "no bigint lib loaded");
}
static void
bigint_div_bigint(Interp *interp, PMC* self, PMC *value, PMC *dest)
{
    real_exception(interp, NULL, E_LibraryNotLoadedError,
        "no bigint lib loaded");
}
static void
bigint_div_bigint_int(Interp *interp, PMC* self, INTVAL value, PMC *dest)
{
    real_exception(interp, NULL, E_LibraryNotLoadedError,
        "no bigint lib loaded");
}
static void
bigint_fdiv_bigint(Interp *interp, PMC* self, PMC *value, PMC *dest)
{
    real_exception(interp, NULL, E_LibraryNotLoadedError,
        "no bigint lib loaded");
}
static void
bigint_fdiv_bigint_int(Interp *interp, PMC* self, INTVAL value, PMC *dest)
{
    real_exception(interp, NULL, E_LibraryNotLoadedError,
        "no bigint lib loaded");
}
static void
bigint_mod_bigint(Interp *interp, PMC* self, PMC *value, PMC *dest)
{
    real_exception(interp, NULL, E_LibraryNotLoadedError,
        "no bigint lib loaded");
}
static void
bigint_mod_bigint_int(Interp *interp, PMC* self, INTVAL value, PMC *dest)
{
    real_exception(interp, NULL, E_LibraryNotLoadedError,
        "no bigint lib loaded");
}
static INTVAL
bigint_cmp(Interp *interp, PMC* self, PMC *value)
{
    real_exception(interp, NULL, E_LibraryNotLoadedError,
        "no bigint lib loaded");
    return 0;
}
static INTVAL
bigint_cmp_int(Interp *interp, PMC* self, INTVAL value)
{
    real_exception(interp, NULL, E_LibraryNotLoadedError,
        "no bigint lib loaded");
    return 0;
}
static void
bigint_abs(Interp *interp, PMC* self, PMC *dest)
{
    real_exception(interp, NULL, E_LibraryNotLoadedError,
        "no bigint lib loaded");
}
static void
bigint_neg(Interp *interp, PMC* self, PMC *dest)
{
    real_exception(interp, NULL, E_LibraryNotLoadedError,
        "no bigint lib loaded");
}
static void
bigint_bitwise_shl_bigint(Interp *interp, PMC* self, PMC *value, PMC *dest)
{
    real_exception(interp, NULL, E_LibraryNotLoadedError,
        "no bigint lib loaded");
}
static void
bigint_bitwise_shl_bigint_int(Interp *interp, PMC* self,
                              INTVAL value, PMC *dest)
{
    real_exception(interp, NULL, E_LibraryNotLoadedError,
        "no bigint lib loaded");
}

static void
bigint_bitwise_shr_bigint(Interp *interp, PMC* self, PMC *value, PMC *dest)
{
    real_exception(interp, NULL, E_LibraryNotLoadedError,
        "no bigint lib loaded");
}
static void
bigint_bitwise_shr_bigint_int(Interp *interp, PMC* self,
                              INTVAL value, PMC *dest)
{
    real_exception(interp, NULL, E_LibraryNotLoadedError,
        "no bigint lib loaded");
}
#endif /* ifdef PARROT_HAS_GMP */

#line 505 "src/pmc/bigint.c"
#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_bigint.h"
#include "pmc_default.h"
#include "bigint.str"

PMC*
Parrot_BigInt_add(Interp *interp, PMC* pmc, PMC* value, PMC* dest)
#line 756 "./src/pmc/bigint.pmc"
{
        real_exception(interp, NULL, E_NotImplementedError, "unimp add");
        return dest;
}
#line 520 "src/pmc/bigint.c"
PMC*
Parrot_BigInt_add_BigInt(Interp *interp, PMC* pmc, PMC* value, PMC* dest)
{
            if (dest)
                VTABLE_morph(interp, dest, pmc->vtable->base_type);
            else
                dest = pmc_new(interp, pmc->vtable->base_type);
            bigint_add_bigint(interp, pmc, value, dest);
            return dest;
}PMC*
Parrot_BigInt_add_Integer(Interp *interp, PMC* pmc, PMC* value, PMC* dest)
{
            if (dest)
                VTABLE_morph(interp, dest, pmc->vtable->base_type);
            else
                dest = pmc_new(interp, pmc->vtable->base_type);
            bigint_add_bigint_int(interp, pmc, PMC_int_val(value), dest);
            return dest;
}
PMC*
Parrot_BigInt_add_int(Interp *interp, PMC* pmc, INTVAL value, PMC* dest)
#line 779 "./src/pmc/bigint.pmc"
{
    if (dest)
        VTABLE_morph(interp, dest, pmc->vtable->base_type);
    else
        dest = pmc_new(interp, pmc->vtable->base_type);
    bigint_add_bigint_int(interp, pmc, value, dest);
    return dest;

}
#line 552 "src/pmc/bigint.c"
void
Parrot_BigInt_i_add(Interp *interp, PMC* pmc, PMC* value)
#line 788 "./src/pmc/bigint.pmc"
{
        real_exception(interp, NULL, E_NotImplementedError, "unimp add");
}
#line 559 "src/pmc/bigint.c"
void
Parrot_BigInt_i_add_BigInt(Interp *interp, PMC* pmc, PMC* value)
{
            bigint_add_bigint(interp, pmc, value, pmc);
}void
Parrot_BigInt_i_add_Integer(Interp *interp, PMC* pmc, PMC* value)
{
            bigint_add_bigint_int(interp, pmc, PMC_int_val(value), pmc);
}
void
Parrot_BigInt_i_add_int(Interp *interp, PMC* pmc, INTVAL value)
#line 800 "./src/pmc/bigint.pmc"
{
    bigint_add_bigint_int(interp, pmc, value, pmc);

}
#line 576 "src/pmc/bigint.c"
void
Parrot_BigInt_i_add_float(Interp *interp, PMC* pmc, FLOATVAL value)
#line 804 "./src/pmc/bigint.pmc"
{
    real_exception(interp, NULL, E_NotImplementedError, "unimp add");

}
#line 584 "src/pmc/bigint.c"
PMC*
Parrot_BigInt_subtract(Interp *interp, PMC* pmc, PMC* value, PMC* dest)
#line 809 "./src/pmc/bigint.pmc"
{
        real_exception(interp, NULL, E_NotImplementedError, "unimp sub");
        return dest;
}
#line 592 "src/pmc/bigint.c"
PMC*
Parrot_BigInt_subtract_BigInt(Interp *interp, PMC* pmc, PMC* value, PMC* dest)
{
            if (dest)
                VTABLE_morph(interp, dest, pmc->vtable->base_type);
            else
                dest = pmc_new(interp, pmc->vtable->base_type);
            bigint_sub_bigint(interp, pmc, value, dest);
            return dest;
}PMC*
Parrot_BigInt_subtract_Integer(Interp *interp, PMC* pmc, PMC* value, PMC* dest)
{
            if (dest)
                VTABLE_morph(interp, dest, pmc->vtable->base_type);
            else
                dest = pmc_new(interp, pmc->vtable->base_type);
            bigint_sub_bigint_int(interp, pmc, PMC_int_val(value), dest);
            return dest;
}
PMC*
Parrot_BigInt_subtract_int(Interp *interp, PMC* pmc, INTVAL value, PMC* dest)
#line 832 "./src/pmc/bigint.pmc"
{
    if (dest)
        VTABLE_morph(interp, dest, pmc->vtable->base_type);
    else
        dest = pmc_new(interp, pmc->vtable->base_type);
    bigint_sub_bigint_int(interp, pmc, value, dest);
    return dest;

}
#line 624 "src/pmc/bigint.c"
void
Parrot_BigInt_i_subtract(Interp *interp, PMC* pmc, PMC* value)
#line 841 "./src/pmc/bigint.pmc"
{
        real_exception(interp, NULL, E_NotImplementedError, "unimp sub");
}
#line 631 "src/pmc/bigint.c"
void
Parrot_BigInt_i_subtract_BigInt(Interp *interp, PMC* pmc, PMC* value)
{
            bigint_sub_bigint(interp, pmc, value, pmc);
}void
Parrot_BigInt_i_subtract_Integer(Interp *interp, PMC* pmc, PMC* value)
{
            bigint_sub_bigint_int(interp, pmc, PMC_int_val(value), pmc);
}
void
Parrot_BigInt_i_subtract_int(Interp *interp, PMC* pmc, INTVAL value)
#line 853 "./src/pmc/bigint.pmc"
{
    bigint_sub_bigint_int(interp, pmc, value, pmc);

}
#line 648 "src/pmc/bigint.c"
void
Parrot_BigInt_i_subtract_float(Interp *interp, PMC* pmc, FLOATVAL value)
#line 857 "./src/pmc/bigint.pmc"
{
    real_exception(interp, NULL, E_NotImplementedError, "unimp sub");

}
#line 656 "src/pmc/bigint.c"
PMC*
Parrot_BigInt_multiply(Interp *interp, PMC* pmc, PMC* value, PMC* dest)
#line 862 "./src/pmc/bigint.pmc"
{
         real_exception(interp, NULL, E_NotImplementedError, "unimp mul");
        return dest;
}
#line 664 "src/pmc/bigint.c"
PMC*
Parrot_BigInt_multiply_BigInt(Interp *interp, PMC* pmc, PMC* value, PMC* dest)
{
        if (dest)
            VTABLE_morph(interp, dest, pmc->vtable->base_type);
        else
            dest = pmc_new(interp, pmc->vtable->base_type);
        bigint_mul_bigint(interp, pmc, value, dest);
        return dest;
}PMC*
Parrot_BigInt_multiply_Integer(Interp *interp, PMC* pmc, PMC* value, PMC* dest)
{
        if (dest)
            VTABLE_morph(interp, dest, pmc->vtable->base_type);
        else
            dest = pmc_new(interp, pmc->vtable->base_type);
        bigint_mul_bigint_int(interp, pmc, PMC_int_val(value), dest);
        return dest;
}
PMC*
Parrot_BigInt_multiply_int(Interp *interp, PMC* pmc, INTVAL value, PMC* dest)
#line 885 "./src/pmc/bigint.pmc"
{
    if (dest)
        VTABLE_morph(interp, dest, pmc->vtable->base_type);
    else
            dest = pmc_new(interp, pmc->vtable->base_type);
    bigint_mul_bigint_int(interp, pmc, value, dest);
    return dest;

}
#line 696 "src/pmc/bigint.c"
void
Parrot_BigInt_i_multiply(Interp *interp, PMC* pmc, PMC* value)
#line 894 "./src/pmc/bigint.pmc"
{
        real_exception(interp, NULL, E_NotImplementedError, "unimp mul");
}
#line 703 "src/pmc/bigint.c"
void
Parrot_BigInt_i_multiply_BigInt(Interp *interp, PMC* pmc, PMC* value)
{
            bigint_mul_bigint(interp, pmc, value, pmc);
}void
Parrot_BigInt_i_multiply_Integer(Interp *interp, PMC* pmc, PMC* value)
{
            bigint_mul_bigint_int(interp, pmc, PMC_int_val(value), pmc);
}
void
Parrot_BigInt_i_multiply_int(Interp *interp, PMC* pmc, INTVAL value)
#line 906 "./src/pmc/bigint.pmc"
{
    bigint_mul_bigint_int(interp, pmc, value, pmc);

}
#line 720 "src/pmc/bigint.c"
void
Parrot_BigInt_i_multiply_float(Interp *interp, PMC* pmc, FLOATVAL value)
#line 910 "./src/pmc/bigint.pmc"
{
    real_exception(interp, NULL, E_NotImplementedError, "unimp mul");

}
#line 728 "src/pmc/bigint.c"
PMC*
Parrot_BigInt_divide(Interp *interp, PMC* pmc, PMC* value, PMC* dest)
#line 929 "./src/pmc/bigint.pmc"
{
        real_exception(interp, NULL, E_NotImplementedError, "unimp div");
        return dest;
}
#line 736 "src/pmc/bigint.c"
PMC*
Parrot_BigInt_divide_BigInt(Interp *interp, PMC* pmc, PMC* value, PMC* dest)
{
        if (dest)
            VTABLE_morph(interp, dest, pmc->vtable->base_type);
        else
            dest = pmc_new(interp, pmc->vtable->base_type);
        bigint_div_bigint(interp, pmc, value, dest);
#if 0
        /* to downgrade or not that's the question */
        if (mpz_fits_slong_p(BN(dest))) {
            long iresult = mpz_get_si(BN(dest));
            VTABLE_morph(interp, dest, enum_class_Integer);
            VTABLE_set_integer_native(interp, dest, iresult);
        }
#endif
        return dest;
}PMC*
Parrot_BigInt_divide_Integer(Interp *interp, PMC* pmc, PMC* value, PMC* dest)
{
        if (dest)
            VTABLE_morph(interp, dest, pmc->vtable->base_type);
        else
            dest = pmc_new(interp, pmc->vtable->base_type);
        bigint_div_bigint_int(interp, pmc, PMC_int_val(value), dest);
        return dest;
}
PMC*
Parrot_BigInt_divide_int(Interp *interp, PMC* pmc, INTVAL value, PMC* dest)
#line 960 "./src/pmc/bigint.pmc"
{
    if (dest)
        VTABLE_morph(interp, dest, pmc->vtable->base_type);
    else
        dest = pmc_new(interp, pmc->vtable->base_type);
    bigint_div_bigint_int(interp, pmc, value, dest);
    return dest;

}
#line 776 "src/pmc/bigint.c"
void
Parrot_BigInt_i_divide(Interp *interp, PMC* pmc, PMC* value)
#line 969 "./src/pmc/bigint.pmc"
{
         real_exception(interp, NULL, E_NotImplementedError, "unimp fdiv");
}
#line 783 "src/pmc/bigint.c"
void
Parrot_BigInt_i_divide_BigInt(Interp *interp, PMC* pmc, PMC* value)
{
        bigint_div_bigint(interp, pmc, value, pmc);
}void
Parrot_BigInt_i_divide_Integer(Interp *interp, PMC* pmc, PMC* value)
{
        bigint_div_bigint_int(interp, pmc, PMC_int_val(value), pmc);
}
void
Parrot_BigInt_i_divide_int(Interp *interp, PMC* pmc, INTVAL value)
#line 981 "./src/pmc/bigint.pmc"
{
    bigint_div_bigint_int(interp, pmc, value, pmc);

}
#line 800 "src/pmc/bigint.c"
PMC*
Parrot_BigInt_floor_divide(Interp *interp, PMC* pmc, PMC* value, PMC* dest)
#line 985 "./src/pmc/bigint.pmc"
{
        real_exception(interp, NULL, E_NotImplementedError, "unimp fdiv");
        return dest;
}
#line 808 "src/pmc/bigint.c"
PMC*
Parrot_BigInt_floor_divide_BigInt(Interp *interp, PMC* pmc, PMC* value, PMC* dest)
{
        if (dest)
            VTABLE_morph(interp, dest, pmc->vtable->base_type);
        else
            dest = pmc_new(interp, pmc->vtable->base_type);
        bigint_fdiv_bigint(interp, pmc, value, dest);
        return dest;
}PMC*
Parrot_BigInt_floor_divide_Integer(Interp *interp, PMC* pmc, PMC* value, PMC* dest)
{
        if (dest)
            VTABLE_morph(interp, dest, pmc->vtable->base_type);
        else
            dest = pmc_new(interp, pmc->vtable->base_type);
        bigint_fdiv_bigint_int(interp, pmc, PMC_int_val(value), dest);
        return dest;
}
PMC*
Parrot_BigInt_floor_divide_int(Interp *interp, PMC* pmc, INTVAL value, PMC* dest)
#line 1008 "./src/pmc/bigint.pmc"
{
    if (dest)
        VTABLE_morph(interp, dest, pmc->vtable->base_type);
    else
        dest = pmc_new(interp, pmc->vtable->base_type);
    bigint_fdiv_bigint_int(interp, pmc, value, dest);
    return dest;

}
#line 840 "src/pmc/bigint.c"
void
Parrot_BigInt_i_floor_divide(Interp *interp, PMC* pmc, PMC* value)
#line 1017 "./src/pmc/bigint.pmc"
{
        real_exception(interp, NULL, E_NotImplementedError, "unimp fdiv");
}
#line 847 "src/pmc/bigint.c"
void
Parrot_BigInt_i_floor_divide_BigInt(Interp *interp, PMC* pmc, PMC* value)
{
        bigint_fdiv_bigint(interp, pmc, value, pmc);
}void
Parrot_BigInt_i_floor_divide_Integer(Interp *interp, PMC* pmc, PMC* value)
{
        bigint_fdiv_bigint_int(interp, pmc, PMC_int_val(value), pmc);
}
void
Parrot_BigInt_i_floor_divide_int(Interp *interp, PMC* pmc, INTVAL value)
#line 1029 "./src/pmc/bigint.pmc"
{
    bigint_fdiv_bigint_int(interp, pmc, value, pmc);

}
#line 864 "src/pmc/bigint.c"
PMC*
Parrot_BigInt_modulus(Interp *interp, PMC* pmc, PMC* value, PMC* dest)
#line 1033 "./src/pmc/bigint.pmc"
{
        real_exception(interp, NULL, E_NotImplementedError, "unimp mod");
        return dest;
}
#line 872 "src/pmc/bigint.c"
PMC*
Parrot_BigInt_modulus_BigInt(Interp *interp, PMC* pmc, PMC* value, PMC* dest)
{
        if (dest)
            VTABLE_morph(interp, dest, pmc->vtable->base_type);
        else
            dest = pmc_new(interp, pmc->vtable->base_type);
        bigint_mod_bigint(interp, pmc, value, dest);
        return dest;
}PMC*
Parrot_BigInt_modulus_Integer(Interp *interp, PMC* pmc, PMC* value, PMC* dest)
{
        if (dest)
            VTABLE_morph(interp, dest, pmc->vtable->base_type);
        else
            dest = pmc_new(interp, pmc->vtable->base_type);
        bigint_mod_bigint_int(interp, pmc, PMC_int_val(value), dest);
        return dest;
}
void
Parrot_BigInt_i_modulus(Interp *interp, PMC* pmc, PMC* value)
#line 1068 "./src/pmc/bigint.pmc"
{
        real_exception(interp, NULL, E_NotImplementedError, "unimp mod");
}
#line 898 "src/pmc/bigint.c"
void
Parrot_BigInt_i_modulus_BigInt(Interp *interp, PMC* pmc, PMC* value)
{
            bigint_mod_bigint(interp, pmc, value, pmc);
}void
Parrot_BigInt_i_modulus_Integer(Interp *interp, PMC* pmc, PMC* value)
{
            bigint_mod_bigint_int(interp, pmc, PMC_int_val(value), pmc);
}
PMC*
Parrot_BigInt_cmodulus(Interp *interp, PMC* pmc, PMC* value, PMC* dest)
#line 1056 "./src/pmc/bigint.pmc"
{
            return Parrot_BigInt_modulus(interp, pmc, value, dest);
}
#line 914 "src/pmc/bigint.c"
PMC*
Parrot_BigInt_cmodulus_BigInt(Interp *interp, PMC* pmc, PMC* value, PMC* dest)
{
            return Parrot_BigInt_modulus_BigInt(interp, pmc, value, dest);
}PMC*
Parrot_BigInt_cmodulus_Integer(Interp *interp, PMC* pmc, PMC* value, PMC* dest)
{
            return Parrot_BigInt_modulus_Integer(interp, pmc, value, dest);
}
void
Parrot_BigInt_i_cmodulus(Interp *interp, PMC* pmc, PMC* value)
#line 1080 "./src/pmc/bigint.pmc"
{
        real_exception(interp, NULL, E_NotImplementedError, "unimp cmod");
}
#line 930 "src/pmc/bigint.c"
void
Parrot_BigInt_i_cmodulus_BigInt(Interp *interp, PMC* pmc, PMC* value)
{
            bigint_mod_bigint(interp, pmc, value, pmc);
}void
Parrot_BigInt_i_cmodulus_Integer(Interp *interp, PMC* pmc, PMC* value)
{
            bigint_mod_bigint_int(interp, pmc, PMC_int_val(value), pmc);
}
PMC*
Parrot_BigInt_pow(Interp *interp, PMC* pmc, PMC* value, PMC* dest)
#line 923 "./src/pmc/bigint.pmc"
{
    /* XXX only Integer RHS currently */
    INTVAL r = VTABLE_get_integer(interp, value);
    return Parrot_BigInt_pow_int(interp, pmc, r, dest);

}
#line 949 "src/pmc/bigint.c"
PMC*
Parrot_BigInt_pow_int(Interp *interp, PMC* pmc, INTVAL value, PMC* dest)
#line 914 "./src/pmc/bigint.pmc"
{
    if (dest)
        VTABLE_morph(interp, dest, pmc->vtable->base_type);
    else
        dest = pmc_new(interp, pmc->vtable->base_type);
    bigint_pow_bigint_int(interp, pmc, value, dest);
    return dest;

}
#line 962 "src/pmc/bigint.c"
PMC*
Parrot_BigInt_bitwise_shl(Interp *interp, PMC* pmc, PMC* value, PMC* dest)
#line 1184 "./src/pmc/bigint.pmc"
{
        real_exception(interp, NULL, E_NotImplementedError, "unimp shl");
        return dest;
}
#line 970 "src/pmc/bigint.c"
PMC*
Parrot_BigInt_bitwise_shl_BigInt(Interp *interp, PMC* pmc, PMC* value, PMC* dest)
{
        if (dest)
            VTABLE_morph(interp, dest, pmc->vtable->base_type);
        else
            dest = pmc_new(interp, pmc->vtable->base_type);
        bigint_bitwise_shl_bigint_int(interp, pmc,
                                      VTABLE_get_integer(interp, value),
                                      dest);
        return dest;
}PMC*
Parrot_BigInt_bitwise_shl_Integer(Interp *interp, PMC* pmc, PMC* value, PMC* dest)
{
        if (dest)
            VTABLE_morph(interp, dest, pmc->vtable->base_type);
        else
            dest = pmc_new(interp, pmc->vtable->base_type);
        bigint_bitwise_shl_bigint_int(interp, pmc, PMC_int_val(value),
                                      dest);
        return dest;
}
PMC*
Parrot_BigInt_bitwise_shl_int(Interp *interp, PMC* pmc, INTVAL value, PMC* dest)
#line 1210 "./src/pmc/bigint.pmc"
{
    if (dest)
        VTABLE_morph(interp, dest, pmc->vtable->base_type);
    else
        dest = pmc_new(interp, pmc->vtable->base_type);
    bigint_bitwise_shl_bigint_int(interp, pmc, value, dest);
    return dest;

}
#line 1005 "src/pmc/bigint.c"
void
Parrot_BigInt_i_bitwise_shl(Interp *interp, PMC* pmc, PMC* value)
#line 1220 "./src/pmc/bigint.pmc"
{
        real_exception(interp, NULL, E_NotImplementedError, "unimp shl");
}
#line 1012 "src/pmc/bigint.c"
void
Parrot_BigInt_i_bitwise_shl_BigInt(Interp *interp, PMC* pmc, PMC* value)
{
        bigint_bitwise_shl_bigint_int(interp, pmc,
                                      VTABLE_get_integer(interp, value),
                                      pmc);
}void
Parrot_BigInt_i_bitwise_shl_Integer(Interp *interp, PMC* pmc, PMC* value)
{
        bigint_bitwise_shl_bigint_int(interp, pmc, PMC_int_val(value),
                                      pmc);
}
void
Parrot_BigInt_i_bitwise_shl_int(Interp *interp, PMC* pmc, INTVAL value)
#line 1235 "./src/pmc/bigint.pmc"
{
    bigint_bitwise_shl_bigint_int(interp, pmc, value, pmc);

}
#line 1032 "src/pmc/bigint.c"
PMC*
Parrot_BigInt_bitwise_shr(Interp *interp, PMC* pmc, PMC* value, PMC* dest)
#line 1257 "./src/pmc/bigint.pmc"
{
        real_exception(interp, NULL, E_NotImplementedError, "unimp shr");
        return dest;
}
#line 1040 "src/pmc/bigint.c"
PMC*
Parrot_BigInt_bitwise_shr_BigInt(Interp *interp, PMC* pmc, PMC* value, PMC* dest)
{
        if (dest)
            VTABLE_morph(interp, dest, pmc->vtable->base_type);
        else
            dest = pmc_new(interp, pmc->vtable->base_type);
        bigint_bitwise_shr_bigint_int(interp, pmc,
                                      VTABLE_get_integer(interp, value),
                                      dest);
        return dest;
}PMC*
Parrot_BigInt_bitwise_shr_Integer(Interp *interp, PMC* pmc, PMC* value, PMC* dest)
{
        if (dest)
            VTABLE_morph(interp, dest, pmc->vtable->base_type);
        else
            dest = pmc_new(interp, pmc->vtable->base_type);
        bigint_bitwise_shr_bigint_int(interp, pmc, PMC_int_val(value),
                                      dest);
        return dest;
}
PMC*
Parrot_BigInt_bitwise_shr_int(Interp *interp, PMC* pmc, INTVAL value, PMC* dest)
#line 1283 "./src/pmc/bigint.pmc"
{
    if (dest)
        VTABLE_morph(interp, dest, pmc->vtable->base_type);
    else
        dest = pmc_new(interp, pmc->vtable->base_type);
    bigint_bitwise_shr_bigint_int(interp, pmc, value, dest);
    return dest;

}
#line 1075 "src/pmc/bigint.c"
void
Parrot_BigInt_i_bitwise_shr(Interp *interp, PMC* pmc, PMC* value)
#line 1293 "./src/pmc/bigint.pmc"
{
        real_exception(interp, NULL, E_NotImplementedError, "unimp shr");
}
#line 1082 "src/pmc/bigint.c"
void
Parrot_BigInt_i_bitwise_shr_BigInt(Interp *interp, PMC* pmc, PMC* value)
{
        bigint_bitwise_shr_bigint_int(interp, pmc,
                                      VTABLE_get_integer(interp, value),
                                      pmc);
}void
Parrot_BigInt_i_bitwise_shr_Integer(Interp *interp, PMC* pmc, PMC* value)
{
        bigint_bitwise_shr_bigint_int(interp, pmc, PMC_int_val(value),
                                      pmc);
}
void
Parrot_BigInt_i_bitwise_shr_int(Interp *interp, PMC* pmc, INTVAL value)
#line 1308 "./src/pmc/bigint.pmc"
{
    bigint_bitwise_shr_bigint_int(interp, pmc, value, pmc);

}
#line 1102 "src/pmc/bigint.c"
INTVAL
Parrot_BigInt_is_equal(Interp *interp, PMC* pmc, PMC* value)
#line 1106 "./src/pmc/bigint.pmc"
{
        real_exception(interp, NULL, E_NotImplementedError, "unimp eq");
        return 0;
}
#line 1110 "src/pmc/bigint.c"
INTVAL
Parrot_BigInt_is_equal_BigInt(Interp *interp, PMC* pmc, PMC* value)
{
    return bigint_cmp(interp, pmc, value) == 0;
}INTVAL
Parrot_BigInt_is_equal_Integer(Interp *interp, PMC* pmc, PMC* value)
{
    return bigint_cmp_int(interp, pmc, PMC_int_val(value)) == 0;
}
INTVAL
Parrot_BigInt_cmp(Interp *interp, PMC* pmc, PMC* value)
#line 1093 "./src/pmc/bigint.pmc"
{
        real_exception(interp, NULL, E_NotImplementedError, "unimp cmp");
        return 0;
}
#line 1127 "src/pmc/bigint.c"
INTVAL
Parrot_BigInt_cmp_BigInt(Interp *interp, PMC* pmc, PMC* value)
{
    return bigint_cmp(interp, pmc, value);
}INTVAL
Parrot_BigInt_cmp_Integer(Interp *interp, PMC* pmc, PMC* value)
{
    return bigint_cmp_int(interp, pmc, PMC_int_val(value));
}
PMC*
Parrot_BigInt_absolute(Interp *interp, PMC* pmc, PMC *dest)
#line 1131 "./src/pmc/bigint.pmc"
{
    if (!dest)
        dest = pmc_new(interp, pmc->vtable->base_type);
    bigint_abs(interp, pmc, dest);
    return dest;

}
#line 1147 "src/pmc/bigint.c"
PMC*
Parrot_BigInt_clone(Interp *interp, PMC* pmc)
#line 558 "./src/pmc/bigint.pmc"
{
    PMC *res;
    res = pmc_new(interp, pmc->vtable->base_type);
    bigint_set(interp, res, pmc);
    return res;

}
#line 1158 "src/pmc/bigint.c"
void
Parrot_BigInt_decrement(Interp *interp, PMC* pmc)
#line 752 "./src/pmc/bigint.pmc"
{
    bigint_sub_bigint_int(interp, pmc, 1, pmc);

}
#line 1166 "src/pmc/bigint.c"
void
Parrot_BigInt_destroy(Interp *interp, PMC* pmc)
#line 565 "./src/pmc/bigint.pmc"
{
    bigint_clear(interp, pmc);
    mem_sys_free(PMC_struct_val(pmc));

}
#line 1175 "src/pmc/bigint.c"
PMC*
Parrot_BigInt_get_bignum(Interp *interp, PMC* pmc)
#line 674 "./src/pmc/bigint.pmc"
{
    return pmc;

}
#line 1183 "src/pmc/bigint.c"
INTVAL
Parrot_BigInt_get_bool(Interp *interp, PMC* pmc)
#line 688 "./src/pmc/bigint.pmc"
{
    return bigint_get_bool(interp, pmc);

}
#line 1191 "src/pmc/bigint.c"
INTVAL
Parrot_BigInt_get_integer(Interp *interp, PMC* pmc)
#line 660 "./src/pmc/bigint.pmc"
{
    return bigint_get_long(interp, pmc);

}
#line 1199 "src/pmc/bigint.c"
FLOATVAL
Parrot_BigInt_get_number(Interp *interp, PMC* pmc)
#line 646 "./src/pmc/bigint.pmc"
{
    return bigint_get_double(interp, pmc);

}
#line 1207 "src/pmc/bigint.c"
STRING*
Parrot_BigInt_get_repr(Interp *interp, PMC* pmc)
#line 724 "./src/pmc/bigint.pmc"
{
    STRING *s = Parrot_BigInt_get_string(interp, pmc);
    return string_append(interp, s, const_string(interp, "L"));

}
#line 1216 "src/pmc/bigint.c"
STRING*
Parrot_BigInt_get_string(Interp *interp, PMC* pmc)
#line 711 "./src/pmc/bigint.pmc"
{
    char *s = bigint_get_string(interp, pmc, 10);
    STRING *ps = string_from_cstring(interp, s, 0);
    mem_sys_free(s);
    return ps;

}
#line 1227 "src/pmc/bigint.c"
STRING*
Parrot_BigInt_get_string_keyed_int(Interp *interp, PMC* pmc, INTVAL base)
#line 718 "./src/pmc/bigint.pmc"
{
    char *s = bigint_get_string(interp, pmc, base);
    STRING *ps = string_from_cstring(interp, s, 0);
    mem_sys_free(s);
    return ps;

}
#line 1238 "src/pmc/bigint.c"
void
Parrot_BigInt_i_absolute(Interp *interp, PMC* pmc)
#line 1138 "./src/pmc/bigint.pmc"
{
    bigint_abs(interp, pmc, pmc);

}
#line 1246 "src/pmc/bigint.c"
void
Parrot_BigInt_i_neg(Interp *interp, PMC* pmc)
#line 1162 "./src/pmc/bigint.pmc"
{
    bigint_neg(interp, pmc, pmc);

}
#line 1254 "src/pmc/bigint.c"
void
Parrot_BigInt_increment(Interp *interp, PMC* pmc)
#line 738 "./src/pmc/bigint.pmc"
{
    bigint_add_bigint_int(interp, pmc, 1, pmc);

}
#line 1262 "src/pmc/bigint.c"
void
Parrot_BigInt_init(Interp *interp, PMC* pmc)
#line 553 "./src/pmc/bigint.pmc"
{
    bigint_init(interp, pmc);
    PObj_active_destroy_SET(pmc);

}
#line 1271 "src/pmc/bigint.c"
PMC*
Parrot_BigInt_instantiate(Interp *interp, PMC* pmc, PMC* sig)
#line 529 "./src/pmc/bigint.pmc"
{
    int argcP = REG_INT(3);
    int base;
    PMC *res;
    STRING *num;

    return PMCNULL;  /* TODO */

    res = pmc_new(interp, enum_class_BigInt);
    if (!argcP) {
        return res;
    }
    base = 10;
    if (argcP == 2)
        base = VTABLE_get_integer(interp, REG_PMC(6));
    num = VTABLE_get_string(interp, REG_PMC(5));
    VTABLE_set_string_keyed_int(interp, res, base, num);
    return res;

}
#line 1295 "src/pmc/bigint.c"
void
Parrot_BigInt_morph(Interp *interp, PMC* pmc, INTVAL new_type)
#line 549 "./src/pmc/bigint.pmc"
{
    pmc_reuse(interp, pmc, new_type, 0);

}
#line 1303 "src/pmc/bigint.c"
PMC*
Parrot_BigInt_neg(Interp *interp, PMC* pmc, PMC* dest)
#line 1155 "./src/pmc/bigint.pmc"
{
    if (!dest)
        dest = pmc_new(interp, pmc->vtable->base_type);
    bigint_neg(interp, pmc, dest);
    return dest;

}
#line 1314 "src/pmc/bigint.c"
void
Parrot_BigInt_set_integer_native(Interp *interp, PMC* pmc, INTVAL value)
#line 578 "./src/pmc/bigint.pmc"
{
    bigint_set_long(interp, pmc, (long)value);

}
#line 1322 "src/pmc/bigint.c"
void
Parrot_BigInt_set_number_native(Interp *interp, PMC* pmc, FLOATVAL value)
#line 592 "./src/pmc/bigint.pmc"
{
    bigint_set_double(interp, pmc, (double)value);

}
#line 1330 "src/pmc/bigint.c"
void
Parrot_BigInt_set_pmc(Interp *interp, PMC* pmc, PMC *value)
#line 632 "./src/pmc/bigint.pmc"
{
    bigint_set_self(interp, pmc, bigint_get_self(interp, value));

}
#line 1338 "src/pmc/bigint.c"
void
Parrot_BigInt_set_string_keyed_int(Interp *interp, PMC* pmc, INTVAL base, STRING* value)
#line 617 "./src/pmc/bigint.pmc"
{
    char *s = string_to_cstring(interp, value);
    bigint_set_str(interp, pmc, s, base);
    string_cstring_free(s);

}
#line 1348 "src/pmc/bigint.c"
void
Parrot_BigInt_set_string_native(Interp *interp, PMC* pmc, STRING* value)
#line 611 "./src/pmc/bigint.pmc"
{
    char *s = string_to_cstring(interp, value);
    bigint_set_str(interp, pmc, s, 10);
    string_cstring_free(s);

}
#line 1358 "src/pmc/bigint.c"
STRING*
Parrot_BigInt_nci_version(Interp *interp, PMC* pmc)
#line 511 "./src/pmc/bigint.pmc"
{
#ifdef PARROT_HAS_GMP
    return string_from_cstring(interp, gmp_version, 0);
#else
    return const_string(interp, "0.0.0");
#endif

}
#line 1370 "src/pmc/bigint.c"
void
Parrot_BigInt_ro_add_attribute(Interp *interp, PMC* pmc, STRING* name, PMC* type)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "add_attribute() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_add_method(Interp *interp, PMC* pmc, STRING* method_name, PMC* sub_pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "add_method() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_add_parent(Interp *interp, PMC* pmc, PMC* parent)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "add_parent() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_add_role(Interp *interp, PMC* pmc, PMC* role)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "add_role() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_assign_pmc(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "assign_pmc() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_assign_string_native(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "assign_string_native() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_decrement(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "decrement() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_delete_keyed(Interp *interp, PMC* pmc, PMC* key)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "delete_keyed() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_delete_keyed_int(Interp *interp, PMC* pmc, INTVAL key)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "delete_keyed_int() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_delete_keyed_str(Interp *interp, PMC* pmc, STRING* key)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "delete_keyed_str() in read-only instance of BigInt");
}
PMC*
Parrot_BigInt_ro_find_method(Interp *interp, PMC* pmc, STRING* method_name)
 {
    PMC *const method = Parrot_default_find_method(interp, pmc, method_name);
    if (!PMC_IS_NULL(VTABLE_getprop(interp, method, const_string(interp, "write"))))
        return PMCNULL;
    else
        return method;
}
void
Parrot_BigInt_ro_i_absolute(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_absolute() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_i_bitwise_not(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_bitwise_not() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_i_bitwise_nots(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_bitwise_nots() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_i_logical_not(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_logical_not() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_i_neg(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_neg() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_increment(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "increment() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_morph(Interp *interp, PMC* pmc, INTVAL type)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "morph() in read-only instance of BigInt");
}
FLOATVAL
Parrot_BigInt_ro_pop_float(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "pop_float() in read-only instance of BigInt");
    return (FLOATVAL)0;
}
INTVAL
Parrot_BigInt_ro_pop_integer(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "pop_integer() in read-only instance of BigInt");
    return (INTVAL)0;
}
PMC*
Parrot_BigInt_ro_pop_pmc(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "pop_pmc() in read-only instance of BigInt");
    return PMCNULL;
}
STRING*
Parrot_BigInt_ro_pop_string(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "pop_string() in read-only instance of BigInt");
    return (STRING*)0;
}
void
Parrot_BigInt_ro_push_float(Interp *interp, PMC* pmc, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "push_float() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_push_integer(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "push_integer() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_push_pmc(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "push_pmc() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_push_string(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "push_string() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_remove_attribute(Interp *interp, PMC* pmc, STRING* name)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "remove_attribute() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_remove_method(Interp *interp, PMC* pmc, STRING* method_name)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "remove_method() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_remove_parent(Interp *interp, PMC* pmc, PMC* parent)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "remove_parent() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_remove_role(Interp *interp, PMC* pmc, PMC* role)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "remove_role() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_set_attr(Interp *interp, PMC* pmc, INTVAL idx, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_attr() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_set_attr_str(Interp *interp, PMC* pmc, STRING* idx, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_attr_str() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_set_bignum_int(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_bignum_int() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_set_bignum_num(Interp *interp, PMC* pmc, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_bignum_num() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_set_bignum_str(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_bignum_str() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_set_bool(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_bool() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_set_integer_keyed(Interp *interp, PMC* pmc, PMC* key, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_keyed() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_set_integer_keyed_int(Interp *interp, PMC* pmc, INTVAL key, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_keyed_int() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_set_integer_keyed_str(Interp *interp, PMC* pmc, STRING* key, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_keyed_str() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_set_integer_native(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_native() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_set_integer_same(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_same() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_set_number_keyed(Interp *interp, PMC* pmc, PMC* key, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_keyed() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_set_number_keyed_int(Interp *interp, PMC* pmc, INTVAL key, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_keyed_int() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_set_number_keyed_str(Interp *interp, PMC* pmc, STRING* key, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_keyed_str() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_set_number_native(Interp *interp, PMC* pmc, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_native() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_set_number_same(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_same() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_set_pmc(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pmc() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_set_pmc_keyed(Interp *interp, PMC* pmc, PMC* key, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pmc_keyed() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_set_pmc_keyed_int(Interp *interp, PMC* pmc, INTVAL key, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_int() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_set_pmc_keyed_str(Interp *interp, PMC* pmc, STRING* key, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_str() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_set_pointer(Interp *interp, PMC* pmc, void* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pointer() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_set_pointer_keyed(Interp *interp, PMC* pmc, PMC* key, void* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pointer_keyed() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_set_pointer_keyed_int(Interp *interp, PMC* pmc, INTVAL key, void* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_int() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_set_pointer_keyed_str(Interp *interp, PMC* pmc, STRING* key, void* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_str() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_set_string_keyed(Interp *interp, PMC* pmc, PMC* key, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_keyed() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_set_string_keyed_int(Interp *interp, PMC* pmc, INTVAL key, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_keyed_int() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_set_string_keyed_str(Interp *interp, PMC* pmc, STRING* key, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_keyed_str() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_set_string_native(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_native() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_set_string_same(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_same() in read-only instance of BigInt");
}
FLOATVAL
Parrot_BigInt_ro_shift_float(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "shift_float() in read-only instance of BigInt");
    return (FLOATVAL)0;
}
INTVAL
Parrot_BigInt_ro_shift_integer(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "shift_integer() in read-only instance of BigInt");
    return (INTVAL)0;
}
PMC*
Parrot_BigInt_ro_shift_pmc(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "shift_pmc() in read-only instance of BigInt");
    return PMCNULL;
}
STRING*
Parrot_BigInt_ro_shift_string(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "shift_string() in read-only instance of BigInt");
    return (STRING*)0;
}
void
Parrot_BigInt_ro_splice(Interp *interp, PMC* pmc, PMC* value, INTVAL offset, INTVAL count)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "splice() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_thaw(Interp *interp, PMC* pmc, visit_info* info)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "thaw() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_thawfinish(Interp *interp, PMC* pmc, visit_info* info)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "thawfinish() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_unshift_float(Interp *interp, PMC* pmc, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "unshift_float() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_unshift_integer(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "unshift_integer() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_unshift_pmc(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "unshift_pmc() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_unshift_string(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "unshift_string() in read-only instance of BigInt");
}
void
Parrot_BigInt_class_init(Parrot_Interp interp, int entry, int pass)
{
    const VTABLE temp_base_vtable = {
        NULL, /* namespace */
        enum_class_BigInt, /* base_type */
        NULL, /* whoami */
        0|VTABLE_HAS_READONLY_FLAG, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        NULL,   /* ro_variant_vtable */
        Parrot_BigInt_absolute,
        Parrot_default_add_attribute,
        Parrot_default_add_method,
        Parrot_default_add_parent,
        Parrot_default_add_role,
        Parrot_default_assign_pmc,
        Parrot_default_assign_string_native,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_can,
        Parrot_default_class_type,
        Parrot_BigInt_clone,
        Parrot_default_clone_pmc,
        Parrot_BigInt_decrement,
        Parrot_default_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_default_delete_keyed,
        Parrot_default_delete_keyed_int,
        Parrot_default_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_BigInt_destroy,
        Parrot_default_does,
        Parrot_default_elements,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_default_find_method,
        Parrot_default_freeze,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_BigInt_get_bignum,
        Parrot_BigInt_get_bool,
        Parrot_default_get_class,
        Parrot_BigInt_get_integer,
        Parrot_default_get_integer_keyed,
        Parrot_default_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_iter,
        Parrot_BigInt_get_number,
        Parrot_default_get_number_keyed,
        Parrot_default_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_default_get_pmc_keyed,
        Parrot_default_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_BigInt_get_repr,
        Parrot_BigInt_get_string,
        Parrot_default_get_string_keyed,
        Parrot_BigInt_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_default_hash,
        Parrot_BigInt_i_absolute,
        Parrot_default_i_bitwise_not,
        Parrot_default_i_bitwise_nots,
        Parrot_default_i_logical_not,
        Parrot_BigInt_i_neg,
        Parrot_BigInt_increment,
        Parrot_BigInt_init,
        Parrot_default_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_BigInt_instantiate,
        Parrot_default_invoke,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_logical_not,
        Parrot_default_mark,
        Parrot_BigInt_morph,
        Parrot_default_name,
        Parrot_BigInt_neg,
        Parrot_default_new_from_string,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_pmc_namespace,
        Parrot_default_pop_float,
        Parrot_default_pop_integer,
        Parrot_default_pop_pmc,
        Parrot_default_pop_string,
        Parrot_default_push_float,
        Parrot_default_push_integer,
        Parrot_default_push_pmc,
        Parrot_default_push_string,
        Parrot_default_remove_attribute,
        Parrot_default_remove_method,
        Parrot_default_remove_parent,
        Parrot_default_remove_role,
        Parrot_default_set_attr,
        Parrot_default_set_attr_str,
        Parrot_default_set_bignum_int,
        Parrot_default_set_bignum_num,
        Parrot_default_set_bignum_str,
        Parrot_default_set_bool,
        Parrot_default_set_integer_keyed,
        Parrot_default_set_integer_keyed_int,
        Parrot_default_set_integer_keyed_str,
        Parrot_BigInt_set_integer_native,
        Parrot_default_set_integer_same,
        Parrot_default_set_number_keyed,
        Parrot_default_set_number_keyed_int,
        Parrot_default_set_number_keyed_str,
        Parrot_BigInt_set_number_native,
        Parrot_default_set_number_same,
        Parrot_BigInt_set_pmc,
        Parrot_default_set_pmc_keyed,
        Parrot_default_set_pmc_keyed_int,
        Parrot_default_set_pmc_keyed_str,
        Parrot_default_set_pointer,
        Parrot_default_set_pointer_keyed,
        Parrot_default_set_pointer_keyed_int,
        Parrot_default_set_pointer_keyed_str,
        Parrot_default_set_string_keyed,
        Parrot_BigInt_set_string_keyed_int,
        Parrot_default_set_string_keyed_str,
        Parrot_BigInt_set_string_native,
        Parrot_default_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_default_shift_float,
        Parrot_default_shift_integer,
        Parrot_default_shift_pmc,
        Parrot_default_shift_string,
        Parrot_default_slice,
        Parrot_default_splice,
        Parrot_default_subclass,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtype,
        Parrot_default_thaw,
        Parrot_default_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_type_keyed_int,
        Parrot_default_type_keyed_str,
        Parrot_default_unshift_float,
        Parrot_default_unshift_integer,
        Parrot_default_unshift_pmc,
        Parrot_default_unshift_string,
        Parrot_default_visit
    };

    const VTABLE temp_ro_vtable = {
        NULL, /* namespace */
        enum_class_BigInt, /* base_type */
        NULL, /* whoami */
        0|VTABLE_IS_READONLY_FLAG, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        NULL,   /* ro_variant_vtable */
        Parrot_BigInt_absolute,
        Parrot_BigInt_ro_add_attribute,
        Parrot_BigInt_ro_add_method,
        Parrot_BigInt_ro_add_parent,
        Parrot_BigInt_ro_add_role,
        Parrot_BigInt_ro_assign_pmc,
        Parrot_BigInt_ro_assign_string_native,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_can,
        Parrot_default_class_type,
        Parrot_BigInt_clone,
        Parrot_default_clone_pmc,
        Parrot_BigInt_ro_decrement,
        Parrot_default_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_BigInt_ro_delete_keyed,
        Parrot_BigInt_ro_delete_keyed_int,
        Parrot_BigInt_ro_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_BigInt_destroy,
        Parrot_default_does,
        Parrot_default_elements,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_BigInt_ro_find_method,
        Parrot_default_freeze,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_BigInt_get_bignum,
        Parrot_BigInt_get_bool,
        Parrot_default_get_class,
        Parrot_BigInt_get_integer,
        Parrot_default_get_integer_keyed,
        Parrot_default_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_iter,
        Parrot_BigInt_get_number,
        Parrot_default_get_number_keyed,
        Parrot_default_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_default_get_pmc_keyed,
        Parrot_default_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_BigInt_get_repr,
        Parrot_BigInt_get_string,
        Parrot_default_get_string_keyed,
        Parrot_BigInt_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_default_hash,
        Parrot_BigInt_ro_i_absolute,
        Parrot_BigInt_ro_i_bitwise_not,
        Parrot_BigInt_ro_i_bitwise_nots,
        Parrot_BigInt_ro_i_logical_not,
        Parrot_BigInt_ro_i_neg,
        Parrot_BigInt_ro_increment,
        Parrot_BigInt_init,
        Parrot_default_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_BigInt_instantiate,
        Parrot_default_invoke,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_logical_not,
        Parrot_default_mark,
        Parrot_BigInt_ro_morph,
        Parrot_default_name,
        Parrot_BigInt_neg,
        Parrot_default_new_from_string,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_pmc_namespace,
        Parrot_BigInt_ro_pop_float,
        Parrot_BigInt_ro_pop_integer,
        Parrot_BigInt_ro_pop_pmc,
        Parrot_BigInt_ro_pop_string,
        Parrot_BigInt_ro_push_float,
        Parrot_BigInt_ro_push_integer,
        Parrot_BigInt_ro_push_pmc,
        Parrot_BigInt_ro_push_string,
        Parrot_BigInt_ro_remove_attribute,
        Parrot_BigInt_ro_remove_method,
        Parrot_BigInt_ro_remove_parent,
        Parrot_BigInt_ro_remove_role,
        Parrot_BigInt_ro_set_attr,
        Parrot_BigInt_ro_set_attr_str,
        Parrot_BigInt_ro_set_bignum_int,
        Parrot_BigInt_ro_set_bignum_num,
        Parrot_BigInt_ro_set_bignum_str,
        Parrot_BigInt_ro_set_bool,
        Parrot_BigInt_ro_set_integer_keyed,
        Parrot_BigInt_ro_set_integer_keyed_int,
        Parrot_BigInt_ro_set_integer_keyed_str,
        Parrot_BigInt_ro_set_integer_native,
        Parrot_BigInt_ro_set_integer_same,
        Parrot_BigInt_ro_set_number_keyed,
        Parrot_BigInt_ro_set_number_keyed_int,
        Parrot_BigInt_ro_set_number_keyed_str,
        Parrot_BigInt_ro_set_number_native,
        Parrot_BigInt_ro_set_number_same,
        Parrot_BigInt_ro_set_pmc,
        Parrot_BigInt_ro_set_pmc_keyed,
        Parrot_BigInt_ro_set_pmc_keyed_int,
        Parrot_BigInt_ro_set_pmc_keyed_str,
        Parrot_BigInt_ro_set_pointer,
        Parrot_BigInt_ro_set_pointer_keyed,
        Parrot_BigInt_ro_set_pointer_keyed_int,
        Parrot_BigInt_ro_set_pointer_keyed_str,
        Parrot_BigInt_ro_set_string_keyed,
        Parrot_BigInt_ro_set_string_keyed_int,
        Parrot_BigInt_ro_set_string_keyed_str,
        Parrot_BigInt_ro_set_string_native,
        Parrot_BigInt_ro_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_BigInt_ro_shift_float,
        Parrot_BigInt_ro_shift_integer,
        Parrot_BigInt_ro_shift_pmc,
        Parrot_BigInt_ro_shift_string,
        Parrot_default_slice,
        Parrot_BigInt_ro_splice,
        Parrot_default_subclass,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtype,
        Parrot_BigInt_ro_thaw,
        Parrot_BigInt_ro_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_type_keyed_int,
        Parrot_default_type_keyed_str,
        Parrot_BigInt_ro_unshift_float,
        Parrot_BigInt_ro_unshift_integer,
        Parrot_BigInt_ro_unshift_pmc,
        Parrot_BigInt_ro_unshift_string,
        Parrot_default_visit
    };

    const  MMD_init _temp_mmd_init[] = {
        { MMD_ADD, 0, enum_type_PMC, (funcptr_t) Parrot_BigInt_add },
        { MMD_ADD, 0, enum_class_BigInt, (funcptr_t) Parrot_BigInt_add_BigInt },
        { MMD_ADD, 0, enum_class_Integer, (funcptr_t) Parrot_BigInt_add_Integer },
        { MMD_ADD, 0, enum_type_INTVAL, (funcptr_t) Parrot_BigInt_add_int },
        { MMD_I_ADD, 0, enum_type_PMC, (funcptr_t) Parrot_BigInt_i_add },
        { MMD_I_ADD, 0, enum_class_BigInt, (funcptr_t) Parrot_BigInt_i_add_BigInt },
        { MMD_I_ADD, 0, enum_class_Integer, (funcptr_t) Parrot_BigInt_i_add_Integer },
        { MMD_I_ADD, 0, enum_type_INTVAL, (funcptr_t) Parrot_BigInt_i_add_int },
        { MMD_I_ADD, 0, enum_type_FLOATVAL, (funcptr_t) Parrot_BigInt_i_add_float },
        { MMD_SUBTRACT, 0, enum_type_PMC, (funcptr_t) Parrot_BigInt_subtract },
        { MMD_SUBTRACT, 0, enum_class_BigInt, (funcptr_t) Parrot_BigInt_subtract_BigInt },
        { MMD_SUBTRACT, 0, enum_class_Integer, (funcptr_t) Parrot_BigInt_subtract_Integer },
        { MMD_SUBTRACT, 0, enum_type_INTVAL, (funcptr_t) Parrot_BigInt_subtract_int },
        { MMD_I_SUBTRACT, 0, enum_type_PMC, (funcptr_t) Parrot_BigInt_i_subtract },
        { MMD_I_SUBTRACT, 0, enum_class_BigInt, (funcptr_t) Parrot_BigInt_i_subtract_BigInt },
        { MMD_I_SUBTRACT, 0, enum_class_Integer, (funcptr_t) Parrot_BigInt_i_subtract_Integer },
        { MMD_I_SUBTRACT, 0, enum_type_INTVAL, (funcptr_t) Parrot_BigInt_i_subtract_int },
        { MMD_I_SUBTRACT, 0, enum_type_FLOATVAL, (funcptr_t) Parrot_BigInt_i_subtract_float },
        { MMD_MULTIPLY, 0, enum_type_PMC, (funcptr_t) Parrot_BigInt_multiply },
        { MMD_MULTIPLY, 0, enum_class_BigInt, (funcptr_t) Parrot_BigInt_multiply_BigInt },
        { MMD_MULTIPLY, 0, enum_class_Integer, (funcptr_t) Parrot_BigInt_multiply_Integer },
        { MMD_MULTIPLY, 0, enum_type_INTVAL, (funcptr_t) Parrot_BigInt_multiply_int },
        { MMD_I_MULTIPLY, 0, enum_type_PMC, (funcptr_t) Parrot_BigInt_i_multiply },
        { MMD_I_MULTIPLY, 0, enum_class_BigInt, (funcptr_t) Parrot_BigInt_i_multiply_BigInt },
        { MMD_I_MULTIPLY, 0, enum_class_Integer, (funcptr_t) Parrot_BigInt_i_multiply_Integer },
        { MMD_I_MULTIPLY, 0, enum_type_INTVAL, (funcptr_t) Parrot_BigInt_i_multiply_int },
        { MMD_I_MULTIPLY, 0, enum_type_FLOATVAL, (funcptr_t) Parrot_BigInt_i_multiply_float },
        { MMD_DIVIDE, 0, enum_type_PMC, (funcptr_t) Parrot_BigInt_divide },
        { MMD_DIVIDE, 0, enum_class_BigInt, (funcptr_t) Parrot_BigInt_divide_BigInt },
        { MMD_DIVIDE, 0, enum_class_Integer, (funcptr_t) Parrot_BigInt_divide_Integer },
        { MMD_DIVIDE, 0, enum_type_INTVAL, (funcptr_t) Parrot_BigInt_divide_int },
        { MMD_I_DIVIDE, 0, enum_type_PMC, (funcptr_t) Parrot_BigInt_i_divide },
        { MMD_I_DIVIDE, 0, enum_class_BigInt, (funcptr_t) Parrot_BigInt_i_divide_BigInt },
        { MMD_I_DIVIDE, 0, enum_class_Integer, (funcptr_t) Parrot_BigInt_i_divide_Integer },
        { MMD_I_DIVIDE, 0, enum_type_INTVAL, (funcptr_t) Parrot_BigInt_i_divide_int },
        { MMD_FLOOR_DIVIDE, 0, enum_type_PMC, (funcptr_t) Parrot_BigInt_floor_divide },
        { MMD_FLOOR_DIVIDE, 0, enum_class_BigInt, (funcptr_t) Parrot_BigInt_floor_divide_BigInt },
        { MMD_FLOOR_DIVIDE, 0, enum_class_Integer, (funcptr_t) Parrot_BigInt_floor_divide_Integer },
        { MMD_FLOOR_DIVIDE, 0, enum_type_INTVAL, (funcptr_t) Parrot_BigInt_floor_divide_int },
        { MMD_I_FLOOR_DIVIDE, 0, enum_type_PMC, (funcptr_t) Parrot_BigInt_i_floor_divide },
        { MMD_I_FLOOR_DIVIDE, 0, enum_class_BigInt, (funcptr_t) Parrot_BigInt_i_floor_divide_BigInt },
        { MMD_I_FLOOR_DIVIDE, 0, enum_class_Integer, (funcptr_t) Parrot_BigInt_i_floor_divide_Integer },
        { MMD_I_FLOOR_DIVIDE, 0, enum_type_INTVAL, (funcptr_t) Parrot_BigInt_i_floor_divide_int },
        { MMD_MOD, 0, enum_type_PMC, (funcptr_t) Parrot_BigInt_modulus },
        { MMD_MOD, 0, enum_class_BigInt, (funcptr_t) Parrot_BigInt_modulus_BigInt },
        { MMD_MOD, 0, enum_class_Integer, (funcptr_t) Parrot_BigInt_modulus_Integer },
        { MMD_I_MOD, 0, enum_type_PMC, (funcptr_t) Parrot_BigInt_i_modulus },
        { MMD_I_MOD, 0, enum_class_BigInt, (funcptr_t) Parrot_BigInt_i_modulus_BigInt },
        { MMD_I_MOD, 0, enum_class_Integer, (funcptr_t) Parrot_BigInt_i_modulus_Integer },
        { MMD_CMOD, 0, enum_type_PMC, (funcptr_t) Parrot_BigInt_cmodulus },
        { MMD_CMOD, 0, enum_class_BigInt, (funcptr_t) Parrot_BigInt_cmodulus_BigInt },
        { MMD_CMOD, 0, enum_class_Integer, (funcptr_t) Parrot_BigInt_cmodulus_Integer },
        { MMD_I_CMOD, 0, enum_type_PMC, (funcptr_t) Parrot_BigInt_i_cmodulus },
        { MMD_I_CMOD, 0, enum_class_BigInt, (funcptr_t) Parrot_BigInt_i_cmodulus_BigInt },
        { MMD_I_CMOD, 0, enum_class_Integer, (funcptr_t) Parrot_BigInt_i_cmodulus_Integer },
        { MMD_POW, 0, enum_type_PMC, (funcptr_t) Parrot_BigInt_pow },
        { MMD_POW, 0, enum_type_INTVAL, (funcptr_t) Parrot_BigInt_pow_int },
        { MMD_BSL, 0, enum_type_PMC, (funcptr_t) Parrot_BigInt_bitwise_shl },
        { MMD_BSL, 0, enum_class_BigInt, (funcptr_t) Parrot_BigInt_bitwise_shl_BigInt },
        { MMD_BSL, 0, enum_class_Integer, (funcptr_t) Parrot_BigInt_bitwise_shl_Integer },
        { MMD_BSL, 0, enum_type_INTVAL, (funcptr_t) Parrot_BigInt_bitwise_shl_int },
        { MMD_I_BSL, 0, enum_type_PMC, (funcptr_t) Parrot_BigInt_i_bitwise_shl },
        { MMD_I_BSL, 0, enum_class_BigInt, (funcptr_t) Parrot_BigInt_i_bitwise_shl_BigInt },
        { MMD_I_BSL, 0, enum_class_Integer, (funcptr_t) Parrot_BigInt_i_bitwise_shl_Integer },
        { MMD_I_BSL, 0, enum_type_INTVAL, (funcptr_t) Parrot_BigInt_i_bitwise_shl_int },
        { MMD_BSR, 0, enum_type_PMC, (funcptr_t) Parrot_BigInt_bitwise_shr },
        { MMD_BSR, 0, enum_class_BigInt, (funcptr_t) Parrot_BigInt_bitwise_shr_BigInt },
        { MMD_BSR, 0, enum_class_Integer, (funcptr_t) Parrot_BigInt_bitwise_shr_Integer },
        { MMD_BSR, 0, enum_type_INTVAL, (funcptr_t) Parrot_BigInt_bitwise_shr_int },
        { MMD_I_BSR, 0, enum_type_PMC, (funcptr_t) Parrot_BigInt_i_bitwise_shr },
        { MMD_I_BSR, 0, enum_class_BigInt, (funcptr_t) Parrot_BigInt_i_bitwise_shr_BigInt },
        { MMD_I_BSR, 0, enum_class_Integer, (funcptr_t) Parrot_BigInt_i_bitwise_shr_Integer },
        { MMD_I_BSR, 0, enum_type_INTVAL, (funcptr_t) Parrot_BigInt_i_bitwise_shr_int },
        { MMD_EQ, 0, enum_type_PMC, (funcptr_t) Parrot_BigInt_is_equal },
        { MMD_EQ, 0, enum_class_BigInt, (funcptr_t) Parrot_BigInt_is_equal_BigInt },
        { MMD_EQ, 0, enum_class_Integer, (funcptr_t) Parrot_BigInt_is_equal_Integer },
        { MMD_CMP, 0, enum_type_PMC, (funcptr_t) Parrot_BigInt_cmp },
        { MMD_CMP, 0, enum_class_BigInt, (funcptr_t) Parrot_BigInt_cmp_BigInt },
        { MMD_CMP, 0, enum_class_Integer, (funcptr_t) Parrot_BigInt_cmp_Integer }
    };
    /*  Dynamic PMCs need the runtime type
    which is passed in entry to class_init.
    */
    if (pass == 0) {
        /*
         * create vtable - clone it - we have to set a few items
         */
        VTABLE *vt_clone =
            Parrot_clone_vtable(interp, &temp_base_vtable);
        VTABLE *vt_ro_clone =
            Parrot_clone_vtable(interp, &temp_ro_vtable);
        vt_clone->whoami = CONST_STRING(interp, "BigInt");
        vt_clone->isa_str = CONST_STRING(interp, "BigInt");
        vt_clone->does_str = CONST_STRING(interp, "scalar");
        vt_ro_clone->base_type = entry;
        vt_ro_clone->whoami = vt_clone->whoami;
        vt_ro_clone->isa_str = vt_clone->isa_str;
        vt_ro_clone->does_str = vt_clone->does_str;
        vt_clone->ro_variant_vtable = vt_ro_clone;
        vt_ro_clone->ro_variant_vtable = vt_clone;
        interp->vtables[entry] = vt_clone;
    }
    else { /* pass */
        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        /* create PMC Proxy object */
        Parrot_create_pmc_proxy(interp, entry);
        register_nci_method(interp, entry,
                F2DPTR(Parrot_BigInt_nci_version),
                "version", "SJO");
        /* class_init */
        {
#define N_MMD_INIT (sizeof(_temp_mmd_init)/sizeof(_temp_mmd_init[0]))
            Parrot_mmd_register_table(interp, entry,
                _temp_mmd_init, N_MMD_INIT);
        }
    } /* pass */
} /* Parrot_BigInt_class_init */


/*

=back

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
