/*
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/coroutine.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

#line 1 "./src/pmc/coroutine.pmc"
/*
Copyright (C) 2001-2007, The Perl Foundation.
$Id: coroutine.pmc 19040 2007-06-16 08:20:45Z chromatic $

=head1 NAME

src/pmc/coroutine.pmc - Co-Routine PMC

=head1 DESCRIPTION

C<Coroutine> extends C<Continuation> to provide a subroutine that can
stop in the middle, and start back up later at the point at which it
stopped. See the L<Glossary|docs/glossary.pod> for more information.

=head2 Flags

=over 4

=item private0 call flip flop

=item private3 restore current sub after "flop".  Used by generators.

=back

=head2 Methods

=over 4

=cut

*/

#include "parrot/parrot.h"
#include "parrot/oplib/ops.h"
#include <assert.h>

/*
 * XXX put these into exceptions.h
 */


#define TRY \
    do { \
        new_internal_exception(INTERP); \
        if (!setjmp(INTERP->exceptions->destination))

#define CATCH \
    else

#define ENDTRY \
    } while (0); \
    do { \
        Parrot_exception *e = INTERP->exceptions; \
        INTERP->exceptions = e->prev; \
        INTERP->exc_free_list = e; \
    } while (0)


#define THROW(e)  \
    do { \
        exceptions->err = e; \
        longjmp(exceptions->dest, 1); \
    } while (0)

static void
print_sub_name(Interp* interp, PMC* sub)
{
    Parrot_coro *co     = PMC_coro(sub);
    Interp      *tracer = interp->debugger ? interp->debugger : interp;

    PIO_eprintf(tracer, "# %s coro '%Ss'",
        !(PObj_get_FLAGS(sub) & SUB_FLAG_CORO_FF) ?
        "Calling" : "yielding from",
        Parrot_full_sub_name(interp, sub));
    if (co->ctx &&
        (PObj_get_FLAGS(sub) & SUB_FLAG_CORO_FF)) {
        PIO_eprintf(tracer, " to '%Ss'",
                Parrot_full_sub_name(interp,
                    co->ctx->caller_ctx->current_sub));
    }
    PIO_eprintf(tracer, "\n# ");
    print_pbc_location(interp);
}

#line 97 "src/pmc/coroutine.c"
#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_coroutine.h"
#include "pmc_sub.h"
#include "pmc_default.h"
#include "coroutine.str"

PMC*
Parrot_Coroutine_clone(Interp *interp, PMC* pmc)
#line 123 "./src/pmc/coroutine.pmc"
{
    Parrot_coro *sub;
    PMC         *ret    = pmc_new_noinit(interp, pmc->vtable->base_type);

    PObj_custom_mark_destroy_SETALL(ret);

    sub                 = mem_allocate_typed(Parrot_coro);
    PMC_struct_val(ret) = sub;
    PMC_pmc_val(ret)    = NULL;

    memcpy(sub, PMC_sub(pmc), sizeof (Parrot_coro));

    sub->name           = string_copy(interp, sub->name);

    return ret;

}
#line 126 "src/pmc/coroutine.c"
void
Parrot_Coroutine_destroy(Interp *interp, PMC* pmc)
#line 115 "./src/pmc/coroutine.pmc"
{
    Parrot_coro *sub = PMC_coro(pmc);
    if (sub->ctx)
        Parrot_free_context(interp, sub->ctx, 0);

    Parrot_Sub_destroy(interp, pmc);

}
#line 138 "src/pmc/coroutine.c"
void
Parrot_Coroutine_init(Interp *interp, PMC* pmc)
#line 101 "./src/pmc/coroutine.pmc"
{
    PMC_struct_val(pmc) = new_coroutine(interp);
    PMC_pmc_val(pmc)    = NULL;
    PObj_custom_mark_destroy_SETALL(pmc);

}
#line 148 "src/pmc/coroutine.c"
opcode_t*
Parrot_Coroutine_invoke(Interp *interp, PMC* pmc, void *next)
#line 150 "./src/pmc/coroutine.pmc"
{
    parrot_context_t   *caller_ctx;
    PackFile_ByteCode  *wanted_seg;
    struct Stack_Chunk *state;
    parrot_context_t   *ctx;
    PMC                *ccont;
    Parrot_coro        *co   = PMC_coro(pmc);
    opcode_t           *dest = co->address;

    if (Interp_trace_TEST(interp, PARROT_TRACE_SUB_CALL_FLAG))
        print_sub_name(interp, pmc);

    if (!co->ctx) {
        /* TODO factor out common code with Sub.invoke
         *      and inherit it
         */
        ccont = interp->current_cont;
        if (ccont == NEED_CONTINUATION)
            ccont = (PMC *)new_ret_continuation_pmc(interp,
                                                   (opcode_t *)next);

        if (PObj_get_FLAGS(ccont) & SUB_FLAG_TAILCALL)
            real_exception(interp, NULL, E_Exception,
                    "tail call to coro not allowed");

        caller_ctx = CONTEXT(interp->ctx);

        /* first time set current sub, cont, object */
        Parrot_alloc_context(interp, co->n_regs_used);

        co->ctx                   = ctx = CONTEXT(interp->ctx);
        co->dynamic_state         = interp->dynamic_env;
        ctx->caller_ctx           = caller_ctx;
        PMC_cont(ccont)->from_ctx = ctx;
        ctx->current_sub          = pmc;
        ctx->current_HLL          = co->HLL_id;
        ctx->current_namespace    = co->namespace_stash;
        ctx->current_cont         = ccont;
        ctx->current_object       = NULL;
        interp->current_object    = NULL;
        interp->current_cont      = NULL;

        /* create pad if needed */
        if (!PMC_IS_NULL(co->lex_info)) {
            ctx->lex_pad = pmc_new_init(interp,
                    Parrot_get_ctx_HLL_type(interp,
                        enum_class_LexPad),
                    co->lex_info);
            VTABLE_set_pointer(interp, ctx->lex_pad, ctx);
        }

        PObj_get_FLAGS(pmc) |= SUB_FLAG_CORO_FF;
        wanted_seg            = co->seg;
        co->caller_seg        = interp->code;
        co->address           = co->seg->base.data + co->start_offs;
    }

    /* if calling the Coro we need the segment of the Coro */
    else if (!(PObj_get_FLAGS(pmc) & SUB_FLAG_CORO_FF)) {
        PObj_get_FLAGS(pmc) |= SUB_FLAG_CORO_FF;
        wanted_seg            = co->seg;

        /* remember segment of caller */
        co->caller_seg        = interp->code;
        ctx                   = co->ctx;

        /* and the recent call context */
        ccont                 = ctx->current_cont;
        ctx->caller_ctx       = PMC_cont(ccont)->to_ctx = CONTEXT(interp->ctx);
        /* set context to coro context */
        state                 = interp->dynamic_env;
        interp->dynamic_env   = co->dynamic_state;
        co->dynamic_state     = state;
        CONTEXT(interp->ctx)  = ctx;
        interp->ctx.bp        = ctx->bp;
        interp->ctx.bp_ps     = ctx->bp_ps;
    }
    else {
        PObj_get_FLAGS(pmc) &= ~SUB_FLAG_CORO_FF;
        /* switch back to last remembered code seg and context */

        wanted_seg            = co->caller_seg;
        ccont                 = co->ctx->current_cont;
        ctx                   = PMC_cont(ccont)->to_ctx;

        if (! ctx) {
            /* This still isn't quite right, but it beats segfaulting.  See
               the "Call an exited coroutine" case in t/pmc/coroutine.t; the
               problem is that the defunct coroutine yields up one more
               result before we get here.  -- rgr, 7-Oct-06.
            */
            real_exception(interp, NULL, E_Exception,
                           "Cannot resume dead coroutine.");
        }

        state                = interp->dynamic_env;
        interp->dynamic_env  = co->dynamic_state;
        co->dynamic_state    = state;
        CONTEXT(interp->ctx) = ctx;
        interp->ctx.bp       = ctx->bp;
        interp->ctx.bp_ps    = ctx->bp_ps;
    }

    /* toggle address */
    dest        = co->address;
    co->address = (opcode_t *)next;

    if (interp->code != wanted_seg)
        Parrot_switch_to_cs(interp, wanted_seg, 1);

    return dest;

}
#line 265 "src/pmc/coroutine.c"
void
Parrot_Coroutine_mark(Interp *interp, PMC* pmc)
#line 273 "./src/pmc/coroutine.pmc"
{
    Parrot_coro *c = PMC_coro(pmc);
    if (c && c->ctx)
        mark_context(interp, c->ctx);
    if (c && c->dynamic_state)
        mark_stack(interp, c->dynamic_state);
    Parrot_Sub_mark(interp, pmc);

}
#line 278 "src/pmc/coroutine.c"
void
Parrot_Coroutine_ro_add_attribute(Interp *interp, PMC* pmc, STRING* name, PMC* type)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "add_attribute() in read-only instance of Coroutine");
}
void
Parrot_Coroutine_ro_add_method(Interp *interp, PMC* pmc, STRING* method_name, PMC* sub_pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "add_method() in read-only instance of Coroutine");
}
void
Parrot_Coroutine_ro_add_parent(Interp *interp, PMC* pmc, PMC* parent)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "add_parent() in read-only instance of Coroutine");
}
void
Parrot_Coroutine_ro_add_role(Interp *interp, PMC* pmc, PMC* role)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "add_role() in read-only instance of Coroutine");
}
void
Parrot_Coroutine_ro_assign_pmc(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "assign_pmc() in read-only instance of Coroutine");
}
void
Parrot_Coroutine_ro_assign_string_native(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "assign_string_native() in read-only instance of Coroutine");
}
void
Parrot_Coroutine_ro_decrement(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "decrement() in read-only instance of Coroutine");
}
void
Parrot_Coroutine_ro_delete_keyed(Interp *interp, PMC* pmc, PMC* key)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "delete_keyed() in read-only instance of Coroutine");
}
void
Parrot_Coroutine_ro_delete_keyed_int(Interp *interp, PMC* pmc, INTVAL key)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "delete_keyed_int() in read-only instance of Coroutine");
}
void
Parrot_Coroutine_ro_delete_keyed_str(Interp *interp, PMC* pmc, STRING* key)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "delete_keyed_str() in read-only instance of Coroutine");
}
PMC*
Parrot_Coroutine_ro_find_method(Interp *interp, PMC* pmc, STRING* method_name)
 {
    PMC *const method = Parrot_default_find_method(interp, pmc, method_name);
    if (!PMC_IS_NULL(VTABLE_getprop(interp, method, const_string(interp, "write"))))
        return PMCNULL;
    else
        return method;
}
void
Parrot_Coroutine_ro_i_absolute(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_absolute() in read-only instance of Coroutine");
}
void
Parrot_Coroutine_ro_i_bitwise_not(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_bitwise_not() in read-only instance of Coroutine");
}
void
Parrot_Coroutine_ro_i_bitwise_nots(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_bitwise_nots() in read-only instance of Coroutine");
}
void
Parrot_Coroutine_ro_i_logical_not(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_logical_not() in read-only instance of Coroutine");
}
void
Parrot_Coroutine_ro_i_neg(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_neg() in read-only instance of Coroutine");
}
void
Parrot_Coroutine_ro_increment(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "increment() in read-only instance of Coroutine");
}
void
Parrot_Coroutine_ro_morph(Interp *interp, PMC* pmc, INTVAL type)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "morph() in read-only instance of Coroutine");
}
FLOATVAL
Parrot_Coroutine_ro_pop_float(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "pop_float() in read-only instance of Coroutine");
    return (FLOATVAL)0;
}
INTVAL
Parrot_Coroutine_ro_pop_integer(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "pop_integer() in read-only instance of Coroutine");
    return (INTVAL)0;
}
PMC*
Parrot_Coroutine_ro_pop_pmc(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "pop_pmc() in read-only instance of Coroutine");
    return PMCNULL;
}
STRING*
Parrot_Coroutine_ro_pop_string(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "pop_string() in read-only instance of Coroutine");
    return (STRING*)0;
}
void
Parrot_Coroutine_ro_push_float(Interp *interp, PMC* pmc, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "push_float() in read-only instance of Coroutine");
}
void
Parrot_Coroutine_ro_push_integer(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "push_integer() in read-only instance of Coroutine");
}
void
Parrot_Coroutine_ro_push_pmc(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "push_pmc() in read-only instance of Coroutine");
}
void
Parrot_Coroutine_ro_push_string(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "push_string() in read-only instance of Coroutine");
}
void
Parrot_Coroutine_ro_remove_attribute(Interp *interp, PMC* pmc, STRING* name)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "remove_attribute() in read-only instance of Coroutine");
}
void
Parrot_Coroutine_ro_remove_method(Interp *interp, PMC* pmc, STRING* method_name)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "remove_method() in read-only instance of Coroutine");
}
void
Parrot_Coroutine_ro_remove_parent(Interp *interp, PMC* pmc, PMC* parent)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "remove_parent() in read-only instance of Coroutine");
}
void
Parrot_Coroutine_ro_remove_role(Interp *interp, PMC* pmc, PMC* role)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "remove_role() in read-only instance of Coroutine");
}
void
Parrot_Coroutine_ro_set_attr(Interp *interp, PMC* pmc, INTVAL idx, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_attr() in read-only instance of Coroutine");
}
void
Parrot_Coroutine_ro_set_attr_str(Interp *interp, PMC* pmc, STRING* idx, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_attr_str() in read-only instance of Coroutine");
}
void
Parrot_Coroutine_ro_set_bignum_int(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_bignum_int() in read-only instance of Coroutine");
}
void
Parrot_Coroutine_ro_set_bignum_num(Interp *interp, PMC* pmc, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_bignum_num() in read-only instance of Coroutine");
}
void
Parrot_Coroutine_ro_set_bignum_str(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_bignum_str() in read-only instance of Coroutine");
}
void
Parrot_Coroutine_ro_set_bool(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_bool() in read-only instance of Coroutine");
}
void
Parrot_Coroutine_ro_set_integer_keyed(Interp *interp, PMC* pmc, PMC* key, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_keyed() in read-only instance of Coroutine");
}
void
Parrot_Coroutine_ro_set_integer_keyed_int(Interp *interp, PMC* pmc, INTVAL key, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_keyed_int() in read-only instance of Coroutine");
}
void
Parrot_Coroutine_ro_set_integer_keyed_str(Interp *interp, PMC* pmc, STRING* key, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_keyed_str() in read-only instance of Coroutine");
}
void
Parrot_Coroutine_ro_set_integer_native(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_native() in read-only instance of Coroutine");
}
void
Parrot_Coroutine_ro_set_integer_same(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_same() in read-only instance of Coroutine");
}
void
Parrot_Coroutine_ro_set_number_keyed(Interp *interp, PMC* pmc, PMC* key, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_keyed() in read-only instance of Coroutine");
}
void
Parrot_Coroutine_ro_set_number_keyed_int(Interp *interp, PMC* pmc, INTVAL key, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_keyed_int() in read-only instance of Coroutine");
}
void
Parrot_Coroutine_ro_set_number_keyed_str(Interp *interp, PMC* pmc, STRING* key, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_keyed_str() in read-only instance of Coroutine");
}
void
Parrot_Coroutine_ro_set_number_native(Interp *interp, PMC* pmc, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_native() in read-only instance of Coroutine");
}
void
Parrot_Coroutine_ro_set_number_same(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_same() in read-only instance of Coroutine");
}
void
Parrot_Coroutine_ro_set_pmc(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pmc() in read-only instance of Coroutine");
}
void
Parrot_Coroutine_ro_set_pmc_keyed(Interp *interp, PMC* pmc, PMC* key, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pmc_keyed() in read-only instance of Coroutine");
}
void
Parrot_Coroutine_ro_set_pmc_keyed_int(Interp *interp, PMC* pmc, INTVAL key, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_int() in read-only instance of Coroutine");
}
void
Parrot_Coroutine_ro_set_pmc_keyed_str(Interp *interp, PMC* pmc, STRING* key, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_str() in read-only instance of Coroutine");
}
void
Parrot_Coroutine_ro_set_pointer(Interp *interp, PMC* pmc, void* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pointer() in read-only instance of Coroutine");
}
void
Parrot_Coroutine_ro_set_pointer_keyed(Interp *interp, PMC* pmc, PMC* key, void* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pointer_keyed() in read-only instance of Coroutine");
}
void
Parrot_Coroutine_ro_set_pointer_keyed_int(Interp *interp, PMC* pmc, INTVAL key, void* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_int() in read-only instance of Coroutine");
}
void
Parrot_Coroutine_ro_set_pointer_keyed_str(Interp *interp, PMC* pmc, STRING* key, void* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_str() in read-only instance of Coroutine");
}
void
Parrot_Coroutine_ro_set_string_keyed(Interp *interp, PMC* pmc, PMC* key, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_keyed() in read-only instance of Coroutine");
}
void
Parrot_Coroutine_ro_set_string_keyed_int(Interp *interp, PMC* pmc, INTVAL key, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_keyed_int() in read-only instance of Coroutine");
}
void
Parrot_Coroutine_ro_set_string_keyed_str(Interp *interp, PMC* pmc, STRING* key, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_keyed_str() in read-only instance of Coroutine");
}
void
Parrot_Coroutine_ro_set_string_native(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_native() in read-only instance of Coroutine");
}
void
Parrot_Coroutine_ro_set_string_same(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_same() in read-only instance of Coroutine");
}
FLOATVAL
Parrot_Coroutine_ro_shift_float(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "shift_float() in read-only instance of Coroutine");
    return (FLOATVAL)0;
}
INTVAL
Parrot_Coroutine_ro_shift_integer(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "shift_integer() in read-only instance of Coroutine");
    return (INTVAL)0;
}
PMC*
Parrot_Coroutine_ro_shift_pmc(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "shift_pmc() in read-only instance of Coroutine");
    return PMCNULL;
}
STRING*
Parrot_Coroutine_ro_shift_string(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "shift_string() in read-only instance of Coroutine");
    return (STRING*)0;
}
void
Parrot_Coroutine_ro_splice(Interp *interp, PMC* pmc, PMC* value, INTVAL offset, INTVAL count)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "splice() in read-only instance of Coroutine");
}
void
Parrot_Coroutine_ro_thaw(Interp *interp, PMC* pmc, visit_info* info)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "thaw() in read-only instance of Coroutine");
}
void
Parrot_Coroutine_ro_thawfinish(Interp *interp, PMC* pmc, visit_info* info)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "thawfinish() in read-only instance of Coroutine");
}
void
Parrot_Coroutine_ro_unshift_float(Interp *interp, PMC* pmc, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "unshift_float() in read-only instance of Coroutine");
}
void
Parrot_Coroutine_ro_unshift_integer(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "unshift_integer() in read-only instance of Coroutine");
}
void
Parrot_Coroutine_ro_unshift_pmc(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "unshift_pmc() in read-only instance of Coroutine");
}
void
Parrot_Coroutine_ro_unshift_string(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "unshift_string() in read-only instance of Coroutine");
}
void
Parrot_Coroutine_class_init(Parrot_Interp interp, int entry, int pass)
{
    const VTABLE temp_base_vtable = {
        NULL, /* namespace */
        enum_class_Coroutine, /* base_type */
        NULL, /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_HAS_READONLY_FLAG, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        NULL,   /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_default_add_attribute,
        Parrot_default_add_method,
        Parrot_default_add_parent,
        Parrot_default_add_role,
        Parrot_Sub_assign_pmc,
        Parrot_default_assign_string_native,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_can,
        Parrot_default_class_type,
        Parrot_Coroutine_clone,
        Parrot_default_clone_pmc,
        Parrot_default_decrement,
        Parrot_Sub_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_default_delete_keyed,
        Parrot_default_delete_keyed_int,
        Parrot_default_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_Coroutine_destroy,
        Parrot_default_does,
        Parrot_default_elements,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_default_find_method,
        Parrot_Sub_freeze,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_Sub_get_bool,
        Parrot_default_get_class,
        Parrot_default_get_integer,
        Parrot_Sub_get_integer_keyed,
        Parrot_default_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_iter,
        Parrot_default_get_number,
        Parrot_default_get_number_keyed,
        Parrot_default_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_default_get_pmc_keyed,
        Parrot_default_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_Sub_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_default_get_repr,
        Parrot_Sub_get_string,
        Parrot_default_get_string_keyed,
        Parrot_default_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_default_hash,
        Parrot_default_i_absolute,
        Parrot_default_i_bitwise_not,
        Parrot_default_i_bitwise_nots,
        Parrot_default_i_logical_not,
        Parrot_default_i_neg,
        Parrot_default_increment,
        Parrot_Coroutine_init,
        Parrot_default_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_default_instantiate,
        Parrot_Coroutine_invoke,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_logical_not,
        Parrot_Coroutine_mark,
        Parrot_default_morph,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_new_from_string,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_pmc_namespace,
        Parrot_default_pop_float,
        Parrot_default_pop_integer,
        Parrot_default_pop_pmc,
        Parrot_default_pop_string,
        Parrot_default_push_float,
        Parrot_default_push_integer,
        Parrot_default_push_pmc,
        Parrot_default_push_string,
        Parrot_default_remove_attribute,
        Parrot_default_remove_method,
        Parrot_default_remove_parent,
        Parrot_default_remove_role,
        Parrot_default_set_attr,
        Parrot_default_set_attr_str,
        Parrot_default_set_bignum_int,
        Parrot_default_set_bignum_num,
        Parrot_default_set_bignum_str,
        Parrot_default_set_bool,
        Parrot_default_set_integer_keyed,
        Parrot_default_set_integer_keyed_int,
        Parrot_default_set_integer_keyed_str,
        Parrot_default_set_integer_native,
        Parrot_default_set_integer_same,
        Parrot_default_set_number_keyed,
        Parrot_default_set_number_keyed_int,
        Parrot_default_set_number_keyed_str,
        Parrot_default_set_number_native,
        Parrot_default_set_number_same,
        Parrot_Sub_set_pmc,
        Parrot_default_set_pmc_keyed,
        Parrot_default_set_pmc_keyed_int,
        Parrot_default_set_pmc_keyed_str,
        Parrot_Sub_set_pointer,
        Parrot_default_set_pointer_keyed,
        Parrot_default_set_pointer_keyed_int,
        Parrot_default_set_pointer_keyed_str,
        Parrot_default_set_string_keyed,
        Parrot_default_set_string_keyed_int,
        Parrot_default_set_string_keyed_str,
        Parrot_Sub_set_string_native,
        Parrot_default_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_default_shift_float,
        Parrot_default_shift_integer,
        Parrot_default_shift_pmc,
        Parrot_default_shift_string,
        Parrot_default_slice,
        Parrot_default_splice,
        Parrot_default_subclass,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtype,
        Parrot_Sub_thaw,
        Parrot_default_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_type_keyed_int,
        Parrot_default_type_keyed_str,
        Parrot_default_unshift_float,
        Parrot_default_unshift_integer,
        Parrot_default_unshift_pmc,
        Parrot_default_unshift_string,
        Parrot_Sub_visit
    };

    const VTABLE temp_ro_vtable = {
        NULL, /* namespace */
        enum_class_Coroutine, /* base_type */
        NULL, /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_IS_READONLY_FLAG, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        NULL,   /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_Coroutine_ro_add_attribute,
        Parrot_Coroutine_ro_add_method,
        Parrot_Coroutine_ro_add_parent,
        Parrot_Coroutine_ro_add_role,
        Parrot_Coroutine_ro_assign_pmc,
        Parrot_Coroutine_ro_assign_string_native,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_can,
        Parrot_default_class_type,
        Parrot_Coroutine_clone,
        Parrot_default_clone_pmc,
        Parrot_Coroutine_ro_decrement,
        Parrot_Sub_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_Coroutine_ro_delete_keyed,
        Parrot_Coroutine_ro_delete_keyed_int,
        Parrot_Coroutine_ro_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_Coroutine_destroy,
        Parrot_default_does,
        Parrot_default_elements,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_Coroutine_ro_find_method,
        Parrot_Sub_freeze,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_Sub_get_bool,
        Parrot_default_get_class,
        Parrot_default_get_integer,
        Parrot_Sub_get_integer_keyed,
        Parrot_default_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_iter,
        Parrot_default_get_number,
        Parrot_default_get_number_keyed,
        Parrot_default_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_default_get_pmc_keyed,
        Parrot_default_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_Sub_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_default_get_repr,
        Parrot_Sub_get_string,
        Parrot_default_get_string_keyed,
        Parrot_default_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_default_hash,
        Parrot_Coroutine_ro_i_absolute,
        Parrot_Coroutine_ro_i_bitwise_not,
        Parrot_Coroutine_ro_i_bitwise_nots,
        Parrot_Coroutine_ro_i_logical_not,
        Parrot_Coroutine_ro_i_neg,
        Parrot_Coroutine_ro_increment,
        Parrot_Coroutine_init,
        Parrot_default_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_default_instantiate,
        Parrot_Coroutine_invoke,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_logical_not,
        Parrot_Coroutine_mark,
        Parrot_Coroutine_ro_morph,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_new_from_string,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_pmc_namespace,
        Parrot_Coroutine_ro_pop_float,
        Parrot_Coroutine_ro_pop_integer,
        Parrot_Coroutine_ro_pop_pmc,
        Parrot_Coroutine_ro_pop_string,
        Parrot_Coroutine_ro_push_float,
        Parrot_Coroutine_ro_push_integer,
        Parrot_Coroutine_ro_push_pmc,
        Parrot_Coroutine_ro_push_string,
        Parrot_Coroutine_ro_remove_attribute,
        Parrot_Coroutine_ro_remove_method,
        Parrot_Coroutine_ro_remove_parent,
        Parrot_Coroutine_ro_remove_role,
        Parrot_Coroutine_ro_set_attr,
        Parrot_Coroutine_ro_set_attr_str,
        Parrot_Coroutine_ro_set_bignum_int,
        Parrot_Coroutine_ro_set_bignum_num,
        Parrot_Coroutine_ro_set_bignum_str,
        Parrot_Coroutine_ro_set_bool,
        Parrot_Coroutine_ro_set_integer_keyed,
        Parrot_Coroutine_ro_set_integer_keyed_int,
        Parrot_Coroutine_ro_set_integer_keyed_str,
        Parrot_Coroutine_ro_set_integer_native,
        Parrot_Coroutine_ro_set_integer_same,
        Parrot_Coroutine_ro_set_number_keyed,
        Parrot_Coroutine_ro_set_number_keyed_int,
        Parrot_Coroutine_ro_set_number_keyed_str,
        Parrot_Coroutine_ro_set_number_native,
        Parrot_Coroutine_ro_set_number_same,
        Parrot_Coroutine_ro_set_pmc,
        Parrot_Coroutine_ro_set_pmc_keyed,
        Parrot_Coroutine_ro_set_pmc_keyed_int,
        Parrot_Coroutine_ro_set_pmc_keyed_str,
        Parrot_Coroutine_ro_set_pointer,
        Parrot_Coroutine_ro_set_pointer_keyed,
        Parrot_Coroutine_ro_set_pointer_keyed_int,
        Parrot_Coroutine_ro_set_pointer_keyed_str,
        Parrot_Coroutine_ro_set_string_keyed,
        Parrot_Coroutine_ro_set_string_keyed_int,
        Parrot_Coroutine_ro_set_string_keyed_str,
        Parrot_Coroutine_ro_set_string_native,
        Parrot_Coroutine_ro_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_Coroutine_ro_shift_float,
        Parrot_Coroutine_ro_shift_integer,
        Parrot_Coroutine_ro_shift_pmc,
        Parrot_Coroutine_ro_shift_string,
        Parrot_default_slice,
        Parrot_Coroutine_ro_splice,
        Parrot_default_subclass,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtype,
        Parrot_Coroutine_ro_thaw,
        Parrot_Coroutine_ro_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_type_keyed_int,
        Parrot_default_type_keyed_str,
        Parrot_Coroutine_ro_unshift_float,
        Parrot_Coroutine_ro_unshift_integer,
        Parrot_Coroutine_ro_unshift_pmc,
        Parrot_Coroutine_ro_unshift_string,
        Parrot_Sub_visit
    };
    if (pass == 0) {
        /*
         * create vtable - clone it - we have to set a few items
         */
        VTABLE *vt_clone =
            Parrot_clone_vtable(interp, &temp_base_vtable);
        VTABLE *vt_ro_clone =
            Parrot_clone_vtable(interp, &temp_ro_vtable);
        vt_clone->whoami = CONST_STRING(interp, "Coroutine");
        vt_clone->isa_str = CONST_STRING(interp, "Coroutine Sub");
        vt_clone->does_str = CONST_STRING(interp, "scalar");
        vt_ro_clone->base_type = entry;
        vt_ro_clone->whoami = vt_clone->whoami;
        vt_ro_clone->isa_str = vt_clone->isa_str;
        vt_ro_clone->does_str = vt_clone->does_str;
        vt_clone->ro_variant_vtable = vt_ro_clone;
        vt_ro_clone->ro_variant_vtable = vt_clone;
        interp->vtables[entry] = vt_clone;
    }
    else { /* pass */
        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        /* create PMC Proxy object */
        Parrot_create_pmc_proxy(interp, entry);
        /* class_init */
        {
        }
    } /* pass */
} /* Parrot_Coroutine_class_init */


/*

=back

=head1 HISTORY

Initial version by Melvin on 2002/06/6.

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
