/*
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/default.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

#line 1 "./src/pmc/default.pmc"
/*
Copyright (C) 2001-2007, The Perl Foundation.
$Id: default.pmc 18578 2007-05-17 05:09:00Z chromatic $

=head1 NAME

src/pmc/default.pmc - Abstract root class

=head1 DESCRIPTION

These are the vtable functions for the default PMC class.

All methods which are not defined here get a default implementation
generated from F<vtable.tbl> by F<tools/build/pmc2c.pl>.

=head2 Functions

=over 4

=cut

*/

#include "parrot/parrot.h"

#define INT2KEY(i,k) key_new_integer((i), (k))

/* undef 'interface', because msvc is craptastic */
#undef interface

/*

=item C<static const char *caller(Interp *interp, PMC *pmc)>

Returns a C string for the name of C<*pmc>.

=cut

*/

static const char *
caller(Interp *interp, PMC * pmc)
{
    return pmc && pmc->vtable && pmc->vtable->whoami ?
    VTABLE_name(interp, pmc)->strstart : "(null)";
}

/*

=item C<static void cant_do_method(Interp *interp, PMC * pmc,
                                   const char *methname)>

Throws an exception "$methname() not implemented in class '$class'", used by
all unimplemented messages.

=cut

*/

static void
cant_do_method(Interp *interp, PMC * pmc, const char *methname)
{
    real_exception(interp, NULL, ILL_INHERIT,
                       "%s() not implemented in class '%s'", methname,
                       caller(interp, pmc));
}

/*

=item C<static INTVAL
check_set_std_props(Interp *interp, PMC *pmc, STRING *key, PMC *value)>

Called from C<setprop()>.

Returns a true value if C<setprop()> can avoid actually setting a property
in the prophash. If it returns true, the property setting will be reflected
in a future call to C<propagate_std_props()>

=cut

*/

static INTVAL
check_set_std_props(Interp *interp, PMC *pmc, STRING *key, PMC *value)
{
    /* the quick hack below cannot be used because the string could
       be constructed in an interpreter that is later destroyed */
#if  0
    /* XXX
     * a quick hack, to prevent freeing that string during DOD
     * triggered in t/pmc/pmc_62.t when configured with --gc=libc
     */
    static STRING *ro;
    if (!ro)
        ro = string_make(interp, "_ro", 3, "ascii",
            PObj_constant_FLAG|PObj_external_FLAG);
    if (!string_compare(interp, key, ro)) {
#else

    /*
     * s2 in string_compare is freed here
     */
    if (!string_compare(interp, key,
        string_from_cstring(interp, "_ro", 3))) {
#endif
        /* pmc should set/clear readonly */
        INTVAL on = VTABLE_get_bool(interp, value);
        /* morph to Const/normal class or readonly class */
        /* XXX warn when this fails? */
        if (on && (pmc->vtable->flags & VTABLE_HAS_CONST_TOO))
            pmc->vtable = interp->vtables[pmc->vtable->base_type + 1];
        else if (!on && (pmc->vtable->flags & (VTABLE_IS_CONST_FLAG)))
            VTABLE_morph(interp, pmc, pmc->vtable->base_type - 1);
        else if (on && (pmc->vtable->flags & VTABLE_HAS_READONLY_FLAG))
            pmc->vtable = pmc->vtable->ro_variant_vtable;
        else if (!on && (pmc->vtable->flags & VTABLE_IS_READONLY_FLAG)
                && pmc->vtable->ro_variant_vtable)
            pmc->vtable = pmc->vtable->ro_variant_vtable;
        else
            return 0;

        return 1;
    }
    return 0;
}

/*

=item C<static void
propagate_std_props(Interp *interp, PMC *self, PMC *prop_hash)>

Set pending standard properties in C<prop_hash>.

=cut

*/

static void
propagate_std_props(Interp *interp, PMC *self, PMC *prop_hash) {
    if (self->vtable->flags & (VTABLE_IS_CONST_FLAG | VTABLE_IS_READONLY_FLAG)){
        PMC *pmc_true;
        pmc_true = pmc_new(interp, enum_class_Integer);
        PMC_int_val(pmc_true) = 1;
        VTABLE_set_pmc_keyed_str(interp, prop_hash,
            string_from_cstring(interp, "_ro", 3), pmc_true);
    }
}

/*

=item C<static INTVAL
has_pending_std_props(Interp *interp, PMC *self)>

Returns true if propagate_std_props() would create a non-empty prophash.

=cut

*/

static INTVAL
has_pending_std_props(Interp *interp, PMC *self) {
    if (self->vtable->flags & (VTABLE_IS_CONST_FLAG | VTABLE_IS_READONLY_FLAG))
        return 1;
    else
        return 0;
}


/*

=item C<static PMC*
check_get_std_props(Interp *interpeter, PMC *self, STRING *key)>

Checks if we can infer the value of C<key> property from C<self> without
looking at its prophash. Returns C<PMCNULL> if not, returns the value otherwise.

=cut
*/

static PMC*
check_get_std_props(Interp *interp, PMC *self, STRING *key) {
    if ((self->vtable->flags & (VTABLE_IS_CONST_FLAG | VTABLE_IS_READONLY_FLAG))
        &&!string_compare(interp, key,
                          string_from_cstring(interp, "_ro", 3))) {
        PMC *ret_val;
        ret_val = pmc_new(interp, enum_class_Integer);
        PMC_int_val(ret_val) = 1;
        return ret_val;
    }
    else
        return PMCNULL;
}

/*

=item C<static PMC *
make_prop_hash(Interp *interp, PMC *self)>

Create a property hash for C<self>. Returns the created hash. Inferred
properties will be added to the hash and it will be set as
C<PMC_metadata(self)>.

=cut

*/

static PMC*
make_prop_hash(Interp *interp, PMC *self) {
    PMC *prop;

    if (!self->pmc_ext)
        add_pmc_ext(interp, self);

    PMC_metadata(self) = prop = pmc_new_noinit(interp, enum_class_Hash);
    DOD_WRITE_BARRIER(interp, self, NULL, prop);
    VTABLE_init(interp, prop);
    propagate_std_props(interp, self, prop);
    return prop;
}

/*

=item C<static INTVAL
does_isa(Interp* interp, STRING *method, STRING *what)>

Compares C<*method> and C<*what>.

=cut

*/

static INTVAL
does_isa(Interp* interp, STRING *method, STRING *what)
{
    INTVAL len, pos = 0;

    do {
        pos = string_str_index(interp, what, method, pos);
        if (pos < 0)
            return 0;
        if (pos >= (INTVAL)string_length(interp, what))
            return 0;
        len = string_length(interp, method);
        if (pos && string_index(interp, what, pos - 1) != 32) {
            pos += len;
            continue;
        }

        if (pos+len < (INTVAL)string_length(interp, what) &&
            string_index(interp, what, pos + len) != 32) {
            pos += len;
            continue;
        }
        return 1;
    } while (1);
    return 0;
}

#line 271 "src/pmc/default.c"
#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_default.h"
#include "default.str"

#line 276 "default.c"

PMC*
Parrot_default_add(Interp *interp, PMC* pmc, PMC* value, PMC* dest)
{
    cant_do_method(interp, pmc, "add");
    return PMCNULL;
}

#line 285 "default.c"

PMC*
Parrot_default_add_int(Interp *interp, PMC* pmc, INTVAL value, PMC* dest)
{
    cant_do_method(interp, pmc, "add_int");
    return PMCNULL;
}

#line 294 "default.c"

PMC*
Parrot_default_add_float(Interp *interp, PMC* pmc, FLOATVAL value, PMC* dest)
{
    cant_do_method(interp, pmc, "add_float");
    return PMCNULL;
}

#line 303 "default.c"

void
Parrot_default_i_add(Interp *interp, PMC* pmc, PMC* value)
{
    cant_do_method(interp, pmc, "i_add");
}

#line 311 "default.c"

void
Parrot_default_i_add_int(Interp *interp, PMC* pmc, INTVAL value)
{
    cant_do_method(interp, pmc, "i_add_int");
}

#line 319 "default.c"

void
Parrot_default_i_add_float(Interp *interp, PMC* pmc, FLOATVAL value)
{
    cant_do_method(interp, pmc, "i_add_float");
}

#line 327 "default.c"

PMC*
Parrot_default_subtract(Interp *interp, PMC* pmc, PMC* value, PMC* dest)
{
    cant_do_method(interp, pmc, "subtract");
    return PMCNULL;
}

#line 336 "default.c"

PMC*
Parrot_default_subtract_int(Interp *interp, PMC* pmc, INTVAL value, PMC* dest)
{
    cant_do_method(interp, pmc, "subtract_int");
    return PMCNULL;
}

#line 345 "default.c"

PMC*
Parrot_default_subtract_float(Interp *interp, PMC* pmc, FLOATVAL value, PMC* dest)
{
    cant_do_method(interp, pmc, "subtract_float");
    return PMCNULL;
}

#line 354 "default.c"

void
Parrot_default_i_subtract(Interp *interp, PMC* pmc, PMC* value)
{
    cant_do_method(interp, pmc, "i_subtract");
}

#line 362 "default.c"

void
Parrot_default_i_subtract_int(Interp *interp, PMC* pmc, INTVAL value)
{
    cant_do_method(interp, pmc, "i_subtract_int");
}

#line 370 "default.c"

void
Parrot_default_i_subtract_float(Interp *interp, PMC* pmc, FLOATVAL value)
{
    cant_do_method(interp, pmc, "i_subtract_float");
}

#line 378 "default.c"

PMC*
Parrot_default_multiply(Interp *interp, PMC* pmc, PMC* value, PMC* dest)
{
    cant_do_method(interp, pmc, "multiply");
    return PMCNULL;
}

#line 387 "default.c"

PMC*
Parrot_default_multiply_int(Interp *interp, PMC* pmc, INTVAL value, PMC* dest)
{
    cant_do_method(interp, pmc, "multiply_int");
    return PMCNULL;
}

#line 396 "default.c"

PMC*
Parrot_default_multiply_float(Interp *interp, PMC* pmc, FLOATVAL value, PMC* dest)
{
    cant_do_method(interp, pmc, "multiply_float");
    return PMCNULL;
}

#line 405 "default.c"

void
Parrot_default_i_multiply(Interp *interp, PMC* pmc, PMC* value)
{
    cant_do_method(interp, pmc, "i_multiply");
}

#line 413 "default.c"

void
Parrot_default_i_multiply_int(Interp *interp, PMC* pmc, INTVAL value)
{
    cant_do_method(interp, pmc, "i_multiply_int");
}

#line 421 "default.c"

void
Parrot_default_i_multiply_float(Interp *interp, PMC* pmc, FLOATVAL value)
{
    cant_do_method(interp, pmc, "i_multiply_float");
}

#line 429 "default.c"

PMC*
Parrot_default_divide(Interp *interp, PMC* pmc, PMC* value, PMC* dest)
{
    cant_do_method(interp, pmc, "divide");
    return PMCNULL;
}

#line 438 "default.c"

PMC*
Parrot_default_divide_int(Interp *interp, PMC* pmc, INTVAL value, PMC* dest)
{
    cant_do_method(interp, pmc, "divide_int");
    return PMCNULL;
}

#line 447 "default.c"

PMC*
Parrot_default_divide_float(Interp *interp, PMC* pmc, FLOATVAL value, PMC* dest)
{
    cant_do_method(interp, pmc, "divide_float");
    return PMCNULL;
}

#line 456 "default.c"

void
Parrot_default_i_divide(Interp *interp, PMC* pmc, PMC* value)
{
    cant_do_method(interp, pmc, "i_divide");
}

#line 464 "default.c"

void
Parrot_default_i_divide_int(Interp *interp, PMC* pmc, INTVAL value)
{
    cant_do_method(interp, pmc, "i_divide_int");
}

#line 472 "default.c"

void
Parrot_default_i_divide_float(Interp *interp, PMC* pmc, FLOATVAL value)
{
    cant_do_method(interp, pmc, "i_divide_float");
}

#line 480 "default.c"

PMC*
Parrot_default_floor_divide(Interp *interp, PMC* pmc, PMC* value, PMC* dest)
{
    cant_do_method(interp, pmc, "floor_divide");
    return PMCNULL;
}

#line 489 "default.c"

PMC*
Parrot_default_floor_divide_int(Interp *interp, PMC* pmc, INTVAL value, PMC* dest)
{
    cant_do_method(interp, pmc, "floor_divide_int");
    return PMCNULL;
}

#line 498 "default.c"

PMC*
Parrot_default_floor_divide_float(Interp *interp, PMC* pmc, FLOATVAL value, PMC* dest)
{
    cant_do_method(interp, pmc, "floor_divide_float");
    return PMCNULL;
}

#line 507 "default.c"

void
Parrot_default_i_floor_divide(Interp *interp, PMC* pmc, PMC* value)
{
    cant_do_method(interp, pmc, "i_floor_divide");
}

#line 515 "default.c"

void
Parrot_default_i_floor_divide_int(Interp *interp, PMC* pmc, INTVAL value)
{
    cant_do_method(interp, pmc, "i_floor_divide_int");
}

#line 523 "default.c"

void
Parrot_default_i_floor_divide_float(Interp *interp, PMC* pmc, FLOATVAL value)
{
    cant_do_method(interp, pmc, "i_floor_divide_float");
}

#line 531 "default.c"

PMC*
Parrot_default_modulus(Interp *interp, PMC* pmc, PMC* value, PMC* dest)
{
    cant_do_method(interp, pmc, "modulus");
    return PMCNULL;
}

#line 540 "default.c"

PMC*
Parrot_default_modulus_int(Interp *interp, PMC* pmc, INTVAL value, PMC* dest)
{
    cant_do_method(interp, pmc, "modulus_int");
    return PMCNULL;
}

#line 549 "default.c"

PMC*
Parrot_default_modulus_float(Interp *interp, PMC* pmc, FLOATVAL value, PMC* dest)
{
    cant_do_method(interp, pmc, "modulus_float");
    return PMCNULL;
}

#line 558 "default.c"

void
Parrot_default_i_modulus(Interp *interp, PMC* pmc, PMC* value)
{
    cant_do_method(interp, pmc, "i_modulus");
}

#line 566 "default.c"

void
Parrot_default_i_modulus_int(Interp *interp, PMC* pmc, INTVAL value)
{
    cant_do_method(interp, pmc, "i_modulus_int");
}

#line 574 "default.c"

void
Parrot_default_i_modulus_float(Interp *interp, PMC* pmc, FLOATVAL value)
{
    cant_do_method(interp, pmc, "i_modulus_float");
}

#line 582 "default.c"

PMC*
Parrot_default_cmodulus(Interp *interp, PMC* pmc, PMC* value, PMC* dest)
{
    cant_do_method(interp, pmc, "cmodulus");
    return PMCNULL;
}

#line 591 "default.c"

PMC*
Parrot_default_cmodulus_int(Interp *interp, PMC* pmc, INTVAL value, PMC* dest)
{
    cant_do_method(interp, pmc, "cmodulus_int");
    return PMCNULL;
}

#line 600 "default.c"

PMC*
Parrot_default_cmodulus_float(Interp *interp, PMC* pmc, FLOATVAL value, PMC* dest)
{
    cant_do_method(interp, pmc, "cmodulus_float");
    return PMCNULL;
}

#line 609 "default.c"

void
Parrot_default_i_cmodulus(Interp *interp, PMC* pmc, PMC* value)
{
    cant_do_method(interp, pmc, "i_cmodulus");
}

#line 617 "default.c"

void
Parrot_default_i_cmodulus_int(Interp *interp, PMC* pmc, INTVAL value)
{
    cant_do_method(interp, pmc, "i_cmodulus_int");
}

#line 625 "default.c"

void
Parrot_default_i_cmodulus_float(Interp *interp, PMC* pmc, FLOATVAL value)
{
    cant_do_method(interp, pmc, "i_cmodulus_float");
}

#line 633 "default.c"

PMC*
Parrot_default_pow(Interp *interp, PMC* pmc, PMC* value, PMC* dest)
{
    cant_do_method(interp, pmc, "pow");
    return PMCNULL;
}

#line 642 "default.c"

PMC*
Parrot_default_pow_int(Interp *interp, PMC* pmc, INTVAL value, PMC* dest)
{
    cant_do_method(interp, pmc, "pow_int");
    return PMCNULL;
}

#line 651 "default.c"

PMC*
Parrot_default_pow_float(Interp *interp, PMC* pmc, FLOATVAL value, PMC* dest)
{
    cant_do_method(interp, pmc, "pow_float");
    return PMCNULL;
}

#line 660 "default.c"

void
Parrot_default_i_pow(Interp *interp, PMC* pmc, PMC* value)
{
    cant_do_method(interp, pmc, "i_pow");
}

#line 668 "default.c"

void
Parrot_default_i_pow_int(Interp *interp, PMC* pmc, INTVAL value)
{
    cant_do_method(interp, pmc, "i_pow_int");
}

#line 676 "default.c"

void
Parrot_default_i_pow_float(Interp *interp, PMC* pmc, FLOATVAL value)
{
    cant_do_method(interp, pmc, "i_pow_float");
}

#line 684 "default.c"

PMC*
Parrot_default_bitwise_or(Interp *interp, PMC* pmc, PMC* value, PMC* dest)
{
    cant_do_method(interp, pmc, "bitwise_or");
    return PMCNULL;
}

#line 693 "default.c"

PMC*
Parrot_default_bitwise_or_int(Interp *interp, PMC* pmc, INTVAL value, PMC* dest)
{
    cant_do_method(interp, pmc, "bitwise_or_int");
    return PMCNULL;
}

#line 702 "default.c"

void
Parrot_default_i_bitwise_or(Interp *interp, PMC* pmc, PMC* value)
{
    cant_do_method(interp, pmc, "i_bitwise_or");
}

#line 710 "default.c"

void
Parrot_default_i_bitwise_or_int(Interp *interp, PMC* pmc, INTVAL value)
{
    cant_do_method(interp, pmc, "i_bitwise_or_int");
}

#line 718 "default.c"

PMC*
Parrot_default_bitwise_and(Interp *interp, PMC* pmc, PMC* value, PMC* dest)
{
    cant_do_method(interp, pmc, "bitwise_and");
    return PMCNULL;
}

#line 727 "default.c"

PMC*
Parrot_default_bitwise_and_int(Interp *interp, PMC* pmc, INTVAL value, PMC* dest)
{
    cant_do_method(interp, pmc, "bitwise_and_int");
    return PMCNULL;
}

#line 736 "default.c"

void
Parrot_default_i_bitwise_and(Interp *interp, PMC* pmc, PMC* value)
{
    cant_do_method(interp, pmc, "i_bitwise_and");
}

#line 744 "default.c"

void
Parrot_default_i_bitwise_and_int(Interp *interp, PMC* pmc, INTVAL value)
{
    cant_do_method(interp, pmc, "i_bitwise_and_int");
}

#line 752 "default.c"

PMC*
Parrot_default_bitwise_xor(Interp *interp, PMC* pmc, PMC* value, PMC* dest)
{
    cant_do_method(interp, pmc, "bitwise_xor");
    return PMCNULL;
}

#line 761 "default.c"

PMC*
Parrot_default_bitwise_xor_int(Interp *interp, PMC* pmc, INTVAL value, PMC* dest)
{
    cant_do_method(interp, pmc, "bitwise_xor_int");
    return PMCNULL;
}

#line 770 "default.c"

void
Parrot_default_i_bitwise_xor(Interp *interp, PMC* pmc, PMC* value)
{
    cant_do_method(interp, pmc, "i_bitwise_xor");
}

#line 778 "default.c"

void
Parrot_default_i_bitwise_xor_int(Interp *interp, PMC* pmc, INTVAL value)
{
    cant_do_method(interp, pmc, "i_bitwise_xor_int");
}

#line 786 "default.c"

PMC*
Parrot_default_bitwise_ors(Interp *interp, PMC* pmc, PMC* value, PMC* dest)
{
    cant_do_method(interp, pmc, "bitwise_ors");
    return PMCNULL;
}

#line 795 "default.c"

PMC*
Parrot_default_bitwise_ors_str(Interp *interp, PMC* pmc, STRING* value, PMC* dest)
{
    cant_do_method(interp, pmc, "bitwise_ors_str");
    return PMCNULL;
}

#line 804 "default.c"

void
Parrot_default_i_bitwise_ors(Interp *interp, PMC* pmc, PMC* value)
{
    cant_do_method(interp, pmc, "i_bitwise_ors");
}

#line 812 "default.c"

void
Parrot_default_i_bitwise_ors_str(Interp *interp, PMC* pmc, STRING* value)
{
    cant_do_method(interp, pmc, "i_bitwise_ors_str");
}

#line 820 "default.c"

PMC*
Parrot_default_bitwise_ands(Interp *interp, PMC* pmc, PMC* value, PMC* dest)
{
    cant_do_method(interp, pmc, "bitwise_ands");
    return PMCNULL;
}

#line 829 "default.c"

PMC*
Parrot_default_bitwise_ands_str(Interp *interp, PMC* pmc, STRING* value, PMC* dest)
{
    cant_do_method(interp, pmc, "bitwise_ands_str");
    return PMCNULL;
}

#line 838 "default.c"

void
Parrot_default_i_bitwise_ands(Interp *interp, PMC* pmc, PMC* value)
{
    cant_do_method(interp, pmc, "i_bitwise_ands");
}

#line 846 "default.c"

void
Parrot_default_i_bitwise_ands_str(Interp *interp, PMC* pmc, STRING* value)
{
    cant_do_method(interp, pmc, "i_bitwise_ands_str");
}

#line 854 "default.c"

PMC*
Parrot_default_bitwise_xors(Interp *interp, PMC* pmc, PMC* value, PMC* dest)
{
    cant_do_method(interp, pmc, "bitwise_xors");
    return PMCNULL;
}

#line 863 "default.c"

PMC*
Parrot_default_bitwise_xors_str(Interp *interp, PMC* pmc, STRING* value, PMC* dest)
{
    cant_do_method(interp, pmc, "bitwise_xors_str");
    return PMCNULL;
}

#line 872 "default.c"

void
Parrot_default_i_bitwise_xors(Interp *interp, PMC* pmc, PMC* value)
{
    cant_do_method(interp, pmc, "i_bitwise_xors");
}

#line 880 "default.c"

void
Parrot_default_i_bitwise_xors_str(Interp *interp, PMC* pmc, STRING* value)
{
    cant_do_method(interp, pmc, "i_bitwise_xors_str");
}

#line 888 "default.c"

PMC*
Parrot_default_bitwise_shl(Interp *interp, PMC* pmc, PMC* value, PMC* dest)
{
    cant_do_method(interp, pmc, "bitwise_shl");
    return PMCNULL;
}

#line 897 "default.c"

PMC*
Parrot_default_bitwise_shl_int(Interp *interp, PMC* pmc, INTVAL value, PMC* dest)
{
    cant_do_method(interp, pmc, "bitwise_shl_int");
    return PMCNULL;
}

#line 906 "default.c"

void
Parrot_default_i_bitwise_shl(Interp *interp, PMC* pmc, PMC* value)
{
    cant_do_method(interp, pmc, "i_bitwise_shl");
}

#line 914 "default.c"

void
Parrot_default_i_bitwise_shl_int(Interp *interp, PMC* pmc, INTVAL value)
{
    cant_do_method(interp, pmc, "i_bitwise_shl_int");
}

#line 922 "default.c"

PMC*
Parrot_default_bitwise_shr(Interp *interp, PMC* pmc, PMC* value, PMC* dest)
{
    cant_do_method(interp, pmc, "bitwise_shr");
    return PMCNULL;
}

#line 931 "default.c"

PMC*
Parrot_default_bitwise_shr_int(Interp *interp, PMC* pmc, INTVAL value, PMC* dest)
{
    cant_do_method(interp, pmc, "bitwise_shr_int");
    return PMCNULL;
}

#line 940 "default.c"

void
Parrot_default_i_bitwise_shr(Interp *interp, PMC* pmc, PMC* value)
{
    cant_do_method(interp, pmc, "i_bitwise_shr");
}

#line 948 "default.c"

void
Parrot_default_i_bitwise_shr_int(Interp *interp, PMC* pmc, INTVAL value)
{
    cant_do_method(interp, pmc, "i_bitwise_shr_int");
}

#line 956 "default.c"

PMC*
Parrot_default_bitwise_lsr(Interp *interp, PMC* pmc, PMC* value, PMC* dest)
{
    cant_do_method(interp, pmc, "bitwise_lsr");
    return PMCNULL;
}

#line 965 "default.c"

PMC*
Parrot_default_bitwise_lsr_int(Interp *interp, PMC* pmc, INTVAL value, PMC* dest)
{
    cant_do_method(interp, pmc, "bitwise_lsr_int");
    return PMCNULL;
}

#line 974 "default.c"

void
Parrot_default_i_bitwise_lsr(Interp *interp, PMC* pmc, PMC* value)
{
    cant_do_method(interp, pmc, "i_bitwise_lsr");
}

#line 982 "default.c"

void
Parrot_default_i_bitwise_lsr_int(Interp *interp, PMC* pmc, INTVAL value)
{
    cant_do_method(interp, pmc, "i_bitwise_lsr_int");
}

INTVAL
Parrot_default_is_equal(Interp *interp, PMC* pmc, PMC* value)
#line 755 "./src/pmc/default.pmc"
{
    return (pmc->vtable == value->vtable
        && PMC_struct_val(pmc) == PMC_struct_val(value)
        && PMC_data(pmc) == PMC_data(value));

}
#line 1001 "src/pmc/default.c"
INTVAL
Parrot_default_is_equal_num(Interp *interp, PMC* pmc, PMC* value)
#line 771 "./src/pmc/default.pmc"
{
    return (VTABLE_get_number(interp, pmc) ==
            VTABLE_get_number(interp, value));

}
#line 1010 "src/pmc/default.c"
#line 1009 "default.c"

INTVAL
Parrot_default_is_equal_string(Interp *interp, PMC* pmc, PMC* value)
{
    cant_do_method(interp, pmc, "is_equal_string");
    return (INTVAL)0;
}

#line 1018 "default.c"

INTVAL
Parrot_default_cmp(Interp *interp, PMC* pmc, PMC* value)
{
    cant_do_method(interp, pmc, "cmp");
    return (INTVAL)0;
}

#line 1027 "default.c"

INTVAL
Parrot_default_cmp_num(Interp *interp, PMC* pmc, PMC* value)
{
    cant_do_method(interp, pmc, "cmp_num");
    return (INTVAL)0;
}

#line 1036 "default.c"

INTVAL
Parrot_default_cmp_string(Interp *interp, PMC* pmc, PMC* value)
{
    cant_do_method(interp, pmc, "cmp_string");
    return (INTVAL)0;
}

#line 1045 "default.c"

PMC*
Parrot_default_logical_or(Interp *interp, PMC* pmc, PMC* value, PMC* dest)
{
    cant_do_method(interp, pmc, "logical_or");
    return PMCNULL;
}

#line 1054 "default.c"

PMC*
Parrot_default_logical_and(Interp *interp, PMC* pmc, PMC* value, PMC* dest)
{
    cant_do_method(interp, pmc, "logical_and");
    return PMCNULL;
}

#line 1063 "default.c"

PMC*
Parrot_default_logical_xor(Interp *interp, PMC* pmc, PMC* value, PMC* dest)
{
    cant_do_method(interp, pmc, "logical_xor");
    return PMCNULL;
}

#line 1072 "default.c"

PMC*
Parrot_default_concatenate(Interp *interp, PMC* pmc, PMC* value, PMC* dest)
{
    cant_do_method(interp, pmc, "concatenate");
    return PMCNULL;
}

#line 1081 "default.c"

PMC*
Parrot_default_concatenate_str(Interp *interp, PMC* pmc, STRING* value, PMC* dest)
{
    cant_do_method(interp, pmc, "concatenate_str");
    return PMCNULL;
}

#line 1090 "default.c"

void
Parrot_default_i_concatenate(Interp *interp, PMC* pmc, PMC* value)
{
    cant_do_method(interp, pmc, "i_concatenate");
}

#line 1098 "default.c"

void
Parrot_default_i_concatenate_str(Interp *interp, PMC* pmc, STRING* value)
{
    cant_do_method(interp, pmc, "i_concatenate_str");
}

#line 1106 "default.c"

PMC*
Parrot_default_repeat(Interp *interp, PMC* pmc, PMC* value, PMC* dest)
{
    cant_do_method(interp, pmc, "repeat");
    return PMCNULL;
}

#line 1115 "default.c"

PMC*
Parrot_default_repeat_int(Interp *interp, PMC* pmc, INTVAL value, PMC* dest)
{
    cant_do_method(interp, pmc, "repeat_int");
    return PMCNULL;
}

#line 1124 "default.c"

void
Parrot_default_i_repeat(Interp *interp, PMC* pmc, PMC* value)
{
    cant_do_method(interp, pmc, "i_repeat");
}

#line 1132 "default.c"

void
Parrot_default_i_repeat_int(Interp *interp, PMC* pmc, INTVAL value)
{
    cant_do_method(interp, pmc, "i_repeat_int");
}

#line 1140 "default.c"

PMC*
Parrot_default_absolute(Interp *interp, PMC* pmc, PMC* dest)
{
    cant_do_method(interp, pmc, "absolute");
    return PMCNULL;
}

#line 1149 "default.c"

void
Parrot_default_add_attribute(Interp *interp, PMC* pmc, STRING* name, PMC* type)
{
    cant_do_method(interp, pmc, "add_attribute");
}

void
Parrot_default_add_method(Interp *interp, PMC* pmc, STRING *method_name, PMC *sub_pmc)
#line 494 "./src/pmc/default.pmc"
{
    VTABLE_set_pmc_keyed_str(interp,
                             pmc->vtable->_namespace,
                             method_name, sub_pmc);

}
#line 1168 "src/pmc/default.c"
void
Parrot_default_add_parent(Interp *interp, PMC* pmc, PMC *parent)
#line 1000 "./src/pmc/default.pmc"
{
    Parrot_add_parent(interp, pmc, parent);

}
#line 1176 "src/pmc/default.c"
#line 1175 "default.c"

void
Parrot_default_add_role(Interp *interp, PMC* pmc, PMC* role)
{
    cant_do_method(interp, pmc, "add_role");
}

void
Parrot_default_assign_pmc(Interp *interp, PMC* pmc, PMC* value)
#line 637 "./src/pmc/default.pmc"
{
    STRING *undef = string_from_const_cstring(interp, "Undef", 5);

    if (VTABLE_isa(interp, value, undef))
        pmc_reuse(interp, pmc, value->vtable->base_type, 0);
    else
         VTABLE_set_pmc(interp, pmc, value);

}
#line 1197 "src/pmc/default.c"
void
Parrot_default_assign_string_native(Interp *interp, PMC* pmc, STRING* value)
#line 646 "./src/pmc/default.pmc"
{
     VTABLE_set_string_native(interp, pmc, value);

}
#line 1205 "src/pmc/default.c"
#line 1204 "default.c"

PMC*
Parrot_default_bitwise_not(Interp *interp, PMC* pmc, PMC* dest)
{
    cant_do_method(interp, pmc, "bitwise_not");
    return PMCNULL;
}

#line 1213 "default.c"

PMC*
Parrot_default_bitwise_nots(Interp *interp, PMC* pmc, PMC* dest)
{
    cant_do_method(interp, pmc, "bitwise_nots");
    return PMCNULL;
}

INTVAL
Parrot_default_can(Interp *interp, PMC* pmc, STRING *method)
#line 881 "./src/pmc/default.pmc"
{
    return !PMC_IS_NULL(VTABLE_find_method(interp, pmc, method));

}
#line 1231 "src/pmc/default.c"
#line 1230 "default.c"

INTVAL
Parrot_default_class_type(Interp *interp, PMC* pmc)
{
    cant_do_method(interp, pmc, "class_type");
    return (INTVAL)0;
}

#line 1239 "default.c"

PMC*
Parrot_default_clone(Interp *interp, PMC* pmc)
{
    cant_do_method(interp, pmc, "clone");
    return PMCNULL;
}

#line 1248 "default.c"

PMC*
Parrot_default_clone_pmc(Interp *interp, PMC* pmc, PMC* args)
{
    cant_do_method(interp, pmc, "clone_pmc");
    return PMCNULL;
}

#line 1257 "default.c"

void
Parrot_default_decrement(Interp *interp, PMC* pmc)
{
    cant_do_method(interp, pmc, "decrement");
}

INTVAL
Parrot_default_defined(Interp *interp, PMC* pmc)
#line 819 "./src/pmc/default.pmc"
{
    return 1;

}
#line 1274 "src/pmc/default.c"
#line 1273 "default.c"

INTVAL
Parrot_default_defined_keyed(Interp *interp, PMC* pmc, PMC* key)
{
    cant_do_method(interp, pmc, "defined_keyed");
    return (INTVAL)0;
}

INTVAL
Parrot_default_defined_keyed_int(Interp *interp, PMC* pmc, INTVAL key)
#line 835 "./src/pmc/default.pmc"
{
    PMC* r_key = INT2KEY(interp, key);
    return  VTABLE_defined_keyed(interp, pmc, r_key);

}
#line 1292 "src/pmc/default.c"
#line 1291 "default.c"

INTVAL
Parrot_default_defined_keyed_str(Interp *interp, PMC* pmc, STRING* key)
{
    cant_do_method(interp, pmc, "defined_keyed_str");
    return (INTVAL)0;
}

#line 1300 "default.c"

void
Parrot_default_delete_keyed(Interp *interp, PMC* pmc, PMC* key)
{
    cant_do_method(interp, pmc, "delete_keyed");
}

void
Parrot_default_delete_keyed_int(Interp *interp, PMC* pmc, INTVAL key)
#line 850 "./src/pmc/default.pmc"
{
    PMC* r_key = INT2KEY(interp, key);
     VTABLE_delete_keyed(interp, pmc, r_key);

}
#line 1318 "src/pmc/default.c"
#line 1317 "default.c"

void
Parrot_default_delete_keyed_str(Interp *interp, PMC* pmc, STRING* key)
{
    cant_do_method(interp, pmc, "delete_keyed_str");
}

void
Parrot_default_delprop(Interp *interp, PMC* pmc, STRING* key)
#line 392 "./src/pmc/default.pmc"
{
    if (pmc->pmc_ext && PMC_metadata(pmc)) {
        VTABLE_delete_keyed_str(interp, PMC_metadata(pmc), key);
    }
    return;

}
#line 1337 "src/pmc/default.c"
#line 1336 "default.c"

void
Parrot_default_destroy(Interp *interp, PMC* pmc)
{
    cant_do_method(interp, pmc, "destroy");
}

INTVAL
Parrot_default_does(Interp *interp, PMC* pmc, STRING* interface)
#line 895 "./src/pmc/default.pmc"
{
    return does_isa(interp, interface, pmc->vtable->does_str);

}
#line 1353 "src/pmc/default.c"
#line 1352 "default.c"

INTVAL
Parrot_default_elements(Interp *interp, PMC* pmc)
{
    cant_do_method(interp, pmc, "elements");
    return (INTVAL)0;
}

#line 1361 "default.c"

INTVAL
Parrot_default_exists_keyed(Interp *interp, PMC* pmc, PMC* key)
{
    cant_do_method(interp, pmc, "exists_keyed");
    return (INTVAL)0;
}

INTVAL
Parrot_default_exists_keyed_int(Interp *interp, PMC* pmc, INTVAL key)
#line 804 "./src/pmc/default.pmc"
{
    PMC* r_key = INT2KEY(interp, key);
    return  VTABLE_exists_keyed(interp, pmc, r_key);

}
#line 1380 "src/pmc/default.c"
#line 1379 "default.c"

INTVAL
Parrot_default_exists_keyed_str(Interp *interp, PMC* pmc, STRING* key)
{
    cant_do_method(interp, pmc, "exists_keyed_str");
    return (INTVAL)0;
}

PMC*
Parrot_default_find_method(Interp *interp, PMC* pmc, STRING *method_name)
#line 490 "./src/pmc/default.pmc"
{
    return Parrot_find_method_with_cache(interp, pmc, method_name);

}
#line 1397 "src/pmc/default.c"
void
Parrot_default_freeze(Interp *interp, PMC* pmc, visit_info *info)
#line 1037 "./src/pmc/default.pmc"
{
    /* default - no action */

}
#line 1405 "src/pmc/default.c"
#line 1404 "default.c"

PMC*
Parrot_default_get_attr(Interp *interp, PMC* pmc, INTVAL idx)
{
    cant_do_method(interp, pmc, "get_attr");
    return PMCNULL;
}

PMC*
Parrot_default_get_attr_str(Interp *interp, PMC* pmc, STRING *name)
#line 945 "./src/pmc/default.pmc"
{
    PMC        *p = NULL;
    HashBucket *b;

    /* let's look for props first
     * XXX do we need that in the default object system?
     */
    if (pmc->pmc_ext && PMC_metadata(pmc)) {
         b = parrot_hash_get_bucket(interp, (Hash*) PMC_metadata(pmc),
                                    name);
         if (b)
             p = (PMC *)b->value;
    }

    /* may be NCI? */
    if (PMC_IS_NULL(p))
        p = VTABLE_find_method(interp, pmc, name);

    if (PMC_IS_NULL(p)) {
        /* TODO AttributeError */
    }
    else if (VTABLE_isa(interp, p, CONST_STRING(interp, "NCI"))) {
        PMC *bound_meth;

        bound_meth         = VTABLE_clone(interp, p);
        bound_meth->vtable = interp->vtables[enum_class_Bound_NCI];
        VTABLE_set_pmc(interp, bound_meth, pmc);

        return bound_meth;
    }
    else if (p->vtable->base_type == enum_class_MultiSub) {
        PMC *bound_meth;

        bound_meth                  = pmc_new(interp, enum_class_Bound_NCI);
        VTABLE_set_pmc(interp, bound_meth, pmc);
        PMC_struct_val(bound_meth)  = p;
        PObj_get_FLAGS(bound_meth) |= PObj_private0_FLAG;

        return bound_meth;
    }

    /* TODO bound user functions */
    return p;

}
#line 1463 "src/pmc/default.c"
#line 1462 "default.c"

PMC*
Parrot_default_get_bignum(Interp *interp, PMC* pmc)
{
    cant_do_method(interp, pmc, "get_bignum");
    return PMCNULL;
}

#line 1471 "default.c"

INTVAL
Parrot_default_get_bool(Interp *interp, PMC* pmc)
{
    cant_do_method(interp, pmc, "get_bool");
    return (INTVAL)0;
}

PMC*
Parrot_default_get_class(Interp *interp, PMC* pmc)
#line 941 "./src/pmc/default.pmc"
{
    return pmc;

}
#line 1489 "src/pmc/default.c"
#line 1488 "default.c"

INTVAL
Parrot_default_get_integer(Interp *interp, PMC* pmc)
{
    cant_do_method(interp, pmc, "get_integer");
    return (INTVAL)0;
}

#line 1497 "default.c"

INTVAL
Parrot_default_get_integer_keyed(Interp *interp, PMC* pmc, PMC* key)
{
    cant_do_method(interp, pmc, "get_integer_keyed");
    return (INTVAL)0;
}

INTVAL
Parrot_default_get_integer_keyed_int(Interp *interp, PMC* pmc, INTVAL key)
#line 510 "./src/pmc/default.pmc"
{
    PMC* r_key = INT2KEY(interp, key);
    return  VTABLE_get_integer_keyed(interp, pmc, r_key);

}
#line 1516 "src/pmc/default.c"
#line 1515 "default.c"

INTVAL
Parrot_default_get_integer_keyed_str(Interp *interp, PMC* pmc, STRING* key)
{
    cant_do_method(interp, pmc, "get_integer_keyed_str");
    return (INTVAL)0;
}

#line 1524 "default.c"

PMC*
Parrot_default_get_iter(Interp *interp, PMC* pmc)
{
    cant_do_method(interp, pmc, "get_iter");
    return PMCNULL;
}

#line 1533 "default.c"

FLOATVAL
Parrot_default_get_number(Interp *interp, PMC* pmc)
{
    cant_do_method(interp, pmc, "get_number");
    return (FLOATVAL)0;
}

#line 1542 "default.c"

FLOATVAL
Parrot_default_get_number_keyed(Interp *interp, PMC* pmc, PMC* key)
{
    cant_do_method(interp, pmc, "get_number_keyed");
    return (FLOATVAL)0;
}

FLOATVAL
Parrot_default_get_number_keyed_int(Interp *interp, PMC* pmc, INTVAL key)
#line 526 "./src/pmc/default.pmc"
{
    PMC* r_key = INT2KEY(interp, key);
    return  VTABLE_get_number_keyed(interp, pmc, r_key);

}
#line 1561 "src/pmc/default.c"
#line 1560 "default.c"

FLOATVAL
Parrot_default_get_number_keyed_str(Interp *interp, PMC* pmc, STRING* key)
{
    cant_do_method(interp, pmc, "get_number_keyed_str");
    return (FLOATVAL)0;
}

#line 1569 "default.c"

PMC*
Parrot_default_get_pmc(Interp *interp, PMC* pmc)
{
    cant_do_method(interp, pmc, "get_pmc");
    return PMCNULL;
}

#line 1578 "default.c"

PMC*
Parrot_default_get_pmc_keyed(Interp *interp, PMC* pmc, PMC* key)
{
    cant_do_method(interp, pmc, "get_pmc_keyed");
    return PMCNULL;
}

PMC*
Parrot_default_get_pmc_keyed_int(Interp *interp, PMC* pmc, INTVAL key)
#line 592 "./src/pmc/default.pmc"
{
    PMC* r_key = INT2KEY(interp, key);
    return  VTABLE_get_pmc_keyed(interp, pmc, r_key);

}
#line 1597 "src/pmc/default.c"
#line 1596 "default.c"

PMC*
Parrot_default_get_pmc_keyed_str(Interp *interp, PMC* pmc, STRING* key)
{
    cant_do_method(interp, pmc, "get_pmc_keyed_str");
    return PMCNULL;
}

void*
Parrot_default_get_pointer(Interp *interp, PMC* pmc)
#line 607 "./src/pmc/default.pmc"
{
    return pmc;

}
#line 1614 "src/pmc/default.c"
#line 1613 "default.c"

void*
Parrot_default_get_pointer_keyed(Interp *interp, PMC* pmc, PMC* key)
{
    cant_do_method(interp, pmc, "get_pointer_keyed");
    return (void*)0;
}

#line 1622 "default.c"

void*
Parrot_default_get_pointer_keyed_int(Interp *interp, PMC* pmc, INTVAL key)
{
    cant_do_method(interp, pmc, "get_pointer_keyed_int");
    return (void*)0;
}

#line 1631 "default.c"

void*
Parrot_default_get_pointer_keyed_str(Interp *interp, PMC* pmc, STRING* key)
{
    cant_do_method(interp, pmc, "get_pointer_keyed_str");
    return (void*)0;
}

#line 1640 "default.c"

STRING*
Parrot_default_get_repr(Interp *interp, PMC* pmc)
{
    cant_do_method(interp, pmc, "get_repr");
    return (STRING*)0;
}

#line 1649 "default.c"

STRING*
Parrot_default_get_string(Interp *interp, PMC* pmc)
{
    cant_do_method(interp, pmc, "get_string");
    return (STRING*)0;
}

#line 1658 "default.c"

STRING*
Parrot_default_get_string_keyed(Interp *interp, PMC* pmc, PMC* key)
{
    cant_do_method(interp, pmc, "get_string_keyed");
    return (STRING*)0;
}

STRING*
Parrot_default_get_string_keyed_int(Interp *interp, PMC* pmc, INTVAL key)
#line 543 "./src/pmc/default.pmc"
{
    PMC* r_key = INT2KEY(interp, key);
    return  VTABLE_get_string_keyed(interp, pmc, r_key);

}
#line 1677 "src/pmc/default.c"
#line 1676 "default.c"

STRING*
Parrot_default_get_string_keyed_str(Interp *interp, PMC* pmc, STRING* key)
{
    cant_do_method(interp, pmc, "get_string_keyed_str");
    return (STRING*)0;
}

PMC*
Parrot_default_getprop(Interp *interp, PMC* pmc, STRING* key)
#line 342 "./src/pmc/default.pmc"
{
    if (pmc->pmc_ext && PMC_metadata(pmc)) {
      return VTABLE_get_pmc_keyed_str(interp, PMC_metadata(pmc), key);
    }
    else {
      return check_get_std_props(interp, pmc, key);
    }

}
#line 1699 "src/pmc/default.c"
PMC*
Parrot_default_getprops(Interp *interp, PMC* pmc)
#line 409 "./src/pmc/default.pmc"
{
    if (!pmc->pmc_ext)
        add_pmc_ext(interp, pmc);
    if (!PMC_metadata(pmc)) {
        if (has_pending_std_props(interp, pmc))
            return make_prop_hash(interp, pmc);
        else
            return PMCNULL;
    }
    return PMC_metadata(pmc);

}
#line 1715 "src/pmc/default.c"
#line 1714 "default.c"

INTVAL
Parrot_default_hash(Interp *interp, PMC* pmc, size_t seed)
{
    cant_do_method(interp, pmc, "hash");
    return (INTVAL)0;
}

#line 1723 "default.c"

void
Parrot_default_i_absolute(Interp *interp, PMC* pmc)
{
    cant_do_method(interp, pmc, "i_absolute");
}

#line 1731 "default.c"

void
Parrot_default_i_bitwise_not(Interp *interp, PMC* pmc)
{
    cant_do_method(interp, pmc, "i_bitwise_not");
}

#line 1739 "default.c"

void
Parrot_default_i_bitwise_nots(Interp *interp, PMC* pmc)
{
    cant_do_method(interp, pmc, "i_bitwise_nots");
}

#line 1747 "default.c"

void
Parrot_default_i_logical_not(Interp *interp, PMC* pmc)
{
    cant_do_method(interp, pmc, "i_logical_not");
}

#line 1755 "default.c"

void
Parrot_default_i_neg(Interp *interp, PMC* pmc)
{
    cant_do_method(interp, pmc, "i_neg");
}

#line 1763 "default.c"

void
Parrot_default_increment(Interp *interp, PMC* pmc)
{
    cant_do_method(interp, pmc, "increment");
}

void
Parrot_default_init(Interp *interp, PMC* pmc)
#line 277 "./src/pmc/default.pmc"
{

}
#line 1779 "src/pmc/default.c"
void
Parrot_default_init_pmc(Interp *interp, PMC* pmc, PMC* initializer)
#line 290 "./src/pmc/default.pmc"
{
    if (PMC_IS_NULL(initializer))
         VTABLE_init(interp, pmc);
    else
        real_exception(interp, NULL, ILL_INHERIT,
                   "init_pmc() not implemented in class '%s'",
                   caller(interp, pmc));

}
#line 1792 "src/pmc/default.c"
#line 1791 "default.c"

PMC*
Parrot_default_inspect(Interp *interp, PMC* pmc)
{
    cant_do_method(interp, pmc, "inspect");
    return PMCNULL;
}

#line 1800 "default.c"

PMC*
Parrot_default_inspect_str(Interp *interp, PMC* pmc, STRING* what)
{
    cant_do_method(interp, pmc, "inspect_str");
    return PMCNULL;
}

PMC*
Parrot_default_instantiate(Interp *interp, PMC* pmc, PMC* sig)
#line 310 "./src/pmc/default.pmc"
{
    INTVAL type = pmc->vtable->base_type;
    PMC* ret = pmc_new_noinit(interp, type);
    VTABLE_init(interp, ret);
    return ret;

}
#line 1821 "src/pmc/default.c"
#line 1820 "default.c"

opcode_t*
Parrot_default_invoke(Interp *interp, PMC* pmc, void* next)
{
    cant_do_method(interp, pmc, "invoke");
    return (opcode_t*)0;
}

INTVAL
Parrot_default_is_same(Interp *interp, PMC* pmc, PMC* value)
#line 621 "./src/pmc/default.pmc"
{
    return pmc == value;

}
#line 1838 "src/pmc/default.c"
INTVAL
Parrot_default_isa(Interp *interp, PMC* pmc, STRING* _class)
#line 909 "./src/pmc/default.pmc"
{
    /* TODO FIXME - walk mro */
    return does_isa(interp, _class, pmc->vtable->isa_str);

}
#line 1847 "src/pmc/default.c"
#line 1846 "default.c"

PMC*
Parrot_default_logical_not(Interp *interp, PMC* pmc, PMC* dest)
{
    cant_do_method(interp, pmc, "logical_not");
    return PMCNULL;
}

void
Parrot_default_mark(Interp *interp, PMC* pmc)
#line 327 "./src/pmc/default.pmc"
{
    PANIC("custom_mark flag set but no custom mark routine defined");

}
#line 1864 "src/pmc/default.c"
void
Parrot_default_morph(Interp *interp, PMC* pmc, INTVAL type)
#line 660 "./src/pmc/default.pmc"
{
    pmc_reuse(interp, pmc, type, 0);

}
#line 1872 "src/pmc/default.c"
STRING*
Parrot_default_name(Interp *interp, PMC* pmc)
#line 461 "./src/pmc/default.pmc"
{
    return pmc->vtable->whoami;

}
#line 1880 "src/pmc/default.c"
#line 1879 "default.c"

PMC*
Parrot_default_neg(Interp *interp, PMC* pmc, PMC* dest)
{
    cant_do_method(interp, pmc, "neg");
    return PMCNULL;
}

#line 1888 "default.c"

PMC*
Parrot_default_new_from_string(Interp *interp, PMC* pmc, STRING* rep, INTVAL flags)
{
    cant_do_method(interp, pmc, "new_from_string");
    return PMCNULL;
}

#line 1897 "default.c"

PMC*
Parrot_default_nextkey_keyed(Interp *interp, PMC* pmc, PMC* key, INTVAL what)
{
    cant_do_method(interp, pmc, "nextkey_keyed");
    return PMCNULL;
}

PMC*
Parrot_default_nextkey_keyed_int(Interp *interp, PMC* pmc, INTVAL key, INTVAL w)
#line 866 "./src/pmc/default.pmc"
{
    PMC* r_key = INT2KEY(interp, key);
    return  VTABLE_nextkey_keyed(interp, pmc, r_key, w);

}
#line 1916 "src/pmc/default.c"
#line 1915 "default.c"

PMC*
Parrot_default_nextkey_keyed_str(Interp *interp, PMC* pmc, STRING* key, INTVAL what)
{
    cant_do_method(interp, pmc, "nextkey_keyed_str");
    return PMCNULL;
}

PMC*
Parrot_default_pmc_namespace(Interp *interp, PMC* pmc)
#line 485 "./src/pmc/default.pmc"
{
    return pmc->vtable->_namespace;

}
#line 1933 "src/pmc/default.c"
#line 1932 "default.c"

FLOATVAL
Parrot_default_pop_float(Interp *interp, PMC* pmc)
{
    cant_do_method(interp, pmc, "pop_float");
    return (FLOATVAL)0;
}

#line 1941 "default.c"

INTVAL
Parrot_default_pop_integer(Interp *interp, PMC* pmc)
{
    cant_do_method(interp, pmc, "pop_integer");
    return (INTVAL)0;
}

#line 1950 "default.c"

PMC*
Parrot_default_pop_pmc(Interp *interp, PMC* pmc)
{
    cant_do_method(interp, pmc, "pop_pmc");
    return PMCNULL;
}

#line 1959 "default.c"

STRING*
Parrot_default_pop_string(Interp *interp, PMC* pmc)
{
    cant_do_method(interp, pmc, "pop_string");
    return (STRING*)0;
}

#line 1968 "default.c"

void
Parrot_default_push_float(Interp *interp, PMC* pmc, FLOATVAL value)
{
    cant_do_method(interp, pmc, "push_float");
}

#line 1976 "default.c"

void
Parrot_default_push_integer(Interp *interp, PMC* pmc, INTVAL value)
{
    cant_do_method(interp, pmc, "push_integer");
}

#line 1984 "default.c"

void
Parrot_default_push_pmc(Interp *interp, PMC* pmc, PMC* value)
{
    cant_do_method(interp, pmc, "push_pmc");
}

#line 1992 "default.c"

void
Parrot_default_push_string(Interp *interp, PMC* pmc, STRING* value)
{
    cant_do_method(interp, pmc, "push_string");
}

#line 2000 "default.c"

void
Parrot_default_remove_attribute(Interp *interp, PMC* pmc, STRING* name)
{
    cant_do_method(interp, pmc, "remove_attribute");
}

#line 2008 "default.c"

void
Parrot_default_remove_method(Interp *interp, PMC* pmc, STRING* method_name)
{
    cant_do_method(interp, pmc, "remove_method");
}

#line 2016 "default.c"

void
Parrot_default_remove_parent(Interp *interp, PMC* pmc, PMC* parent)
{
    cant_do_method(interp, pmc, "remove_parent");
}

#line 2024 "default.c"

void
Parrot_default_remove_role(Interp *interp, PMC* pmc, PMC* role)
{
    cant_do_method(interp, pmc, "remove_role");
}

#line 2032 "default.c"

void
Parrot_default_set_attr(Interp *interp, PMC* pmc, INTVAL idx, PMC* value)
{
    cant_do_method(interp, pmc, "set_attr");
}

#line 2040 "default.c"

void
Parrot_default_set_attr_str(Interp *interp, PMC* pmc, STRING* idx, PMC* value)
{
    cant_do_method(interp, pmc, "set_attr_str");
}

#line 2048 "default.c"

void
Parrot_default_set_bignum_int(Interp *interp, PMC* pmc, INTVAL value)
{
    cant_do_method(interp, pmc, "set_bignum_int");
}

#line 2056 "default.c"

void
Parrot_default_set_bignum_num(Interp *interp, PMC* pmc, FLOATVAL value)
{
    cant_do_method(interp, pmc, "set_bignum_num");
}

#line 2064 "default.c"

void
Parrot_default_set_bignum_str(Interp *interp, PMC* pmc, STRING* value)
{
    cant_do_method(interp, pmc, "set_bignum_str");
}

#line 2072 "default.c"

void
Parrot_default_set_bool(Interp *interp, PMC* pmc, INTVAL value)
{
    cant_do_method(interp, pmc, "set_bool");
}

#line 2080 "default.c"

void
Parrot_default_set_integer_keyed(Interp *interp, PMC* pmc, PMC* key, INTVAL value)
{
    cant_do_method(interp, pmc, "set_integer_keyed");
}

void
Parrot_default_set_integer_keyed_int(Interp *interp, PMC* pmc, INTVAL key, INTVAL value)
#line 675 "./src/pmc/default.pmc"
{
    PMC* r_key = INT2KEY(interp, key);
     VTABLE_set_integer_keyed(interp, pmc, r_key, value);

}
#line 2098 "src/pmc/default.c"
#line 2097 "default.c"

void
Parrot_default_set_integer_keyed_str(Interp *interp, PMC* pmc, STRING* key, INTVAL value)
{
    cant_do_method(interp, pmc, "set_integer_keyed_str");
}

#line 2105 "default.c"

void
Parrot_default_set_integer_native(Interp *interp, PMC* pmc, INTVAL value)
{
    cant_do_method(interp, pmc, "set_integer_native");
}

#line 2113 "default.c"

void
Parrot_default_set_integer_same(Interp *interp, PMC* pmc, PMC* value)
{
    cant_do_method(interp, pmc, "set_integer_same");
}

#line 2121 "default.c"

void
Parrot_default_set_number_keyed(Interp *interp, PMC* pmc, PMC* key, FLOATVAL value)
{
    cant_do_method(interp, pmc, "set_number_keyed");
}

void
Parrot_default_set_number_keyed_int(Interp *interp, PMC* pmc, INTVAL key, FLOATVAL value)
#line 691 "./src/pmc/default.pmc"
{
    PMC* r_key = INT2KEY(interp, key);
     VTABLE_set_number_keyed(interp, pmc, r_key, value);

}
#line 2139 "src/pmc/default.c"
#line 2138 "default.c"

void
Parrot_default_set_number_keyed_str(Interp *interp, PMC* pmc, STRING* key, FLOATVAL value)
{
    cant_do_method(interp, pmc, "set_number_keyed_str");
}

#line 2146 "default.c"

void
Parrot_default_set_number_native(Interp *interp, PMC* pmc, FLOATVAL value)
{
    cant_do_method(interp, pmc, "set_number_native");
}

#line 2154 "default.c"

void
Parrot_default_set_number_same(Interp *interp, PMC* pmc, PMC* value)
{
    cant_do_method(interp, pmc, "set_number_same");
}

#line 2162 "default.c"

void
Parrot_default_set_pmc(Interp *interp, PMC* pmc, PMC* value)
{
    cant_do_method(interp, pmc, "set_pmc");
}

#line 2170 "default.c"

void
Parrot_default_set_pmc_keyed(Interp *interp, PMC* pmc, PMC* key, PMC* value)
{
    cant_do_method(interp, pmc, "set_pmc_keyed");
}

void
Parrot_default_set_pmc_keyed_int(Interp *interp, PMC* pmc, INTVAL key, PMC* value)
#line 740 "./src/pmc/default.pmc"
{
    PMC* r_key = INT2KEY(interp, key);
     VTABLE_set_pmc_keyed(interp, pmc, r_key, value);

}
#line 2188 "src/pmc/default.c"
#line 2187 "default.c"

void
Parrot_default_set_pmc_keyed_str(Interp *interp, PMC* pmc, STRING* key, PMC* value)
{
    cant_do_method(interp, pmc, "set_pmc_keyed_str");
}

#line 2195 "default.c"

void
Parrot_default_set_pointer(Interp *interp, PMC* pmc, void* value)
{
    cant_do_method(interp, pmc, "set_pointer");
}

#line 2203 "default.c"

void
Parrot_default_set_pointer_keyed(Interp *interp, PMC* pmc, PMC* key, void* value)
{
    cant_do_method(interp, pmc, "set_pointer_keyed");
}

#line 2211 "default.c"

void
Parrot_default_set_pointer_keyed_int(Interp *interp, PMC* pmc, INTVAL key, void* value)
{
    cant_do_method(interp, pmc, "set_pointer_keyed_int");
}

#line 2219 "default.c"

void
Parrot_default_set_pointer_keyed_str(Interp *interp, PMC* pmc, STRING* key, void* value)
{
    cant_do_method(interp, pmc, "set_pointer_keyed_str");
}

#line 2227 "default.c"

void
Parrot_default_set_string_keyed(Interp *interp, PMC* pmc, PMC* key, STRING* value)
{
    cant_do_method(interp, pmc, "set_string_keyed");
}

void
Parrot_default_set_string_keyed_int(Interp *interp, PMC* pmc, INTVAL key, STRING* string)
#line 708 "./src/pmc/default.pmc"
{
    PMC* r_key = INT2KEY(interp, key);
     VTABLE_set_string_keyed(interp, pmc, r_key, string);

}
#line 2245 "src/pmc/default.c"
#line 2244 "default.c"

void
Parrot_default_set_string_keyed_str(Interp *interp, PMC* pmc, STRING* key, STRING* value)
{
    cant_do_method(interp, pmc, "set_string_keyed_str");
}

#line 2252 "default.c"

void
Parrot_default_set_string_native(Interp *interp, PMC* pmc, STRING* value)
{
    cant_do_method(interp, pmc, "set_string_native");
}

#line 2260 "default.c"

void
Parrot_default_set_string_same(Interp *interp, PMC* pmc, PMC* value)
{
    cant_do_method(interp, pmc, "set_string_same");
}

void
Parrot_default_setprop(Interp *interp, PMC* pmc, STRING* key, PMC* value)
#line 361 "./src/pmc/default.pmc"
{
    if (check_set_std_props(interp, pmc, key, value)) {
        return;
    }
    if (pmc->pmc_ext && PMC_metadata(pmc)) {
        VTABLE_set_pmc_keyed_str(interp,
            PMC_metadata(pmc), key, value);
    }
    else {
        PMC *prop;

        prop = make_prop_hash(interp, pmc);
        /* XXX is this too late for --gc-debug? */
        VTABLE_set_pmc_keyed_str(interp, prop, key, value);
#if 0
PObj_report_SET(PMC_metadata(pmc));
#endif
    }
    return;

}
#line 2294 "src/pmc/default.c"
#line 2293 "default.c"

void
Parrot_default_share(Interp *interp, PMC* pmc)
{
    cant_do_method(interp, pmc, "share");
}

#line 2301 "default.c"

PMC*
Parrot_default_share_ro(Interp *interp, PMC* pmc)
{
    cant_do_method(interp, pmc, "share_ro");
    return PMCNULL;
}

#line 2310 "default.c"

FLOATVAL
Parrot_default_shift_float(Interp *interp, PMC* pmc)
{
    cant_do_method(interp, pmc, "shift_float");
    return (FLOATVAL)0;
}

#line 2319 "default.c"

INTVAL
Parrot_default_shift_integer(Interp *interp, PMC* pmc)
{
    cant_do_method(interp, pmc, "shift_integer");
    return (INTVAL)0;
}

#line 2328 "default.c"

PMC*
Parrot_default_shift_pmc(Interp *interp, PMC* pmc)
{
    cant_do_method(interp, pmc, "shift_pmc");
    return PMCNULL;
}

#line 2337 "default.c"

STRING*
Parrot_default_shift_string(Interp *interp, PMC* pmc)
{
    cant_do_method(interp, pmc, "shift_string");
    return (STRING*)0;
}

#line 2346 "default.c"

PMC*
Parrot_default_slice(Interp *interp, PMC* pmc, PMC* key, INTVAL flag)
{
    cant_do_method(interp, pmc, "slice");
    return PMCNULL;
}

#line 2355 "default.c"

void
Parrot_default_splice(Interp *interp, PMC* pmc, PMC* value, INTVAL offset, INTVAL count)
{
    cant_do_method(interp, pmc, "splice");
}

PMC*
Parrot_default_subclass(Interp *interp, PMC* pmc, PMC *name)
#line 924 "./src/pmc/default.pmc"
{
    return Parrot_single_subclass(interp, pmc, name);

}
#line 2372 "src/pmc/default.c"
#line 2371 "default.c"

void
Parrot_default_substr(Interp *interp, PMC* pmc, INTVAL offset, INTVAL length, PMC* dest)
{
    cant_do_method(interp, pmc, "substr");
}

#line 2379 "default.c"

STRING*
Parrot_default_substr_str(Interp *interp, PMC* pmc, INTVAL offset, INTVAL length)
{
    cant_do_method(interp, pmc, "substr_str");
    return (STRING*)0;
}

#line 2388 "default.c"

UINTVAL
Parrot_default_subtype(Interp *interp, PMC* pmc, INTVAL type)
{
    cant_do_method(interp, pmc, "subtype");
    return (UINTVAL)0;
}

void
Parrot_default_thaw(Interp *interp, PMC* pmc, visit_info *info)
#line 1051 "./src/pmc/default.pmc"
{
    /* default - initialize the PMC */
    if (info->extra_flags == EXTRA_IS_PROP_HASH) {
        if (!pmc->pmc_ext)
            add_pmc_ext(interp, pmc);
        info->thaw_ptr = &PMC_metadata(pmc);
        info->container = pmc;
        (info->visit_pmc_now)(interp, PMC_metadata(pmc), info);
    }
    else
         VTABLE_init(interp, pmc);

}
#line 2415 "src/pmc/default.c"
void
Parrot_default_thawfinish(Interp *interp, PMC* pmc, visit_info *info)
#line 1074 "./src/pmc/default.pmc"
{
    /* default - no action */

}
#line 2423 "src/pmc/default.c"
INTVAL
Parrot_default_type(Interp *interp, PMC* pmc)
#line 431 "./src/pmc/default.pmc"
{
    return pmc->vtable->base_type;

}
#line 2431 "src/pmc/default.c"
#line 2430 "default.c"

INTVAL
Parrot_default_type_keyed(Interp *interp, PMC* pmc, PMC* key)
{
    cant_do_method(interp, pmc, "type_keyed");
    return (INTVAL)0;
}

INTVAL
Parrot_default_type_keyed_int(Interp *interp, PMC* pmc, INTVAL key)
#line 446 "./src/pmc/default.pmc"
{
    PMC* r_key = INT2KEY(interp, key);
    return  VTABLE_type_keyed(interp, pmc, r_key);

}
#line 2449 "src/pmc/default.c"
#line 2448 "default.c"

INTVAL
Parrot_default_type_keyed_str(Interp *interp, PMC* pmc, STRING* key)
{
    cant_do_method(interp, pmc, "type_keyed_str");
    return (INTVAL)0;
}

#line 2457 "default.c"

void
Parrot_default_unshift_float(Interp *interp, PMC* pmc, FLOATVAL value)
{
    cant_do_method(interp, pmc, "unshift_float");
}

#line 2465 "default.c"

void
Parrot_default_unshift_integer(Interp *interp, PMC* pmc, INTVAL value)
{
    cant_do_method(interp, pmc, "unshift_integer");
}

#line 2473 "default.c"

void
Parrot_default_unshift_pmc(Interp *interp, PMC* pmc, PMC* value)
{
    cant_do_method(interp, pmc, "unshift_pmc");
}

#line 2481 "default.c"

void
Parrot_default_unshift_string(Interp *interp, PMC* pmc, STRING* value)
{
    cant_do_method(interp, pmc, "unshift_string");
}

void
Parrot_default_visit(Interp *interp, PMC* pmc, visit_info *info)
#line 1014 "./src/pmc/default.pmc"
{
    /* default - mark prop hash */
    if (pmc->pmc_ext && PMC_metadata(pmc) &&
        info->extra_flags != EXTRA_IS_PROP_HASH) {
        info->extra_flags = EXTRA_IS_PROP_HASH;
        info->extra = PMC_metadata(pmc);
        /* place escape mark */
        (info->visit_pmc_now)(interp, pmc, info);
        /* place and the prop hash */
        (info->visit_pmc_now)(interp, PMC_metadata(pmc), info);
    }

}
#line 2507 "src/pmc/default.c"


/*

=back

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
