/*
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/delegate.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

#line 1 "./src/pmc/delegate.pmc"
/*
Copyright (C) 2003-2007, The Perl Foundation.
$Id: delegate.pmc 18306 2007-04-23 16:46:53Z chromatic $

=head1 NAME

src/pmc/delegate.pmc - Delegate PMC

=head1 DESCRIPTION

Delegate each and every function to parrot bytecode.

Almost all methods are auto-generated in lib/Parrot/Pmc2c.pm

=head2 Functions

=over 4

=cut

*/

#include "parrot/parrot.h"
#include "delegate.str"
#include <assert.h>

/*

All these functions to run code can leak a full Parrot register file, as
well as potentially permanently unroot some PMCs or strings, if the
vtable method throws an exception. It really ought be caught rather than
let flow through.

*/

static void
vtable_meth_not_found(Interp *interp, PMC *pmc, const char *meth)
{
    char *_class;

    if (PObj_is_class_TEST(pmc))
        _class = string_to_cstring(interp, PMC_str_val(
            get_attrib_num(
                (SLOTTYPE *)PMC_data(GET_CLASS(PMC_data(pmc), pmc)),
                    PCD_CLASS_NAME)));
    else
        _class = string_to_cstring(interp, pmc->vtable->whoami);

    real_exception(interp, NULL, E_LookupError,
        "Can't find vtable method '%s' in class '%s'", meth, _class);

    string_cstring_free(_class);
}

#line 67 "src/pmc/delegate.c"
#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_delegate.h"
#include "pmc_default.h"
#include "delegate.str"

#line 73 "delegate.c"

PMC*
Parrot_delegate_absolute(Interp *interp, PMC* pmc, PMC* dest)
 {
    STRING *meth = CONST_STRING(interp, "absolute");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "absolute");
    return (PMC*)Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "PP", dest);
}

#line 86 "delegate.c"

void
Parrot_delegate_add_attribute(Interp *interp, PMC* pmc, STRING* name, PMC* type)
 {
    STRING *meth = CONST_STRING(interp, "add_attribute");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "add_attribute");
    Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "vSP", name, type);
}

void
Parrot_delegate_add_method(Interp *interp, PMC* pmc, STRING *method_name, PMC *sub_pmc)
#line 107 "./src/pmc/delegate.pmc"
{
    Parrot_default_add_method(interp, pmc, method_name, sub_pmc);

}
#line 108 "src/pmc/delegate.c"
#line 107 "delegate.c"

void
Parrot_delegate_add_parent(Interp *interp, PMC* pmc, PMC* parent)
 {
    STRING *meth = CONST_STRING(interp, "add_parent");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "add_parent");
    Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "vP", parent);
}

#line 120 "delegate.c"

void
Parrot_delegate_add_role(Interp *interp, PMC* pmc, PMC* role)
 {
    STRING *meth = CONST_STRING(interp, "add_role");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "add_role");
    Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "vP", role);
}

#line 133 "delegate.c"

void
Parrot_delegate_assign_pmc(Interp *interp, PMC* pmc, PMC* value)
 {
    STRING *meth = CONST_STRING(interp, "assign_pmc");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "assign_pmc");
    Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "vP", value);
}

#line 146 "delegate.c"

void
Parrot_delegate_assign_string_native(Interp *interp, PMC* pmc, STRING* value)
 {
    STRING *meth = CONST_STRING(interp, "assign_string_native");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "assign_string_native");
    Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "vS", value);
}

#line 159 "delegate.c"

PMC*
Parrot_delegate_bitwise_not(Interp *interp, PMC* pmc, PMC* dest)
 {
    STRING *meth = CONST_STRING(interp, "bitwise_not");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "bitwise_not");
    return (PMC*)Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "PP", dest);
}

#line 172 "delegate.c"

PMC*
Parrot_delegate_bitwise_nots(Interp *interp, PMC* pmc, PMC* dest)
 {
    STRING *meth = CONST_STRING(interp, "bitwise_nots");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "bitwise_nots");
    return (PMC*)Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "PP", dest);
}

#line 185 "delegate.c"

INTVAL
Parrot_delegate_can(Interp *interp, PMC* pmc, STRING* method)
 {
    STRING *meth = CONST_STRING(interp, "can");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "can");
    return (INTVAL)Parrot_run_meth_fromc_args_reti(interp, sub,
        pmc, meth, "IS", method);
}

#line 198 "delegate.c"

INTVAL
Parrot_delegate_class_type(Interp *interp, PMC* pmc)
 {
    STRING *meth = CONST_STRING(interp, "class_type");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "class_type");
    return (INTVAL)Parrot_run_meth_fromc_args_reti(interp, sub,
        pmc, meth, "I");
}

#line 211 "delegate.c"

PMC*
Parrot_delegate_clone(Interp *interp, PMC* pmc)
 {
    STRING *meth = CONST_STRING(interp, "clone");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "clone");
    return (PMC*)Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "P");
}

#line 224 "delegate.c"

PMC*
Parrot_delegate_clone_pmc(Interp *interp, PMC* pmc, PMC* args)
 {
    STRING *meth = CONST_STRING(interp, "clone_pmc");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "clone_pmc");
    return (PMC*)Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "PP", args);
}

#line 237 "delegate.c"

void
Parrot_delegate_decrement(Interp *interp, PMC* pmc)
 {
    STRING *meth = CONST_STRING(interp, "decrement");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "decrement");
    Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "v");
}

#line 250 "delegate.c"

INTVAL
Parrot_delegate_defined(Interp *interp, PMC* pmc)
 {
    STRING *meth = CONST_STRING(interp, "defined");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "defined");
    return (INTVAL)Parrot_run_meth_fromc_args_reti(interp, sub,
        pmc, meth, "I");
}

#line 263 "delegate.c"

INTVAL
Parrot_delegate_defined_keyed(Interp *interp, PMC* pmc, PMC* key)
 {
    STRING *meth = CONST_STRING(interp, "defined_keyed");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "defined_keyed");
    return (INTVAL)Parrot_run_meth_fromc_args_reti(interp, sub,
        pmc, meth, "IP", key);
}

#line 276 "delegate.c"

INTVAL
Parrot_delegate_defined_keyed_int(Interp *interp, PMC* pmc, INTVAL key)
 {
    STRING *meth = CONST_STRING(interp, "defined_keyed_int");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "defined_keyed_int");
    return (INTVAL)Parrot_run_meth_fromc_args_reti(interp, sub,
        pmc, meth, "II", key);
}

#line 289 "delegate.c"

INTVAL
Parrot_delegate_defined_keyed_str(Interp *interp, PMC* pmc, STRING* key)
 {
    STRING *meth = CONST_STRING(interp, "defined_keyed_str");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "defined_keyed_str");
    return (INTVAL)Parrot_run_meth_fromc_args_reti(interp, sub,
        pmc, meth, "IS", key);
}

#line 302 "delegate.c"

void
Parrot_delegate_delete_keyed(Interp *interp, PMC* pmc, PMC* key)
 {
    STRING *meth = CONST_STRING(interp, "delete_keyed");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "delete_keyed");
    Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "vP", key);
}

#line 315 "delegate.c"

void
Parrot_delegate_delete_keyed_int(Interp *interp, PMC* pmc, INTVAL key)
 {
    STRING *meth = CONST_STRING(interp, "delete_keyed_int");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "delete_keyed_int");
    Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "vI", key);
}

#line 328 "delegate.c"

void
Parrot_delegate_delete_keyed_str(Interp *interp, PMC* pmc, STRING* key)
 {
    STRING *meth = CONST_STRING(interp, "delete_keyed_str");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "delete_keyed_str");
    Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "vS", key);
}

#line 341 "delegate.c"

void
Parrot_delegate_delprop(Interp *interp, PMC* pmc, STRING* key)
 {
    STRING *meth = CONST_STRING(interp, "delprop");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "delprop");
    Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "vS", key);
}

void
Parrot_delegate_destroy(Interp *interp, PMC* pmc)
#line 99 "./src/pmc/delegate.pmc"
{
    /* don't delegate destroy */

}
#line 363 "src/pmc/delegate.c"
#line 362 "delegate.c"

INTVAL
Parrot_delegate_does(Interp *interp, PMC* pmc, STRING* method)
 {
    STRING *meth = CONST_STRING(interp, "does");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "does");
    return (INTVAL)Parrot_run_meth_fromc_args_reti(interp, sub,
        pmc, meth, "IS", method);
}

#line 375 "delegate.c"

INTVAL
Parrot_delegate_elements(Interp *interp, PMC* pmc)
 {
    STRING *meth = CONST_STRING(interp, "elements");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "elements");
    return (INTVAL)Parrot_run_meth_fromc_args_reti(interp, sub,
        pmc, meth, "I");
}

#line 388 "delegate.c"

INTVAL
Parrot_delegate_exists_keyed(Interp *interp, PMC* pmc, PMC* key)
 {
    STRING *meth = CONST_STRING(interp, "exists_keyed");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "exists_keyed");
    return (INTVAL)Parrot_run_meth_fromc_args_reti(interp, sub,
        pmc, meth, "IP", key);
}

#line 401 "delegate.c"

INTVAL
Parrot_delegate_exists_keyed_int(Interp *interp, PMC* pmc, INTVAL key)
 {
    STRING *meth = CONST_STRING(interp, "exists_keyed_int");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "exists_keyed_int");
    return (INTVAL)Parrot_run_meth_fromc_args_reti(interp, sub,
        pmc, meth, "II", key);
}

#line 414 "delegate.c"

INTVAL
Parrot_delegate_exists_keyed_str(Interp *interp, PMC* pmc, STRING* key)
 {
    STRING *meth = CONST_STRING(interp, "exists_keyed_str");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "exists_keyed_str");
    return (INTVAL)Parrot_run_meth_fromc_args_reti(interp, sub,
        pmc, meth, "IS", key);
}

#line 427 "delegate.c"

PMC*
Parrot_delegate_find_method(Interp *interp, PMC* pmc, STRING* method_name)
 {
    STRING *meth = CONST_STRING(interp, "find_method");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "find_method");
    return (PMC*)Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "PS", method_name);
}

#line 440 "delegate.c"

void
Parrot_delegate_freeze(Interp *interp, PMC* pmc, visit_info* info)
 {
    STRING *meth = CONST_STRING(interp, "freeze");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "freeze");
    Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "v?", info);
}

#line 453 "delegate.c"

PMC*
Parrot_delegate_get_attr(Interp *interp, PMC* pmc, INTVAL idx)
 {
    STRING *meth = CONST_STRING(interp, "get_attr");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "get_attr");
    return (PMC*)Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "PI", idx);
}

#line 466 "delegate.c"

PMC*
Parrot_delegate_get_attr_str(Interp *interp, PMC* pmc, STRING* idx)
 {
    STRING *meth = CONST_STRING(interp, "get_attr_str");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "get_attr_str");
    return (PMC*)Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "PS", idx);
}

#line 479 "delegate.c"

PMC*
Parrot_delegate_get_bignum(Interp *interp, PMC* pmc)
 {
    STRING *meth = CONST_STRING(interp, "get_bignum");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "get_bignum");
    return (PMC*)Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "P");
}

#line 492 "delegate.c"

INTVAL
Parrot_delegate_get_bool(Interp *interp, PMC* pmc)
 {
    STRING *meth = CONST_STRING(interp, "get_bool");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "get_bool");
    return (INTVAL)Parrot_run_meth_fromc_args_reti(interp, sub,
        pmc, meth, "I");
}

#line 505 "delegate.c"

PMC*
Parrot_delegate_get_class(Interp *interp, PMC* pmc)
 {
    STRING *meth = CONST_STRING(interp, "get_class");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "get_class");
    return (PMC*)Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "P");
}

#line 518 "delegate.c"

INTVAL
Parrot_delegate_get_integer(Interp *interp, PMC* pmc)
 {
    STRING *meth = CONST_STRING(interp, "get_integer");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "get_integer");
    return (INTVAL)Parrot_run_meth_fromc_args_reti(interp, sub,
        pmc, meth, "I");
}

#line 531 "delegate.c"

INTVAL
Parrot_delegate_get_integer_keyed(Interp *interp, PMC* pmc, PMC* key)
 {
    STRING *meth = CONST_STRING(interp, "get_integer_keyed");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "get_integer_keyed");
    return (INTVAL)Parrot_run_meth_fromc_args_reti(interp, sub,
        pmc, meth, "IP", key);
}

#line 544 "delegate.c"

INTVAL
Parrot_delegate_get_integer_keyed_int(Interp *interp, PMC* pmc, INTVAL key)
 {
    STRING *meth = CONST_STRING(interp, "get_integer_keyed_int");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "get_integer_keyed_int");
    return (INTVAL)Parrot_run_meth_fromc_args_reti(interp, sub,
        pmc, meth, "II", key);
}

#line 557 "delegate.c"

INTVAL
Parrot_delegate_get_integer_keyed_str(Interp *interp, PMC* pmc, STRING* key)
 {
    STRING *meth = CONST_STRING(interp, "get_integer_keyed_str");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "get_integer_keyed_str");
    return (INTVAL)Parrot_run_meth_fromc_args_reti(interp, sub,
        pmc, meth, "IS", key);
}

#line 570 "delegate.c"

PMC*
Parrot_delegate_get_iter(Interp *interp, PMC* pmc)
 {
    STRING *meth = CONST_STRING(interp, "get_iter");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "get_iter");
    return (PMC*)Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "P");
}

#line 583 "delegate.c"

FLOATVAL
Parrot_delegate_get_number(Interp *interp, PMC* pmc)
 {
    STRING *meth = CONST_STRING(interp, "get_number");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "get_number");
    return (FLOATVAL)Parrot_run_meth_fromc_args_retf(interp, sub,
        pmc, meth, "N");
}

#line 596 "delegate.c"

FLOATVAL
Parrot_delegate_get_number_keyed(Interp *interp, PMC* pmc, PMC* key)
 {
    STRING *meth = CONST_STRING(interp, "get_number_keyed");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "get_number_keyed");
    return (FLOATVAL)Parrot_run_meth_fromc_args_retf(interp, sub,
        pmc, meth, "NP", key);
}

#line 609 "delegate.c"

FLOATVAL
Parrot_delegate_get_number_keyed_int(Interp *interp, PMC* pmc, INTVAL key)
 {
    STRING *meth = CONST_STRING(interp, "get_number_keyed_int");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "get_number_keyed_int");
    return (FLOATVAL)Parrot_run_meth_fromc_args_retf(interp, sub,
        pmc, meth, "NI", key);
}

#line 622 "delegate.c"

FLOATVAL
Parrot_delegate_get_number_keyed_str(Interp *interp, PMC* pmc, STRING* key)
 {
    STRING *meth = CONST_STRING(interp, "get_number_keyed_str");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "get_number_keyed_str");
    return (FLOATVAL)Parrot_run_meth_fromc_args_retf(interp, sub,
        pmc, meth, "NS", key);
}

#line 635 "delegate.c"

PMC*
Parrot_delegate_get_pmc(Interp *interp, PMC* pmc)
 {
    STRING *meth = CONST_STRING(interp, "get_pmc");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "get_pmc");
    return (PMC*)Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "P");
}

#line 648 "delegate.c"

PMC*
Parrot_delegate_get_pmc_keyed(Interp *interp, PMC* pmc, PMC* key)
 {
    STRING *meth = CONST_STRING(interp, "get_pmc_keyed");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "get_pmc_keyed");
    return (PMC*)Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "PP", key);
}

#line 661 "delegate.c"

PMC*
Parrot_delegate_get_pmc_keyed_int(Interp *interp, PMC* pmc, INTVAL key)
 {
    STRING *meth = CONST_STRING(interp, "get_pmc_keyed_int");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "get_pmc_keyed_int");
    return (PMC*)Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "PI", key);
}

#line 674 "delegate.c"

PMC*
Parrot_delegate_get_pmc_keyed_str(Interp *interp, PMC* pmc, STRING* key)
 {
    STRING *meth = CONST_STRING(interp, "get_pmc_keyed_str");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "get_pmc_keyed_str");
    return (PMC*)Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "PS", key);
}

#line 687 "delegate.c"

void*
Parrot_delegate_get_pointer(Interp *interp, PMC* pmc)
 {
    STRING *meth = CONST_STRING(interp, "get_pointer");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "get_pointer");
    return (void*)Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "?");
}

#line 700 "delegate.c"

void*
Parrot_delegate_get_pointer_keyed(Interp *interp, PMC* pmc, PMC* key)
 {
    STRING *meth = CONST_STRING(interp, "get_pointer_keyed");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "get_pointer_keyed");
    return (void*)Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "?P", key);
}

#line 713 "delegate.c"

void*
Parrot_delegate_get_pointer_keyed_int(Interp *interp, PMC* pmc, INTVAL key)
 {
    STRING *meth = CONST_STRING(interp, "get_pointer_keyed_int");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "get_pointer_keyed_int");
    return (void*)Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "?I", key);
}

#line 726 "delegate.c"

void*
Parrot_delegate_get_pointer_keyed_str(Interp *interp, PMC* pmc, STRING* key)
 {
    STRING *meth = CONST_STRING(interp, "get_pointer_keyed_str");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "get_pointer_keyed_str");
    return (void*)Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "?S", key);
}

#line 739 "delegate.c"

STRING*
Parrot_delegate_get_repr(Interp *interp, PMC* pmc)
 {
    STRING *meth = CONST_STRING(interp, "get_repr");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "get_repr");
    return (STRING*)Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "S");
}

#line 752 "delegate.c"

STRING*
Parrot_delegate_get_string(Interp *interp, PMC* pmc)
 {
    STRING *meth = CONST_STRING(interp, "get_string");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "get_string");
    return (STRING*)Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "S");
}

#line 765 "delegate.c"

STRING*
Parrot_delegate_get_string_keyed(Interp *interp, PMC* pmc, PMC* key)
 {
    STRING *meth = CONST_STRING(interp, "get_string_keyed");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "get_string_keyed");
    return (STRING*)Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "SP", key);
}

#line 778 "delegate.c"

STRING*
Parrot_delegate_get_string_keyed_int(Interp *interp, PMC* pmc, INTVAL key)
 {
    STRING *meth = CONST_STRING(interp, "get_string_keyed_int");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "get_string_keyed_int");
    return (STRING*)Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "SI", key);
}

#line 791 "delegate.c"

STRING*
Parrot_delegate_get_string_keyed_str(Interp *interp, PMC* pmc, STRING* key)
 {
    STRING *meth = CONST_STRING(interp, "get_string_keyed_str");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "get_string_keyed_str");
    return (STRING*)Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "SS", key);
}

#line 804 "delegate.c"

PMC*
Parrot_delegate_getprop(Interp *interp, PMC* pmc, STRING* key)
 {
    STRING *meth = CONST_STRING(interp, "getprop");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "getprop");
    return (PMC*)Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "PS", key);
}

#line 817 "delegate.c"

PMC*
Parrot_delegate_getprops(Interp *interp, PMC* pmc)
 {
    STRING *meth = CONST_STRING(interp, "getprops");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "getprops");
    return (PMC*)Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "P");
}

#line 830 "delegate.c"

INTVAL
Parrot_delegate_hash(Interp *interp, PMC* pmc, size_t seed)
 {
    STRING *meth = CONST_STRING(interp, "hash");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "hash");
    return (INTVAL)Parrot_run_meth_fromc_args_reti(interp, sub,
        pmc, meth, "I?", seed);
}

#line 843 "delegate.c"

void
Parrot_delegate_i_absolute(Interp *interp, PMC* pmc)
 {
    STRING *meth = CONST_STRING(interp, "i_absolute");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "i_absolute");
    Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "v");
}

#line 856 "delegate.c"

void
Parrot_delegate_i_bitwise_not(Interp *interp, PMC* pmc)
 {
    STRING *meth = CONST_STRING(interp, "i_bitwise_not");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "i_bitwise_not");
    Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "v");
}

#line 869 "delegate.c"

void
Parrot_delegate_i_bitwise_nots(Interp *interp, PMC* pmc)
 {
    STRING *meth = CONST_STRING(interp, "i_bitwise_nots");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "i_bitwise_nots");
    Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "v");
}

#line 882 "delegate.c"

void
Parrot_delegate_i_logical_not(Interp *interp, PMC* pmc)
 {
    STRING *meth = CONST_STRING(interp, "i_logical_not");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "i_logical_not");
    Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "v");
}

#line 895 "delegate.c"

void
Parrot_delegate_i_neg(Interp *interp, PMC* pmc)
 {
    STRING *meth = CONST_STRING(interp, "i_neg");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "i_neg");
    Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "v");
}

#line 908 "delegate.c"

void
Parrot_delegate_increment(Interp *interp, PMC* pmc)
 {
    STRING *meth = CONST_STRING(interp, "increment");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "increment");
    Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "v");
}

void
Parrot_delegate_init(Interp *interp, PMC* pmc)
#line 77 "./src/pmc/delegate.pmc"
{
    STRING *meth = CONST_STRING(interp, "init");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (!PMC_IS_NULL(sub))
        Parrot_run_meth_fromc(interp, sub, pmc, meth);

}
#line 933 "src/pmc/delegate.c"
void
Parrot_delegate_init_pmc(Interp *interp, PMC* pmc, PMC* initializer)
#line 84 "./src/pmc/delegate.pmc"
{
    STRING *meth = CONST_STRING(interp, "init_pmc");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (!PMC_IS_NULL(sub))
        Parrot_run_meth_fromc_args(interp, sub, pmc, meth, "vP", initializer);

}
#line 944 "src/pmc/delegate.c"
#line 943 "delegate.c"

PMC*
Parrot_delegate_inspect(Interp *interp, PMC* pmc)
 {
    STRING *meth = CONST_STRING(interp, "inspect");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "inspect");
    return (PMC*)Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "P");
}

#line 956 "delegate.c"

PMC*
Parrot_delegate_inspect_str(Interp *interp, PMC* pmc, STRING* what)
 {
    STRING *meth = CONST_STRING(interp, "inspect_str");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "inspect_str");
    return (PMC*)Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "PS", what);
}

PMC*
Parrot_delegate_instantiate(Interp *interp, PMC* pmc, PMC* sig)
#line 91 "./src/pmc/delegate.pmc"
{
    STRING *meth = CONST_STRING(interp, "instantiate");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        return Parrot_default_instantiate(interp, pmc, sig);
    return (PMC*) Parrot_run_meth_fromc(interp, sub, pmc, meth);

}
#line 982 "src/pmc/delegate.c"
opcode_t*
Parrot_delegate_invoke(Interp *interp, PMC* pmc, void *next)
#line 133 "./src/pmc/delegate.pmc"
{
    STRING *meth = CONST_STRING(interp, "invoke");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "invoke");
    interp->current_object = pmc;
    return VTABLE_invoke(interp, sub, next);

}
#line 995 "src/pmc/delegate.c"
#line 994 "delegate.c"

INTVAL
Parrot_delegate_is_same(Interp *interp, PMC* pmc, PMC* value)
 {
    STRING *meth = CONST_STRING(interp, "is_same");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "is_same");
    return (INTVAL)Parrot_run_meth_fromc_args_reti(interp, sub,
        pmc, meth, "IP", value);
}

#line 1007 "delegate.c"

INTVAL
Parrot_delegate_isa(Interp *interp, PMC* pmc, STRING* _class)
 {
    STRING *meth = CONST_STRING(interp, "isa");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "isa");
    return (INTVAL)Parrot_run_meth_fromc_args_reti(interp, sub,
        pmc, meth, "IS", _class);
}

#line 1020 "delegate.c"

PMC*
Parrot_delegate_logical_not(Interp *interp, PMC* pmc, PMC* dest)
 {
    STRING *meth = CONST_STRING(interp, "logical_not");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "logical_not");
    return (PMC*)Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "PP", dest);
}

void
Parrot_delegate_mark(Interp *interp, PMC* pmc)
#line 103 "./src/pmc/delegate.pmc"
{
    /* don't delegate mark */

}
#line 1042 "src/pmc/delegate.c"
#line 1041 "delegate.c"

void
Parrot_delegate_morph(Interp *interp, PMC* pmc, INTVAL type)
 {
    STRING *meth = CONST_STRING(interp, "morph");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "morph");
    Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "vI", type);
}

STRING*
Parrot_delegate_name(Interp *interp, PMC* pmc)
#line 111 "./src/pmc/delegate.pmc"
{
    return pmc->vtable->whoami;

}
#line 1063 "src/pmc/delegate.c"
#line 1062 "delegate.c"

PMC*
Parrot_delegate_neg(Interp *interp, PMC* pmc, PMC* dest)
 {
    STRING *meth = CONST_STRING(interp, "neg");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "neg");
    return (PMC*)Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "PP", dest);
}

#line 1075 "delegate.c"

PMC*
Parrot_delegate_new_from_string(Interp *interp, PMC* pmc, STRING* rep, INTVAL flags)
 {
    STRING *meth = CONST_STRING(interp, "new_from_string");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "new_from_string");
    return (PMC*)Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "PSI", rep, flags);
}

#line 1088 "delegate.c"

PMC*
Parrot_delegate_nextkey_keyed(Interp *interp, PMC* pmc, PMC* key, INTVAL what)
 {
    STRING *meth = CONST_STRING(interp, "nextkey_keyed");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "nextkey_keyed");
    return (PMC*)Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "PPI", key, what);
}

#line 1101 "delegate.c"

PMC*
Parrot_delegate_nextkey_keyed_int(Interp *interp, PMC* pmc, INTVAL key, INTVAL what)
 {
    STRING *meth = CONST_STRING(interp, "nextkey_keyed_int");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "nextkey_keyed_int");
    return (PMC*)Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "PII", key, what);
}

#line 1114 "delegate.c"

PMC*
Parrot_delegate_nextkey_keyed_str(Interp *interp, PMC* pmc, STRING* key, INTVAL what)
 {
    STRING *meth = CONST_STRING(interp, "nextkey_keyed_str");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "nextkey_keyed_str");
    return (PMC*)Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "PSI", key, what);
}

PMC*
Parrot_delegate_pmc_namespace(Interp *interp, PMC* pmc)
#line 115 "./src/pmc/delegate.pmc"
{
    return pmc->vtable->_namespace;

}
#line 1136 "src/pmc/delegate.c"
#line 1135 "delegate.c"

FLOATVAL
Parrot_delegate_pop_float(Interp *interp, PMC* pmc)
 {
    STRING *meth = CONST_STRING(interp, "pop_float");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "pop_float");
    return (FLOATVAL)Parrot_run_meth_fromc_args_retf(interp, sub,
        pmc, meth, "N");
}

#line 1148 "delegate.c"

INTVAL
Parrot_delegate_pop_integer(Interp *interp, PMC* pmc)
 {
    STRING *meth = CONST_STRING(interp, "pop_integer");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "pop_integer");
    return (INTVAL)Parrot_run_meth_fromc_args_reti(interp, sub,
        pmc, meth, "I");
}

#line 1161 "delegate.c"

PMC*
Parrot_delegate_pop_pmc(Interp *interp, PMC* pmc)
 {
    STRING *meth = CONST_STRING(interp, "pop_pmc");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "pop_pmc");
    return (PMC*)Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "P");
}

#line 1174 "delegate.c"

STRING*
Parrot_delegate_pop_string(Interp *interp, PMC* pmc)
 {
    STRING *meth = CONST_STRING(interp, "pop_string");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "pop_string");
    return (STRING*)Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "S");
}

#line 1187 "delegate.c"

void
Parrot_delegate_push_float(Interp *interp, PMC* pmc, FLOATVAL value)
 {
    STRING *meth = CONST_STRING(interp, "push_float");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "push_float");
    Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "vN", value);
}

#line 1200 "delegate.c"

void
Parrot_delegate_push_integer(Interp *interp, PMC* pmc, INTVAL value)
 {
    STRING *meth = CONST_STRING(interp, "push_integer");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "push_integer");
    Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "vI", value);
}

#line 1213 "delegate.c"

void
Parrot_delegate_push_pmc(Interp *interp, PMC* pmc, PMC* value)
 {
    STRING *meth = CONST_STRING(interp, "push_pmc");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "push_pmc");
    Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "vP", value);
}

#line 1226 "delegate.c"

void
Parrot_delegate_push_string(Interp *interp, PMC* pmc, STRING* value)
 {
    STRING *meth = CONST_STRING(interp, "push_string");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "push_string");
    Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "vS", value);
}

#line 1239 "delegate.c"

void
Parrot_delegate_remove_attribute(Interp *interp, PMC* pmc, STRING* name)
 {
    STRING *meth = CONST_STRING(interp, "remove_attribute");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "remove_attribute");
    Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "vS", name);
}

#line 1252 "delegate.c"

void
Parrot_delegate_remove_method(Interp *interp, PMC* pmc, STRING* method_name)
 {
    STRING *meth = CONST_STRING(interp, "remove_method");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "remove_method");
    Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "vS", method_name);
}

#line 1265 "delegate.c"

void
Parrot_delegate_remove_parent(Interp *interp, PMC* pmc, PMC* parent)
 {
    STRING *meth = CONST_STRING(interp, "remove_parent");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "remove_parent");
    Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "vP", parent);
}

#line 1278 "delegate.c"

void
Parrot_delegate_remove_role(Interp *interp, PMC* pmc, PMC* role)
 {
    STRING *meth = CONST_STRING(interp, "remove_role");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "remove_role");
    Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "vP", role);
}

#line 1291 "delegate.c"

void
Parrot_delegate_set_attr(Interp *interp, PMC* pmc, INTVAL idx, PMC* value)
 {
    STRING *meth = CONST_STRING(interp, "set_attr");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "set_attr");
    Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "vIP", idx, value);
}

#line 1304 "delegate.c"

void
Parrot_delegate_set_attr_str(Interp *interp, PMC* pmc, STRING* idx, PMC* value)
 {
    STRING *meth = CONST_STRING(interp, "set_attr_str");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "set_attr_str");
    Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "vSP", idx, value);
}

#line 1317 "delegate.c"

void
Parrot_delegate_set_bignum_int(Interp *interp, PMC* pmc, INTVAL value)
 {
    STRING *meth = CONST_STRING(interp, "set_bignum_int");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "set_bignum_int");
    Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "vI", value);
}

#line 1330 "delegate.c"

void
Parrot_delegate_set_bignum_num(Interp *interp, PMC* pmc, FLOATVAL value)
 {
    STRING *meth = CONST_STRING(interp, "set_bignum_num");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "set_bignum_num");
    Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "vN", value);
}

#line 1343 "delegate.c"

void
Parrot_delegate_set_bignum_str(Interp *interp, PMC* pmc, STRING* value)
 {
    STRING *meth = CONST_STRING(interp, "set_bignum_str");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "set_bignum_str");
    Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "vS", value);
}

#line 1356 "delegate.c"

void
Parrot_delegate_set_bool(Interp *interp, PMC* pmc, INTVAL value)
 {
    STRING *meth = CONST_STRING(interp, "set_bool");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "set_bool");
    Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "vI", value);
}

#line 1369 "delegate.c"

void
Parrot_delegate_set_integer_keyed(Interp *interp, PMC* pmc, PMC* key, INTVAL value)
 {
    STRING *meth = CONST_STRING(interp, "set_integer_keyed");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "set_integer_keyed");
    Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "vPI", key, value);
}

#line 1382 "delegate.c"

void
Parrot_delegate_set_integer_keyed_int(Interp *interp, PMC* pmc, INTVAL key, INTVAL value)
 {
    STRING *meth = CONST_STRING(interp, "set_integer_keyed_int");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "set_integer_keyed_int");
    Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "vII", key, value);
}

#line 1395 "delegate.c"

void
Parrot_delegate_set_integer_keyed_str(Interp *interp, PMC* pmc, STRING* key, INTVAL value)
 {
    STRING *meth = CONST_STRING(interp, "set_integer_keyed_str");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "set_integer_keyed_str");
    Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "vSI", key, value);
}

#line 1408 "delegate.c"

void
Parrot_delegate_set_integer_native(Interp *interp, PMC* pmc, INTVAL value)
 {
    STRING *meth = CONST_STRING(interp, "set_integer_native");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "set_integer_native");
    Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "vI", value);
}

#line 1421 "delegate.c"

void
Parrot_delegate_set_integer_same(Interp *interp, PMC* pmc, PMC* value)
 {
    STRING *meth = CONST_STRING(interp, "set_integer_same");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "set_integer_same");
    Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "vP", value);
}

#line 1434 "delegate.c"

void
Parrot_delegate_set_number_keyed(Interp *interp, PMC* pmc, PMC* key, FLOATVAL value)
 {
    STRING *meth = CONST_STRING(interp, "set_number_keyed");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "set_number_keyed");
    Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "vPN", key, value);
}

#line 1447 "delegate.c"

void
Parrot_delegate_set_number_keyed_int(Interp *interp, PMC* pmc, INTVAL key, FLOATVAL value)
 {
    STRING *meth = CONST_STRING(interp, "set_number_keyed_int");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "set_number_keyed_int");
    Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "vIN", key, value);
}

#line 1460 "delegate.c"

void
Parrot_delegate_set_number_keyed_str(Interp *interp, PMC* pmc, STRING* key, FLOATVAL value)
 {
    STRING *meth = CONST_STRING(interp, "set_number_keyed_str");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "set_number_keyed_str");
    Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "vSN", key, value);
}

#line 1473 "delegate.c"

void
Parrot_delegate_set_number_native(Interp *interp, PMC* pmc, FLOATVAL value)
 {
    STRING *meth = CONST_STRING(interp, "set_number_native");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "set_number_native");
    Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "vN", value);
}

#line 1486 "delegate.c"

void
Parrot_delegate_set_number_same(Interp *interp, PMC* pmc, PMC* value)
 {
    STRING *meth = CONST_STRING(interp, "set_number_same");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "set_number_same");
    Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "vP", value);
}

#line 1499 "delegate.c"

void
Parrot_delegate_set_pmc(Interp *interp, PMC* pmc, PMC* value)
 {
    STRING *meth = CONST_STRING(interp, "set_pmc");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "set_pmc");
    Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "vP", value);
}

#line 1512 "delegate.c"

void
Parrot_delegate_set_pmc_keyed(Interp *interp, PMC* pmc, PMC* key, PMC* value)
 {
    STRING *meth = CONST_STRING(interp, "set_pmc_keyed");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "set_pmc_keyed");
    Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "vPP", key, value);
}

#line 1525 "delegate.c"

void
Parrot_delegate_set_pmc_keyed_int(Interp *interp, PMC* pmc, INTVAL key, PMC* value)
 {
    STRING *meth = CONST_STRING(interp, "set_pmc_keyed_int");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "set_pmc_keyed_int");
    Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "vIP", key, value);
}

#line 1538 "delegate.c"

void
Parrot_delegate_set_pmc_keyed_str(Interp *interp, PMC* pmc, STRING* key, PMC* value)
 {
    STRING *meth = CONST_STRING(interp, "set_pmc_keyed_str");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "set_pmc_keyed_str");
    Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "vSP", key, value);
}

#line 1551 "delegate.c"

void
Parrot_delegate_set_pointer(Interp *interp, PMC* pmc, void* value)
 {
    STRING *meth = CONST_STRING(interp, "set_pointer");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "set_pointer");
    Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "v?", value);
}

#line 1564 "delegate.c"

void
Parrot_delegate_set_pointer_keyed(Interp *interp, PMC* pmc, PMC* key, void* value)
 {
    STRING *meth = CONST_STRING(interp, "set_pointer_keyed");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "set_pointer_keyed");
    Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "vP?", key, value);
}

#line 1577 "delegate.c"

void
Parrot_delegate_set_pointer_keyed_int(Interp *interp, PMC* pmc, INTVAL key, void* value)
 {
    STRING *meth = CONST_STRING(interp, "set_pointer_keyed_int");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "set_pointer_keyed_int");
    Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "vI?", key, value);
}

#line 1590 "delegate.c"

void
Parrot_delegate_set_pointer_keyed_str(Interp *interp, PMC* pmc, STRING* key, void* value)
 {
    STRING *meth = CONST_STRING(interp, "set_pointer_keyed_str");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "set_pointer_keyed_str");
    Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "vS?", key, value);
}

#line 1603 "delegate.c"

void
Parrot_delegate_set_string_keyed(Interp *interp, PMC* pmc, PMC* key, STRING* value)
 {
    STRING *meth = CONST_STRING(interp, "set_string_keyed");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "set_string_keyed");
    Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "vPS", key, value);
}

#line 1616 "delegate.c"

void
Parrot_delegate_set_string_keyed_int(Interp *interp, PMC* pmc, INTVAL key, STRING* value)
 {
    STRING *meth = CONST_STRING(interp, "set_string_keyed_int");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "set_string_keyed_int");
    Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "vIS", key, value);
}

#line 1629 "delegate.c"

void
Parrot_delegate_set_string_keyed_str(Interp *interp, PMC* pmc, STRING* key, STRING* value)
 {
    STRING *meth = CONST_STRING(interp, "set_string_keyed_str");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "set_string_keyed_str");
    Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "vSS", key, value);
}

#line 1642 "delegate.c"

void
Parrot_delegate_set_string_native(Interp *interp, PMC* pmc, STRING* value)
 {
    STRING *meth = CONST_STRING(interp, "set_string_native");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "set_string_native");
    Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "vS", value);
}

#line 1655 "delegate.c"

void
Parrot_delegate_set_string_same(Interp *interp, PMC* pmc, PMC* value)
 {
    STRING *meth = CONST_STRING(interp, "set_string_same");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "set_string_same");
    Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "vP", value);
}

#line 1668 "delegate.c"

void
Parrot_delegate_setprop(Interp *interp, PMC* pmc, STRING* key, PMC* value)
 {
    STRING *meth = CONST_STRING(interp, "setprop");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "setprop");
    Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "vSP", key, value);
}

#line 1681 "delegate.c"

void
Parrot_delegate_share(Interp *interp, PMC* pmc)
 {
    STRING *meth = CONST_STRING(interp, "share");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "share");
    Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "v");
}

#line 1694 "delegate.c"

PMC*
Parrot_delegate_share_ro(Interp *interp, PMC* pmc)
 {
    STRING *meth = CONST_STRING(interp, "share_ro");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "share_ro");
    return (PMC*)Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "P");
}

#line 1707 "delegate.c"

FLOATVAL
Parrot_delegate_shift_float(Interp *interp, PMC* pmc)
 {
    STRING *meth = CONST_STRING(interp, "shift_float");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "shift_float");
    return (FLOATVAL)Parrot_run_meth_fromc_args_retf(interp, sub,
        pmc, meth, "N");
}

#line 1720 "delegate.c"

INTVAL
Parrot_delegate_shift_integer(Interp *interp, PMC* pmc)
 {
    STRING *meth = CONST_STRING(interp, "shift_integer");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "shift_integer");
    return (INTVAL)Parrot_run_meth_fromc_args_reti(interp, sub,
        pmc, meth, "I");
}

#line 1733 "delegate.c"

PMC*
Parrot_delegate_shift_pmc(Interp *interp, PMC* pmc)
 {
    STRING *meth = CONST_STRING(interp, "shift_pmc");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "shift_pmc");
    return (PMC*)Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "P");
}

#line 1746 "delegate.c"

STRING*
Parrot_delegate_shift_string(Interp *interp, PMC* pmc)
 {
    STRING *meth = CONST_STRING(interp, "shift_string");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "shift_string");
    return (STRING*)Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "S");
}

#line 1759 "delegate.c"

PMC*
Parrot_delegate_slice(Interp *interp, PMC* pmc, PMC* key, INTVAL flag)
 {
    STRING *meth = CONST_STRING(interp, "slice");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "slice");
    return (PMC*)Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "PPI", key, flag);
}

#line 1772 "delegate.c"

void
Parrot_delegate_splice(Interp *interp, PMC* pmc, PMC* value, INTVAL offset, INTVAL count)
 {
    STRING *meth = CONST_STRING(interp, "splice");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "splice");
    Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "vPII", value, offset, count);
}

#line 1785 "delegate.c"

PMC*
Parrot_delegate_subclass(Interp *interp, PMC* pmc, PMC* name)
 {
    STRING *meth = CONST_STRING(interp, "subclass");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "subclass");
    return (PMC*)Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "PP", name);
}

#line 1798 "delegate.c"

void
Parrot_delegate_substr(Interp *interp, PMC* pmc, INTVAL offset, INTVAL length, PMC* dest)
 {
    STRING *meth = CONST_STRING(interp, "substr");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "substr");
    Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "vIIP", offset, length, dest);
}

#line 1811 "delegate.c"

STRING*
Parrot_delegate_substr_str(Interp *interp, PMC* pmc, INTVAL offset, INTVAL length)
 {
    STRING *meth = CONST_STRING(interp, "substr_str");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "substr_str");
    return (STRING*)Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "SII", offset, length);
}

#line 1824 "delegate.c"

UINTVAL
Parrot_delegate_subtype(Interp *interp, PMC* pmc, INTVAL type)
 {
    STRING *meth = CONST_STRING(interp, "subtype");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "subtype");
    return (UINTVAL)Parrot_run_meth_fromc_args_reti(interp, sub,
        pmc, meth, "?I", type);
}

#line 1837 "delegate.c"

void
Parrot_delegate_thaw(Interp *interp, PMC* pmc, visit_info* info)
 {
    STRING *meth = CONST_STRING(interp, "thaw");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "thaw");
    Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "v?", info);
}

#line 1850 "delegate.c"

void
Parrot_delegate_thawfinish(Interp *interp, PMC* pmc, visit_info* info)
 {
    STRING *meth = CONST_STRING(interp, "thawfinish");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "thawfinish");
    Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "v?", info);
}

INTVAL
Parrot_delegate_type(Interp *interp, PMC* pmc)
#line 119 "./src/pmc/delegate.pmc"
{
    return Parrot_default_type(interp, pmc);

}
#line 1872 "src/pmc/delegate.c"
#line 1871 "delegate.c"

INTVAL
Parrot_delegate_type_keyed(Interp *interp, PMC* pmc, PMC* key)
 {
    STRING *meth = CONST_STRING(interp, "type_keyed");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "type_keyed");
    return (INTVAL)Parrot_run_meth_fromc_args_reti(interp, sub,
        pmc, meth, "IP", key);
}

#line 1884 "delegate.c"

INTVAL
Parrot_delegate_type_keyed_int(Interp *interp, PMC* pmc, INTVAL key)
 {
    STRING *meth = CONST_STRING(interp, "type_keyed_int");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "type_keyed_int");
    return (INTVAL)Parrot_run_meth_fromc_args_reti(interp, sub,
        pmc, meth, "II", key);
}

#line 1897 "delegate.c"

INTVAL
Parrot_delegate_type_keyed_str(Interp *interp, PMC* pmc, STRING* key)
 {
    STRING *meth = CONST_STRING(interp, "type_keyed_str");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "type_keyed_str");
    return (INTVAL)Parrot_run_meth_fromc_args_reti(interp, sub,
        pmc, meth, "IS", key);
}

#line 1910 "delegate.c"

void
Parrot_delegate_unshift_float(Interp *interp, PMC* pmc, FLOATVAL value)
 {
    STRING *meth = CONST_STRING(interp, "unshift_float");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "unshift_float");
    Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "vN", value);
}

#line 1923 "delegate.c"

void
Parrot_delegate_unshift_integer(Interp *interp, PMC* pmc, INTVAL value)
 {
    STRING *meth = CONST_STRING(interp, "unshift_integer");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "unshift_integer");
    Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "vI", value);
}

#line 1936 "delegate.c"

void
Parrot_delegate_unshift_pmc(Interp *interp, PMC* pmc, PMC* value)
 {
    STRING *meth = CONST_STRING(interp, "unshift_pmc");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "unshift_pmc");
    Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "vP", value);
}

#line 1949 "delegate.c"

void
Parrot_delegate_unshift_string(Interp *interp, PMC* pmc, STRING* value)
 {
    STRING *meth = CONST_STRING(interp, "unshift_string");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "unshift_string");
    Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "vS", value);
}

#line 1962 "delegate.c"

void
Parrot_delegate_visit(Interp *interp, PMC* pmc, visit_info* info)
 {
    STRING *meth = CONST_STRING(interp, "visit");
    PMC *sub = Parrot_find_vtable_meth(interp, pmc, meth);
    if (PMC_IS_NULL(sub))
        vtable_meth_not_found(interp, pmc, "visit");
    Parrot_run_meth_fromc_args(interp, sub,
        pmc, meth, "v?", info);
}
void
Parrot_delegate_ro_add_attribute(Interp *interp, PMC* pmc, STRING* name, PMC* type)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "add_attribute() in read-only instance of delegate");
}
void
Parrot_delegate_ro_add_method(Interp *interp, PMC* pmc, STRING* method_name, PMC* sub_pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "add_method() in read-only instance of delegate");
}
void
Parrot_delegate_ro_add_parent(Interp *interp, PMC* pmc, PMC* parent)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "add_parent() in read-only instance of delegate");
}
void
Parrot_delegate_ro_add_role(Interp *interp, PMC* pmc, PMC* role)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "add_role() in read-only instance of delegate");
}
void
Parrot_delegate_ro_assign_pmc(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "assign_pmc() in read-only instance of delegate");
}
void
Parrot_delegate_ro_assign_string_native(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "assign_string_native() in read-only instance of delegate");
}
void
Parrot_delegate_ro_decrement(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "decrement() in read-only instance of delegate");
}
void
Parrot_delegate_ro_delete_keyed(Interp *interp, PMC* pmc, PMC* key)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "delete_keyed() in read-only instance of delegate");
}
void
Parrot_delegate_ro_delete_keyed_int(Interp *interp, PMC* pmc, INTVAL key)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "delete_keyed_int() in read-only instance of delegate");
}
void
Parrot_delegate_ro_delete_keyed_str(Interp *interp, PMC* pmc, STRING* key)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "delete_keyed_str() in read-only instance of delegate");
}
PMC*
Parrot_delegate_ro_find_method(Interp *interp, PMC* pmc, STRING* method_name)
 {
    PMC *const method = Parrot_delegate_find_method(interp, pmc, method_name);
    if (!PMC_IS_NULL(VTABLE_getprop(interp, method, const_string(interp, "write"))))
        return PMCNULL;
    else
        return method;
}
void
Parrot_delegate_ro_i_absolute(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_absolute() in read-only instance of delegate");
}
void
Parrot_delegate_ro_i_bitwise_not(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_bitwise_not() in read-only instance of delegate");
}
void
Parrot_delegate_ro_i_bitwise_nots(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_bitwise_nots() in read-only instance of delegate");
}
void
Parrot_delegate_ro_i_logical_not(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_logical_not() in read-only instance of delegate");
}
void
Parrot_delegate_ro_i_neg(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_neg() in read-only instance of delegate");
}
void
Parrot_delegate_ro_increment(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "increment() in read-only instance of delegate");
}
void
Parrot_delegate_ro_morph(Interp *interp, PMC* pmc, INTVAL type)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "morph() in read-only instance of delegate");
}
FLOATVAL
Parrot_delegate_ro_pop_float(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "pop_float() in read-only instance of delegate");
    return (FLOATVAL)0;
}
INTVAL
Parrot_delegate_ro_pop_integer(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "pop_integer() in read-only instance of delegate");
    return (INTVAL)0;
}
PMC*
Parrot_delegate_ro_pop_pmc(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "pop_pmc() in read-only instance of delegate");
    return PMCNULL;
}
STRING*
Parrot_delegate_ro_pop_string(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "pop_string() in read-only instance of delegate");
    return (STRING*)0;
}
void
Parrot_delegate_ro_push_float(Interp *interp, PMC* pmc, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "push_float() in read-only instance of delegate");
}
void
Parrot_delegate_ro_push_integer(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "push_integer() in read-only instance of delegate");
}
void
Parrot_delegate_ro_push_pmc(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "push_pmc() in read-only instance of delegate");
}
void
Parrot_delegate_ro_push_string(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "push_string() in read-only instance of delegate");
}
void
Parrot_delegate_ro_remove_attribute(Interp *interp, PMC* pmc, STRING* name)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "remove_attribute() in read-only instance of delegate");
}
void
Parrot_delegate_ro_remove_method(Interp *interp, PMC* pmc, STRING* method_name)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "remove_method() in read-only instance of delegate");
}
void
Parrot_delegate_ro_remove_parent(Interp *interp, PMC* pmc, PMC* parent)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "remove_parent() in read-only instance of delegate");
}
void
Parrot_delegate_ro_remove_role(Interp *interp, PMC* pmc, PMC* role)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "remove_role() in read-only instance of delegate");
}
void
Parrot_delegate_ro_set_attr(Interp *interp, PMC* pmc, INTVAL idx, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_attr() in read-only instance of delegate");
}
void
Parrot_delegate_ro_set_attr_str(Interp *interp, PMC* pmc, STRING* idx, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_attr_str() in read-only instance of delegate");
}
void
Parrot_delegate_ro_set_bignum_int(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_bignum_int() in read-only instance of delegate");
}
void
Parrot_delegate_ro_set_bignum_num(Interp *interp, PMC* pmc, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_bignum_num() in read-only instance of delegate");
}
void
Parrot_delegate_ro_set_bignum_str(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_bignum_str() in read-only instance of delegate");
}
void
Parrot_delegate_ro_set_bool(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_bool() in read-only instance of delegate");
}
void
Parrot_delegate_ro_set_integer_keyed(Interp *interp, PMC* pmc, PMC* key, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_keyed() in read-only instance of delegate");
}
void
Parrot_delegate_ro_set_integer_keyed_int(Interp *interp, PMC* pmc, INTVAL key, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_keyed_int() in read-only instance of delegate");
}
void
Parrot_delegate_ro_set_integer_keyed_str(Interp *interp, PMC* pmc, STRING* key, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_keyed_str() in read-only instance of delegate");
}
void
Parrot_delegate_ro_set_integer_native(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_native() in read-only instance of delegate");
}
void
Parrot_delegate_ro_set_integer_same(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_same() in read-only instance of delegate");
}
void
Parrot_delegate_ro_set_number_keyed(Interp *interp, PMC* pmc, PMC* key, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_keyed() in read-only instance of delegate");
}
void
Parrot_delegate_ro_set_number_keyed_int(Interp *interp, PMC* pmc, INTVAL key, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_keyed_int() in read-only instance of delegate");
}
void
Parrot_delegate_ro_set_number_keyed_str(Interp *interp, PMC* pmc, STRING* key, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_keyed_str() in read-only instance of delegate");
}
void
Parrot_delegate_ro_set_number_native(Interp *interp, PMC* pmc, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_native() in read-only instance of delegate");
}
void
Parrot_delegate_ro_set_number_same(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_same() in read-only instance of delegate");
}
void
Parrot_delegate_ro_set_pmc(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pmc() in read-only instance of delegate");
}
void
Parrot_delegate_ro_set_pmc_keyed(Interp *interp, PMC* pmc, PMC* key, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pmc_keyed() in read-only instance of delegate");
}
void
Parrot_delegate_ro_set_pmc_keyed_int(Interp *interp, PMC* pmc, INTVAL key, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_int() in read-only instance of delegate");
}
void
Parrot_delegate_ro_set_pmc_keyed_str(Interp *interp, PMC* pmc, STRING* key, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_str() in read-only instance of delegate");
}
void
Parrot_delegate_ro_set_pointer(Interp *interp, PMC* pmc, void* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pointer() in read-only instance of delegate");
}
void
Parrot_delegate_ro_set_pointer_keyed(Interp *interp, PMC* pmc, PMC* key, void* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pointer_keyed() in read-only instance of delegate");
}
void
Parrot_delegate_ro_set_pointer_keyed_int(Interp *interp, PMC* pmc, INTVAL key, void* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_int() in read-only instance of delegate");
}
void
Parrot_delegate_ro_set_pointer_keyed_str(Interp *interp, PMC* pmc, STRING* key, void* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_str() in read-only instance of delegate");
}
void
Parrot_delegate_ro_set_string_keyed(Interp *interp, PMC* pmc, PMC* key, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_keyed() in read-only instance of delegate");
}
void
Parrot_delegate_ro_set_string_keyed_int(Interp *interp, PMC* pmc, INTVAL key, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_keyed_int() in read-only instance of delegate");
}
void
Parrot_delegate_ro_set_string_keyed_str(Interp *interp, PMC* pmc, STRING* key, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_keyed_str() in read-only instance of delegate");
}
void
Parrot_delegate_ro_set_string_native(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_native() in read-only instance of delegate");
}
void
Parrot_delegate_ro_set_string_same(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_same() in read-only instance of delegate");
}
FLOATVAL
Parrot_delegate_ro_shift_float(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "shift_float() in read-only instance of delegate");
    return (FLOATVAL)0;
}
INTVAL
Parrot_delegate_ro_shift_integer(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "shift_integer() in read-only instance of delegate");
    return (INTVAL)0;
}
PMC*
Parrot_delegate_ro_shift_pmc(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "shift_pmc() in read-only instance of delegate");
    return PMCNULL;
}
STRING*
Parrot_delegate_ro_shift_string(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "shift_string() in read-only instance of delegate");
    return (STRING*)0;
}
void
Parrot_delegate_ro_splice(Interp *interp, PMC* pmc, PMC* value, INTVAL offset, INTVAL count)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "splice() in read-only instance of delegate");
}
void
Parrot_delegate_ro_thaw(Interp *interp, PMC* pmc, visit_info* info)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "thaw() in read-only instance of delegate");
}
void
Parrot_delegate_ro_thawfinish(Interp *interp, PMC* pmc, visit_info* info)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "thawfinish() in read-only instance of delegate");
}
void
Parrot_delegate_ro_unshift_float(Interp *interp, PMC* pmc, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "unshift_float() in read-only instance of delegate");
}
void
Parrot_delegate_ro_unshift_integer(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "unshift_integer() in read-only instance of delegate");
}
void
Parrot_delegate_ro_unshift_pmc(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "unshift_pmc() in read-only instance of delegate");
}
void
Parrot_delegate_ro_unshift_string(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "unshift_string() in read-only instance of delegate");
}
void
Parrot_delegate_class_init(Parrot_Interp interp, int entry, int pass)
{
    const VTABLE temp_base_vtable = {
        NULL, /* namespace */
        enum_class_delegate, /* base_type */
        NULL, /* whoami */
        0|VTABLE_HAS_READONLY_FLAG, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        NULL,   /* ro_variant_vtable */
        Parrot_delegate_absolute,
        Parrot_delegate_add_attribute,
        Parrot_delegate_add_method,
        Parrot_delegate_add_parent,
        Parrot_delegate_add_role,
        Parrot_delegate_assign_pmc,
        Parrot_delegate_assign_string_native,
        Parrot_delegate_bitwise_not,
        Parrot_delegate_bitwise_nots,
        Parrot_delegate_can,
        Parrot_delegate_class_type,
        Parrot_delegate_clone,
        Parrot_delegate_clone_pmc,
        Parrot_delegate_decrement,
        Parrot_delegate_defined,
        Parrot_delegate_defined_keyed,
        Parrot_delegate_defined_keyed_int,
        Parrot_delegate_defined_keyed_str,
        Parrot_delegate_delete_keyed,
        Parrot_delegate_delete_keyed_int,
        Parrot_delegate_delete_keyed_str,
        Parrot_delegate_delprop,
        Parrot_delegate_destroy,
        Parrot_delegate_does,
        Parrot_delegate_elements,
        Parrot_delegate_exists_keyed,
        Parrot_delegate_exists_keyed_int,
        Parrot_delegate_exists_keyed_str,
        Parrot_delegate_find_method,
        Parrot_delegate_freeze,
        Parrot_delegate_get_attr,
        Parrot_delegate_get_attr_str,
        Parrot_delegate_get_bignum,
        Parrot_delegate_get_bool,
        Parrot_delegate_get_class,
        Parrot_delegate_get_integer,
        Parrot_delegate_get_integer_keyed,
        Parrot_delegate_get_integer_keyed_int,
        Parrot_delegate_get_integer_keyed_str,
        Parrot_delegate_get_iter,
        Parrot_delegate_get_number,
        Parrot_delegate_get_number_keyed,
        Parrot_delegate_get_number_keyed_int,
        Parrot_delegate_get_number_keyed_str,
        Parrot_delegate_get_pmc,
        Parrot_delegate_get_pmc_keyed,
        Parrot_delegate_get_pmc_keyed_int,
        Parrot_delegate_get_pmc_keyed_str,
        Parrot_delegate_get_pointer,
        Parrot_delegate_get_pointer_keyed,
        Parrot_delegate_get_pointer_keyed_int,
        Parrot_delegate_get_pointer_keyed_str,
        Parrot_delegate_get_repr,
        Parrot_delegate_get_string,
        Parrot_delegate_get_string_keyed,
        Parrot_delegate_get_string_keyed_int,
        Parrot_delegate_get_string_keyed_str,
        Parrot_delegate_getprop,
        Parrot_delegate_getprops,
        Parrot_delegate_hash,
        Parrot_delegate_i_absolute,
        Parrot_delegate_i_bitwise_not,
        Parrot_delegate_i_bitwise_nots,
        Parrot_delegate_i_logical_not,
        Parrot_delegate_i_neg,
        Parrot_delegate_increment,
        Parrot_delegate_init,
        Parrot_delegate_init_pmc,
        Parrot_delegate_inspect,
        Parrot_delegate_inspect_str,
        Parrot_delegate_instantiate,
        Parrot_delegate_invoke,
        Parrot_delegate_is_same,
        Parrot_delegate_isa,
        Parrot_delegate_logical_not,
        Parrot_delegate_mark,
        Parrot_delegate_morph,
        Parrot_delegate_name,
        Parrot_delegate_neg,
        Parrot_delegate_new_from_string,
        Parrot_delegate_nextkey_keyed,
        Parrot_delegate_nextkey_keyed_int,
        Parrot_delegate_nextkey_keyed_str,
        Parrot_delegate_pmc_namespace,
        Parrot_delegate_pop_float,
        Parrot_delegate_pop_integer,
        Parrot_delegate_pop_pmc,
        Parrot_delegate_pop_string,
        Parrot_delegate_push_float,
        Parrot_delegate_push_integer,
        Parrot_delegate_push_pmc,
        Parrot_delegate_push_string,
        Parrot_delegate_remove_attribute,
        Parrot_delegate_remove_method,
        Parrot_delegate_remove_parent,
        Parrot_delegate_remove_role,
        Parrot_delegate_set_attr,
        Parrot_delegate_set_attr_str,
        Parrot_delegate_set_bignum_int,
        Parrot_delegate_set_bignum_num,
        Parrot_delegate_set_bignum_str,
        Parrot_delegate_set_bool,
        Parrot_delegate_set_integer_keyed,
        Parrot_delegate_set_integer_keyed_int,
        Parrot_delegate_set_integer_keyed_str,
        Parrot_delegate_set_integer_native,
        Parrot_delegate_set_integer_same,
        Parrot_delegate_set_number_keyed,
        Parrot_delegate_set_number_keyed_int,
        Parrot_delegate_set_number_keyed_str,
        Parrot_delegate_set_number_native,
        Parrot_delegate_set_number_same,
        Parrot_delegate_set_pmc,
        Parrot_delegate_set_pmc_keyed,
        Parrot_delegate_set_pmc_keyed_int,
        Parrot_delegate_set_pmc_keyed_str,
        Parrot_delegate_set_pointer,
        Parrot_delegate_set_pointer_keyed,
        Parrot_delegate_set_pointer_keyed_int,
        Parrot_delegate_set_pointer_keyed_str,
        Parrot_delegate_set_string_keyed,
        Parrot_delegate_set_string_keyed_int,
        Parrot_delegate_set_string_keyed_str,
        Parrot_delegate_set_string_native,
        Parrot_delegate_set_string_same,
        Parrot_delegate_setprop,
        Parrot_delegate_share,
        Parrot_delegate_share_ro,
        Parrot_delegate_shift_float,
        Parrot_delegate_shift_integer,
        Parrot_delegate_shift_pmc,
        Parrot_delegate_shift_string,
        Parrot_delegate_slice,
        Parrot_delegate_splice,
        Parrot_delegate_subclass,
        Parrot_delegate_substr,
        Parrot_delegate_substr_str,
        Parrot_delegate_subtype,
        Parrot_delegate_thaw,
        Parrot_delegate_thawfinish,
        Parrot_delegate_type,
        Parrot_delegate_type_keyed,
        Parrot_delegate_type_keyed_int,
        Parrot_delegate_type_keyed_str,
        Parrot_delegate_unshift_float,
        Parrot_delegate_unshift_integer,
        Parrot_delegate_unshift_pmc,
        Parrot_delegate_unshift_string,
        Parrot_delegate_visit
    };

    const VTABLE temp_ro_vtable = {
        NULL, /* namespace */
        enum_class_delegate, /* base_type */
        NULL, /* whoami */
        0|VTABLE_IS_READONLY_FLAG, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        NULL,   /* ro_variant_vtable */
        Parrot_delegate_absolute,
        Parrot_delegate_ro_add_attribute,
        Parrot_delegate_ro_add_method,
        Parrot_delegate_ro_add_parent,
        Parrot_delegate_ro_add_role,
        Parrot_delegate_ro_assign_pmc,
        Parrot_delegate_ro_assign_string_native,
        Parrot_delegate_bitwise_not,
        Parrot_delegate_bitwise_nots,
        Parrot_delegate_can,
        Parrot_delegate_class_type,
        Parrot_delegate_clone,
        Parrot_delegate_clone_pmc,
        Parrot_delegate_ro_decrement,
        Parrot_delegate_defined,
        Parrot_delegate_defined_keyed,
        Parrot_delegate_defined_keyed_int,
        Parrot_delegate_defined_keyed_str,
        Parrot_delegate_ro_delete_keyed,
        Parrot_delegate_ro_delete_keyed_int,
        Parrot_delegate_ro_delete_keyed_str,
        Parrot_delegate_delprop,
        Parrot_delegate_destroy,
        Parrot_delegate_does,
        Parrot_delegate_elements,
        Parrot_delegate_exists_keyed,
        Parrot_delegate_exists_keyed_int,
        Parrot_delegate_exists_keyed_str,
        Parrot_delegate_ro_find_method,
        Parrot_delegate_freeze,
        Parrot_delegate_get_attr,
        Parrot_delegate_get_attr_str,
        Parrot_delegate_get_bignum,
        Parrot_delegate_get_bool,
        Parrot_delegate_get_class,
        Parrot_delegate_get_integer,
        Parrot_delegate_get_integer_keyed,
        Parrot_delegate_get_integer_keyed_int,
        Parrot_delegate_get_integer_keyed_str,
        Parrot_delegate_get_iter,
        Parrot_delegate_get_number,
        Parrot_delegate_get_number_keyed,
        Parrot_delegate_get_number_keyed_int,
        Parrot_delegate_get_number_keyed_str,
        Parrot_delegate_get_pmc,
        Parrot_delegate_get_pmc_keyed,
        Parrot_delegate_get_pmc_keyed_int,
        Parrot_delegate_get_pmc_keyed_str,
        Parrot_delegate_get_pointer,
        Parrot_delegate_get_pointer_keyed,
        Parrot_delegate_get_pointer_keyed_int,
        Parrot_delegate_get_pointer_keyed_str,
        Parrot_delegate_get_repr,
        Parrot_delegate_get_string,
        Parrot_delegate_get_string_keyed,
        Parrot_delegate_get_string_keyed_int,
        Parrot_delegate_get_string_keyed_str,
        Parrot_delegate_getprop,
        Parrot_delegate_getprops,
        Parrot_delegate_hash,
        Parrot_delegate_ro_i_absolute,
        Parrot_delegate_ro_i_bitwise_not,
        Parrot_delegate_ro_i_bitwise_nots,
        Parrot_delegate_ro_i_logical_not,
        Parrot_delegate_ro_i_neg,
        Parrot_delegate_ro_increment,
        Parrot_delegate_init,
        Parrot_delegate_init_pmc,
        Parrot_delegate_inspect,
        Parrot_delegate_inspect_str,
        Parrot_delegate_instantiate,
        Parrot_delegate_invoke,
        Parrot_delegate_is_same,
        Parrot_delegate_isa,
        Parrot_delegate_logical_not,
        Parrot_delegate_mark,
        Parrot_delegate_ro_morph,
        Parrot_delegate_name,
        Parrot_delegate_neg,
        Parrot_delegate_new_from_string,
        Parrot_delegate_nextkey_keyed,
        Parrot_delegate_nextkey_keyed_int,
        Parrot_delegate_nextkey_keyed_str,
        Parrot_delegate_pmc_namespace,
        Parrot_delegate_ro_pop_float,
        Parrot_delegate_ro_pop_integer,
        Parrot_delegate_ro_pop_pmc,
        Parrot_delegate_ro_pop_string,
        Parrot_delegate_ro_push_float,
        Parrot_delegate_ro_push_integer,
        Parrot_delegate_ro_push_pmc,
        Parrot_delegate_ro_push_string,
        Parrot_delegate_ro_remove_attribute,
        Parrot_delegate_ro_remove_method,
        Parrot_delegate_ro_remove_parent,
        Parrot_delegate_ro_remove_role,
        Parrot_delegate_ro_set_attr,
        Parrot_delegate_ro_set_attr_str,
        Parrot_delegate_ro_set_bignum_int,
        Parrot_delegate_ro_set_bignum_num,
        Parrot_delegate_ro_set_bignum_str,
        Parrot_delegate_ro_set_bool,
        Parrot_delegate_ro_set_integer_keyed,
        Parrot_delegate_ro_set_integer_keyed_int,
        Parrot_delegate_ro_set_integer_keyed_str,
        Parrot_delegate_ro_set_integer_native,
        Parrot_delegate_ro_set_integer_same,
        Parrot_delegate_ro_set_number_keyed,
        Parrot_delegate_ro_set_number_keyed_int,
        Parrot_delegate_ro_set_number_keyed_str,
        Parrot_delegate_ro_set_number_native,
        Parrot_delegate_ro_set_number_same,
        Parrot_delegate_ro_set_pmc,
        Parrot_delegate_ro_set_pmc_keyed,
        Parrot_delegate_ro_set_pmc_keyed_int,
        Parrot_delegate_ro_set_pmc_keyed_str,
        Parrot_delegate_ro_set_pointer,
        Parrot_delegate_ro_set_pointer_keyed,
        Parrot_delegate_ro_set_pointer_keyed_int,
        Parrot_delegate_ro_set_pointer_keyed_str,
        Parrot_delegate_ro_set_string_keyed,
        Parrot_delegate_ro_set_string_keyed_int,
        Parrot_delegate_ro_set_string_keyed_str,
        Parrot_delegate_ro_set_string_native,
        Parrot_delegate_ro_set_string_same,
        Parrot_delegate_setprop,
        Parrot_delegate_share,
        Parrot_delegate_share_ro,
        Parrot_delegate_ro_shift_float,
        Parrot_delegate_ro_shift_integer,
        Parrot_delegate_ro_shift_pmc,
        Parrot_delegate_ro_shift_string,
        Parrot_delegate_slice,
        Parrot_delegate_ro_splice,
        Parrot_delegate_subclass,
        Parrot_delegate_substr,
        Parrot_delegate_substr_str,
        Parrot_delegate_subtype,
        Parrot_delegate_ro_thaw,
        Parrot_delegate_ro_thawfinish,
        Parrot_delegate_type,
        Parrot_delegate_type_keyed,
        Parrot_delegate_type_keyed_int,
        Parrot_delegate_type_keyed_str,
        Parrot_delegate_ro_unshift_float,
        Parrot_delegate_ro_unshift_integer,
        Parrot_delegate_ro_unshift_pmc,
        Parrot_delegate_ro_unshift_string,
        Parrot_delegate_visit
    };
    if (pass == 0) {
        /*
         * create vtable - clone it - we have to set a few items
         */
        VTABLE *vt_clone =
            Parrot_clone_vtable(interp, &temp_base_vtable);
        VTABLE *vt_ro_clone =
            Parrot_clone_vtable(interp, &temp_ro_vtable);
        vt_clone->whoami = CONST_STRING(interp, "delegate");
        vt_clone->isa_str = CONST_STRING(interp, "delegate");
        vt_clone->does_str = CONST_STRING(interp, "scalar");
        vt_ro_clone->base_type = entry;
        vt_ro_clone->whoami = vt_clone->whoami;
        vt_ro_clone->isa_str = vt_clone->isa_str;
        vt_ro_clone->does_str = vt_clone->does_str;
        vt_clone->ro_variant_vtable = vt_ro_clone;
        vt_ro_clone->ro_variant_vtable = vt_clone;
        interp->vtables[entry] = vt_clone;
    }
    else { /* pass */
        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        /* create PMC Proxy object */
        Parrot_create_pmc_proxy(interp, entry);
        /* class_init */
        {
        }
    } /* pass */
} /* Parrot_delegate_class_init */


/*

=back

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
