/*
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/env.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

#line 1 "./src/pmc/env.pmc"
/*
Copyright (C) 2001-2007, The Perl Foundation.
$Id: env.pmc 18714 2007-06-01 01:29:41Z petdance $

=head1 NAME

src/pmc/env.pmc - System Environment

=head1 DESCRIPTION

C<Env> is a singleton class which provides access to the system
environment.

=head2 Methods

=over 4

=cut

*/

#include "parrot/parrot.h"

/* array of environment variables,
   speced in POSIX.1, but not in ISO-C
   MS C compilers know about environ, as it is declared in stdlib.h.
*/
#ifndef WIN32
extern char **environ;
#endif

static PMC * Env_PMC;
#line 45 "src/pmc/env.c"
#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_env.h"
#include "pmc_default.h"
#include "env.str"

void
Parrot_Env_delete_keyed(Interp *interp, PMC* pmc, PMC* key)
#line 286 "./src/pmc/env.pmc"
{
    char * const keyname = string_to_cstring(interp,
        VTABLE_get_string(interp, key));
    int free_it;

    if (keyname) {
        char * const val = Parrot_getenv(keyname, &free_it);
        if (val) {
            if (free_it)
                mem_sys_free(val);
            Parrot_unsetenv(keyname);
        }
        string_cstring_free(keyname);
    }

}
#line 72 "src/pmc/env.c"
INTVAL
Parrot_Env_elements(Interp *interp, PMC* pmc)
#line 89 "./src/pmc/env.pmc"
{
    INTVAL rv = 0;
    while (environ[rv] != NULL)
        rv++;
    return rv;

}
#line 83 "src/pmc/env.c"
INTVAL
Parrot_Env_exists_keyed(Interp *interp, PMC* pmc, PMC* key)
#line 258 "./src/pmc/env.pmc"
{
    char * const keyname = string_to_cstring(interp,
        VTABLE_get_string(interp, key));

    if (keyname) {
        int free_it;
        char * const val = Parrot_getenv(keyname, &free_it);
        string_cstring_free(keyname);
        if (val) {
            if (free_it)
                mem_sys_free(val);
            return 1;
        }
    }

    return 0;

}
#line 105 "src/pmc/env.c"
INTVAL
Parrot_Env_get_integer(Interp *interp, PMC* pmc)
#line 106 "./src/pmc/env.pmc"
{
    return  VTABLE_elements(interp, pmc);

}
#line 113 "src/pmc/env.c"
PMC*
Parrot_Env_get_iter(Interp *interp, PMC* pmc)
#line 67 "./src/pmc/env.pmc"
{
    PMC *iter = pmc_new_init(interp, enum_class_Iterator, pmc);
    PMC *key = pmc_new(interp, enum_class_Key);
    PMC_struct_val(iter) = key;
    PObj_get_FLAGS(key) |= KEY_integer_FLAG;
    PMC_int_val(key) = 0;
    if (!environ[0])
        PMC_int_val(key) = -1;
    return iter;

}
#line 128 "src/pmc/env.c"
FLOATVAL
Parrot_Env_get_number(Interp *interp, PMC* pmc)
#line 119 "./src/pmc/env.pmc"
{
    return  VTABLE_elements(interp, pmc);

}
#line 136 "src/pmc/env.c"
PMC*
Parrot_Env_get_pmc_keyed(Interp *interp, PMC* pmc, PMC* key)
#line 176 "./src/pmc/env.pmc"
{
    char * const keyname = string_to_cstring(interp,
        VTABLE_get_string(interp, key));
    int free_it = 0;
    STRING *retval;
    PMC *return_pmc;
    char *val = NULL;

    if (keyname) {
        val = Parrot_getenv(keyname, &free_it);
        string_cstring_free(keyname);
    }
    retval = string_from_cstring(interp, val ? val : "", 0);
    if (free_it && val)
        mem_sys_free(val);
    return_pmc = pmc_new(interp, enum_class_String);
    VTABLE_set_string_native(interp, return_pmc, retval);
    return return_pmc;

}
#line 160 "src/pmc/env.c"
void*
Parrot_Env_get_pointer(Interp *interp, PMC* pmc)
#line 48 "./src/pmc/env.pmc"
{
    return Env_PMC;

}
#line 168 "src/pmc/env.c"
STRING*
Parrot_Env_get_string_keyed(Interp *interp, PMC* pmc, PMC* key)
#line 133 "./src/pmc/env.pmc"
{
    STRING *retval;

    switch (PObj_get_FLAGS(key) & KEY_type_FLAGS) {
        case KEY_integer_FLAG:
            if (PMC_int_val(key) < 0) {
                retval = string_from_cstring(interp, "", 0);
            }
            else {
                const char * const envp = environ[PMC_int_val(key)];
                const char * const p = strchr(envp, '=');
                retval = string_from_cstring(interp, envp, (p-envp));
            }
            break;
        default: {
            char * const keyname = string_to_cstring(interp,
                VTABLE_get_string(interp, key));
            char *val = NULL;
            int free_it = 0;

            if (keyname) {
                val = Parrot_getenv(keyname, &free_it);
                string_cstring_free(keyname);
            }
            retval = string_from_cstring(interp, val ? val : "", 0);
            if (free_it && val)
                mem_sys_free(val);
            break;
        }
    }
    return retval;

}
#line 205 "src/pmc/env.c"
PMC*
Parrot_Env_pmc_namespace(Interp *interp, PMC* pmc)
#line 1 "./src/pmc/env.pmc"
{ return interp->vtables[pmc->vtable->base_type]->_namespace; 
}
#line 211 "src/pmc/env.c"
void
Parrot_Env_set_pmc_keyed(Interp *interp, PMC* pmc, PMC* key, PMC* value)
#line 232 "./src/pmc/env.pmc"
{
    char * const keyname = string_to_cstring(interp,
        VTABLE_get_string(interp, key));
    const STRING * const str_value = VTABLE_get_string(interp, value);
    char * const env_val   = string_to_cstring(interp, str_value);

    if (keyname && env_val)
        Parrot_setenv(keyname, env_val);

    if (keyname)
        string_cstring_free(keyname);

    if (env_val)
        string_cstring_free(env_val);

}
#line 231 "src/pmc/env.c"
void
Parrot_Env_set_pointer(Interp *interp, PMC* pmc, void* ptr)
#line 52 "./src/pmc/env.pmc"
{
    Env_PMC = (PMC*) ptr;

}
#line 239 "src/pmc/env.c"
void
Parrot_Env_set_string_keyed(Interp *interp, PMC* pmc, PMC* key, STRING* value)
#line 206 "./src/pmc/env.pmc"
{
    char * const keyname = string_to_cstring(interp,
        VTABLE_get_string(interp, key));
    char * const env_val = string_to_cstring(interp, value);

    if (keyname && env_val)
        Parrot_setenv(keyname, env_val);

    if (keyname)
        string_cstring_free(keyname);

    if (env_val)
        string_cstring_free(env_val);

}
#line 259 "src/pmc/env.c"
void
Parrot_Env_class_init(Parrot_Interp interp, int entry, int pass)
{
    const VTABLE temp_base_vtable = {
        NULL, /* namespace */
        enum_class_Env, /* base_type */
        NULL, /* whoami */
        0|VTABLE_PMC_IS_SINGLETON, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        NULL,   /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_default_add_attribute,
        Parrot_default_add_method,
        Parrot_default_add_parent,
        Parrot_default_add_role,
        Parrot_default_assign_pmc,
        Parrot_default_assign_string_native,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_can,
        Parrot_default_class_type,
        Parrot_default_clone,
        Parrot_default_clone_pmc,
        Parrot_default_decrement,
        Parrot_default_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_Env_delete_keyed,
        Parrot_default_delete_keyed_int,
        Parrot_default_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_default_destroy,
        Parrot_default_does,
        Parrot_Env_elements,
        Parrot_Env_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_default_find_method,
        Parrot_default_freeze,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_default_get_bool,
        Parrot_default_get_class,
        Parrot_Env_get_integer,
        Parrot_default_get_integer_keyed,
        Parrot_default_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_Env_get_iter,
        Parrot_Env_get_number,
        Parrot_default_get_number_keyed,
        Parrot_default_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_Env_get_pmc_keyed,
        Parrot_default_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_Env_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_default_get_repr,
        Parrot_default_get_string,
        Parrot_Env_get_string_keyed,
        Parrot_default_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_default_hash,
        Parrot_default_i_absolute,
        Parrot_default_i_bitwise_not,
        Parrot_default_i_bitwise_nots,
        Parrot_default_i_logical_not,
        Parrot_default_i_neg,
        Parrot_default_increment,
        Parrot_default_init,
        Parrot_default_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_default_instantiate,
        Parrot_default_invoke,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_logical_not,
        Parrot_default_mark,
        Parrot_default_morph,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_new_from_string,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_Env_pmc_namespace,
        Parrot_default_pop_float,
        Parrot_default_pop_integer,
        Parrot_default_pop_pmc,
        Parrot_default_pop_string,
        Parrot_default_push_float,
        Parrot_default_push_integer,
        Parrot_default_push_pmc,
        Parrot_default_push_string,
        Parrot_default_remove_attribute,
        Parrot_default_remove_method,
        Parrot_default_remove_parent,
        Parrot_default_remove_role,
        Parrot_default_set_attr,
        Parrot_default_set_attr_str,
        Parrot_default_set_bignum_int,
        Parrot_default_set_bignum_num,
        Parrot_default_set_bignum_str,
        Parrot_default_set_bool,
        Parrot_default_set_integer_keyed,
        Parrot_default_set_integer_keyed_int,
        Parrot_default_set_integer_keyed_str,
        Parrot_default_set_integer_native,
        Parrot_default_set_integer_same,
        Parrot_default_set_number_keyed,
        Parrot_default_set_number_keyed_int,
        Parrot_default_set_number_keyed_str,
        Parrot_default_set_number_native,
        Parrot_default_set_number_same,
        Parrot_default_set_pmc,
        Parrot_Env_set_pmc_keyed,
        Parrot_default_set_pmc_keyed_int,
        Parrot_default_set_pmc_keyed_str,
        Parrot_Env_set_pointer,
        Parrot_default_set_pointer_keyed,
        Parrot_default_set_pointer_keyed_int,
        Parrot_default_set_pointer_keyed_str,
        Parrot_Env_set_string_keyed,
        Parrot_default_set_string_keyed_int,
        Parrot_default_set_string_keyed_str,
        Parrot_default_set_string_native,
        Parrot_default_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_default_shift_float,
        Parrot_default_shift_integer,
        Parrot_default_shift_pmc,
        Parrot_default_shift_string,
        Parrot_default_slice,
        Parrot_default_splice,
        Parrot_default_subclass,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtype,
        Parrot_default_thaw,
        Parrot_default_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_type_keyed_int,
        Parrot_default_type_keyed_str,
        Parrot_default_unshift_float,
        Parrot_default_unshift_integer,
        Parrot_default_unshift_pmc,
        Parrot_default_unshift_string,
        Parrot_default_visit
    };

    if (pass == 0) {
        /*
         * create vtable - clone it - we have to set a few items
         */
        VTABLE *vt_clone =
            Parrot_clone_vtable(interp, &temp_base_vtable);
        vt_clone->whoami = CONST_STRING(interp, "Env");
        vt_clone->isa_str = CONST_STRING(interp, "Env");
        vt_clone->does_str = CONST_STRING(interp, "hash");
        interp->vtables[entry] = vt_clone;
    }
    else { /* pass */
        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        /* create PMC Proxy object */
        Parrot_create_pmc_proxy(interp, entry);
        /* class_init */
        {
        }
    } /* pass */
} /* Parrot_Env_class_init */


/*

=back

=head1 SEE ALS0

PDD -
L<http://www.parrotcode.org/docs/pdd/pdd17_basic_types.html#Hash_types>

Environment in Perl6 - L<http://dev.perl.org/perl6/rfc/318.html>

Module for Perl5 - L<http://search.cpan.org/~stas/Env-C-0.06/>

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
