/*
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/eval.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

#line 1 "./src/pmc/eval.pmc"
/*
Copyright (C) 2001-2003, The Perl Foundation.
$Id: eval.pmc 18526 2007-05-13 20:42:55Z chromatic $

=head1 NAME

src/pmc/eval.pmc - Dynamic code evaluation

=head1 DESCRIPTION

C<Eval> extends C<Closure> to provide C<eval>-like dynamic code
evaluation and execution.

=head2 Methods

=over 4

=cut

*/

#include "parrot/parrot.h"

static void
clear_fixups(Interp *interp, Parrot_sub *sub_data)
{
    opcode_t i, ci;
    PackFile_ByteCode *seg;
    PackFile_FixupTable *ft;
    PackFile_ConstTable *ct;
    PMC *sub;

    seg = sub_data->seg;
    if (!seg)
        return;
    ft = seg->fixups;
    if (!ft)
        return;
    ct = seg->const_table;
    if (!ct)
        return;
    for (i = 0; i < ft->fixup_count; i++) {
        switch (ft->fixups[i]->type) {
            case enum_fixup_sub:
                ci = ft->fixups[i]->offset;
                sub = ct->constants[ci]->u.key;
                if (PMC_sub(sub)) {
                    PMC_sub(sub)->seg = NULL;
                    PMC_sub(sub)->eval_pmc = NULL;
                }
                ct->constants[ci]->u.key = NULL;
                ft->fixups[i]->type = 0;
        }
    }
}

static PMC*
get_sub(Interp *interp, PMC* self, int idx)
{
    opcode_t i, n, ci;
    PackFile_ByteCode *seg;
    PackFile_FixupTable *ft;
    PackFile_ConstTable *ct;
    PMC *sub;

    seg = PMC_sub(self)->seg;
    if (!seg)
        return PMCNULL;
    ft = seg->fixups;
    if (!ft)
        return PMCNULL;
    ct = seg->const_table;
    if (!ct)
        return PMCNULL;
    for (i = n = 0; i < ft->fixup_count; i++) {
        switch (ft->fixups[i]->type) {
            case enum_fixup_sub:
                if (n++ != idx)
                    continue;
                ci = ft->fixups[i]->offset;
                sub = ct->constants[ci]->u.key;
                return sub;
        }
    }
    return PMCNULL;
}

static void
mark_subs(Interp *interp, PMC* self)
{
    opcode_t i, ci;
    PackFile_ByteCode *seg;
    PackFile_FixupTable *ft;
    PackFile_ConstTable *ct;
    PMC *sub;

    seg = PMC_sub(self)->seg;
    if (!seg)
        return;
    ft = seg->fixups;
    if (!ft)
        return;
    ct = seg->const_table;
    if (!ct)
        return;
    for (i = 0; i < ft->fixup_count; i++) {
        switch (ft->fixups[i]->type) {
            case enum_fixup_sub:
                ci = ft->fixups[i]->offset;
                sub = ct->constants[ci]->u.key;
                pobject_lives(interp, (PObj*)sub);
        }
    }
}

#line 128 "src/pmc/eval.c"
#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_eval.h"
#include "pmc_sub.h"
#include "pmc_default.h"
#include "eval.str"

void
Parrot_Eval_destroy(Interp *interp, PMC* pmc)
#line 140 "./src/pmc/eval.pmc"
{
    /*
     * If the compiled code contained any .sub (or .pcc.sub)
     * subroutines, these subs got installed in the globals
     * during compiling this bytecode segment.
     *
     * These globals still exist, calling them will segfault
     * as the segment is destroyed now.
     *
     * TODO walk the fixups for this segment, locate globals
     *      and nullify the Sub PMC.
     * This probably needs a pointer into the globals.
     *
     * OTOH - if the global exists - this eval pmc ought
     *        to be alive and destroy isn't called.
     */
    Parrot_sub *sub_data;
    PackFile_Segment *seg;
    PackFile_ByteCode *cur_cs;

    sub_data = PMC_sub(pmc);

    if (!sub_data)
        return;
    clear_fixups(interp, sub_data);
    cur_cs = sub_data->seg;
    if (!cur_cs)
        return;

    /* TODO create PF API, move it there */
    seg = (PackFile_Segment *)cur_cs->const_table;
    if (seg) {
        PackFile_Segment_destroy(interp, seg);
    }
    seg = (PackFile_Segment *)cur_cs->debugs;
    if (seg) {
        PackFile_Segment_destroy(interp, seg);
    }
    seg = (PackFile_Segment *)cur_cs->fixups;
    if (seg) {
        PackFile_Segment_destroy(interp, seg);
        cur_cs->fixups = NULL;
    }
    seg = cur_cs->pic_index;
    if (seg) {
        PackFile_Segment_destroy(interp, seg);
    }
    seg = (PackFile_Segment *)cur_cs;
    PackFile_Segment_destroy(interp, seg);
    sub_data->seg = NULL;
    PMC_struct_val(pmc) = NULL;
    mem_sys_free(sub_data);
    Parrot_Sub_destroy(interp, pmc);

}
#line 195 "src/pmc/eval.c"
void
Parrot_Eval_freeze(Interp *interp, PMC* pmc, visit_info *info)
#line 293 "./src/pmc/eval.pmc"
{
    IMAGE_IO *io = info->image_io;
    STRING *packed = Parrot_Eval_get_string(interp, pmc);
     VTABLE_push_string(interp, io, packed);
    Parrot_Sub_freeze(interp, pmc, info);

}
#line 206 "src/pmc/eval.c"
PMC*
Parrot_Eval_get_pmc_keyed_int(Interp *interp, PMC* pmc, INTVAL key)
#line 275 "./src/pmc/eval.pmc"
{
    return get_sub(interp, pmc, key);

}
#line 214 "src/pmc/eval.c"
STRING*
Parrot_Eval_get_string(Interp *interp, PMC* pmc)
#line 210 "./src/pmc/eval.pmc"
{
    STRING *res;
    PackFile *pf;
    size_t size, aligned_size;
    PackFile_ByteCode *seg;

    pf = PackFile_new(interp, 0);
    seg = PMC_sub(pmc)->seg;
    PackFile_add_segment(interp, &pf->directory, (PackFile_Segment *)seg);
    if (seg->const_table)
        PackFile_add_segment(interp, &pf->directory,
                (PackFile_Segment *)seg->const_table);
    if (seg->debugs)
        PackFile_add_segment(interp, &pf->directory,
                (PackFile_Segment *)seg->debugs);
    if (seg->fixups)
        PackFile_add_segment(interp, &pf->directory,
                (PackFile_Segment *)seg->fixups);
    if (seg->pic_index)
        PackFile_add_segment(interp, &pf->directory,
                (PackFile_Segment *)seg->pic_index);
    size = PackFile_pack_size(interp, pf) * sizeof (opcode_t);
    /*
     * work around packfile bug:
     * as far as I have checked it the story is:
     * - PackFile_pack_size() assumes 16 byte alignment but doesn't
     *   have the actual start of the code (packed)
     * - PackFile_pack() uses 16 bye alignment relative to the start
     *   of the code, which isn't really the same
     * Therefore align code at 16, which should give the desired
     * effect
     */
    aligned_size = size + 15;
    res = string_make_empty(interp, enum_stringrep_one, aligned_size);
    res->strlen = res->bufused = size;
    if ((size_t)(res->strstart) & 0xf) {
        char *adr = res->strstart;
        adr += 16 - ((size_t)adr & 0xf);
        res->strstart = adr;
    }
    /* We block DOD while doing the packing, since GC run during a pack
       has been observed to cause problems. There may be a Better Fix.
       See RT #40410 for example of the problem (note on line that
       segfaults, it is *cursor that is pointing to dealloced memory). */
    Parrot_block_DOD(interp);
    PackFile_pack(interp, pf, (opcode_t *)res->strstart);
    Parrot_unblock_DOD(interp);
    /* now remove all segments from directory again and destroy
     * the packfile
     */
    pf->directory.num_segments = 0;
    PackFile_destroy(interp, pf);
    return res;

}
#line 273 "src/pmc/eval.c"
void
Parrot_Eval_init(Interp *interp, PMC* pmc)
#line 118 "./src/pmc/eval.pmc"
{
    Parrot_sub *sub_data;
    Parrot_Sub_init(interp, pmc);
    sub_data = PMC_sub(pmc);
    PObj_custom_mark_destroy_SETALL(pmc);
    sub_data->seg = NULL;

}
#line 285 "src/pmc/eval.c"
opcode_t*
Parrot_Eval_invoke(Interp *interp, PMC* pmc, void *next)
#line 135 "./src/pmc/eval.pmc"
{
    PMC *sub = Parrot_Eval_get_pmc_keyed_int(interp, pmc, 0);
    return VTABLE_invoke(interp, sub, next);

}
#line 294 "src/pmc/eval.c"
void
Parrot_Eval_mark(Interp *interp, PMC* pmc)
#line 195 "./src/pmc/eval.pmc"
{
    mark_subs(interp, pmc);

}
#line 302 "src/pmc/eval.c"
void
Parrot_Eval_thaw(Interp *interp, PMC* pmc, visit_info *info)
#line 300 "./src/pmc/eval.pmc"
{
    IMAGE_IO *io = info->image_io;
    PackFile *pf;
    STRING *packed;
    size_t i;
    PackFile_Segment *seg;
    struct Parrot_sub * sub;

    packed =  VTABLE_shift_string(interp, io);
    Parrot_Sub_thaw(interp, pmc, info);
    sub = PMC_sub(pmc);
    pf = PackFile_new(interp, 0);
    if (!PackFile_unpack(interp, pf, (opcode_t *)packed->strstart,
            packed->strlen))
        real_exception(interp, NULL, E_IOError,
                "couldn't unpack packfile");
    do_sub_pragmas(interp, pf->cur_cs, PBC_PBC, pmc);
    for (i = 0; i < pf->directory.num_segments; ++i) {
        seg = pf->directory.segments[i];
        if (seg->type == PF_BYTEC_SEG) {
            PMC_sub(pmc)->seg = (PackFile_ByteCode *)seg;
            break;
        }
    }
    pf->directory.num_segments = 0;
    /*
     * XXX this isn't ok - it seems that the packfile
     *     gets attached to interp->code and is
     *     destroyed again during interpreter destruction
     */
    /* PackFile_destroy(interp, pf); */

}
#line 339 "src/pmc/eval.c"
void
Parrot_Eval_ro_add_attribute(Interp *interp, PMC* pmc, STRING* name, PMC* type)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "add_attribute() in read-only instance of Eval");
}
void
Parrot_Eval_ro_add_method(Interp *interp, PMC* pmc, STRING* method_name, PMC* sub_pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "add_method() in read-only instance of Eval");
}
void
Parrot_Eval_ro_add_parent(Interp *interp, PMC* pmc, PMC* parent)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "add_parent() in read-only instance of Eval");
}
void
Parrot_Eval_ro_add_role(Interp *interp, PMC* pmc, PMC* role)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "add_role() in read-only instance of Eval");
}
void
Parrot_Eval_ro_assign_pmc(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "assign_pmc() in read-only instance of Eval");
}
void
Parrot_Eval_ro_assign_string_native(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "assign_string_native() in read-only instance of Eval");
}
void
Parrot_Eval_ro_decrement(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "decrement() in read-only instance of Eval");
}
void
Parrot_Eval_ro_delete_keyed(Interp *interp, PMC* pmc, PMC* key)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "delete_keyed() in read-only instance of Eval");
}
void
Parrot_Eval_ro_delete_keyed_int(Interp *interp, PMC* pmc, INTVAL key)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "delete_keyed_int() in read-only instance of Eval");
}
void
Parrot_Eval_ro_delete_keyed_str(Interp *interp, PMC* pmc, STRING* key)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "delete_keyed_str() in read-only instance of Eval");
}
PMC*
Parrot_Eval_ro_find_method(Interp *interp, PMC* pmc, STRING* method_name)
 {
    PMC *const method = Parrot_default_find_method(interp, pmc, method_name);
    if (!PMC_IS_NULL(VTABLE_getprop(interp, method, const_string(interp, "write"))))
        return PMCNULL;
    else
        return method;
}
void
Parrot_Eval_ro_i_absolute(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_absolute() in read-only instance of Eval");
}
void
Parrot_Eval_ro_i_bitwise_not(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_bitwise_not() in read-only instance of Eval");
}
void
Parrot_Eval_ro_i_bitwise_nots(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_bitwise_nots() in read-only instance of Eval");
}
void
Parrot_Eval_ro_i_logical_not(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_logical_not() in read-only instance of Eval");
}
void
Parrot_Eval_ro_i_neg(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_neg() in read-only instance of Eval");
}
void
Parrot_Eval_ro_increment(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "increment() in read-only instance of Eval");
}
void
Parrot_Eval_ro_morph(Interp *interp, PMC* pmc, INTVAL type)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "morph() in read-only instance of Eval");
}
FLOATVAL
Parrot_Eval_ro_pop_float(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "pop_float() in read-only instance of Eval");
    return (FLOATVAL)0;
}
INTVAL
Parrot_Eval_ro_pop_integer(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "pop_integer() in read-only instance of Eval");
    return (INTVAL)0;
}
PMC*
Parrot_Eval_ro_pop_pmc(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "pop_pmc() in read-only instance of Eval");
    return PMCNULL;
}
STRING*
Parrot_Eval_ro_pop_string(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "pop_string() in read-only instance of Eval");
    return (STRING*)0;
}
void
Parrot_Eval_ro_push_float(Interp *interp, PMC* pmc, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "push_float() in read-only instance of Eval");
}
void
Parrot_Eval_ro_push_integer(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "push_integer() in read-only instance of Eval");
}
void
Parrot_Eval_ro_push_pmc(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "push_pmc() in read-only instance of Eval");
}
void
Parrot_Eval_ro_push_string(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "push_string() in read-only instance of Eval");
}
void
Parrot_Eval_ro_remove_attribute(Interp *interp, PMC* pmc, STRING* name)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "remove_attribute() in read-only instance of Eval");
}
void
Parrot_Eval_ro_remove_method(Interp *interp, PMC* pmc, STRING* method_name)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "remove_method() in read-only instance of Eval");
}
void
Parrot_Eval_ro_remove_parent(Interp *interp, PMC* pmc, PMC* parent)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "remove_parent() in read-only instance of Eval");
}
void
Parrot_Eval_ro_remove_role(Interp *interp, PMC* pmc, PMC* role)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "remove_role() in read-only instance of Eval");
}
void
Parrot_Eval_ro_set_attr(Interp *interp, PMC* pmc, INTVAL idx, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_attr() in read-only instance of Eval");
}
void
Parrot_Eval_ro_set_attr_str(Interp *interp, PMC* pmc, STRING* idx, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_attr_str() in read-only instance of Eval");
}
void
Parrot_Eval_ro_set_bignum_int(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_bignum_int() in read-only instance of Eval");
}
void
Parrot_Eval_ro_set_bignum_num(Interp *interp, PMC* pmc, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_bignum_num() in read-only instance of Eval");
}
void
Parrot_Eval_ro_set_bignum_str(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_bignum_str() in read-only instance of Eval");
}
void
Parrot_Eval_ro_set_bool(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_bool() in read-only instance of Eval");
}
void
Parrot_Eval_ro_set_integer_keyed(Interp *interp, PMC* pmc, PMC* key, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_keyed() in read-only instance of Eval");
}
void
Parrot_Eval_ro_set_integer_keyed_int(Interp *interp, PMC* pmc, INTVAL key, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_keyed_int() in read-only instance of Eval");
}
void
Parrot_Eval_ro_set_integer_keyed_str(Interp *interp, PMC* pmc, STRING* key, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_keyed_str() in read-only instance of Eval");
}
void
Parrot_Eval_ro_set_integer_native(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_native() in read-only instance of Eval");
}
void
Parrot_Eval_ro_set_integer_same(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_same() in read-only instance of Eval");
}
void
Parrot_Eval_ro_set_number_keyed(Interp *interp, PMC* pmc, PMC* key, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_keyed() in read-only instance of Eval");
}
void
Parrot_Eval_ro_set_number_keyed_int(Interp *interp, PMC* pmc, INTVAL key, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_keyed_int() in read-only instance of Eval");
}
void
Parrot_Eval_ro_set_number_keyed_str(Interp *interp, PMC* pmc, STRING* key, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_keyed_str() in read-only instance of Eval");
}
void
Parrot_Eval_ro_set_number_native(Interp *interp, PMC* pmc, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_native() in read-only instance of Eval");
}
void
Parrot_Eval_ro_set_number_same(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_same() in read-only instance of Eval");
}
void
Parrot_Eval_ro_set_pmc(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pmc() in read-only instance of Eval");
}
void
Parrot_Eval_ro_set_pmc_keyed(Interp *interp, PMC* pmc, PMC* key, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pmc_keyed() in read-only instance of Eval");
}
void
Parrot_Eval_ro_set_pmc_keyed_int(Interp *interp, PMC* pmc, INTVAL key, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_int() in read-only instance of Eval");
}
void
Parrot_Eval_ro_set_pmc_keyed_str(Interp *interp, PMC* pmc, STRING* key, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_str() in read-only instance of Eval");
}
void
Parrot_Eval_ro_set_pointer(Interp *interp, PMC* pmc, void* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pointer() in read-only instance of Eval");
}
void
Parrot_Eval_ro_set_pointer_keyed(Interp *interp, PMC* pmc, PMC* key, void* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pointer_keyed() in read-only instance of Eval");
}
void
Parrot_Eval_ro_set_pointer_keyed_int(Interp *interp, PMC* pmc, INTVAL key, void* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_int() in read-only instance of Eval");
}
void
Parrot_Eval_ro_set_pointer_keyed_str(Interp *interp, PMC* pmc, STRING* key, void* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_str() in read-only instance of Eval");
}
void
Parrot_Eval_ro_set_string_keyed(Interp *interp, PMC* pmc, PMC* key, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_keyed() in read-only instance of Eval");
}
void
Parrot_Eval_ro_set_string_keyed_int(Interp *interp, PMC* pmc, INTVAL key, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_keyed_int() in read-only instance of Eval");
}
void
Parrot_Eval_ro_set_string_keyed_str(Interp *interp, PMC* pmc, STRING* key, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_keyed_str() in read-only instance of Eval");
}
void
Parrot_Eval_ro_set_string_native(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_native() in read-only instance of Eval");
}
void
Parrot_Eval_ro_set_string_same(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_same() in read-only instance of Eval");
}
FLOATVAL
Parrot_Eval_ro_shift_float(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "shift_float() in read-only instance of Eval");
    return (FLOATVAL)0;
}
INTVAL
Parrot_Eval_ro_shift_integer(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "shift_integer() in read-only instance of Eval");
    return (INTVAL)0;
}
PMC*
Parrot_Eval_ro_shift_pmc(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "shift_pmc() in read-only instance of Eval");
    return PMCNULL;
}
STRING*
Parrot_Eval_ro_shift_string(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "shift_string() in read-only instance of Eval");
    return (STRING*)0;
}
void
Parrot_Eval_ro_splice(Interp *interp, PMC* pmc, PMC* value, INTVAL offset, INTVAL count)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "splice() in read-only instance of Eval");
}
void
Parrot_Eval_ro_thaw(Interp *interp, PMC* pmc, visit_info* info)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "thaw() in read-only instance of Eval");
}
void
Parrot_Eval_ro_thawfinish(Interp *interp, PMC* pmc, visit_info* info)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "thawfinish() in read-only instance of Eval");
}
void
Parrot_Eval_ro_unshift_float(Interp *interp, PMC* pmc, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "unshift_float() in read-only instance of Eval");
}
void
Parrot_Eval_ro_unshift_integer(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "unshift_integer() in read-only instance of Eval");
}
void
Parrot_Eval_ro_unshift_pmc(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "unshift_pmc() in read-only instance of Eval");
}
void
Parrot_Eval_ro_unshift_string(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "unshift_string() in read-only instance of Eval");
}
void
Parrot_Eval_class_init(Parrot_Interp interp, int entry, int pass)
{
    const VTABLE temp_base_vtable = {
        NULL, /* namespace */
        enum_class_Eval, /* base_type */
        NULL, /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_HAS_READONLY_FLAG, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        NULL,   /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_default_add_attribute,
        Parrot_default_add_method,
        Parrot_default_add_parent,
        Parrot_default_add_role,
        Parrot_Sub_assign_pmc,
        Parrot_default_assign_string_native,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_can,
        Parrot_default_class_type,
        Parrot_Sub_clone,
        Parrot_default_clone_pmc,
        Parrot_default_decrement,
        Parrot_Sub_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_default_delete_keyed,
        Parrot_default_delete_keyed_int,
        Parrot_default_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_Eval_destroy,
        Parrot_default_does,
        Parrot_default_elements,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_default_find_method,
        Parrot_Eval_freeze,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_Sub_get_bool,
        Parrot_default_get_class,
        Parrot_default_get_integer,
        Parrot_Sub_get_integer_keyed,
        Parrot_default_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_iter,
        Parrot_default_get_number,
        Parrot_default_get_number_keyed,
        Parrot_default_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_default_get_pmc_keyed,
        Parrot_Eval_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_Sub_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_default_get_repr,
        Parrot_Eval_get_string,
        Parrot_default_get_string_keyed,
        Parrot_default_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_default_hash,
        Parrot_default_i_absolute,
        Parrot_default_i_bitwise_not,
        Parrot_default_i_bitwise_nots,
        Parrot_default_i_logical_not,
        Parrot_default_i_neg,
        Parrot_default_increment,
        Parrot_Eval_init,
        Parrot_default_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_default_instantiate,
        Parrot_Eval_invoke,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_logical_not,
        Parrot_Eval_mark,
        Parrot_default_morph,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_new_from_string,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_pmc_namespace,
        Parrot_default_pop_float,
        Parrot_default_pop_integer,
        Parrot_default_pop_pmc,
        Parrot_default_pop_string,
        Parrot_default_push_float,
        Parrot_default_push_integer,
        Parrot_default_push_pmc,
        Parrot_default_push_string,
        Parrot_default_remove_attribute,
        Parrot_default_remove_method,
        Parrot_default_remove_parent,
        Parrot_default_remove_role,
        Parrot_default_set_attr,
        Parrot_default_set_attr_str,
        Parrot_default_set_bignum_int,
        Parrot_default_set_bignum_num,
        Parrot_default_set_bignum_str,
        Parrot_default_set_bool,
        Parrot_default_set_integer_keyed,
        Parrot_default_set_integer_keyed_int,
        Parrot_default_set_integer_keyed_str,
        Parrot_default_set_integer_native,
        Parrot_default_set_integer_same,
        Parrot_default_set_number_keyed,
        Parrot_default_set_number_keyed_int,
        Parrot_default_set_number_keyed_str,
        Parrot_default_set_number_native,
        Parrot_default_set_number_same,
        Parrot_Sub_set_pmc,
        Parrot_default_set_pmc_keyed,
        Parrot_default_set_pmc_keyed_int,
        Parrot_default_set_pmc_keyed_str,
        Parrot_Sub_set_pointer,
        Parrot_default_set_pointer_keyed,
        Parrot_default_set_pointer_keyed_int,
        Parrot_default_set_pointer_keyed_str,
        Parrot_default_set_string_keyed,
        Parrot_default_set_string_keyed_int,
        Parrot_default_set_string_keyed_str,
        Parrot_Sub_set_string_native,
        Parrot_default_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_default_shift_float,
        Parrot_default_shift_integer,
        Parrot_default_shift_pmc,
        Parrot_default_shift_string,
        Parrot_default_slice,
        Parrot_default_splice,
        Parrot_default_subclass,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtype,
        Parrot_Eval_thaw,
        Parrot_default_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_type_keyed_int,
        Parrot_default_type_keyed_str,
        Parrot_default_unshift_float,
        Parrot_default_unshift_integer,
        Parrot_default_unshift_pmc,
        Parrot_default_unshift_string,
        Parrot_Sub_visit
    };

    const VTABLE temp_ro_vtable = {
        NULL, /* namespace */
        enum_class_Eval, /* base_type */
        NULL, /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_IS_READONLY_FLAG, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        NULL,   /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_Eval_ro_add_attribute,
        Parrot_Eval_ro_add_method,
        Parrot_Eval_ro_add_parent,
        Parrot_Eval_ro_add_role,
        Parrot_Eval_ro_assign_pmc,
        Parrot_Eval_ro_assign_string_native,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_can,
        Parrot_default_class_type,
        Parrot_Sub_clone,
        Parrot_default_clone_pmc,
        Parrot_Eval_ro_decrement,
        Parrot_Sub_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_Eval_ro_delete_keyed,
        Parrot_Eval_ro_delete_keyed_int,
        Parrot_Eval_ro_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_Eval_destroy,
        Parrot_default_does,
        Parrot_default_elements,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_Eval_ro_find_method,
        Parrot_Eval_freeze,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_Sub_get_bool,
        Parrot_default_get_class,
        Parrot_default_get_integer,
        Parrot_Sub_get_integer_keyed,
        Parrot_default_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_iter,
        Parrot_default_get_number,
        Parrot_default_get_number_keyed,
        Parrot_default_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_default_get_pmc_keyed,
        Parrot_Eval_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_Sub_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_default_get_repr,
        Parrot_Eval_get_string,
        Parrot_default_get_string_keyed,
        Parrot_default_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_default_hash,
        Parrot_Eval_ro_i_absolute,
        Parrot_Eval_ro_i_bitwise_not,
        Parrot_Eval_ro_i_bitwise_nots,
        Parrot_Eval_ro_i_logical_not,
        Parrot_Eval_ro_i_neg,
        Parrot_Eval_ro_increment,
        Parrot_Eval_init,
        Parrot_default_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_default_instantiate,
        Parrot_Eval_invoke,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_logical_not,
        Parrot_Eval_mark,
        Parrot_Eval_ro_morph,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_new_from_string,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_pmc_namespace,
        Parrot_Eval_ro_pop_float,
        Parrot_Eval_ro_pop_integer,
        Parrot_Eval_ro_pop_pmc,
        Parrot_Eval_ro_pop_string,
        Parrot_Eval_ro_push_float,
        Parrot_Eval_ro_push_integer,
        Parrot_Eval_ro_push_pmc,
        Parrot_Eval_ro_push_string,
        Parrot_Eval_ro_remove_attribute,
        Parrot_Eval_ro_remove_method,
        Parrot_Eval_ro_remove_parent,
        Parrot_Eval_ro_remove_role,
        Parrot_Eval_ro_set_attr,
        Parrot_Eval_ro_set_attr_str,
        Parrot_Eval_ro_set_bignum_int,
        Parrot_Eval_ro_set_bignum_num,
        Parrot_Eval_ro_set_bignum_str,
        Parrot_Eval_ro_set_bool,
        Parrot_Eval_ro_set_integer_keyed,
        Parrot_Eval_ro_set_integer_keyed_int,
        Parrot_Eval_ro_set_integer_keyed_str,
        Parrot_Eval_ro_set_integer_native,
        Parrot_Eval_ro_set_integer_same,
        Parrot_Eval_ro_set_number_keyed,
        Parrot_Eval_ro_set_number_keyed_int,
        Parrot_Eval_ro_set_number_keyed_str,
        Parrot_Eval_ro_set_number_native,
        Parrot_Eval_ro_set_number_same,
        Parrot_Eval_ro_set_pmc,
        Parrot_Eval_ro_set_pmc_keyed,
        Parrot_Eval_ro_set_pmc_keyed_int,
        Parrot_Eval_ro_set_pmc_keyed_str,
        Parrot_Eval_ro_set_pointer,
        Parrot_Eval_ro_set_pointer_keyed,
        Parrot_Eval_ro_set_pointer_keyed_int,
        Parrot_Eval_ro_set_pointer_keyed_str,
        Parrot_Eval_ro_set_string_keyed,
        Parrot_Eval_ro_set_string_keyed_int,
        Parrot_Eval_ro_set_string_keyed_str,
        Parrot_Eval_ro_set_string_native,
        Parrot_Eval_ro_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_Eval_ro_shift_float,
        Parrot_Eval_ro_shift_integer,
        Parrot_Eval_ro_shift_pmc,
        Parrot_Eval_ro_shift_string,
        Parrot_default_slice,
        Parrot_Eval_ro_splice,
        Parrot_default_subclass,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtype,
        Parrot_Eval_ro_thaw,
        Parrot_Eval_ro_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_type_keyed_int,
        Parrot_default_type_keyed_str,
        Parrot_Eval_ro_unshift_float,
        Parrot_Eval_ro_unshift_integer,
        Parrot_Eval_ro_unshift_pmc,
        Parrot_Eval_ro_unshift_string,
        Parrot_Sub_visit
    };
    if (pass == 0) {
        /*
         * create vtable - clone it - we have to set a few items
         */
        VTABLE *vt_clone =
            Parrot_clone_vtable(interp, &temp_base_vtable);
        VTABLE *vt_ro_clone =
            Parrot_clone_vtable(interp, &temp_ro_vtable);
        vt_clone->whoami = CONST_STRING(interp, "Eval");
        vt_clone->isa_str = CONST_STRING(interp, "Eval Sub");
        vt_clone->does_str = CONST_STRING(interp, "scalar");
        vt_ro_clone->base_type = entry;
        vt_ro_clone->whoami = vt_clone->whoami;
        vt_ro_clone->isa_str = vt_clone->isa_str;
        vt_ro_clone->does_str = vt_clone->does_str;
        vt_clone->ro_variant_vtable = vt_ro_clone;
        vt_ro_clone->ro_variant_vtable = vt_clone;
        interp->vtables[entry] = vt_clone;
    }
    else { /* pass */
        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        /* create PMC Proxy object */
        Parrot_create_pmc_proxy(interp, entry);
        /* class_init */
        {
        }
    } /* pass */
} /* Parrot_Eval_class_init */


/*

=back

=head1 HISTORY

Initial version by leo 2003/01/16.

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
