/*
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/fixedbooleanarray.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

#line 1 "./src/pmc/fixedbooleanarray.pmc"
/*
Copyright (C) 2001-2007, The Perl Foundation.
$Id: fixedbooleanarray.pmc 18407 2007-05-03 05:08:51Z chromatic $

=head1 NAME

src/pmc/fixedbooleanarray.pmc - fixed size array for booleans only

=head1 DESCRIPTION

The C<FixedBooleanArray PMC> implements an array of fixed size, which
stores booleans.  It uses the C<Boolean PMC> for all conversions.  The
C<FixedBooleanArray PMC> is extended by the C<ResizableBooleanArray
PMC>.

=head2 Functions

=over 4

=cut

*/

#include "parrot/parrot.h"


/*
 * TODO merge this with functions from BigInt PMC
 */

#define BITS_PER_CHAR 8

static void
booleanarray_init(Interp *interp, PMC *self) {
    PMC_int_val(self) = 0;
    PMC_int_val2(self) = 0;
    PMC_data(self) = NULL;
}

static void
booleanarray_clone(Interp *interp, PMC *self, PMC *dest) {
    PMC_int_val(dest)  = PMC_int_val(self);
    PMC_int_val2(dest) = PMC_int_val2(self);
    if (PMC_data(self)) {
        PMC_data(dest) = malloc(PMC_int_val2(self) / BITS_PER_CHAR);
        mem_sys_memcopy(PMC_data(dest),
                        PMC_data(self), PMC_int_val2(self) / BITS_PER_CHAR);
    }
    else
        PMC_data(dest) = NULL;
}

static void
booleanarray_clear(Interp *interp, PMC *self) {
    PMC_int_val(self) = 0;
    PMC_int_val2(self) = 0;
    if (PMC_data(self)) {
        mem_sys_free(PMC_data(self));
        PMC_data(self) = NULL;
    }
}

#line 75 "src/pmc/fixedbooleanarray.c"
#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_fixedbooleanarray.h"
#include "pmc_default.h"
#include "fixedbooleanarray.str"

PMC*
Parrot_FixedBooleanArray_clone(Interp *interp, PMC* pmc)
#line 126 "./src/pmc/fixedbooleanarray.pmc"
{
    PMC * dest = pmc_new(interp, pmc->vtable->base_type);
    booleanarray_clone(interp, pmc, dest);
    PObj_active_destroy_SET(dest);
    return dest;

}
#line 93 "src/pmc/fixedbooleanarray.c"
void
Parrot_FixedBooleanArray_destroy(Interp *interp, PMC* pmc)
#line 112 "./src/pmc/fixedbooleanarray.pmc"
{
    booleanarray_clear(interp, pmc);

}
#line 101 "src/pmc/fixedbooleanarray.c"
INTVAL
Parrot_FixedBooleanArray_elements(Interp *interp, PMC* pmc)
#line 155 "./src/pmc/fixedbooleanarray.pmc"
{
    return PMC_int_val(pmc);

}
#line 109 "src/pmc/fixedbooleanarray.c"
void
Parrot_FixedBooleanArray_freeze(Interp *interp, PMC* pmc, visit_info *info)
#line 494 "./src/pmc/fixedbooleanarray.pmc"
{
    IMAGE_IO *io = info->image_io;
    STRING   *s;

     VTABLE_push_integer(interp, io, PMC_int_val(pmc));
    s = string_from_cstring(interp,
                            PMC_data_typed(pmc, char *),
                            PMC_int_val2(pmc) / BITS_PER_CHAR);
     VTABLE_push_string(interp, io, s);

}
#line 124 "src/pmc/fixedbooleanarray.c"
INTVAL
Parrot_FixedBooleanArray_get_bool(Interp *interp, PMC* pmc)
#line 143 "./src/pmc/fixedbooleanarray.pmc"
{
    return Parrot_FixedBooleanArray_elements(interp, pmc) ? 1 : 0;

}
#line 132 "src/pmc/fixedbooleanarray.c"
INTVAL
Parrot_FixedBooleanArray_get_integer(Interp *interp, PMC* pmc)
#line 169 "./src/pmc/fixedbooleanarray.pmc"
{
    return Parrot_FixedBooleanArray_elements(interp, pmc);

}
#line 140 "src/pmc/fixedbooleanarray.c"
INTVAL
Parrot_FixedBooleanArray_get_integer_keyed(Interp *interp, PMC* pmc, PMC* key)
#line 204 "./src/pmc/fixedbooleanarray.pmc"
{
    /* simple int keys only */
    INTVAL k = key_integer(interp, key);
    return Parrot_FixedBooleanArray_get_integer_keyed_int(interp, pmc, k);

}
#line 150 "src/pmc/fixedbooleanarray.c"
INTVAL
Parrot_FixedBooleanArray_get_integer_keyed_int(Interp *interp, PMC* pmc, INTVAL key)
#line 184 "./src/pmc/fixedbooleanarray.pmc"
{
    Parrot_UInt1 *sd = PMC_data_typed(pmc, Parrot_UInt1 *);

    if (key < 0 || key >= PMC_int_val(pmc))
        real_exception(interp, NULL, E_IndexError,
            "FixedBooleanArray: index out of bounds!");

    return (sd[key/BITS_PER_CHAR] & (1 << (key % BITS_PER_CHAR))) ? 1:0;

}
#line 164 "src/pmc/fixedbooleanarray.c"
FLOATVAL
Parrot_FixedBooleanArray_get_number_keyed(Interp *interp, PMC* pmc, PMC* key)
#line 235 "./src/pmc/fixedbooleanarray.pmc"
{
    INTVAL k = key_integer(interp, key);
    return  VTABLE_get_number_keyed_int(interp, pmc, k);

}
#line 173 "src/pmc/fixedbooleanarray.c"
FLOATVAL
Parrot_FixedBooleanArray_get_number_keyed_int(Interp *interp, PMC* pmc, INTVAL key)
#line 221 "./src/pmc/fixedbooleanarray.pmc"
{
    return (FLOATVAL) VTABLE_get_integer_keyed_int(interp, pmc, key);

}
#line 181 "src/pmc/fixedbooleanarray.c"
PMC*
Parrot_FixedBooleanArray_get_pmc_keyed(Interp *interp, PMC* pmc, PMC* key)
#line 298 "./src/pmc/fixedbooleanarray.pmc"
{
    INTVAL k = key_integer(interp, key);
    return  VTABLE_get_pmc_keyed_int(interp, pmc, k);

}
#line 190 "src/pmc/fixedbooleanarray.c"
PMC*
Parrot_FixedBooleanArray_get_pmc_keyed_int(Interp *interp, PMC* pmc, INTVAL key)
#line 281 "./src/pmc/fixedbooleanarray.pmc"
{
    PMC *ret = pmc_new(interp, enum_class_Boolean);
    INTVAL val =  VTABLE_get_integer_keyed_int(interp, pmc, key);
    VTABLE_set_integer_native(interp, ret, val);
    return ret;

}
#line 201 "src/pmc/fixedbooleanarray.c"
STRING*
Parrot_FixedBooleanArray_get_string_keyed(Interp *interp, PMC* pmc, PMC* key)
#line 265 "./src/pmc/fixedbooleanarray.pmc"
{
    INTVAL k = key_integer(interp, key);
    return  VTABLE_get_string_keyed_int(interp, pmc, k);

}
#line 210 "src/pmc/fixedbooleanarray.c"
STRING*
Parrot_FixedBooleanArray_get_string_keyed_int(Interp *interp, PMC* pmc, INTVAL key)
#line 250 "./src/pmc/fixedbooleanarray.pmc"
{
    PMC *val =  VTABLE_get_pmc_keyed_int(interp, pmc, key);
    return VTABLE_get_string(interp, val);

}
#line 219 "src/pmc/fixedbooleanarray.c"
void
Parrot_FixedBooleanArray_init(Interp *interp, PMC* pmc)
#line 81 "./src/pmc/fixedbooleanarray.pmc"
{
    booleanarray_init(interp, pmc);
    PObj_active_destroy_SET(pmc);

}
#line 228 "src/pmc/fixedbooleanarray.c"
void
Parrot_FixedBooleanArray_morph(Interp *interp, PMC* pmc, INTVAL type)
#line 97 "./src/pmc/fixedbooleanarray.pmc"
{
    Parrot_default_morph(interp, pmc, type);

}
#line 236 "src/pmc/fixedbooleanarray.c"
void
Parrot_FixedBooleanArray_push_integer(Interp *interp, PMC* pmc, INTVAL value)
#line 474 "./src/pmc/fixedbooleanarray.pmc"
{
    INTVAL nextix =  VTABLE_elements(interp, pmc);
     VTABLE_set_integer_keyed_int(interp, pmc, nextix, value);

}
#line 245 "src/pmc/fixedbooleanarray.c"
void
Parrot_FixedBooleanArray_set_integer_keyed(Interp *interp, PMC* pmc, PMC *key, INTVAL value)
#line 357 "./src/pmc/fixedbooleanarray.pmc"
{
    INTVAL k = key_integer(interp, key);
     VTABLE_set_integer_keyed_int(interp, pmc, k, value);

}
#line 254 "src/pmc/fixedbooleanarray.c"
void
Parrot_FixedBooleanArray_set_integer_keyed_int(Interp *interp, PMC* pmc, INTVAL key, INTVAL value)
#line 334 "./src/pmc/fixedbooleanarray.pmc"
{
    Parrot_UInt1 *sd = PMC_data_typed(pmc, Parrot_UInt1 *);

    if (key < 0 || key >= PMC_int_val(pmc))
        real_exception(interp, NULL, E_IndexError,
            "FixedBooleanArray: index out of bounds!");

    if (value)
        sd[key/BITS_PER_CHAR] |= (1 << (key % BITS_PER_CHAR));
    else
        sd[key/BITS_PER_CHAR] &= (~ (1 << (key % BITS_PER_CHAR)));

}
#line 271 "src/pmc/fixedbooleanarray.c"
void
Parrot_FixedBooleanArray_set_integer_native(Interp *interp, PMC* pmc, INTVAL size)
#line 313 "./src/pmc/fixedbooleanarray.pmc"
{
    if (PMC_int_val(pmc) || size < 1)
        real_exception(interp, NULL, E_IndexError,
                "FixedBooleanArray: Can't resize!");

    PMC_int_val(pmc) = size;
    PMC_int_val2(pmc) = (size / BITS_PER_CHAR + 1) * BITS_PER_CHAR;
    PMC_data(pmc) =
        mem_sys_allocate_zeroed(PMC_int_val2(pmc) / BITS_PER_CHAR);

}
#line 286 "src/pmc/fixedbooleanarray.c"
void
Parrot_FixedBooleanArray_set_number_keyed(Interp *interp, PMC* pmc, PMC *key, FLOATVAL value)
#line 388 "./src/pmc/fixedbooleanarray.pmc"
{
    INTVAL k = key_integer(interp, key);
     VTABLE_set_number_keyed_int(interp, pmc, k, value);

}
#line 295 "src/pmc/fixedbooleanarray.c"
void
Parrot_FixedBooleanArray_set_number_keyed_int(Interp *interp, PMC* pmc, INTVAL key, FLOATVAL value)
#line 373 "./src/pmc/fixedbooleanarray.pmc"
{
     VTABLE_set_integer_keyed_int(interp, pmc, key, (value ? 1 : 0));

}
#line 303 "src/pmc/fixedbooleanarray.c"
void
Parrot_FixedBooleanArray_set_pmc_keyed(Interp *interp, PMC* pmc, PMC *key, PMC* value)
#line 457 "./src/pmc/fixedbooleanarray.pmc"
{
    INTVAL k;
    k = key_integer(interp, key);
     VTABLE_set_pmc_keyed_int(interp, pmc, k, value);

}
#line 313 "src/pmc/fixedbooleanarray.c"
void
Parrot_FixedBooleanArray_set_pmc_keyed_int(Interp *interp, PMC* pmc, INTVAL key, PMC* src)
#line 439 "./src/pmc/fixedbooleanarray.pmc"
{
    INTVAL tempInt;

    tempInt = VTABLE_get_integer(interp, src);
     VTABLE_set_integer_keyed_int(interp, pmc, key, tempInt);

}
#line 324 "src/pmc/fixedbooleanarray.c"
void
Parrot_FixedBooleanArray_set_string_keyed(Interp *interp, PMC* pmc, PMC *key, STRING* value)
#line 424 "./src/pmc/fixedbooleanarray.pmc"
{
    INTVAL k = key_integer(interp, key);
     VTABLE_set_string_keyed_int(interp, pmc, k, value);

}
#line 333 "src/pmc/fixedbooleanarray.c"
void
Parrot_FixedBooleanArray_set_string_keyed_int(Interp *interp, PMC* pmc, INTVAL key, STRING* value)
#line 403 "./src/pmc/fixedbooleanarray.pmc"
{
    INTVAL tempInt;
    PMC *tempPMC;

    tempPMC = pmc_new(interp, enum_class_Boolean);
    VTABLE_set_string_native(interp, tempPMC, value);
    tempInt = VTABLE_get_integer(interp, tempPMC);
     VTABLE_set_integer_keyed_int(interp, pmc, key, tempInt);

}
#line 347 "src/pmc/fixedbooleanarray.c"
void
Parrot_FixedBooleanArray_thaw(Interp *interp, PMC* pmc, visit_info *info)
#line 514 "./src/pmc/fixedbooleanarray.pmc"
{
    IMAGE_IO *io = info->image_io;
    Parrot_default_thaw(interp, pmc, info);
    if (info->extra_flags == EXTRA_IS_NULL) {
        INTVAL size =  VTABLE_shift_integer(interp, io);
        STRING * s  =  VTABLE_shift_string(interp, io);
        PMC_int_val(pmc) = size;
        PMC_int_val2(pmc) = s->bufused * BITS_PER_CHAR;
        PMC_data(pmc) = mem_sys_allocate_zeroed(s->bufused);
        mem_sys_memcopy(PMC_data(pmc), s->strstart, s->bufused);
    }

}
#line 364 "src/pmc/fixedbooleanarray.c"
void
Parrot_FixedBooleanArray_nci_fill(Interp *interp, PMC* pmc, INTVAL fill)
#line 538 "./src/pmc/fixedbooleanarray.pmc"
{
    Parrot_UInt1 *sd = PMC_data_typed(pmc, Parrot_UInt1 *);
    INTVAL j;
    j = PMC_int_val(pmc) / BITS_PER_CHAR + 1;
    if (fill)
        memset(sd, 0xff, j);
    else
        memset(sd, 0, j);

}
#line 378 "src/pmc/fixedbooleanarray.c"
void
Parrot_FixedBooleanArray_ro_add_attribute(Interp *interp, PMC* pmc, STRING* name, PMC* type)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "add_attribute() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_add_method(Interp *interp, PMC* pmc, STRING* method_name, PMC* sub_pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "add_method() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_add_parent(Interp *interp, PMC* pmc, PMC* parent)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "add_parent() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_add_role(Interp *interp, PMC* pmc, PMC* role)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "add_role() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_assign_pmc(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "assign_pmc() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_assign_string_native(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "assign_string_native() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_decrement(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "decrement() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_delete_keyed(Interp *interp, PMC* pmc, PMC* key)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "delete_keyed() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_delete_keyed_int(Interp *interp, PMC* pmc, INTVAL key)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "delete_keyed_int() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_delete_keyed_str(Interp *interp, PMC* pmc, STRING* key)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "delete_keyed_str() in read-only instance of FixedBooleanArray");
}
PMC*
Parrot_FixedBooleanArray_ro_find_method(Interp *interp, PMC* pmc, STRING* method_name)
 {
    PMC *const method = Parrot_default_find_method(interp, pmc, method_name);
    if (!PMC_IS_NULL(VTABLE_getprop(interp, method, const_string(interp, "write"))))
        return PMCNULL;
    else
        return method;
}
void
Parrot_FixedBooleanArray_ro_i_absolute(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_absolute() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_i_bitwise_not(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_bitwise_not() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_i_bitwise_nots(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_bitwise_nots() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_i_logical_not(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_logical_not() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_i_neg(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_neg() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_increment(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "increment() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_morph(Interp *interp, PMC* pmc, INTVAL type)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "morph() in read-only instance of FixedBooleanArray");
}
FLOATVAL
Parrot_FixedBooleanArray_ro_pop_float(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "pop_float() in read-only instance of FixedBooleanArray");
    return (FLOATVAL)0;
}
INTVAL
Parrot_FixedBooleanArray_ro_pop_integer(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "pop_integer() in read-only instance of FixedBooleanArray");
    return (INTVAL)0;
}
PMC*
Parrot_FixedBooleanArray_ro_pop_pmc(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "pop_pmc() in read-only instance of FixedBooleanArray");
    return PMCNULL;
}
STRING*
Parrot_FixedBooleanArray_ro_pop_string(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "pop_string() in read-only instance of FixedBooleanArray");
    return (STRING*)0;
}
void
Parrot_FixedBooleanArray_ro_push_float(Interp *interp, PMC* pmc, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "push_float() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_push_integer(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "push_integer() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_push_pmc(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "push_pmc() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_push_string(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "push_string() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_remove_attribute(Interp *interp, PMC* pmc, STRING* name)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "remove_attribute() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_remove_method(Interp *interp, PMC* pmc, STRING* method_name)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "remove_method() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_remove_parent(Interp *interp, PMC* pmc, PMC* parent)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "remove_parent() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_remove_role(Interp *interp, PMC* pmc, PMC* role)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "remove_role() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_set_attr(Interp *interp, PMC* pmc, INTVAL idx, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_attr() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_set_attr_str(Interp *interp, PMC* pmc, STRING* idx, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_attr_str() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_set_bignum_int(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_bignum_int() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_set_bignum_num(Interp *interp, PMC* pmc, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_bignum_num() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_set_bignum_str(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_bignum_str() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_set_bool(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_bool() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_set_integer_keyed(Interp *interp, PMC* pmc, PMC* key, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_keyed() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_set_integer_keyed_int(Interp *interp, PMC* pmc, INTVAL key, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_keyed_int() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_set_integer_keyed_str(Interp *interp, PMC* pmc, STRING* key, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_keyed_str() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_set_integer_native(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_native() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_set_integer_same(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_same() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_set_number_keyed(Interp *interp, PMC* pmc, PMC* key, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_keyed() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_set_number_keyed_int(Interp *interp, PMC* pmc, INTVAL key, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_keyed_int() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_set_number_keyed_str(Interp *interp, PMC* pmc, STRING* key, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_keyed_str() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_set_number_native(Interp *interp, PMC* pmc, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_native() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_set_number_same(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_same() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_set_pmc(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pmc() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_set_pmc_keyed(Interp *interp, PMC* pmc, PMC* key, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pmc_keyed() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_set_pmc_keyed_int(Interp *interp, PMC* pmc, INTVAL key, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_int() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_set_pmc_keyed_str(Interp *interp, PMC* pmc, STRING* key, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_str() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_set_pointer(Interp *interp, PMC* pmc, void* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pointer() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_set_pointer_keyed(Interp *interp, PMC* pmc, PMC* key, void* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pointer_keyed() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_set_pointer_keyed_int(Interp *interp, PMC* pmc, INTVAL key, void* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_int() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_set_pointer_keyed_str(Interp *interp, PMC* pmc, STRING* key, void* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_str() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_set_string_keyed(Interp *interp, PMC* pmc, PMC* key, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_keyed() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_set_string_keyed_int(Interp *interp, PMC* pmc, INTVAL key, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_keyed_int() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_set_string_keyed_str(Interp *interp, PMC* pmc, STRING* key, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_keyed_str() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_set_string_native(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_native() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_set_string_same(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_same() in read-only instance of FixedBooleanArray");
}
FLOATVAL
Parrot_FixedBooleanArray_ro_shift_float(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "shift_float() in read-only instance of FixedBooleanArray");
    return (FLOATVAL)0;
}
INTVAL
Parrot_FixedBooleanArray_ro_shift_integer(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "shift_integer() in read-only instance of FixedBooleanArray");
    return (INTVAL)0;
}
PMC*
Parrot_FixedBooleanArray_ro_shift_pmc(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "shift_pmc() in read-only instance of FixedBooleanArray");
    return PMCNULL;
}
STRING*
Parrot_FixedBooleanArray_ro_shift_string(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "shift_string() in read-only instance of FixedBooleanArray");
    return (STRING*)0;
}
void
Parrot_FixedBooleanArray_ro_splice(Interp *interp, PMC* pmc, PMC* value, INTVAL offset, INTVAL count)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "splice() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_thaw(Interp *interp, PMC* pmc, visit_info* info)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "thaw() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_thawfinish(Interp *interp, PMC* pmc, visit_info* info)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "thawfinish() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_unshift_float(Interp *interp, PMC* pmc, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "unshift_float() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_unshift_integer(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "unshift_integer() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_unshift_pmc(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "unshift_pmc() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_unshift_string(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "unshift_string() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_class_init(Parrot_Interp interp, int entry, int pass)
{
    const VTABLE temp_base_vtable = {
        NULL, /* namespace */
        enum_class_FixedBooleanArray, /* base_type */
        NULL, /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_HAS_READONLY_FLAG, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        NULL,   /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_default_add_attribute,
        Parrot_default_add_method,
        Parrot_default_add_parent,
        Parrot_default_add_role,
        Parrot_default_assign_pmc,
        Parrot_default_assign_string_native,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_can,
        Parrot_default_class_type,
        Parrot_FixedBooleanArray_clone,
        Parrot_default_clone_pmc,
        Parrot_default_decrement,
        Parrot_default_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_default_delete_keyed,
        Parrot_default_delete_keyed_int,
        Parrot_default_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_FixedBooleanArray_destroy,
        Parrot_default_does,
        Parrot_FixedBooleanArray_elements,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_default_find_method,
        Parrot_FixedBooleanArray_freeze,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_FixedBooleanArray_get_bool,
        Parrot_default_get_class,
        Parrot_FixedBooleanArray_get_integer,
        Parrot_FixedBooleanArray_get_integer_keyed,
        Parrot_FixedBooleanArray_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_iter,
        Parrot_default_get_number,
        Parrot_FixedBooleanArray_get_number_keyed,
        Parrot_FixedBooleanArray_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_FixedBooleanArray_get_pmc_keyed,
        Parrot_FixedBooleanArray_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_default_get_repr,
        Parrot_default_get_string,
        Parrot_FixedBooleanArray_get_string_keyed,
        Parrot_FixedBooleanArray_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_default_hash,
        Parrot_default_i_absolute,
        Parrot_default_i_bitwise_not,
        Parrot_default_i_bitwise_nots,
        Parrot_default_i_logical_not,
        Parrot_default_i_neg,
        Parrot_default_increment,
        Parrot_FixedBooleanArray_init,
        Parrot_default_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_default_instantiate,
        Parrot_default_invoke,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_logical_not,
        Parrot_default_mark,
        Parrot_FixedBooleanArray_morph,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_new_from_string,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_pmc_namespace,
        Parrot_default_pop_float,
        Parrot_default_pop_integer,
        Parrot_default_pop_pmc,
        Parrot_default_pop_string,
        Parrot_default_push_float,
        Parrot_FixedBooleanArray_push_integer,
        Parrot_default_push_pmc,
        Parrot_default_push_string,
        Parrot_default_remove_attribute,
        Parrot_default_remove_method,
        Parrot_default_remove_parent,
        Parrot_default_remove_role,
        Parrot_default_set_attr,
        Parrot_default_set_attr_str,
        Parrot_default_set_bignum_int,
        Parrot_default_set_bignum_num,
        Parrot_default_set_bignum_str,
        Parrot_default_set_bool,
        Parrot_FixedBooleanArray_set_integer_keyed,
        Parrot_FixedBooleanArray_set_integer_keyed_int,
        Parrot_default_set_integer_keyed_str,
        Parrot_FixedBooleanArray_set_integer_native,
        Parrot_default_set_integer_same,
        Parrot_FixedBooleanArray_set_number_keyed,
        Parrot_FixedBooleanArray_set_number_keyed_int,
        Parrot_default_set_number_keyed_str,
        Parrot_default_set_number_native,
        Parrot_default_set_number_same,
        Parrot_default_set_pmc,
        Parrot_FixedBooleanArray_set_pmc_keyed,
        Parrot_FixedBooleanArray_set_pmc_keyed_int,
        Parrot_default_set_pmc_keyed_str,
        Parrot_default_set_pointer,
        Parrot_default_set_pointer_keyed,
        Parrot_default_set_pointer_keyed_int,
        Parrot_default_set_pointer_keyed_str,
        Parrot_FixedBooleanArray_set_string_keyed,
        Parrot_FixedBooleanArray_set_string_keyed_int,
        Parrot_default_set_string_keyed_str,
        Parrot_default_set_string_native,
        Parrot_default_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_default_shift_float,
        Parrot_default_shift_integer,
        Parrot_default_shift_pmc,
        Parrot_default_shift_string,
        Parrot_default_slice,
        Parrot_default_splice,
        Parrot_default_subclass,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtype,
        Parrot_FixedBooleanArray_thaw,
        Parrot_default_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_type_keyed_int,
        Parrot_default_type_keyed_str,
        Parrot_default_unshift_float,
        Parrot_default_unshift_integer,
        Parrot_default_unshift_pmc,
        Parrot_default_unshift_string,
        Parrot_default_visit
    };

    const VTABLE temp_ro_vtable = {
        NULL, /* namespace */
        enum_class_FixedBooleanArray, /* base_type */
        NULL, /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_IS_READONLY_FLAG, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        NULL,   /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_FixedBooleanArray_ro_add_attribute,
        Parrot_FixedBooleanArray_ro_add_method,
        Parrot_FixedBooleanArray_ro_add_parent,
        Parrot_FixedBooleanArray_ro_add_role,
        Parrot_FixedBooleanArray_ro_assign_pmc,
        Parrot_FixedBooleanArray_ro_assign_string_native,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_can,
        Parrot_default_class_type,
        Parrot_FixedBooleanArray_clone,
        Parrot_default_clone_pmc,
        Parrot_FixedBooleanArray_ro_decrement,
        Parrot_default_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_FixedBooleanArray_ro_delete_keyed,
        Parrot_FixedBooleanArray_ro_delete_keyed_int,
        Parrot_FixedBooleanArray_ro_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_FixedBooleanArray_destroy,
        Parrot_default_does,
        Parrot_FixedBooleanArray_elements,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_FixedBooleanArray_ro_find_method,
        Parrot_FixedBooleanArray_freeze,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_FixedBooleanArray_get_bool,
        Parrot_default_get_class,
        Parrot_FixedBooleanArray_get_integer,
        Parrot_FixedBooleanArray_get_integer_keyed,
        Parrot_FixedBooleanArray_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_iter,
        Parrot_default_get_number,
        Parrot_FixedBooleanArray_get_number_keyed,
        Parrot_FixedBooleanArray_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_FixedBooleanArray_get_pmc_keyed,
        Parrot_FixedBooleanArray_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_default_get_repr,
        Parrot_default_get_string,
        Parrot_FixedBooleanArray_get_string_keyed,
        Parrot_FixedBooleanArray_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_default_hash,
        Parrot_FixedBooleanArray_ro_i_absolute,
        Parrot_FixedBooleanArray_ro_i_bitwise_not,
        Parrot_FixedBooleanArray_ro_i_bitwise_nots,
        Parrot_FixedBooleanArray_ro_i_logical_not,
        Parrot_FixedBooleanArray_ro_i_neg,
        Parrot_FixedBooleanArray_ro_increment,
        Parrot_FixedBooleanArray_init,
        Parrot_default_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_default_instantiate,
        Parrot_default_invoke,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_logical_not,
        Parrot_default_mark,
        Parrot_FixedBooleanArray_ro_morph,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_new_from_string,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_pmc_namespace,
        Parrot_FixedBooleanArray_ro_pop_float,
        Parrot_FixedBooleanArray_ro_pop_integer,
        Parrot_FixedBooleanArray_ro_pop_pmc,
        Parrot_FixedBooleanArray_ro_pop_string,
        Parrot_FixedBooleanArray_ro_push_float,
        Parrot_FixedBooleanArray_ro_push_integer,
        Parrot_FixedBooleanArray_ro_push_pmc,
        Parrot_FixedBooleanArray_ro_push_string,
        Parrot_FixedBooleanArray_ro_remove_attribute,
        Parrot_FixedBooleanArray_ro_remove_method,
        Parrot_FixedBooleanArray_ro_remove_parent,
        Parrot_FixedBooleanArray_ro_remove_role,
        Parrot_FixedBooleanArray_ro_set_attr,
        Parrot_FixedBooleanArray_ro_set_attr_str,
        Parrot_FixedBooleanArray_ro_set_bignum_int,
        Parrot_FixedBooleanArray_ro_set_bignum_num,
        Parrot_FixedBooleanArray_ro_set_bignum_str,
        Parrot_FixedBooleanArray_ro_set_bool,
        Parrot_FixedBooleanArray_ro_set_integer_keyed,
        Parrot_FixedBooleanArray_ro_set_integer_keyed_int,
        Parrot_FixedBooleanArray_ro_set_integer_keyed_str,
        Parrot_FixedBooleanArray_ro_set_integer_native,
        Parrot_FixedBooleanArray_ro_set_integer_same,
        Parrot_FixedBooleanArray_ro_set_number_keyed,
        Parrot_FixedBooleanArray_ro_set_number_keyed_int,
        Parrot_FixedBooleanArray_ro_set_number_keyed_str,
        Parrot_FixedBooleanArray_ro_set_number_native,
        Parrot_FixedBooleanArray_ro_set_number_same,
        Parrot_FixedBooleanArray_ro_set_pmc,
        Parrot_FixedBooleanArray_ro_set_pmc_keyed,
        Parrot_FixedBooleanArray_ro_set_pmc_keyed_int,
        Parrot_FixedBooleanArray_ro_set_pmc_keyed_str,
        Parrot_FixedBooleanArray_ro_set_pointer,
        Parrot_FixedBooleanArray_ro_set_pointer_keyed,
        Parrot_FixedBooleanArray_ro_set_pointer_keyed_int,
        Parrot_FixedBooleanArray_ro_set_pointer_keyed_str,
        Parrot_FixedBooleanArray_ro_set_string_keyed,
        Parrot_FixedBooleanArray_ro_set_string_keyed_int,
        Parrot_FixedBooleanArray_ro_set_string_keyed_str,
        Parrot_FixedBooleanArray_ro_set_string_native,
        Parrot_FixedBooleanArray_ro_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_FixedBooleanArray_ro_shift_float,
        Parrot_FixedBooleanArray_ro_shift_integer,
        Parrot_FixedBooleanArray_ro_shift_pmc,
        Parrot_FixedBooleanArray_ro_shift_string,
        Parrot_default_slice,
        Parrot_FixedBooleanArray_ro_splice,
        Parrot_default_subclass,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtype,
        Parrot_FixedBooleanArray_ro_thaw,
        Parrot_FixedBooleanArray_ro_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_type_keyed_int,
        Parrot_default_type_keyed_str,
        Parrot_FixedBooleanArray_ro_unshift_float,
        Parrot_FixedBooleanArray_ro_unshift_integer,
        Parrot_FixedBooleanArray_ro_unshift_pmc,
        Parrot_FixedBooleanArray_ro_unshift_string,
        Parrot_default_visit
    };
    if (pass == 0) {
        /*
         * create vtable - clone it - we have to set a few items
         */
        VTABLE *vt_clone =
            Parrot_clone_vtable(interp, &temp_base_vtable);
        VTABLE *vt_ro_clone =
            Parrot_clone_vtable(interp, &temp_ro_vtable);
        vt_clone->whoami = CONST_STRING(interp, "FixedBooleanArray");
        vt_clone->isa_str = CONST_STRING(interp, "FixedBooleanArray");
        vt_clone->does_str = CONST_STRING(interp, "array");
        vt_ro_clone->base_type = entry;
        vt_ro_clone->whoami = vt_clone->whoami;
        vt_ro_clone->isa_str = vt_clone->isa_str;
        vt_ro_clone->does_str = vt_clone->does_str;
        vt_clone->ro_variant_vtable = vt_ro_clone;
        vt_ro_clone->ro_variant_vtable = vt_clone;
        interp->vtables[entry] = vt_clone;
    }
    else { /* pass */
        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        /* create PMC Proxy object */
        Parrot_create_pmc_proxy(interp, entry);
        register_nci_method(interp, entry,
                F2DPTR(Parrot_FixedBooleanArray_nci_fill),
                "fill", "vJOI");
        /* class_init */
        {
        }
    } /* pass */
} /* Parrot_FixedBooleanArray_class_init */


/*

=back

=head1 SEE ALSO

F<docs/pdds/pdd17_basic_types.pod>.

=head1 HISTORY

Initial version 2004.06.11 by Matt Fowles

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
