/*
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/fixedfloatarray.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

#line 1 "./src/pmc/fixedfloatarray.pmc"
/*
Copyright (C) 2001-2003, The Perl Foundation.
$Id: fixedfloatarray.pmc 16275 2006-12-28 01:20:44Z particle $

=head1 NAME

src/pmc/fixedfloatarray.pmc - fixed size array for floating point numbers only

=head1 DESCRIPTION

This class, FixedFloatArray, implements an array of fixed size, which
stored FLOATVALs, it uses Float PMCs to do all necessary conversions

=head2 Functions

=over 4

=cut

*/

#include "parrot/parrot.h"

#line 36 "src/pmc/fixedfloatarray.c"
#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_fixedfloatarray.h"
#include "pmc_default.h"
#include "fixedfloatarray.str"

PMC*
Parrot_FixedFloatArray_clone(Interp *interp, PMC* pmc)
#line 89 "./src/pmc/fixedfloatarray.pmc"
{
    INTVAL size;
    PMC * dest = pmc_new(interp, pmc->vtable->base_type);

    if (!PMC_data(pmc))
        return dest;
    size = PMC_int_val(pmc);
    PMC_int_val(dest) = size;

    PMC_data(dest) = mem_sys_allocate(size * sizeof (FLOATVAL));
    mem_sys_memcopy(PMC_data(dest), PMC_data(pmc), size*sizeof (FLOATVAL));
    PObj_active_destroy_SET(dest);
    return dest;

}
#line 62 "src/pmc/fixedfloatarray.c"
void
Parrot_FixedFloatArray_destroy(Interp *interp, PMC* pmc)
#line 72 "./src/pmc/fixedfloatarray.pmc"
{
    if (PMC_data(pmc))
        mem_sys_free(PMC_data(pmc));
    PMC_data(pmc) = NULL;
    PMC_int_val(pmc) = 0;

}
#line 73 "src/pmc/fixedfloatarray.c"
INTVAL
Parrot_FixedFloatArray_elements(Interp *interp, PMC* pmc)
#line 127 "./src/pmc/fixedfloatarray.pmc"
{
    return PMC_int_val(pmc);

}
#line 81 "src/pmc/fixedfloatarray.c"
INTVAL
Parrot_FixedFloatArray_get_bool(Interp *interp, PMC* pmc)
#line 114 "./src/pmc/fixedfloatarray.pmc"
{
    INTVAL size = Parrot_FixedFloatArray_elements(interp, pmc);
    return (INTVAL)(size != 0);

}
#line 90 "src/pmc/fixedfloatarray.c"
INTVAL
Parrot_FixedFloatArray_get_integer(Interp *interp, PMC* pmc)
#line 141 "./src/pmc/fixedfloatarray.pmc"
{
    return Parrot_FixedFloatArray_elements(interp, pmc);

}
#line 98 "src/pmc/fixedfloatarray.c"
INTVAL
Parrot_FixedFloatArray_get_integer_keyed(Interp *interp, PMC* pmc, PMC* key)
#line 170 "./src/pmc/fixedfloatarray.pmc"
{
    /* simple int keys only */
    INTVAL k = key_integer(interp, key);
    return  VTABLE_get_integer_keyed_int(interp, pmc, k);

}
#line 108 "src/pmc/fixedfloatarray.c"
INTVAL
Parrot_FixedFloatArray_get_integer_keyed_int(Interp *interp, PMC* pmc, INTVAL key)
#line 156 "./src/pmc/fixedfloatarray.pmc"
{
    return (INTVAL) VTABLE_get_number_keyed_int(interp, pmc, key);

}
#line 116 "src/pmc/fixedfloatarray.c"
FLOATVAL
Parrot_FixedFloatArray_get_number_keyed(Interp *interp, PMC* pmc, PMC* key)
#line 207 "./src/pmc/fixedfloatarray.pmc"
{
    INTVAL k = key_integer(interp, key);
    return  VTABLE_get_number_keyed_int(interp, pmc, k);

}
#line 125 "src/pmc/fixedfloatarray.c"
FLOATVAL
Parrot_FixedFloatArray_get_number_keyed_int(Interp *interp, PMC* pmc, INTVAL key)
#line 187 "./src/pmc/fixedfloatarray.pmc"
{
    FLOATVAL *data;
    if (key < 0 || key >= PMC_int_val(pmc))
        real_exception(interp, NULL, E_IndexError,
            "FixedFloatArray: index out of bounds!");

    data = (FLOATVAL *)PMC_data(pmc);
    return data[key];

}
#line 139 "src/pmc/fixedfloatarray.c"
PMC*
Parrot_FixedFloatArray_get_pmc_keyed(Interp *interp, PMC* pmc, PMC* key)
#line 274 "./src/pmc/fixedfloatarray.pmc"
{
    INTVAL k = key_integer(interp, key);
    return  VTABLE_get_pmc_keyed_int(interp, pmc, k);

}
#line 148 "src/pmc/fixedfloatarray.c"
PMC*
Parrot_FixedFloatArray_get_pmc_keyed_int(Interp *interp, PMC* pmc, INTVAL key)
#line 254 "./src/pmc/fixedfloatarray.pmc"
{
    PMC *ret;
    FLOATVAL val;

    ret = pmc_new(interp, enum_class_Float);
    val =  VTABLE_get_number_keyed_int(interp, pmc, key);
    VTABLE_set_number_native(interp, ret, val);
    return ret;

}
#line 162 "src/pmc/fixedfloatarray.c"
STRING*
Parrot_FixedFloatArray_get_string_keyed(Interp *interp, PMC* pmc, PMC* key)
#line 238 "./src/pmc/fixedfloatarray.pmc"
{
    INTVAL k = key_integer(interp, key);
    return  VTABLE_get_string_keyed_int(interp, pmc, k);

}
#line 171 "src/pmc/fixedfloatarray.c"
STRING*
Parrot_FixedFloatArray_get_string_keyed_int(Interp *interp, PMC* pmc, INTVAL key)
#line 222 "./src/pmc/fixedfloatarray.pmc"
{
    PMC *temp;
    temp =  VTABLE_get_pmc_keyed_int(interp, pmc, key);
    return VTABLE_get_string(interp, temp);

}
#line 181 "src/pmc/fixedfloatarray.c"
void
Parrot_FixedFloatArray_init(Interp *interp, PMC* pmc)
#line 42 "./src/pmc/fixedfloatarray.pmc"
{
    PMC_int_val(pmc) = 0;
    PMC_data(pmc) = NULL;

}
#line 190 "src/pmc/fixedfloatarray.c"
void
Parrot_FixedFloatArray_morph(Interp *interp, PMC* pmc, INTVAL type)
#line 57 "./src/pmc/fixedfloatarray.pmc"
{
    Parrot_default_morph(interp, pmc, type);

}
#line 198 "src/pmc/fixedfloatarray.c"
void
Parrot_FixedFloatArray_set_integer_keyed(Interp *interp, PMC* pmc, PMC *key, INTVAL value)
#line 322 "./src/pmc/fixedfloatarray.pmc"
{
    INTVAL k;
    k = key_integer(interp, key);
     VTABLE_set_integer_keyed_int(interp, pmc, k, value);

}
#line 208 "src/pmc/fixedfloatarray.c"
void
Parrot_FixedFloatArray_set_integer_keyed_int(Interp *interp, PMC* pmc, INTVAL key, INTVAL value)
#line 308 "./src/pmc/fixedfloatarray.pmc"
{
     VTABLE_set_number_keyed_int(interp, pmc, key, (FLOATVAL)value);

}
#line 216 "src/pmc/fixedfloatarray.c"
void
Parrot_FixedFloatArray_set_integer_native(Interp *interp, PMC* pmc, INTVAL size)
#line 289 "./src/pmc/fixedfloatarray.pmc"
{
    if (PMC_int_val(pmc) || size < 1)
        real_exception(interp, NULL, E_IndexError,
                "FixedFloatArray: Can't resize!");
    PMC_int_val(pmc) = size;
    PMC_data(pmc) = mem_sys_allocate(size * sizeof (FLOATVAL));
    PObj_active_destroy_SET(pmc);

}
#line 229 "src/pmc/fixedfloatarray.c"
void
Parrot_FixedFloatArray_set_number_keyed(Interp *interp, PMC* pmc, PMC *key, FLOATVAL value)
#line 360 "./src/pmc/fixedfloatarray.pmc"
{
    INTVAL k;
    k = key_integer(interp, key);
     VTABLE_set_number_keyed_int(interp, pmc, k, value);

}
#line 239 "src/pmc/fixedfloatarray.c"
void
Parrot_FixedFloatArray_set_number_keyed_int(Interp *interp, PMC* pmc, INTVAL key, FLOATVAL value)
#line 339 "./src/pmc/fixedfloatarray.pmc"
{
    FLOATVAL *data;
    if (key < 0 || key >= PMC_int_val(pmc))
        real_exception(interp, NULL, E_IndexError,
            "FixedFloatArray: index out of bounds!");

    data = (FLOATVAL*)PMC_data(pmc);
    data[key] = value;

}
#line 253 "src/pmc/fixedfloatarray.c"
void
Parrot_FixedFloatArray_set_pmc_keyed(Interp *interp, PMC* pmc, PMC *key, PMC* value)
#line 430 "./src/pmc/fixedfloatarray.pmc"
{
    INTVAL k;
    k = key_integer(interp, key);
     VTABLE_set_pmc_keyed_int(interp, pmc, k, value);

}
#line 263 "src/pmc/fixedfloatarray.c"
void
Parrot_FixedFloatArray_set_pmc_keyed_int(Interp *interp, PMC* pmc, INTVAL key, PMC* src)
#line 413 "./src/pmc/fixedfloatarray.pmc"
{
    FLOATVAL tempNum;
    tempNum = VTABLE_get_number(interp, src);
     VTABLE_set_number_keyed_int(interp, pmc, key, tempNum);

}
#line 273 "src/pmc/fixedfloatarray.c"
void
Parrot_FixedFloatArray_set_string_keyed(Interp *interp, PMC* pmc, PMC *key, STRING* value)
#line 397 "./src/pmc/fixedfloatarray.pmc"
{
    INTVAL k;
    k = key_integer(interp, key);
     VTABLE_set_string_keyed_int(interp, pmc, k, value);

}
#line 283 "src/pmc/fixedfloatarray.c"
void
Parrot_FixedFloatArray_set_string_keyed_int(Interp *interp, PMC* pmc, INTVAL key, STRING* value)
#line 376 "./src/pmc/fixedfloatarray.pmc"
{
    FLOATVAL tempNum;
    PMC *tempPMC;

    tempPMC = pmc_new(interp, enum_class_Float);
    VTABLE_set_string_native(interp, tempPMC, value);
    tempNum = VTABLE_get_number(interp, tempPMC);
     VTABLE_set_number_keyed_int(interp, pmc, key, tempNum);

}
#line 297 "src/pmc/fixedfloatarray.c"
void
Parrot_FixedFloatArray_ro_add_attribute(Interp *interp, PMC* pmc, STRING* name, PMC* type)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "add_attribute() in read-only instance of FixedFloatArray");
}
void
Parrot_FixedFloatArray_ro_add_method(Interp *interp, PMC* pmc, STRING* method_name, PMC* sub_pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "add_method() in read-only instance of FixedFloatArray");
}
void
Parrot_FixedFloatArray_ro_add_parent(Interp *interp, PMC* pmc, PMC* parent)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "add_parent() in read-only instance of FixedFloatArray");
}
void
Parrot_FixedFloatArray_ro_add_role(Interp *interp, PMC* pmc, PMC* role)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "add_role() in read-only instance of FixedFloatArray");
}
void
Parrot_FixedFloatArray_ro_assign_pmc(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "assign_pmc() in read-only instance of FixedFloatArray");
}
void
Parrot_FixedFloatArray_ro_assign_string_native(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "assign_string_native() in read-only instance of FixedFloatArray");
}
void
Parrot_FixedFloatArray_ro_decrement(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "decrement() in read-only instance of FixedFloatArray");
}
void
Parrot_FixedFloatArray_ro_delete_keyed(Interp *interp, PMC* pmc, PMC* key)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "delete_keyed() in read-only instance of FixedFloatArray");
}
void
Parrot_FixedFloatArray_ro_delete_keyed_int(Interp *interp, PMC* pmc, INTVAL key)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "delete_keyed_int() in read-only instance of FixedFloatArray");
}
void
Parrot_FixedFloatArray_ro_delete_keyed_str(Interp *interp, PMC* pmc, STRING* key)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "delete_keyed_str() in read-only instance of FixedFloatArray");
}
PMC*
Parrot_FixedFloatArray_ro_find_method(Interp *interp, PMC* pmc, STRING* method_name)
 {
    PMC *const method = Parrot_default_find_method(interp, pmc, method_name);
    if (!PMC_IS_NULL(VTABLE_getprop(interp, method, const_string(interp, "write"))))
        return PMCNULL;
    else
        return method;
}
void
Parrot_FixedFloatArray_ro_i_absolute(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_absolute() in read-only instance of FixedFloatArray");
}
void
Parrot_FixedFloatArray_ro_i_bitwise_not(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_bitwise_not() in read-only instance of FixedFloatArray");
}
void
Parrot_FixedFloatArray_ro_i_bitwise_nots(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_bitwise_nots() in read-only instance of FixedFloatArray");
}
void
Parrot_FixedFloatArray_ro_i_logical_not(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_logical_not() in read-only instance of FixedFloatArray");
}
void
Parrot_FixedFloatArray_ro_i_neg(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_neg() in read-only instance of FixedFloatArray");
}
void
Parrot_FixedFloatArray_ro_increment(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "increment() in read-only instance of FixedFloatArray");
}
void
Parrot_FixedFloatArray_ro_morph(Interp *interp, PMC* pmc, INTVAL type)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "morph() in read-only instance of FixedFloatArray");
}
FLOATVAL
Parrot_FixedFloatArray_ro_pop_float(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "pop_float() in read-only instance of FixedFloatArray");
    return (FLOATVAL)0;
}
INTVAL
Parrot_FixedFloatArray_ro_pop_integer(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "pop_integer() in read-only instance of FixedFloatArray");
    return (INTVAL)0;
}
PMC*
Parrot_FixedFloatArray_ro_pop_pmc(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "pop_pmc() in read-only instance of FixedFloatArray");
    return PMCNULL;
}
STRING*
Parrot_FixedFloatArray_ro_pop_string(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "pop_string() in read-only instance of FixedFloatArray");
    return (STRING*)0;
}
void
Parrot_FixedFloatArray_ro_push_float(Interp *interp, PMC* pmc, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "push_float() in read-only instance of FixedFloatArray");
}
void
Parrot_FixedFloatArray_ro_push_integer(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "push_integer() in read-only instance of FixedFloatArray");
}
void
Parrot_FixedFloatArray_ro_push_pmc(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "push_pmc() in read-only instance of FixedFloatArray");
}
void
Parrot_FixedFloatArray_ro_push_string(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "push_string() in read-only instance of FixedFloatArray");
}
void
Parrot_FixedFloatArray_ro_remove_attribute(Interp *interp, PMC* pmc, STRING* name)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "remove_attribute() in read-only instance of FixedFloatArray");
}
void
Parrot_FixedFloatArray_ro_remove_method(Interp *interp, PMC* pmc, STRING* method_name)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "remove_method() in read-only instance of FixedFloatArray");
}
void
Parrot_FixedFloatArray_ro_remove_parent(Interp *interp, PMC* pmc, PMC* parent)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "remove_parent() in read-only instance of FixedFloatArray");
}
void
Parrot_FixedFloatArray_ro_remove_role(Interp *interp, PMC* pmc, PMC* role)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "remove_role() in read-only instance of FixedFloatArray");
}
void
Parrot_FixedFloatArray_ro_set_attr(Interp *interp, PMC* pmc, INTVAL idx, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_attr() in read-only instance of FixedFloatArray");
}
void
Parrot_FixedFloatArray_ro_set_attr_str(Interp *interp, PMC* pmc, STRING* idx, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_attr_str() in read-only instance of FixedFloatArray");
}
void
Parrot_FixedFloatArray_ro_set_bignum_int(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_bignum_int() in read-only instance of FixedFloatArray");
}
void
Parrot_FixedFloatArray_ro_set_bignum_num(Interp *interp, PMC* pmc, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_bignum_num() in read-only instance of FixedFloatArray");
}
void
Parrot_FixedFloatArray_ro_set_bignum_str(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_bignum_str() in read-only instance of FixedFloatArray");
}
void
Parrot_FixedFloatArray_ro_set_bool(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_bool() in read-only instance of FixedFloatArray");
}
void
Parrot_FixedFloatArray_ro_set_integer_keyed(Interp *interp, PMC* pmc, PMC* key, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_keyed() in read-only instance of FixedFloatArray");
}
void
Parrot_FixedFloatArray_ro_set_integer_keyed_int(Interp *interp, PMC* pmc, INTVAL key, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_keyed_int() in read-only instance of FixedFloatArray");
}
void
Parrot_FixedFloatArray_ro_set_integer_keyed_str(Interp *interp, PMC* pmc, STRING* key, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_keyed_str() in read-only instance of FixedFloatArray");
}
void
Parrot_FixedFloatArray_ro_set_integer_native(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_native() in read-only instance of FixedFloatArray");
}
void
Parrot_FixedFloatArray_ro_set_integer_same(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_same() in read-only instance of FixedFloatArray");
}
void
Parrot_FixedFloatArray_ro_set_number_keyed(Interp *interp, PMC* pmc, PMC* key, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_keyed() in read-only instance of FixedFloatArray");
}
void
Parrot_FixedFloatArray_ro_set_number_keyed_int(Interp *interp, PMC* pmc, INTVAL key, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_keyed_int() in read-only instance of FixedFloatArray");
}
void
Parrot_FixedFloatArray_ro_set_number_keyed_str(Interp *interp, PMC* pmc, STRING* key, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_keyed_str() in read-only instance of FixedFloatArray");
}
void
Parrot_FixedFloatArray_ro_set_number_native(Interp *interp, PMC* pmc, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_native() in read-only instance of FixedFloatArray");
}
void
Parrot_FixedFloatArray_ro_set_number_same(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_same() in read-only instance of FixedFloatArray");
}
void
Parrot_FixedFloatArray_ro_set_pmc(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pmc() in read-only instance of FixedFloatArray");
}
void
Parrot_FixedFloatArray_ro_set_pmc_keyed(Interp *interp, PMC* pmc, PMC* key, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pmc_keyed() in read-only instance of FixedFloatArray");
}
void
Parrot_FixedFloatArray_ro_set_pmc_keyed_int(Interp *interp, PMC* pmc, INTVAL key, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_int() in read-only instance of FixedFloatArray");
}
void
Parrot_FixedFloatArray_ro_set_pmc_keyed_str(Interp *interp, PMC* pmc, STRING* key, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_str() in read-only instance of FixedFloatArray");
}
void
Parrot_FixedFloatArray_ro_set_pointer(Interp *interp, PMC* pmc, void* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pointer() in read-only instance of FixedFloatArray");
}
void
Parrot_FixedFloatArray_ro_set_pointer_keyed(Interp *interp, PMC* pmc, PMC* key, void* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pointer_keyed() in read-only instance of FixedFloatArray");
}
void
Parrot_FixedFloatArray_ro_set_pointer_keyed_int(Interp *interp, PMC* pmc, INTVAL key, void* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_int() in read-only instance of FixedFloatArray");
}
void
Parrot_FixedFloatArray_ro_set_pointer_keyed_str(Interp *interp, PMC* pmc, STRING* key, void* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_str() in read-only instance of FixedFloatArray");
}
void
Parrot_FixedFloatArray_ro_set_string_keyed(Interp *interp, PMC* pmc, PMC* key, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_keyed() in read-only instance of FixedFloatArray");
}
void
Parrot_FixedFloatArray_ro_set_string_keyed_int(Interp *interp, PMC* pmc, INTVAL key, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_keyed_int() in read-only instance of FixedFloatArray");
}
void
Parrot_FixedFloatArray_ro_set_string_keyed_str(Interp *interp, PMC* pmc, STRING* key, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_keyed_str() in read-only instance of FixedFloatArray");
}
void
Parrot_FixedFloatArray_ro_set_string_native(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_native() in read-only instance of FixedFloatArray");
}
void
Parrot_FixedFloatArray_ro_set_string_same(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_same() in read-only instance of FixedFloatArray");
}
FLOATVAL
Parrot_FixedFloatArray_ro_shift_float(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "shift_float() in read-only instance of FixedFloatArray");
    return (FLOATVAL)0;
}
INTVAL
Parrot_FixedFloatArray_ro_shift_integer(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "shift_integer() in read-only instance of FixedFloatArray");
    return (INTVAL)0;
}
PMC*
Parrot_FixedFloatArray_ro_shift_pmc(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "shift_pmc() in read-only instance of FixedFloatArray");
    return PMCNULL;
}
STRING*
Parrot_FixedFloatArray_ro_shift_string(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "shift_string() in read-only instance of FixedFloatArray");
    return (STRING*)0;
}
void
Parrot_FixedFloatArray_ro_splice(Interp *interp, PMC* pmc, PMC* value, INTVAL offset, INTVAL count)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "splice() in read-only instance of FixedFloatArray");
}
void
Parrot_FixedFloatArray_ro_thaw(Interp *interp, PMC* pmc, visit_info* info)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "thaw() in read-only instance of FixedFloatArray");
}
void
Parrot_FixedFloatArray_ro_thawfinish(Interp *interp, PMC* pmc, visit_info* info)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "thawfinish() in read-only instance of FixedFloatArray");
}
void
Parrot_FixedFloatArray_ro_unshift_float(Interp *interp, PMC* pmc, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "unshift_float() in read-only instance of FixedFloatArray");
}
void
Parrot_FixedFloatArray_ro_unshift_integer(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "unshift_integer() in read-only instance of FixedFloatArray");
}
void
Parrot_FixedFloatArray_ro_unshift_pmc(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "unshift_pmc() in read-only instance of FixedFloatArray");
}
void
Parrot_FixedFloatArray_ro_unshift_string(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "unshift_string() in read-only instance of FixedFloatArray");
}
void
Parrot_FixedFloatArray_class_init(Parrot_Interp interp, int entry, int pass)
{
    const VTABLE temp_base_vtable = {
        NULL, /* namespace */
        enum_class_FixedFloatArray, /* base_type */
        NULL, /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_HAS_READONLY_FLAG, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        NULL,   /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_default_add_attribute,
        Parrot_default_add_method,
        Parrot_default_add_parent,
        Parrot_default_add_role,
        Parrot_default_assign_pmc,
        Parrot_default_assign_string_native,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_can,
        Parrot_default_class_type,
        Parrot_FixedFloatArray_clone,
        Parrot_default_clone_pmc,
        Parrot_default_decrement,
        Parrot_default_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_default_delete_keyed,
        Parrot_default_delete_keyed_int,
        Parrot_default_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_FixedFloatArray_destroy,
        Parrot_default_does,
        Parrot_FixedFloatArray_elements,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_default_find_method,
        Parrot_default_freeze,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_FixedFloatArray_get_bool,
        Parrot_default_get_class,
        Parrot_FixedFloatArray_get_integer,
        Parrot_FixedFloatArray_get_integer_keyed,
        Parrot_FixedFloatArray_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_iter,
        Parrot_default_get_number,
        Parrot_FixedFloatArray_get_number_keyed,
        Parrot_FixedFloatArray_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_FixedFloatArray_get_pmc_keyed,
        Parrot_FixedFloatArray_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_default_get_repr,
        Parrot_default_get_string,
        Parrot_FixedFloatArray_get_string_keyed,
        Parrot_FixedFloatArray_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_default_hash,
        Parrot_default_i_absolute,
        Parrot_default_i_bitwise_not,
        Parrot_default_i_bitwise_nots,
        Parrot_default_i_logical_not,
        Parrot_default_i_neg,
        Parrot_default_increment,
        Parrot_FixedFloatArray_init,
        Parrot_default_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_default_instantiate,
        Parrot_default_invoke,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_logical_not,
        Parrot_default_mark,
        Parrot_FixedFloatArray_morph,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_new_from_string,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_pmc_namespace,
        Parrot_default_pop_float,
        Parrot_default_pop_integer,
        Parrot_default_pop_pmc,
        Parrot_default_pop_string,
        Parrot_default_push_float,
        Parrot_default_push_integer,
        Parrot_default_push_pmc,
        Parrot_default_push_string,
        Parrot_default_remove_attribute,
        Parrot_default_remove_method,
        Parrot_default_remove_parent,
        Parrot_default_remove_role,
        Parrot_default_set_attr,
        Parrot_default_set_attr_str,
        Parrot_default_set_bignum_int,
        Parrot_default_set_bignum_num,
        Parrot_default_set_bignum_str,
        Parrot_default_set_bool,
        Parrot_FixedFloatArray_set_integer_keyed,
        Parrot_FixedFloatArray_set_integer_keyed_int,
        Parrot_default_set_integer_keyed_str,
        Parrot_FixedFloatArray_set_integer_native,
        Parrot_default_set_integer_same,
        Parrot_FixedFloatArray_set_number_keyed,
        Parrot_FixedFloatArray_set_number_keyed_int,
        Parrot_default_set_number_keyed_str,
        Parrot_default_set_number_native,
        Parrot_default_set_number_same,
        Parrot_default_set_pmc,
        Parrot_FixedFloatArray_set_pmc_keyed,
        Parrot_FixedFloatArray_set_pmc_keyed_int,
        Parrot_default_set_pmc_keyed_str,
        Parrot_default_set_pointer,
        Parrot_default_set_pointer_keyed,
        Parrot_default_set_pointer_keyed_int,
        Parrot_default_set_pointer_keyed_str,
        Parrot_FixedFloatArray_set_string_keyed,
        Parrot_FixedFloatArray_set_string_keyed_int,
        Parrot_default_set_string_keyed_str,
        Parrot_default_set_string_native,
        Parrot_default_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_default_shift_float,
        Parrot_default_shift_integer,
        Parrot_default_shift_pmc,
        Parrot_default_shift_string,
        Parrot_default_slice,
        Parrot_default_splice,
        Parrot_default_subclass,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtype,
        Parrot_default_thaw,
        Parrot_default_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_type_keyed_int,
        Parrot_default_type_keyed_str,
        Parrot_default_unshift_float,
        Parrot_default_unshift_integer,
        Parrot_default_unshift_pmc,
        Parrot_default_unshift_string,
        Parrot_default_visit
    };

    const VTABLE temp_ro_vtable = {
        NULL, /* namespace */
        enum_class_FixedFloatArray, /* base_type */
        NULL, /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_IS_READONLY_FLAG, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        NULL,   /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_FixedFloatArray_ro_add_attribute,
        Parrot_FixedFloatArray_ro_add_method,
        Parrot_FixedFloatArray_ro_add_parent,
        Parrot_FixedFloatArray_ro_add_role,
        Parrot_FixedFloatArray_ro_assign_pmc,
        Parrot_FixedFloatArray_ro_assign_string_native,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_can,
        Parrot_default_class_type,
        Parrot_FixedFloatArray_clone,
        Parrot_default_clone_pmc,
        Parrot_FixedFloatArray_ro_decrement,
        Parrot_default_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_FixedFloatArray_ro_delete_keyed,
        Parrot_FixedFloatArray_ro_delete_keyed_int,
        Parrot_FixedFloatArray_ro_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_FixedFloatArray_destroy,
        Parrot_default_does,
        Parrot_FixedFloatArray_elements,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_FixedFloatArray_ro_find_method,
        Parrot_default_freeze,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_FixedFloatArray_get_bool,
        Parrot_default_get_class,
        Parrot_FixedFloatArray_get_integer,
        Parrot_FixedFloatArray_get_integer_keyed,
        Parrot_FixedFloatArray_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_iter,
        Parrot_default_get_number,
        Parrot_FixedFloatArray_get_number_keyed,
        Parrot_FixedFloatArray_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_FixedFloatArray_get_pmc_keyed,
        Parrot_FixedFloatArray_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_default_get_repr,
        Parrot_default_get_string,
        Parrot_FixedFloatArray_get_string_keyed,
        Parrot_FixedFloatArray_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_default_hash,
        Parrot_FixedFloatArray_ro_i_absolute,
        Parrot_FixedFloatArray_ro_i_bitwise_not,
        Parrot_FixedFloatArray_ro_i_bitwise_nots,
        Parrot_FixedFloatArray_ro_i_logical_not,
        Parrot_FixedFloatArray_ro_i_neg,
        Parrot_FixedFloatArray_ro_increment,
        Parrot_FixedFloatArray_init,
        Parrot_default_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_default_instantiate,
        Parrot_default_invoke,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_logical_not,
        Parrot_default_mark,
        Parrot_FixedFloatArray_ro_morph,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_new_from_string,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_pmc_namespace,
        Parrot_FixedFloatArray_ro_pop_float,
        Parrot_FixedFloatArray_ro_pop_integer,
        Parrot_FixedFloatArray_ro_pop_pmc,
        Parrot_FixedFloatArray_ro_pop_string,
        Parrot_FixedFloatArray_ro_push_float,
        Parrot_FixedFloatArray_ro_push_integer,
        Parrot_FixedFloatArray_ro_push_pmc,
        Parrot_FixedFloatArray_ro_push_string,
        Parrot_FixedFloatArray_ro_remove_attribute,
        Parrot_FixedFloatArray_ro_remove_method,
        Parrot_FixedFloatArray_ro_remove_parent,
        Parrot_FixedFloatArray_ro_remove_role,
        Parrot_FixedFloatArray_ro_set_attr,
        Parrot_FixedFloatArray_ro_set_attr_str,
        Parrot_FixedFloatArray_ro_set_bignum_int,
        Parrot_FixedFloatArray_ro_set_bignum_num,
        Parrot_FixedFloatArray_ro_set_bignum_str,
        Parrot_FixedFloatArray_ro_set_bool,
        Parrot_FixedFloatArray_ro_set_integer_keyed,
        Parrot_FixedFloatArray_ro_set_integer_keyed_int,
        Parrot_FixedFloatArray_ro_set_integer_keyed_str,
        Parrot_FixedFloatArray_ro_set_integer_native,
        Parrot_FixedFloatArray_ro_set_integer_same,
        Parrot_FixedFloatArray_ro_set_number_keyed,
        Parrot_FixedFloatArray_ro_set_number_keyed_int,
        Parrot_FixedFloatArray_ro_set_number_keyed_str,
        Parrot_FixedFloatArray_ro_set_number_native,
        Parrot_FixedFloatArray_ro_set_number_same,
        Parrot_FixedFloatArray_ro_set_pmc,
        Parrot_FixedFloatArray_ro_set_pmc_keyed,
        Parrot_FixedFloatArray_ro_set_pmc_keyed_int,
        Parrot_FixedFloatArray_ro_set_pmc_keyed_str,
        Parrot_FixedFloatArray_ro_set_pointer,
        Parrot_FixedFloatArray_ro_set_pointer_keyed,
        Parrot_FixedFloatArray_ro_set_pointer_keyed_int,
        Parrot_FixedFloatArray_ro_set_pointer_keyed_str,
        Parrot_FixedFloatArray_ro_set_string_keyed,
        Parrot_FixedFloatArray_ro_set_string_keyed_int,
        Parrot_FixedFloatArray_ro_set_string_keyed_str,
        Parrot_FixedFloatArray_ro_set_string_native,
        Parrot_FixedFloatArray_ro_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_FixedFloatArray_ro_shift_float,
        Parrot_FixedFloatArray_ro_shift_integer,
        Parrot_FixedFloatArray_ro_shift_pmc,
        Parrot_FixedFloatArray_ro_shift_string,
        Parrot_default_slice,
        Parrot_FixedFloatArray_ro_splice,
        Parrot_default_subclass,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtype,
        Parrot_FixedFloatArray_ro_thaw,
        Parrot_FixedFloatArray_ro_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_type_keyed_int,
        Parrot_default_type_keyed_str,
        Parrot_FixedFloatArray_ro_unshift_float,
        Parrot_FixedFloatArray_ro_unshift_integer,
        Parrot_FixedFloatArray_ro_unshift_pmc,
        Parrot_FixedFloatArray_ro_unshift_string,
        Parrot_default_visit
    };
    if (pass == 0) {
        /*
         * create vtable - clone it - we have to set a few items
         */
        VTABLE *vt_clone =
            Parrot_clone_vtable(interp, &temp_base_vtable);
        VTABLE *vt_ro_clone =
            Parrot_clone_vtable(interp, &temp_ro_vtable);
        vt_clone->whoami = CONST_STRING(interp, "FixedFloatArray");
        vt_clone->isa_str = CONST_STRING(interp, "FixedFloatArray");
        vt_clone->does_str = CONST_STRING(interp, "array");
        vt_ro_clone->base_type = entry;
        vt_ro_clone->whoami = vt_clone->whoami;
        vt_ro_clone->isa_str = vt_clone->isa_str;
        vt_ro_clone->does_str = vt_clone->does_str;
        vt_clone->ro_variant_vtable = vt_ro_clone;
        vt_ro_clone->ro_variant_vtable = vt_clone;
        interp->vtables[entry] = vt_clone;
    }
    else { /* pass */
        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        /* create PMC Proxy object */
        Parrot_create_pmc_proxy(interp, entry);
        /* class_init */
        {
        }
    } /* pass */
} /* Parrot_FixedFloatArray_class_init */


/*

=back

=head1 SEE ALSO

F<docs/pdds/pdd17_basic_types.pod>.

=head1 HISTORY

Initial version 2004.06.11 by Matt Fowles

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
