/*
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/fixedintegerarray.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

#line 1 "./src/pmc/fixedintegerarray.pmc"
/*
Copyright (C) 2001-2003, The Perl Foundation.
$Id: fixedintegerarray.pmc 16275 2006-12-28 01:20:44Z particle $

=head1 NAME

src/pmc/fixedintegerarray.pmc - fixed size array for integers only

=head1 DESCRIPTION

This class, FixedIntegerArray, implements an array of fixed size,
which stored INTVALs, it uses Integer PMCs for all of the conversions

=head2 Functions

=over 4

=cut

*/

#include "parrot/parrot.h"

#line 36 "src/pmc/fixedintegerarray.c"
#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_fixedintegerarray.h"
#include "pmc_default.h"
#include "fixedintegerarray.str"

PMC*
Parrot_FixedIntegerArray_clone(Interp *interp, PMC* pmc)
#line 166 "./src/pmc/fixedintegerarray.pmc"
{
    INTVAL size;
    PMC * dest;
    /* a quick hack to create a clone in the constant PMC arena
     * this is needed for the call signatures
     *
     * a better way would be probably to supply a flag to the clone
     * vtable
     */

    if (PObj_constant_TEST(pmc))
        dest = constant_pmc_new(interp, pmc->vtable->base_type);
    else
        dest = pmc_new(interp, pmc->vtable->base_type);

    if (!PMC_data(pmc))
        return dest;
    size = PMC_int_val(pmc);
    PMC_int_val(dest) = size;

    PMC_data(dest) = mem_sys_allocate(size * sizeof (INTVAL));
    mem_sys_memcopy(PMC_data(dest), PMC_data(pmc), size*sizeof (INTVAL));
    PObj_active_destroy_SET(dest);
    return dest;

}
#line 73 "src/pmc/fixedintegerarray.c"
void
Parrot_FixedIntegerArray_destroy(Interp *interp, PMC* pmc)
#line 149 "./src/pmc/fixedintegerarray.pmc"
{
    if (PMC_data(pmc))
        mem_sys_free(PMC_data(pmc));
    PMC_data(pmc) = NULL;
    PMC_int_val(pmc) = 0;

}
#line 84 "src/pmc/fixedintegerarray.c"
INTVAL
Parrot_FixedIntegerArray_elements(Interp *interp, PMC* pmc)
#line 215 "./src/pmc/fixedintegerarray.pmc"
{
    return PMC_int_val(pmc);

}
#line 92 "src/pmc/fixedintegerarray.c"
void
Parrot_FixedIntegerArray_freeze(Interp *interp, PMC* pmc, visit_info *info)
#line 577 "./src/pmc/fixedintegerarray.pmc"
{
    IMAGE_IO *io = info->image_io;
    INTVAL i, n;
    INTVAL *ar;

    Parrot_default_freeze(interp, pmc, info);
    n = VTABLE_elements(interp, pmc);
     VTABLE_push_integer(interp, io, n);
    ar = (INTVAL *)PMC_data(pmc);
    for (i = 0; i < n; ++i) {
         VTABLE_push_integer(interp, io, ar[i]);
    }

}
#line 110 "src/pmc/fixedintegerarray.c"
INTVAL
Parrot_FixedIntegerArray_get_bool(Interp *interp, PMC* pmc)
#line 202 "./src/pmc/fixedintegerarray.pmc"
{
    INTVAL size = Parrot_FixedIntegerArray_elements(interp, pmc);
    return (INTVAL)(size != 0);

}
#line 119 "src/pmc/fixedintegerarray.c"
INTVAL
Parrot_FixedIntegerArray_get_integer(Interp *interp, PMC* pmc)
#line 229 "./src/pmc/fixedintegerarray.pmc"
{
    return Parrot_FixedIntegerArray_elements(interp, pmc);

}
#line 127 "src/pmc/fixedintegerarray.c"
INTVAL
Parrot_FixedIntegerArray_get_integer_keyed(Interp *interp, PMC* pmc, PMC* key)
#line 264 "./src/pmc/fixedintegerarray.pmc"
{
    /* simple int keys only */
    INTVAL k = key_integer(interp, key);
    return  VTABLE_get_integer_keyed_int(interp, pmc, k);

}
#line 137 "src/pmc/fixedintegerarray.c"
INTVAL
Parrot_FixedIntegerArray_get_integer_keyed_int(Interp *interp, PMC* pmc, INTVAL key)
#line 244 "./src/pmc/fixedintegerarray.pmc"
{
    INTVAL *data;
    if (key < 0 || key >= PMC_int_val(pmc))
        real_exception(interp, NULL, E_IndexError,
            "FixedIntegerArray: index out of bounds!");

    data = (INTVAL *)PMC_data(pmc);
    return data[key];

}
#line 151 "src/pmc/fixedintegerarray.c"
FLOATVAL
Parrot_FixedIntegerArray_get_number_keyed(Interp *interp, PMC* pmc, PMC* key)
#line 295 "./src/pmc/fixedintegerarray.pmc"
{
    INTVAL k = key_integer(interp, key);
    return  VTABLE_get_number_keyed_int(interp, pmc, k);

}
#line 160 "src/pmc/fixedintegerarray.c"
FLOATVAL
Parrot_FixedIntegerArray_get_number_keyed_int(Interp *interp, PMC* pmc, INTVAL key)
#line 281 "./src/pmc/fixedintegerarray.pmc"
{
    return (FLOATVAL) VTABLE_get_integer_keyed_int(interp, pmc, key);

}
#line 168 "src/pmc/fixedintegerarray.c"
PMC*
Parrot_FixedIntegerArray_get_pmc_keyed(Interp *interp, PMC* pmc, PMC* key)
#line 390 "./src/pmc/fixedintegerarray.pmc"
{
    INTVAL k = key_integer(interp, key);
    return  VTABLE_get_pmc_keyed_int(interp, pmc, k);

}
#line 177 "src/pmc/fixedintegerarray.c"
PMC*
Parrot_FixedIntegerArray_get_pmc_keyed_int(Interp *interp, PMC* pmc, INTVAL key)
#line 370 "./src/pmc/fixedintegerarray.pmc"
{
    PMC *ret;
    INTVAL val;

    ret = pmc_new(interp, enum_class_Integer);
    val =  VTABLE_get_integer_keyed_int(interp, pmc, key);
    VTABLE_set_integer_native(interp, ret, val);
    return ret;

}
#line 191 "src/pmc/fixedintegerarray.c"
STRING*
Parrot_FixedIntegerArray_get_repr(Interp *interp, PMC* pmc)
#line 326 "./src/pmc/fixedintegerarray.pmc"
{
    STRING *res;
    INTVAL j, n;
    PMC *val;

    res = string_from_cstring(interp, "[ ", 0);
    n = VTABLE_elements(interp, pmc);
    for (j = 0; j < n; ++j) {
        val = Parrot_FixedIntegerArray_get_pmc_keyed_int(interp, pmc, j);
        res = string_append(interp, res, VTABLE_get_repr(interp, val));
        if (j < n - 1)
            res = string_append(interp, res, const_string(interp, ", "));
    }
    res = string_append(interp, res, const_string(interp, " ]"));
    return res;

}
#line 212 "src/pmc/fixedintegerarray.c"
STRING*
Parrot_FixedIntegerArray_get_string_keyed(Interp *interp, PMC* pmc, PMC* key)
#line 354 "./src/pmc/fixedintegerarray.pmc"
{
    INTVAL k = key_integer(interp, key);
    return  VTABLE_get_string_keyed_int(interp, pmc, k);

}
#line 221 "src/pmc/fixedintegerarray.c"
STRING*
Parrot_FixedIntegerArray_get_string_keyed_int(Interp *interp, PMC* pmc, INTVAL key)
#line 310 "./src/pmc/fixedintegerarray.pmc"
{
    PMC *temp;
    temp =  VTABLE_get_pmc_keyed_int(interp, pmc, key);
    return VTABLE_get_string(interp, temp);

}
#line 231 "src/pmc/fixedintegerarray.c"
void
Parrot_FixedIntegerArray_init(Interp *interp, PMC* pmc)
#line 42 "./src/pmc/fixedintegerarray.pmc"
{
    PMC_int_val(pmc) = 0;
    PMC_data(pmc) = NULL;

}
#line 240 "src/pmc/fixedintegerarray.c"
void
Parrot_FixedIntegerArray_morph(Interp *interp, PMC* pmc, INTVAL type)
#line 134 "./src/pmc/fixedintegerarray.pmc"
{
    Parrot_default_morph(interp, pmc, type);

}
#line 248 "src/pmc/fixedintegerarray.c"
PMC*
Parrot_FixedIntegerArray_new_from_string(Interp *interp, PMC* pmc, STRING *rep, INTVAL flags)
#line 59 "./src/pmc/fixedintegerarray.pmc"
{
    INTVAL type, n, elem;
    char *p, *start;
    UINTVAL i, l;
    int base;

    type = pmc->vtable->base_type;
    if (flags & PObj_constant_FLAG)
        pmc = constant_pmc_new(interp, type);
    else
        pmc = pmc_new(interp, type);
    l = string_length(interp, rep);
    if (!l)
        return pmc;
    if (rep->encoding != Parrot_fixed_8_encoding_ptr)
        real_exception(interp, NULL, E_ValueError,
                "unhandled string encoding in constructor");
    if (l <= 2 && ((char*)rep->strstart)[0] == '(')   /* "()" - no args */
        return pmc;
    /* count commas */
    p = rep->strstart;
    for (i = l, n = 0; i; --i, ++p) {
        if (*p == ',')
            ++n;
    }
    /* presize the array */
    Parrot_FixedIntegerArray_set_integer_native(interp, pmc, n + 1);
    /* parse string */
    p = rep->strstart;
    for (i = l, n = 0; i; --i, ++p) {
        switch (*p) {
            case ' ': continue;
            case '\t': continue;
            case '(': continue;
            case ')': break;
            case ',':
                      n++;
                      break;
            default:
                      base = 10;
                      if (*p == '0') {
                          ++p;
                          --i;
                          if (*p == 'b' || *p == 'B') {
                              base = 2;
                              ++p;
                              --i;
                          }
                          else if (*p == 'x' || *p == 'X') {
                              base = 16;
                              ++p;
                              --i;
                          }
                      }
                      start = p;
                      elem = strtoul(p, &p, base);
                      --p;
                      i -= (p - start);
                      Parrot_FixedIntegerArray_set_integer_keyed_int(interp, pmc, n, elem);
                      break;
        }
    }
    return pmc;

}
#line 317 "src/pmc/fixedintegerarray.c"
void
Parrot_FixedIntegerArray_set_integer_keyed(Interp *interp, PMC* pmc, PMC *key, INTVAL value)
#line 444 "./src/pmc/fixedintegerarray.pmc"
{
    INTVAL k;
    k = key_integer(interp, key);
     VTABLE_set_integer_keyed_int(interp, pmc, k, value);

}
#line 327 "src/pmc/fixedintegerarray.c"
void
Parrot_FixedIntegerArray_set_integer_keyed_int(Interp *interp, PMC* pmc, INTVAL key, INTVAL value)
#line 424 "./src/pmc/fixedintegerarray.pmc"
{
    INTVAL *data;
    if (key < 0 || key >= PMC_int_val(pmc))
        real_exception(interp, NULL, E_IndexError,
            "FixedIntegerArray: index out of bounds!");

    data = (INTVAL*)PMC_data(pmc);
    data[key] = value;

}
#line 341 "src/pmc/fixedintegerarray.c"
void
Parrot_FixedIntegerArray_set_integer_native(Interp *interp, PMC* pmc, INTVAL size)
#line 405 "./src/pmc/fixedintegerarray.pmc"
{
    if (PMC_int_val(pmc) || size < 1)
        real_exception(interp, NULL, E_IndexError,
            "FixedIntegerArray: Can't resize!");
    PMC_int_val(pmc) = size;
    PMC_data(pmc) = mem_sys_allocate_zeroed(size * sizeof (INTVAL));
    PObj_active_destroy_SET(pmc);

}
#line 354 "src/pmc/fixedintegerarray.c"
void
Parrot_FixedIntegerArray_set_number_keyed(Interp *interp, PMC* pmc, PMC *key, FLOATVAL value)
#line 476 "./src/pmc/fixedintegerarray.pmc"
{
    INTVAL k;
    k = key_integer(interp, key);
     VTABLE_set_number_keyed_int(interp, pmc, k, value);

}
#line 364 "src/pmc/fixedintegerarray.c"
void
Parrot_FixedIntegerArray_set_number_keyed_int(Interp *interp, PMC* pmc, INTVAL key, FLOATVAL value)
#line 461 "./src/pmc/fixedintegerarray.pmc"
{
     VTABLE_set_integer_keyed_int(interp, pmc, key, (INTVAL)value);

}
#line 372 "src/pmc/fixedintegerarray.c"
void
Parrot_FixedIntegerArray_set_pmc_keyed(Interp *interp, PMC* pmc, PMC *key, PMC* value)
#line 547 "./src/pmc/fixedintegerarray.pmc"
{
    INTVAL k;
    k = key_integer(interp, key);
     VTABLE_set_pmc_keyed_int(interp, pmc, k, value);

}
#line 382 "src/pmc/fixedintegerarray.c"
void
Parrot_FixedIntegerArray_set_pmc_keyed_int(Interp *interp, PMC* pmc, INTVAL key, PMC* src)
#line 529 "./src/pmc/fixedintegerarray.pmc"
{
    INTVAL tempInt;

    tempInt = VTABLE_get_integer(interp, src);
     VTABLE_set_integer_keyed_int(interp, pmc, key, tempInt);

}
#line 393 "src/pmc/fixedintegerarray.c"
void
Parrot_FixedIntegerArray_set_string_keyed(Interp *interp, PMC* pmc, PMC *key, STRING* value)
#line 513 "./src/pmc/fixedintegerarray.pmc"
{
    INTVAL k;
    k = key_integer(interp, key);
     VTABLE_set_string_keyed_int(interp, pmc, k, value);

}
#line 403 "src/pmc/fixedintegerarray.c"
void
Parrot_FixedIntegerArray_set_string_keyed_int(Interp *interp, PMC* pmc, INTVAL key, STRING* value)
#line 492 "./src/pmc/fixedintegerarray.pmc"
{
    INTVAL tempInt;
    PMC *tempPMC;

    tempPMC = pmc_new(interp, enum_class_Integer);
    VTABLE_set_string_native(interp, tempPMC, value);
    tempInt = VTABLE_get_integer(interp, tempPMC);
     VTABLE_set_integer_keyed_int(interp, pmc, key, tempInt);

}
#line 417 "src/pmc/fixedintegerarray.c"
void
Parrot_FixedIntegerArray_thaw(Interp *interp, PMC* pmc, visit_info *info)
#line 591 "./src/pmc/fixedintegerarray.pmc"
{
    IMAGE_IO *io = info->image_io;
    INTVAL i, n;
    INTVAL *ar;

    if (info->extra_flags == EXTRA_IS_NULL) {
        PMC_int_val(pmc) = 0;
        PMC_data(pmc) = NULL;
        n =  VTABLE_shift_integer(interp, io);
        if (!n)
            return;
         VTABLE_set_integer_native(interp, pmc, n);
        ar = (INTVAL *)PMC_data(pmc);
        for (i = 0; i < n; ++i) {
            ar[i] =  VTABLE_shift_integer(interp, io);
        }
    }
    else
        Parrot_default_thaw(interp, pmc, info);

}
#line 442 "src/pmc/fixedintegerarray.c"
void
Parrot_FixedIntegerArray_visit(Interp *interp, PMC* pmc, visit_info *info)
#line 573 "./src/pmc/fixedintegerarray.pmc"
{
    Parrot_default_visit(interp, pmc, info);

}
#line 450 "src/pmc/fixedintegerarray.c"
void
Parrot_FixedIntegerArray_ro_add_attribute(Interp *interp, PMC* pmc, STRING* name, PMC* type)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "add_attribute() in read-only instance of FixedIntegerArray");
}
void
Parrot_FixedIntegerArray_ro_add_method(Interp *interp, PMC* pmc, STRING* method_name, PMC* sub_pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "add_method() in read-only instance of FixedIntegerArray");
}
void
Parrot_FixedIntegerArray_ro_add_parent(Interp *interp, PMC* pmc, PMC* parent)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "add_parent() in read-only instance of FixedIntegerArray");
}
void
Parrot_FixedIntegerArray_ro_add_role(Interp *interp, PMC* pmc, PMC* role)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "add_role() in read-only instance of FixedIntegerArray");
}
void
Parrot_FixedIntegerArray_ro_assign_pmc(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "assign_pmc() in read-only instance of FixedIntegerArray");
}
void
Parrot_FixedIntegerArray_ro_assign_string_native(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "assign_string_native() in read-only instance of FixedIntegerArray");
}
void
Parrot_FixedIntegerArray_ro_decrement(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "decrement() in read-only instance of FixedIntegerArray");
}
void
Parrot_FixedIntegerArray_ro_delete_keyed(Interp *interp, PMC* pmc, PMC* key)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "delete_keyed() in read-only instance of FixedIntegerArray");
}
void
Parrot_FixedIntegerArray_ro_delete_keyed_int(Interp *interp, PMC* pmc, INTVAL key)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "delete_keyed_int() in read-only instance of FixedIntegerArray");
}
void
Parrot_FixedIntegerArray_ro_delete_keyed_str(Interp *interp, PMC* pmc, STRING* key)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "delete_keyed_str() in read-only instance of FixedIntegerArray");
}
PMC*
Parrot_FixedIntegerArray_ro_find_method(Interp *interp, PMC* pmc, STRING* method_name)
 {
    PMC *const method = Parrot_default_find_method(interp, pmc, method_name);
    if (!PMC_IS_NULL(VTABLE_getprop(interp, method, const_string(interp, "write"))))
        return PMCNULL;
    else
        return method;
}
void
Parrot_FixedIntegerArray_ro_i_absolute(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_absolute() in read-only instance of FixedIntegerArray");
}
void
Parrot_FixedIntegerArray_ro_i_bitwise_not(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_bitwise_not() in read-only instance of FixedIntegerArray");
}
void
Parrot_FixedIntegerArray_ro_i_bitwise_nots(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_bitwise_nots() in read-only instance of FixedIntegerArray");
}
void
Parrot_FixedIntegerArray_ro_i_logical_not(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_logical_not() in read-only instance of FixedIntegerArray");
}
void
Parrot_FixedIntegerArray_ro_i_neg(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_neg() in read-only instance of FixedIntegerArray");
}
void
Parrot_FixedIntegerArray_ro_increment(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "increment() in read-only instance of FixedIntegerArray");
}
void
Parrot_FixedIntegerArray_ro_morph(Interp *interp, PMC* pmc, INTVAL type)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "morph() in read-only instance of FixedIntegerArray");
}
FLOATVAL
Parrot_FixedIntegerArray_ro_pop_float(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "pop_float() in read-only instance of FixedIntegerArray");
    return (FLOATVAL)0;
}
INTVAL
Parrot_FixedIntegerArray_ro_pop_integer(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "pop_integer() in read-only instance of FixedIntegerArray");
    return (INTVAL)0;
}
PMC*
Parrot_FixedIntegerArray_ro_pop_pmc(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "pop_pmc() in read-only instance of FixedIntegerArray");
    return PMCNULL;
}
STRING*
Parrot_FixedIntegerArray_ro_pop_string(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "pop_string() in read-only instance of FixedIntegerArray");
    return (STRING*)0;
}
void
Parrot_FixedIntegerArray_ro_push_float(Interp *interp, PMC* pmc, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "push_float() in read-only instance of FixedIntegerArray");
}
void
Parrot_FixedIntegerArray_ro_push_integer(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "push_integer() in read-only instance of FixedIntegerArray");
}
void
Parrot_FixedIntegerArray_ro_push_pmc(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "push_pmc() in read-only instance of FixedIntegerArray");
}
void
Parrot_FixedIntegerArray_ro_push_string(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "push_string() in read-only instance of FixedIntegerArray");
}
void
Parrot_FixedIntegerArray_ro_remove_attribute(Interp *interp, PMC* pmc, STRING* name)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "remove_attribute() in read-only instance of FixedIntegerArray");
}
void
Parrot_FixedIntegerArray_ro_remove_method(Interp *interp, PMC* pmc, STRING* method_name)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "remove_method() in read-only instance of FixedIntegerArray");
}
void
Parrot_FixedIntegerArray_ro_remove_parent(Interp *interp, PMC* pmc, PMC* parent)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "remove_parent() in read-only instance of FixedIntegerArray");
}
void
Parrot_FixedIntegerArray_ro_remove_role(Interp *interp, PMC* pmc, PMC* role)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "remove_role() in read-only instance of FixedIntegerArray");
}
void
Parrot_FixedIntegerArray_ro_set_attr(Interp *interp, PMC* pmc, INTVAL idx, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_attr() in read-only instance of FixedIntegerArray");
}
void
Parrot_FixedIntegerArray_ro_set_attr_str(Interp *interp, PMC* pmc, STRING* idx, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_attr_str() in read-only instance of FixedIntegerArray");
}
void
Parrot_FixedIntegerArray_ro_set_bignum_int(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_bignum_int() in read-only instance of FixedIntegerArray");
}
void
Parrot_FixedIntegerArray_ro_set_bignum_num(Interp *interp, PMC* pmc, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_bignum_num() in read-only instance of FixedIntegerArray");
}
void
Parrot_FixedIntegerArray_ro_set_bignum_str(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_bignum_str() in read-only instance of FixedIntegerArray");
}
void
Parrot_FixedIntegerArray_ro_set_bool(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_bool() in read-only instance of FixedIntegerArray");
}
void
Parrot_FixedIntegerArray_ro_set_integer_keyed(Interp *interp, PMC* pmc, PMC* key, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_keyed() in read-only instance of FixedIntegerArray");
}
void
Parrot_FixedIntegerArray_ro_set_integer_keyed_int(Interp *interp, PMC* pmc, INTVAL key, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_keyed_int() in read-only instance of FixedIntegerArray");
}
void
Parrot_FixedIntegerArray_ro_set_integer_keyed_str(Interp *interp, PMC* pmc, STRING* key, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_keyed_str() in read-only instance of FixedIntegerArray");
}
void
Parrot_FixedIntegerArray_ro_set_integer_native(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_native() in read-only instance of FixedIntegerArray");
}
void
Parrot_FixedIntegerArray_ro_set_integer_same(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_same() in read-only instance of FixedIntegerArray");
}
void
Parrot_FixedIntegerArray_ro_set_number_keyed(Interp *interp, PMC* pmc, PMC* key, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_keyed() in read-only instance of FixedIntegerArray");
}
void
Parrot_FixedIntegerArray_ro_set_number_keyed_int(Interp *interp, PMC* pmc, INTVAL key, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_keyed_int() in read-only instance of FixedIntegerArray");
}
void
Parrot_FixedIntegerArray_ro_set_number_keyed_str(Interp *interp, PMC* pmc, STRING* key, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_keyed_str() in read-only instance of FixedIntegerArray");
}
void
Parrot_FixedIntegerArray_ro_set_number_native(Interp *interp, PMC* pmc, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_native() in read-only instance of FixedIntegerArray");
}
void
Parrot_FixedIntegerArray_ro_set_number_same(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_same() in read-only instance of FixedIntegerArray");
}
void
Parrot_FixedIntegerArray_ro_set_pmc(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pmc() in read-only instance of FixedIntegerArray");
}
void
Parrot_FixedIntegerArray_ro_set_pmc_keyed(Interp *interp, PMC* pmc, PMC* key, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pmc_keyed() in read-only instance of FixedIntegerArray");
}
void
Parrot_FixedIntegerArray_ro_set_pmc_keyed_int(Interp *interp, PMC* pmc, INTVAL key, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_int() in read-only instance of FixedIntegerArray");
}
void
Parrot_FixedIntegerArray_ro_set_pmc_keyed_str(Interp *interp, PMC* pmc, STRING* key, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_str() in read-only instance of FixedIntegerArray");
}
void
Parrot_FixedIntegerArray_ro_set_pointer(Interp *interp, PMC* pmc, void* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pointer() in read-only instance of FixedIntegerArray");
}
void
Parrot_FixedIntegerArray_ro_set_pointer_keyed(Interp *interp, PMC* pmc, PMC* key, void* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pointer_keyed() in read-only instance of FixedIntegerArray");
}
void
Parrot_FixedIntegerArray_ro_set_pointer_keyed_int(Interp *interp, PMC* pmc, INTVAL key, void* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_int() in read-only instance of FixedIntegerArray");
}
void
Parrot_FixedIntegerArray_ro_set_pointer_keyed_str(Interp *interp, PMC* pmc, STRING* key, void* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_str() in read-only instance of FixedIntegerArray");
}
void
Parrot_FixedIntegerArray_ro_set_string_keyed(Interp *interp, PMC* pmc, PMC* key, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_keyed() in read-only instance of FixedIntegerArray");
}
void
Parrot_FixedIntegerArray_ro_set_string_keyed_int(Interp *interp, PMC* pmc, INTVAL key, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_keyed_int() in read-only instance of FixedIntegerArray");
}
void
Parrot_FixedIntegerArray_ro_set_string_keyed_str(Interp *interp, PMC* pmc, STRING* key, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_keyed_str() in read-only instance of FixedIntegerArray");
}
void
Parrot_FixedIntegerArray_ro_set_string_native(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_native() in read-only instance of FixedIntegerArray");
}
void
Parrot_FixedIntegerArray_ro_set_string_same(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_same() in read-only instance of FixedIntegerArray");
}
FLOATVAL
Parrot_FixedIntegerArray_ro_shift_float(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "shift_float() in read-only instance of FixedIntegerArray");
    return (FLOATVAL)0;
}
INTVAL
Parrot_FixedIntegerArray_ro_shift_integer(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "shift_integer() in read-only instance of FixedIntegerArray");
    return (INTVAL)0;
}
PMC*
Parrot_FixedIntegerArray_ro_shift_pmc(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "shift_pmc() in read-only instance of FixedIntegerArray");
    return PMCNULL;
}
STRING*
Parrot_FixedIntegerArray_ro_shift_string(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "shift_string() in read-only instance of FixedIntegerArray");
    return (STRING*)0;
}
void
Parrot_FixedIntegerArray_ro_splice(Interp *interp, PMC* pmc, PMC* value, INTVAL offset, INTVAL count)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "splice() in read-only instance of FixedIntegerArray");
}
void
Parrot_FixedIntegerArray_ro_thaw(Interp *interp, PMC* pmc, visit_info* info)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "thaw() in read-only instance of FixedIntegerArray");
}
void
Parrot_FixedIntegerArray_ro_thawfinish(Interp *interp, PMC* pmc, visit_info* info)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "thawfinish() in read-only instance of FixedIntegerArray");
}
void
Parrot_FixedIntegerArray_ro_unshift_float(Interp *interp, PMC* pmc, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "unshift_float() in read-only instance of FixedIntegerArray");
}
void
Parrot_FixedIntegerArray_ro_unshift_integer(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "unshift_integer() in read-only instance of FixedIntegerArray");
}
void
Parrot_FixedIntegerArray_ro_unshift_pmc(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "unshift_pmc() in read-only instance of FixedIntegerArray");
}
void
Parrot_FixedIntegerArray_ro_unshift_string(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "unshift_string() in read-only instance of FixedIntegerArray");
}
void
Parrot_FixedIntegerArray_class_init(Parrot_Interp interp, int entry, int pass)
{
    const VTABLE temp_base_vtable = {
        NULL, /* namespace */
        enum_class_FixedIntegerArray, /* base_type */
        NULL, /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_HAS_READONLY_FLAG, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        NULL,   /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_default_add_attribute,
        Parrot_default_add_method,
        Parrot_default_add_parent,
        Parrot_default_add_role,
        Parrot_default_assign_pmc,
        Parrot_default_assign_string_native,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_can,
        Parrot_default_class_type,
        Parrot_FixedIntegerArray_clone,
        Parrot_default_clone_pmc,
        Parrot_default_decrement,
        Parrot_default_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_default_delete_keyed,
        Parrot_default_delete_keyed_int,
        Parrot_default_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_FixedIntegerArray_destroy,
        Parrot_default_does,
        Parrot_FixedIntegerArray_elements,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_default_find_method,
        Parrot_FixedIntegerArray_freeze,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_FixedIntegerArray_get_bool,
        Parrot_default_get_class,
        Parrot_FixedIntegerArray_get_integer,
        Parrot_FixedIntegerArray_get_integer_keyed,
        Parrot_FixedIntegerArray_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_iter,
        Parrot_default_get_number,
        Parrot_FixedIntegerArray_get_number_keyed,
        Parrot_FixedIntegerArray_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_FixedIntegerArray_get_pmc_keyed,
        Parrot_FixedIntegerArray_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_FixedIntegerArray_get_repr,
        Parrot_default_get_string,
        Parrot_FixedIntegerArray_get_string_keyed,
        Parrot_FixedIntegerArray_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_default_hash,
        Parrot_default_i_absolute,
        Parrot_default_i_bitwise_not,
        Parrot_default_i_bitwise_nots,
        Parrot_default_i_logical_not,
        Parrot_default_i_neg,
        Parrot_default_increment,
        Parrot_FixedIntegerArray_init,
        Parrot_default_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_default_instantiate,
        Parrot_default_invoke,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_logical_not,
        Parrot_default_mark,
        Parrot_FixedIntegerArray_morph,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_FixedIntegerArray_new_from_string,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_pmc_namespace,
        Parrot_default_pop_float,
        Parrot_default_pop_integer,
        Parrot_default_pop_pmc,
        Parrot_default_pop_string,
        Parrot_default_push_float,
        Parrot_default_push_integer,
        Parrot_default_push_pmc,
        Parrot_default_push_string,
        Parrot_default_remove_attribute,
        Parrot_default_remove_method,
        Parrot_default_remove_parent,
        Parrot_default_remove_role,
        Parrot_default_set_attr,
        Parrot_default_set_attr_str,
        Parrot_default_set_bignum_int,
        Parrot_default_set_bignum_num,
        Parrot_default_set_bignum_str,
        Parrot_default_set_bool,
        Parrot_FixedIntegerArray_set_integer_keyed,
        Parrot_FixedIntegerArray_set_integer_keyed_int,
        Parrot_default_set_integer_keyed_str,
        Parrot_FixedIntegerArray_set_integer_native,
        Parrot_default_set_integer_same,
        Parrot_FixedIntegerArray_set_number_keyed,
        Parrot_FixedIntegerArray_set_number_keyed_int,
        Parrot_default_set_number_keyed_str,
        Parrot_default_set_number_native,
        Parrot_default_set_number_same,
        Parrot_default_set_pmc,
        Parrot_FixedIntegerArray_set_pmc_keyed,
        Parrot_FixedIntegerArray_set_pmc_keyed_int,
        Parrot_default_set_pmc_keyed_str,
        Parrot_default_set_pointer,
        Parrot_default_set_pointer_keyed,
        Parrot_default_set_pointer_keyed_int,
        Parrot_default_set_pointer_keyed_str,
        Parrot_FixedIntegerArray_set_string_keyed,
        Parrot_FixedIntegerArray_set_string_keyed_int,
        Parrot_default_set_string_keyed_str,
        Parrot_default_set_string_native,
        Parrot_default_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_default_shift_float,
        Parrot_default_shift_integer,
        Parrot_default_shift_pmc,
        Parrot_default_shift_string,
        Parrot_default_slice,
        Parrot_default_splice,
        Parrot_default_subclass,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtype,
        Parrot_FixedIntegerArray_thaw,
        Parrot_default_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_type_keyed_int,
        Parrot_default_type_keyed_str,
        Parrot_default_unshift_float,
        Parrot_default_unshift_integer,
        Parrot_default_unshift_pmc,
        Parrot_default_unshift_string,
        Parrot_FixedIntegerArray_visit
    };

    const VTABLE temp_ro_vtable = {
        NULL, /* namespace */
        enum_class_FixedIntegerArray, /* base_type */
        NULL, /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_IS_READONLY_FLAG, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        NULL,   /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_FixedIntegerArray_ro_add_attribute,
        Parrot_FixedIntegerArray_ro_add_method,
        Parrot_FixedIntegerArray_ro_add_parent,
        Parrot_FixedIntegerArray_ro_add_role,
        Parrot_FixedIntegerArray_ro_assign_pmc,
        Parrot_FixedIntegerArray_ro_assign_string_native,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_can,
        Parrot_default_class_type,
        Parrot_FixedIntegerArray_clone,
        Parrot_default_clone_pmc,
        Parrot_FixedIntegerArray_ro_decrement,
        Parrot_default_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_FixedIntegerArray_ro_delete_keyed,
        Parrot_FixedIntegerArray_ro_delete_keyed_int,
        Parrot_FixedIntegerArray_ro_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_FixedIntegerArray_destroy,
        Parrot_default_does,
        Parrot_FixedIntegerArray_elements,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_FixedIntegerArray_ro_find_method,
        Parrot_FixedIntegerArray_freeze,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_FixedIntegerArray_get_bool,
        Parrot_default_get_class,
        Parrot_FixedIntegerArray_get_integer,
        Parrot_FixedIntegerArray_get_integer_keyed,
        Parrot_FixedIntegerArray_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_iter,
        Parrot_default_get_number,
        Parrot_FixedIntegerArray_get_number_keyed,
        Parrot_FixedIntegerArray_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_FixedIntegerArray_get_pmc_keyed,
        Parrot_FixedIntegerArray_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_FixedIntegerArray_get_repr,
        Parrot_default_get_string,
        Parrot_FixedIntegerArray_get_string_keyed,
        Parrot_FixedIntegerArray_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_default_hash,
        Parrot_FixedIntegerArray_ro_i_absolute,
        Parrot_FixedIntegerArray_ro_i_bitwise_not,
        Parrot_FixedIntegerArray_ro_i_bitwise_nots,
        Parrot_FixedIntegerArray_ro_i_logical_not,
        Parrot_FixedIntegerArray_ro_i_neg,
        Parrot_FixedIntegerArray_ro_increment,
        Parrot_FixedIntegerArray_init,
        Parrot_default_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_default_instantiate,
        Parrot_default_invoke,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_logical_not,
        Parrot_default_mark,
        Parrot_FixedIntegerArray_ro_morph,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_FixedIntegerArray_new_from_string,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_pmc_namespace,
        Parrot_FixedIntegerArray_ro_pop_float,
        Parrot_FixedIntegerArray_ro_pop_integer,
        Parrot_FixedIntegerArray_ro_pop_pmc,
        Parrot_FixedIntegerArray_ro_pop_string,
        Parrot_FixedIntegerArray_ro_push_float,
        Parrot_FixedIntegerArray_ro_push_integer,
        Parrot_FixedIntegerArray_ro_push_pmc,
        Parrot_FixedIntegerArray_ro_push_string,
        Parrot_FixedIntegerArray_ro_remove_attribute,
        Parrot_FixedIntegerArray_ro_remove_method,
        Parrot_FixedIntegerArray_ro_remove_parent,
        Parrot_FixedIntegerArray_ro_remove_role,
        Parrot_FixedIntegerArray_ro_set_attr,
        Parrot_FixedIntegerArray_ro_set_attr_str,
        Parrot_FixedIntegerArray_ro_set_bignum_int,
        Parrot_FixedIntegerArray_ro_set_bignum_num,
        Parrot_FixedIntegerArray_ro_set_bignum_str,
        Parrot_FixedIntegerArray_ro_set_bool,
        Parrot_FixedIntegerArray_ro_set_integer_keyed,
        Parrot_FixedIntegerArray_ro_set_integer_keyed_int,
        Parrot_FixedIntegerArray_ro_set_integer_keyed_str,
        Parrot_FixedIntegerArray_ro_set_integer_native,
        Parrot_FixedIntegerArray_ro_set_integer_same,
        Parrot_FixedIntegerArray_ro_set_number_keyed,
        Parrot_FixedIntegerArray_ro_set_number_keyed_int,
        Parrot_FixedIntegerArray_ro_set_number_keyed_str,
        Parrot_FixedIntegerArray_ro_set_number_native,
        Parrot_FixedIntegerArray_ro_set_number_same,
        Parrot_FixedIntegerArray_ro_set_pmc,
        Parrot_FixedIntegerArray_ro_set_pmc_keyed,
        Parrot_FixedIntegerArray_ro_set_pmc_keyed_int,
        Parrot_FixedIntegerArray_ro_set_pmc_keyed_str,
        Parrot_FixedIntegerArray_ro_set_pointer,
        Parrot_FixedIntegerArray_ro_set_pointer_keyed,
        Parrot_FixedIntegerArray_ro_set_pointer_keyed_int,
        Parrot_FixedIntegerArray_ro_set_pointer_keyed_str,
        Parrot_FixedIntegerArray_ro_set_string_keyed,
        Parrot_FixedIntegerArray_ro_set_string_keyed_int,
        Parrot_FixedIntegerArray_ro_set_string_keyed_str,
        Parrot_FixedIntegerArray_ro_set_string_native,
        Parrot_FixedIntegerArray_ro_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_FixedIntegerArray_ro_shift_float,
        Parrot_FixedIntegerArray_ro_shift_integer,
        Parrot_FixedIntegerArray_ro_shift_pmc,
        Parrot_FixedIntegerArray_ro_shift_string,
        Parrot_default_slice,
        Parrot_FixedIntegerArray_ro_splice,
        Parrot_default_subclass,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtype,
        Parrot_FixedIntegerArray_ro_thaw,
        Parrot_FixedIntegerArray_ro_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_type_keyed_int,
        Parrot_default_type_keyed_str,
        Parrot_FixedIntegerArray_ro_unshift_float,
        Parrot_FixedIntegerArray_ro_unshift_integer,
        Parrot_FixedIntegerArray_ro_unshift_pmc,
        Parrot_FixedIntegerArray_ro_unshift_string,
        Parrot_FixedIntegerArray_visit
    };
    if (pass == 0) {
        /*
         * create vtable - clone it - we have to set a few items
         */
        VTABLE *vt_clone =
            Parrot_clone_vtable(interp, &temp_base_vtable);
        VTABLE *vt_ro_clone =
            Parrot_clone_vtable(interp, &temp_ro_vtable);
        vt_clone->whoami = CONST_STRING(interp, "FixedIntegerArray");
        vt_clone->isa_str = CONST_STRING(interp, "FixedIntegerArray");
        vt_clone->does_str = CONST_STRING(interp, "array");
        vt_ro_clone->base_type = entry;
        vt_ro_clone->whoami = vt_clone->whoami;
        vt_ro_clone->isa_str = vt_clone->isa_str;
        vt_ro_clone->does_str = vt_clone->does_str;
        vt_clone->ro_variant_vtable = vt_ro_clone;
        vt_ro_clone->ro_variant_vtable = vt_clone;
        interp->vtables[entry] = vt_clone;
    }
    else { /* pass */
        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        /* create PMC Proxy object */
        Parrot_create_pmc_proxy(interp, entry);
        /* class_init */
        {
        }
    } /* pass */
} /* Parrot_FixedIntegerArray_class_init */


/*

=back

=head1 SEE ALSO

F<docs/pdds/pdd17_basic_types.pod>.

=head1 HISTORY

Initial version 2004.06.11 by Matt Fowles

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
