/*
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/hash.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

#line 1 "./src/pmc/hash.pmc"
/*
Copyright (C) 2001-2006, The Perl Foundation.
$Id: hash.pmc 18680 2007-05-30 06:35:36Z petdance $

=head1 NAME

src/pmc/hash.pmc - Hash PMC

=head1 DESCRIPTION

These are the vtable functions for the Hash PMC.

=head2 Functions

=over 4

=cut

*/

#include "parrot/parrot.h"
#include <assert.h>


/*

=item C<static PMC * get_integer_pmc(Interp *interp, INTVAL base_type )>

Lookup the PMC type which is used for storing native integers.

TODO: PMCs extending Hash should probably register themselves.

=cut

*/

static PMC* get_integer_pmc(Interp *interp, INTVAL base_type) {

    return pmc_new(interp,
                   Parrot_get_ctx_HLL_type(interp, enum_class_Integer));
}


/*

=item C<static PMC * get_number_pmc(Interp *interp, INTVAL base_type )>

Lookup the PMC type which is used for floating point numbers.

TODO: PMCs extending Hash should probably register themselves.

=cut

*/

static PMC * get_number_pmc(Interp *interp, INTVAL base_type) {

    return pmc_new(interp,
                   Parrot_get_ctx_HLL_type(interp, enum_class_Float));
}

/*

=item C<static PMC * get_string_pmc(Interp *interp, INTVAL base_type )>

Lookup the PMC type which is used for storing strings.

TODO: PMCs extending Hash should probably register themselves.

=cut

*/

static PMC * get_string_pmc(Interp *interp, INTVAL base_type) {

    return pmc_new(interp,
                   Parrot_get_ctx_HLL_type(interp, enum_class_String));
}


/*

=item C<static STRING* make_hash_key(Interp *interp, PMC *key)>

Returns a Parrot string for C<*key>.

=cut

*/

static STRING* make_hash_key(Interp *interp, PMC * key)
{
    if (key == NULL) {
        real_exception(interp, NULL, E_KeyError,
                "Hash: Cannot use NULL key");
        return NULL;
    }
    return key_string(interp, key);
}

/* Albeit the Hash PMC doesn't use PMC_data, it needs the next_for_GC pointer
 * We would get recursive marking of a deeply nested HoHoH...
 */
#line 116 "src/pmc/hash.c"
#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_hash.h"
#include "pmc_default.h"
#include "hash.str"

INTVAL
Parrot_Hash_is_equal(Interp *interp, PMC* pmc, PMC* value)
#line 845 "./src/pmc/hash.pmc"
{
    PMC * const iter = VTABLE_get_iter(interp, pmc);
    INTVAL j, n;

    /* TODO: comparing Hash and PerlHash should probably be possible */
    if (value->vtable->base_type != pmc->vtable->base_type)
        return 0;
    n = Parrot_Hash_elements(interp, pmc);
    if (VTABLE_elements(interp, value) != n)
        return 0;
    for (j = 0; j < n; ++j) {
        STRING * const key = VTABLE_shift_string(interp, iter);
        PMC *item1, *item2;
        if (!VTABLE_exists_keyed_str(interp, value, key))
            return 0;
        item1 = Parrot_Hash_get_pmc_keyed_str(interp, pmc, key);
        item2 = VTABLE_get_pmc_keyed_str(interp, value, key);
        if (item1 == item2)
            continue;
        if (!mmd_dispatch_i_pp(interp, item1, item2, MMD_EQ))
            return 0;
    }
    return 1;

}
#line 152 "src/pmc/hash.c"
PMC*
Parrot_Hash_clone(Interp *interp, PMC* pmc)
#line 205 "./src/pmc/hash.pmc"
{
    PMC* const dest = pmc_new_noinit(interp, pmc->vtable->base_type);
    PObj_custom_mark_destroy_SETALL(dest);
    parrot_hash_clone(interp, (Hash *)PMC_struct_val(pmc),
               (Hash**)&PMC_struct_val(dest));
    ((Hash*)PMC_struct_val(dest))->container = dest;
    return dest;

}
#line 165 "src/pmc/hash.c"
INTVAL
Parrot_Hash_defined_keyed(Interp *interp, PMC* pmc, PMC* key)
#line 935 "./src/pmc/hash.pmc"
{
    Hash * const h = (Hash *)PMC_struct_val(pmc);
    STRING * const sx = key_string(interp, key);
    HashBucket *b;

    key = key_next(interp, key);
    b = parrot_hash_get_bucket(interp, h, sx);
    if (b == NULL)
        return 0;       /* no such key */
    if (key == NULL)
        return VTABLE_defined(interp, (PMC*)b->value);
    else
        return VTABLE_defined_keyed(interp, (PMC*)b->value, key);

}
#line 184 "src/pmc/hash.c"
INTVAL
Parrot_Hash_defined_keyed_str(Interp *interp, PMC* pmc, STRING* key)
#line 916 "./src/pmc/hash.pmc"
{
    HashBucket * const b =
        parrot_hash_get_bucket(interp, (Hash*) PMC_struct_val(pmc), key);

    if (b == NULL)
        return 0;       /* no such key */
    return VTABLE_defined(interp, (PMC*)b->value);

}
#line 197 "src/pmc/hash.c"
void
Parrot_Hash_delete_keyed(Interp *interp, PMC* pmc, PMC* key)
#line 972 "./src/pmc/hash.pmc"
{
    Hash * const h = (Hash *)PMC_struct_val(pmc);
    STRING * const sx = key_string(interp, key);
    HashBucket *b;

    key = key_next(interp, key);
    b = parrot_hash_get_bucket(interp, h, sx);
    if (b == NULL)
        return;  /* no such key */
    if (key == NULL)
        parrot_hash_delete(interp, h, sx);
    else
        VTABLE_delete_keyed(interp, (PMC*)b->value, key);

}
#line 216 "src/pmc/hash.c"
void
Parrot_Hash_delete_keyed_str(Interp *interp, PMC* pmc, STRING* key)
#line 958 "./src/pmc/hash.pmc"
{
    parrot_hash_delete(interp, (Hash *)PMC_struct_val(pmc), key);

}
#line 224 "src/pmc/hash.c"
void
Parrot_Hash_destroy(Interp *interp, PMC* pmc)
#line 126 "./src/pmc/hash.pmc"
{
    if (PMC_struct_val(pmc)) {
        parrot_hash_destroy(interp, (Hash*) PMC_struct_val(pmc));
        PMC_struct_val(pmc) = NULL;
    }

}
#line 235 "src/pmc/hash.c"
INTVAL
Parrot_Hash_elements(Interp *interp, PMC* pmc)
#line 514 "./src/pmc/hash.pmc"
{
    return parrot_hash_size(interp, (Hash *)PMC_struct_val(pmc));

}
#line 243 "src/pmc/hash.c"
INTVAL
Parrot_Hash_exists_keyed(Interp *interp, PMC* pmc, PMC* key)
#line 894 "./src/pmc/hash.pmc"
{
    Hash * const h = (Hash *)PMC_struct_val(pmc);
    STRING * const sx = key_string(interp, key);
    HashBucket *b;

    key = key_next(interp, key);
    b = parrot_hash_get_bucket(interp, h, sx);
    if (b == NULL)
        return 0;       /* no such key */
    if (key == NULL)
        return 1;       /* lookup stops here */
    return VTABLE_exists_keyed(interp, (PMC*)b->value, key);

}
#line 261 "src/pmc/hash.c"
INTVAL
Parrot_Hash_exists_keyed_str(Interp *interp, PMC* pmc, STRING* key)
#line 878 "./src/pmc/hash.pmc"
{
    HashBucket * const b =
        parrot_hash_get_bucket(interp, (Hash*) PMC_struct_val(pmc), key);
    return b != NULL;

}
#line 271 "src/pmc/hash.c"
void
Parrot_Hash_freeze(Interp *interp, PMC* pmc, visit_info *info)
#line 1039 "./src/pmc/hash.pmc"
{
    IMAGE_IO * const io = info->image_io;
    Hash * const hash = (Hash *)PMC_struct_val(pmc);;

    Parrot_default_freeze(interp, pmc, info);
     VTABLE_push_integer(interp, io, VTABLE_elements(interp, pmc));
     VTABLE_push_integer(interp, io, hash->key_type);
     VTABLE_push_integer(interp, io, hash->entry_type);

}
#line 285 "src/pmc/hash.c"
INTVAL
Parrot_Hash_get_bool(Interp *interp, PMC* pmc)
#line 500 "./src/pmc/hash.pmc"
{
    return parrot_hash_size(interp, (Hash *)PMC_struct_val(pmc)) != 0;

}
#line 293 "src/pmc/hash.c"
INTVAL
Parrot_Hash_get_integer(Interp *interp, PMC* pmc)
#line 224 "./src/pmc/hash.pmc"
{
    return parrot_hash_size(interp, (Hash *)PMC_struct_val(pmc));

}
#line 301 "src/pmc/hash.c"
INTVAL
Parrot_Hash_get_integer_keyed(Interp *interp, PMC* pmc, PMC *key)
#line 261 "./src/pmc/hash.pmc"
{
    PMC        *valpmc;
    STRING     *keystr;
    HashBucket *b;
    PMC        *nextkey;
    const Hash * const hash = (Hash *)PMC_struct_val(pmc);

    switch (PObj_get_FLAGS(key) & KEY_type_FLAGS) {
        case KEY_hash_iterator_FLAGS:
            /* called from iterator with an integer idx in key
             * check if we really have Hash_key_type_int
             */
            if (hash->key_type == Hash_key_type_int) {
                return (INTVAL)parrot_hash_get_idx(interp, hash, key);
            }
            else {
                const STRING * const s = (STRING*)parrot_hash_get_idx(interp, hash, key);
                return string_to_int(interp, s);
            }
        default:
            keystr = make_hash_key(interp, key);
    }

    b       = parrot_hash_get_bucket(interp, hash, keystr);

    if (b == NULL)
        return 0;

    nextkey = key_next(interp, key);
    valpmc  = (PMC *)b->value;

    if (!nextkey)
        return VTABLE_get_integer(interp, valpmc);

    return VTABLE_get_integer_keyed(interp, valpmc, nextkey);

}
#line 342 "src/pmc/hash.c"
INTVAL
Parrot_Hash_get_integer_keyed_int(Interp *interp, PMC* pmc, INTVAL key)
#line 247 "./src/pmc/hash.pmc"
{
    STRING * const s = string_from_int(interp, key);
    return Parrot_Hash_get_integer_keyed_str(interp, pmc, s);

}
#line 351 "src/pmc/hash.c"
INTVAL
Parrot_Hash_get_integer_keyed_str(Interp *interp, PMC* pmc, STRING* key)
#line 238 "./src/pmc/hash.pmc"
{
    HashBucket * const b =
        parrot_hash_get_bucket(interp, (Hash*) PMC_struct_val(pmc), key);
    if (b == NULL) {
        return 0;
    }
    return VTABLE_get_integer(interp, (PMC*) b->value);

}
#line 364 "src/pmc/hash.c"
PMC*
Parrot_Hash_get_iter(Interp *interp, PMC* pmc)
#line 557 "./src/pmc/hash.pmc"
{
    PMC * const iter     = pmc_new_init(interp, enum_class_Iterator, pmc);
    PMC * const key      =  pmc_new(interp, enum_class_Key);

    PMC_struct_val(iter) = key;
    PObj_get_FLAGS(key) |= KEY_hash_iterator_FLAGS;
    PMC_data(key)        = (void *)INITBucketIndex;

    /* -1 for an empty hash, 0 for a non-empty hash.  */
    PMC_int_val(key)     =
        parrot_hash_size(interp, (Hash *)PMC_struct_val(pmc)) ? 0 : -1;

    return iter;

}
#line 383 "src/pmc/hash.c"
FLOATVAL
Parrot_Hash_get_number_keyed(Interp *interp, PMC* pmc, PMC *key)
#line 331 "./src/pmc/hash.pmc"
{
    PMC               *nextkey;
    PMC               *valpmc;
    STRING     * const keystr = make_hash_key(interp, key);
    HashBucket * const b      = parrot_hash_get_bucket(interp,
                                       (Hash*)PMC_struct_val(pmc), keystr);

    if (b == NULL)
        return 0.0;

    nextkey = key_next(interp, key);
    valpmc  = (PMC *)b->value;

    if (!nextkey)
        return VTABLE_get_number(interp, valpmc);

    return VTABLE_get_number_keyed(interp, valpmc, nextkey);

}
#line 406 "src/pmc/hash.c"
FLOATVAL
Parrot_Hash_get_number_keyed_int(Interp *interp, PMC* pmc, INTVAL key)
#line 317 "./src/pmc/hash.pmc"
{
    STRING * const s = string_from_int(interp, key);
    return Parrot_Hash_get_number_keyed_str(interp, pmc, s);

}
#line 415 "src/pmc/hash.c"
FLOATVAL
Parrot_Hash_get_number_keyed_str(Interp *interp, PMC* pmc, STRING* key)
#line 308 "./src/pmc/hash.pmc"
{
    HashBucket * const b =
        parrot_hash_get_bucket(interp, (Hash*) PMC_struct_val(pmc), key);
    if (b == NULL) {
        return 0.0;
    }
    return VTABLE_get_number(interp, (PMC*) b->value);

}
#line 428 "src/pmc/hash.c"
PMC*
Parrot_Hash_get_pmc_keyed(Interp *interp, PMC* pmc, PMC *key)
#line 576 "./src/pmc/hash.pmc"
{
    Hash   * const hash = (Hash *)PMC_struct_val(pmc);
    STRING     *keystr;
    HashBucket *b;
    PMC        *nextkey;
    PMC        *result;

    switch (PObj_get_FLAGS(key) & KEY_type_FLAGS) {
        case KEY_hash_iterator_FLAGS:
            /* called from iterator with an integer idx in key
             * check if we really have Hash_key_type_int
             */
            if (hash->key_type == Hash_key_type_int) {
                const INTVAL i = (INTVAL)parrot_hash_get_idx(interp,
                                                             hash, key);
                result = pmc_new(interp, enum_class_Integer);
                PMC_int_val(result) = i;
            }
            else {
                STRING *s;
                s      = (STRING *)parrot_hash_get_idx(interp, hash, key);
                result = pmc_new(interp, enum_class_String);
                VTABLE_set_string_native(interp, result, s);
            }
            return result;
        default:
            keystr = make_hash_key(interp, key);
    }

    b = parrot_hash_get_bucket(interp, hash, keystr);

    if (b == NULL)
        return PMCNULL;

    nextkey = key_next(interp, key);

    if (!nextkey)
        return (PMC *)b->value;

    return VTABLE_get_pmc_keyed(interp, (PMC*)b->value, nextkey);

}
#line 474 "src/pmc/hash.c"
PMC*
Parrot_Hash_get_pmc_keyed_int(Interp *interp, PMC* pmc, INTVAL key)
#line 538 "./src/pmc/hash.pmc"
{
    STRING * const s = string_from_int(interp, key);
    return Parrot_Hash_get_pmc_keyed_str(interp, pmc, s);

}
#line 483 "src/pmc/hash.c"
PMC*
Parrot_Hash_get_pmc_keyed_str(Interp *interp, PMC* pmc, STRING *key)
#line 528 "./src/pmc/hash.pmc"
{
    HashBucket * const b =
        parrot_hash_get_bucket(interp, (Hash*) PMC_struct_val(pmc), key);

    if (b == NULL)
        return PMCNULL;

    return (PMC *)b->value;

}
#line 497 "src/pmc/hash.c"
STRING*
Parrot_Hash_get_repr(Interp *interp, PMC* pmc)
#line 370 "./src/pmc/hash.pmc"
{
    /* TODO use freeze */
    PMC * const iter = VTABLE_get_iter(interp, pmc);
    STRING *res = string_from_cstring(interp, "{", 0);
    const INTVAL n = VTABLE_elements(interp, pmc);
    INTVAL j;

    for (j = 0; j < n; ++j) {
        STRING * const key = VTABLE_shift_string(interp, iter);
        int i,all_digit = 1;
        PMC *val;

        for (i = 0; i < (int)key->strlen; ++i) {
            if (!isdigit(((char *)key->strstart)[i])) {
                all_digit = 0;
                break;
            }
        }
        if (all_digit) {
            res = string_append(interp, res, key);
        }
        else {
            res = string_append(interp, res,
                    const_string(interp, "'"));
            res = string_append(interp, res, key);
            res = string_append(interp, res,
                    const_string(interp, "'"));
        }
        res = string_append(interp, res,
                const_string(interp, ": "));
        val = Parrot_Hash_get_pmc_keyed_str(interp, pmc, key);
        res = string_append(interp, res,
                VTABLE_get_string(interp, val));
        if (j < n - 1)
            res = string_append(interp, res,
                    const_string(interp, ", "));
    }
    res = string_append(interp, res,
            const_string(interp, "}"));
    return res;

}
#line 543 "src/pmc/hash.c"
STRING*
Parrot_Hash_get_string(Interp *interp, PMC* pmc)
#line 366 "./src/pmc/hash.pmc"
{
    return Parrot_sprintf_c(interp, "Hash[0x%x]", pmc);

}
#line 551 "src/pmc/hash.c"
STRING*
Parrot_Hash_get_string_keyed(Interp *interp, PMC* pmc, PMC* key)
#line 451 "./src/pmc/hash.pmc"
{
    PMC         *valpmc;
    STRING      *keystr;
    HashBucket  *b;
    PMC         *nextkey;
    Hash * const hash = (Hash *)PMC_struct_val(pmc);

    switch (PObj_get_FLAGS(key) & KEY_type_FLAGS) {
        case KEY_hash_iterator_FLAGS:
            /* called from iterator with an integer idx in key */
            if (hash->key_type == Hash_key_type_int) {
                INTVAL i = (INTVAL)parrot_hash_get_idx(interp, hash, key);
                return string_from_int(interp, i);
            }
            return (STRING *)parrot_hash_get_idx(interp, hash, key);
        default:
            keystr = make_hash_key(interp, key);
    }

    b = parrot_hash_get_bucket(interp, hash, keystr);

    if (b == NULL) {
        /*
         * TODO current behaviour of $S0 = hsh['no_such_key'] in
         *      PGE and possibly more code needs an empty STRING
         *      (--leo)
         */
        return string_make_empty(interp, enum_stringrep_one, 0);
    }

    nextkey = key_next(interp, key);
    valpmc  = (PMC *)b->value;

    if (!nextkey)
        return VTABLE_get_string(interp, valpmc);

    return VTABLE_get_string_keyed(interp, valpmc, nextkey);

}
#line 594 "src/pmc/hash.c"
STRING*
Parrot_Hash_get_string_keyed_int(Interp *interp, PMC* pmc, INTVAL key)
#line 436 "./src/pmc/hash.pmc"
{
    STRING * const s = string_from_int(interp, key);
    return Parrot_Hash_get_string_keyed_str(interp, pmc, s);

}
#line 603 "src/pmc/hash.c"
STRING*
Parrot_Hash_get_string_keyed_str(Interp *interp, PMC* pmc, STRING* key)
#line 422 "./src/pmc/hash.pmc"
{
    HashBucket * const b =
        parrot_hash_get_bucket(interp, (Hash*) PMC_struct_val(pmc), key);
    if (b == NULL) {
        /*
         * TODO current behaviour of $S0 = hsh['no_such_key'] in
         *      PGE and possibly more code needs an empty STRING
         *      (--leo)
         */
        return string_make_empty(interp,enum_stringrep_one,0);
    }
    return VTABLE_get_string(interp, (PMC*) b->value);

}
#line 621 "src/pmc/hash.c"
void
Parrot_Hash_init(Interp *interp, PMC* pmc)
#line 120 "./src/pmc/hash.pmc"
{
    PMC_struct_val(pmc) = NULL;
    PObj_custom_mark_destroy_SETALL(pmc);
    parrot_new_pmc_hash(interp, pmc);

}
#line 631 "src/pmc/hash.c"
INTVAL
Parrot_Hash_is_same(Interp *interp, PMC* pmc, PMC* other)
#line 628 "./src/pmc/hash.pmc"
{
    return (INTVAL)(other->vtable == pmc->vtable &&
        PMC_struct_val(other) == PMC_struct_val(pmc));

}
#line 640 "src/pmc/hash.c"
void
Parrot_Hash_mark(Interp *interp, PMC* pmc)
#line 142 "./src/pmc/hash.pmc"
{
    if (PMC_struct_val(pmc))
        parrot_mark_hash(interp, (Hash *)PMC_struct_val(pmc));

}
#line 649 "src/pmc/hash.c"
void
Parrot_Hash_set_integer_keyed(Interp *interp, PMC* pmc, PMC *key, INTVAL value)
#line 641 "./src/pmc/hash.pmc"
{
    STRING *keystr;
    PMC    *nextkey;
    PMC    *box;

    if (!key)
        return;

    keystr  = make_hash_key(interp, key);
    nextkey = key_next(interp, key);

    if (nextkey == NULL) {
        PMC* val = get_integer_pmc(interp, pmc->vtable->base_type);

        VTABLE_set_integer_native(interp, val, value);
        parrot_hash_put(interp, (Hash *)PMC_struct_val(pmc), keystr, val);
        return;
    }
    box = Parrot_Hash_get_pmc_keyed_str(interp, pmc, keystr);
    if (box == NULL) {
        /* autovivify an Hash */
        box = pmc_new(interp,  VTABLE_type(interp, pmc));
    }
    VTABLE_set_integer_keyed(interp, box, nextkey, value);

}
#line 679 "src/pmc/hash.c"
void
Parrot_Hash_set_integer_keyed_str(Interp *interp, PMC* pmc, STRING *key, INTVAL value)
#line 675 "./src/pmc/hash.pmc"
{
    PMC * const val  = get_integer_pmc(interp, pmc->vtable->base_type);

    PMC_int_val(val) = value;

    parrot_hash_put(interp, (Hash *)PMC_struct_val(pmc), key, val);

}
#line 691 "src/pmc/hash.c"
void
Parrot_Hash_set_number_keyed(Interp *interp, PMC* pmc, PMC *key, FLOATVAL value)
#line 691 "./src/pmc/hash.pmc"
{
    STRING *keystr;
    PMC    *nextkey;
    PMC    *box;

    if (!key)
        return;

    keystr  = make_hash_key(interp, key);
    nextkey = key_next(interp, key);

    if (nextkey == NULL) {
        PMC* val = get_number_pmc(interp, pmc->vtable->base_type);
        PMC_num_val(val) = value;
        parrot_hash_put(interp, (Hash *)PMC_struct_val(pmc), keystr, val);
        return;
    }

    box = Parrot_Hash_get_pmc_keyed_str(interp, pmc, keystr);

    /* autovivify an Hash */
    if (box == NULL)
        box = pmc_new(interp,  VTABLE_type(interp, pmc));

    VTABLE_set_number_keyed(interp, box, nextkey, value);

}
#line 722 "src/pmc/hash.c"
void
Parrot_Hash_set_number_keyed_str(Interp *interp, PMC* pmc, STRING *key, FLOATVAL value)
#line 728 "./src/pmc/hash.pmc"
{
    PMC * const val  = get_number_pmc(interp, pmc->vtable->base_type);

    PMC_num_val(val) = value;

    parrot_hash_put(interp, (Hash *)PMC_struct_val(pmc), key, val);

}
#line 734 "src/pmc/hash.c"
void
Parrot_Hash_set_pmc_keyed(Interp *interp, PMC* pmc, PMC *key, PMC *value)
#line 794 "./src/pmc/hash.pmc"
{
    STRING *keystr;
    PMC    *nextkey;
    PMC    *box;

    if (!key)
        return;

    keystr  = make_hash_key(interp, key);
    nextkey = key_next(interp, key);

    if (nextkey == NULL) {
        parrot_hash_put(interp, (Hash*)PMC_struct_val(pmc), keystr, value);
        return;
    }

    box = Parrot_Hash_get_pmc_keyed_str(interp, pmc, keystr);

    /* autovivify an Hash */
    if (box == NULL)
        box = pmc_new(interp,  VTABLE_type(interp, pmc));

    VTABLE_set_pmc_keyed(interp, box, nextkey, value);

}
#line 763 "src/pmc/hash.c"
void
Parrot_Hash_set_pmc_keyed_str(Interp *interp, PMC* pmc, STRING *key, PMC *value)
#line 829 "./src/pmc/hash.pmc"
{
    parrot_hash_put(interp, (Hash *)PMC_struct_val(pmc), key, value);

}
#line 771 "src/pmc/hash.c"
void
Parrot_Hash_set_string_keyed(Interp *interp, PMC* pmc, PMC *key, STRING *value)
#line 744 "./src/pmc/hash.pmc"
{
    STRING *keystr;
    PMC    *nextkey;
    PMC    *box;

    if (!key)
        return;

    keystr  = make_hash_key(interp, key);
    nextkey = key_next(interp, key);

    if (nextkey == NULL) {
        PMC* const val = get_string_pmc(interp, pmc->vtable->base_type);
        VTABLE_set_string_native(interp, val, value);
        parrot_hash_put(interp, (Hash *)PMC_struct_val(pmc), keystr, val);
        return;
    }

    box = Parrot_Hash_get_pmc_keyed_str(interp, pmc, keystr);

    /* autovivify an Hash */
    if (box == NULL)
        box = pmc_new(interp,  VTABLE_type(interp, pmc));

    VTABLE_set_string_keyed(interp, box, nextkey, value);

}
#line 802 "src/pmc/hash.c"
void
Parrot_Hash_set_string_keyed_str(Interp *interp, PMC* pmc, STRING *key, STRING *value)
#line 779 "./src/pmc/hash.pmc"
{
    PMC* const val = get_string_pmc(interp, pmc->vtable->base_type);

    VTABLE_set_string_native(interp, val, value);
    parrot_hash_put(interp, (Hash *)PMC_struct_val(pmc), key, val);

}
#line 813 "src/pmc/hash.c"
PMC*
Parrot_Hash_slice(Interp *interp, PMC* pmc, PMC* key, INTVAL f)
#line 997 "./src/pmc/hash.pmc"
{
    switch (f) {
        case 0:
            {
                PMC * const iter = pmc_new_init(interp,
                        enum_class_Iterator, pmc);
                PMC_struct_val(iter) = key;
                return iter;
            }
    }
    real_exception(interp, NULL, E_IndexError,
            "Hash: Unknown slice type");
    return NULL;

}
#line 832 "src/pmc/hash.c"
void
Parrot_Hash_thaw(Interp *interp, PMC* pmc, visit_info *info)
#line 1059 "./src/pmc/hash.pmc"
{
    IMAGE_IO * const io = info->image_io;

    Parrot_default_thaw(interp, pmc, info);
    if (info->extra_flags == EXTRA_IS_NULL) {
        const INTVAL elems =  VTABLE_shift_integer(interp, io);
        const INTVAL k_type =  VTABLE_shift_integer(interp, io);
        const INTVAL v_type =  VTABLE_shift_integer(interp, io);
        Hash *hash;

        /* TODO make a better interface for hash creation
         * TODO create hash with needed size in the first place
         */
        if (k_type == Hash_key_type_int && v_type == enum_hash_int) {
            PMC * const dummy = Parrot_new_INTVAL_hash(interp, 0);
            PMC_struct_val(pmc) = PMC_struct_val(dummy);
            PMC_struct_val(dummy) = NULL;
        }
        else
            Parrot_Hash_init(interp, pmc);

        hash            = (Hash *)PMC_struct_val(pmc);

        assert((INTVAL)hash->key_type == k_type);
        assert(hash->entry_type       == v_type);

        hash->container = pmc;
        hash->entries   = elems;
    }

}
#line 867 "src/pmc/hash.c"
INTVAL
Parrot_Hash_type_keyed(Interp *interp, PMC* pmc, PMC *key)
#line 176 "./src/pmc/hash.pmc"
{
    PMC               *valpmc;
    PMC               *nextkey;
    STRING     * const keystr = make_hash_key(interp, key);
    HashBucket * const b      =
        parrot_hash_get_bucket(interp, (Hash*)PMC_struct_val(pmc), keystr);

    if (b == NULL)
        return 0;

    nextkey = key_next(interp, key);
    valpmc  = (PMC *)b->value;

    if (!nextkey)
        return VTABLE_type(interp, valpmc);

    return VTABLE_type_keyed(interp, valpmc, nextkey);

}
#line 890 "src/pmc/hash.c"
INTVAL
Parrot_Hash_type_keyed_str(Interp *interp, PMC* pmc, STRING* key)
#line 157 "./src/pmc/hash.pmc"
{
    HashBucket* const b =
        parrot_hash_get_bucket(interp, (Hash*) PMC_struct_val(pmc), key);
    if (b == NULL) {
        return 0;
    }
    return VTABLE_type(interp, (PMC*) b->value);

}
#line 903 "src/pmc/hash.c"
void
Parrot_Hash_visit(Interp *interp, PMC* pmc, visit_info *info)
#line 1023 "./src/pmc/hash.pmc"
{
    info->container = pmc;
    parrot_hash_visit(interp, (Hash*)PMC_struct_val(pmc), info);
    Parrot_default_visit(interp, pmc, info);

}
#line 913 "src/pmc/hash.c"
void
Parrot_Hash_ro_add_attribute(Interp *interp, PMC* pmc, STRING* name, PMC* type)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "add_attribute() in read-only instance of Hash");
}
void
Parrot_Hash_ro_add_method(Interp *interp, PMC* pmc, STRING* method_name, PMC* sub_pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "add_method() in read-only instance of Hash");
}
void
Parrot_Hash_ro_add_parent(Interp *interp, PMC* pmc, PMC* parent)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "add_parent() in read-only instance of Hash");
}
void
Parrot_Hash_ro_add_role(Interp *interp, PMC* pmc, PMC* role)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "add_role() in read-only instance of Hash");
}
void
Parrot_Hash_ro_assign_pmc(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "assign_pmc() in read-only instance of Hash");
}
void
Parrot_Hash_ro_assign_string_native(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "assign_string_native() in read-only instance of Hash");
}
void
Parrot_Hash_ro_decrement(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "decrement() in read-only instance of Hash");
}
void
Parrot_Hash_ro_delete_keyed(Interp *interp, PMC* pmc, PMC* key)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "delete_keyed() in read-only instance of Hash");
}
void
Parrot_Hash_ro_delete_keyed_int(Interp *interp, PMC* pmc, INTVAL key)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "delete_keyed_int() in read-only instance of Hash");
}
void
Parrot_Hash_ro_delete_keyed_str(Interp *interp, PMC* pmc, STRING* key)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "delete_keyed_str() in read-only instance of Hash");
}
PMC*
Parrot_Hash_ro_find_method(Interp *interp, PMC* pmc, STRING* method_name)
 {
    PMC *const method = Parrot_default_find_method(interp, pmc, method_name);
    if (!PMC_IS_NULL(VTABLE_getprop(interp, method, const_string(interp, "write"))))
        return PMCNULL;
    else
        return method;
}
void
Parrot_Hash_ro_i_absolute(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_absolute() in read-only instance of Hash");
}
void
Parrot_Hash_ro_i_bitwise_not(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_bitwise_not() in read-only instance of Hash");
}
void
Parrot_Hash_ro_i_bitwise_nots(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_bitwise_nots() in read-only instance of Hash");
}
void
Parrot_Hash_ro_i_logical_not(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_logical_not() in read-only instance of Hash");
}
void
Parrot_Hash_ro_i_neg(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_neg() in read-only instance of Hash");
}
void
Parrot_Hash_ro_increment(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "increment() in read-only instance of Hash");
}
void
Parrot_Hash_ro_morph(Interp *interp, PMC* pmc, INTVAL type)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "morph() in read-only instance of Hash");
}
FLOATVAL
Parrot_Hash_ro_pop_float(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "pop_float() in read-only instance of Hash");
    return (FLOATVAL)0;
}
INTVAL
Parrot_Hash_ro_pop_integer(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "pop_integer() in read-only instance of Hash");
    return (INTVAL)0;
}
PMC*
Parrot_Hash_ro_pop_pmc(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "pop_pmc() in read-only instance of Hash");
    return PMCNULL;
}
STRING*
Parrot_Hash_ro_pop_string(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "pop_string() in read-only instance of Hash");
    return (STRING*)0;
}
void
Parrot_Hash_ro_push_float(Interp *interp, PMC* pmc, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "push_float() in read-only instance of Hash");
}
void
Parrot_Hash_ro_push_integer(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "push_integer() in read-only instance of Hash");
}
void
Parrot_Hash_ro_push_pmc(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "push_pmc() in read-only instance of Hash");
}
void
Parrot_Hash_ro_push_string(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "push_string() in read-only instance of Hash");
}
void
Parrot_Hash_ro_remove_attribute(Interp *interp, PMC* pmc, STRING* name)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "remove_attribute() in read-only instance of Hash");
}
void
Parrot_Hash_ro_remove_method(Interp *interp, PMC* pmc, STRING* method_name)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "remove_method() in read-only instance of Hash");
}
void
Parrot_Hash_ro_remove_parent(Interp *interp, PMC* pmc, PMC* parent)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "remove_parent() in read-only instance of Hash");
}
void
Parrot_Hash_ro_remove_role(Interp *interp, PMC* pmc, PMC* role)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "remove_role() in read-only instance of Hash");
}
void
Parrot_Hash_ro_set_attr(Interp *interp, PMC* pmc, INTVAL idx, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_attr() in read-only instance of Hash");
}
void
Parrot_Hash_ro_set_attr_str(Interp *interp, PMC* pmc, STRING* idx, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_attr_str() in read-only instance of Hash");
}
void
Parrot_Hash_ro_set_bignum_int(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_bignum_int() in read-only instance of Hash");
}
void
Parrot_Hash_ro_set_bignum_num(Interp *interp, PMC* pmc, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_bignum_num() in read-only instance of Hash");
}
void
Parrot_Hash_ro_set_bignum_str(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_bignum_str() in read-only instance of Hash");
}
void
Parrot_Hash_ro_set_bool(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_bool() in read-only instance of Hash");
}
void
Parrot_Hash_ro_set_integer_keyed(Interp *interp, PMC* pmc, PMC* key, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_keyed() in read-only instance of Hash");
}
void
Parrot_Hash_ro_set_integer_keyed_int(Interp *interp, PMC* pmc, INTVAL key, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_keyed_int() in read-only instance of Hash");
}
void
Parrot_Hash_ro_set_integer_keyed_str(Interp *interp, PMC* pmc, STRING* key, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_keyed_str() in read-only instance of Hash");
}
void
Parrot_Hash_ro_set_integer_native(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_native() in read-only instance of Hash");
}
void
Parrot_Hash_ro_set_integer_same(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_same() in read-only instance of Hash");
}
void
Parrot_Hash_ro_set_number_keyed(Interp *interp, PMC* pmc, PMC* key, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_keyed() in read-only instance of Hash");
}
void
Parrot_Hash_ro_set_number_keyed_int(Interp *interp, PMC* pmc, INTVAL key, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_keyed_int() in read-only instance of Hash");
}
void
Parrot_Hash_ro_set_number_keyed_str(Interp *interp, PMC* pmc, STRING* key, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_keyed_str() in read-only instance of Hash");
}
void
Parrot_Hash_ro_set_number_native(Interp *interp, PMC* pmc, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_native() in read-only instance of Hash");
}
void
Parrot_Hash_ro_set_number_same(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_same() in read-only instance of Hash");
}
void
Parrot_Hash_ro_set_pmc(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pmc() in read-only instance of Hash");
}
void
Parrot_Hash_ro_set_pmc_keyed(Interp *interp, PMC* pmc, PMC* key, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pmc_keyed() in read-only instance of Hash");
}
void
Parrot_Hash_ro_set_pmc_keyed_int(Interp *interp, PMC* pmc, INTVAL key, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_int() in read-only instance of Hash");
}
void
Parrot_Hash_ro_set_pmc_keyed_str(Interp *interp, PMC* pmc, STRING* key, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_str() in read-only instance of Hash");
}
void
Parrot_Hash_ro_set_pointer(Interp *interp, PMC* pmc, void* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pointer() in read-only instance of Hash");
}
void
Parrot_Hash_ro_set_pointer_keyed(Interp *interp, PMC* pmc, PMC* key, void* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pointer_keyed() in read-only instance of Hash");
}
void
Parrot_Hash_ro_set_pointer_keyed_int(Interp *interp, PMC* pmc, INTVAL key, void* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_int() in read-only instance of Hash");
}
void
Parrot_Hash_ro_set_pointer_keyed_str(Interp *interp, PMC* pmc, STRING* key, void* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_str() in read-only instance of Hash");
}
void
Parrot_Hash_ro_set_string_keyed(Interp *interp, PMC* pmc, PMC* key, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_keyed() in read-only instance of Hash");
}
void
Parrot_Hash_ro_set_string_keyed_int(Interp *interp, PMC* pmc, INTVAL key, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_keyed_int() in read-only instance of Hash");
}
void
Parrot_Hash_ro_set_string_keyed_str(Interp *interp, PMC* pmc, STRING* key, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_keyed_str() in read-only instance of Hash");
}
void
Parrot_Hash_ro_set_string_native(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_native() in read-only instance of Hash");
}
void
Parrot_Hash_ro_set_string_same(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_same() in read-only instance of Hash");
}
FLOATVAL
Parrot_Hash_ro_shift_float(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "shift_float() in read-only instance of Hash");
    return (FLOATVAL)0;
}
INTVAL
Parrot_Hash_ro_shift_integer(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "shift_integer() in read-only instance of Hash");
    return (INTVAL)0;
}
PMC*
Parrot_Hash_ro_shift_pmc(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "shift_pmc() in read-only instance of Hash");
    return PMCNULL;
}
STRING*
Parrot_Hash_ro_shift_string(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "shift_string() in read-only instance of Hash");
    return (STRING*)0;
}
void
Parrot_Hash_ro_splice(Interp *interp, PMC* pmc, PMC* value, INTVAL offset, INTVAL count)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "splice() in read-only instance of Hash");
}
void
Parrot_Hash_ro_thaw(Interp *interp, PMC* pmc, visit_info* info)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "thaw() in read-only instance of Hash");
}
void
Parrot_Hash_ro_thawfinish(Interp *interp, PMC* pmc, visit_info* info)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "thawfinish() in read-only instance of Hash");
}
void
Parrot_Hash_ro_unshift_float(Interp *interp, PMC* pmc, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "unshift_float() in read-only instance of Hash");
}
void
Parrot_Hash_ro_unshift_integer(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "unshift_integer() in read-only instance of Hash");
}
void
Parrot_Hash_ro_unshift_pmc(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "unshift_pmc() in read-only instance of Hash");
}
void
Parrot_Hash_ro_unshift_string(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "unshift_string() in read-only instance of Hash");
}
void
Parrot_Hash_class_init(Parrot_Interp interp, int entry, int pass)
{
    const VTABLE temp_base_vtable = {
        NULL, /* namespace */
        enum_class_Hash, /* base_type */
        NULL, /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_HAS_READONLY_FLAG, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        NULL,   /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_default_add_attribute,
        Parrot_default_add_method,
        Parrot_default_add_parent,
        Parrot_default_add_role,
        Parrot_default_assign_pmc,
        Parrot_default_assign_string_native,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_can,
        Parrot_default_class_type,
        Parrot_Hash_clone,
        Parrot_default_clone_pmc,
        Parrot_default_decrement,
        Parrot_default_defined,
        Parrot_Hash_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_Hash_defined_keyed_str,
        Parrot_Hash_delete_keyed,
        Parrot_default_delete_keyed_int,
        Parrot_Hash_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_Hash_destroy,
        Parrot_default_does,
        Parrot_Hash_elements,
        Parrot_Hash_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_Hash_exists_keyed_str,
        Parrot_default_find_method,
        Parrot_Hash_freeze,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_Hash_get_bool,
        Parrot_default_get_class,
        Parrot_Hash_get_integer,
        Parrot_Hash_get_integer_keyed,
        Parrot_Hash_get_integer_keyed_int,
        Parrot_Hash_get_integer_keyed_str,
        Parrot_Hash_get_iter,
        Parrot_default_get_number,
        Parrot_Hash_get_number_keyed,
        Parrot_Hash_get_number_keyed_int,
        Parrot_Hash_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_Hash_get_pmc_keyed,
        Parrot_Hash_get_pmc_keyed_int,
        Parrot_Hash_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_Hash_get_repr,
        Parrot_Hash_get_string,
        Parrot_Hash_get_string_keyed,
        Parrot_Hash_get_string_keyed_int,
        Parrot_Hash_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_default_hash,
        Parrot_default_i_absolute,
        Parrot_default_i_bitwise_not,
        Parrot_default_i_bitwise_nots,
        Parrot_default_i_logical_not,
        Parrot_default_i_neg,
        Parrot_default_increment,
        Parrot_Hash_init,
        Parrot_default_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_default_instantiate,
        Parrot_default_invoke,
        Parrot_Hash_is_same,
        Parrot_default_isa,
        Parrot_default_logical_not,
        Parrot_Hash_mark,
        Parrot_default_morph,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_new_from_string,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_pmc_namespace,
        Parrot_default_pop_float,
        Parrot_default_pop_integer,
        Parrot_default_pop_pmc,
        Parrot_default_pop_string,
        Parrot_default_push_float,
        Parrot_default_push_integer,
        Parrot_default_push_pmc,
        Parrot_default_push_string,
        Parrot_default_remove_attribute,
        Parrot_default_remove_method,
        Parrot_default_remove_parent,
        Parrot_default_remove_role,
        Parrot_default_set_attr,
        Parrot_default_set_attr_str,
        Parrot_default_set_bignum_int,
        Parrot_default_set_bignum_num,
        Parrot_default_set_bignum_str,
        Parrot_default_set_bool,
        Parrot_Hash_set_integer_keyed,
        Parrot_default_set_integer_keyed_int,
        Parrot_Hash_set_integer_keyed_str,
        Parrot_default_set_integer_native,
        Parrot_default_set_integer_same,
        Parrot_Hash_set_number_keyed,
        Parrot_default_set_number_keyed_int,
        Parrot_Hash_set_number_keyed_str,
        Parrot_default_set_number_native,
        Parrot_default_set_number_same,
        Parrot_default_set_pmc,
        Parrot_Hash_set_pmc_keyed,
        Parrot_default_set_pmc_keyed_int,
        Parrot_Hash_set_pmc_keyed_str,
        Parrot_default_set_pointer,
        Parrot_default_set_pointer_keyed,
        Parrot_default_set_pointer_keyed_int,
        Parrot_default_set_pointer_keyed_str,
        Parrot_Hash_set_string_keyed,
        Parrot_default_set_string_keyed_int,
        Parrot_Hash_set_string_keyed_str,
        Parrot_default_set_string_native,
        Parrot_default_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_default_shift_float,
        Parrot_default_shift_integer,
        Parrot_default_shift_pmc,
        Parrot_default_shift_string,
        Parrot_Hash_slice,
        Parrot_default_splice,
        Parrot_default_subclass,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtype,
        Parrot_Hash_thaw,
        Parrot_default_thawfinish,
        Parrot_default_type,
        Parrot_Hash_type_keyed,
        Parrot_default_type_keyed_int,
        Parrot_Hash_type_keyed_str,
        Parrot_default_unshift_float,
        Parrot_default_unshift_integer,
        Parrot_default_unshift_pmc,
        Parrot_default_unshift_string,
        Parrot_Hash_visit
    };

    const VTABLE temp_ro_vtable = {
        NULL, /* namespace */
        enum_class_Hash, /* base_type */
        NULL, /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_IS_READONLY_FLAG, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        NULL,   /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_Hash_ro_add_attribute,
        Parrot_Hash_ro_add_method,
        Parrot_Hash_ro_add_parent,
        Parrot_Hash_ro_add_role,
        Parrot_Hash_ro_assign_pmc,
        Parrot_Hash_ro_assign_string_native,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_can,
        Parrot_default_class_type,
        Parrot_Hash_clone,
        Parrot_default_clone_pmc,
        Parrot_Hash_ro_decrement,
        Parrot_default_defined,
        Parrot_Hash_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_Hash_defined_keyed_str,
        Parrot_Hash_ro_delete_keyed,
        Parrot_Hash_ro_delete_keyed_int,
        Parrot_Hash_ro_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_Hash_destroy,
        Parrot_default_does,
        Parrot_Hash_elements,
        Parrot_Hash_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_Hash_exists_keyed_str,
        Parrot_Hash_ro_find_method,
        Parrot_Hash_freeze,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_Hash_get_bool,
        Parrot_default_get_class,
        Parrot_Hash_get_integer,
        Parrot_Hash_get_integer_keyed,
        Parrot_Hash_get_integer_keyed_int,
        Parrot_Hash_get_integer_keyed_str,
        Parrot_Hash_get_iter,
        Parrot_default_get_number,
        Parrot_Hash_get_number_keyed,
        Parrot_Hash_get_number_keyed_int,
        Parrot_Hash_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_Hash_get_pmc_keyed,
        Parrot_Hash_get_pmc_keyed_int,
        Parrot_Hash_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_Hash_get_repr,
        Parrot_Hash_get_string,
        Parrot_Hash_get_string_keyed,
        Parrot_Hash_get_string_keyed_int,
        Parrot_Hash_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_default_hash,
        Parrot_Hash_ro_i_absolute,
        Parrot_Hash_ro_i_bitwise_not,
        Parrot_Hash_ro_i_bitwise_nots,
        Parrot_Hash_ro_i_logical_not,
        Parrot_Hash_ro_i_neg,
        Parrot_Hash_ro_increment,
        Parrot_Hash_init,
        Parrot_default_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_default_instantiate,
        Parrot_default_invoke,
        Parrot_Hash_is_same,
        Parrot_default_isa,
        Parrot_default_logical_not,
        Parrot_Hash_mark,
        Parrot_Hash_ro_morph,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_new_from_string,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_pmc_namespace,
        Parrot_Hash_ro_pop_float,
        Parrot_Hash_ro_pop_integer,
        Parrot_Hash_ro_pop_pmc,
        Parrot_Hash_ro_pop_string,
        Parrot_Hash_ro_push_float,
        Parrot_Hash_ro_push_integer,
        Parrot_Hash_ro_push_pmc,
        Parrot_Hash_ro_push_string,
        Parrot_Hash_ro_remove_attribute,
        Parrot_Hash_ro_remove_method,
        Parrot_Hash_ro_remove_parent,
        Parrot_Hash_ro_remove_role,
        Parrot_Hash_ro_set_attr,
        Parrot_Hash_ro_set_attr_str,
        Parrot_Hash_ro_set_bignum_int,
        Parrot_Hash_ro_set_bignum_num,
        Parrot_Hash_ro_set_bignum_str,
        Parrot_Hash_ro_set_bool,
        Parrot_Hash_ro_set_integer_keyed,
        Parrot_Hash_ro_set_integer_keyed_int,
        Parrot_Hash_ro_set_integer_keyed_str,
        Parrot_Hash_ro_set_integer_native,
        Parrot_Hash_ro_set_integer_same,
        Parrot_Hash_ro_set_number_keyed,
        Parrot_Hash_ro_set_number_keyed_int,
        Parrot_Hash_ro_set_number_keyed_str,
        Parrot_Hash_ro_set_number_native,
        Parrot_Hash_ro_set_number_same,
        Parrot_Hash_ro_set_pmc,
        Parrot_Hash_ro_set_pmc_keyed,
        Parrot_Hash_ro_set_pmc_keyed_int,
        Parrot_Hash_ro_set_pmc_keyed_str,
        Parrot_Hash_ro_set_pointer,
        Parrot_Hash_ro_set_pointer_keyed,
        Parrot_Hash_ro_set_pointer_keyed_int,
        Parrot_Hash_ro_set_pointer_keyed_str,
        Parrot_Hash_ro_set_string_keyed,
        Parrot_Hash_ro_set_string_keyed_int,
        Parrot_Hash_ro_set_string_keyed_str,
        Parrot_Hash_ro_set_string_native,
        Parrot_Hash_ro_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_Hash_ro_shift_float,
        Parrot_Hash_ro_shift_integer,
        Parrot_Hash_ro_shift_pmc,
        Parrot_Hash_ro_shift_string,
        Parrot_Hash_slice,
        Parrot_Hash_ro_splice,
        Parrot_default_subclass,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtype,
        Parrot_Hash_ro_thaw,
        Parrot_Hash_ro_thawfinish,
        Parrot_default_type,
        Parrot_Hash_type_keyed,
        Parrot_default_type_keyed_int,
        Parrot_Hash_type_keyed_str,
        Parrot_Hash_ro_unshift_float,
        Parrot_Hash_ro_unshift_integer,
        Parrot_Hash_ro_unshift_pmc,
        Parrot_Hash_ro_unshift_string,
        Parrot_Hash_visit
    };

    const  MMD_init _temp_mmd_init[] = {
        { MMD_EQ, 0, enum_type_PMC, (funcptr_t) Parrot_Hash_is_equal }
    };
    /*  Dynamic PMCs need the runtime type
    which is passed in entry to class_init.
    */
    if (pass == 0) {
        /*
         * create vtable - clone it - we have to set a few items
         */
        VTABLE *vt_clone =
            Parrot_clone_vtable(interp, &temp_base_vtable);
        VTABLE *vt_ro_clone =
            Parrot_clone_vtable(interp, &temp_ro_vtable);
        vt_clone->whoami = CONST_STRING(interp, "Hash");
        vt_clone->isa_str = CONST_STRING(interp, "Hash");
        vt_clone->does_str = CONST_STRING(interp, "hash");
        vt_ro_clone->base_type = entry;
        vt_ro_clone->whoami = vt_clone->whoami;
        vt_ro_clone->isa_str = vt_clone->isa_str;
        vt_ro_clone->does_str = vt_clone->does_str;
        vt_clone->ro_variant_vtable = vt_ro_clone;
        vt_ro_clone->ro_variant_vtable = vt_clone;
        interp->vtables[entry] = vt_clone;
    }
    else { /* pass */
        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        /* create PMC Proxy object */
        Parrot_create_pmc_proxy(interp, entry);
        /* class_init */
        {
#define N_MMD_INIT (sizeof(_temp_mmd_init)/sizeof(_temp_mmd_init[0]))
            Parrot_mmd_register_table(interp, entry,
                _temp_mmd_init, N_MMD_INIT);
        }
    } /* pass */
} /* Parrot_Hash_class_init */


/*

=back

=head1 SEE ALSO

F<docs/pdds/pdd08_keys.pod>.

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
