/*
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/integer.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

#line 1 "./src/pmc/integer.pmc"
/*
Copyright (C) 2003-2006, The Perl Foundation.
$Id: integer.pmc 16275 2006-12-28 01:20:44Z particle $

=head1 NAME

src/pmc/integer.pmc - Integer PMC class

=head1 DESCRIPTION

C<Integer> provides an integer for languages
that want a value-restricted integer type without going to an I
register.

=head2 Functions

=over 4

=cut

*/

#include "parrot/parrot.h"
#include <assert.h>

/* XXX create MMD headers to in Pmc2c.pm */
extern INTVAL Parrot_BigInt_is_equal_BigInt(Interp*, PMC*, PMC*);
extern PMC* Parrot_BigInt_multiply_int(Interp *interp,
        PMC* pmc, INTVAL value, PMC* dest) ;

static PMC*
overflow(Interp *interp, PMC *self, INTVAL b, PMC *dest, int mmd)
{
    const INTVAL a = VTABLE_get_integer(interp, self);

    if (PARROT_ERRORS_test(interp,PARROT_ERRORS_OVERFLOW_FLAG)) {
        real_exception(interp, NULL, ERR_OVERFLOW,
                "Integer overflow");
    }
    if (self == dest) {
        /* TODO preserve type system */
        VTABLE_morph(interp, self, enum_class_BigInt);
        VTABLE_set_integer_native(interp, self, a);
        return mmd_dispatch_p_pip(interp, self, b, dest, mmd);
    }
    else {
        PMC * const temp = VTABLE_get_bignum(interp, self);
        return mmd_dispatch_p_pip(interp, temp, b, dest, mmd);
    }
}

static PMC*
overflow_p(Interp *interp, PMC *self, PMC *val, PMC *dest, int mmd)
{
    const INTVAL a = VTABLE_get_integer(interp, self);

    if (PARROT_ERRORS_test(interp,PARROT_ERRORS_OVERFLOW_FLAG)) {
        real_exception(interp, NULL, ERR_OVERFLOW,
                "Integer overflow");
    }
    if (self == dest) {
        VTABLE_morph(interp, self, enum_class_BigInt);
        VTABLE_set_integer_native(interp, self, a);
        return mmd_dispatch_p_ppp(interp, self, val, dest, mmd);
    }
    else {
        PMC * const temp = VTABLE_get_bignum(interp, self);
        return mmd_dispatch_p_ppp(interp, temp, val, dest, mmd);
    }
}

#line 84 "src/pmc/integer.c"
#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_integer.h"
#include "pmc_scalar.h"
#include "pmc_default.h"
#include "integer.str"

PMC*
Parrot_Integer_add(Interp *interp, PMC* pmc, PMC* value, PMC* dest)
#line 323 "./src/pmc/integer.pmc"
{
        if (!dest)
            dest = pmc_new(interp, value->vtable->base_type);
        VTABLE_set_number_native(interp, dest,
             VTABLE_get_integer(interp, pmc) + VTABLE_get_number(interp, value));
        return dest;
}
#line 103 "src/pmc/integer.c"
PMC*
Parrot_Integer_add_Integer(Interp *interp, PMC* pmc, PMC* value, PMC* dest)
{
        /*
         * pmc and value can both be PMCs that inherit
         * from Integer:
         *   cl = subclass "Integer", "MyInt"
         * so we can't used PMC_int_val(pmc) in any of these
         * Integer methods
         *
         * TODO
         *   check for exact Integer type
         *   e.g. MMD_Integer_EXACT
         */

        const INTVAL a =  VTABLE_get_integer(interp, pmc);
        const INTVAL b = VTABLE_get_integer(interp, value);
        const INTVAL c = a + b;
        if ((c^a) >= 0 || (c^b) >= 0) {
            if (!dest)
                dest = pmc_new(interp, pmc->vtable->base_type);
            /* need this for e.g. Undef PMC */
            VTABLE_set_integer_native(interp, dest, c);
            return dest;
        }
        else
            return overflow(interp, pmc, b, dest, MMD_ADD);
}PMC*
Parrot_Integer_add_Complex(Interp *interp, PMC* pmc, PMC* value, PMC* dest)
{
        const INTVAL a =  VTABLE_get_integer(interp, pmc);
        if (dest)
            VTABLE_morph(interp, dest, value->vtable->base_type);
        else
            dest = pmc_new(interp, value->vtable->base_type);
        VTABLE_set_number_native(interp, dest,
                a + VTABLE_get_number_keyed_int(interp, value, 0));
        VTABLE_set_number_keyed_int(interp, dest, 1,
                VTABLE_get_number_keyed_int(interp, value, 1));
        return dest;
}PMC*
Parrot_Integer_add_BigInt(Interp *interp, PMC* pmc, PMC* value, PMC* dest)
{
        return overflow_p(interp, pmc, value, dest, MMD_ADD);
}
PMC*
Parrot_Integer_add_int(Interp *interp, PMC* pmc, INTVAL b, PMC* dest)
#line 374 "./src/pmc/integer.pmc"
{
    /* INTVAL a = PMC_int_val(pmc); */
    const INTVAL a = VTABLE_get_integer(interp, pmc);
    const INTVAL c = a + b;
    if ((c^a) >= 0 || (c^b) >= 0) {
        if (!dest)
            dest = pmc_new(interp, pmc->vtable->base_type);
        VTABLE_set_integer_native(interp, dest, c);
        return dest;
    }
    else
        return overflow(interp, pmc, b, dest, MMD_ADD);

}
#line 166 "src/pmc/integer.c"
void
Parrot_Integer_i_add(Interp *interp, PMC* pmc, PMC* value)
#line 402 "./src/pmc/integer.pmc"
{
    VTABLE_set_number_native(interp, pmc,
        PMC_int_val(pmc) + VTABLE_get_number(interp, value));
}
#line 174 "src/pmc/integer.c"
void
Parrot_Integer_i_add_Integer(Interp *interp, PMC* pmc, PMC* value)
{
        Parrot_Integer_i_add_int(interp, pmc, VTABLE_get_integer(interp, value));
}void
Parrot_Integer_i_add_Complex(Interp *interp, PMC* pmc, PMC* value)
{
        const INTVAL a =  VTABLE_get_integer(interp, pmc);
        VTABLE_morph(interp, pmc, value->vtable->base_type);
        VTABLE_set_number_native(interp, pmc,
                (FLOATVAL)a +
                VTABLE_get_number_keyed_int(interp, value, 0));
        VTABLE_set_number_keyed_int(interp, pmc, 1,
                VTABLE_get_number_keyed_int(interp, value, 1));
}
void
Parrot_Integer_i_add_int(Interp *interp, PMC* pmc, INTVAL b)
#line 421 "./src/pmc/integer.pmc"
{
    const INTVAL a =  VTABLE_get_integer(interp, pmc);
    const INTVAL c = a + b;
    if ((c^a) >= 0 || (c^b) >= 0) {
        VTABLE_set_integer_native(interp, pmc, c);
    }
    else
        overflow(interp, pmc, b, pmc, MMD_SUBTRACT);

}
#line 203 "src/pmc/integer.c"
void
Parrot_Integer_i_add_float(Interp *interp, PMC* pmc, FLOATVAL value)
#line 431 "./src/pmc/integer.pmc"
{
    const INTVAL a =  VTABLE_get_integer(interp, pmc);
    VTABLE_set_number_native(interp, pmc, a + value);

}
#line 212 "src/pmc/integer.c"
PMC*
Parrot_Integer_subtract(Interp *interp, PMC* pmc, PMC* value, PMC* dest)
#line 448 "./src/pmc/integer.pmc"
{
        if (!dest)
            dest = pmc_new(interp, value->vtable->base_type);
        VTABLE_set_number_native(interp, dest,
             VTABLE_get_integer(interp, pmc) - VTABLE_get_number(interp, value));
        return dest;
}
#line 223 "src/pmc/integer.c"
PMC*
Parrot_Integer_subtract_Integer(Interp *interp, PMC* pmc, PMC* value, PMC* dest)
{
        const INTVAL a =  VTABLE_get_integer(interp, pmc);
        const INTVAL b = VTABLE_get_integer(interp, value);
        const INTVAL c = a - b;
        if ((c^a) >= 0 || (c^~b) >= 0) {
            if (!dest)
                dest = pmc_new(interp, pmc->vtable->base_type);
            VTABLE_set_integer_native(interp, dest, c);
            return dest;
        }
        else
            return overflow(interp, pmc, b, dest, MMD_SUBTRACT);
}PMC*
Parrot_Integer_subtract_Complex(Interp *interp, PMC* pmc, PMC* value, PMC* dest)
{
        const INTVAL a =  VTABLE_get_integer(interp, pmc);
        if (dest)
            VTABLE_morph(interp, dest, value->vtable->base_type);
        else
            dest = pmc_new(interp, value->vtable->base_type);
        VTABLE_set_number_native(interp, dest,
                a - VTABLE_get_number_keyed_int(interp, value, 0));
        VTABLE_set_number_keyed_int(interp, dest, 1,
                -VTABLE_get_number_keyed_int(interp, value, 1));
        return dest;
}PMC*
Parrot_Integer_subtract_BigInt(Interp *interp, PMC* pmc, PMC* value, PMC* dest)
{
        return overflow_p(interp, pmc, value, dest, MMD_SUBTRACT);
}
PMC*
Parrot_Integer_subtract_int(Interp *interp, PMC* pmc, INTVAL b, PMC* dest)
#line 495 "./src/pmc/integer.pmc"
{
    const INTVAL a =  VTABLE_get_integer(interp, pmc);
    const INTVAL c = a - b;
    if ((c^a) >= 0 || (c^~b) >= 0) {
        if (!dest)
            dest = pmc_new(interp, pmc->vtable->base_type);
        VTABLE_set_integer_native(interp, dest, c);
        return dest;
    }
    else
        return overflow(interp, pmc, b, dest, MMD_SUBTRACT);

}
#line 272 "src/pmc/integer.c"
void
Parrot_Integer_i_subtract(Interp *interp, PMC* pmc, PMC* value)
#line 522 "./src/pmc/integer.pmc"
{
    VTABLE_set_number_native(interp, pmc,
         VTABLE_get_integer(interp, pmc) - VTABLE_get_number(interp, value));
}
#line 280 "src/pmc/integer.c"
void
Parrot_Integer_i_subtract_Integer(Interp *interp, PMC* pmc, PMC* value)
{
        const INTVAL a =  VTABLE_get_integer(interp, pmc);
        const INTVAL b = VTABLE_get_integer(interp, value);
        const INTVAL c = a - b;
        if ((c^a) >= 0 || (c^~b) >= 0) {
            VTABLE_set_integer_native(interp, pmc, c);
        }
        else
            overflow(interp, pmc, b, pmc, MMD_SUBTRACT);
}void
Parrot_Integer_i_subtract_Complex(Interp *interp, PMC* pmc, PMC* value)
{
        const INTVAL a =  VTABLE_get_integer(interp, pmc);
        VTABLE_morph(interp, pmc, value->vtable->base_type);
        VTABLE_set_number_native(interp, pmc,
                (FLOATVAL)a -
                VTABLE_get_number_keyed_int(interp, value, 0));
        VTABLE_set_number_keyed_int(interp, pmc, 1,
                -VTABLE_get_number_keyed_int(interp, value, 1));
}
void
Parrot_Integer_i_subtract_int(Interp *interp, PMC* pmc, INTVAL b)
#line 548 "./src/pmc/integer.pmc"
{
    const INTVAL a =  VTABLE_get_integer(interp, pmc);
    const INTVAL c = a - b;
    if ((c^a) >= 0 || (c^~b) >= 0) {
        VTABLE_set_integer_native(interp, pmc, c);
    }
    else
        overflow(interp, pmc, b, pmc, MMD_SUBTRACT);

}
#line 316 "src/pmc/integer.c"
void
Parrot_Integer_i_subtract_float(Interp *interp, PMC* pmc, FLOATVAL value)
#line 558 "./src/pmc/integer.pmc"
{
    const INTVAL a =  VTABLE_get_integer(interp, pmc);
    VTABLE_set_number_native(interp, pmc, a - value);

}
#line 325 "src/pmc/integer.c"
PMC*
Parrot_Integer_multiply(Interp *interp, PMC* pmc, PMC* value, PMC* dest)
#line 574 "./src/pmc/integer.pmc"
{
        const FLOATVAL valf = VTABLE_get_number(interp, value);
        if (!dest)
            dest = pmc_new(interp, pmc->vtable->base_type);
        VTABLE_set_number_native(interp, dest, valf * PMC_int_val(pmc));
        return dest;
}
#line 336 "src/pmc/integer.c"
PMC*
Parrot_Integer_multiply_Integer(Interp *interp, PMC* pmc, PMC* value, PMC* dest)
{
        const INTVAL a = VTABLE_get_integer(interp, pmc);
        const INTVAL b = VTABLE_get_integer(interp, value);
        const double cf = (double)a * (double)b;
        const INTVAL c = a * b;
        if ((double) c == cf) {
            if (!dest)
                dest = pmc_new(interp, pmc->vtable->base_type);
            VTABLE_set_integer_native(interp, dest, c);
            return dest;
        }
        else
            return overflow(interp, pmc, b, dest, MMD_MULTIPLY);
}PMC*
Parrot_Integer_multiply_Complex(Interp *interp, PMC* pmc, PMC* value, PMC* dest)
{
            real_exception(interp, NULL, E_NotImplementedError,
                    "TODO mul<Integer, Complex>");
            return dest;
}PMC*
Parrot_Integer_multiply_BigInt(Interp *interp, PMC* pmc, PMC* value, PMC* dest)
{
        return Parrot_BigInt_multiply_int(interp, value,
                 VTABLE_get_integer(interp, pmc), dest);
}PMC*
Parrot_Integer_multiply_String(Interp *interp, PMC* pmc, PMC* value, PMC* dest)
{
        return Parrot_Integer_multiply_Integer(interp, pmc, value, dest);
}
PMC*
Parrot_Integer_multiply_int(Interp *interp, PMC* pmc, INTVAL b, PMC* dest)
#line 610 "./src/pmc/integer.pmc"
{
    const INTVAL a =  VTABLE_get_integer(interp, pmc);
    const double cf = (double)a * (double)b;
    const INTVAL c = a * b;
    if ((double) c == cf) {
        if (!dest)
            dest = pmc_new(interp, pmc->vtable->base_type);
        VTABLE_set_integer_native(interp, dest, c);
        return dest;
    }
    else
        return overflow(interp, pmc, b, dest, MMD_MULTIPLY);

}
#line 385 "src/pmc/integer.c"
void
Parrot_Integer_i_multiply(Interp *interp, PMC* pmc, PMC* value)
#line 638 "./src/pmc/integer.pmc"
{
    VTABLE_set_number_native(interp, pmc,
        PMC_int_val(pmc) * VTABLE_get_number(interp, value));
}
#line 393 "src/pmc/integer.c"
void
Parrot_Integer_i_multiply_Integer(Interp *interp, PMC* pmc, PMC* value)
{
        Parrot_Integer_i_multiply_int(interp, pmc, VTABLE_get_integer(interp, value));
}void
Parrot_Integer_i_multiply_BigInt(Interp *interp, PMC* pmc, PMC* value)
{
        Parrot_BigInt_multiply_int(interp, value,
                 VTABLE_get_integer(interp, pmc), pmc);
}void
Parrot_Integer_i_multiply_Complex(Interp *interp, PMC* pmc, PMC* value)
{
            real_exception(interp, NULL, E_NotImplementedError,
                    "TODO i_mul<Integer, Complex>");
}
void
Parrot_Integer_i_multiply_int(Interp *interp, PMC* pmc, INTVAL b)
#line 656 "./src/pmc/integer.pmc"
{
    const INTVAL a =  VTABLE_get_integer(interp, pmc);
    const double cf = (double)a * (double)b;
    const INTVAL c = a * b;
    if ((double) c == cf) {
         VTABLE_set_integer_native(interp, pmc, c);
    }
    else
        overflow(interp, pmc, b, pmc, MMD_MULTIPLY);

}
#line 423 "src/pmc/integer.c"
void
Parrot_Integer_i_multiply_float(Interp *interp, PMC* pmc, FLOATVAL value)
#line 667 "./src/pmc/integer.pmc"
{
    const INTVAL a =  VTABLE_get_integer(interp, pmc);
    VTABLE_set_number_native(interp, pmc, a * value);

}
#line 432 "src/pmc/integer.c"
PMC*
Parrot_Integer_divide(Interp *interp, PMC* pmc, PMC* value, PMC* dest)
#line 694 "./src/pmc/integer.pmc"
{
        const FLOATVAL d = VTABLE_get_number(interp, value);

        if (d == 0.0)
            real_exception(interp, NULL, E_ZeroDivisionError,
                    "float division by zero");
        if (!dest)
            dest = pmc_new(interp, pmc->vtable->base_type);
        VTABLE_set_number_native(interp, dest,  VTABLE_get_number(interp, pmc) / d);
        return dest;
}
#line 447 "src/pmc/integer.c"
PMC*
Parrot_Integer_divide_BigInt(Interp *interp, PMC* pmc, PMC* value, PMC* dest)
{
        return overflow_p(interp, pmc, value, dest, MMD_DIVIDE);
}
void
Parrot_Integer_i_divide(Interp *interp, PMC* pmc, PMC* value)
#line 711 "./src/pmc/integer.pmc"
{
        const FLOATVAL d = VTABLE_get_number(interp, value);

        if (d == 0.0)
            real_exception(interp, NULL, E_ZeroDivisionError,
                    "float division by zero");
        VTABLE_set_number_native(interp, pmc,  VTABLE_get_number(interp, pmc) / d);
}
#line 464 "src/pmc/integer.c"
void
Parrot_Integer_i_divide_BigInt(Interp *interp, PMC* pmc, PMC* value)
{
         overflow_p(interp, pmc, value, pmc, MMD_DIVIDE);
}
PMC*
Parrot_Integer_floor_divide(Interp *interp, PMC* pmc, PMC* value, PMC* dest)
#line 747 "./src/pmc/integer.pmc"
{
        const FLOATVAL d = VTABLE_get_number(interp, value);

        if (d == 0.0)
            real_exception(interp, NULL, E_ZeroDivisionError,
                    "float division by zero");
        if (!dest)
            dest = pmc_new(interp, pmc->vtable->base_type);
        VTABLE_set_integer_native(interp, dest,
                (INTVAL)floor( VTABLE_get_number(interp, pmc) / d));
        return dest;
}
#line 485 "src/pmc/integer.c"
PMC*
Parrot_Integer_floor_divide_BigInt(Interp *interp, PMC* pmc, PMC* value, PMC* dest)
{
        return overflow_p(interp, pmc, value, dest, MMD_FLOOR_DIVIDE);
}
PMC*
Parrot_Integer_floor_divide_int(Interp *interp, PMC* pmc, INTVAL value, PMC* dest)
#line 765 "./src/pmc/integer.pmc"
{
    if (value == 0)
        real_exception(interp, NULL, E_ZeroDivisionError,
                "float division by zero");
    if (!dest)
        dest = pmc_new(interp, pmc->vtable->base_type);
    VTABLE_set_integer_native(interp, dest,
            (INTVAL)floor( VTABLE_get_number(interp, pmc) / value));
    return dest;

}
#line 505 "src/pmc/integer.c"
PMC*
Parrot_Integer_floor_divide_float(Interp *interp, PMC* pmc, FLOATVAL value, PMC* dest)
#line 776 "./src/pmc/integer.pmc"
{
    if (value == 0.0)
        real_exception(interp, NULL, E_ZeroDivisionError,
                "float division by zero");
    if (!dest)
        dest = pmc_new(interp, pmc->vtable->base_type);
    VTABLE_set_integer_native(interp, dest,
            (INTVAL)floor( VTABLE_get_number(interp, pmc) / value));
    return dest;

}
#line 520 "src/pmc/integer.c"
void
Parrot_Integer_i_floor_divide(Interp *interp, PMC* pmc, PMC* value)
#line 787 "./src/pmc/integer.pmc"
{
        const FLOATVAL d = VTABLE_get_number(interp, value);

        if (d == 0.0)
            real_exception(interp, NULL, E_ZeroDivisionError,
                    "float division by zero");
        VTABLE_set_integer_native(interp, pmc,
                (INTVAL)floor( VTABLE_get_number(interp, pmc) / d));
}
#line 533 "src/pmc/integer.c"
void
Parrot_Integer_i_floor_divide_BigInt(Interp *interp, PMC* pmc, PMC* value)
{
        overflow_p(interp, pmc, value, pmc, MMD_FLOOR_DIVIDE);
}
void
Parrot_Integer_i_floor_divide_int(Interp *interp, PMC* pmc, INTVAL value)
#line 802 "./src/pmc/integer.pmc"
{
    if (value == 0)
        real_exception(interp, NULL, E_ZeroDivisionError,
                "float division by zero");
    VTABLE_set_integer_native(interp, pmc,
            (INTVAL)floor( VTABLE_get_number(interp, pmc) / value));

}
#line 550 "src/pmc/integer.c"
void
Parrot_Integer_i_floor_divide_float(Interp *interp, PMC* pmc, FLOATVAL value)
#line 810 "./src/pmc/integer.pmc"
{
    if (value == 0.0)
        real_exception(interp, NULL, E_ZeroDivisionError,
                "float division by zero");
    VTABLE_set_integer_native(interp, pmc,
            (INTVAL)floor( VTABLE_get_number(interp, pmc) / value));

}
#line 562 "src/pmc/integer.c"
PMC*
Parrot_Integer_modulus(Interp *interp, PMC* pmc, PMC* value, PMC* dest)
#line 936 "./src/pmc/integer.pmc"
{
        const INTVAL d = VTABLE_get_integer(interp, value);

        if (d == 0)
            real_exception(interp, NULL, E_ZeroDivisionError,
                    "int modulus by zero");
        if (!dest)
            dest = pmc_new(interp, pmc->vtable->base_type);
        VTABLE_set_integer_native(interp, dest,
                intval_mod( VTABLE_get_integer(interp, pmc), d));
        return dest;
}
#line 578 "src/pmc/integer.c"
PMC*
Parrot_Integer_modulus_BigInt(Interp *interp, PMC* pmc, PMC* value, PMC* dest)
{
        return overflow_p(interp, pmc, value, dest, MMD_MOD);
}
PMC*
Parrot_Integer_modulus_int(Interp *interp, PMC* pmc, INTVAL value, PMC* dest)
#line 954 "./src/pmc/integer.pmc"
{
    if (value == 0)
        real_exception(interp, NULL, E_ZeroDivisionError,
                "int modulus by zero");
    if (!dest)
        dest = pmc_new(interp, pmc->vtable->base_type);
    VTABLE_set_integer_native(interp, dest,
            intval_mod( VTABLE_get_integer(interp, pmc), value));
    return dest;

}
#line 598 "src/pmc/integer.c"
PMC*
Parrot_Integer_modulus_float(Interp *interp, PMC* pmc, FLOATVAL value, PMC* dest)
#line 965 "./src/pmc/integer.pmc"
{
    if (value == 0.0)
        real_exception(interp, NULL, E_ZeroDivisionError,
                "int modulus by zero");
    if (!dest)
        dest = pmc_new(interp, pmc->vtable->base_type);
    VTABLE_set_integer_native(interp, dest,
            intval_mod( VTABLE_get_integer(interp, pmc), (INTVAL)value));
    return dest;

}
#line 613 "src/pmc/integer.c"
void
Parrot_Integer_i_modulus(Interp *interp, PMC* pmc, PMC* value)
#line 975 "./src/pmc/integer.pmc"
{
        const INTVAL d = VTABLE_get_integer(interp, value);

        if (d == 0.0)
            real_exception(interp, NULL, E_ZeroDivisionError,
                    "int modulus by zero");
        VTABLE_set_integer_native(interp, pmc,
                intval_mod( VTABLE_get_integer(interp, pmc) , d));
}
#line 626 "src/pmc/integer.c"
void
Parrot_Integer_i_modulus_BigInt(Interp *interp, PMC* pmc, PMC* value)
{
         overflow_p(interp, pmc, value, pmc, MMD_MOD);
}
void
Parrot_Integer_i_modulus_int(Interp *interp, PMC* pmc, INTVAL value)
#line 990 "./src/pmc/integer.pmc"
{
    if (value == 0)
        real_exception(interp, NULL, E_ZeroDivisionError,
                "int modulus by zero");
    VTABLE_set_integer_native(interp, pmc,
            intval_mod( VTABLE_get_integer(interp, pmc) , value));

}
#line 643 "src/pmc/integer.c"
void
Parrot_Integer_i_modulus_float(Interp *interp, PMC* pmc, FLOATVAL value)
#line 998 "./src/pmc/integer.pmc"
{
    if (value == 0.0)
        real_exception(interp, NULL, E_ZeroDivisionError,
                "int modulus by zero");
    VTABLE_set_integer_native(interp, pmc,
            intval_mod( VTABLE_get_integer(interp, pmc) , (INTVAL)value));

}
#line 655 "src/pmc/integer.c"
PMC*
Parrot_Integer_cmodulus(Interp *interp, PMC* pmc, PMC* value, PMC* dest)
#line 842 "./src/pmc/integer.pmc"
{
        INTVAL d = VTABLE_get_integer(interp, value);

        if (d == 0.0)
            real_exception(interp, NULL, E_ZeroDivisionError,
                    "int cmodulus by zero");
        if (!dest)
            dest = pmc_new(interp, pmc->vtable->base_type);
        VTABLE_set_integer_native(interp, dest,
                 VTABLE_get_integer(interp, pmc) % d);
        return dest;
}
#line 671 "src/pmc/integer.c"
PMC*
Parrot_Integer_cmodulus_BigInt(Interp *interp, PMC* pmc, PMC* value, PMC* dest)
{
        return overflow_p(interp, pmc, value, dest, MMD_CMOD);
}
PMC*
Parrot_Integer_cmodulus_int(Interp *interp, PMC* pmc, INTVAL value, PMC* dest)
#line 871 "./src/pmc/integer.pmc"
{
    if (value == 0)
        real_exception(interp, NULL, E_ZeroDivisionError,
                "int cmodulus by zero");
    if (!dest)
        dest = pmc_new(interp, pmc->vtable->base_type);
    VTABLE_set_integer_native(interp, dest,
             VTABLE_get_integer(interp, pmc) % value);
    return dest;

}
#line 691 "src/pmc/integer.c"
PMC*
Parrot_Integer_cmodulus_float(Interp *interp, PMC* pmc, FLOATVAL value, PMC* dest)
#line 860 "./src/pmc/integer.pmc"
{
    if (value == 0.0)
        real_exception(interp, NULL, E_ZeroDivisionError,
                "int cmodulus by zero");
    if (!dest)
        dest = pmc_new(interp, pmc->vtable->base_type);
    VTABLE_set_integer_native(interp, dest,
            (INTVAL)fmod( VTABLE_get_integer(interp, pmc), value));
    return dest;

}
#line 706 "src/pmc/integer.c"
void
Parrot_Integer_i_cmodulus(Interp *interp, PMC* pmc, PMC* value)
#line 882 "./src/pmc/integer.pmc"
{
        const INTVAL d = VTABLE_get_integer(interp, value);

        if (d == 0.0)
            real_exception(interp, NULL, E_ZeroDivisionError,
                    "int cmodulus by zero");
        VTABLE_set_integer_native(interp, pmc,
                 VTABLE_get_integer(interp, pmc) % d);
}
#line 719 "src/pmc/integer.c"
void
Parrot_Integer_i_cmodulus_BigInt(Interp *interp, PMC* pmc, PMC* value)
{
         overflow_p(interp, pmc, value, pmc, MMD_CMOD);
}
void
Parrot_Integer_i_cmodulus_int(Interp *interp, PMC* pmc, INTVAL value)
#line 897 "./src/pmc/integer.pmc"
{
    if (value == 0)
        real_exception(interp, NULL, E_ZeroDivisionError,
                "int cmodulus by zero");
    VTABLE_set_integer_native(interp, pmc,
             VTABLE_get_integer(interp, pmc) % value);

}
#line 736 "src/pmc/integer.c"
void
Parrot_Integer_i_cmodulus_float(Interp *interp, PMC* pmc, FLOATVAL value)
#line 905 "./src/pmc/integer.pmc"
{
    if (value == 0.0)
        real_exception(interp, NULL, E_ZeroDivisionError,
                "int cmodulus by zero");
    VTABLE_set_integer_native(interp, pmc,
            (INTVAL)fmod( VTABLE_get_integer(interp, pmc), value));

}
#line 748 "src/pmc/integer.c"
PMC*
Parrot_Integer_pow(Interp *interp, PMC* pmc, PMC* value, PMC* dest)
#line 1025 "./src/pmc/integer.pmc"
{
    const INTVAL v = VTABLE_get_integer(interp, value);
    return Parrot_Integer_pow_int(interp, pmc, v, dest);

}
#line 757 "src/pmc/integer.c"
PMC*
Parrot_Integer_pow_int(Interp *interp, PMC* pmc, INTVAL b, PMC* dest)
#line 1030 "./src/pmc/integer.pmc"
{
    const INTVAL a =  VTABLE_get_integer(interp, pmc);
    const INTVAL orig_b = b;
    INTVAL r;

    if (b < 0)
        return Parrot_scalar_pow_int(interp, pmc, b, dest);
    r = 1;
    if (a) {
        INTVAL temp = a;
        while (b > 0) {
            INTVAL prev = r;
            if (b & 1) {
                r *= temp;
                if (r / temp != prev) {
                    return overflow(interp, pmc, orig_b, dest, MMD_POW);
                }
            }
            b >>= 1;
            if (!b)
                break;
            prev = temp;
            temp *= temp;
            if (prev != 0 && temp / prev != prev) {
                return overflow(interp, pmc, orig_b, dest, MMD_POW);
            }
        }
    }
    if (!dest)
        dest = pmc_new(interp, pmc->vtable->base_type);
    VTABLE_set_integer_native(interp, dest, r);
    return dest;

}
#line 796 "src/pmc/integer.c"
void
Parrot_Integer_i_pow(Interp *interp, PMC* pmc, PMC* value)
#line 1065 "./src/pmc/integer.pmc"
{
    Parrot_Integer_pow(interp, pmc, value, pmc);

}
#line 803 "src/pmc/integer.c"
void
Parrot_Integer_i_pow_int(Interp *interp, PMC* pmc, INTVAL value)
#line 1069 "./src/pmc/integer.pmc"
{
    Parrot_Integer_pow_int(interp, pmc, value, pmc);

}
#line 811 "src/pmc/integer.c"
INTVAL
Parrot_Integer_is_equal(Interp *interp, PMC* pmc, PMC* value)
#line 1083 "./src/pmc/integer.pmc"
{
    return (INTVAL)(PMC_int_val(pmc) ==
        VTABLE_get_integer(interp, value));
}
#line 819 "src/pmc/integer.c"
INTVAL
Parrot_Integer_is_equal_BigInt(Interp *interp, PMC* pmc, PMC* value)
{
    PMC* const temp = pmc_new(interp, enum_class_BigInt);
    VTABLE_set_integer_native(interp, temp, PMC_int_val(pmc));
    return Parrot_BigInt_is_equal_BigInt(interp, temp, value);
}
INTVAL
Parrot_Integer_cmp(Interp *interp, PMC* pmc, PMC* value)
#line 1104 "./src/pmc/integer.pmc"
{
        /* int or undef */
        const INTVAL diff = PMC_int_val(pmc)
            - VTABLE_get_integer(interp, value);
        return diff > 0 ? 1 : diff < 0 ? -1 : 0;
}
#line 836 "src/pmc/integer.c"
INTVAL
Parrot_Integer_cmp_String(Interp *interp, PMC* pmc, PMC* value)
{
        const FLOATVAL fdiff =
            PMC_int_val(pmc) - VTABLE_get_number(interp, value);
        if (fdiff == 0) {
            const INTVAL idiff =
                PMC_int_val(pmc) - VTABLE_get_integer(interp, value);
            return idiff > 0 ? 1 : idiff < 0 ? -1 : 0;
        }
        else {
            return fdiff > 0 ? 1 : -1;
        }
}INTVAL
Parrot_Integer_cmp_Float(Interp *interp, PMC* pmc, PMC* value)
{
        const FLOATVAL diff =
            (FLOATVAL)PMC_int_val(pmc) - VTABLE_get_number(interp, value);
        return diff > 0 ? 1 : diff < 0 ? -1 : 0;
}
INTVAL
Parrot_Integer_cmp_num(Interp *interp, PMC* pmc, PMC* value)
#line 1139 "./src/pmc/integer.pmc"
{
        /* int or undef */
        const INTVAL diff =
            PMC_int_val(pmc) - VTABLE_get_integer(interp, value);
        return diff > 0 ? 1 : diff < 0 ? -1 : 0;
}
#line 866 "src/pmc/integer.c"
INTVAL
Parrot_Integer_cmp_num_String(Interp *interp, PMC* pmc, PMC* value)
{
        const FLOATVAL fdiff =
            PMC_int_val(pmc) - VTABLE_get_number(interp, value);
        if (fdiff == 0) {
            const INTVAL idiff =
                PMC_int_val(pmc) - VTABLE_get_integer(interp, value);
            return idiff > 0 ? 1 : idiff < 0 ? -1 : 0;
        }
        else {
            return fdiff > 0 ? 1 : -1;
        }
}INTVAL
Parrot_Integer_cmp_num_Float(Interp *interp, PMC* pmc, PMC* value)
{
        const FLOATVAL diff =
            (FLOATVAL)PMC_int_val(pmc) - VTABLE_get_number(interp, value);
        return diff > 0 ? 1 : diff < 0 ? -1 : 0;
}
PMC*
Parrot_Integer_absolute(Interp *interp, PMC* pmc, PMC *dest)
#line 1204 "./src/pmc/integer.pmc"
{
    const INTVAL a = abs( VTABLE_get_integer(interp, pmc));
    /* XXX overlflow for -maxint */
    if (!dest)
        dest = pmc_new(interp, pmc->vtable->base_type);
    VTABLE_set_integer_native(interp, dest, a);
    return dest;

}
#line 900 "src/pmc/integer.c"
void
Parrot_Integer_decrement(Interp *interp, PMC* pmc)
#line 1188 "./src/pmc/integer.pmc"
{
    /* XXX overflow */
    PMC_int_val(pmc) --;

}
#line 908 "src/pmc/integer.c"
void
Parrot_Integer_freeze(Interp *interp, PMC* pmc, visit_info *info)
#line 1250 "./src/pmc/integer.pmc"
{
    IMAGE_IO * const io = info->image_io;
    Parrot_default_freeze(interp, pmc, info);
     VTABLE_push_integer(interp, io, PMC_int_val(pmc));

}
#line 918 "src/pmc/integer.c"
PMC*
Parrot_Integer_get_bignum(Interp *interp, PMC* pmc)
#line 222 "./src/pmc/integer.pmc"
{
    const INTVAL val =  VTABLE_get_integer(interp, pmc);
    PMC * const ret = pmc_new(interp, enum_class_BigInt);
    VTABLE_set_integer_native(interp, ret, val);
    return ret;

}
#line 929 "src/pmc/integer.c"
INTVAL
Parrot_Integer_get_bool(Interp *interp, PMC* pmc)
#line 196 "./src/pmc/integer.pmc"
{
    return PMC_int_val(pmc) ? 1 : 0;

}
#line 937 "src/pmc/integer.c"
INTVAL
Parrot_Integer_get_integer(Interp *interp, PMC* pmc)
#line 183 "./src/pmc/integer.pmc"
{
    return PMC_int_val(pmc);

}
#line 945 "src/pmc/integer.c"
FLOATVAL
Parrot_Integer_get_number(Interp *interp, PMC* pmc)
#line 209 "./src/pmc/integer.pmc"
{
    return (FLOATVAL)PMC_int_val(pmc);

}
#line 953 "src/pmc/integer.c"
STRING*
Parrot_Integer_get_repr(Interp *interp, PMC* pmc)
#line 241 "./src/pmc/integer.pmc"
{
    return string_from_int(interp, PMC_int_val(pmc));

}
#line 961 "src/pmc/integer.c"
STRING*
Parrot_Integer_get_string(Interp *interp, PMC* pmc)
#line 238 "./src/pmc/integer.pmc"
{
    return string_from_int(interp, PMC_int_val(pmc));

}
#line 969 "src/pmc/integer.c"
void
Parrot_Integer_i_absolute(Interp *interp, PMC* pmc)
#line 1214 "./src/pmc/integer.pmc"
{
    const INTVAL a = abs( VTABLE_get_integer(interp, pmc));
    VTABLE_set_integer_native(interp, pmc, a);

}
#line 978 "src/pmc/integer.c"
void
Parrot_Integer_increment(Interp *interp, PMC* pmc)
#line 1174 "./src/pmc/integer.pmc"
{
    /* XXX overflow */
    PMC_int_val(pmc) ++;

}
#line 987 "src/pmc/integer.c"
void
Parrot_Integer_init(Interp *interp, PMC* pmc)
#line 112 "./src/pmc/integer.pmc"
{
    PMC_int_val(pmc) = 0;

}
#line 995 "src/pmc/integer.c"
PMC*
Parrot_Integer_instantiate(Interp *interp, PMC* pmc, PMC* sig)
#line 87 "./src/pmc/integer.pmc"
{
    PMC* const ret = new_pmc_header(interp, 0);
    opcode_t *arg_op;
    INTVAL init = 0;

    ret->vtable = interp->vtables[pmc->vtable->base_type];
    arg_op = interp->current_args;
    if (SIG_ELEMS(sig) == 2) {
        switch (SIG_ITEM(sig, 1)) {
            case PARROT_ARG_I:
                init = REG_INT(arg_op[3]);
                break;
            case PARROT_ARG_IC:
                init = arg_op[3];
                break;
            default:
                internal_exception(1,
                        "Integer.instantiate: unhandled initializer");
                break;
        }
    }
    PMC_int_val(ret) = init;
    return ret;

}
#line 1024 "src/pmc/integer.c"
PMC*
Parrot_Integer_new_from_string(Interp *interp, PMC* pmc, STRING *rep, INTVAL flags)
#line 125 "./src/pmc/integer.pmc"
{
    PMC *res;
    const INTVAL type = pmc->vtable->base_type;

    if (flags & PObj_constant_FLAG)
        res = constant_pmc_new(interp, type);
    else
        res = pmc_new(interp, type);
    /* TODO bigint overflow */
    PMC_int_val(res) = string_to_int(interp, rep);
    return res;

}
#line 1041 "src/pmc/integer.c"
void
Parrot_Integer_set_bignum_int(Interp *interp, PMC* pmc, INTVAL value)
#line 297 "./src/pmc/integer.pmc"
{
     VTABLE_morph(interp, pmc, enum_class_BigInt);
     VTABLE_set_integer_native(interp, pmc, value);

}
#line 1050 "src/pmc/integer.c"
void
Parrot_Integer_set_bool(Interp *interp, PMC* pmc, INTVAL value)
#line 292 "./src/pmc/integer.pmc"
{
     VTABLE_morph(interp, pmc, enum_class_Boolean);
     VTABLE_set_bool(interp, pmc, value);

}
#line 1059 "src/pmc/integer.c"
void
Parrot_Integer_set_integer_native(Interp *interp, PMC* pmc, INTVAL value)
#line 260 "./src/pmc/integer.pmc"
{
    PMC_int_val(pmc) = value;

}
#line 1067 "src/pmc/integer.c"
void
Parrot_Integer_set_integer_same(Interp *interp, PMC* pmc, PMC * value)
#line 256 "./src/pmc/integer.pmc"
{
    PMC_int_val(pmc) = PMC_int_val(value);

}
#line 1075 "src/pmc/integer.c"
void
Parrot_Integer_set_number_native(Interp *interp, PMC* pmc, FLOATVAL value)
#line 287 "./src/pmc/integer.pmc"
{
     VTABLE_morph(interp, pmc, enum_class_Float);
     VTABLE_set_number_native(interp, pmc, value);

}
#line 1084 "src/pmc/integer.c"
void
Parrot_Integer_set_pmc(Interp *interp, PMC* pmc, PMC *value)
#line 148 "./src/pmc/integer.pmc"
{
    PMC_int_val(pmc) = VTABLE_get_integer(interp, value);

}
#line 1092 "src/pmc/integer.c"
void
Parrot_Integer_set_string_native(Interp *interp, PMC* pmc, STRING* value)
#line 302 "./src/pmc/integer.pmc"
{
     VTABLE_morph(interp, pmc, enum_class_String);
     VTABLE_set_string_native(interp, pmc, value);

}
#line 1101 "src/pmc/integer.c"
void
Parrot_Integer_share(Interp *interp, PMC* pmc)
#line 161 "./src/pmc/integer.pmc"
{
    /*
     * assume that the access to a long is atomic.
     * integers are most often (1) equal to C longs,
     * not C ints, and this makes a difference in 64-bit
     * platforms where longs are 64-bit but ints are 32-bit.
     * (1) Not equal when integers have been configured
     *     to be software-emulated long longs.
     */
    if (sizeof (INTVAL) != sizeof (long))
        Parrot_default_share(interp, pmc);

}
#line 1118 "src/pmc/integer.c"
void
Parrot_Integer_thaw(Interp *interp, PMC* pmc, visit_info *info)
#line 1265 "./src/pmc/integer.pmc"
{
    IMAGE_IO * const io = info->image_io;
    Parrot_default_thaw(interp, pmc, info);
    if (info->extra_flags == EXTRA_IS_NULL)
        PMC_int_val(pmc) =  VTABLE_shift_integer(interp, io);

}
#line 1129 "src/pmc/integer.c"
STRING*
Parrot_Integer_nci_get_as_base(Interp *interp, PMC* pmc, INTVAL base)
#line 1230 "./src/pmc/integer.pmc"
{
    char buf[128];

    if ((base < 2) || (base > 36))
        real_exception(interp, NULL, E_RuntimeError,
                "get_as_base: base out of bounds");

    return int_to_str(interp, buf,
            (HUGEINTVAL)VTABLE_get_integer(interp, pmc), (char)base);

}
#line 1144 "src/pmc/integer.c"
void
Parrot_Integer_ro_add_attribute(Interp *interp, PMC* pmc, STRING* name, PMC* type)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "add_attribute() in read-only instance of Integer");
}
void
Parrot_Integer_ro_add_method(Interp *interp, PMC* pmc, STRING* method_name, PMC* sub_pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "add_method() in read-only instance of Integer");
}
void
Parrot_Integer_ro_add_parent(Interp *interp, PMC* pmc, PMC* parent)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "add_parent() in read-only instance of Integer");
}
void
Parrot_Integer_ro_add_role(Interp *interp, PMC* pmc, PMC* role)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "add_role() in read-only instance of Integer");
}
void
Parrot_Integer_ro_assign_pmc(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "assign_pmc() in read-only instance of Integer");
}
void
Parrot_Integer_ro_assign_string_native(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "assign_string_native() in read-only instance of Integer");
}
void
Parrot_Integer_ro_decrement(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "decrement() in read-only instance of Integer");
}
void
Parrot_Integer_ro_delete_keyed(Interp *interp, PMC* pmc, PMC* key)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "delete_keyed() in read-only instance of Integer");
}
void
Parrot_Integer_ro_delete_keyed_int(Interp *interp, PMC* pmc, INTVAL key)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "delete_keyed_int() in read-only instance of Integer");
}
void
Parrot_Integer_ro_delete_keyed_str(Interp *interp, PMC* pmc, STRING* key)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "delete_keyed_str() in read-only instance of Integer");
}
PMC*
Parrot_Integer_ro_find_method(Interp *interp, PMC* pmc, STRING* method_name)
 {
    PMC *const method = Parrot_default_find_method(interp, pmc, method_name);
    if (!PMC_IS_NULL(VTABLE_getprop(interp, method, const_string(interp, "write"))))
        return PMCNULL;
    else
        return method;
}
void
Parrot_Integer_ro_i_absolute(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_absolute() in read-only instance of Integer");
}
void
Parrot_Integer_ro_i_bitwise_not(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_bitwise_not() in read-only instance of Integer");
}
void
Parrot_Integer_ro_i_bitwise_nots(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_bitwise_nots() in read-only instance of Integer");
}
void
Parrot_Integer_ro_i_logical_not(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_logical_not() in read-only instance of Integer");
}
void
Parrot_Integer_ro_i_neg(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_neg() in read-only instance of Integer");
}
void
Parrot_Integer_ro_increment(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "increment() in read-only instance of Integer");
}
void
Parrot_Integer_ro_morph(Interp *interp, PMC* pmc, INTVAL type)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "morph() in read-only instance of Integer");
}
FLOATVAL
Parrot_Integer_ro_pop_float(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "pop_float() in read-only instance of Integer");
    return (FLOATVAL)0;
}
INTVAL
Parrot_Integer_ro_pop_integer(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "pop_integer() in read-only instance of Integer");
    return (INTVAL)0;
}
PMC*
Parrot_Integer_ro_pop_pmc(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "pop_pmc() in read-only instance of Integer");
    return PMCNULL;
}
STRING*
Parrot_Integer_ro_pop_string(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "pop_string() in read-only instance of Integer");
    return (STRING*)0;
}
void
Parrot_Integer_ro_push_float(Interp *interp, PMC* pmc, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "push_float() in read-only instance of Integer");
}
void
Parrot_Integer_ro_push_integer(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "push_integer() in read-only instance of Integer");
}
void
Parrot_Integer_ro_push_pmc(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "push_pmc() in read-only instance of Integer");
}
void
Parrot_Integer_ro_push_string(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "push_string() in read-only instance of Integer");
}
void
Parrot_Integer_ro_remove_attribute(Interp *interp, PMC* pmc, STRING* name)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "remove_attribute() in read-only instance of Integer");
}
void
Parrot_Integer_ro_remove_method(Interp *interp, PMC* pmc, STRING* method_name)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "remove_method() in read-only instance of Integer");
}
void
Parrot_Integer_ro_remove_parent(Interp *interp, PMC* pmc, PMC* parent)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "remove_parent() in read-only instance of Integer");
}
void
Parrot_Integer_ro_remove_role(Interp *interp, PMC* pmc, PMC* role)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "remove_role() in read-only instance of Integer");
}
void
Parrot_Integer_ro_set_attr(Interp *interp, PMC* pmc, INTVAL idx, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_attr() in read-only instance of Integer");
}
void
Parrot_Integer_ro_set_attr_str(Interp *interp, PMC* pmc, STRING* idx, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_attr_str() in read-only instance of Integer");
}
void
Parrot_Integer_ro_set_bignum_int(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_bignum_int() in read-only instance of Integer");
}
void
Parrot_Integer_ro_set_bignum_num(Interp *interp, PMC* pmc, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_bignum_num() in read-only instance of Integer");
}
void
Parrot_Integer_ro_set_bignum_str(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_bignum_str() in read-only instance of Integer");
}
void
Parrot_Integer_ro_set_bool(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_bool() in read-only instance of Integer");
}
void
Parrot_Integer_ro_set_integer_keyed(Interp *interp, PMC* pmc, PMC* key, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_keyed() in read-only instance of Integer");
}
void
Parrot_Integer_ro_set_integer_keyed_int(Interp *interp, PMC* pmc, INTVAL key, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_keyed_int() in read-only instance of Integer");
}
void
Parrot_Integer_ro_set_integer_keyed_str(Interp *interp, PMC* pmc, STRING* key, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_keyed_str() in read-only instance of Integer");
}
void
Parrot_Integer_ro_set_integer_native(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_native() in read-only instance of Integer");
}
void
Parrot_Integer_ro_set_integer_same(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_same() in read-only instance of Integer");
}
void
Parrot_Integer_ro_set_number_keyed(Interp *interp, PMC* pmc, PMC* key, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_keyed() in read-only instance of Integer");
}
void
Parrot_Integer_ro_set_number_keyed_int(Interp *interp, PMC* pmc, INTVAL key, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_keyed_int() in read-only instance of Integer");
}
void
Parrot_Integer_ro_set_number_keyed_str(Interp *interp, PMC* pmc, STRING* key, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_keyed_str() in read-only instance of Integer");
}
void
Parrot_Integer_ro_set_number_native(Interp *interp, PMC* pmc, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_native() in read-only instance of Integer");
}
void
Parrot_Integer_ro_set_number_same(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_same() in read-only instance of Integer");
}
void
Parrot_Integer_ro_set_pmc(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pmc() in read-only instance of Integer");
}
void
Parrot_Integer_ro_set_pmc_keyed(Interp *interp, PMC* pmc, PMC* key, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pmc_keyed() in read-only instance of Integer");
}
void
Parrot_Integer_ro_set_pmc_keyed_int(Interp *interp, PMC* pmc, INTVAL key, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_int() in read-only instance of Integer");
}
void
Parrot_Integer_ro_set_pmc_keyed_str(Interp *interp, PMC* pmc, STRING* key, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_str() in read-only instance of Integer");
}
void
Parrot_Integer_ro_set_pointer(Interp *interp, PMC* pmc, void* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pointer() in read-only instance of Integer");
}
void
Parrot_Integer_ro_set_pointer_keyed(Interp *interp, PMC* pmc, PMC* key, void* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pointer_keyed() in read-only instance of Integer");
}
void
Parrot_Integer_ro_set_pointer_keyed_int(Interp *interp, PMC* pmc, INTVAL key, void* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_int() in read-only instance of Integer");
}
void
Parrot_Integer_ro_set_pointer_keyed_str(Interp *interp, PMC* pmc, STRING* key, void* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_str() in read-only instance of Integer");
}
void
Parrot_Integer_ro_set_string_keyed(Interp *interp, PMC* pmc, PMC* key, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_keyed() in read-only instance of Integer");
}
void
Parrot_Integer_ro_set_string_keyed_int(Interp *interp, PMC* pmc, INTVAL key, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_keyed_int() in read-only instance of Integer");
}
void
Parrot_Integer_ro_set_string_keyed_str(Interp *interp, PMC* pmc, STRING* key, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_keyed_str() in read-only instance of Integer");
}
void
Parrot_Integer_ro_set_string_native(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_native() in read-only instance of Integer");
}
void
Parrot_Integer_ro_set_string_same(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_same() in read-only instance of Integer");
}
FLOATVAL
Parrot_Integer_ro_shift_float(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "shift_float() in read-only instance of Integer");
    return (FLOATVAL)0;
}
INTVAL
Parrot_Integer_ro_shift_integer(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "shift_integer() in read-only instance of Integer");
    return (INTVAL)0;
}
PMC*
Parrot_Integer_ro_shift_pmc(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "shift_pmc() in read-only instance of Integer");
    return PMCNULL;
}
STRING*
Parrot_Integer_ro_shift_string(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "shift_string() in read-only instance of Integer");
    return (STRING*)0;
}
void
Parrot_Integer_ro_splice(Interp *interp, PMC* pmc, PMC* value, INTVAL offset, INTVAL count)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "splice() in read-only instance of Integer");
}
void
Parrot_Integer_ro_thaw(Interp *interp, PMC* pmc, visit_info* info)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "thaw() in read-only instance of Integer");
}
void
Parrot_Integer_ro_thawfinish(Interp *interp, PMC* pmc, visit_info* info)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "thawfinish() in read-only instance of Integer");
}
void
Parrot_Integer_ro_unshift_float(Interp *interp, PMC* pmc, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "unshift_float() in read-only instance of Integer");
}
void
Parrot_Integer_ro_unshift_integer(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "unshift_integer() in read-only instance of Integer");
}
void
Parrot_Integer_ro_unshift_pmc(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "unshift_pmc() in read-only instance of Integer");
}
void
Parrot_Integer_ro_unshift_string(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "unshift_string() in read-only instance of Integer");
}
void
Parrot_Integer_class_init(Parrot_Interp interp, int entry, int pass)
{
    const VTABLE temp_base_vtable = {
        NULL, /* namespace */
        enum_class_Integer, /* base_type */
        NULL, /* whoami */
        0|VTABLE_HAS_READONLY_FLAG, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        NULL,   /* ro_variant_vtable */
        Parrot_Integer_absolute,
        Parrot_default_add_attribute,
        Parrot_default_add_method,
        Parrot_default_add_parent,
        Parrot_default_add_role,
        Parrot_scalar_assign_pmc,
        Parrot_default_assign_string_native,
        Parrot_scalar_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_can,
        Parrot_default_class_type,
        Parrot_scalar_clone,
        Parrot_default_clone_pmc,
        Parrot_Integer_decrement,
        Parrot_scalar_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_default_delete_keyed,
        Parrot_default_delete_keyed_int,
        Parrot_default_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_default_destroy,
        Parrot_default_does,
        Parrot_default_elements,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_default_find_method,
        Parrot_Integer_freeze,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_Integer_get_bignum,
        Parrot_Integer_get_bool,
        Parrot_default_get_class,
        Parrot_Integer_get_integer,
        Parrot_default_get_integer_keyed,
        Parrot_default_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_iter,
        Parrot_Integer_get_number,
        Parrot_default_get_number_keyed,
        Parrot_default_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_default_get_pmc_keyed,
        Parrot_default_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_Integer_get_repr,
        Parrot_Integer_get_string,
        Parrot_default_get_string_keyed,
        Parrot_default_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_default_hash,
        Parrot_Integer_i_absolute,
        Parrot_scalar_i_bitwise_not,
        Parrot_default_i_bitwise_nots,
        Parrot_scalar_i_logical_not,
        Parrot_scalar_i_neg,
        Parrot_Integer_increment,
        Parrot_Integer_init,
        Parrot_default_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_Integer_instantiate,
        Parrot_default_invoke,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_scalar_logical_not,
        Parrot_default_mark,
        Parrot_scalar_morph,
        Parrot_default_name,
        Parrot_scalar_neg,
        Parrot_Integer_new_from_string,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_pmc_namespace,
        Parrot_default_pop_float,
        Parrot_default_pop_integer,
        Parrot_default_pop_pmc,
        Parrot_default_pop_string,
        Parrot_default_push_float,
        Parrot_default_push_integer,
        Parrot_default_push_pmc,
        Parrot_default_push_string,
        Parrot_default_remove_attribute,
        Parrot_default_remove_method,
        Parrot_default_remove_parent,
        Parrot_default_remove_role,
        Parrot_default_set_attr,
        Parrot_default_set_attr_str,
        Parrot_Integer_set_bignum_int,
        Parrot_default_set_bignum_num,
        Parrot_default_set_bignum_str,
        Parrot_Integer_set_bool,
        Parrot_default_set_integer_keyed,
        Parrot_default_set_integer_keyed_int,
        Parrot_default_set_integer_keyed_str,
        Parrot_Integer_set_integer_native,
        Parrot_Integer_set_integer_same,
        Parrot_default_set_number_keyed,
        Parrot_default_set_number_keyed_int,
        Parrot_default_set_number_keyed_str,
        Parrot_Integer_set_number_native,
        Parrot_default_set_number_same,
        Parrot_Integer_set_pmc,
        Parrot_default_set_pmc_keyed,
        Parrot_default_set_pmc_keyed_int,
        Parrot_default_set_pmc_keyed_str,
        Parrot_default_set_pointer,
        Parrot_default_set_pointer_keyed,
        Parrot_default_set_pointer_keyed_int,
        Parrot_default_set_pointer_keyed_str,
        Parrot_default_set_string_keyed,
        Parrot_default_set_string_keyed_int,
        Parrot_default_set_string_keyed_str,
        Parrot_Integer_set_string_native,
        Parrot_default_set_string_same,
        Parrot_default_setprop,
        Parrot_Integer_share,
        Parrot_scalar_share_ro,
        Parrot_default_shift_float,
        Parrot_default_shift_integer,
        Parrot_default_shift_pmc,
        Parrot_default_shift_string,
        Parrot_default_slice,
        Parrot_default_splice,
        Parrot_default_subclass,
        Parrot_default_substr,
        Parrot_scalar_substr_str,
        Parrot_default_subtype,
        Parrot_Integer_thaw,
        Parrot_default_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_type_keyed_int,
        Parrot_default_type_keyed_str,
        Parrot_default_unshift_float,
        Parrot_default_unshift_integer,
        Parrot_default_unshift_pmc,
        Parrot_default_unshift_string,
        Parrot_default_visit
    };

    const VTABLE temp_ro_vtable = {
        NULL, /* namespace */
        enum_class_Integer, /* base_type */
        NULL, /* whoami */
        0|VTABLE_IS_READONLY_FLAG, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        NULL,   /* ro_variant_vtable */
        Parrot_Integer_absolute,
        Parrot_Integer_ro_add_attribute,
        Parrot_Integer_ro_add_method,
        Parrot_Integer_ro_add_parent,
        Parrot_Integer_ro_add_role,
        Parrot_Integer_ro_assign_pmc,
        Parrot_Integer_ro_assign_string_native,
        Parrot_scalar_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_can,
        Parrot_default_class_type,
        Parrot_scalar_clone,
        Parrot_default_clone_pmc,
        Parrot_Integer_ro_decrement,
        Parrot_scalar_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_Integer_ro_delete_keyed,
        Parrot_Integer_ro_delete_keyed_int,
        Parrot_Integer_ro_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_default_destroy,
        Parrot_default_does,
        Parrot_default_elements,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_Integer_ro_find_method,
        Parrot_Integer_freeze,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_Integer_get_bignum,
        Parrot_Integer_get_bool,
        Parrot_default_get_class,
        Parrot_Integer_get_integer,
        Parrot_default_get_integer_keyed,
        Parrot_default_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_iter,
        Parrot_Integer_get_number,
        Parrot_default_get_number_keyed,
        Parrot_default_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_default_get_pmc_keyed,
        Parrot_default_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_Integer_get_repr,
        Parrot_Integer_get_string,
        Parrot_default_get_string_keyed,
        Parrot_default_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_default_hash,
        Parrot_Integer_ro_i_absolute,
        Parrot_Integer_ro_i_bitwise_not,
        Parrot_Integer_ro_i_bitwise_nots,
        Parrot_Integer_ro_i_logical_not,
        Parrot_Integer_ro_i_neg,
        Parrot_Integer_ro_increment,
        Parrot_Integer_init,
        Parrot_default_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_Integer_instantiate,
        Parrot_default_invoke,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_scalar_logical_not,
        Parrot_default_mark,
        Parrot_Integer_ro_morph,
        Parrot_default_name,
        Parrot_scalar_neg,
        Parrot_Integer_new_from_string,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_pmc_namespace,
        Parrot_Integer_ro_pop_float,
        Parrot_Integer_ro_pop_integer,
        Parrot_Integer_ro_pop_pmc,
        Parrot_Integer_ro_pop_string,
        Parrot_Integer_ro_push_float,
        Parrot_Integer_ro_push_integer,
        Parrot_Integer_ro_push_pmc,
        Parrot_Integer_ro_push_string,
        Parrot_Integer_ro_remove_attribute,
        Parrot_Integer_ro_remove_method,
        Parrot_Integer_ro_remove_parent,
        Parrot_Integer_ro_remove_role,
        Parrot_Integer_ro_set_attr,
        Parrot_Integer_ro_set_attr_str,
        Parrot_Integer_ro_set_bignum_int,
        Parrot_Integer_ro_set_bignum_num,
        Parrot_Integer_ro_set_bignum_str,
        Parrot_Integer_ro_set_bool,
        Parrot_Integer_ro_set_integer_keyed,
        Parrot_Integer_ro_set_integer_keyed_int,
        Parrot_Integer_ro_set_integer_keyed_str,
        Parrot_Integer_ro_set_integer_native,
        Parrot_Integer_ro_set_integer_same,
        Parrot_Integer_ro_set_number_keyed,
        Parrot_Integer_ro_set_number_keyed_int,
        Parrot_Integer_ro_set_number_keyed_str,
        Parrot_Integer_ro_set_number_native,
        Parrot_Integer_ro_set_number_same,
        Parrot_Integer_ro_set_pmc,
        Parrot_Integer_ro_set_pmc_keyed,
        Parrot_Integer_ro_set_pmc_keyed_int,
        Parrot_Integer_ro_set_pmc_keyed_str,
        Parrot_Integer_ro_set_pointer,
        Parrot_Integer_ro_set_pointer_keyed,
        Parrot_Integer_ro_set_pointer_keyed_int,
        Parrot_Integer_ro_set_pointer_keyed_str,
        Parrot_Integer_ro_set_string_keyed,
        Parrot_Integer_ro_set_string_keyed_int,
        Parrot_Integer_ro_set_string_keyed_str,
        Parrot_Integer_ro_set_string_native,
        Parrot_Integer_ro_set_string_same,
        Parrot_default_setprop,
        Parrot_Integer_share,
        Parrot_scalar_share_ro,
        Parrot_Integer_ro_shift_float,
        Parrot_Integer_ro_shift_integer,
        Parrot_Integer_ro_shift_pmc,
        Parrot_Integer_ro_shift_string,
        Parrot_default_slice,
        Parrot_Integer_ro_splice,
        Parrot_default_subclass,
        Parrot_default_substr,
        Parrot_scalar_substr_str,
        Parrot_default_subtype,
        Parrot_Integer_ro_thaw,
        Parrot_Integer_ro_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_type_keyed_int,
        Parrot_default_type_keyed_str,
        Parrot_Integer_ro_unshift_float,
        Parrot_Integer_ro_unshift_integer,
        Parrot_Integer_ro_unshift_pmc,
        Parrot_Integer_ro_unshift_string,
        Parrot_default_visit
    };

    const  MMD_init _temp_mmd_init[] = {
        { MMD_ADD, 0, enum_class_Complex, (funcptr_t) Parrot_scalar_add_Complex },
        { MMD_ADD, 0, enum_type_PMC, (funcptr_t) Parrot_Integer_add },
        { MMD_ADD, 0, enum_class_Integer, (funcptr_t) Parrot_Integer_add_Integer },
        { MMD_ADD, 0, enum_class_Complex, (funcptr_t) Parrot_Integer_add_Complex },
        { MMD_ADD, 0, enum_class_BigInt, (funcptr_t) Parrot_Integer_add_BigInt },
        { MMD_ADD, 0, enum_type_INTVAL, (funcptr_t) Parrot_Integer_add_int },
        { MMD_ADD, 0, enum_type_FLOATVAL, (funcptr_t) Parrot_scalar_add_float },
        { MMD_I_ADD, 0, enum_class_Complex, (funcptr_t) Parrot_scalar_i_add_Complex },
        { MMD_I_ADD, 0, enum_type_PMC, (funcptr_t) Parrot_Integer_i_add },
        { MMD_I_ADD, 0, enum_class_Integer, (funcptr_t) Parrot_Integer_i_add_Integer },
        { MMD_I_ADD, 0, enum_class_Complex, (funcptr_t) Parrot_Integer_i_add_Complex },
        { MMD_I_ADD, 0, enum_type_INTVAL, (funcptr_t) Parrot_Integer_i_add_int },
        { MMD_I_ADD, 0, enum_type_FLOATVAL, (funcptr_t) Parrot_Integer_i_add_float },
        { MMD_SUBTRACT, 0, enum_class_Complex, (funcptr_t) Parrot_scalar_subtract_Complex },
        { MMD_SUBTRACT, 0, enum_type_PMC, (funcptr_t) Parrot_Integer_subtract },
        { MMD_SUBTRACT, 0, enum_class_Integer, (funcptr_t) Parrot_Integer_subtract_Integer },
        { MMD_SUBTRACT, 0, enum_class_Complex, (funcptr_t) Parrot_Integer_subtract_Complex },
        { MMD_SUBTRACT, 0, enum_class_BigInt, (funcptr_t) Parrot_Integer_subtract_BigInt },
        { MMD_SUBTRACT, 0, enum_type_INTVAL, (funcptr_t) Parrot_Integer_subtract_int },
        { MMD_SUBTRACT, 0, enum_type_FLOATVAL, (funcptr_t) Parrot_scalar_subtract_float },
        { MMD_I_SUBTRACT, 0, enum_class_Complex, (funcptr_t) Parrot_scalar_i_subtract_Complex },
        { MMD_I_SUBTRACT, 0, enum_type_PMC, (funcptr_t) Parrot_Integer_i_subtract },
        { MMD_I_SUBTRACT, 0, enum_class_Integer, (funcptr_t) Parrot_Integer_i_subtract_Integer },
        { MMD_I_SUBTRACT, 0, enum_class_Complex, (funcptr_t) Parrot_Integer_i_subtract_Complex },
        { MMD_I_SUBTRACT, 0, enum_type_INTVAL, (funcptr_t) Parrot_Integer_i_subtract_int },
        { MMD_I_SUBTRACT, 0, enum_type_FLOATVAL, (funcptr_t) Parrot_Integer_i_subtract_float },
        { MMD_MULTIPLY, 0, enum_class_Complex, (funcptr_t) Parrot_scalar_multiply_Complex },
        { MMD_MULTIPLY, 0, enum_type_PMC, (funcptr_t) Parrot_Integer_multiply },
        { MMD_MULTIPLY, 0, enum_class_Integer, (funcptr_t) Parrot_Integer_multiply_Integer },
        { MMD_MULTIPLY, 0, enum_class_Complex, (funcptr_t) Parrot_Integer_multiply_Complex },
        { MMD_MULTIPLY, 0, enum_class_BigInt, (funcptr_t) Parrot_Integer_multiply_BigInt },
        { MMD_MULTIPLY, 0, enum_class_String, (funcptr_t) Parrot_Integer_multiply_String },
        { MMD_MULTIPLY, 0, enum_type_INTVAL, (funcptr_t) Parrot_Integer_multiply_int },
        { MMD_MULTIPLY, 0, enum_type_FLOATVAL, (funcptr_t) Parrot_scalar_multiply_float },
        { MMD_I_MULTIPLY, 0, enum_class_Complex, (funcptr_t) Parrot_scalar_i_multiply_Complex },
        { MMD_I_MULTIPLY, 0, enum_type_PMC, (funcptr_t) Parrot_Integer_i_multiply },
        { MMD_I_MULTIPLY, 0, enum_class_Integer, (funcptr_t) Parrot_Integer_i_multiply_Integer },
        { MMD_I_MULTIPLY, 0, enum_class_BigInt, (funcptr_t) Parrot_Integer_i_multiply_BigInt },
        { MMD_I_MULTIPLY, 0, enum_class_Complex, (funcptr_t) Parrot_Integer_i_multiply_Complex },
        { MMD_I_MULTIPLY, 0, enum_type_INTVAL, (funcptr_t) Parrot_Integer_i_multiply_int },
        { MMD_I_MULTIPLY, 0, enum_type_FLOATVAL, (funcptr_t) Parrot_Integer_i_multiply_float },
        { MMD_DIVIDE, 0, enum_type_PMC, (funcptr_t) Parrot_Integer_divide },
        { MMD_DIVIDE, 0, enum_class_BigInt, (funcptr_t) Parrot_Integer_divide_BigInt },
        { MMD_DIVIDE, 0, enum_type_INTVAL, (funcptr_t) Parrot_scalar_divide_int },
        { MMD_DIVIDE, 0, enum_type_FLOATVAL, (funcptr_t) Parrot_scalar_divide_float },
        { MMD_I_DIVIDE, 0, enum_type_PMC, (funcptr_t) Parrot_Integer_i_divide },
        { MMD_I_DIVIDE, 0, enum_class_BigInt, (funcptr_t) Parrot_Integer_i_divide_BigInt },
        { MMD_I_DIVIDE, 0, enum_type_INTVAL, (funcptr_t) Parrot_scalar_i_divide_int },
        { MMD_I_DIVIDE, 0, enum_type_FLOATVAL, (funcptr_t) Parrot_scalar_i_divide_float },
        { MMD_FLOOR_DIVIDE, 0, enum_type_PMC, (funcptr_t) Parrot_Integer_floor_divide },
        { MMD_FLOOR_DIVIDE, 0, enum_class_BigInt, (funcptr_t) Parrot_Integer_floor_divide_BigInt },
        { MMD_FLOOR_DIVIDE, 0, enum_type_INTVAL, (funcptr_t) Parrot_Integer_floor_divide_int },
        { MMD_FLOOR_DIVIDE, 0, enum_type_FLOATVAL, (funcptr_t) Parrot_Integer_floor_divide_float },
        { MMD_I_FLOOR_DIVIDE, 0, enum_type_PMC, (funcptr_t) Parrot_Integer_i_floor_divide },
        { MMD_I_FLOOR_DIVIDE, 0, enum_class_BigInt, (funcptr_t) Parrot_Integer_i_floor_divide_BigInt },
        { MMD_I_FLOOR_DIVIDE, 0, enum_type_INTVAL, (funcptr_t) Parrot_Integer_i_floor_divide_int },
        { MMD_I_FLOOR_DIVIDE, 0, enum_type_FLOATVAL, (funcptr_t) Parrot_Integer_i_floor_divide_float },
        { MMD_MOD, 0, enum_type_PMC, (funcptr_t) Parrot_Integer_modulus },
        { MMD_MOD, 0, enum_class_BigInt, (funcptr_t) Parrot_Integer_modulus_BigInt },
        { MMD_MOD, 0, enum_type_INTVAL, (funcptr_t) Parrot_Integer_modulus_int },
        { MMD_MOD, 0, enum_type_FLOATVAL, (funcptr_t) Parrot_Integer_modulus_float },
        { MMD_I_MOD, 0, enum_type_PMC, (funcptr_t) Parrot_Integer_i_modulus },
        { MMD_I_MOD, 0, enum_class_BigInt, (funcptr_t) Parrot_Integer_i_modulus_BigInt },
        { MMD_I_MOD, 0, enum_type_INTVAL, (funcptr_t) Parrot_Integer_i_modulus_int },
        { MMD_I_MOD, 0, enum_type_FLOATVAL, (funcptr_t) Parrot_Integer_i_modulus_float },
        { MMD_CMOD, 0, enum_type_PMC, (funcptr_t) Parrot_Integer_cmodulus },
        { MMD_CMOD, 0, enum_class_BigInt, (funcptr_t) Parrot_Integer_cmodulus_BigInt },
        { MMD_CMOD, 0, enum_type_INTVAL, (funcptr_t) Parrot_Integer_cmodulus_int },
        { MMD_CMOD, 0, enum_type_FLOATVAL, (funcptr_t) Parrot_Integer_cmodulus_float },
        { MMD_I_CMOD, 0, enum_type_PMC, (funcptr_t) Parrot_Integer_i_cmodulus },
        { MMD_I_CMOD, 0, enum_class_BigInt, (funcptr_t) Parrot_Integer_i_cmodulus_BigInt },
        { MMD_I_CMOD, 0, enum_type_INTVAL, (funcptr_t) Parrot_Integer_i_cmodulus_int },
        { MMD_I_CMOD, 0, enum_type_FLOATVAL, (funcptr_t) Parrot_Integer_i_cmodulus_float },
        { MMD_POW, 0, enum_type_PMC, (funcptr_t) Parrot_Integer_pow },
        { MMD_POW, 0, enum_type_INTVAL, (funcptr_t) Parrot_Integer_pow_int },
        { MMD_POW, 0, enum_type_FLOATVAL, (funcptr_t) Parrot_scalar_pow_float },
        { MMD_I_POW, 0, enum_type_PMC, (funcptr_t) Parrot_Integer_i_pow },
        { MMD_I_POW, 0, enum_type_INTVAL, (funcptr_t) Parrot_Integer_i_pow_int },
        { MMD_I_POW, 0, enum_type_FLOATVAL, (funcptr_t) Parrot_scalar_i_pow_float },
        { MMD_BOR, 0, enum_type_PMC, (funcptr_t) Parrot_scalar_bitwise_or },
        { MMD_BOR, 0, enum_type_INTVAL, (funcptr_t) Parrot_scalar_bitwise_or_int },
        { MMD_I_BOR, 0, enum_type_PMC, (funcptr_t) Parrot_scalar_i_bitwise_or },
        { MMD_I_BOR, 0, enum_type_INTVAL, (funcptr_t) Parrot_scalar_i_bitwise_or_int },
        { MMD_BAND, 0, enum_type_PMC, (funcptr_t) Parrot_scalar_bitwise_and },
        { MMD_BAND, 0, enum_type_INTVAL, (funcptr_t) Parrot_scalar_bitwise_and_int },
        { MMD_I_BAND, 0, enum_type_PMC, (funcptr_t) Parrot_scalar_i_bitwise_and },
        { MMD_I_BAND, 0, enum_type_INTVAL, (funcptr_t) Parrot_scalar_i_bitwise_and_int },
        { MMD_BXOR, 0, enum_type_PMC, (funcptr_t) Parrot_scalar_bitwise_xor },
        { MMD_BXOR, 0, enum_type_INTVAL, (funcptr_t) Parrot_scalar_bitwise_xor_int },
        { MMD_I_BXOR, 0, enum_type_PMC, (funcptr_t) Parrot_scalar_i_bitwise_xor },
        { MMD_I_BXOR, 0, enum_type_INTVAL, (funcptr_t) Parrot_scalar_i_bitwise_xor_int },
        { MMD_BSL, 0, enum_type_PMC, (funcptr_t) Parrot_scalar_bitwise_shl },
        { MMD_BSL, 0, enum_type_INTVAL, (funcptr_t) Parrot_scalar_bitwise_shl_int },
        { MMD_I_BSL, 0, enum_type_PMC, (funcptr_t) Parrot_scalar_i_bitwise_shl },
        { MMD_I_BSL, 0, enum_type_INTVAL, (funcptr_t) Parrot_scalar_i_bitwise_shl_int },
        { MMD_BSR, 0, enum_type_PMC, (funcptr_t) Parrot_scalar_bitwise_shr },
        { MMD_BSR, 0, enum_type_INTVAL, (funcptr_t) Parrot_scalar_bitwise_shr_int },
        { MMD_I_BSR, 0, enum_type_PMC, (funcptr_t) Parrot_scalar_i_bitwise_shr },
        { MMD_I_BSR, 0, enum_type_INTVAL, (funcptr_t) Parrot_scalar_i_bitwise_shr_int },
        { MMD_LSR, 0, enum_type_PMC, (funcptr_t) Parrot_scalar_bitwise_lsr },
        { MMD_LSR, 0, enum_type_INTVAL, (funcptr_t) Parrot_scalar_bitwise_lsr_int },
        { MMD_I_LSR, 0, enum_type_PMC, (funcptr_t) Parrot_scalar_i_bitwise_lsr },
        { MMD_I_LSR, 0, enum_type_INTVAL, (funcptr_t) Parrot_scalar_i_bitwise_lsr_int },
        { MMD_EQ, 0, enum_type_PMC, (funcptr_t) Parrot_Integer_is_equal },
        { MMD_EQ, 0, enum_class_BigInt, (funcptr_t) Parrot_Integer_is_equal_BigInt },
        { MMD_CMP, 0, enum_type_PMC, (funcptr_t) Parrot_Integer_cmp },
        { MMD_CMP, 0, enum_class_String, (funcptr_t) Parrot_Integer_cmp_String },
        { MMD_CMP, 0, enum_class_Float, (funcptr_t) Parrot_Integer_cmp_Float },
        { MMD_NUMCMP, 0, enum_type_PMC, (funcptr_t) Parrot_Integer_cmp_num },
        { MMD_NUMCMP, 0, enum_class_String, (funcptr_t) Parrot_Integer_cmp_num_String },
        { MMD_NUMCMP, 0, enum_class_Float, (funcptr_t) Parrot_Integer_cmp_num_Float },
        { MMD_STRCMP, 0, enum_type_PMC, (funcptr_t) Parrot_scalar_cmp_string },
        { MMD_LOR, 0, enum_type_PMC, (funcptr_t) Parrot_scalar_logical_or },
        { MMD_LAND, 0, enum_type_PMC, (funcptr_t) Parrot_scalar_logical_and },
        { MMD_LXOR, 0, enum_type_PMC, (funcptr_t) Parrot_scalar_logical_xor },
        { MMD_CONCAT, 0, enum_type_PMC, (funcptr_t) Parrot_scalar_concatenate },
        { MMD_CONCAT, 0, enum_type_STRING, (funcptr_t) Parrot_scalar_concatenate_str },
        { MMD_I_CONCAT, 0, enum_type_PMC, (funcptr_t) Parrot_scalar_i_concatenate },
        { MMD_I_CONCAT, 0, enum_type_STRING, (funcptr_t) Parrot_scalar_i_concatenate_str },
        { MMD_REPEAT, 0, enum_type_PMC, (funcptr_t) Parrot_scalar_repeat },
        { MMD_REPEAT, 0, enum_type_INTVAL, (funcptr_t) Parrot_scalar_repeat_int },
        { MMD_I_REPEAT, 0, enum_type_PMC, (funcptr_t) Parrot_scalar_i_repeat },
        { MMD_I_REPEAT, 0, enum_type_INTVAL, (funcptr_t) Parrot_scalar_i_repeat_int }
    };
    /*  Dynamic PMCs need the runtime type
    which is passed in entry to class_init.
    */
    if (pass == 0) {
        /*
         * create vtable - clone it - we have to set a few items
         */
        VTABLE *vt_clone =
            Parrot_clone_vtable(interp, &temp_base_vtable);
        VTABLE *vt_ro_clone =
            Parrot_clone_vtable(interp, &temp_ro_vtable);
        vt_clone->whoami = CONST_STRING(interp, "Integer");
        vt_clone->isa_str = CONST_STRING(interp, "Integer scalar");
        vt_clone->does_str = CONST_STRING(interp, "scalar integer");
        vt_ro_clone->base_type = entry;
        vt_ro_clone->whoami = vt_clone->whoami;
        vt_ro_clone->isa_str = vt_clone->isa_str;
        vt_ro_clone->does_str = vt_clone->does_str;
        vt_clone->ro_variant_vtable = vt_ro_clone;
        vt_ro_clone->ro_variant_vtable = vt_clone;
        interp->vtables[entry] = vt_clone;
    }
    else { /* pass */
        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        /* create PMC Proxy object */
        Parrot_create_pmc_proxy(interp, entry);
        register_nci_method(interp, entry,
                F2DPTR(Parrot_Integer_nci_get_as_base),
                "get_as_base", "SJOI");
        /* class_init */
        {
#define N_MMD_INIT (sizeof(_temp_mmd_init)/sizeof(_temp_mmd_init[0]))
            Parrot_mmd_register_table(interp, entry,
                _temp_mmd_init, N_MMD_INIT);
        }
    } /* pass */
} /* Parrot_Integer_class_init */


/*

=back

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
