/*
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/key.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

#line 1 "./src/pmc/key.pmc"
/*
Copyright (C) 2001-2007, The Perl Foundation.
$Id: key.pmc 18857 2007-06-07 08:07:12Z chromatic $

=head1 NAME

src/pmc/key.pmc - Key PMC

=head1 DESCRIPTION

These are the vtable functions for the Key PMC class.

=head2 Methods

=over 4

=cut

*/

#include "parrot/parrot.h"

static int
is_hash_iter(PMC *key /*NN*/)
{
    if ((PObj_get_FLAGS(key) & KEY_type_FLAGS) ==
        KEY_hash_iterator_FLAGS)
        return 1;
    return 0;
}

#line 44 "src/pmc/key.c"
#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_key.h"
#include "pmc_default.h"
#include "key.str"

PMC*
Parrot_Key_clone(Interp *interp, PMC* pmc)
#line 58 "./src/pmc/key.pmc"
{
    PMC * const dest = pmc_new_noinit(interp, pmc->vtable->base_type);
    PMC *dkey = dest;
    PMC *key = pmc;
    PMC *p;

    PObj_custom_mark_SET(dest);
    for (; key ;) {
        switch (PObj_get_FLAGS(key) & KEY_type_FLAGS) {
            case KEY_integer_FLAG:
            case KEY_integer_FLAG|KEY_register_FLAG:
                key_set_integer(interp, dkey, key_integer(interp, key));
                break;
            case KEY_number_FLAG:
            case KEY_number_FLAG|KEY_register_FLAG:
                key_set_number(interp, dkey, key_number(interp, key));
                break;
            case KEY_string_FLAG:
            case KEY_string_FLAG|KEY_register_FLAG:
                key_set_string(interp, dkey,
                    string_copy(interp, key_string(interp, key)));
                break;
            case KEY_pmc_FLAG:
            case KEY_pmc_FLAG|KEY_register_FLAG:
                p = key_pmc(interp, key);
                key_set_pmc(interp, dkey, VTABLE_clone(interp, p));
                break;
        }
        key = key_next(interp, key);
        if (key) {
            p = key_new(interp);
            key_append(interp, dkey, p);
            dkey = p;
        }
    }
    return dest;

}
#line 93 "src/pmc/key.c"
void
Parrot_Key_freeze(Interp *interp, PMC* pmc, visit_info *info /*NN*/)
#line 381 "./src/pmc/key.pmc"
{
    IMAGE_IO * const io = info->image_io;
    /* write flags */
    const INTVAL flags = (PObj_get_FLAGS(pmc) & KEY_type_FLAGS);
    /* write the contents of a register - else thaw can't restore
     * the register state
     */
     VTABLE_push_integer(interp, io, flags & ~KEY_register_FLAG);
    /* and contents of this key component */
    switch (flags) {
        case KEY_integer_FLAG:
        case KEY_integer_FLAG|KEY_register_FLAG:
             VTABLE_push_integer(interp, io, key_integer(interp, pmc));
            break;
        case KEY_number_FLAG:
        case KEY_number_FLAG|KEY_register_FLAG:
             VTABLE_push_float(interp, io, key_number(interp, pmc));
            break;
        case KEY_string_FLAG:
        case KEY_string_FLAG|KEY_register_FLAG:
             VTABLE_push_string(interp, io, key_string(interp, pmc));
            break;
        default:
            real_exception(interp, NULL, E_KeyError,
                    "Unsupported key type in Key.freeze");
            break;
    }

}
#line 126 "src/pmc/key.c"
INTVAL
Parrot_Key_get_integer(Interp *interp, PMC* pmc)
#line 120 "./src/pmc/key.pmc"
{
    return key_integer(interp, pmc);

}
#line 134 "src/pmc/key.c"
FLOATVAL
Parrot_Key_get_number(Interp *interp, PMC* pmc)
#line 134 "./src/pmc/key.pmc"
{
    return key_number(interp, pmc);

}
#line 142 "src/pmc/key.c"
PMC*
Parrot_Key_get_pmc(Interp *interp, PMC* pmc)
#line 162 "./src/pmc/key.pmc"
{
    return key_pmc(interp, pmc);

}
#line 150 "src/pmc/key.c"
PMC*
Parrot_Key_get_pmc_keyed(Interp *interp, PMC* pmc, PMC* key)
#line 269 "./src/pmc/key.pmc"
{
    return key;

}
#line 158 "src/pmc/key.c"
STRING*
Parrot_Key_get_string(Interp *interp, PMC* pmc)
#line 148 "./src/pmc/key.pmc"
{
    return key_string(interp, pmc);

}
#line 166 "src/pmc/key.c"
void
Parrot_Key_init(Interp *interp, PMC* pmc)
#line 44 "./src/pmc/key.pmc"
{
    PObj_custom_mark_SET(pmc);

}
#line 174 "src/pmc/key.c"
void
Parrot_Key_mark(Interp *interp, PMC* pmc)
#line 106 "./src/pmc/key.pmc"
{
    key_mark(interp, pmc);

}
#line 182 "src/pmc/key.c"
PMC*
Parrot_Key_nextkey_keyed(Interp *interp, PMC* pmc, PMC* agg, INTVAL what)
#line 284 "./src/pmc/key.pmc"
{
    const INTVAL n = VTABLE_elements(interp, agg);
    PMC *ret = pmc;
    STRING *_hash;

    switch (what) {
        case ITERATE_FROM_START_KEYS:
            /*
             * OrderedHash supports two iterators: by key
             * or by ordered values
             */
            PObj_get_FLAGS(ret) &= ~KEY_type_FLAGS;
            PObj_get_FLAGS(ret) |= KEY_integer_FLAG;
            if (agg->vtable->base_type == enum_class_OrderedHash)
                PObj_get_FLAGS(ret) |= KEY_number_FLAG;
            goto init;
        case ITERATE_FROM_START:    /* reset key */
            PObj_get_FLAGS(ret) &= ~KEY_type_FLAGS;
            PObj_get_FLAGS(ret) |= KEY_integer_FLAG;
            /*
             * KEY_hash_iterator_FLAGS, which is the same as
             * KEY_integer_FLAG | KEY_number_FLAG
             * indicates a hash iterator operation
             * KEY_integer_FLAG alone is an indexed hash lookup
             * with an Integer KEY
             */
             _hash = CONST_STRING(interp, "Hash");
            if (VTABLE_isa(interp, agg, _hash) &&
                 agg->vtable->base_type != enum_class_OrderedHash)
                PObj_get_FLAGS(ret) |= KEY_hash_iterator_FLAGS;
    init:
            PMC_int_val(ret) = 0;
            if (!n)
                PMC_int_val(ret) = -1;
            /*
             * iterating over a hash needs additionally the
             * Bucket index
             */
            if (is_hash_iter(ret))
                PMC_data(ret) = (void *)INITBucketIndex;
            break;
        case ITERATE_GET_NEXT:
            /*
             * src/hash.c:parrot_hash_get_idx() advances to next
             * so, if we are iterating over a hash do nothing
             * */
            if (!is_hash_iter(ret)) {
                if (PMC_int_val(ret) < n - 1)
                    ++PMC_int_val(ret);
                else
                    PMC_int_val(ret) = -1;
            }
            break;
        case ITERATE_GET_PREV:
            if (PMC_int_val(ret) >= 0)
                --PMC_int_val(ret);
            break;
        case ITERATE_FROM_END:
            PObj_get_FLAGS(ret) &= ~KEY_type_FLAGS;
            PObj_get_FLAGS(ret) |= KEY_integer_FLAG;
            PMC_int_val(ret) = n - 1;
            break;
    }
    return ret;

}
#line 252 "src/pmc/key.c"
void
Parrot_Key_push_pmc(Interp *interp, PMC* pmc, PMC * value /*NN*/)
#line 229 "./src/pmc/key.pmc"
{
    if (value->vtable->base_type != enum_class_Key)
        real_exception(interp, NULL, INVALID_OPERATION,
            "Can only push another Key onto a Key PMC.");
    key_append(interp, pmc, value);

}
#line 263 "src/pmc/key.c"
void
Parrot_Key_set_integer_native(Interp *interp, PMC* pmc, INTVAL value)
#line 174 "./src/pmc/key.pmc"
{
    key_set_integer(interp, pmc, value);

}
#line 271 "src/pmc/key.c"
void
Parrot_Key_set_number_native(Interp *interp, PMC* pmc, FLOATVAL value)
#line 188 "./src/pmc/key.pmc"
{
    key_set_number(interp, pmc, value);

}
#line 279 "src/pmc/key.c"
void
Parrot_Key_set_pmc(Interp *interp, PMC* pmc, PMC* value)
#line 215 "./src/pmc/key.pmc"
{
    key_set_pmc(interp, pmc, value);

}
#line 287 "src/pmc/key.c"
void
Parrot_Key_set_string_native(Interp *interp, PMC* pmc, STRING* value)
#line 201 "./src/pmc/key.pmc"
{
    key_set_string(interp, pmc, value);

}
#line 295 "src/pmc/key.c"
PMC*
Parrot_Key_shift_pmc(Interp *interp, PMC* pmc)
#line 249 "./src/pmc/key.pmc"
{
    return key_next(interp, pmc);

}
#line 303 "src/pmc/key.c"
void
Parrot_Key_thaw(Interp *interp, PMC* pmc, visit_info *info /*NN*/)
#line 410 "./src/pmc/key.pmc"
{
    IMAGE_IO * const io    = info->image_io;
    INTVAL     const flags =  VTABLE_shift_integer(interp, io)
                                & KEY_type_FLAGS;

    PObj_get_FLAGS(pmc) |= flags;
    PObj_custom_mark_SET(pmc);

    /* get contents */
    switch (flags) {
        case KEY_integer_FLAG:
            PMC_int_val(pmc) =  VTABLE_shift_integer(interp, io);
            break;
        case KEY_number_FLAG:
            PMC_num_val(pmc) =  VTABLE_shift_float(interp, io);
            break;
        case KEY_string_FLAG:
            PMC_str_val(pmc) =  VTABLE_shift_string(interp, io);
            break;
        default:
            real_exception(interp, NULL, E_KeyError,
                    "Unsupported key type in Key.thaw");
            break;
    }

}
#line 333 "src/pmc/key.c"
void
Parrot_Key_thawfinish(Interp *interp, PMC* pmc, visit_info *info)
#line 436 "./src/pmc/key.pmc"
{
    PMC *key = pmc;

    while (1) {
        PMC * const next = (PMC *)PMC_data(key);

        if (PMC_IS_NULL(next)) {
            PMC_data(key) = NULL;
            break;
        }

        key = next;
    }

}
#line 352 "src/pmc/key.c"
void
Parrot_Key_visit(Interp *interp, PMC* pmc, visit_info *info)
#line 371 "./src/pmc/key.pmc"
{
    /*
     * at end a PMC_NULL is written during thaw,
     * which should stop visiting the key
     */
    PMC ** const pos = (PMC**)&PMC_data(pmc);
    info->thaw_ptr = pos;
    (info->visit_pmc_now)(interp, *pos, info);

}
#line 366 "src/pmc/key.c"
void
Parrot_Key_ro_add_attribute(Interp *interp, PMC* pmc, STRING* name, PMC* type)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "add_attribute() in read-only instance of Key");
}
void
Parrot_Key_ro_add_method(Interp *interp, PMC* pmc, STRING* method_name, PMC* sub_pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "add_method() in read-only instance of Key");
}
void
Parrot_Key_ro_add_parent(Interp *interp, PMC* pmc, PMC* parent)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "add_parent() in read-only instance of Key");
}
void
Parrot_Key_ro_add_role(Interp *interp, PMC* pmc, PMC* role)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "add_role() in read-only instance of Key");
}
void
Parrot_Key_ro_assign_pmc(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "assign_pmc() in read-only instance of Key");
}
void
Parrot_Key_ro_assign_string_native(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "assign_string_native() in read-only instance of Key");
}
void
Parrot_Key_ro_decrement(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "decrement() in read-only instance of Key");
}
void
Parrot_Key_ro_delete_keyed(Interp *interp, PMC* pmc, PMC* key)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "delete_keyed() in read-only instance of Key");
}
void
Parrot_Key_ro_delete_keyed_int(Interp *interp, PMC* pmc, INTVAL key)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "delete_keyed_int() in read-only instance of Key");
}
void
Parrot_Key_ro_delete_keyed_str(Interp *interp, PMC* pmc, STRING* key)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "delete_keyed_str() in read-only instance of Key");
}
PMC*
Parrot_Key_ro_find_method(Interp *interp, PMC* pmc, STRING* method_name)
 {
    PMC *const method = Parrot_default_find_method(interp, pmc, method_name);
    if (!PMC_IS_NULL(VTABLE_getprop(interp, method, const_string(interp, "write"))))
        return PMCNULL;
    else
        return method;
}
void
Parrot_Key_ro_i_absolute(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_absolute() in read-only instance of Key");
}
void
Parrot_Key_ro_i_bitwise_not(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_bitwise_not() in read-only instance of Key");
}
void
Parrot_Key_ro_i_bitwise_nots(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_bitwise_nots() in read-only instance of Key");
}
void
Parrot_Key_ro_i_logical_not(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_logical_not() in read-only instance of Key");
}
void
Parrot_Key_ro_i_neg(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_neg() in read-only instance of Key");
}
void
Parrot_Key_ro_increment(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "increment() in read-only instance of Key");
}
void
Parrot_Key_ro_morph(Interp *interp, PMC* pmc, INTVAL type)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "morph() in read-only instance of Key");
}
FLOATVAL
Parrot_Key_ro_pop_float(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "pop_float() in read-only instance of Key");
    return (FLOATVAL)0;
}
INTVAL
Parrot_Key_ro_pop_integer(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "pop_integer() in read-only instance of Key");
    return (INTVAL)0;
}
PMC*
Parrot_Key_ro_pop_pmc(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "pop_pmc() in read-only instance of Key");
    return PMCNULL;
}
STRING*
Parrot_Key_ro_pop_string(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "pop_string() in read-only instance of Key");
    return (STRING*)0;
}
void
Parrot_Key_ro_push_float(Interp *interp, PMC* pmc, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "push_float() in read-only instance of Key");
}
void
Parrot_Key_ro_push_integer(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "push_integer() in read-only instance of Key");
}
void
Parrot_Key_ro_push_pmc(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "push_pmc() in read-only instance of Key");
}
void
Parrot_Key_ro_push_string(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "push_string() in read-only instance of Key");
}
void
Parrot_Key_ro_remove_attribute(Interp *interp, PMC* pmc, STRING* name)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "remove_attribute() in read-only instance of Key");
}
void
Parrot_Key_ro_remove_method(Interp *interp, PMC* pmc, STRING* method_name)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "remove_method() in read-only instance of Key");
}
void
Parrot_Key_ro_remove_parent(Interp *interp, PMC* pmc, PMC* parent)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "remove_parent() in read-only instance of Key");
}
void
Parrot_Key_ro_remove_role(Interp *interp, PMC* pmc, PMC* role)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "remove_role() in read-only instance of Key");
}
void
Parrot_Key_ro_set_attr(Interp *interp, PMC* pmc, INTVAL idx, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_attr() in read-only instance of Key");
}
void
Parrot_Key_ro_set_attr_str(Interp *interp, PMC* pmc, STRING* idx, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_attr_str() in read-only instance of Key");
}
void
Parrot_Key_ro_set_bignum_int(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_bignum_int() in read-only instance of Key");
}
void
Parrot_Key_ro_set_bignum_num(Interp *interp, PMC* pmc, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_bignum_num() in read-only instance of Key");
}
void
Parrot_Key_ro_set_bignum_str(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_bignum_str() in read-only instance of Key");
}
void
Parrot_Key_ro_set_bool(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_bool() in read-only instance of Key");
}
void
Parrot_Key_ro_set_integer_keyed(Interp *interp, PMC* pmc, PMC* key, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_keyed() in read-only instance of Key");
}
void
Parrot_Key_ro_set_integer_keyed_int(Interp *interp, PMC* pmc, INTVAL key, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_keyed_int() in read-only instance of Key");
}
void
Parrot_Key_ro_set_integer_keyed_str(Interp *interp, PMC* pmc, STRING* key, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_keyed_str() in read-only instance of Key");
}
void
Parrot_Key_ro_set_integer_native(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_native() in read-only instance of Key");
}
void
Parrot_Key_ro_set_integer_same(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_same() in read-only instance of Key");
}
void
Parrot_Key_ro_set_number_keyed(Interp *interp, PMC* pmc, PMC* key, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_keyed() in read-only instance of Key");
}
void
Parrot_Key_ro_set_number_keyed_int(Interp *interp, PMC* pmc, INTVAL key, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_keyed_int() in read-only instance of Key");
}
void
Parrot_Key_ro_set_number_keyed_str(Interp *interp, PMC* pmc, STRING* key, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_keyed_str() in read-only instance of Key");
}
void
Parrot_Key_ro_set_number_native(Interp *interp, PMC* pmc, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_native() in read-only instance of Key");
}
void
Parrot_Key_ro_set_number_same(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_same() in read-only instance of Key");
}
void
Parrot_Key_ro_set_pmc(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pmc() in read-only instance of Key");
}
void
Parrot_Key_ro_set_pmc_keyed(Interp *interp, PMC* pmc, PMC* key, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pmc_keyed() in read-only instance of Key");
}
void
Parrot_Key_ro_set_pmc_keyed_int(Interp *interp, PMC* pmc, INTVAL key, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_int() in read-only instance of Key");
}
void
Parrot_Key_ro_set_pmc_keyed_str(Interp *interp, PMC* pmc, STRING* key, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_str() in read-only instance of Key");
}
void
Parrot_Key_ro_set_pointer(Interp *interp, PMC* pmc, void* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pointer() in read-only instance of Key");
}
void
Parrot_Key_ro_set_pointer_keyed(Interp *interp, PMC* pmc, PMC* key, void* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pointer_keyed() in read-only instance of Key");
}
void
Parrot_Key_ro_set_pointer_keyed_int(Interp *interp, PMC* pmc, INTVAL key, void* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_int() in read-only instance of Key");
}
void
Parrot_Key_ro_set_pointer_keyed_str(Interp *interp, PMC* pmc, STRING* key, void* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_str() in read-only instance of Key");
}
void
Parrot_Key_ro_set_string_keyed(Interp *interp, PMC* pmc, PMC* key, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_keyed() in read-only instance of Key");
}
void
Parrot_Key_ro_set_string_keyed_int(Interp *interp, PMC* pmc, INTVAL key, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_keyed_int() in read-only instance of Key");
}
void
Parrot_Key_ro_set_string_keyed_str(Interp *interp, PMC* pmc, STRING* key, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_keyed_str() in read-only instance of Key");
}
void
Parrot_Key_ro_set_string_native(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_native() in read-only instance of Key");
}
void
Parrot_Key_ro_set_string_same(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_same() in read-only instance of Key");
}
FLOATVAL
Parrot_Key_ro_shift_float(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "shift_float() in read-only instance of Key");
    return (FLOATVAL)0;
}
INTVAL
Parrot_Key_ro_shift_integer(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "shift_integer() in read-only instance of Key");
    return (INTVAL)0;
}
PMC*
Parrot_Key_ro_shift_pmc(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "shift_pmc() in read-only instance of Key");
    return PMCNULL;
}
STRING*
Parrot_Key_ro_shift_string(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "shift_string() in read-only instance of Key");
    return (STRING*)0;
}
void
Parrot_Key_ro_splice(Interp *interp, PMC* pmc, PMC* value, INTVAL offset, INTVAL count)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "splice() in read-only instance of Key");
}
void
Parrot_Key_ro_thaw(Interp *interp, PMC* pmc, visit_info* info)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "thaw() in read-only instance of Key");
}
void
Parrot_Key_ro_thawfinish(Interp *interp, PMC* pmc, visit_info* info)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "thawfinish() in read-only instance of Key");
}
void
Parrot_Key_ro_unshift_float(Interp *interp, PMC* pmc, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "unshift_float() in read-only instance of Key");
}
void
Parrot_Key_ro_unshift_integer(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "unshift_integer() in read-only instance of Key");
}
void
Parrot_Key_ro_unshift_pmc(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "unshift_pmc() in read-only instance of Key");
}
void
Parrot_Key_ro_unshift_string(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "unshift_string() in read-only instance of Key");
}
void
Parrot_Key_class_init(Parrot_Interp interp, int entry, int pass)
{
    const VTABLE temp_base_vtable = {
        NULL, /* namespace */
        enum_class_Key, /* base_type */
        NULL, /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_HAS_READONLY_FLAG, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        NULL,   /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_default_add_attribute,
        Parrot_default_add_method,
        Parrot_default_add_parent,
        Parrot_default_add_role,
        Parrot_default_assign_pmc,
        Parrot_default_assign_string_native,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_can,
        Parrot_default_class_type,
        Parrot_Key_clone,
        Parrot_default_clone_pmc,
        Parrot_default_decrement,
        Parrot_default_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_default_delete_keyed,
        Parrot_default_delete_keyed_int,
        Parrot_default_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_default_destroy,
        Parrot_default_does,
        Parrot_default_elements,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_default_find_method,
        Parrot_Key_freeze,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_default_get_bool,
        Parrot_default_get_class,
        Parrot_Key_get_integer,
        Parrot_default_get_integer_keyed,
        Parrot_default_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_iter,
        Parrot_Key_get_number,
        Parrot_default_get_number_keyed,
        Parrot_default_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_Key_get_pmc,
        Parrot_Key_get_pmc_keyed,
        Parrot_default_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_default_get_repr,
        Parrot_Key_get_string,
        Parrot_default_get_string_keyed,
        Parrot_default_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_default_hash,
        Parrot_default_i_absolute,
        Parrot_default_i_bitwise_not,
        Parrot_default_i_bitwise_nots,
        Parrot_default_i_logical_not,
        Parrot_default_i_neg,
        Parrot_default_increment,
        Parrot_Key_init,
        Parrot_default_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_default_instantiate,
        Parrot_default_invoke,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_logical_not,
        Parrot_Key_mark,
        Parrot_default_morph,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_new_from_string,
        Parrot_Key_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_pmc_namespace,
        Parrot_default_pop_float,
        Parrot_default_pop_integer,
        Parrot_default_pop_pmc,
        Parrot_default_pop_string,
        Parrot_default_push_float,
        Parrot_default_push_integer,
        Parrot_Key_push_pmc,
        Parrot_default_push_string,
        Parrot_default_remove_attribute,
        Parrot_default_remove_method,
        Parrot_default_remove_parent,
        Parrot_default_remove_role,
        Parrot_default_set_attr,
        Parrot_default_set_attr_str,
        Parrot_default_set_bignum_int,
        Parrot_default_set_bignum_num,
        Parrot_default_set_bignum_str,
        Parrot_default_set_bool,
        Parrot_default_set_integer_keyed,
        Parrot_default_set_integer_keyed_int,
        Parrot_default_set_integer_keyed_str,
        Parrot_Key_set_integer_native,
        Parrot_default_set_integer_same,
        Parrot_default_set_number_keyed,
        Parrot_default_set_number_keyed_int,
        Parrot_default_set_number_keyed_str,
        Parrot_Key_set_number_native,
        Parrot_default_set_number_same,
        Parrot_Key_set_pmc,
        Parrot_default_set_pmc_keyed,
        Parrot_default_set_pmc_keyed_int,
        Parrot_default_set_pmc_keyed_str,
        Parrot_default_set_pointer,
        Parrot_default_set_pointer_keyed,
        Parrot_default_set_pointer_keyed_int,
        Parrot_default_set_pointer_keyed_str,
        Parrot_default_set_string_keyed,
        Parrot_default_set_string_keyed_int,
        Parrot_default_set_string_keyed_str,
        Parrot_Key_set_string_native,
        Parrot_default_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_default_shift_float,
        Parrot_default_shift_integer,
        Parrot_Key_shift_pmc,
        Parrot_default_shift_string,
        Parrot_default_slice,
        Parrot_default_splice,
        Parrot_default_subclass,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtype,
        Parrot_Key_thaw,
        Parrot_Key_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_type_keyed_int,
        Parrot_default_type_keyed_str,
        Parrot_default_unshift_float,
        Parrot_default_unshift_integer,
        Parrot_default_unshift_pmc,
        Parrot_default_unshift_string,
        Parrot_Key_visit
    };

    const VTABLE temp_ro_vtable = {
        NULL, /* namespace */
        enum_class_Key, /* base_type */
        NULL, /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_IS_READONLY_FLAG, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        NULL,   /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_Key_ro_add_attribute,
        Parrot_Key_ro_add_method,
        Parrot_Key_ro_add_parent,
        Parrot_Key_ro_add_role,
        Parrot_Key_ro_assign_pmc,
        Parrot_Key_ro_assign_string_native,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_can,
        Parrot_default_class_type,
        Parrot_Key_clone,
        Parrot_default_clone_pmc,
        Parrot_Key_ro_decrement,
        Parrot_default_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_Key_ro_delete_keyed,
        Parrot_Key_ro_delete_keyed_int,
        Parrot_Key_ro_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_default_destroy,
        Parrot_default_does,
        Parrot_default_elements,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_Key_ro_find_method,
        Parrot_Key_freeze,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_default_get_bool,
        Parrot_default_get_class,
        Parrot_Key_get_integer,
        Parrot_default_get_integer_keyed,
        Parrot_default_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_iter,
        Parrot_Key_get_number,
        Parrot_default_get_number_keyed,
        Parrot_default_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_Key_get_pmc,
        Parrot_Key_get_pmc_keyed,
        Parrot_default_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_default_get_repr,
        Parrot_Key_get_string,
        Parrot_default_get_string_keyed,
        Parrot_default_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_default_hash,
        Parrot_Key_ro_i_absolute,
        Parrot_Key_ro_i_bitwise_not,
        Parrot_Key_ro_i_bitwise_nots,
        Parrot_Key_ro_i_logical_not,
        Parrot_Key_ro_i_neg,
        Parrot_Key_ro_increment,
        Parrot_Key_init,
        Parrot_default_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_default_instantiate,
        Parrot_default_invoke,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_logical_not,
        Parrot_Key_mark,
        Parrot_Key_ro_morph,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_new_from_string,
        Parrot_Key_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_pmc_namespace,
        Parrot_Key_ro_pop_float,
        Parrot_Key_ro_pop_integer,
        Parrot_Key_ro_pop_pmc,
        Parrot_Key_ro_pop_string,
        Parrot_Key_ro_push_float,
        Parrot_Key_ro_push_integer,
        Parrot_Key_ro_push_pmc,
        Parrot_Key_ro_push_string,
        Parrot_Key_ro_remove_attribute,
        Parrot_Key_ro_remove_method,
        Parrot_Key_ro_remove_parent,
        Parrot_Key_ro_remove_role,
        Parrot_Key_ro_set_attr,
        Parrot_Key_ro_set_attr_str,
        Parrot_Key_ro_set_bignum_int,
        Parrot_Key_ro_set_bignum_num,
        Parrot_Key_ro_set_bignum_str,
        Parrot_Key_ro_set_bool,
        Parrot_Key_ro_set_integer_keyed,
        Parrot_Key_ro_set_integer_keyed_int,
        Parrot_Key_ro_set_integer_keyed_str,
        Parrot_Key_ro_set_integer_native,
        Parrot_Key_ro_set_integer_same,
        Parrot_Key_ro_set_number_keyed,
        Parrot_Key_ro_set_number_keyed_int,
        Parrot_Key_ro_set_number_keyed_str,
        Parrot_Key_ro_set_number_native,
        Parrot_Key_ro_set_number_same,
        Parrot_Key_ro_set_pmc,
        Parrot_Key_ro_set_pmc_keyed,
        Parrot_Key_ro_set_pmc_keyed_int,
        Parrot_Key_ro_set_pmc_keyed_str,
        Parrot_Key_ro_set_pointer,
        Parrot_Key_ro_set_pointer_keyed,
        Parrot_Key_ro_set_pointer_keyed_int,
        Parrot_Key_ro_set_pointer_keyed_str,
        Parrot_Key_ro_set_string_keyed,
        Parrot_Key_ro_set_string_keyed_int,
        Parrot_Key_ro_set_string_keyed_str,
        Parrot_Key_ro_set_string_native,
        Parrot_Key_ro_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_Key_ro_shift_float,
        Parrot_Key_ro_shift_integer,
        Parrot_Key_ro_shift_pmc,
        Parrot_Key_ro_shift_string,
        Parrot_default_slice,
        Parrot_Key_ro_splice,
        Parrot_default_subclass,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtype,
        Parrot_Key_ro_thaw,
        Parrot_Key_ro_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_type_keyed_int,
        Parrot_default_type_keyed_str,
        Parrot_Key_ro_unshift_float,
        Parrot_Key_ro_unshift_integer,
        Parrot_Key_ro_unshift_pmc,
        Parrot_Key_ro_unshift_string,
        Parrot_Key_visit
    };
    if (pass == 0) {
        /*
         * create vtable - clone it - we have to set a few items
         */
        VTABLE *vt_clone =
            Parrot_clone_vtable(interp, &temp_base_vtable);
        VTABLE *vt_ro_clone =
            Parrot_clone_vtable(interp, &temp_ro_vtable);
        vt_clone->whoami = CONST_STRING(interp, "Key");
        vt_clone->isa_str = CONST_STRING(interp, "Key");
        vt_clone->does_str = CONST_STRING(interp, "scalar");
        vt_ro_clone->base_type = entry;
        vt_ro_clone->whoami = vt_clone->whoami;
        vt_ro_clone->isa_str = vt_clone->isa_str;
        vt_ro_clone->does_str = vt_clone->does_str;
        vt_clone->ro_variant_vtable = vt_ro_clone;
        vt_ro_clone->ro_variant_vtable = vt_clone;
        interp->vtables[entry] = vt_clone;
    }
    else { /* pass */
        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        /* create PMC Proxy object */
        Parrot_create_pmc_proxy(interp, entry);
        /* class_init */
        {
        }
    } /* pass */
} /* Parrot_Key_class_init */


/*

=back

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
