/*
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/namespace.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

#line 1 "./src/pmc/namespace.pmc"
/*
Copyright (C) 2005-2007, The Perl Foundation.
$Id: namespace.pmc 19004 2007-06-14 20:50:04Z chromatic $

=head1 NAME

src/pmc/namespace.pmc - NameSpace PMC

=head1 DESCRIPTION

These are the vtable functions for the namespace PMC.

=head2 Data

  PMC_struct_val       ... the hash, bucket->value is a
                           var/sub, a namespace, or a FixedPMCarray
                           of 2 PMCs (namespace, sub/var) slots
  PMC_pmc_val          ... parent namespace
  PMC_data             ... Namespace information struct (name, class/role)

=head2 Functions

=over 4

=cut

*/

#include "parrot/parrot.h"
#include <assert.h>

/*
 * Typically a named slot contains either another namespace or a
 * var/sub (not both).
 * In case that the bucket->value is occupied, a FixedPMCArray is
 * created, and the items are moved over to that extra storage.
 * The array is flagged with FPA_is_ns_ext to distinguish it from a
 * plain array variable.
 *
 * This could easily expand to a full-fledged typed namespace if needed.
 */

enum {
    NS_slot_ns,
    NS_slot_var_sub,         /* unspecified ~half-raw slot */
    NS_max_slots
} NS_slot_enum;

#define FPA_is_ns_ext PObj_private0_FLAG


/* We store extra information about the namespace in a struct, which we will
 * hang off the PMC_data slot. */
typedef struct Parrot_NSInfo {
    STRING *name;     /* Name of this namespace part. */
    PMC    *_class;   /* The class or role attached to this namespace. */
    PMC    *vtable;   /* A Hash of vtable subs, keyed on the vtable index */
} Parrot_NSInfo;

/* Macro for easy access to the namespace info. */
#define PARROT_NSINFO(o) ((Parrot_NSInfo *) PMC_data(o))


#line 76 "src/pmc/namespace.c"
#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_fixedintegerarray.h"
#include "pmc_namespace.h"
#include "pmc_hash.h"
#include "pmc_default.h"
#include "namespace.str"

void
Parrot_NameSpace_destroy(Interp *interp, PMC* pmc)
#line 115 "./src/pmc/namespace.pmc"
{
    mem_sys_free(PARROT_NSINFO(pmc));
    Parrot_Hash_destroy(interp, pmc);

}
#line 94 "src/pmc/namespace.c"
PMC*
Parrot_NameSpace_get_pmc_keyed(Interp *interp, PMC* pmc, PMC *key)
#line 274 "./src/pmc/namespace.pmc"
{
    PMC *ns = pmc;
    STRING *part;

    if (key->vtable->base_type == enum_class_String) {
        return Parrot_NameSpace_get_pmc_keyed_str(interp, pmc, VTABLE_get_string(interp, key));
    }

    if (key->vtable->base_type == enum_class_Key) {
        while (key) {
            part = key_string(interp, key);
            key = key_next(interp, key);
            if (!key)
                return VTABLE_get_pmc_keyed_str(interp, ns, part);
            ns = Parrot_get_namespace_keyed_str(interp, ns, part);
            if (PMC_IS_NULL(ns))
                return PMCNULL;
        }
        return ns;
    }

    real_exception(interp, NULL, E_NameError, "Invalid namespace key in get_pmc_keyed_str");
    /* NOTREACHED */
    return PMCNULL;

}
#line 124 "src/pmc/namespace.c"
PMC*
Parrot_NameSpace_get_pmc_keyed_int(Interp *interp, PMC* pmc, INTVAL key)
#line 300 "./src/pmc/namespace.pmc"
{
    Parrot_NSInfo *nsinfo = PARROT_NSINFO(pmc);
    PMC           *vtable = nsinfo->vtable;

    if (PMC_IS_NULL(vtable))
        return PMCNULL;

    return VTABLE_get_pmc_keyed_int(interp, vtable, key);

}
#line 138 "src/pmc/namespace.c"
PMC*
Parrot_NameSpace_get_pmc_keyed_str(Interp *interp, PMC* pmc, STRING *key)
#line 261 "./src/pmc/namespace.pmc"
{
    PMC *ns = (PMC *)parrot_hash_get(interp, (Hash *)PMC_struct_val(pmc),
                                     key);
    if (!ns)
        return PMCNULL;

    if ((PObj_get_FLAGS(ns) & FPA_is_ns_ext) &&
            ns->vtable->base_type == enum_class_FixedPMCArray)
        ns = VTABLE_get_pmc_keyed_int(interp, ns, NS_slot_ns);

    return ns;

}
#line 155 "src/pmc/namespace.c"
void*
Parrot_NameSpace_get_pointer_keyed(Interp *interp, PMC* pmc, PMC *key)
#line 338 "./src/pmc/namespace.pmc"
{
    PMC *ns = pmc;
    STRING *part;

    if (key->vtable->base_type == enum_class_String) {
        return Parrot_NameSpace_get_pointer_keyed_str(interp, pmc, VTABLE_get_string(interp, key));
    }

    if (key->vtable->base_type == enum_class_Key) {
        while (key) {
            part = key_string(interp, key);
            key = key_next(interp, key);
            if (!key)
                return VTABLE_get_pointer_keyed_str(interp, ns, part);
            ns = Parrot_get_namespace_keyed_str(interp, ns, part);
            if (PMC_IS_NULL(ns))
                return PMCNULL;
        }
        return ns;
    }

    real_exception(interp, NULL, E_NameError, "Invalid namespace key in get_pointer_keyed");
    /* NOTREACHED */
    return PMCNULL;

}
#line 185 "src/pmc/namespace.c"
void*
Parrot_NameSpace_get_pointer_keyed_str(Interp *interp, PMC* pmc, STRING *key)
#line 325 "./src/pmc/namespace.pmc"
{
    PMC *ns = (PMC *)parrot_hash_get(interp, (Hash *)PMC_struct_val(pmc),
                                    key);
    if (!ns)
        return PMCNULL;

    if ((PObj_get_FLAGS(ns) & FPA_is_ns_ext) &&
            ns->vtable->base_type == enum_class_FixedPMCArray)
        ns = VTABLE_get_pmc_keyed_int(interp, ns, NS_slot_var_sub);

    return ns;

}
#line 202 "src/pmc/namespace.c"
STRING*
Parrot_NameSpace_get_string(Interp *interp, PMC* pmc)
#line 374 "./src/pmc/namespace.pmc"
{
    Parrot_NSInfo *nsinfo = PARROT_NSINFO(pmc);
    return nsinfo->name;

}
#line 211 "src/pmc/namespace.c"
void
Parrot_NameSpace_init(Interp *interp, PMC* pmc)
#line 77 "./src/pmc/namespace.pmc"
{
    Parrot_Hash_init(interp, pmc);                             /* _struct_val := Hash */
    PMC_pmc_val(pmc)           = NULL;  /* parent */
    PMC_data(pmc)              = mem_allocate_zeroed_typed(Parrot_NSInfo);
    PARROT_NSINFO(pmc)->vtable = PMCNULL;

}
#line 222 "src/pmc/namespace.c"
void
Parrot_NameSpace_mark(Interp *interp, PMC* pmc)
#line 93 "./src/pmc/namespace.pmc"
{
    Parrot_NSInfo *nsinfo = PARROT_NSINFO(pmc);
    Parrot_Hash_mark(interp, pmc);
    if (PMC_pmc_val(pmc))
        pobject_lives(interp, (PObj*)PMC_pmc_val(pmc));
    if (nsinfo->name)
        pobject_lives(interp, (PObj*)nsinfo->name);
    if (nsinfo->_class)
        pobject_lives(interp, (PObj*)nsinfo->_class);
    if (nsinfo->vtable)
        pobject_lives(interp, (PObj*)nsinfo->vtable);

}
#line 239 "src/pmc/namespace.c"
void
Parrot_NameSpace_set_pmc_keyed(Interp *interp, PMC* pmc, PMC *key, PMC *value)
#line 237 "./src/pmc/namespace.pmc"
{
    PMC *ns = pmc;
    STRING *part;

    if (key->vtable->base_type == enum_class_String) {
        Parrot_NameSpace_set_pmc_keyed_str(interp, pmc, VTABLE_get_string(interp, key), value);
        return;
    }

    if (key->vtable->base_type == enum_class_Key) {
        while (1) {
            part = key_string(interp, key);
            key = key_next(interp, key);
            if (!key) {
                Parrot_set_global(interp, ns, part, value);
                return;
            }
            ns = Parrot_make_namespace_keyed_str(interp, ns, part);
        }
    }

    real_exception(interp, NULL, E_NameError, "Invalid namespace key in set_pmc_keyed");

}
#line 267 "src/pmc/namespace.c"
void
Parrot_NameSpace_set_pmc_keyed_str(Interp *interp, PMC* pmc, STRING *key, PMC *value)
#line 153 "./src/pmc/namespace.pmc"
{
    const int val_is_NS = value->vtable->base_type == enum_class_NameSpace;
    PMC        *new_tuple = NULL;
    HashBucket *b         =
        parrot_hash_get_bucket(interp, (Hash*) PMC_struct_val(pmc), key);

    if (!b)
        Parrot_Hash_set_pmc_keyed_str(interp, pmc, key, value);
    else {
        PMC *old = (PMC *)b->value;

        if ((old->vtable->base_type == enum_class_NameSpace) == val_is_NS) {
            /* simple ns or simple var/sub changed */
            Parrot_Hash_set_pmc_keyed_str(interp, pmc, key, value);
        }
        else if ((PObj_get_FLAGS(old) & FPA_is_ns_ext) &&
                old->vtable->base_type == enum_class_FixedPMCArray) {
            /* we have a tuple extension already */
            VTABLE_set_pmc_keyed_int(interp, old,
                    val_is_NS ? NS_slot_ns : NS_slot_var_sub,
                    value);
        }
        else {
            /* creat new tuple */
            new_tuple = pmc_new(interp, enum_class_FixedPMCArray);

            /* flag it as special */
            PObj_get_FLAGS(new_tuple) |= FPA_is_ns_ext;

            /* for a fully typed namespace, we'd need 3 or 4 */
            VTABLE_set_integer_native(interp, new_tuple, NS_max_slots);
        }
    }

    if (val_is_NS) {
        /* TODO - this hack needs to go */
        Parrot_NSInfo *nsinfo = PARROT_NSINFO(value);
        PMC_pmc_val(value)    = pmc;  /* set parent */
        nsinfo->name          = key;   /* and name */

        if (new_tuple) {
            VTABLE_set_pmc_keyed_int(interp, new_tuple, NS_slot_ns,
                                     value);
            VTABLE_set_pmc_keyed_int(interp, new_tuple, NS_slot_var_sub,
                                     (PMC *)b->value);
            b->value = new_tuple;
            /* distinction from a plain FPA, which doesn't extend the
             * namespace storage
             */
        }
    }
    else if (new_tuple) {
        VTABLE_set_pmc_keyed_int(interp, new_tuple, NS_slot_ns,
            (PMC *)b->value);
        VTABLE_set_pmc_keyed_int(interp, new_tuple, NS_slot_var_sub, value);
        b->value = new_tuple;
    }

    if (value->vtable->base_type == enum_class_Sub) {
        Parrot_NSInfo *nsinfo    = PARROT_NSINFO(pmc);
        PMC           *vtable    = nsinfo->vtable;
        Parrot_sub    *sub       = PMC_sub(value);

        if (PMC_IS_NULL(vtable))
            nsinfo->vtable = vtable = pmc_new(interp, enum_class_Hash);

        if (sub->vtable_index == -1) {
            STRING *meth_name = key;

            if (string_str_index(interp, key,
                CONST_STRING(interp, "__"), 0 == 0)) {
                meth_name = string_substr(interp, key, 2,
                    string_length(interp, key) - 2, NULL, 0);
            }

            sub->vtable_index = Parrot_get_vtable_index(interp, meth_name);
        }

        if (sub->vtable_index != -1)
            VTABLE_set_pmc_keyed_int(interp, vtable,
                sub->vtable_index, value);
    }

}
#line 355 "src/pmc/namespace.c"
void
Parrot_NameSpace_nci_add_namespace(Interp *interp, PMC* pmc, STRING *name, PMC *_namespace)
#line 400 "./src/pmc/namespace.pmc"
{
    STRING *s_ns = CONST_STRING(interp, "NameSpace");
    if (!VTABLE_isa(interp, _namespace, s_ns))
        real_exception(interp, NULL, E_TypeError,
            "Invalid type %d in add_namespace()",
            _namespace->vtable->base_type);

    VTABLE_set_pmc_keyed_str(interp, pmc, name, _namespace);
    return;

}
#line 370 "src/pmc/namespace.c"
void
Parrot_NameSpace_nci_add_sub(Interp *interp, PMC* pmc, STRING *name, PMC *sub)
#line 422 "./src/pmc/namespace.pmc"
{
    STRING *s_sub = CONST_STRING(interp, "Sub");
    if (!VTABLE_isa(interp, sub, s_sub))
        real_exception(interp, NULL, E_TypeError,
            "Invalid type %d in add_sub()", sub->vtable->base_type);

    VTABLE_set_pmc_keyed_str(interp, pmc, name, sub);
    return;

}
#line 384 "src/pmc/namespace.c"
void
Parrot_NameSpace_nci_add_var(Interp *interp, PMC* pmc, STRING *name, PMC *var)
#line 442 "./src/pmc/namespace.pmc"
{
    VTABLE_set_pmc_keyed_str(interp, pmc, name, var);
    return;

}
#line 393 "src/pmc/namespace.c"
PMC*
Parrot_NameSpace_nci_get_name(Interp *interp, PMC* pmc)
#line 460 "./src/pmc/namespace.pmc"
{
    PMC *ar, *ns;

    ar = pmc_new(interp, enum_class_ResizableStringArray);
    ns = pmc;
    while (ns) {
        Parrot_NSInfo *nsinfo = PARROT_NSINFO(ns);
        VTABLE_unshift_string(interp, ar, nsinfo->name);
        ns = PMC_pmc_val(ns);
    }

    /* remove the NULL string of the namespace root */
    VTABLE_shift_string(interp, ar);

    return ar;

}
#line 414 "src/pmc/namespace.c"
PMC*
Parrot_NameSpace_nci_find_namespace(Interp *interp, PMC* pmc, STRING* key)
#line 486 "./src/pmc/namespace.pmc"
{
    STRING *s_ns = CONST_STRING(interp, "NameSpace");
    PMC    *ns   = (PMC *)parrot_hash_get(interp,
                            (Hash *)PMC_struct_val(pmc), key);

    if (!ns)
        return PMCNULL;

    /* it's a NameSpace */
    if (VTABLE_isa(interp, ns, s_ns))
        return ns;

    return PMCNULL;

}
#line 433 "src/pmc/namespace.c"
PMC*
Parrot_NameSpace_nci_find_sub(Interp *interp, PMC* pmc, STRING *key)
#line 511 "./src/pmc/namespace.pmc"
{
    STRING *s_sub = CONST_STRING(interp, "Sub");
    PMC    *sub   = (PMC *)parrot_hash_get(interp,
                        (Hash *)PMC_struct_val(pmc), key);

    if (!sub)
        return PMCNULL;

    /* it's a Sub */
    if (VTABLE_isa(interp, sub, s_sub))
        return sub;

    return PMCNULL;

}
#line 452 "src/pmc/namespace.c"
PMC*
Parrot_NameSpace_nci_find_var(Interp *interp, PMC* pmc, STRING *key)
#line 536 "./src/pmc/namespace.pmc"
{
    PMC *val = (PMC *)parrot_hash_get(interp,
                (Hash *)PMC_struct_val(pmc), key);

    if (!val)
        return PMCNULL;

    return val;

}
#line 466 "src/pmc/namespace.c"
void
Parrot_NameSpace_nci_del_namespace(Interp *interp, PMC* pmc, STRING *name)
#line 558 "./src/pmc/namespace.pmc"
{
    Hash   *hash = (Hash *)PMC_struct_val(pmc);
    PMC    *ns   = (PMC  *)parrot_hash_get(interp, hash, name);
    STRING *s_ns = CONST_STRING(interp, "NameSpace");

    if ( PMC_IS_NULL(ns) )
        return;

    if (!VTABLE_isa(interp, ns, s_ns)) {
        char *item_name = string_to_cstring(interp, name);
        real_exception(interp, NULL, E_TypeError,
            "Invalid type %d for '%s' in del_namespace()",
            ns->vtable->base_type, item_name);
        string_cstring_free(item_name);
    }

    parrot_hash_delete(interp, hash, name);

}
#line 489 "src/pmc/namespace.c"
void
Parrot_NameSpace_nci_del_sub(Interp *interp, PMC* pmc, STRING *name)
#line 591 "./src/pmc/namespace.pmc"
{
    Hash   *hash  = (Hash *)PMC_struct_val(pmc);
    PMC    *sub   = (PMC  *)parrot_hash_get(interp, hash, name);
    STRING *s_sub = CONST_STRING(interp, "Sub");

    if ( PMC_IS_NULL(sub) )
        return;

    if (!VTABLE_isa(interp, sub, s_sub)) {
        char *item_name = string_to_cstring(interp, name);
        real_exception(interp, NULL, E_TypeError,
            "Invalid type %d for '%s' in del_sub()",
            sub->vtable->base_type, item_name);
        string_cstring_free(item_name);
    }

    parrot_hash_delete(interp, hash, name);

}
#line 512 "src/pmc/namespace.c"
void
Parrot_NameSpace_nci_del_var(Interp *interp, PMC* pmc, STRING* name)
#line 620 "./src/pmc/namespace.pmc"
{
    parrot_hash_delete(interp, (Hash*) PMC_struct_val(pmc), name);

}
#line 520 "src/pmc/namespace.c"
PMC*
Parrot_NameSpace_nci_get_sym(Interp *interp, PMC* pmc, STRING *key)
#line 635 "./src/pmc/namespace.pmc"
{
    PMC *ns = (PMC *)parrot_hash_get(interp,
        (Hash *)PMC_struct_val(pmc), key);

    if (!ns)
        return PMCNULL;

    /* it's a NameSpace */
    if (ns->vtable == pmc->vtable)
        return PMCNULL;

    if ((PObj_get_FLAGS(ns) & FPA_is_ns_ext) &&
            ns->vtable->base_type == enum_class_FixedPMCArray)
        ns = VTABLE_get_pmc_keyed_int(interp, ns, NS_slot_var_sub);

    return ns;

}
#line 542 "src/pmc/namespace.c"
void
Parrot_NameSpace_nci_export_to(Interp *interp, PMC* pmc, PMC* dest, PMC* what)
#line 673 "./src/pmc/namespace.pmc"
{
    STRING *s_hash  = CONST_STRING(interp, "hash");
    STRING *s_array = CONST_STRING(interp, "array");

    if (PMC_IS_NULL(dest)) {
        real_exception(interp, NULL, 0,
                "destination namespace not specified");
        return;
    }

    if (PMC_IS_NULL(what) || !VTABLE_elements(interp, what)) {
        real_exception(interp, NULL, 0,
                "exporting default object set not yet implemented");
        return;
    }

    /* if "what" does "hash", we extract string key/value pairs,
     * lookup the object with the name specified in the key,
     * and export it with the name specified as value. */
    if (VTABLE_does(interp, what, s_hash)) {
        PMC * const  iter = VTABLE_get_iter(interp, what);
        const INTVAL n    = VTABLE_elements(interp, what);
        INTVAL       i;

        for (i = 0; i < n; ++i) {
            STRING *src_name;
            STRING *dest_name;
            PMC    *object;

            src_name = VTABLE_shift_string(interp, iter);
            if (STRING_IS_NULL(src_name) || STRING_IS_EMPTY(src_name)) {
                real_exception(interp, NULL, 0, "source object name not specified");
                return;
            }

            if (PMC_IS_NULL(VTABLE_get_pmc_keyed_str(interp, what, src_name))) {
                dest_name = src_name;
            }
            else {
                dest_name = VTABLE_get_string_keyed_str(interp, what, src_name);
                if (STRING_IS_NULL(dest_name) || STRING_IS_EMPTY(dest_name)) {
                    dest_name = src_name;
                }
            }

            object = VTABLE_get_pmc_keyed_str(interp, pmc, src_name);
            if (PMC_IS_NULL(object)) {
                real_exception(interp, NULL, 0,
                        "object '%s' not found in current namespace",
                        string_to_cstring(interp, src_name));
                return;
            }

            VTABLE_set_pmc_keyed_str(interp, dest, dest_name, object);
        }
    }
    else if (VTABLE_does(interp, what, s_array)) {
        const INTVAL n = VTABLE_elements(interp, what);
        INTVAL i;

        for (i = 0; i < n; ++i) {
            STRING *name;
            PMC    *object;

            name = VTABLE_get_string_keyed_int(interp, what, i);
            if (STRING_IS_NULL(name) || STRING_IS_EMPTY(name)) {
                real_exception(interp, NULL, 0, "object name not specified");
                return;
            }

            object = VTABLE_get_pmc_keyed_str(interp, pmc, name);
            if (PMC_IS_NULL(object)) {
                real_exception(interp, NULL, 0,
                        "object '%s' not found in current namespace",
                        string_to_cstring(interp, name));
                return;
            }

            VTABLE_set_pmc_keyed_str(interp, dest, name, object);
        }
    }
    else {
        real_exception(interp, NULL, 0,
                "can't handle argument of type %s", what->vtable->base_type);
    }

}
#line 633 "src/pmc/namespace.c"
PMC*
Parrot_NameSpace_nci_get_parent(Interp *interp, PMC* pmc)
#line 770 "./src/pmc/namespace.pmc"
{
    return PMC_pmc_val(pmc) ? PMC_pmc_val(pmc) : PMCNULL;

}
#line 641 "src/pmc/namespace.c"
void
Parrot_NameSpace_nci_get_class(Interp *interp, PMC* pmc)
{
#line 368 "/home/mandrake/rpm/BUILD/parrot-0.4.13/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    INTVAL   n_regs_used[]   = { 0, 0, 0, 1 };
    opcode_t param_indexes[] = { 0 };
    opcode_t *return_indexes;
    opcode_t *current_args;
    PMC* _type      = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC* param_sig  = Parrot_FixedIntegerArray_new_from_string(interp, _type,
        string_from_const_cstring(interp, "(2)", 0), 0);

    PMC* return_sig              = PMCNULL;

    parrot_context_t *caller_ctx = CONTEXT(interp->ctx);
    PMC* ret_cont                = new_ret_continuation_pmc(interp, NULL);
    parrot_context_t *ctx        = Parrot_push_context(interp, n_regs_used);
    PMC* ccont                   = caller_ctx->current_cont;

    ctx->current_cont            = ret_cont;
    PMC_cont(ret_cont)->from_ctx = ctx;

    current_args                 = interp->current_args;
    interp->current_args         = NULL;

    interp->params_signature     = param_sig;
    parrot_pass_args(interp, caller_ctx, ctx, current_args, param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(ccont) &= ~SUB_FLAG_TAILCALL;
        --ctx->recursion_depth;
        ctx->caller_ctx      = caller_ctx->caller_ctx;
        Parrot_free_context(interp, caller_ctx, 0);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
    PMC* pmc = CTX_REG_PMC(ctx, 0);

    /* BEGIN PMETHOD BODY */
#line 785 "./src/pmc/namespace.pmc"

    Parrot_NSInfo *nsinfo = PARROT_NSINFO(pmc);
    PMC *ret_class = nsinfo->_class;
    {
#line 237 "/home/mandrake/rpm/BUILD/parrot-0.4.13/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
/*BEGIN PCCRETURN PMC *ret_class */
/*BEGIN GENERATED ACCESSORS */
CTX_REG_PMC(ctx, 0) = ret_class;

#line 243 "/home/mandrake/rpm/BUILD/parrot-0.4.13/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
/*END GENERATED ACCESSORS */
{
    opcode_t temp_return_indexes[] = { 0 };
    return_indexes = temp_return_indexes;
}
return_sig = Parrot_FixedIntegerArray_new_from_string(interp, _type,
    string_from_const_cstring(interp, "(2)", 0), 0);
goto get_class_returns;
/*END PCCRETURN PMC *ret_class */
}

#line 413 "/home/mandrake/rpm/BUILD/parrot-0.4.13/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    goto no_return;
    /* END PMETHOD BODY */

get_class_returns:

    /* if (PMC_cont(ccont)->address) { */
    {
        /* parrot_context_t * const caller_ctx = PMC_cont(ccont)->to_ctx; */
        if (! caller_ctx) {
            /* there is no point calling real_exception here, because
               PDB_backtrace can't deal with a missing to_ctx either. */
            internal_exception(1, "No caller_ctx for continuation %p.", ccont);
        }

        interp->returns_signature = return_sig;
        parrot_pass_args(interp, ctx, caller_ctx, return_indexes,
            caller_ctx->current_results, PARROT_PASS_RESULTS);
    }

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_type);
    PObj_live_CLEAR(param_sig);
    PObj_live_CLEAR(return_sig);
    Parrot_pop_context(interp);

}
#line 738 "src/pmc/namespace.c"
void
Parrot_NameSpace_nci_set_class(Interp *interp, PMC* pmc)
{
#line 368 "/home/mandrake/rpm/BUILD/parrot-0.4.13/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    INTVAL   n_regs_used[]   = { 0, 0, 0, 2 };
    opcode_t param_indexes[] = { 0, 1 };
    opcode_t *return_indexes;
    opcode_t *current_args;
    PMC* _type      = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC* param_sig  = Parrot_FixedIntegerArray_new_from_string(interp, _type,
        string_from_const_cstring(interp, "(2, 2)", 0), 0);

    PMC* return_sig              = PMCNULL;

    parrot_context_t *caller_ctx = CONTEXT(interp->ctx);
    PMC* ret_cont                = new_ret_continuation_pmc(interp, NULL);
    parrot_context_t *ctx        = Parrot_push_context(interp, n_regs_used);
    PMC* ccont                   = caller_ctx->current_cont;

    ctx->current_cont            = ret_cont;
    PMC_cont(ret_cont)->from_ctx = ctx;

    current_args                 = interp->current_args;
    interp->current_args         = NULL;

    interp->params_signature     = param_sig;
    parrot_pass_args(interp, caller_ctx, ctx, current_args, param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(ccont) &= ~SUB_FLAG_TAILCALL;
        --ctx->recursion_depth;
        ctx->caller_ctx      = caller_ctx->caller_ctx;
        Parrot_free_context(interp, caller_ctx, 0);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
    PMC* pmc = CTX_REG_PMC(ctx, 0);
    PMC* class_or_role = CTX_REG_PMC(ctx, 1);

    /* BEGIN PMETHOD BODY */
#line 802 "./src/pmc/namespace.pmc"

    Parrot_NSInfo *nsinfo = PARROT_NSINFO(pmc);
    nsinfo->_class        = class_or_role;

#line 413 "/home/mandrake/rpm/BUILD/parrot-0.4.13/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    goto no_return;
    /* END PMETHOD BODY */

set_class_returns:

    /* if (PMC_cont(ccont)->address) { */
    {
        /* parrot_context_t * const caller_ctx = PMC_cont(ccont)->to_ctx; */
        if (! caller_ctx) {
            /* there is no point calling real_exception here, because
               PDB_backtrace can't deal with a missing to_ctx either. */
            internal_exception(1, "No caller_ctx for continuation %p.", ccont);
        }

        interp->returns_signature = return_sig;
        parrot_pass_args(interp, ctx, caller_ctx, return_indexes,
            caller_ctx->current_results, PARROT_PASS_RESULTS);
    }

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_type);
    PObj_live_CLEAR(param_sig);
    PObj_live_CLEAR(return_sig);
    Parrot_pop_context(interp);

}
#line 814 "src/pmc/namespace.c"
void
Parrot_NameSpace_ro_add_attribute(Interp *interp, PMC* pmc, STRING* name, PMC* type)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "add_attribute() in read-only instance of NameSpace");
}
void
Parrot_NameSpace_ro_add_method(Interp *interp, PMC* pmc, STRING* method_name, PMC* sub_pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "add_method() in read-only instance of NameSpace");
}
void
Parrot_NameSpace_ro_add_parent(Interp *interp, PMC* pmc, PMC* parent)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "add_parent() in read-only instance of NameSpace");
}
void
Parrot_NameSpace_ro_add_role(Interp *interp, PMC* pmc, PMC* role)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "add_role() in read-only instance of NameSpace");
}
void
Parrot_NameSpace_ro_assign_pmc(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "assign_pmc() in read-only instance of NameSpace");
}
void
Parrot_NameSpace_ro_assign_string_native(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "assign_string_native() in read-only instance of NameSpace");
}
void
Parrot_NameSpace_ro_decrement(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "decrement() in read-only instance of NameSpace");
}
void
Parrot_NameSpace_ro_delete_keyed(Interp *interp, PMC* pmc, PMC* key)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "delete_keyed() in read-only instance of NameSpace");
}
void
Parrot_NameSpace_ro_delete_keyed_int(Interp *interp, PMC* pmc, INTVAL key)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "delete_keyed_int() in read-only instance of NameSpace");
}
void
Parrot_NameSpace_ro_delete_keyed_str(Interp *interp, PMC* pmc, STRING* key)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "delete_keyed_str() in read-only instance of NameSpace");
}
PMC*
Parrot_NameSpace_ro_find_method(Interp *interp, PMC* pmc, STRING* method_name)
 {
    PMC *const method = Parrot_default_find_method(interp, pmc, method_name);
    if (!PMC_IS_NULL(VTABLE_getprop(interp, method, const_string(interp, "write"))))
        return PMCNULL;
    else
        return method;
}
void
Parrot_NameSpace_ro_i_absolute(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_absolute() in read-only instance of NameSpace");
}
void
Parrot_NameSpace_ro_i_bitwise_not(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_bitwise_not() in read-only instance of NameSpace");
}
void
Parrot_NameSpace_ro_i_bitwise_nots(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_bitwise_nots() in read-only instance of NameSpace");
}
void
Parrot_NameSpace_ro_i_logical_not(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_logical_not() in read-only instance of NameSpace");
}
void
Parrot_NameSpace_ro_i_neg(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_neg() in read-only instance of NameSpace");
}
void
Parrot_NameSpace_ro_increment(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "increment() in read-only instance of NameSpace");
}
void
Parrot_NameSpace_ro_morph(Interp *interp, PMC* pmc, INTVAL type)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "morph() in read-only instance of NameSpace");
}
FLOATVAL
Parrot_NameSpace_ro_pop_float(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "pop_float() in read-only instance of NameSpace");
    return (FLOATVAL)0;
}
INTVAL
Parrot_NameSpace_ro_pop_integer(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "pop_integer() in read-only instance of NameSpace");
    return (INTVAL)0;
}
PMC*
Parrot_NameSpace_ro_pop_pmc(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "pop_pmc() in read-only instance of NameSpace");
    return PMCNULL;
}
STRING*
Parrot_NameSpace_ro_pop_string(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "pop_string() in read-only instance of NameSpace");
    return (STRING*)0;
}
void
Parrot_NameSpace_ro_push_float(Interp *interp, PMC* pmc, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "push_float() in read-only instance of NameSpace");
}
void
Parrot_NameSpace_ro_push_integer(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "push_integer() in read-only instance of NameSpace");
}
void
Parrot_NameSpace_ro_push_pmc(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "push_pmc() in read-only instance of NameSpace");
}
void
Parrot_NameSpace_ro_push_string(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "push_string() in read-only instance of NameSpace");
}
void
Parrot_NameSpace_ro_remove_attribute(Interp *interp, PMC* pmc, STRING* name)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "remove_attribute() in read-only instance of NameSpace");
}
void
Parrot_NameSpace_ro_remove_method(Interp *interp, PMC* pmc, STRING* method_name)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "remove_method() in read-only instance of NameSpace");
}
void
Parrot_NameSpace_ro_remove_parent(Interp *interp, PMC* pmc, PMC* parent)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "remove_parent() in read-only instance of NameSpace");
}
void
Parrot_NameSpace_ro_remove_role(Interp *interp, PMC* pmc, PMC* role)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "remove_role() in read-only instance of NameSpace");
}
void
Parrot_NameSpace_ro_set_attr(Interp *interp, PMC* pmc, INTVAL idx, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_attr() in read-only instance of NameSpace");
}
void
Parrot_NameSpace_ro_set_attr_str(Interp *interp, PMC* pmc, STRING* idx, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_attr_str() in read-only instance of NameSpace");
}
void
Parrot_NameSpace_ro_set_bignum_int(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_bignum_int() in read-only instance of NameSpace");
}
void
Parrot_NameSpace_ro_set_bignum_num(Interp *interp, PMC* pmc, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_bignum_num() in read-only instance of NameSpace");
}
void
Parrot_NameSpace_ro_set_bignum_str(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_bignum_str() in read-only instance of NameSpace");
}
void
Parrot_NameSpace_ro_set_bool(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_bool() in read-only instance of NameSpace");
}
void
Parrot_NameSpace_ro_set_integer_keyed(Interp *interp, PMC* pmc, PMC* key, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_keyed() in read-only instance of NameSpace");
}
void
Parrot_NameSpace_ro_set_integer_keyed_int(Interp *interp, PMC* pmc, INTVAL key, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_keyed_int() in read-only instance of NameSpace");
}
void
Parrot_NameSpace_ro_set_integer_keyed_str(Interp *interp, PMC* pmc, STRING* key, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_keyed_str() in read-only instance of NameSpace");
}
void
Parrot_NameSpace_ro_set_integer_native(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_native() in read-only instance of NameSpace");
}
void
Parrot_NameSpace_ro_set_integer_same(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_same() in read-only instance of NameSpace");
}
void
Parrot_NameSpace_ro_set_number_keyed(Interp *interp, PMC* pmc, PMC* key, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_keyed() in read-only instance of NameSpace");
}
void
Parrot_NameSpace_ro_set_number_keyed_int(Interp *interp, PMC* pmc, INTVAL key, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_keyed_int() in read-only instance of NameSpace");
}
void
Parrot_NameSpace_ro_set_number_keyed_str(Interp *interp, PMC* pmc, STRING* key, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_keyed_str() in read-only instance of NameSpace");
}
void
Parrot_NameSpace_ro_set_number_native(Interp *interp, PMC* pmc, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_native() in read-only instance of NameSpace");
}
void
Parrot_NameSpace_ro_set_number_same(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_same() in read-only instance of NameSpace");
}
void
Parrot_NameSpace_ro_set_pmc(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pmc() in read-only instance of NameSpace");
}
void
Parrot_NameSpace_ro_set_pmc_keyed(Interp *interp, PMC* pmc, PMC* key, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pmc_keyed() in read-only instance of NameSpace");
}
void
Parrot_NameSpace_ro_set_pmc_keyed_int(Interp *interp, PMC* pmc, INTVAL key, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_int() in read-only instance of NameSpace");
}
void
Parrot_NameSpace_ro_set_pmc_keyed_str(Interp *interp, PMC* pmc, STRING* key, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_str() in read-only instance of NameSpace");
}
void
Parrot_NameSpace_ro_set_pointer(Interp *interp, PMC* pmc, void* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pointer() in read-only instance of NameSpace");
}
void
Parrot_NameSpace_ro_set_pointer_keyed(Interp *interp, PMC* pmc, PMC* key, void* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pointer_keyed() in read-only instance of NameSpace");
}
void
Parrot_NameSpace_ro_set_pointer_keyed_int(Interp *interp, PMC* pmc, INTVAL key, void* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_int() in read-only instance of NameSpace");
}
void
Parrot_NameSpace_ro_set_pointer_keyed_str(Interp *interp, PMC* pmc, STRING* key, void* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_str() in read-only instance of NameSpace");
}
void
Parrot_NameSpace_ro_set_string_keyed(Interp *interp, PMC* pmc, PMC* key, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_keyed() in read-only instance of NameSpace");
}
void
Parrot_NameSpace_ro_set_string_keyed_int(Interp *interp, PMC* pmc, INTVAL key, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_keyed_int() in read-only instance of NameSpace");
}
void
Parrot_NameSpace_ro_set_string_keyed_str(Interp *interp, PMC* pmc, STRING* key, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_keyed_str() in read-only instance of NameSpace");
}
void
Parrot_NameSpace_ro_set_string_native(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_native() in read-only instance of NameSpace");
}
void
Parrot_NameSpace_ro_set_string_same(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_same() in read-only instance of NameSpace");
}
FLOATVAL
Parrot_NameSpace_ro_shift_float(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "shift_float() in read-only instance of NameSpace");
    return (FLOATVAL)0;
}
INTVAL
Parrot_NameSpace_ro_shift_integer(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "shift_integer() in read-only instance of NameSpace");
    return (INTVAL)0;
}
PMC*
Parrot_NameSpace_ro_shift_pmc(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "shift_pmc() in read-only instance of NameSpace");
    return PMCNULL;
}
STRING*
Parrot_NameSpace_ro_shift_string(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "shift_string() in read-only instance of NameSpace");
    return (STRING*)0;
}
void
Parrot_NameSpace_ro_splice(Interp *interp, PMC* pmc, PMC* value, INTVAL offset, INTVAL count)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "splice() in read-only instance of NameSpace");
}
void
Parrot_NameSpace_ro_thaw(Interp *interp, PMC* pmc, visit_info* info)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "thaw() in read-only instance of NameSpace");
}
void
Parrot_NameSpace_ro_thawfinish(Interp *interp, PMC* pmc, visit_info* info)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "thawfinish() in read-only instance of NameSpace");
}
void
Parrot_NameSpace_ro_unshift_float(Interp *interp, PMC* pmc, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "unshift_float() in read-only instance of NameSpace");
}
void
Parrot_NameSpace_ro_unshift_integer(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "unshift_integer() in read-only instance of NameSpace");
}
void
Parrot_NameSpace_ro_unshift_pmc(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "unshift_pmc() in read-only instance of NameSpace");
}
void
Parrot_NameSpace_ro_unshift_string(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "unshift_string() in read-only instance of NameSpace");
}
void
Parrot_NameSpace_class_init(Parrot_Interp interp, int entry, int pass)
{
    const VTABLE temp_base_vtable = {
        NULL, /* namespace */
        enum_class_NameSpace, /* base_type */
        NULL, /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_HAS_READONLY_FLAG, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        NULL,   /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_default_add_attribute,
        Parrot_default_add_method,
        Parrot_default_add_parent,
        Parrot_default_add_role,
        Parrot_default_assign_pmc,
        Parrot_default_assign_string_native,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_can,
        Parrot_default_class_type,
        Parrot_Hash_clone,
        Parrot_default_clone_pmc,
        Parrot_default_decrement,
        Parrot_default_defined,
        Parrot_Hash_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_Hash_defined_keyed_str,
        Parrot_Hash_delete_keyed,
        Parrot_default_delete_keyed_int,
        Parrot_Hash_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_NameSpace_destroy,
        Parrot_default_does,
        Parrot_Hash_elements,
        Parrot_Hash_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_Hash_exists_keyed_str,
        Parrot_default_find_method,
        Parrot_Hash_freeze,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_Hash_get_bool,
        Parrot_default_get_class,
        Parrot_Hash_get_integer,
        Parrot_Hash_get_integer_keyed,
        Parrot_Hash_get_integer_keyed_int,
        Parrot_Hash_get_integer_keyed_str,
        Parrot_Hash_get_iter,
        Parrot_default_get_number,
        Parrot_Hash_get_number_keyed,
        Parrot_Hash_get_number_keyed_int,
        Parrot_Hash_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_NameSpace_get_pmc_keyed,
        Parrot_NameSpace_get_pmc_keyed_int,
        Parrot_NameSpace_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_NameSpace_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_NameSpace_get_pointer_keyed_str,
        Parrot_Hash_get_repr,
        Parrot_NameSpace_get_string,
        Parrot_Hash_get_string_keyed,
        Parrot_Hash_get_string_keyed_int,
        Parrot_Hash_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_default_hash,
        Parrot_default_i_absolute,
        Parrot_default_i_bitwise_not,
        Parrot_default_i_bitwise_nots,
        Parrot_default_i_logical_not,
        Parrot_default_i_neg,
        Parrot_default_increment,
        Parrot_NameSpace_init,
        Parrot_default_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_default_instantiate,
        Parrot_default_invoke,
        Parrot_Hash_is_same,
        Parrot_default_isa,
        Parrot_default_logical_not,
        Parrot_NameSpace_mark,
        Parrot_default_morph,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_new_from_string,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_pmc_namespace,
        Parrot_default_pop_float,
        Parrot_default_pop_integer,
        Parrot_default_pop_pmc,
        Parrot_default_pop_string,
        Parrot_default_push_float,
        Parrot_default_push_integer,
        Parrot_default_push_pmc,
        Parrot_default_push_string,
        Parrot_default_remove_attribute,
        Parrot_default_remove_method,
        Parrot_default_remove_parent,
        Parrot_default_remove_role,
        Parrot_default_set_attr,
        Parrot_default_set_attr_str,
        Parrot_default_set_bignum_int,
        Parrot_default_set_bignum_num,
        Parrot_default_set_bignum_str,
        Parrot_default_set_bool,
        Parrot_Hash_set_integer_keyed,
        Parrot_default_set_integer_keyed_int,
        Parrot_Hash_set_integer_keyed_str,
        Parrot_default_set_integer_native,
        Parrot_default_set_integer_same,
        Parrot_Hash_set_number_keyed,
        Parrot_default_set_number_keyed_int,
        Parrot_Hash_set_number_keyed_str,
        Parrot_default_set_number_native,
        Parrot_default_set_number_same,
        Parrot_default_set_pmc,
        Parrot_NameSpace_set_pmc_keyed,
        Parrot_default_set_pmc_keyed_int,
        Parrot_NameSpace_set_pmc_keyed_str,
        Parrot_default_set_pointer,
        Parrot_default_set_pointer_keyed,
        Parrot_default_set_pointer_keyed_int,
        Parrot_default_set_pointer_keyed_str,
        Parrot_Hash_set_string_keyed,
        Parrot_default_set_string_keyed_int,
        Parrot_Hash_set_string_keyed_str,
        Parrot_default_set_string_native,
        Parrot_default_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_default_shift_float,
        Parrot_default_shift_integer,
        Parrot_default_shift_pmc,
        Parrot_default_shift_string,
        Parrot_Hash_slice,
        Parrot_default_splice,
        Parrot_default_subclass,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtype,
        Parrot_Hash_thaw,
        Parrot_default_thawfinish,
        Parrot_default_type,
        Parrot_Hash_type_keyed,
        Parrot_default_type_keyed_int,
        Parrot_Hash_type_keyed_str,
        Parrot_default_unshift_float,
        Parrot_default_unshift_integer,
        Parrot_default_unshift_pmc,
        Parrot_default_unshift_string,
        Parrot_Hash_visit
    };

    const VTABLE temp_ro_vtable = {
        NULL, /* namespace */
        enum_class_NameSpace, /* base_type */
        NULL, /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_IS_READONLY_FLAG, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        NULL,   /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_NameSpace_ro_add_attribute,
        Parrot_NameSpace_ro_add_method,
        Parrot_NameSpace_ro_add_parent,
        Parrot_NameSpace_ro_add_role,
        Parrot_NameSpace_ro_assign_pmc,
        Parrot_NameSpace_ro_assign_string_native,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_can,
        Parrot_default_class_type,
        Parrot_Hash_clone,
        Parrot_default_clone_pmc,
        Parrot_NameSpace_ro_decrement,
        Parrot_default_defined,
        Parrot_Hash_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_Hash_defined_keyed_str,
        Parrot_NameSpace_ro_delete_keyed,
        Parrot_NameSpace_ro_delete_keyed_int,
        Parrot_NameSpace_ro_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_NameSpace_destroy,
        Parrot_default_does,
        Parrot_Hash_elements,
        Parrot_Hash_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_Hash_exists_keyed_str,
        Parrot_NameSpace_ro_find_method,
        Parrot_Hash_freeze,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_Hash_get_bool,
        Parrot_default_get_class,
        Parrot_Hash_get_integer,
        Parrot_Hash_get_integer_keyed,
        Parrot_Hash_get_integer_keyed_int,
        Parrot_Hash_get_integer_keyed_str,
        Parrot_Hash_get_iter,
        Parrot_default_get_number,
        Parrot_Hash_get_number_keyed,
        Parrot_Hash_get_number_keyed_int,
        Parrot_Hash_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_NameSpace_get_pmc_keyed,
        Parrot_NameSpace_get_pmc_keyed_int,
        Parrot_NameSpace_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_NameSpace_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_NameSpace_get_pointer_keyed_str,
        Parrot_Hash_get_repr,
        Parrot_NameSpace_get_string,
        Parrot_Hash_get_string_keyed,
        Parrot_Hash_get_string_keyed_int,
        Parrot_Hash_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_default_hash,
        Parrot_NameSpace_ro_i_absolute,
        Parrot_NameSpace_ro_i_bitwise_not,
        Parrot_NameSpace_ro_i_bitwise_nots,
        Parrot_NameSpace_ro_i_logical_not,
        Parrot_NameSpace_ro_i_neg,
        Parrot_NameSpace_ro_increment,
        Parrot_NameSpace_init,
        Parrot_default_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_default_instantiate,
        Parrot_default_invoke,
        Parrot_Hash_is_same,
        Parrot_default_isa,
        Parrot_default_logical_not,
        Parrot_NameSpace_mark,
        Parrot_NameSpace_ro_morph,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_new_from_string,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_pmc_namespace,
        Parrot_NameSpace_ro_pop_float,
        Parrot_NameSpace_ro_pop_integer,
        Parrot_NameSpace_ro_pop_pmc,
        Parrot_NameSpace_ro_pop_string,
        Parrot_NameSpace_ro_push_float,
        Parrot_NameSpace_ro_push_integer,
        Parrot_NameSpace_ro_push_pmc,
        Parrot_NameSpace_ro_push_string,
        Parrot_NameSpace_ro_remove_attribute,
        Parrot_NameSpace_ro_remove_method,
        Parrot_NameSpace_ro_remove_parent,
        Parrot_NameSpace_ro_remove_role,
        Parrot_NameSpace_ro_set_attr,
        Parrot_NameSpace_ro_set_attr_str,
        Parrot_NameSpace_ro_set_bignum_int,
        Parrot_NameSpace_ro_set_bignum_num,
        Parrot_NameSpace_ro_set_bignum_str,
        Parrot_NameSpace_ro_set_bool,
        Parrot_NameSpace_ro_set_integer_keyed,
        Parrot_NameSpace_ro_set_integer_keyed_int,
        Parrot_NameSpace_ro_set_integer_keyed_str,
        Parrot_NameSpace_ro_set_integer_native,
        Parrot_NameSpace_ro_set_integer_same,
        Parrot_NameSpace_ro_set_number_keyed,
        Parrot_NameSpace_ro_set_number_keyed_int,
        Parrot_NameSpace_ro_set_number_keyed_str,
        Parrot_NameSpace_ro_set_number_native,
        Parrot_NameSpace_ro_set_number_same,
        Parrot_NameSpace_ro_set_pmc,
        Parrot_NameSpace_ro_set_pmc_keyed,
        Parrot_NameSpace_ro_set_pmc_keyed_int,
        Parrot_NameSpace_ro_set_pmc_keyed_str,
        Parrot_NameSpace_ro_set_pointer,
        Parrot_NameSpace_ro_set_pointer_keyed,
        Parrot_NameSpace_ro_set_pointer_keyed_int,
        Parrot_NameSpace_ro_set_pointer_keyed_str,
        Parrot_NameSpace_ro_set_string_keyed,
        Parrot_NameSpace_ro_set_string_keyed_int,
        Parrot_NameSpace_ro_set_string_keyed_str,
        Parrot_NameSpace_ro_set_string_native,
        Parrot_NameSpace_ro_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_NameSpace_ro_shift_float,
        Parrot_NameSpace_ro_shift_integer,
        Parrot_NameSpace_ro_shift_pmc,
        Parrot_NameSpace_ro_shift_string,
        Parrot_Hash_slice,
        Parrot_NameSpace_ro_splice,
        Parrot_default_subclass,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtype,
        Parrot_NameSpace_ro_thaw,
        Parrot_NameSpace_ro_thawfinish,
        Parrot_default_type,
        Parrot_Hash_type_keyed,
        Parrot_default_type_keyed_int,
        Parrot_Hash_type_keyed_str,
        Parrot_NameSpace_ro_unshift_float,
        Parrot_NameSpace_ro_unshift_integer,
        Parrot_NameSpace_ro_unshift_pmc,
        Parrot_NameSpace_ro_unshift_string,
        Parrot_Hash_visit
    };
    if (pass == 0) {
        /*
         * create vtable - clone it - we have to set a few items
         */
        VTABLE *vt_clone =
            Parrot_clone_vtable(interp, &temp_base_vtable);
        VTABLE *vt_ro_clone =
            Parrot_clone_vtable(interp, &temp_ro_vtable);
        vt_clone->whoami = CONST_STRING(interp, "NameSpace");
        vt_clone->isa_str = CONST_STRING(interp, "NameSpace Hash");
        vt_clone->does_str = CONST_STRING(interp, "hash");
        vt_ro_clone->base_type = entry;
        vt_ro_clone->whoami = vt_clone->whoami;
        vt_ro_clone->isa_str = vt_clone->isa_str;
        vt_ro_clone->does_str = vt_clone->does_str;
        vt_clone->ro_variant_vtable = vt_ro_clone;
        vt_ro_clone->ro_variant_vtable = vt_clone;
        interp->vtables[entry] = vt_clone;
    }
    else { /* pass */
        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        /* create PMC Proxy object */
        Parrot_create_pmc_proxy(interp, entry);
        register_nci_method(interp, entry,
                F2DPTR(Parrot_NameSpace_nci_add_namespace),
                "add_namespace", "vJOSP");
        register_nci_method(interp, entry,
                F2DPTR(Parrot_NameSpace_nci_add_sub),
                "add_sub", "vJOSP");
        register_nci_method(interp, entry,
                F2DPTR(Parrot_NameSpace_nci_add_var),
                "add_var", "vJOSP");
        register_nci_method(interp, entry,
                F2DPTR(Parrot_NameSpace_nci_get_name),
                "get_name", "PJO");
        register_nci_method(interp, entry,
                F2DPTR(Parrot_NameSpace_nci_find_namespace),
                "find_namespace", "PJOS");
        register_nci_method(interp, entry,
                F2DPTR(Parrot_NameSpace_nci_find_sub),
                "find_sub", "PJOS");
        register_nci_method(interp, entry,
                F2DPTR(Parrot_NameSpace_nci_find_var),
                "find_var", "PJOS");
        register_nci_method(interp, entry,
                F2DPTR(Parrot_NameSpace_nci_del_namespace),
                "del_namespace", "vJOS");
        register_nci_method(interp, entry,
                F2DPTR(Parrot_NameSpace_nci_del_sub),
                "del_sub", "vJOS");
        register_nci_method(interp, entry,
                F2DPTR(Parrot_NameSpace_nci_del_var),
                "del_var", "vJOS");
        register_nci_method(interp, entry,
                F2DPTR(Parrot_NameSpace_nci_get_sym),
                "get_sym", "PJOS");
        register_nci_method(interp, entry,
                F2DPTR(Parrot_NameSpace_nci_export_to),
                "export_to", "vJOPP");
        register_nci_method(interp, entry,
                F2DPTR(Parrot_NameSpace_nci_get_parent),
                "get_parent", "PJO");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_NameSpace_nci_get_class), "get_class");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_NameSpace_nci_set_class), "set_class");
        /* class_init */
        {
        }
    } /* pass */
} /* Parrot_NameSpace_class_init */

/*

=back

=head1 SEE ALSO

F<docs/pdds/pdd21_namespaces.pod>

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
