/*
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/os.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

#line 1 "./src/pmc/os.pmc"
/*
Copyright (C) 2001-2006, The Perl Foundation.
$Id: os.pmc 19023 2007-06-15 18:40:04Z particle $

=head1 NAME

src/pmc/os.pmc - Files and Directories PMC

=head1 DESCRIPTION

C<OS> is a singleton class which provides access to the filesystem
files and directories.

=head2 Methods

=over 4

=cut

*/

#if defined(_MSC_VER)
#  include <direct.h>
#  include <io.h>
#elif defined(__BORLANDC__)
#  include <dir.h>
#  include <dirent.h>
#else
#  include <dirent.h>
#endif

#include "parrot/parrot.h"

/* XXX Check if we need to deallocate strerror strings */
/* XXX apparently, strerror_r is thread-safe and should be used instead.*/

static PMC * OS_PMC;
#line 50 "src/pmc/os.c"
#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_os.h"
#include "pmc_default.h"
#include "os.str"

void*
Parrot_OS_get_pointer(Interp *interp, PMC* pmc)
#line 53 "./src/pmc/os.pmc"
{
    return OS_PMC;

}
#line 65 "src/pmc/os.c"
PMC*
Parrot_OS_pmc_namespace(Interp *interp, PMC* pmc)
#line 1 "./src/pmc/os.pmc"
{ return interp->vtables[pmc->vtable->base_type]->_namespace; 
}
#line 71 "src/pmc/os.c"
void
Parrot_OS_set_pointer(Interp *interp, PMC* pmc, void* ptr)
#line 57 "./src/pmc/os.pmc"
{
    OS_PMC = (PMC*) ptr;

}
#line 79 "src/pmc/os.c"
STRING*
Parrot_OS_nci_cwd(Interp *interp, PMC* pmc)
#line 72 "./src/pmc/os.pmc"
{
    char * cwd;
#ifdef _MSC_VER
    cwd = _getcwd(NULL, 0);
    /* capitalize the drive letter */
    cwd[0] = toupper(cwd[0]);
#else
#  ifdef PATH_MAX
    cwd = getcwd(NULL, PATH_MAX+1);
#  else
    cwd = getcwd(NULL, 0);
#  endif
#endif
    if (cwd) {
        STRING *scwd;
        scwd = string_from_cstring(interp, cwd, strlen(cwd));
        mem_sys_free(cwd);
        return scwd;
    }
    else {
        char *errmsg = strerror(errno);
        real_exception(interp, NULL, E_SystemError, errmsg);
        return NULL;
    }

}
#line 109 "src/pmc/os.c"
void
Parrot_OS_nci_chdir(Interp *interp, PMC* pmc, STRING *path)
#line 108 "./src/pmc/os.pmc"
{
    int error;
    char *cpath = string_to_cstring(interp, path);
#ifdef _MSC_VER
    error = _chdir(cpath);
#else
    error = chdir(cpath);
#endif
    string_cstring_free(cpath);
    if (error) {
        char *errmsg = strerror(errno);
        real_exception(interp, NULL, E_SystemError, errmsg);
    }

}
#line 128 "src/pmc/os.c"
void
Parrot_OS_nci_rm(Interp *interp, PMC* pmc, STRING *path)
#line 134 "./src/pmc/os.pmc"
{
    struct stat info;
    char *cpath = string_to_cstring(interp, path);
    int error = stat(cpath, &info);
    if (error) {
        char *errmsg = strerror(errno);
        real_exception(interp, NULL, E_SystemError, errmsg);
    }

    if (S_ISDIR(info.st_mode)) {
#ifdef _MSC_VER
        error = _rmdir(cpath);
#else
        error = rmdir(cpath);
#endif
        string_cstring_free(cpath);
        if (error) {
            char *errmsg = strerror(errno);
            real_exception(interp, NULL, E_SystemError, errmsg);
        }
    }
    else {
        error = remove(cpath);
        string_cstring_free(cpath);
        if (error) {
            char *errmsg = strerror(errno);
            real_exception(interp, NULL, E_SystemError, errmsg);
        }
    }

}
#line 163 "src/pmc/os.c"
void
Parrot_OS_nci_mkdir(Interp *interp, PMC* pmc, STRING *path, INTVAL mode)
#line 175 "./src/pmc/os.pmc"
{
    int error;
    char *cpath = string_to_cstring(interp, path);
    /* should we validate mode? */
#ifdef WIN32
    error = _mkdir(cpath);
#else
    error = mkdir(cpath, mode);
#endif
    string_cstring_free(cpath);
    if (error) {
        char *errmsg = strerror(errno);
        real_exception(interp, NULL, E_SystemError, errmsg);
    }

}
#line 183 "src/pmc/os.c"
PMC*
Parrot_OS_nci_stat(Interp *interp, PMC* pmc, STRING *path)
#line 217 "./src/pmc/os.pmc"
{
    struct stat info;
    PMC *array;

    char *cpath = string_to_cstring(interp, path);
    int error = stat(cpath, &info);
    string_cstring_free(cpath);

    if (error) {
        char *errmsg = strerror(errno);
        real_exception(interp, NULL, E_SystemError, errmsg);
        return NULL;
    }
    else {
        array = pmc_new(interp, enum_class_FixedPMCArray);
        VTABLE_set_integer_native(interp, array, 13);

        VTABLE_set_integer_keyed_int(interp, array, 0,
                                     info.st_dev);
        VTABLE_set_integer_keyed_int(interp, array, 1,
                                     info.st_ino);
        VTABLE_set_integer_keyed_int(interp, array, 2,
                                     info.st_mode);
        VTABLE_set_integer_keyed_int(interp, array, 3,
                                     info.st_nlink);
        VTABLE_set_integer_keyed_int(interp, array, 4,
                                     info.st_uid);
        VTABLE_set_integer_keyed_int(interp, array, 5,
                                     info.st_gid);
        VTABLE_set_integer_keyed_int(interp, array, 6,
                                     info.st_rdev);
        VTABLE_set_integer_keyed_int(interp, array, 7,
                                     info.st_size);
        VTABLE_set_integer_keyed_int(interp, array, 8,
                                     info.st_atime);
        VTABLE_set_integer_keyed_int(interp, array, 9,
                                     info.st_mtime);
        VTABLE_set_integer_keyed_int(interp, array,10,
                                     info.st_ctime);
#ifndef WIN32
        VTABLE_set_integer_keyed_int(interp, array,11,
                                     info.st_blksize);
        VTABLE_set_integer_keyed_int(interp, array,12,
                                     info.st_blocks);
#endif
        return array;
    }

}
#line 236 "src/pmc/os.c"
PMC*
Parrot_OS_nci_lstat(Interp *interp, PMC* pmc, STRING *path)
#line 292 "./src/pmc/os.pmc"
{
    struct stat info;
    PMC *array;

    char *cpath = string_to_cstring(interp, path);
#ifdef WIN32
    int error = stat(cpath, &info);
#else
    int error = lstat(cpath, &info);
#endif
    string_cstring_free(cpath);

    if (error) {
        char *errmsg = strerror(errno);
        real_exception(interp, NULL, E_SystemError, errmsg);
        return NULL;
    }
    else {
        array = pmc_new(interp, enum_class_FixedPMCArray);
        VTABLE_set_integer_native(interp, array, 13);

        VTABLE_set_integer_keyed_int(interp, array, 0,
                                     info.st_dev);
        VTABLE_set_integer_keyed_int(interp, array, 1,
                                     info.st_ino);
        VTABLE_set_integer_keyed_int(interp, array, 2,
                                     info.st_mode);
        VTABLE_set_integer_keyed_int(interp, array, 3,
                                     info.st_nlink);
        VTABLE_set_integer_keyed_int(interp, array, 4,
                                     info.st_uid);
        VTABLE_set_integer_keyed_int(interp, array, 5,
                                     info.st_gid);
        VTABLE_set_integer_keyed_int(interp, array, 6,
                                     info.st_rdev);
        VTABLE_set_integer_keyed_int(interp, array, 7,
                                     info.st_size);
        VTABLE_set_integer_keyed_int(interp, array, 8,
                                     info.st_atime);
        VTABLE_set_integer_keyed_int(interp, array, 9,
                                     info.st_mtime);
        VTABLE_set_integer_keyed_int(interp, array,10,
                                     info.st_ctime);
#ifndef WIN32
        VTABLE_set_integer_keyed_int(interp, array,11,
                                     info.st_blksize);
        VTABLE_set_integer_keyed_int(interp, array,12,
                                     info.st_blocks);
#endif
        return array;
    }

}
#line 293 "src/pmc/os.c"
void
Parrot_OS_nci_symlink(Interp *interp, PMC* pmc, STRING *from, STRING *to)
#line 355 "./src/pmc/os.pmc"
{
#ifndef WIN32
    char *cfrom = string_to_cstring(interp, from);
    char *cto = string_to_cstring(interp, to);
    int error = symlink(cfrom, cto);
    string_cstring_free(cfrom);
    string_cstring_free(cto);
    if (error) {
        char *errmsg = strerror(errno);
        real_exception(interp, NULL, E_SystemError, errmsg);
    }
#else
    real_exception(interp, NULL, E_NotImplementedError,
            "Win32 does not support symlinks!");
#endif

}
#line 314 "src/pmc/os.c"
void
Parrot_OS_nci_link(Interp *interp, PMC* pmc, STRING *from, STRING *to)
#line 382 "./src/pmc/os.pmc"
{
#ifndef WIN32
    char *cfrom = string_to_cstring(interp, from);
    char *cto = string_to_cstring(interp, to);
    int error = link(cfrom, cto);
    string_cstring_free(cfrom);
    string_cstring_free(cto);
    if (error) {
        char *errmsg = strerror(errno);
        real_exception(interp, NULL, E_SystemError, errmsg);
    }
#else
    real_exception(interp, NULL, E_NotImplementedError,
            "Win32 is not POSIX. Need win32 developer!");
#endif

}
#line 335 "src/pmc/os.c"
INTVAL
Parrot_OS_nci_umask(Interp *interp, PMC* pmc, INTVAL mask)
#line 410 "./src/pmc/os.pmc"
{
#ifndef _MSC_VER
    INTVAL old = umask(mask);
    return old;
#else
    real_exception(interp, NULL, E_NotImplementedError,
            "Win32 is not POSIX. Need win32 developer!");
    return 0;
#endif

}
#line 350 "src/pmc/os.c"
void
Parrot_OS_nci_chroot(Interp *interp, PMC* pmc, STRING* path)
#line 435 "./src/pmc/os.pmc"
{
#ifndef WIN32
    char *cpath = string_to_cstring(interp, path);
    int error = chroot(cpath);
    string_cstring_free(cpath);
    if (error) {
        char *errmsg = strerror(errno);
        real_exception(interp, NULL, E_SystemError, errmsg);
    }
#else
    real_exception(interp, NULL, E_NotImplementedError,
            "Win32 is not POSIX. Need win32 developer!");
#endif

}
#line 369 "src/pmc/os.c"
PMC*
Parrot_OS_nci_readdir(Interp *interp, PMC* pmc, STRING* path)
#line 460 "./src/pmc/os.pmc"
{
#ifndef _MSC_VER
    DIR *dir ;
    struct dirent *dirent;
    PMC *array;
    char *cpath = string_to_cstring(interp, path);
    STRING *retval ;

    dir = opendir(cpath);
    string_cstring_free(cpath);
    if (dir == NULL)
    {
        char *errmsg = strerror(errno);
        real_exception(interp, NULL, E_SystemError, errmsg);
    }

    array = pmc_new(interp, enum_class_ResizableStringArray);
    while ((dirent = readdir(dir)) != NULL)
    {
        retval = string_from_cstring(interp, dirent->d_name, 0) ;
        VTABLE_push_string(interp, array, retval);
    }

    closedir(dir);

    return array ;
#else
    real_exception(interp, NULL, E_NotImplementedError,
            "Win32 is not POSIX. Need win32 developer!");
    return NULL;
#endif

}
#line 406 "src/pmc/os.c"
void
Parrot_OS_nci_rename(Interp *interp, PMC* pmc, STRING* oldpath, STRING* newpath)
#line 500 "./src/pmc/os.pmc"
{
    char *coldpath = string_to_cstring(interp, oldpath);
    char *cnewpath = string_to_cstring(interp, newpath);
    int ret;

    ret = rename(coldpath, cnewpath);

    string_cstring_free(coldpath);
    string_cstring_free(cnewpath);

    if (ret < 0) {
        const char * const errmsg = strerror(errno) ;
        real_exception(interp, NULL, E_SystemError, "%s", errmsg);
    }

}
#line 426 "src/pmc/os.c"
void
Parrot_OS_class_init(Parrot_Interp interp, int entry, int pass)
{
    const VTABLE temp_base_vtable = {
        NULL, /* namespace */
        enum_class_OS, /* base_type */
        NULL, /* whoami */
        0|VTABLE_PMC_IS_SINGLETON, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        NULL,   /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_default_add_attribute,
        Parrot_default_add_method,
        Parrot_default_add_parent,
        Parrot_default_add_role,
        Parrot_default_assign_pmc,
        Parrot_default_assign_string_native,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_can,
        Parrot_default_class_type,
        Parrot_default_clone,
        Parrot_default_clone_pmc,
        Parrot_default_decrement,
        Parrot_default_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_default_delete_keyed,
        Parrot_default_delete_keyed_int,
        Parrot_default_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_default_destroy,
        Parrot_default_does,
        Parrot_default_elements,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_default_find_method,
        Parrot_default_freeze,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_default_get_bool,
        Parrot_default_get_class,
        Parrot_default_get_integer,
        Parrot_default_get_integer_keyed,
        Parrot_default_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_iter,
        Parrot_default_get_number,
        Parrot_default_get_number_keyed,
        Parrot_default_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_default_get_pmc_keyed,
        Parrot_default_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_OS_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_default_get_repr,
        Parrot_default_get_string,
        Parrot_default_get_string_keyed,
        Parrot_default_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_default_hash,
        Parrot_default_i_absolute,
        Parrot_default_i_bitwise_not,
        Parrot_default_i_bitwise_nots,
        Parrot_default_i_logical_not,
        Parrot_default_i_neg,
        Parrot_default_increment,
        Parrot_default_init,
        Parrot_default_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_default_instantiate,
        Parrot_default_invoke,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_logical_not,
        Parrot_default_mark,
        Parrot_default_morph,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_new_from_string,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_OS_pmc_namespace,
        Parrot_default_pop_float,
        Parrot_default_pop_integer,
        Parrot_default_pop_pmc,
        Parrot_default_pop_string,
        Parrot_default_push_float,
        Parrot_default_push_integer,
        Parrot_default_push_pmc,
        Parrot_default_push_string,
        Parrot_default_remove_attribute,
        Parrot_default_remove_method,
        Parrot_default_remove_parent,
        Parrot_default_remove_role,
        Parrot_default_set_attr,
        Parrot_default_set_attr_str,
        Parrot_default_set_bignum_int,
        Parrot_default_set_bignum_num,
        Parrot_default_set_bignum_str,
        Parrot_default_set_bool,
        Parrot_default_set_integer_keyed,
        Parrot_default_set_integer_keyed_int,
        Parrot_default_set_integer_keyed_str,
        Parrot_default_set_integer_native,
        Parrot_default_set_integer_same,
        Parrot_default_set_number_keyed,
        Parrot_default_set_number_keyed_int,
        Parrot_default_set_number_keyed_str,
        Parrot_default_set_number_native,
        Parrot_default_set_number_same,
        Parrot_default_set_pmc,
        Parrot_default_set_pmc_keyed,
        Parrot_default_set_pmc_keyed_int,
        Parrot_default_set_pmc_keyed_str,
        Parrot_OS_set_pointer,
        Parrot_default_set_pointer_keyed,
        Parrot_default_set_pointer_keyed_int,
        Parrot_default_set_pointer_keyed_str,
        Parrot_default_set_string_keyed,
        Parrot_default_set_string_keyed_int,
        Parrot_default_set_string_keyed_str,
        Parrot_default_set_string_native,
        Parrot_default_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_default_shift_float,
        Parrot_default_shift_integer,
        Parrot_default_shift_pmc,
        Parrot_default_shift_string,
        Parrot_default_slice,
        Parrot_default_splice,
        Parrot_default_subclass,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtype,
        Parrot_default_thaw,
        Parrot_default_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_type_keyed_int,
        Parrot_default_type_keyed_str,
        Parrot_default_unshift_float,
        Parrot_default_unshift_integer,
        Parrot_default_unshift_pmc,
        Parrot_default_unshift_string,
        Parrot_default_visit
    };

    if (pass == 0) {
        /*
         * create vtable - clone it - we have to set a few items
         */
        VTABLE *vt_clone =
            Parrot_clone_vtable(interp, &temp_base_vtable);
        vt_clone->whoami = CONST_STRING(interp, "OS");
        vt_clone->isa_str = CONST_STRING(interp, "OS");
        vt_clone->does_str = CONST_STRING(interp, "scalar");
        interp->vtables[entry] = vt_clone;
    }
    else { /* pass */
        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        /* create PMC Proxy object */
        Parrot_create_pmc_proxy(interp, entry);
        register_nci_method(interp, entry,
                F2DPTR(Parrot_OS_nci_cwd),
                "cwd", "SJO");
        register_nci_method(interp, entry,
                F2DPTR(Parrot_OS_nci_chdir),
                "chdir", "vJOS");
        register_nci_method(interp, entry,
                F2DPTR(Parrot_OS_nci_rm),
                "rm", "vJOS");
        register_nci_method(interp, entry,
                F2DPTR(Parrot_OS_nci_mkdir),
                "mkdir", "vJOSI");
        register_nci_method(interp, entry,
                F2DPTR(Parrot_OS_nci_stat),
                "stat", "PJOS");
        register_nci_method(interp, entry,
                F2DPTR(Parrot_OS_nci_lstat),
                "lstat", "PJOS");
        register_nci_method(interp, entry,
                F2DPTR(Parrot_OS_nci_symlink),
                "symlink", "vJOSS");
        register_nci_method(interp, entry,
                F2DPTR(Parrot_OS_nci_link),
                "link", "vJOSS");
        register_nci_method(interp, entry,
                F2DPTR(Parrot_OS_nci_umask),
                "umask", "IJOI");
        register_nci_method(interp, entry,
                F2DPTR(Parrot_OS_nci_chroot),
                "chroot", "vJOS");
        register_nci_method(interp, entry,
                F2DPTR(Parrot_OS_nci_readdir),
                "readdir", "PJOS");
        register_nci_method(interp, entry,
                F2DPTR(Parrot_OS_nci_rename),
                "rename", "vJOSS");
        /* class_init */
        {
        }
    } /* pass */
} /* Parrot_OS_class_init */

/*

=back

=head1 SEE ALS0

   chdir(2), getcwd(3), unlink(2), mkdir(2), stat(2), lstat(2),
   symlink(2), link(2), umask(2), chroot(2)

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
