/*
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/parrotio.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

#line 1 "./src/pmc/parrotio.pmc"
/*
Copyright (C) 2001-2007, The Perl Foundation.
$Id: parrotio.pmc 18915 2007-06-11 03:08:03Z petdance $

=head1 NAME

src/pmc/parrotio.pmc - Parrot IO

=head1 DESCRIPTION

These are the vtable functions for Parrot IO.

=head2 Methods

=over 4

=cut

*/

#include "parrot/parrot.h"
#include <assert.h>

/* This class is actually part of the io subsystem */
#include "../src/io/io_private.h"

#ifdef PARROT_HAS_READLINE
extern char* readline(const char*);
void add_history(const char*);
#endif

#line 44 "src/pmc/parrotio.c"
#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_parrotio.h"
#include "pmc_default.h"
#include "parrotio.str"

PMC*
Parrot_ParrotIO_clone(Interp *interp, PMC* pmc)
#line 375 "./src/pmc/parrotio.pmc"
{
    PMC* dest = pmc_new(interp, pmc->vtable->base_type);
    PMC_data(dest) = PMC_data(pmc);
    PMC_struct_val(dest) = PMC_struct_val(pmc);
    return dest;

}
#line 62 "src/pmc/parrotio.c"
void
Parrot_ParrotIO_destroy(Interp *interp, PMC* pmc)
#line 348 "./src/pmc/parrotio.pmc"
{
    ParrotIO *io = (ParrotIO *)PMC_data(pmc);
    if (io) {
        /* shared filehandles will only get flushed */
        if (io->flags & PIO_F_SHARED) {
            PIO_flush(interp, pmc);
        }
        else {
            PIO_close(interp, pmc);
        }
        PIO_destroy(interp, pmc);
    }

}
#line 80 "src/pmc/parrotio.c"
INTVAL
Parrot_ParrotIO_get_bool(Interp *interp, PMC* pmc)
#line 392 "./src/pmc/parrotio.pmc"
{
    return !PIO_eof(interp, pmc);

}
#line 88 "src/pmc/parrotio.c"
STRING*
Parrot_ParrotIO_get_string_keyed_int(Interp *interp, PMC* pmc, INTVAL n)
#line 408 "./src/pmc/parrotio.pmc"
{
    ParrotIO *io = (ParrotIO *)PMC_data(pmc);
    ParrotIOLayer *layer;
    if (!io)
        return const_string(interp, "");
    layer = io->stack;
    if (n >= 0) {
        ParrotIOLayer *last;
        last = layer;
        for (; layer; layer = layer->down)
            last = layer;
        for (; n && last; --n, last = last->up)
            ;
        if (last)
            return string_from_cstring(interp, last->name, 0);
        return const_string(interp, "");
    }
    for (++n; n && layer; layer = layer->down, ++n)
        ;
    if (layer)
        return string_from_cstring(interp, layer->name, 0);
    return const_string(interp, "");

}
#line 116 "src/pmc/parrotio.c"
void
Parrot_ParrotIO_init(Interp *interp, PMC* pmc)
#line 334 "./src/pmc/parrotio.pmc"
{
    PObj_active_destroy_SET(pmc);

}
#line 124 "src/pmc/parrotio.c"
STRING*
Parrot_ParrotIO_pop_string(Interp *interp, PMC* pmc)
#line 449 "./src/pmc/parrotio.pmc"
{
    return PIO_pop_layer_str(interp, pmc);

}
#line 132 "src/pmc/parrotio.c"
void
Parrot_ParrotIO_push_string(Interp *interp, PMC* pmc, STRING* value)
#line 445 "./src/pmc/parrotio.pmc"
{
    PIO_push_layer_str(interp, pmc, value);

}
#line 140 "src/pmc/parrotio.c"
INTVAL
Parrot_ParrotIO_nci_say(Interp *interp, PMC* pmc, STRING *s)
#line 45 "./src/pmc/parrotio.pmc"
{
    PMC *out = pmc == interp->vtables[enum_class_ParrotIO]->pmc_class ?
        PIO_STDOUT(interp) : pmc;
    INTVAL r = PIO_putps(interp, out, s);
    r  += PIO_puts(interp, out, "\n");
    return r;

}
#line 152 "src/pmc/parrotio.c"
PMC*
Parrot_ParrotIO_nci_open(Interp *interp, PMC* pmc, STRING* file, STRING *mode, STRING* layer)
#line 62 "./src/pmc/parrotio.pmc"
{
    ParrotIOLayer *l;
    char *c_file, *c_mode, *c_layer;
    PMC *pio;

    c_file  = string_to_cstring(interp, file);
    c_mode  = string_to_cstring(interp, mode);
    c_layer = string_to_cstring(interp, layer);
    l       = PIO_get_layer(interp, c_layer);
    pio     = PIO_open(interp, l, c_file, c_mode);

    string_cstring_free(c_file);
    string_cstring_free(c_mode);
    string_cstring_free(c_layer);

    if (!pio || !PMC_struct_val(pio))
        return pmc_new(interp, enum_class_Undef);
    if (l) {
        ParrotIO * const io = (ParrotIO *)PMC_data(pio);
        const int is_mmap = strcmp(c_layer, "mmap") == 0;
        /*
         * XXX move this into the layer
         */
        if ((is_mmap && (io->b.flags & PIO_BF_MMAP)) || !is_mmap) {
            l = interp->piodata->default_stack;
            if (strcmp(l->name, "buf") == 0)
                l = l->down;
            /* XXX layer is stored twice - which is used when */
            io->stack           = l;
            PMC_struct_val(pio) = l;
            /* push the layer */
            PIO_push_layer_str(interp, pio, layer);
        }
        else {
            l = interp->piodata->default_stack;
            io->stack           = l;
            PMC_struct_val(pio) = l;
        }
    }
    /* XXX leaks as in ops/io.ops: open */
    return pio;

}
#line 199 "src/pmc/parrotio.c"
INTVAL
Parrot_ParrotIO_nci_set_readline_interactive(Interp *interp, PMC* pmc, INTVAL on)
#line 156 "./src/pmc/parrotio.pmc"
{
    ParrotIO *io = (ParrotIO *)PMC_data(pmc);
#ifdef PARROT_HAS_READLINE
    INTVAL flag;
#endif
    if (!io)
        return -2;
    if (!(io->flags & PIO_F_READ))
        return -2;
#ifdef PARROT_HAS_READLINE
    if (on && !(io->flags & PIO_F_CONSOLE))
        return -2;
    flag = !!(io->flags & PIO_F_READLINE);
    if (on)
        io->flags |= PIO_F_READLINE;
    else
        io->flags &= ~PIO_F_READLINE;
    return flag;
#else
    return -1;
#endif

}
#line 226 "src/pmc/parrotio.c"
PMC*
Parrot_ParrotIO_nci_readline(Interp *interp, PMC* pmc, STRING* prompt)
#line 179 "./src/pmc/parrotio.pmc"
{
    ParrotIO *io = (ParrotIO *)PMC_data(pmc);
    PMC *pmc_res = NULL;
    STRING *res = NULL;
    UINTVAL len;

    if (!io)
        return NULL;
#ifdef PARROT_HAS_READLINE
    if (io->flags & PIO_F_READLINE) {
        char *r;

        r = readline(prompt ? prompt->strstart : NULL);
        if (r) {
            if (*r)
                add_history(r);
            res = string_from_cstring(interp, r, 0);
            free(r);
            pmc_res = pmc_new(interp, enum_class_String);
            PMC_str_val(pmc_res) = res;
            return pmc_res;
        }
        return PMCNULL;
    }
    else
#endif
    {
        if (!(io->flags & PIO_F_LINEBUF))
            PIO_setlinebuf(interp, pmc);
        res = PIO_reads(interp, pmc, 0);
        if (!res)
            return PMCNULL;
        /* readline should better return the string w/o NL */
        len = string_length(interp, res);
        while (len && (((char*)res->strstart)[len-1] == '\n'
                   ||  ((char*)res->strstart)[len-1] == '\r')) {
            --len;
            --res->strlen;
            --res->bufused;
        }
        pmc_res = pmc_new(interp, enum_class_String);
        PMC_str_val(pmc_res) = res;
        return pmc_res;
    }

}
#line 276 "src/pmc/parrotio.c"
STRING*
Parrot_ParrotIO_nci_slurp(Interp *interp, PMC* pmc, STRING* name)
#line 252 "./src/pmc/parrotio.pmc"
{
    STRING* result;
    if (!PMC_data0(pmc)) {
        /* called as class method - open, slurp, close file */
        char * const path = string_to_cstring(interp, name);
        INTVAL size = Parrot_stat_info_intval(interp, name, STAT_FILESIZE);
        PMC* pio = PIO_open(interp, NULL, path, "<");
        string_cstring_free(path);
        /* TODO handle stdin */
        result = PIO_reads(interp, pio, size);
        PIO_close(interp, pio);
        return result;
    }
    else {
        /* slurp open file */
        STRING *part;
        if (!PMC_data(pmc))
            real_exception(interp, NULL, PIO_ERROR,
                    "Cannot slurp from empty filehandle");
        result = NULL;
        do {
            part = PIO_reads(interp, pmc, 4096);
            if (string_length(interp, part) == 0)
                break;
            result = string_append(interp, result, part);
        } while (1);
    }
    return result;

}
#line 310 "src/pmc/parrotio.c"
void
Parrot_ParrotIO_ro_add_attribute(Interp *interp, PMC* pmc, STRING* name, PMC* type)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "add_attribute() in read-only instance of ParrotIO");
}
void
Parrot_ParrotIO_ro_add_method(Interp *interp, PMC* pmc, STRING* method_name, PMC* sub_pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "add_method() in read-only instance of ParrotIO");
}
void
Parrot_ParrotIO_ro_add_parent(Interp *interp, PMC* pmc, PMC* parent)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "add_parent() in read-only instance of ParrotIO");
}
void
Parrot_ParrotIO_ro_add_role(Interp *interp, PMC* pmc, PMC* role)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "add_role() in read-only instance of ParrotIO");
}
void
Parrot_ParrotIO_ro_assign_pmc(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "assign_pmc() in read-only instance of ParrotIO");
}
void
Parrot_ParrotIO_ro_assign_string_native(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "assign_string_native() in read-only instance of ParrotIO");
}
void
Parrot_ParrotIO_ro_decrement(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "decrement() in read-only instance of ParrotIO");
}
void
Parrot_ParrotIO_ro_delete_keyed(Interp *interp, PMC* pmc, PMC* key)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "delete_keyed() in read-only instance of ParrotIO");
}
void
Parrot_ParrotIO_ro_delete_keyed_int(Interp *interp, PMC* pmc, INTVAL key)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "delete_keyed_int() in read-only instance of ParrotIO");
}
void
Parrot_ParrotIO_ro_delete_keyed_str(Interp *interp, PMC* pmc, STRING* key)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "delete_keyed_str() in read-only instance of ParrotIO");
}
PMC*
Parrot_ParrotIO_ro_find_method(Interp *interp, PMC* pmc, STRING* method_name)
 {
    PMC *const method = Parrot_default_find_method(interp, pmc, method_name);
    if (!PMC_IS_NULL(VTABLE_getprop(interp, method, const_string(interp, "write"))))
        return PMCNULL;
    else
        return method;
}
void
Parrot_ParrotIO_ro_i_absolute(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_absolute() in read-only instance of ParrotIO");
}
void
Parrot_ParrotIO_ro_i_bitwise_not(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_bitwise_not() in read-only instance of ParrotIO");
}
void
Parrot_ParrotIO_ro_i_bitwise_nots(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_bitwise_nots() in read-only instance of ParrotIO");
}
void
Parrot_ParrotIO_ro_i_logical_not(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_logical_not() in read-only instance of ParrotIO");
}
void
Parrot_ParrotIO_ro_i_neg(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_neg() in read-only instance of ParrotIO");
}
void
Parrot_ParrotIO_ro_increment(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "increment() in read-only instance of ParrotIO");
}
void
Parrot_ParrotIO_ro_morph(Interp *interp, PMC* pmc, INTVAL type)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "morph() in read-only instance of ParrotIO");
}
FLOATVAL
Parrot_ParrotIO_ro_pop_float(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "pop_float() in read-only instance of ParrotIO");
    return (FLOATVAL)0;
}
INTVAL
Parrot_ParrotIO_ro_pop_integer(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "pop_integer() in read-only instance of ParrotIO");
    return (INTVAL)0;
}
PMC*
Parrot_ParrotIO_ro_pop_pmc(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "pop_pmc() in read-only instance of ParrotIO");
    return PMCNULL;
}
STRING*
Parrot_ParrotIO_ro_pop_string(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "pop_string() in read-only instance of ParrotIO");
    return (STRING*)0;
}
void
Parrot_ParrotIO_ro_push_float(Interp *interp, PMC* pmc, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "push_float() in read-only instance of ParrotIO");
}
void
Parrot_ParrotIO_ro_push_integer(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "push_integer() in read-only instance of ParrotIO");
}
void
Parrot_ParrotIO_ro_push_pmc(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "push_pmc() in read-only instance of ParrotIO");
}
void
Parrot_ParrotIO_ro_push_string(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "push_string() in read-only instance of ParrotIO");
}
void
Parrot_ParrotIO_ro_remove_attribute(Interp *interp, PMC* pmc, STRING* name)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "remove_attribute() in read-only instance of ParrotIO");
}
void
Parrot_ParrotIO_ro_remove_method(Interp *interp, PMC* pmc, STRING* method_name)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "remove_method() in read-only instance of ParrotIO");
}
void
Parrot_ParrotIO_ro_remove_parent(Interp *interp, PMC* pmc, PMC* parent)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "remove_parent() in read-only instance of ParrotIO");
}
void
Parrot_ParrotIO_ro_remove_role(Interp *interp, PMC* pmc, PMC* role)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "remove_role() in read-only instance of ParrotIO");
}
void
Parrot_ParrotIO_ro_set_attr(Interp *interp, PMC* pmc, INTVAL idx, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_attr() in read-only instance of ParrotIO");
}
void
Parrot_ParrotIO_ro_set_attr_str(Interp *interp, PMC* pmc, STRING* idx, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_attr_str() in read-only instance of ParrotIO");
}
void
Parrot_ParrotIO_ro_set_bignum_int(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_bignum_int() in read-only instance of ParrotIO");
}
void
Parrot_ParrotIO_ro_set_bignum_num(Interp *interp, PMC* pmc, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_bignum_num() in read-only instance of ParrotIO");
}
void
Parrot_ParrotIO_ro_set_bignum_str(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_bignum_str() in read-only instance of ParrotIO");
}
void
Parrot_ParrotIO_ro_set_bool(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_bool() in read-only instance of ParrotIO");
}
void
Parrot_ParrotIO_ro_set_integer_keyed(Interp *interp, PMC* pmc, PMC* key, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_keyed() in read-only instance of ParrotIO");
}
void
Parrot_ParrotIO_ro_set_integer_keyed_int(Interp *interp, PMC* pmc, INTVAL key, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_keyed_int() in read-only instance of ParrotIO");
}
void
Parrot_ParrotIO_ro_set_integer_keyed_str(Interp *interp, PMC* pmc, STRING* key, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_keyed_str() in read-only instance of ParrotIO");
}
void
Parrot_ParrotIO_ro_set_integer_native(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_native() in read-only instance of ParrotIO");
}
void
Parrot_ParrotIO_ro_set_integer_same(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_same() in read-only instance of ParrotIO");
}
void
Parrot_ParrotIO_ro_set_number_keyed(Interp *interp, PMC* pmc, PMC* key, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_keyed() in read-only instance of ParrotIO");
}
void
Parrot_ParrotIO_ro_set_number_keyed_int(Interp *interp, PMC* pmc, INTVAL key, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_keyed_int() in read-only instance of ParrotIO");
}
void
Parrot_ParrotIO_ro_set_number_keyed_str(Interp *interp, PMC* pmc, STRING* key, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_keyed_str() in read-only instance of ParrotIO");
}
void
Parrot_ParrotIO_ro_set_number_native(Interp *interp, PMC* pmc, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_native() in read-only instance of ParrotIO");
}
void
Parrot_ParrotIO_ro_set_number_same(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_same() in read-only instance of ParrotIO");
}
void
Parrot_ParrotIO_ro_set_pmc(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pmc() in read-only instance of ParrotIO");
}
void
Parrot_ParrotIO_ro_set_pmc_keyed(Interp *interp, PMC* pmc, PMC* key, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pmc_keyed() in read-only instance of ParrotIO");
}
void
Parrot_ParrotIO_ro_set_pmc_keyed_int(Interp *interp, PMC* pmc, INTVAL key, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_int() in read-only instance of ParrotIO");
}
void
Parrot_ParrotIO_ro_set_pmc_keyed_str(Interp *interp, PMC* pmc, STRING* key, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_str() in read-only instance of ParrotIO");
}
void
Parrot_ParrotIO_ro_set_pointer(Interp *interp, PMC* pmc, void* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pointer() in read-only instance of ParrotIO");
}
void
Parrot_ParrotIO_ro_set_pointer_keyed(Interp *interp, PMC* pmc, PMC* key, void* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pointer_keyed() in read-only instance of ParrotIO");
}
void
Parrot_ParrotIO_ro_set_pointer_keyed_int(Interp *interp, PMC* pmc, INTVAL key, void* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_int() in read-only instance of ParrotIO");
}
void
Parrot_ParrotIO_ro_set_pointer_keyed_str(Interp *interp, PMC* pmc, STRING* key, void* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_str() in read-only instance of ParrotIO");
}
void
Parrot_ParrotIO_ro_set_string_keyed(Interp *interp, PMC* pmc, PMC* key, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_keyed() in read-only instance of ParrotIO");
}
void
Parrot_ParrotIO_ro_set_string_keyed_int(Interp *interp, PMC* pmc, INTVAL key, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_keyed_int() in read-only instance of ParrotIO");
}
void
Parrot_ParrotIO_ro_set_string_keyed_str(Interp *interp, PMC* pmc, STRING* key, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_keyed_str() in read-only instance of ParrotIO");
}
void
Parrot_ParrotIO_ro_set_string_native(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_native() in read-only instance of ParrotIO");
}
void
Parrot_ParrotIO_ro_set_string_same(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_same() in read-only instance of ParrotIO");
}
FLOATVAL
Parrot_ParrotIO_ro_shift_float(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "shift_float() in read-only instance of ParrotIO");
    return (FLOATVAL)0;
}
INTVAL
Parrot_ParrotIO_ro_shift_integer(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "shift_integer() in read-only instance of ParrotIO");
    return (INTVAL)0;
}
PMC*
Parrot_ParrotIO_ro_shift_pmc(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "shift_pmc() in read-only instance of ParrotIO");
    return PMCNULL;
}
STRING*
Parrot_ParrotIO_ro_shift_string(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "shift_string() in read-only instance of ParrotIO");
    return (STRING*)0;
}
void
Parrot_ParrotIO_ro_splice(Interp *interp, PMC* pmc, PMC* value, INTVAL offset, INTVAL count)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "splice() in read-only instance of ParrotIO");
}
void
Parrot_ParrotIO_ro_thaw(Interp *interp, PMC* pmc, visit_info* info)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "thaw() in read-only instance of ParrotIO");
}
void
Parrot_ParrotIO_ro_thawfinish(Interp *interp, PMC* pmc, visit_info* info)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "thawfinish() in read-only instance of ParrotIO");
}
void
Parrot_ParrotIO_ro_unshift_float(Interp *interp, PMC* pmc, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "unshift_float() in read-only instance of ParrotIO");
}
void
Parrot_ParrotIO_ro_unshift_integer(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "unshift_integer() in read-only instance of ParrotIO");
}
void
Parrot_ParrotIO_ro_unshift_pmc(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "unshift_pmc() in read-only instance of ParrotIO");
}
void
Parrot_ParrotIO_ro_unshift_string(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "unshift_string() in read-only instance of ParrotIO");
}
void
Parrot_ParrotIO_class_init(Parrot_Interp interp, int entry, int pass)
{
    const VTABLE temp_base_vtable = {
        NULL, /* namespace */
        enum_class_ParrotIO, /* base_type */
        NULL, /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_HAS_READONLY_FLAG, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        NULL,   /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_default_add_attribute,
        Parrot_default_add_method,
        Parrot_default_add_parent,
        Parrot_default_add_role,
        Parrot_default_assign_pmc,
        Parrot_default_assign_string_native,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_can,
        Parrot_default_class_type,
        Parrot_ParrotIO_clone,
        Parrot_default_clone_pmc,
        Parrot_default_decrement,
        Parrot_default_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_default_delete_keyed,
        Parrot_default_delete_keyed_int,
        Parrot_default_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_ParrotIO_destroy,
        Parrot_default_does,
        Parrot_default_elements,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_default_find_method,
        Parrot_default_freeze,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_ParrotIO_get_bool,
        Parrot_default_get_class,
        Parrot_default_get_integer,
        Parrot_default_get_integer_keyed,
        Parrot_default_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_iter,
        Parrot_default_get_number,
        Parrot_default_get_number_keyed,
        Parrot_default_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_default_get_pmc_keyed,
        Parrot_default_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_default_get_repr,
        Parrot_default_get_string,
        Parrot_default_get_string_keyed,
        Parrot_ParrotIO_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_default_hash,
        Parrot_default_i_absolute,
        Parrot_default_i_bitwise_not,
        Parrot_default_i_bitwise_nots,
        Parrot_default_i_logical_not,
        Parrot_default_i_neg,
        Parrot_default_increment,
        Parrot_ParrotIO_init,
        Parrot_default_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_default_instantiate,
        Parrot_default_invoke,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_logical_not,
        Parrot_default_mark,
        Parrot_default_morph,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_new_from_string,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_pmc_namespace,
        Parrot_default_pop_float,
        Parrot_default_pop_integer,
        Parrot_default_pop_pmc,
        Parrot_ParrotIO_pop_string,
        Parrot_default_push_float,
        Parrot_default_push_integer,
        Parrot_default_push_pmc,
        Parrot_ParrotIO_push_string,
        Parrot_default_remove_attribute,
        Parrot_default_remove_method,
        Parrot_default_remove_parent,
        Parrot_default_remove_role,
        Parrot_default_set_attr,
        Parrot_default_set_attr_str,
        Parrot_default_set_bignum_int,
        Parrot_default_set_bignum_num,
        Parrot_default_set_bignum_str,
        Parrot_default_set_bool,
        Parrot_default_set_integer_keyed,
        Parrot_default_set_integer_keyed_int,
        Parrot_default_set_integer_keyed_str,
        Parrot_default_set_integer_native,
        Parrot_default_set_integer_same,
        Parrot_default_set_number_keyed,
        Parrot_default_set_number_keyed_int,
        Parrot_default_set_number_keyed_str,
        Parrot_default_set_number_native,
        Parrot_default_set_number_same,
        Parrot_default_set_pmc,
        Parrot_default_set_pmc_keyed,
        Parrot_default_set_pmc_keyed_int,
        Parrot_default_set_pmc_keyed_str,
        Parrot_default_set_pointer,
        Parrot_default_set_pointer_keyed,
        Parrot_default_set_pointer_keyed_int,
        Parrot_default_set_pointer_keyed_str,
        Parrot_default_set_string_keyed,
        Parrot_default_set_string_keyed_int,
        Parrot_default_set_string_keyed_str,
        Parrot_default_set_string_native,
        Parrot_default_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_default_shift_float,
        Parrot_default_shift_integer,
        Parrot_default_shift_pmc,
        Parrot_default_shift_string,
        Parrot_default_slice,
        Parrot_default_splice,
        Parrot_default_subclass,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtype,
        Parrot_default_thaw,
        Parrot_default_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_type_keyed_int,
        Parrot_default_type_keyed_str,
        Parrot_default_unshift_float,
        Parrot_default_unshift_integer,
        Parrot_default_unshift_pmc,
        Parrot_default_unshift_string,
        Parrot_default_visit
    };

    const VTABLE temp_ro_vtable = {
        NULL, /* namespace */
        enum_class_ParrotIO, /* base_type */
        NULL, /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_IS_READONLY_FLAG, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        NULL,   /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_ParrotIO_ro_add_attribute,
        Parrot_ParrotIO_ro_add_method,
        Parrot_ParrotIO_ro_add_parent,
        Parrot_ParrotIO_ro_add_role,
        Parrot_ParrotIO_ro_assign_pmc,
        Parrot_ParrotIO_ro_assign_string_native,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_can,
        Parrot_default_class_type,
        Parrot_ParrotIO_clone,
        Parrot_default_clone_pmc,
        Parrot_ParrotIO_ro_decrement,
        Parrot_default_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_ParrotIO_ro_delete_keyed,
        Parrot_ParrotIO_ro_delete_keyed_int,
        Parrot_ParrotIO_ro_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_ParrotIO_destroy,
        Parrot_default_does,
        Parrot_default_elements,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_ParrotIO_ro_find_method,
        Parrot_default_freeze,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_ParrotIO_get_bool,
        Parrot_default_get_class,
        Parrot_default_get_integer,
        Parrot_default_get_integer_keyed,
        Parrot_default_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_iter,
        Parrot_default_get_number,
        Parrot_default_get_number_keyed,
        Parrot_default_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_default_get_pmc_keyed,
        Parrot_default_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_default_get_repr,
        Parrot_default_get_string,
        Parrot_default_get_string_keyed,
        Parrot_ParrotIO_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_default_hash,
        Parrot_ParrotIO_ro_i_absolute,
        Parrot_ParrotIO_ro_i_bitwise_not,
        Parrot_ParrotIO_ro_i_bitwise_nots,
        Parrot_ParrotIO_ro_i_logical_not,
        Parrot_ParrotIO_ro_i_neg,
        Parrot_ParrotIO_ro_increment,
        Parrot_ParrotIO_init,
        Parrot_default_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_default_instantiate,
        Parrot_default_invoke,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_logical_not,
        Parrot_default_mark,
        Parrot_ParrotIO_ro_morph,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_new_from_string,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_pmc_namespace,
        Parrot_ParrotIO_ro_pop_float,
        Parrot_ParrotIO_ro_pop_integer,
        Parrot_ParrotIO_ro_pop_pmc,
        Parrot_ParrotIO_ro_pop_string,
        Parrot_ParrotIO_ro_push_float,
        Parrot_ParrotIO_ro_push_integer,
        Parrot_ParrotIO_ro_push_pmc,
        Parrot_ParrotIO_ro_push_string,
        Parrot_ParrotIO_ro_remove_attribute,
        Parrot_ParrotIO_ro_remove_method,
        Parrot_ParrotIO_ro_remove_parent,
        Parrot_ParrotIO_ro_remove_role,
        Parrot_ParrotIO_ro_set_attr,
        Parrot_ParrotIO_ro_set_attr_str,
        Parrot_ParrotIO_ro_set_bignum_int,
        Parrot_ParrotIO_ro_set_bignum_num,
        Parrot_ParrotIO_ro_set_bignum_str,
        Parrot_ParrotIO_ro_set_bool,
        Parrot_ParrotIO_ro_set_integer_keyed,
        Parrot_ParrotIO_ro_set_integer_keyed_int,
        Parrot_ParrotIO_ro_set_integer_keyed_str,
        Parrot_ParrotIO_ro_set_integer_native,
        Parrot_ParrotIO_ro_set_integer_same,
        Parrot_ParrotIO_ro_set_number_keyed,
        Parrot_ParrotIO_ro_set_number_keyed_int,
        Parrot_ParrotIO_ro_set_number_keyed_str,
        Parrot_ParrotIO_ro_set_number_native,
        Parrot_ParrotIO_ro_set_number_same,
        Parrot_ParrotIO_ro_set_pmc,
        Parrot_ParrotIO_ro_set_pmc_keyed,
        Parrot_ParrotIO_ro_set_pmc_keyed_int,
        Parrot_ParrotIO_ro_set_pmc_keyed_str,
        Parrot_ParrotIO_ro_set_pointer,
        Parrot_ParrotIO_ro_set_pointer_keyed,
        Parrot_ParrotIO_ro_set_pointer_keyed_int,
        Parrot_ParrotIO_ro_set_pointer_keyed_str,
        Parrot_ParrotIO_ro_set_string_keyed,
        Parrot_ParrotIO_ro_set_string_keyed_int,
        Parrot_ParrotIO_ro_set_string_keyed_str,
        Parrot_ParrotIO_ro_set_string_native,
        Parrot_ParrotIO_ro_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_ParrotIO_ro_shift_float,
        Parrot_ParrotIO_ro_shift_integer,
        Parrot_ParrotIO_ro_shift_pmc,
        Parrot_ParrotIO_ro_shift_string,
        Parrot_default_slice,
        Parrot_ParrotIO_ro_splice,
        Parrot_default_subclass,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtype,
        Parrot_ParrotIO_ro_thaw,
        Parrot_ParrotIO_ro_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_type_keyed_int,
        Parrot_default_type_keyed_str,
        Parrot_ParrotIO_ro_unshift_float,
        Parrot_ParrotIO_ro_unshift_integer,
        Parrot_ParrotIO_ro_unshift_pmc,
        Parrot_ParrotIO_ro_unshift_string,
        Parrot_default_visit
    };
    if (pass == 0) {
        /*
         * create vtable - clone it - we have to set a few items
         */
        VTABLE *vt_clone =
            Parrot_clone_vtable(interp, &temp_base_vtable);
        VTABLE *vt_ro_clone =
            Parrot_clone_vtable(interp, &temp_ro_vtable);
        vt_clone->whoami = CONST_STRING(interp, "ParrotIO");
        vt_clone->isa_str = CONST_STRING(interp, "ParrotIO");
        vt_clone->does_str = CONST_STRING(interp, "scalar");
        vt_ro_clone->base_type = entry;
        vt_ro_clone->whoami = vt_clone->whoami;
        vt_ro_clone->isa_str = vt_clone->isa_str;
        vt_ro_clone->does_str = vt_clone->does_str;
        vt_clone->ro_variant_vtable = vt_ro_clone;
        vt_ro_clone->ro_variant_vtable = vt_clone;
        interp->vtables[entry] = vt_clone;
    }
    else { /* pass */
        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        /* create PMC Proxy object */
        Parrot_create_pmc_proxy(interp, entry);
        register_nci_method(interp, entry,
                F2DPTR(Parrot_ParrotIO_nci_say),
                "say", "IJOS");
        register_nci_method(interp, entry,
                F2DPTR(Parrot_ParrotIO_nci_open),
                "open", "PJOSSS");
        register_nci_method(interp, entry,
                F2DPTR(Parrot_ParrotIO_nci_set_readline_interactive),
                "set_readline_interactive", "IJOI");
        register_nci_method(interp, entry,
                F2DPTR(Parrot_ParrotIO_nci_readline),
                "readline", "PJOS");
        register_nci_method(interp, entry,
                F2DPTR(Parrot_ParrotIO_nci_slurp),
                "slurp", "SJOS");
        /* class_init */
    {

        if (pass) {
            register_nci_method(interp, enum_class_ParrotIO,
                    F2DPTR(PIO_flush), "flush", "vJO");
            register_nci_method(interp, enum_class_ParrotIO,
                    F2DPTR(PIO_setbuf), "setbuf", "iJOi");
            register_nci_method(interp, enum_class_ParrotIO,
                    F2DPTR(PIO_setlinebuf), "setlinebuf", "iJO");
            register_nci_method(interp, enum_class_ParrotIO,
                    F2DPTR(PIO_puts), "puts", "iJOt");
            register_nci_method(interp, enum_class_ParrotIO,
                    F2DPTR(PIO_eof), "eof", "iJO");
        }
    }
        {
        }
    } /* pass */
} /* Parrot_ParrotIO_class_init */


/*

=back

=head1 HISTORY

Initial version by leo 2003/06/23.

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
