/*
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/pmcproxy.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

#line 1 "./src/pmc/pmcproxy.pmc"
/*
Copyright (C) 2001-2007, The Perl Foundation.
$Id: pmcproxy.pmc 18906 2007-06-10 07:32:39Z chromatic $

=head1 NAME

src/pmc/pmcproxy.pmc - proxy class object for a PMC enabling introspection

=head1 DESCRIPTION

This class is used to describe a PMC. It can sit in an inheritance hierarchy
of a PDD15 class as well as allowing introspection of the PMC.

PMCProxy is not derived from any other PMC.

=head2 Structure

This class stores its state in the Parrot_PMCProxy structure, which has the
following fields.

=over 4

=item C<id>

The type number of the PMC that is being described.

=item C<name>

The name of the PMC -- a STRING.

=item C<namespace>

The namespace the PMC is associated with, if any.

=item C<parents>

An array of immediate parent classes.
An empty ResizablePMCArray PMC is allocated during initialization.

=item C<all_parents>

A cached array of ourself and all parent classes, in MRO order.
A ResizablePMCArray PMC is allocated during initialization,
and is populated with the current class.

=back

NOTE: No doubt we will need other things later; this is a start.

*/

#include "parrot/parrot.h"

/*

=head2 Functions

=over 4

=cut

*/

#line 76 "src/pmc/pmcproxy.c"
#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_fixedintegerarray.h"
#include "pmc_pmcproxy.h"
#include "pmc_default.h"
#include "pmcproxy.str"

void
Parrot_PMCProxy_destroy(Interp *interp, PMC* pmc)
#line 111 "./src/pmc/pmcproxy.pmc"
{
        mem_sys_free(PMC_data(pmc));

}
#line 92 "src/pmc/pmcproxy.c"
void
Parrot_PMCProxy_init(Interp *interp, PMC* pmc)
#line 76 "./src/pmc/pmcproxy.pmc"
{
    Parrot_PMCProxy *_pmc = NULL;

    /* Set flags for custom DOD mark and destroy. */
    PObj_custom_mark_SET(pmc);
    PObj_active_destroy_SET(pmc);

    /* We are a class. */
    PObj_is_class_SET(pmc);

    /* Set up the object. */
    _pmc = mem_allocate_zeroed_typed(Parrot_PMCProxy);
    _pmc->id              = 0;
    _pmc->name            = CONST_STRING(interp, "");
    _pmc->_namespace      = PMCNULL;
    _pmc->parents         = pmc_new(interp, enum_class_ResizablePMCArray);
    _pmc->all_parents     = pmc_new(interp, enum_class_ResizablePMCArray);
    _pmc->methods         = pmc_new(interp, enum_class_Hash);

    /* We put ourself on the all parents list. */
    VTABLE_push_pmc(interp, _pmc->all_parents, pmc);

    PMC_data(pmc)         = _pmc;

}
#line 121 "src/pmc/pmcproxy.c"
PMC*
Parrot_PMCProxy_inspect(Interp *interp, PMC* pmc)
#line 210 "./src/pmc/pmcproxy.pmc"
{
    /* Create a hash, then use inspect_str to get all of the data to
     * fill it up with. */
    PMC *metadata = pmc_new(interp, enum_class_Hash);
    VTABLE_set_pmc_keyed_str(interp, metadata, CONST_STRING(interp, "name"),
        VTABLE_inspect_str(interp, pmc, CONST_STRING(interp, "name")));
    VTABLE_set_pmc_keyed_str(interp, metadata, CONST_STRING(interp, "namespace"),
        VTABLE_inspect_str(interp, pmc, CONST_STRING(interp, "namespace")));
    VTABLE_set_pmc_keyed_str(interp, metadata, CONST_STRING(interp, "methods"),
        VTABLE_inspect_str(interp, pmc, CONST_STRING(interp, "methods")));
    VTABLE_set_pmc_keyed_str(interp, metadata, CONST_STRING(interp, "parents"),
        VTABLE_inspect_str(interp, pmc, CONST_STRING(interp, "parents")));
    return metadata;

}
#line 140 "src/pmc/pmcproxy.c"
PMC*
Parrot_PMCProxy_inspect_str(Interp *interp, PMC* pmc, STRING *what)
#line 170 "./src/pmc/pmcproxy.pmc"
{
    Parrot_PMCProxy *_pmc = PARROT_PMCPROXY(pmc);

    /* What should we return? */
    PMC          *found  = PMCNULL;

    if (string_equal(interp, what, CONST_STRING(interp, "name")) == 0) {
        found = pmc_new(interp, enum_class_String);
        VTABLE_set_string_native(interp, found, _pmc->name);
    }
    else if (string_equal(interp, what, CONST_STRING(interp, "namespace")) == 0) {
        /* Should not clone this. */
        return _pmc->_namespace;
    }
    else if (string_equal(interp, what, CONST_STRING(interp, "methods")) == 0) {
        found = _pmc->methods;
    }
    else if (string_equal(interp, what, CONST_STRING(interp, "parents")) == 0) {
        found = _pmc->parents;
    }
    else {
        real_exception(interp, NULL, INVALID_OPERATION,
            "Unknown introspection value '%S'", what);
    }

    /* Clone and return. */
    return PMC_IS_NULL(found) ? PMCNULL : VTABLE_clone(interp, found);

}
#line 173 "src/pmc/pmcproxy.c"
void
Parrot_PMCProxy_mark(Interp *interp, PMC* pmc)
#line 125 "./src/pmc/pmcproxy.pmc"
{
    Parrot_PMCProxy * const _pmc = PARROT_PMCPROXY(pmc);
    if (_pmc->name)
        pobject_lives(interp, (PObj*)_pmc->name);
    if (_pmc->_namespace)
        pobject_lives(interp, (PObj*)_pmc->_namespace);
    if (_pmc->parents)
        pobject_lives(interp, (PObj*)_pmc->parents);
    if (_pmc->all_parents)
        pobject_lives(interp, (PObj*)_pmc->all_parents);
    if (_pmc->methods)
        pobject_lives(interp, (PObj*)_pmc->methods);

}
#line 191 "src/pmc/pmcproxy.c"
void
Parrot_PMCProxy_nci_name(Interp *interp, PMC* pmc)
{
#line 368 "/home/mandrake/rpm/BUILD/parrot-0.4.13/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    INTVAL   n_regs_used[]   = { 0, 0, 1, 1 };
    opcode_t param_indexes[] = { 0 };
    opcode_t *return_indexes;
    opcode_t *current_args;
    PMC* _type      = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC* param_sig  = Parrot_FixedIntegerArray_new_from_string(interp, _type,
        string_from_const_cstring(interp, "(2)", 0), 0);

    PMC* return_sig              = PMCNULL;

    parrot_context_t *caller_ctx = CONTEXT(interp->ctx);
    PMC* ret_cont                = new_ret_continuation_pmc(interp, NULL);
    parrot_context_t *ctx        = Parrot_push_context(interp, n_regs_used);
    PMC* ccont                   = caller_ctx->current_cont;

    ctx->current_cont            = ret_cont;
    PMC_cont(ret_cont)->from_ctx = ctx;

    current_args                 = interp->current_args;
    interp->current_args         = NULL;

    interp->params_signature     = param_sig;
    parrot_pass_args(interp, caller_ctx, ctx, current_args, param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(ccont) &= ~SUB_FLAG_TAILCALL;
        --ctx->recursion_depth;
        ctx->caller_ctx      = caller_ctx->caller_ctx;
        Parrot_free_context(interp, caller_ctx, 0);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
    PMC* pmc = CTX_REG_PMC(ctx, 0);

    /* BEGIN PMETHOD BODY */
#line 234 "./src/pmc/pmcproxy.pmc"

    Parrot_PMCProxy *_pmc = PARROT_PMCPROXY(pmc);
    STRING *ret_name = _pmc->name;
    {
#line 237 "/home/mandrake/rpm/BUILD/parrot-0.4.13/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
/*BEGIN PCCRETURN STRING *ret_name */
/*BEGIN GENERATED ACCESSORS */
CTX_REG_STR(ctx, 0) = ret_name;

#line 243 "/home/mandrake/rpm/BUILD/parrot-0.4.13/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
/*END GENERATED ACCESSORS */
{
    opcode_t temp_return_indexes[] = { 0 };
    return_indexes = temp_return_indexes;
}
return_sig = Parrot_FixedIntegerArray_new_from_string(interp, _type,
    string_from_const_cstring(interp, "(1)", 0), 0);
goto name_returns;
/*END PCCRETURN STRING *ret_name */
}

#line 413 "/home/mandrake/rpm/BUILD/parrot-0.4.13/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    goto no_return;
    /* END PMETHOD BODY */

name_returns:

    /* if (PMC_cont(ccont)->address) { */
    {
        /* parrot_context_t * const caller_ctx = PMC_cont(ccont)->to_ctx; */
        if (! caller_ctx) {
            /* there is no point calling real_exception here, because
               PDB_backtrace can't deal with a missing to_ctx either. */
            internal_exception(1, "No caller_ctx for continuation %p.", ccont);
        }

        interp->returns_signature = return_sig;
        parrot_pass_args(interp, ctx, caller_ctx, return_indexes,
            caller_ctx->current_results, PARROT_PASS_RESULTS);
    }

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_type);
    PObj_live_CLEAR(param_sig);
    PObj_live_CLEAR(return_sig);
    Parrot_pop_context(interp);

}
#line 288 "src/pmc/pmcproxy.c"
void
Parrot_PMCProxy_nci_pmc_namespace(Interp *interp, PMC* pmc)
{
#line 368 "/home/mandrake/rpm/BUILD/parrot-0.4.13/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    INTVAL   n_regs_used[]   = { 0, 0, 0, 1 };
    opcode_t param_indexes[] = { 0 };
    opcode_t *return_indexes;
    opcode_t *current_args;
    PMC* _type      = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC* param_sig  = Parrot_FixedIntegerArray_new_from_string(interp, _type,
        string_from_const_cstring(interp, "(2)", 0), 0);

    PMC* return_sig              = PMCNULL;

    parrot_context_t *caller_ctx = CONTEXT(interp->ctx);
    PMC* ret_cont                = new_ret_continuation_pmc(interp, NULL);
    parrot_context_t *ctx        = Parrot_push_context(interp, n_regs_used);
    PMC* ccont                   = caller_ctx->current_cont;

    ctx->current_cont            = ret_cont;
    PMC_cont(ret_cont)->from_ctx = ctx;

    current_args                 = interp->current_args;
    interp->current_args         = NULL;

    interp->params_signature     = param_sig;
    parrot_pass_args(interp, caller_ctx, ctx, current_args, param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(ccont) &= ~SUB_FLAG_TAILCALL;
        --ctx->recursion_depth;
        ctx->caller_ctx      = caller_ctx->caller_ctx;
        Parrot_free_context(interp, caller_ctx, 0);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
    PMC* pmc = CTX_REG_PMC(ctx, 0);

    /* BEGIN PMETHOD BODY */
#line 249 "./src/pmc/pmcproxy.pmc"

    Parrot_PMCProxy *_pmc = PARROT_PMCPROXY(pmc);
    PMC *ret_namespace = _pmc->_namespace;
    {
#line 237 "/home/mandrake/rpm/BUILD/parrot-0.4.13/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
/*BEGIN PCCRETURN PMC *ret_namespace */
/*BEGIN GENERATED ACCESSORS */
CTX_REG_PMC(ctx, 0) = ret_namespace;

#line 243 "/home/mandrake/rpm/BUILD/parrot-0.4.13/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
/*END GENERATED ACCESSORS */
{
    opcode_t temp_return_indexes[] = { 0 };
    return_indexes = temp_return_indexes;
}
return_sig = Parrot_FixedIntegerArray_new_from_string(interp, _type,
    string_from_const_cstring(interp, "(2)", 0), 0);
goto pmc_namespace_returns;
/*END PCCRETURN PMC *ret_namespace */
}

#line 413 "/home/mandrake/rpm/BUILD/parrot-0.4.13/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    goto no_return;
    /* END PMETHOD BODY */

pmc_namespace_returns:

    /* if (PMC_cont(ccont)->address) { */
    {
        /* parrot_context_t * const caller_ctx = PMC_cont(ccont)->to_ctx; */
        if (! caller_ctx) {
            /* there is no point calling real_exception here, because
               PDB_backtrace can't deal with a missing to_ctx either. */
            internal_exception(1, "No caller_ctx for continuation %p.", ccont);
        }

        interp->returns_signature = return_sig;
        parrot_pass_args(interp, ctx, caller_ctx, return_indexes,
            caller_ctx->current_results, PARROT_PASS_RESULTS);
    }

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_type);
    PObj_live_CLEAR(param_sig);
    PObj_live_CLEAR(return_sig);
    Parrot_pop_context(interp);

}
#line 381 "src/pmc/pmcproxy.c"
void
Parrot_PMCProxy_nci_new(Interp *interp, PMC* pmc)
{
#line 368 "/home/mandrake/rpm/BUILD/parrot-0.4.13/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    INTVAL   n_regs_used[]   = { 1, 0, 0, 2 };
    opcode_t param_indexes[] = { 0, 1, 0 };
    opcode_t *return_indexes;
    opcode_t *current_args;
    PMC* _type      = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC* param_sig  = Parrot_FixedIntegerArray_new_from_string(interp, _type,
        string_from_const_cstring(interp, "(2, 130, 256)", 0), 0);

    PMC* return_sig              = PMCNULL;

    parrot_context_t *caller_ctx = CONTEXT(interp->ctx);
    PMC* ret_cont                = new_ret_continuation_pmc(interp, NULL);
    parrot_context_t *ctx        = Parrot_push_context(interp, n_regs_used);
    PMC* ccont                   = caller_ctx->current_cont;

    ctx->current_cont            = ret_cont;
    PMC_cont(ret_cont)->from_ctx = ctx;

    current_args                 = interp->current_args;
    interp->current_args         = NULL;

    interp->params_signature     = param_sig;
    parrot_pass_args(interp, caller_ctx, ctx, current_args, param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(ccont) &= ~SUB_FLAG_TAILCALL;
        --ctx->recursion_depth;
        ctx->caller_ctx      = caller_ctx->caller_ctx;
        Parrot_free_context(interp, caller_ctx, 0);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
    PMC* pmc = CTX_REG_PMC(ctx, 0);
    PMC* args = CTX_REG_PMC(ctx, 1);
    INTVAL got_args = CTX_REG_INT(ctx, 0);

    /* BEGIN PMETHOD BODY */
#line 264 "./src/pmc/pmcproxy.pmc"

    Parrot_PMCProxy *_pmc = PARROT_PMCPROXY(pmc);
    PMC *created;
    if (got_args)
        created = pmc_new_init(interp, _pmc->id, args);
    else
        created = pmc_new(interp, _pmc->id);
    {
#line 237 "/home/mandrake/rpm/BUILD/parrot-0.4.13/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
/*BEGIN PCCRETURN PMC *created */
/*BEGIN GENERATED ACCESSORS */
CTX_REG_PMC(ctx, 0) = created;

#line 243 "/home/mandrake/rpm/BUILD/parrot-0.4.13/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
/*END GENERATED ACCESSORS */
{
    opcode_t temp_return_indexes[] = { 0 };
    return_indexes = temp_return_indexes;
}
return_sig = Parrot_FixedIntegerArray_new_from_string(interp, _type,
    string_from_const_cstring(interp, "(2)", 0), 0);
goto new_returns;
/*END PCCRETURN PMC *created */
}

#line 413 "/home/mandrake/rpm/BUILD/parrot-0.4.13/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    goto no_return;
    /* END PMETHOD BODY */

new_returns:

    /* if (PMC_cont(ccont)->address) { */
    {
        /* parrot_context_t * const caller_ctx = PMC_cont(ccont)->to_ctx; */
        if (! caller_ctx) {
            /* there is no point calling real_exception here, because
               PDB_backtrace can't deal with a missing to_ctx either. */
            internal_exception(1, "No caller_ctx for continuation %p.", ccont);
        }

        interp->returns_signature = return_sig;
        parrot_pass_args(interp, ctx, caller_ctx, return_indexes,
            caller_ctx->current_results, PARROT_PASS_RESULTS);
    }

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_type);
    PObj_live_CLEAR(param_sig);
    PObj_live_CLEAR(return_sig);
    Parrot_pop_context(interp);

}
#line 480 "src/pmc/pmcproxy.c"
void
Parrot_PMCProxy_nci_methods(Interp *interp, PMC* pmc)
{
#line 368 "/home/mandrake/rpm/BUILD/parrot-0.4.13/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    INTVAL   n_regs_used[]   = { 0, 0, 0, 1 };
    opcode_t param_indexes[] = { 0 };
    opcode_t *return_indexes;
    opcode_t *current_args;
    PMC* _type      = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC* param_sig  = Parrot_FixedIntegerArray_new_from_string(interp, _type,
        string_from_const_cstring(interp, "(2)", 0), 0);

    PMC* return_sig              = PMCNULL;

    parrot_context_t *caller_ctx = CONTEXT(interp->ctx);
    PMC* ret_cont                = new_ret_continuation_pmc(interp, NULL);
    parrot_context_t *ctx        = Parrot_push_context(interp, n_regs_used);
    PMC* ccont                   = caller_ctx->current_cont;

    ctx->current_cont            = ret_cont;
    PMC_cont(ret_cont)->from_ctx = ctx;

    current_args                 = interp->current_args;
    interp->current_args         = NULL;

    interp->params_signature     = param_sig;
    parrot_pass_args(interp, caller_ctx, ctx, current_args, param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(ccont) &= ~SUB_FLAG_TAILCALL;
        --ctx->recursion_depth;
        ctx->caller_ctx      = caller_ctx->caller_ctx;
        Parrot_free_context(interp, caller_ctx, 0);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
    PMC* pmc = CTX_REG_PMC(ctx, 0);

    /* BEGIN PMETHOD BODY */
#line 283 "./src/pmc/pmcproxy.pmc"

    PMC *ret_methods = VTABLE_inspect_str(interp, pmc, CONST_STRING(interp, "methods"));
    {
#line 237 "/home/mandrake/rpm/BUILD/parrot-0.4.13/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
/*BEGIN PCCRETURN PMC *ret_methods */
/*BEGIN GENERATED ACCESSORS */
CTX_REG_PMC(ctx, 0) = ret_methods;

#line 243 "/home/mandrake/rpm/BUILD/parrot-0.4.13/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
/*END GENERATED ACCESSORS */
{
    opcode_t temp_return_indexes[] = { 0 };
    return_indexes = temp_return_indexes;
}
return_sig = Parrot_FixedIntegerArray_new_from_string(interp, _type,
    string_from_const_cstring(interp, "(2)", 0), 0);
goto methods_returns;
/*END PCCRETURN PMC *ret_methods */
}

#line 413 "/home/mandrake/rpm/BUILD/parrot-0.4.13/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    goto no_return;
    /* END PMETHOD BODY */

methods_returns:

    /* if (PMC_cont(ccont)->address) { */
    {
        /* parrot_context_t * const caller_ctx = PMC_cont(ccont)->to_ctx; */
        if (! caller_ctx) {
            /* there is no point calling real_exception here, because
               PDB_backtrace can't deal with a missing to_ctx either. */
            internal_exception(1, "No caller_ctx for continuation %p.", ccont);
        }

        interp->returns_signature = return_sig;
        parrot_pass_args(interp, ctx, caller_ctx, return_indexes,
            caller_ctx->current_results, PARROT_PASS_RESULTS);
    }

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_type);
    PObj_live_CLEAR(param_sig);
    PObj_live_CLEAR(return_sig);
    Parrot_pop_context(interp);

}
#line 572 "src/pmc/pmcproxy.c"
void
Parrot_PMCProxy_nci_parents(Interp *interp, PMC* pmc)
{
#line 368 "/home/mandrake/rpm/BUILD/parrot-0.4.13/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    INTVAL   n_regs_used[]   = { 0, 0, 0, 1 };
    opcode_t param_indexes[] = { 0 };
    opcode_t *return_indexes;
    opcode_t *current_args;
    PMC* _type      = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC* param_sig  = Parrot_FixedIntegerArray_new_from_string(interp, _type,
        string_from_const_cstring(interp, "(2)", 0), 0);

    PMC* return_sig              = PMCNULL;

    parrot_context_t *caller_ctx = CONTEXT(interp->ctx);
    PMC* ret_cont                = new_ret_continuation_pmc(interp, NULL);
    parrot_context_t *ctx        = Parrot_push_context(interp, n_regs_used);
    PMC* ccont                   = caller_ctx->current_cont;

    ctx->current_cont            = ret_cont;
    PMC_cont(ret_cont)->from_ctx = ctx;

    current_args                 = interp->current_args;
    interp->current_args         = NULL;

    interp->params_signature     = param_sig;
    parrot_pass_args(interp, caller_ctx, ctx, current_args, param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(ccont) &= ~SUB_FLAG_TAILCALL;
        --ctx->recursion_depth;
        ctx->caller_ctx      = caller_ctx->caller_ctx;
        Parrot_free_context(interp, caller_ctx, 0);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
    PMC* pmc = CTX_REG_PMC(ctx, 0);

    /* BEGIN PMETHOD BODY */
#line 297 "./src/pmc/pmcproxy.pmc"

    PMC *ret_parents = VTABLE_inspect_str(interp, pmc, CONST_STRING(interp, "parents"));
    {
#line 237 "/home/mandrake/rpm/BUILD/parrot-0.4.13/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
/*BEGIN PCCRETURN PMC *ret_parents */
/*BEGIN GENERATED ACCESSORS */
CTX_REG_PMC(ctx, 0) = ret_parents;

#line 243 "/home/mandrake/rpm/BUILD/parrot-0.4.13/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
/*END GENERATED ACCESSORS */
{
    opcode_t temp_return_indexes[] = { 0 };
    return_indexes = temp_return_indexes;
}
return_sig = Parrot_FixedIntegerArray_new_from_string(interp, _type,
    string_from_const_cstring(interp, "(2)", 0), 0);
goto parents_returns;
/*END PCCRETURN PMC *ret_parents */
}

#line 413 "/home/mandrake/rpm/BUILD/parrot-0.4.13/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    goto no_return;
    /* END PMETHOD BODY */

parents_returns:

    /* if (PMC_cont(ccont)->address) { */
    {
        /* parrot_context_t * const caller_ctx = PMC_cont(ccont)->to_ctx; */
        if (! caller_ctx) {
            /* there is no point calling real_exception here, because
               PDB_backtrace can't deal with a missing to_ctx either. */
            internal_exception(1, "No caller_ctx for continuation %p.", ccont);
        }

        interp->returns_signature = return_sig;
        parrot_pass_args(interp, ctx, caller_ctx, return_indexes,
            caller_ctx->current_results, PARROT_PASS_RESULTS);
    }

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_type);
    PObj_live_CLEAR(param_sig);
    PObj_live_CLEAR(return_sig);
    Parrot_pop_context(interp);

}
#line 664 "src/pmc/pmcproxy.c"
void
Parrot_PMCProxy_nci_inspect(Interp *interp, PMC* pmc)
{
#line 368 "/home/mandrake/rpm/BUILD/parrot-0.4.13/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    INTVAL   n_regs_used[]   = { 1, 0, 1, 1 };
    opcode_t param_indexes[] = { 0, 0, 0 };
    opcode_t *return_indexes;
    opcode_t *current_args;
    PMC* _type      = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC* param_sig  = Parrot_FixedIntegerArray_new_from_string(interp, _type,
        string_from_const_cstring(interp, "(2, 129, 256)", 0), 0);

    PMC* return_sig              = PMCNULL;

    parrot_context_t *caller_ctx = CONTEXT(interp->ctx);
    PMC* ret_cont                = new_ret_continuation_pmc(interp, NULL);
    parrot_context_t *ctx        = Parrot_push_context(interp, n_regs_used);
    PMC* ccont                   = caller_ctx->current_cont;

    ctx->current_cont            = ret_cont;
    PMC_cont(ret_cont)->from_ctx = ctx;

    current_args                 = interp->current_args;
    interp->current_args         = NULL;

    interp->params_signature     = param_sig;
    parrot_pass_args(interp, caller_ctx, ctx, current_args, param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(ccont) &= ~SUB_FLAG_TAILCALL;
        --ctx->recursion_depth;
        ctx->caller_ctx      = caller_ctx->caller_ctx;
        Parrot_free_context(interp, caller_ctx, 0);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
    PMC* pmc = CTX_REG_PMC(ctx, 0);
    STRING* what = CTX_REG_STR(ctx, 0);
    INTVAL got_what = CTX_REG_INT(ctx, 0);

    /* BEGIN PMETHOD BODY */
#line 312 "./src/pmc/pmcproxy.pmc"

    PMC *found;

    /* Just delegate to the appropriate vtable method. */
    if (got_what)
        found = VTABLE_inspect_str(interp, pmc, what);
    else
        found = VTABLE_inspect(interp, pmc);

    {
#line 237 "/home/mandrake/rpm/BUILD/parrot-0.4.13/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
/*BEGIN PCCRETURN PMC *found */
/*BEGIN GENERATED ACCESSORS */
CTX_REG_PMC(ctx, 0) = found;

#line 243 "/home/mandrake/rpm/BUILD/parrot-0.4.13/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
/*END GENERATED ACCESSORS */
{
    opcode_t temp_return_indexes[] = { 0 };
    return_indexes = temp_return_indexes;
}
return_sig = Parrot_FixedIntegerArray_new_from_string(interp, _type,
    string_from_const_cstring(interp, "(2)", 0), 0);
goto inspect_returns;
/*END PCCRETURN PMC *found */
}

#line 413 "/home/mandrake/rpm/BUILD/parrot-0.4.13/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    goto no_return;
    /* END PMETHOD BODY */

inspect_returns:

    /* if (PMC_cont(ccont)->address) { */
    {
        /* parrot_context_t * const caller_ctx = PMC_cont(ccont)->to_ctx; */
        if (! caller_ctx) {
            /* there is no point calling real_exception here, because
               PDB_backtrace can't deal with a missing to_ctx either. */
            internal_exception(1, "No caller_ctx for continuation %p.", ccont);
        }

        interp->returns_signature = return_sig;
        parrot_pass_args(interp, ctx, caller_ctx, return_indexes,
            caller_ctx->current_results, PARROT_PASS_RESULTS);
    }

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_type);
    PObj_live_CLEAR(param_sig);
    PObj_live_CLEAR(return_sig);
    Parrot_pop_context(interp);

}
#line 765 "src/pmc/pmcproxy.c"
void
Parrot_PMCProxy_ro_add_attribute(Interp *interp, PMC* pmc, STRING* name, PMC* type)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "add_attribute() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_add_method(Interp *interp, PMC* pmc, STRING* method_name, PMC* sub_pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "add_method() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_add_parent(Interp *interp, PMC* pmc, PMC* parent)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "add_parent() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_add_role(Interp *interp, PMC* pmc, PMC* role)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "add_role() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_assign_pmc(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "assign_pmc() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_assign_string_native(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "assign_string_native() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_decrement(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "decrement() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_delete_keyed(Interp *interp, PMC* pmc, PMC* key)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "delete_keyed() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_delete_keyed_int(Interp *interp, PMC* pmc, INTVAL key)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "delete_keyed_int() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_delete_keyed_str(Interp *interp, PMC* pmc, STRING* key)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "delete_keyed_str() in read-only instance of PMCProxy");
}
PMC*
Parrot_PMCProxy_ro_find_method(Interp *interp, PMC* pmc, STRING* method_name)
 {
    PMC *const method = Parrot_default_find_method(interp, pmc, method_name);
    if (!PMC_IS_NULL(VTABLE_getprop(interp, method, const_string(interp, "write"))))
        return PMCNULL;
    else
        return method;
}
void
Parrot_PMCProxy_ro_i_absolute(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_absolute() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_i_bitwise_not(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_bitwise_not() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_i_bitwise_nots(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_bitwise_nots() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_i_logical_not(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_logical_not() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_i_neg(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_neg() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_increment(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "increment() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_morph(Interp *interp, PMC* pmc, INTVAL type)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "morph() in read-only instance of PMCProxy");
}
FLOATVAL
Parrot_PMCProxy_ro_pop_float(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "pop_float() in read-only instance of PMCProxy");
    return (FLOATVAL)0;
}
INTVAL
Parrot_PMCProxy_ro_pop_integer(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "pop_integer() in read-only instance of PMCProxy");
    return (INTVAL)0;
}
PMC*
Parrot_PMCProxy_ro_pop_pmc(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "pop_pmc() in read-only instance of PMCProxy");
    return PMCNULL;
}
STRING*
Parrot_PMCProxy_ro_pop_string(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "pop_string() in read-only instance of PMCProxy");
    return (STRING*)0;
}
void
Parrot_PMCProxy_ro_push_float(Interp *interp, PMC* pmc, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "push_float() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_push_integer(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "push_integer() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_push_pmc(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "push_pmc() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_push_string(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "push_string() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_remove_attribute(Interp *interp, PMC* pmc, STRING* name)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "remove_attribute() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_remove_method(Interp *interp, PMC* pmc, STRING* method_name)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "remove_method() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_remove_parent(Interp *interp, PMC* pmc, PMC* parent)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "remove_parent() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_remove_role(Interp *interp, PMC* pmc, PMC* role)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "remove_role() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_set_attr(Interp *interp, PMC* pmc, INTVAL idx, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_attr() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_set_attr_str(Interp *interp, PMC* pmc, STRING* idx, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_attr_str() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_set_bignum_int(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_bignum_int() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_set_bignum_num(Interp *interp, PMC* pmc, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_bignum_num() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_set_bignum_str(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_bignum_str() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_set_bool(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_bool() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_set_integer_keyed(Interp *interp, PMC* pmc, PMC* key, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_keyed() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_set_integer_keyed_int(Interp *interp, PMC* pmc, INTVAL key, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_keyed_int() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_set_integer_keyed_str(Interp *interp, PMC* pmc, STRING* key, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_keyed_str() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_set_integer_native(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_native() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_set_integer_same(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_same() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_set_number_keyed(Interp *interp, PMC* pmc, PMC* key, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_keyed() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_set_number_keyed_int(Interp *interp, PMC* pmc, INTVAL key, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_keyed_int() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_set_number_keyed_str(Interp *interp, PMC* pmc, STRING* key, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_keyed_str() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_set_number_native(Interp *interp, PMC* pmc, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_native() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_set_number_same(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_same() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_set_pmc(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pmc() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_set_pmc_keyed(Interp *interp, PMC* pmc, PMC* key, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pmc_keyed() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_set_pmc_keyed_int(Interp *interp, PMC* pmc, INTVAL key, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_int() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_set_pmc_keyed_str(Interp *interp, PMC* pmc, STRING* key, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_str() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_set_pointer(Interp *interp, PMC* pmc, void* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pointer() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_set_pointer_keyed(Interp *interp, PMC* pmc, PMC* key, void* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pointer_keyed() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_set_pointer_keyed_int(Interp *interp, PMC* pmc, INTVAL key, void* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_int() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_set_pointer_keyed_str(Interp *interp, PMC* pmc, STRING* key, void* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_str() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_set_string_keyed(Interp *interp, PMC* pmc, PMC* key, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_keyed() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_set_string_keyed_int(Interp *interp, PMC* pmc, INTVAL key, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_keyed_int() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_set_string_keyed_str(Interp *interp, PMC* pmc, STRING* key, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_keyed_str() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_set_string_native(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_native() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_set_string_same(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_same() in read-only instance of PMCProxy");
}
FLOATVAL
Parrot_PMCProxy_ro_shift_float(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "shift_float() in read-only instance of PMCProxy");
    return (FLOATVAL)0;
}
INTVAL
Parrot_PMCProxy_ro_shift_integer(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "shift_integer() in read-only instance of PMCProxy");
    return (INTVAL)0;
}
PMC*
Parrot_PMCProxy_ro_shift_pmc(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "shift_pmc() in read-only instance of PMCProxy");
    return PMCNULL;
}
STRING*
Parrot_PMCProxy_ro_shift_string(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "shift_string() in read-only instance of PMCProxy");
    return (STRING*)0;
}
void
Parrot_PMCProxy_ro_splice(Interp *interp, PMC* pmc, PMC* value, INTVAL offset, INTVAL count)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "splice() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_thaw(Interp *interp, PMC* pmc, visit_info* info)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "thaw() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_thawfinish(Interp *interp, PMC* pmc, visit_info* info)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "thawfinish() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_unshift_float(Interp *interp, PMC* pmc, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "unshift_float() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_unshift_integer(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "unshift_integer() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_unshift_pmc(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "unshift_pmc() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_unshift_string(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "unshift_string() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_class_init(Parrot_Interp interp, int entry, int pass)
{
    const VTABLE temp_base_vtable = {
        NULL, /* namespace */
        enum_class_PMCProxy, /* base_type */
        NULL, /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_HAS_READONLY_FLAG, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        NULL,   /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_default_add_attribute,
        Parrot_default_add_method,
        Parrot_default_add_parent,
        Parrot_default_add_role,
        Parrot_default_assign_pmc,
        Parrot_default_assign_string_native,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_can,
        Parrot_default_class_type,
        Parrot_default_clone,
        Parrot_default_clone_pmc,
        Parrot_default_decrement,
        Parrot_default_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_default_delete_keyed,
        Parrot_default_delete_keyed_int,
        Parrot_default_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_PMCProxy_destroy,
        Parrot_default_does,
        Parrot_default_elements,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_default_find_method,
        Parrot_default_freeze,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_default_get_bool,
        Parrot_default_get_class,
        Parrot_default_get_integer,
        Parrot_default_get_integer_keyed,
        Parrot_default_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_iter,
        Parrot_default_get_number,
        Parrot_default_get_number_keyed,
        Parrot_default_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_default_get_pmc_keyed,
        Parrot_default_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_default_get_repr,
        Parrot_default_get_string,
        Parrot_default_get_string_keyed,
        Parrot_default_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_default_hash,
        Parrot_default_i_absolute,
        Parrot_default_i_bitwise_not,
        Parrot_default_i_bitwise_nots,
        Parrot_default_i_logical_not,
        Parrot_default_i_neg,
        Parrot_default_increment,
        Parrot_PMCProxy_init,
        Parrot_default_init_pmc,
        Parrot_PMCProxy_inspect,
        Parrot_PMCProxy_inspect_str,
        Parrot_default_instantiate,
        Parrot_default_invoke,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_logical_not,
        Parrot_PMCProxy_mark,
        Parrot_default_morph,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_new_from_string,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_pmc_namespace,
        Parrot_default_pop_float,
        Parrot_default_pop_integer,
        Parrot_default_pop_pmc,
        Parrot_default_pop_string,
        Parrot_default_push_float,
        Parrot_default_push_integer,
        Parrot_default_push_pmc,
        Parrot_default_push_string,
        Parrot_default_remove_attribute,
        Parrot_default_remove_method,
        Parrot_default_remove_parent,
        Parrot_default_remove_role,
        Parrot_default_set_attr,
        Parrot_default_set_attr_str,
        Parrot_default_set_bignum_int,
        Parrot_default_set_bignum_num,
        Parrot_default_set_bignum_str,
        Parrot_default_set_bool,
        Parrot_default_set_integer_keyed,
        Parrot_default_set_integer_keyed_int,
        Parrot_default_set_integer_keyed_str,
        Parrot_default_set_integer_native,
        Parrot_default_set_integer_same,
        Parrot_default_set_number_keyed,
        Parrot_default_set_number_keyed_int,
        Parrot_default_set_number_keyed_str,
        Parrot_default_set_number_native,
        Parrot_default_set_number_same,
        Parrot_default_set_pmc,
        Parrot_default_set_pmc_keyed,
        Parrot_default_set_pmc_keyed_int,
        Parrot_default_set_pmc_keyed_str,
        Parrot_default_set_pointer,
        Parrot_default_set_pointer_keyed,
        Parrot_default_set_pointer_keyed_int,
        Parrot_default_set_pointer_keyed_str,
        Parrot_default_set_string_keyed,
        Parrot_default_set_string_keyed_int,
        Parrot_default_set_string_keyed_str,
        Parrot_default_set_string_native,
        Parrot_default_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_default_shift_float,
        Parrot_default_shift_integer,
        Parrot_default_shift_pmc,
        Parrot_default_shift_string,
        Parrot_default_slice,
        Parrot_default_splice,
        Parrot_default_subclass,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtype,
        Parrot_default_thaw,
        Parrot_default_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_type_keyed_int,
        Parrot_default_type_keyed_str,
        Parrot_default_unshift_float,
        Parrot_default_unshift_integer,
        Parrot_default_unshift_pmc,
        Parrot_default_unshift_string,
        Parrot_default_visit
    };

    const VTABLE temp_ro_vtable = {
        NULL, /* namespace */
        enum_class_PMCProxy, /* base_type */
        NULL, /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_IS_READONLY_FLAG, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        NULL,   /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_PMCProxy_ro_add_attribute,
        Parrot_PMCProxy_ro_add_method,
        Parrot_PMCProxy_ro_add_parent,
        Parrot_PMCProxy_ro_add_role,
        Parrot_PMCProxy_ro_assign_pmc,
        Parrot_PMCProxy_ro_assign_string_native,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_can,
        Parrot_default_class_type,
        Parrot_default_clone,
        Parrot_default_clone_pmc,
        Parrot_PMCProxy_ro_decrement,
        Parrot_default_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_PMCProxy_ro_delete_keyed,
        Parrot_PMCProxy_ro_delete_keyed_int,
        Parrot_PMCProxy_ro_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_PMCProxy_destroy,
        Parrot_default_does,
        Parrot_default_elements,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_PMCProxy_ro_find_method,
        Parrot_default_freeze,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_default_get_bool,
        Parrot_default_get_class,
        Parrot_default_get_integer,
        Parrot_default_get_integer_keyed,
        Parrot_default_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_iter,
        Parrot_default_get_number,
        Parrot_default_get_number_keyed,
        Parrot_default_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_default_get_pmc_keyed,
        Parrot_default_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_default_get_repr,
        Parrot_default_get_string,
        Parrot_default_get_string_keyed,
        Parrot_default_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_default_hash,
        Parrot_PMCProxy_ro_i_absolute,
        Parrot_PMCProxy_ro_i_bitwise_not,
        Parrot_PMCProxy_ro_i_bitwise_nots,
        Parrot_PMCProxy_ro_i_logical_not,
        Parrot_PMCProxy_ro_i_neg,
        Parrot_PMCProxy_ro_increment,
        Parrot_PMCProxy_init,
        Parrot_default_init_pmc,
        Parrot_PMCProxy_inspect,
        Parrot_PMCProxy_inspect_str,
        Parrot_default_instantiate,
        Parrot_default_invoke,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_logical_not,
        Parrot_PMCProxy_mark,
        Parrot_PMCProxy_ro_morph,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_new_from_string,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_pmc_namespace,
        Parrot_PMCProxy_ro_pop_float,
        Parrot_PMCProxy_ro_pop_integer,
        Parrot_PMCProxy_ro_pop_pmc,
        Parrot_PMCProxy_ro_pop_string,
        Parrot_PMCProxy_ro_push_float,
        Parrot_PMCProxy_ro_push_integer,
        Parrot_PMCProxy_ro_push_pmc,
        Parrot_PMCProxy_ro_push_string,
        Parrot_PMCProxy_ro_remove_attribute,
        Parrot_PMCProxy_ro_remove_method,
        Parrot_PMCProxy_ro_remove_parent,
        Parrot_PMCProxy_ro_remove_role,
        Parrot_PMCProxy_ro_set_attr,
        Parrot_PMCProxy_ro_set_attr_str,
        Parrot_PMCProxy_ro_set_bignum_int,
        Parrot_PMCProxy_ro_set_bignum_num,
        Parrot_PMCProxy_ro_set_bignum_str,
        Parrot_PMCProxy_ro_set_bool,
        Parrot_PMCProxy_ro_set_integer_keyed,
        Parrot_PMCProxy_ro_set_integer_keyed_int,
        Parrot_PMCProxy_ro_set_integer_keyed_str,
        Parrot_PMCProxy_ro_set_integer_native,
        Parrot_PMCProxy_ro_set_integer_same,
        Parrot_PMCProxy_ro_set_number_keyed,
        Parrot_PMCProxy_ro_set_number_keyed_int,
        Parrot_PMCProxy_ro_set_number_keyed_str,
        Parrot_PMCProxy_ro_set_number_native,
        Parrot_PMCProxy_ro_set_number_same,
        Parrot_PMCProxy_ro_set_pmc,
        Parrot_PMCProxy_ro_set_pmc_keyed,
        Parrot_PMCProxy_ro_set_pmc_keyed_int,
        Parrot_PMCProxy_ro_set_pmc_keyed_str,
        Parrot_PMCProxy_ro_set_pointer,
        Parrot_PMCProxy_ro_set_pointer_keyed,
        Parrot_PMCProxy_ro_set_pointer_keyed_int,
        Parrot_PMCProxy_ro_set_pointer_keyed_str,
        Parrot_PMCProxy_ro_set_string_keyed,
        Parrot_PMCProxy_ro_set_string_keyed_int,
        Parrot_PMCProxy_ro_set_string_keyed_str,
        Parrot_PMCProxy_ro_set_string_native,
        Parrot_PMCProxy_ro_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_PMCProxy_ro_shift_float,
        Parrot_PMCProxy_ro_shift_integer,
        Parrot_PMCProxy_ro_shift_pmc,
        Parrot_PMCProxy_ro_shift_string,
        Parrot_default_slice,
        Parrot_PMCProxy_ro_splice,
        Parrot_default_subclass,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtype,
        Parrot_PMCProxy_ro_thaw,
        Parrot_PMCProxy_ro_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_type_keyed_int,
        Parrot_default_type_keyed_str,
        Parrot_PMCProxy_ro_unshift_float,
        Parrot_PMCProxy_ro_unshift_integer,
        Parrot_PMCProxy_ro_unshift_pmc,
        Parrot_PMCProxy_ro_unshift_string,
        Parrot_default_visit
    };
    if (pass == 0) {
        /*
         * create vtable - clone it - we have to set a few items
         */
        VTABLE *vt_clone =
            Parrot_clone_vtable(interp, &temp_base_vtable);
        VTABLE *vt_ro_clone =
            Parrot_clone_vtable(interp, &temp_ro_vtable);
        vt_clone->whoami = CONST_STRING(interp, "PMCProxy");
        vt_clone->isa_str = CONST_STRING(interp, "PMCProxy");
        vt_clone->does_str = CONST_STRING(interp, "scalar");
        vt_ro_clone->base_type = entry;
        vt_ro_clone->whoami = vt_clone->whoami;
        vt_ro_clone->isa_str = vt_clone->isa_str;
        vt_ro_clone->does_str = vt_clone->does_str;
        vt_clone->ro_variant_vtable = vt_ro_clone;
        vt_ro_clone->ro_variant_vtable = vt_clone;
        interp->vtables[entry] = vt_clone;
    }
    else { /* pass */
        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        /* create PMC Proxy object */
        Parrot_create_pmc_proxy(interp, entry);
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_PMCProxy_nci_name), "name");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_PMCProxy_nci_pmc_namespace), "pmc_namespace");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_PMCProxy_nci_new), "new");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_PMCProxy_nci_methods), "methods");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_PMCProxy_nci_parents), "parents");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_PMCProxy_nci_inspect), "inspect");
        /* class_init */
        {
        }
    } /* pass */
} /* Parrot_PMCProxy_class_init */
 /* END pmclass */

/*

=back

=head1 SEE ALSO

F<docs/pdds/pdd17_pmc.pod>.

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
