/*
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/resizablebooleanarray.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

#line 1 "./src/pmc/resizablebooleanarray.pmc"
/*
Copyright (C) 2001-2005, The Perl Foundation.
$Id: resizablebooleanarray.pmc 18407 2007-05-03 05:08:51Z chromatic $

=head1 NAME

src/pmc/resizablebooleanarray.pmc - resizable array for booleans only

=head1 DESCRIPTION

The C<ResizableBooleanArray PMC> implements an array of resizable size,
which stores booleans.
It uses the C<Boolean PMC> for all conversions.
The C<ResizableBooleanArray PMC> extends the C<FixedBooleanArray PMC>.

=head2 Functions

=over 4

=cut

*/

#include "parrot/parrot.h"


#define BITS_PER_CHAR 8
/* MIN_ALLOC is 8 * BITS_PER_CHAR */
#define MIN_ALLOC 64

/* Round a given size in bits to the nearest allocation unit, then convert it
 * to bytes. */
#define ROUND_BYTES(size) (((size) / MIN_ALLOC + 1) * MIN_ALLOC / BITS_PER_CHAR)
/* Convert a size in bits to a size in bytes */
#define BITS_TO_BYTES(size) ((size) / BITS_PER_CHAR)

#line 49 "src/pmc/resizablebooleanarray.c"
#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_resizablebooleanarray.h"
#include "pmc_fixedbooleanarray.h"
#include "pmc_default.h"
#include "resizablebooleanarray.str"

INTVAL
Parrot_ResizableBooleanArray_elements(Interp *interp, PMC* pmc)
#line 304 "./src/pmc/resizablebooleanarray.pmc"
{
    return PMC_int_val(pmc) - PMC_int_val2(pmc);

}
#line 65 "src/pmc/resizablebooleanarray.c"
void
Parrot_ResizableBooleanArray_freeze(Interp *interp, PMC* pmc, visit_info *info)
#line 337 "./src/pmc/resizablebooleanarray.pmc"
{
    /* XXX Dino - I'm concerned about freezing the entire
        allocated block of memory, it's dependent on the
        BITS_PER_CHAR value.
        Maybe we need to store that during the freeze as well
        and use it during thaw?
    */

    IMAGE_IO * const io = info->image_io;
    STRING *s;
    const INTVAL size = ROUND_BYTES(PMC_int_val(pmc));

     VTABLE_push_integer(interp, io, PMC_int_val2(pmc));
     VTABLE_push_integer(interp, io, PMC_int_val(pmc));
    s = string_from_cstring(interp, PMC_data_typed(pmc, char *), size);
     VTABLE_push_string(interp, io, s);

}
#line 87 "src/pmc/resizablebooleanarray.c"
INTVAL
Parrot_ResizableBooleanArray_get_integer(Interp *interp, PMC* pmc)
#line 318 "./src/pmc/resizablebooleanarray.pmc"
{
    return Parrot_ResizableBooleanArray_elements(interp, pmc);

}
#line 95 "src/pmc/resizablebooleanarray.c"
INTVAL
Parrot_ResizableBooleanArray_get_integer_keyed_int(Interp *interp, PMC* pmc, INTVAL key)
#line 56 "./src/pmc/resizablebooleanarray.pmc"
{
    INTVAL offsetkey;
    /* Try to make negative index into a real index */
    if (key < 0) {
        key = Parrot_ResizableBooleanArray_elements(interp, pmc) + key;

        /* If it's still negative, we have a problem */
        if (key < 0)
            real_exception(interp, NULL, E_IndexError,
                "ResizableBooleanArray: index out of bounds!");
    }

    /* Check if key is greater than allocated size */
    offsetkey = key + PMC_int_val2(pmc);
    if (offsetkey >= PMC_int_val(pmc))
         VTABLE_set_integer_native(interp, pmc, key+1);

    return Parrot_FixedBooleanArray_get_integer_keyed_int(interp, pmc, offsetkey);

}
#line 119 "src/pmc/resizablebooleanarray.c"
INTVAL
Parrot_ResizableBooleanArray_pop_integer(Interp *interp, PMC* pmc)
#line 184 "./src/pmc/resizablebooleanarray.pmc"
{
    INTVAL size, value;

    if ( VTABLE_elements(interp, pmc) < 1)
        real_exception(interp, NULL, E_IndexError,
            "ResizableBooleanArray: Can't pop from an empty array!");

    size = PMC_int_val(pmc) - PMC_int_val2(pmc);
    value =  VTABLE_get_integer_keyed_int(interp, pmc, size - 1);
     VTABLE_set_integer_native(interp, pmc, size - 1);

    return value;

}
#line 137 "src/pmc/resizablebooleanarray.c"
void
Parrot_ResizableBooleanArray_push_integer(Interp *interp, PMC* pmc, INTVAL value)
#line 168 "./src/pmc/resizablebooleanarray.pmc"
{
    const INTVAL size = PMC_int_val(pmc) - PMC_int_val2(pmc);
     VTABLE_set_integer_native(interp, pmc, size + 1);
     VTABLE_set_integer_keyed_int(interp, pmc, size, value);

}
#line 147 "src/pmc/resizablebooleanarray.c"
void
Parrot_ResizableBooleanArray_set_integer_keyed_int(Interp *interp, PMC* pmc, INTVAL key, INTVAL value)
#line 86 "./src/pmc/resizablebooleanarray.pmc"
{
    INTVAL offsetkey;

    /* Try to make negative index into a real index */
    if (key < 0) {
        key = Parrot_ResizableBooleanArray_elements(interp, pmc) + key;

        /* If it's still negative, we have a problem */
        if (key < 0)
            real_exception(interp, NULL, E_IndexError,
                "ResizableBooleanArray: index out of bounds!");
    }

    /* Check if key is greater than allocated size */
    offsetkey = key + PMC_int_val2(pmc);
    if (offsetkey >= PMC_int_val(pmc))
         VTABLE_set_integer_native(interp, pmc, key+1);

    Parrot_FixedBooleanArray_set_integer_keyed_int(interp, pmc, offsetkey, value);

}
#line 172 "src/pmc/resizablebooleanarray.c"
void
Parrot_ResizableBooleanArray_set_integer_native(Interp *interp, PMC* pmc, INTVAL size)
#line 117 "./src/pmc/resizablebooleanarray.pmc"
{
    /* Size respects any existing head position offset from unshift */
    INTVAL newsize = size + PMC_int_val2(pmc);
    INTVAL oldsize = PMC_int_val(pmc);

    INTVAL new_bytesize, old_bytesize;

    /* We are already at the requested size. Yay */
    if (newsize == oldsize)
        return;

    if (size < 0)
        real_exception(interp, NULL, E_IndexError,
            "ResizableBooleanArray: Can't resize!");

    /* now set the new size, in bits */
    PMC_int_val(pmc) = newsize;

    /* convert sizes to bytes */
    new_bytesize  = ROUND_BYTES(newsize);
    old_bytesize  = ROUND_BYTES(oldsize);

    /* Nothing allocated yet */
    if (! PMC_data(pmc))
        PMC_data(pmc) = mem_sys_allocate_zeroed(new_bytesize);

    /* The size is different, and doesn't fit within the current
     * allocation */
    else if (new_bytesize != old_bytesize) {
        Parrot_UInt1 * old_store = PMC_data_typed(pmc, Parrot_UInt1 *);
        Parrot_UInt1 * new_store =
            (Parrot_UInt1 *)mem_sys_allocate_zeroed(newsize);
        INTVAL         copy_size =
            new_bytesize < old_bytesize ? new_bytesize : old_bytesize;

        /* Replace old array with new array, and free old array */
        PMC_data(pmc) = mem_sys_memmove(new_store, old_store, copy_size);
        mem_sys_free(old_store);
    }

}
#line 217 "src/pmc/resizablebooleanarray.c"
INTVAL
Parrot_ResizableBooleanArray_shift_integer(Interp *interp, PMC* pmc)
#line 254 "./src/pmc/resizablebooleanarray.pmc"
{
    INTVAL value;

    if ( VTABLE_elements(interp, pmc) < 1)
        real_exception(interp, NULL, E_IndexError,
            "ResizableBooleanArray: Can't shift from an empty array!");

    /* Get head value */
    value =  VTABLE_get_integer_keyed_int(interp, pmc, 0);

    /* Move the head position */
    PMC_int_val2(pmc)++;

    /* If the head position offset is greater than our allocation unit
     * size, size this thing down */
    if (PMC_int_val2(pmc) >= MIN_ALLOC) {
        /* Allocate one allocation unit less of space in new array */
        INTVAL newmemsize;
        Parrot_UInt1 *sdNew = NULL;
        Parrot_UInt1 *sdOld = NULL;
        newmemsize          = ROUND_BYTES(PMC_int_val(pmc) - MIN_ALLOC);
        sdNew               =
            (Parrot_UInt1 *)mem_sys_allocate_zeroed(newmemsize);

        /* Copy contents of old array to new array, move the head position
         * offset back by one allocation unit (in bytes) */
        sdOld = PMC_data_typed(pmc, Parrot_UInt1 *);
        mem_sys_memmove(sdNew, sdOld + (BITS_TO_BYTES(MIN_ALLOC)), newmemsize);

        /* Replace old array with new array, and free old array */
        PMC_data(pmc) = sdNew;
        mem_sys_free(sdOld);

        /* Removed one allocation unit from the head position offset */
        PMC_int_val2(pmc) -= MIN_ALLOC;
        PMC_int_val(pmc)  -= MIN_ALLOC;

    }

    return value;

}
#line 263 "src/pmc/resizablebooleanarray.c"
void
Parrot_ResizableBooleanArray_thaw(Interp *interp, PMC* pmc, visit_info *info)
#line 364 "./src/pmc/resizablebooleanarray.pmc"
{
    IMAGE_IO * const io = info->image_io;
    const INTVAL headPos =  VTABLE_shift_integer(interp, io);
    const INTVAL tailPos =  VTABLE_shift_integer(interp, io);
    STRING * const s =  VTABLE_shift_string(interp, io);

    PMC_data(pmc) = mem_sys_allocate_zeroed(s->bufused);
    mem_sys_memcopy(PMC_data(pmc), s->strstart, s->bufused);
    PMC_int_val2(pmc) = headPos;
    PMC_int_val(pmc) = tailPos;

}
#line 279 "src/pmc/resizablebooleanarray.c"
void
Parrot_ResizableBooleanArray_unshift_integer(Interp *interp, PMC* pmc, INTVAL value)
#line 209 "./src/pmc/resizablebooleanarray.pmc"
{
    /* If the current head position offset is 0, size this thing up by one
     * allocation unit */
    if (PMC_int_val2(pmc) <= 0) {
        Parrot_UInt1 * const sdOld = PMC_data_typed(pmc, Parrot_UInt1 *);

        /* Allocate an extra allocation unit of space in new array */
        INTVAL oldmemsize, newmemsize;
        Parrot_UInt1 *sdNew = NULL;
        newmemsize          = ROUND_BYTES(PMC_int_val(pmc) + MIN_ALLOC);
        sdNew               =
            (Parrot_UInt1 *)mem_sys_allocate_zeroed(newmemsize);

        /* Copy contents of old array to new array, moving the head
         * position forward by one allocation unit (in bytes). */
        oldmemsize = ROUND_BYTES(PMC_int_val(pmc));
        mem_sys_memmove(sdNew + (BITS_TO_BYTES(MIN_ALLOC)), sdOld, oldmemsize);

        /* Replace old array with new array, and free old array */
        PMC_data(pmc) = sdNew;
        mem_sys_free(sdOld);

        /* Added one allocation unit to the head position offset */
        PMC_int_val2(pmc) += MIN_ALLOC;
        PMC_int_val(pmc)  += MIN_ALLOC;

    }

    /* Move the head position */
    PMC_int_val2(pmc)--;

    /* Assign the new value as the first item */
     VTABLE_set_integer_keyed_int(interp, pmc, 0, value);

}
#line 318 "src/pmc/resizablebooleanarray.c"
void
Parrot_ResizableBooleanArray_ro_add_attribute(Interp *interp, PMC* pmc, STRING* name, PMC* type)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "add_attribute() in read-only instance of ResizableBooleanArray");
}
void
Parrot_ResizableBooleanArray_ro_add_method(Interp *interp, PMC* pmc, STRING* method_name, PMC* sub_pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "add_method() in read-only instance of ResizableBooleanArray");
}
void
Parrot_ResizableBooleanArray_ro_add_parent(Interp *interp, PMC* pmc, PMC* parent)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "add_parent() in read-only instance of ResizableBooleanArray");
}
void
Parrot_ResizableBooleanArray_ro_add_role(Interp *interp, PMC* pmc, PMC* role)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "add_role() in read-only instance of ResizableBooleanArray");
}
void
Parrot_ResizableBooleanArray_ro_assign_pmc(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "assign_pmc() in read-only instance of ResizableBooleanArray");
}
void
Parrot_ResizableBooleanArray_ro_assign_string_native(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "assign_string_native() in read-only instance of ResizableBooleanArray");
}
void
Parrot_ResizableBooleanArray_ro_decrement(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "decrement() in read-only instance of ResizableBooleanArray");
}
void
Parrot_ResizableBooleanArray_ro_delete_keyed(Interp *interp, PMC* pmc, PMC* key)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "delete_keyed() in read-only instance of ResizableBooleanArray");
}
void
Parrot_ResizableBooleanArray_ro_delete_keyed_int(Interp *interp, PMC* pmc, INTVAL key)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "delete_keyed_int() in read-only instance of ResizableBooleanArray");
}
void
Parrot_ResizableBooleanArray_ro_delete_keyed_str(Interp *interp, PMC* pmc, STRING* key)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "delete_keyed_str() in read-only instance of ResizableBooleanArray");
}
PMC*
Parrot_ResizableBooleanArray_ro_find_method(Interp *interp, PMC* pmc, STRING* method_name)
 {
    PMC *const method = Parrot_default_find_method(interp, pmc, method_name);
    if (!PMC_IS_NULL(VTABLE_getprop(interp, method, const_string(interp, "write"))))
        return PMCNULL;
    else
        return method;
}
void
Parrot_ResizableBooleanArray_ro_i_absolute(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_absolute() in read-only instance of ResizableBooleanArray");
}
void
Parrot_ResizableBooleanArray_ro_i_bitwise_not(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_bitwise_not() in read-only instance of ResizableBooleanArray");
}
void
Parrot_ResizableBooleanArray_ro_i_bitwise_nots(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_bitwise_nots() in read-only instance of ResizableBooleanArray");
}
void
Parrot_ResizableBooleanArray_ro_i_logical_not(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_logical_not() in read-only instance of ResizableBooleanArray");
}
void
Parrot_ResizableBooleanArray_ro_i_neg(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_neg() in read-only instance of ResizableBooleanArray");
}
void
Parrot_ResizableBooleanArray_ro_increment(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "increment() in read-only instance of ResizableBooleanArray");
}
void
Parrot_ResizableBooleanArray_ro_morph(Interp *interp, PMC* pmc, INTVAL type)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "morph() in read-only instance of ResizableBooleanArray");
}
FLOATVAL
Parrot_ResizableBooleanArray_ro_pop_float(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "pop_float() in read-only instance of ResizableBooleanArray");
    return (FLOATVAL)0;
}
INTVAL
Parrot_ResizableBooleanArray_ro_pop_integer(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "pop_integer() in read-only instance of ResizableBooleanArray");
    return (INTVAL)0;
}
PMC*
Parrot_ResizableBooleanArray_ro_pop_pmc(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "pop_pmc() in read-only instance of ResizableBooleanArray");
    return PMCNULL;
}
STRING*
Parrot_ResizableBooleanArray_ro_pop_string(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "pop_string() in read-only instance of ResizableBooleanArray");
    return (STRING*)0;
}
void
Parrot_ResizableBooleanArray_ro_push_float(Interp *interp, PMC* pmc, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "push_float() in read-only instance of ResizableBooleanArray");
}
void
Parrot_ResizableBooleanArray_ro_push_integer(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "push_integer() in read-only instance of ResizableBooleanArray");
}
void
Parrot_ResizableBooleanArray_ro_push_pmc(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "push_pmc() in read-only instance of ResizableBooleanArray");
}
void
Parrot_ResizableBooleanArray_ro_push_string(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "push_string() in read-only instance of ResizableBooleanArray");
}
void
Parrot_ResizableBooleanArray_ro_remove_attribute(Interp *interp, PMC* pmc, STRING* name)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "remove_attribute() in read-only instance of ResizableBooleanArray");
}
void
Parrot_ResizableBooleanArray_ro_remove_method(Interp *interp, PMC* pmc, STRING* method_name)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "remove_method() in read-only instance of ResizableBooleanArray");
}
void
Parrot_ResizableBooleanArray_ro_remove_parent(Interp *interp, PMC* pmc, PMC* parent)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "remove_parent() in read-only instance of ResizableBooleanArray");
}
void
Parrot_ResizableBooleanArray_ro_remove_role(Interp *interp, PMC* pmc, PMC* role)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "remove_role() in read-only instance of ResizableBooleanArray");
}
void
Parrot_ResizableBooleanArray_ro_set_attr(Interp *interp, PMC* pmc, INTVAL idx, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_attr() in read-only instance of ResizableBooleanArray");
}
void
Parrot_ResizableBooleanArray_ro_set_attr_str(Interp *interp, PMC* pmc, STRING* idx, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_attr_str() in read-only instance of ResizableBooleanArray");
}
void
Parrot_ResizableBooleanArray_ro_set_bignum_int(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_bignum_int() in read-only instance of ResizableBooleanArray");
}
void
Parrot_ResizableBooleanArray_ro_set_bignum_num(Interp *interp, PMC* pmc, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_bignum_num() in read-only instance of ResizableBooleanArray");
}
void
Parrot_ResizableBooleanArray_ro_set_bignum_str(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_bignum_str() in read-only instance of ResizableBooleanArray");
}
void
Parrot_ResizableBooleanArray_ro_set_bool(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_bool() in read-only instance of ResizableBooleanArray");
}
void
Parrot_ResizableBooleanArray_ro_set_integer_keyed(Interp *interp, PMC* pmc, PMC* key, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_keyed() in read-only instance of ResizableBooleanArray");
}
void
Parrot_ResizableBooleanArray_ro_set_integer_keyed_int(Interp *interp, PMC* pmc, INTVAL key, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_keyed_int() in read-only instance of ResizableBooleanArray");
}
void
Parrot_ResizableBooleanArray_ro_set_integer_keyed_str(Interp *interp, PMC* pmc, STRING* key, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_keyed_str() in read-only instance of ResizableBooleanArray");
}
void
Parrot_ResizableBooleanArray_ro_set_integer_native(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_native() in read-only instance of ResizableBooleanArray");
}
void
Parrot_ResizableBooleanArray_ro_set_integer_same(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_same() in read-only instance of ResizableBooleanArray");
}
void
Parrot_ResizableBooleanArray_ro_set_number_keyed(Interp *interp, PMC* pmc, PMC* key, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_keyed() in read-only instance of ResizableBooleanArray");
}
void
Parrot_ResizableBooleanArray_ro_set_number_keyed_int(Interp *interp, PMC* pmc, INTVAL key, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_keyed_int() in read-only instance of ResizableBooleanArray");
}
void
Parrot_ResizableBooleanArray_ro_set_number_keyed_str(Interp *interp, PMC* pmc, STRING* key, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_keyed_str() in read-only instance of ResizableBooleanArray");
}
void
Parrot_ResizableBooleanArray_ro_set_number_native(Interp *interp, PMC* pmc, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_native() in read-only instance of ResizableBooleanArray");
}
void
Parrot_ResizableBooleanArray_ro_set_number_same(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_same() in read-only instance of ResizableBooleanArray");
}
void
Parrot_ResizableBooleanArray_ro_set_pmc(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pmc() in read-only instance of ResizableBooleanArray");
}
void
Parrot_ResizableBooleanArray_ro_set_pmc_keyed(Interp *interp, PMC* pmc, PMC* key, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pmc_keyed() in read-only instance of ResizableBooleanArray");
}
void
Parrot_ResizableBooleanArray_ro_set_pmc_keyed_int(Interp *interp, PMC* pmc, INTVAL key, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_int() in read-only instance of ResizableBooleanArray");
}
void
Parrot_ResizableBooleanArray_ro_set_pmc_keyed_str(Interp *interp, PMC* pmc, STRING* key, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_str() in read-only instance of ResizableBooleanArray");
}
void
Parrot_ResizableBooleanArray_ro_set_pointer(Interp *interp, PMC* pmc, void* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pointer() in read-only instance of ResizableBooleanArray");
}
void
Parrot_ResizableBooleanArray_ro_set_pointer_keyed(Interp *interp, PMC* pmc, PMC* key, void* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pointer_keyed() in read-only instance of ResizableBooleanArray");
}
void
Parrot_ResizableBooleanArray_ro_set_pointer_keyed_int(Interp *interp, PMC* pmc, INTVAL key, void* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_int() in read-only instance of ResizableBooleanArray");
}
void
Parrot_ResizableBooleanArray_ro_set_pointer_keyed_str(Interp *interp, PMC* pmc, STRING* key, void* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_str() in read-only instance of ResizableBooleanArray");
}
void
Parrot_ResizableBooleanArray_ro_set_string_keyed(Interp *interp, PMC* pmc, PMC* key, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_keyed() in read-only instance of ResizableBooleanArray");
}
void
Parrot_ResizableBooleanArray_ro_set_string_keyed_int(Interp *interp, PMC* pmc, INTVAL key, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_keyed_int() in read-only instance of ResizableBooleanArray");
}
void
Parrot_ResizableBooleanArray_ro_set_string_keyed_str(Interp *interp, PMC* pmc, STRING* key, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_keyed_str() in read-only instance of ResizableBooleanArray");
}
void
Parrot_ResizableBooleanArray_ro_set_string_native(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_native() in read-only instance of ResizableBooleanArray");
}
void
Parrot_ResizableBooleanArray_ro_set_string_same(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_same() in read-only instance of ResizableBooleanArray");
}
FLOATVAL
Parrot_ResizableBooleanArray_ro_shift_float(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "shift_float() in read-only instance of ResizableBooleanArray");
    return (FLOATVAL)0;
}
INTVAL
Parrot_ResizableBooleanArray_ro_shift_integer(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "shift_integer() in read-only instance of ResizableBooleanArray");
    return (INTVAL)0;
}
PMC*
Parrot_ResizableBooleanArray_ro_shift_pmc(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "shift_pmc() in read-only instance of ResizableBooleanArray");
    return PMCNULL;
}
STRING*
Parrot_ResizableBooleanArray_ro_shift_string(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "shift_string() in read-only instance of ResizableBooleanArray");
    return (STRING*)0;
}
void
Parrot_ResizableBooleanArray_ro_splice(Interp *interp, PMC* pmc, PMC* value, INTVAL offset, INTVAL count)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "splice() in read-only instance of ResizableBooleanArray");
}
void
Parrot_ResizableBooleanArray_ro_thaw(Interp *interp, PMC* pmc, visit_info* info)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "thaw() in read-only instance of ResizableBooleanArray");
}
void
Parrot_ResizableBooleanArray_ro_thawfinish(Interp *interp, PMC* pmc, visit_info* info)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "thawfinish() in read-only instance of ResizableBooleanArray");
}
void
Parrot_ResizableBooleanArray_ro_unshift_float(Interp *interp, PMC* pmc, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "unshift_float() in read-only instance of ResizableBooleanArray");
}
void
Parrot_ResizableBooleanArray_ro_unshift_integer(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "unshift_integer() in read-only instance of ResizableBooleanArray");
}
void
Parrot_ResizableBooleanArray_ro_unshift_pmc(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "unshift_pmc() in read-only instance of ResizableBooleanArray");
}
void
Parrot_ResizableBooleanArray_ro_unshift_string(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "unshift_string() in read-only instance of ResizableBooleanArray");
}
void
Parrot_ResizableBooleanArray_class_init(Parrot_Interp interp, int entry, int pass)
{
    const VTABLE temp_base_vtable = {
        NULL, /* namespace */
        enum_class_ResizableBooleanArray, /* base_type */
        NULL, /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_HAS_READONLY_FLAG, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        NULL,   /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_default_add_attribute,
        Parrot_default_add_method,
        Parrot_default_add_parent,
        Parrot_default_add_role,
        Parrot_default_assign_pmc,
        Parrot_default_assign_string_native,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_can,
        Parrot_default_class_type,
        Parrot_FixedBooleanArray_clone,
        Parrot_default_clone_pmc,
        Parrot_default_decrement,
        Parrot_default_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_default_delete_keyed,
        Parrot_default_delete_keyed_int,
        Parrot_default_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_FixedBooleanArray_destroy,
        Parrot_default_does,
        Parrot_ResizableBooleanArray_elements,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_default_find_method,
        Parrot_ResizableBooleanArray_freeze,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_FixedBooleanArray_get_bool,
        Parrot_default_get_class,
        Parrot_ResizableBooleanArray_get_integer,
        Parrot_FixedBooleanArray_get_integer_keyed,
        Parrot_ResizableBooleanArray_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_iter,
        Parrot_default_get_number,
        Parrot_FixedBooleanArray_get_number_keyed,
        Parrot_FixedBooleanArray_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_FixedBooleanArray_get_pmc_keyed,
        Parrot_FixedBooleanArray_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_default_get_repr,
        Parrot_default_get_string,
        Parrot_FixedBooleanArray_get_string_keyed,
        Parrot_FixedBooleanArray_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_default_hash,
        Parrot_default_i_absolute,
        Parrot_default_i_bitwise_not,
        Parrot_default_i_bitwise_nots,
        Parrot_default_i_logical_not,
        Parrot_default_i_neg,
        Parrot_default_increment,
        Parrot_FixedBooleanArray_init,
        Parrot_default_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_default_instantiate,
        Parrot_default_invoke,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_logical_not,
        Parrot_default_mark,
        Parrot_FixedBooleanArray_morph,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_new_from_string,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_pmc_namespace,
        Parrot_default_pop_float,
        Parrot_ResizableBooleanArray_pop_integer,
        Parrot_default_pop_pmc,
        Parrot_default_pop_string,
        Parrot_default_push_float,
        Parrot_ResizableBooleanArray_push_integer,
        Parrot_default_push_pmc,
        Parrot_default_push_string,
        Parrot_default_remove_attribute,
        Parrot_default_remove_method,
        Parrot_default_remove_parent,
        Parrot_default_remove_role,
        Parrot_default_set_attr,
        Parrot_default_set_attr_str,
        Parrot_default_set_bignum_int,
        Parrot_default_set_bignum_num,
        Parrot_default_set_bignum_str,
        Parrot_default_set_bool,
        Parrot_FixedBooleanArray_set_integer_keyed,
        Parrot_ResizableBooleanArray_set_integer_keyed_int,
        Parrot_default_set_integer_keyed_str,
        Parrot_ResizableBooleanArray_set_integer_native,
        Parrot_default_set_integer_same,
        Parrot_FixedBooleanArray_set_number_keyed,
        Parrot_FixedBooleanArray_set_number_keyed_int,
        Parrot_default_set_number_keyed_str,
        Parrot_default_set_number_native,
        Parrot_default_set_number_same,
        Parrot_default_set_pmc,
        Parrot_FixedBooleanArray_set_pmc_keyed,
        Parrot_FixedBooleanArray_set_pmc_keyed_int,
        Parrot_default_set_pmc_keyed_str,
        Parrot_default_set_pointer,
        Parrot_default_set_pointer_keyed,
        Parrot_default_set_pointer_keyed_int,
        Parrot_default_set_pointer_keyed_str,
        Parrot_FixedBooleanArray_set_string_keyed,
        Parrot_FixedBooleanArray_set_string_keyed_int,
        Parrot_default_set_string_keyed_str,
        Parrot_default_set_string_native,
        Parrot_default_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_default_shift_float,
        Parrot_ResizableBooleanArray_shift_integer,
        Parrot_default_shift_pmc,
        Parrot_default_shift_string,
        Parrot_default_slice,
        Parrot_default_splice,
        Parrot_default_subclass,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtype,
        Parrot_ResizableBooleanArray_thaw,
        Parrot_default_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_type_keyed_int,
        Parrot_default_type_keyed_str,
        Parrot_default_unshift_float,
        Parrot_ResizableBooleanArray_unshift_integer,
        Parrot_default_unshift_pmc,
        Parrot_default_unshift_string,
        Parrot_default_visit
    };

    const VTABLE temp_ro_vtable = {
        NULL, /* namespace */
        enum_class_ResizableBooleanArray, /* base_type */
        NULL, /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_IS_READONLY_FLAG, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        NULL,   /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_ResizableBooleanArray_ro_add_attribute,
        Parrot_ResizableBooleanArray_ro_add_method,
        Parrot_ResizableBooleanArray_ro_add_parent,
        Parrot_ResizableBooleanArray_ro_add_role,
        Parrot_ResizableBooleanArray_ro_assign_pmc,
        Parrot_ResizableBooleanArray_ro_assign_string_native,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_can,
        Parrot_default_class_type,
        Parrot_FixedBooleanArray_clone,
        Parrot_default_clone_pmc,
        Parrot_ResizableBooleanArray_ro_decrement,
        Parrot_default_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_ResizableBooleanArray_ro_delete_keyed,
        Parrot_ResizableBooleanArray_ro_delete_keyed_int,
        Parrot_ResizableBooleanArray_ro_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_FixedBooleanArray_destroy,
        Parrot_default_does,
        Parrot_ResizableBooleanArray_elements,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_ResizableBooleanArray_ro_find_method,
        Parrot_ResizableBooleanArray_freeze,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_FixedBooleanArray_get_bool,
        Parrot_default_get_class,
        Parrot_ResizableBooleanArray_get_integer,
        Parrot_FixedBooleanArray_get_integer_keyed,
        Parrot_ResizableBooleanArray_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_iter,
        Parrot_default_get_number,
        Parrot_FixedBooleanArray_get_number_keyed,
        Parrot_FixedBooleanArray_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_FixedBooleanArray_get_pmc_keyed,
        Parrot_FixedBooleanArray_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_default_get_repr,
        Parrot_default_get_string,
        Parrot_FixedBooleanArray_get_string_keyed,
        Parrot_FixedBooleanArray_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_default_hash,
        Parrot_ResizableBooleanArray_ro_i_absolute,
        Parrot_ResizableBooleanArray_ro_i_bitwise_not,
        Parrot_ResizableBooleanArray_ro_i_bitwise_nots,
        Parrot_ResizableBooleanArray_ro_i_logical_not,
        Parrot_ResizableBooleanArray_ro_i_neg,
        Parrot_ResizableBooleanArray_ro_increment,
        Parrot_FixedBooleanArray_init,
        Parrot_default_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_default_instantiate,
        Parrot_default_invoke,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_logical_not,
        Parrot_default_mark,
        Parrot_ResizableBooleanArray_ro_morph,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_new_from_string,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_pmc_namespace,
        Parrot_ResizableBooleanArray_ro_pop_float,
        Parrot_ResizableBooleanArray_ro_pop_integer,
        Parrot_ResizableBooleanArray_ro_pop_pmc,
        Parrot_ResizableBooleanArray_ro_pop_string,
        Parrot_ResizableBooleanArray_ro_push_float,
        Parrot_ResizableBooleanArray_ro_push_integer,
        Parrot_ResizableBooleanArray_ro_push_pmc,
        Parrot_ResizableBooleanArray_ro_push_string,
        Parrot_ResizableBooleanArray_ro_remove_attribute,
        Parrot_ResizableBooleanArray_ro_remove_method,
        Parrot_ResizableBooleanArray_ro_remove_parent,
        Parrot_ResizableBooleanArray_ro_remove_role,
        Parrot_ResizableBooleanArray_ro_set_attr,
        Parrot_ResizableBooleanArray_ro_set_attr_str,
        Parrot_ResizableBooleanArray_ro_set_bignum_int,
        Parrot_ResizableBooleanArray_ro_set_bignum_num,
        Parrot_ResizableBooleanArray_ro_set_bignum_str,
        Parrot_ResizableBooleanArray_ro_set_bool,
        Parrot_ResizableBooleanArray_ro_set_integer_keyed,
        Parrot_ResizableBooleanArray_ro_set_integer_keyed_int,
        Parrot_ResizableBooleanArray_ro_set_integer_keyed_str,
        Parrot_ResizableBooleanArray_ro_set_integer_native,
        Parrot_ResizableBooleanArray_ro_set_integer_same,
        Parrot_ResizableBooleanArray_ro_set_number_keyed,
        Parrot_ResizableBooleanArray_ro_set_number_keyed_int,
        Parrot_ResizableBooleanArray_ro_set_number_keyed_str,
        Parrot_ResizableBooleanArray_ro_set_number_native,
        Parrot_ResizableBooleanArray_ro_set_number_same,
        Parrot_ResizableBooleanArray_ro_set_pmc,
        Parrot_ResizableBooleanArray_ro_set_pmc_keyed,
        Parrot_ResizableBooleanArray_ro_set_pmc_keyed_int,
        Parrot_ResizableBooleanArray_ro_set_pmc_keyed_str,
        Parrot_ResizableBooleanArray_ro_set_pointer,
        Parrot_ResizableBooleanArray_ro_set_pointer_keyed,
        Parrot_ResizableBooleanArray_ro_set_pointer_keyed_int,
        Parrot_ResizableBooleanArray_ro_set_pointer_keyed_str,
        Parrot_ResizableBooleanArray_ro_set_string_keyed,
        Parrot_ResizableBooleanArray_ro_set_string_keyed_int,
        Parrot_ResizableBooleanArray_ro_set_string_keyed_str,
        Parrot_ResizableBooleanArray_ro_set_string_native,
        Parrot_ResizableBooleanArray_ro_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_ResizableBooleanArray_ro_shift_float,
        Parrot_ResizableBooleanArray_ro_shift_integer,
        Parrot_ResizableBooleanArray_ro_shift_pmc,
        Parrot_ResizableBooleanArray_ro_shift_string,
        Parrot_default_slice,
        Parrot_ResizableBooleanArray_ro_splice,
        Parrot_default_subclass,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtype,
        Parrot_ResizableBooleanArray_ro_thaw,
        Parrot_ResizableBooleanArray_ro_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_type_keyed_int,
        Parrot_default_type_keyed_str,
        Parrot_ResizableBooleanArray_ro_unshift_float,
        Parrot_ResizableBooleanArray_ro_unshift_integer,
        Parrot_ResizableBooleanArray_ro_unshift_pmc,
        Parrot_ResizableBooleanArray_ro_unshift_string,
        Parrot_default_visit
    };
    if (pass == 0) {
        /*
         * create vtable - clone it - we have to set a few items
         */
        VTABLE *vt_clone =
            Parrot_clone_vtable(interp, &temp_base_vtable);
        VTABLE *vt_ro_clone =
            Parrot_clone_vtable(interp, &temp_ro_vtable);
        vt_clone->whoami = CONST_STRING(interp, "ResizableBooleanArray");
        vt_clone->isa_str = CONST_STRING(interp, "ResizableBooleanArray FixedBooleanArray");
        vt_clone->does_str = CONST_STRING(interp, "array");
        vt_ro_clone->base_type = entry;
        vt_ro_clone->whoami = vt_clone->whoami;
        vt_ro_clone->isa_str = vt_clone->isa_str;
        vt_ro_clone->does_str = vt_clone->does_str;
        vt_clone->ro_variant_vtable = vt_ro_clone;
        vt_ro_clone->ro_variant_vtable = vt_clone;
        interp->vtables[entry] = vt_clone;
    }
    else { /* pass */
        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        /* create PMC Proxy object */
        Parrot_create_pmc_proxy(interp, entry);
        /* class_init */
        {
        }
    } /* pass */
} /* Parrot_ResizableBooleanArray_class_init */
  /* pmclass */

/*

=back

=head1 SEE ALSO

F<docs/pdds/pdd17_basic_types.pod>.

=head1 HISTORY

Initial version                  - Matt Fowles 2004-06-11

Changed allocator to double size - Matt Fowles 2004-06-15

Added push_integer               - Bernhard Schmalhofer 2004-10-17

Changed allocation code, added   - Dino Morelli 2005-06-10
  push_, pop_, shift_,
  unshift_integer, freeze, thaw

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
