/*
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/resizableintegerarray.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

#line 1 "./src/pmc/resizableintegerarray.pmc"
/*
Copyright (C) 2001-2003, The Perl Foundation.
$Id: resizableintegerarray.pmc 16275 2006-12-28 01:20:44Z particle $

=head1 NAME

src/pmc/resizableintegerarray.pmc - resizable array for integers only

=head1 DESCRIPTION

This class, ResizableIntegerArray, implements an array of resizable
size, which stores INTVALs.  It uses Integer PMCs for all of the
conversions.

=head2 Functions

=over 4

=cut

*/

#include "parrot/parrot.h"


#line 38 "src/pmc/resizableintegerarray.c"
#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_resizableintegerarray.h"
#include "pmc_fixedintegerarray.h"
#include "pmc_default.h"
#include "resizableintegerarray.str"

PMC*
Parrot_ResizableIntegerArray_clone(Interp *interp, PMC* pmc)
#line 215 "./src/pmc/resizableintegerarray.pmc"
{
    PMC *copy = Parrot_FixedIntegerArray_clone(interp, pmc);
    /* copy trimmed extra space */
    PMC_int_val2(copy) = PMC_int_val(pmc);
    return copy;

}
#line 57 "src/pmc/resizableintegerarray.c"
INTVAL
Parrot_ResizableIntegerArray_get_integer_keyed_int(Interp *interp, PMC* pmc, INTVAL key)
#line 38 "./src/pmc/resizableintegerarray.pmc"
{
    INTVAL *data;
    if (key < 0)
        real_exception(interp, NULL, E_IndexError,
            "ResizableIntegerArray: index out of bounds!");
    if (key >= PMC_int_val(pmc))
         VTABLE_set_integer_native(interp, pmc, key+1);

    data = (INTVAL *)PMC_data(pmc);
    return data[key];

}
#line 73 "src/pmc/resizableintegerarray.c"
INTVAL
Parrot_ResizableIntegerArray_pop_integer(Interp *interp, PMC* pmc)
#line 147 "./src/pmc/resizableintegerarray.pmc"
{
    INTVAL size;
    INTVAL value;

    size = PMC_int_val(pmc);
    if (size == 0) {
        real_exception(interp, NULL, E_IndexError,
                "ResizableIntegerArray: Can't pop from an empty array!");
    }
    value =  VTABLE_get_integer_keyed_int(interp, pmc, size-1);
     VTABLE_set_integer_native(interp, pmc, size - 1);
    return value;

}
#line 91 "src/pmc/resizableintegerarray.c"
void
Parrot_ResizableIntegerArray_push_integer(Interp *interp, PMC* pmc, INTVAL value)
#line 132 "./src/pmc/resizableintegerarray.pmc"
{
    INTVAL nextix =  VTABLE_elements(interp, pmc);
     VTABLE_set_integer_keyed_int(interp, pmc, nextix, value);

}
#line 100 "src/pmc/resizableintegerarray.c"
void
Parrot_ResizableIntegerArray_set_integer_keyed_int(Interp *interp, PMC* pmc, INTVAL key, INTVAL value)
#line 60 "./src/pmc/resizableintegerarray.pmc"
{
    INTVAL *data;
    if (key < 0)
        real_exception(interp, NULL, E_IndexError,
            "ResizableIntegerArray: index out of bounds!");
    if (key >= PMC_int_val(pmc))
         VTABLE_set_integer_native(interp, pmc, key+1);

    data = (INTVAL *)PMC_data(pmc);
    data[key] = value;

}
#line 116 "src/pmc/resizableintegerarray.c"
void
Parrot_ResizableIntegerArray_set_integer_native(Interp *interp, PMC* pmc, INTVAL size)
#line 82 "./src/pmc/resizableintegerarray.pmc"
{
    if (size < 0)
        real_exception(interp, NULL, E_IndexError,
                "ResizableStringArray: Can't resize!");

    if (!PMC_data(pmc)) {
        /* empty - used fixed routine */
        if (size < 8) {
            Parrot_FixedIntegerArray_set_integer_native(interp, pmc, 8);
            PMC_int_val(pmc) = size;
            PMC_int_val2(pmc) = 8;
        }
        else {
            Parrot_FixedIntegerArray_set_integer_native(interp, pmc, size);
            PMC_int_val2(pmc) = size;
        }
    }
    else if (size <= PMC_int_val2(pmc)) {
        PMC_int_val(pmc) = size;
        /* we could shrink here if necessary */
        return;
    }
    else {
        INTVAL cur, needed;
        cur = PMC_int_val2(pmc);
        if (cur < 8192)
            cur = size < 2 * cur ? 2 * cur : size;
        else {
            needed = size - cur;
            cur += needed + 4096;
            cur &= ~0xfff;
        }
        PMC_data(pmc) = mem_sys_realloc(PMC_data(pmc),
                cur * sizeof (INTVAL));
        PMC_int_val2(pmc) = cur;
        PMC_int_val(pmc) = size;
    }

}
#line 159 "src/pmc/resizableintegerarray.c"
INTVAL
Parrot_ResizableIntegerArray_shift_integer(Interp *interp, PMC* pmc)
#line 170 "./src/pmc/resizableintegerarray.pmc"
{
    INTVAL size;
    INTVAL value, *data;

    size = PMC_int_val(pmc);
    if (size == 0) {
        real_exception(interp, NULL, E_IndexError,
                "ResizableIntegerArray: Can't shift from an empty array!");
    }
    data = (INTVAL *)PMC_data(pmc);
    value = data[0];
    PMC_int_val(pmc) = --size;
    mem_sys_memmove(data, data + 1, size * sizeof (INTVAL));
    return value;

}
#line 179 "src/pmc/resizableintegerarray.c"
void
Parrot_ResizableIntegerArray_unshift_integer(Interp *interp, PMC* pmc, INTVAL value)
#line 196 "./src/pmc/resizableintegerarray.pmc"
{
    INTVAL size, *data;

    size = PMC_int_val(pmc);
     VTABLE_set_integer_native(interp, pmc, size + 1);
    data = (INTVAL *)PMC_data(pmc);
    mem_sys_memmove(data + 1, data, size * sizeof (INTVAL));
    data[0] = value;

}
#line 193 "src/pmc/resizableintegerarray.c"
void
Parrot_ResizableIntegerArray_ro_add_attribute(Interp *interp, PMC* pmc, STRING* name, PMC* type)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "add_attribute() in read-only instance of ResizableIntegerArray");
}
void
Parrot_ResizableIntegerArray_ro_add_method(Interp *interp, PMC* pmc, STRING* method_name, PMC* sub_pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "add_method() in read-only instance of ResizableIntegerArray");
}
void
Parrot_ResizableIntegerArray_ro_add_parent(Interp *interp, PMC* pmc, PMC* parent)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "add_parent() in read-only instance of ResizableIntegerArray");
}
void
Parrot_ResizableIntegerArray_ro_add_role(Interp *interp, PMC* pmc, PMC* role)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "add_role() in read-only instance of ResizableIntegerArray");
}
void
Parrot_ResizableIntegerArray_ro_assign_pmc(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "assign_pmc() in read-only instance of ResizableIntegerArray");
}
void
Parrot_ResizableIntegerArray_ro_assign_string_native(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "assign_string_native() in read-only instance of ResizableIntegerArray");
}
void
Parrot_ResizableIntegerArray_ro_decrement(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "decrement() in read-only instance of ResizableIntegerArray");
}
void
Parrot_ResizableIntegerArray_ro_delete_keyed(Interp *interp, PMC* pmc, PMC* key)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "delete_keyed() in read-only instance of ResizableIntegerArray");
}
void
Parrot_ResizableIntegerArray_ro_delete_keyed_int(Interp *interp, PMC* pmc, INTVAL key)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "delete_keyed_int() in read-only instance of ResizableIntegerArray");
}
void
Parrot_ResizableIntegerArray_ro_delete_keyed_str(Interp *interp, PMC* pmc, STRING* key)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "delete_keyed_str() in read-only instance of ResizableIntegerArray");
}
PMC*
Parrot_ResizableIntegerArray_ro_find_method(Interp *interp, PMC* pmc, STRING* method_name)
 {
    PMC *const method = Parrot_default_find_method(interp, pmc, method_name);
    if (!PMC_IS_NULL(VTABLE_getprop(interp, method, const_string(interp, "write"))))
        return PMCNULL;
    else
        return method;
}
void
Parrot_ResizableIntegerArray_ro_i_absolute(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_absolute() in read-only instance of ResizableIntegerArray");
}
void
Parrot_ResizableIntegerArray_ro_i_bitwise_not(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_bitwise_not() in read-only instance of ResizableIntegerArray");
}
void
Parrot_ResizableIntegerArray_ro_i_bitwise_nots(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_bitwise_nots() in read-only instance of ResizableIntegerArray");
}
void
Parrot_ResizableIntegerArray_ro_i_logical_not(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_logical_not() in read-only instance of ResizableIntegerArray");
}
void
Parrot_ResizableIntegerArray_ro_i_neg(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_neg() in read-only instance of ResizableIntegerArray");
}
void
Parrot_ResizableIntegerArray_ro_increment(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "increment() in read-only instance of ResizableIntegerArray");
}
void
Parrot_ResizableIntegerArray_ro_morph(Interp *interp, PMC* pmc, INTVAL type)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "morph() in read-only instance of ResizableIntegerArray");
}
FLOATVAL
Parrot_ResizableIntegerArray_ro_pop_float(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "pop_float() in read-only instance of ResizableIntegerArray");
    return (FLOATVAL)0;
}
INTVAL
Parrot_ResizableIntegerArray_ro_pop_integer(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "pop_integer() in read-only instance of ResizableIntegerArray");
    return (INTVAL)0;
}
PMC*
Parrot_ResizableIntegerArray_ro_pop_pmc(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "pop_pmc() in read-only instance of ResizableIntegerArray");
    return PMCNULL;
}
STRING*
Parrot_ResizableIntegerArray_ro_pop_string(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "pop_string() in read-only instance of ResizableIntegerArray");
    return (STRING*)0;
}
void
Parrot_ResizableIntegerArray_ro_push_float(Interp *interp, PMC* pmc, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "push_float() in read-only instance of ResizableIntegerArray");
}
void
Parrot_ResizableIntegerArray_ro_push_integer(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "push_integer() in read-only instance of ResizableIntegerArray");
}
void
Parrot_ResizableIntegerArray_ro_push_pmc(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "push_pmc() in read-only instance of ResizableIntegerArray");
}
void
Parrot_ResizableIntegerArray_ro_push_string(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "push_string() in read-only instance of ResizableIntegerArray");
}
void
Parrot_ResizableIntegerArray_ro_remove_attribute(Interp *interp, PMC* pmc, STRING* name)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "remove_attribute() in read-only instance of ResizableIntegerArray");
}
void
Parrot_ResizableIntegerArray_ro_remove_method(Interp *interp, PMC* pmc, STRING* method_name)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "remove_method() in read-only instance of ResizableIntegerArray");
}
void
Parrot_ResizableIntegerArray_ro_remove_parent(Interp *interp, PMC* pmc, PMC* parent)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "remove_parent() in read-only instance of ResizableIntegerArray");
}
void
Parrot_ResizableIntegerArray_ro_remove_role(Interp *interp, PMC* pmc, PMC* role)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "remove_role() in read-only instance of ResizableIntegerArray");
}
void
Parrot_ResizableIntegerArray_ro_set_attr(Interp *interp, PMC* pmc, INTVAL idx, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_attr() in read-only instance of ResizableIntegerArray");
}
void
Parrot_ResizableIntegerArray_ro_set_attr_str(Interp *interp, PMC* pmc, STRING* idx, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_attr_str() in read-only instance of ResizableIntegerArray");
}
void
Parrot_ResizableIntegerArray_ro_set_bignum_int(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_bignum_int() in read-only instance of ResizableIntegerArray");
}
void
Parrot_ResizableIntegerArray_ro_set_bignum_num(Interp *interp, PMC* pmc, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_bignum_num() in read-only instance of ResizableIntegerArray");
}
void
Parrot_ResizableIntegerArray_ro_set_bignum_str(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_bignum_str() in read-only instance of ResizableIntegerArray");
}
void
Parrot_ResizableIntegerArray_ro_set_bool(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_bool() in read-only instance of ResizableIntegerArray");
}
void
Parrot_ResizableIntegerArray_ro_set_integer_keyed(Interp *interp, PMC* pmc, PMC* key, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_keyed() in read-only instance of ResizableIntegerArray");
}
void
Parrot_ResizableIntegerArray_ro_set_integer_keyed_int(Interp *interp, PMC* pmc, INTVAL key, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_keyed_int() in read-only instance of ResizableIntegerArray");
}
void
Parrot_ResizableIntegerArray_ro_set_integer_keyed_str(Interp *interp, PMC* pmc, STRING* key, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_keyed_str() in read-only instance of ResizableIntegerArray");
}
void
Parrot_ResizableIntegerArray_ro_set_integer_native(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_native() in read-only instance of ResizableIntegerArray");
}
void
Parrot_ResizableIntegerArray_ro_set_integer_same(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_same() in read-only instance of ResizableIntegerArray");
}
void
Parrot_ResizableIntegerArray_ro_set_number_keyed(Interp *interp, PMC* pmc, PMC* key, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_keyed() in read-only instance of ResizableIntegerArray");
}
void
Parrot_ResizableIntegerArray_ro_set_number_keyed_int(Interp *interp, PMC* pmc, INTVAL key, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_keyed_int() in read-only instance of ResizableIntegerArray");
}
void
Parrot_ResizableIntegerArray_ro_set_number_keyed_str(Interp *interp, PMC* pmc, STRING* key, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_keyed_str() in read-only instance of ResizableIntegerArray");
}
void
Parrot_ResizableIntegerArray_ro_set_number_native(Interp *interp, PMC* pmc, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_native() in read-only instance of ResizableIntegerArray");
}
void
Parrot_ResizableIntegerArray_ro_set_number_same(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_same() in read-only instance of ResizableIntegerArray");
}
void
Parrot_ResizableIntegerArray_ro_set_pmc(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pmc() in read-only instance of ResizableIntegerArray");
}
void
Parrot_ResizableIntegerArray_ro_set_pmc_keyed(Interp *interp, PMC* pmc, PMC* key, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pmc_keyed() in read-only instance of ResizableIntegerArray");
}
void
Parrot_ResizableIntegerArray_ro_set_pmc_keyed_int(Interp *interp, PMC* pmc, INTVAL key, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_int() in read-only instance of ResizableIntegerArray");
}
void
Parrot_ResizableIntegerArray_ro_set_pmc_keyed_str(Interp *interp, PMC* pmc, STRING* key, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_str() in read-only instance of ResizableIntegerArray");
}
void
Parrot_ResizableIntegerArray_ro_set_pointer(Interp *interp, PMC* pmc, void* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pointer() in read-only instance of ResizableIntegerArray");
}
void
Parrot_ResizableIntegerArray_ro_set_pointer_keyed(Interp *interp, PMC* pmc, PMC* key, void* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pointer_keyed() in read-only instance of ResizableIntegerArray");
}
void
Parrot_ResizableIntegerArray_ro_set_pointer_keyed_int(Interp *interp, PMC* pmc, INTVAL key, void* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_int() in read-only instance of ResizableIntegerArray");
}
void
Parrot_ResizableIntegerArray_ro_set_pointer_keyed_str(Interp *interp, PMC* pmc, STRING* key, void* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_str() in read-only instance of ResizableIntegerArray");
}
void
Parrot_ResizableIntegerArray_ro_set_string_keyed(Interp *interp, PMC* pmc, PMC* key, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_keyed() in read-only instance of ResizableIntegerArray");
}
void
Parrot_ResizableIntegerArray_ro_set_string_keyed_int(Interp *interp, PMC* pmc, INTVAL key, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_keyed_int() in read-only instance of ResizableIntegerArray");
}
void
Parrot_ResizableIntegerArray_ro_set_string_keyed_str(Interp *interp, PMC* pmc, STRING* key, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_keyed_str() in read-only instance of ResizableIntegerArray");
}
void
Parrot_ResizableIntegerArray_ro_set_string_native(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_native() in read-only instance of ResizableIntegerArray");
}
void
Parrot_ResizableIntegerArray_ro_set_string_same(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_same() in read-only instance of ResizableIntegerArray");
}
FLOATVAL
Parrot_ResizableIntegerArray_ro_shift_float(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "shift_float() in read-only instance of ResizableIntegerArray");
    return (FLOATVAL)0;
}
INTVAL
Parrot_ResizableIntegerArray_ro_shift_integer(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "shift_integer() in read-only instance of ResizableIntegerArray");
    return (INTVAL)0;
}
PMC*
Parrot_ResizableIntegerArray_ro_shift_pmc(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "shift_pmc() in read-only instance of ResizableIntegerArray");
    return PMCNULL;
}
STRING*
Parrot_ResizableIntegerArray_ro_shift_string(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "shift_string() in read-only instance of ResizableIntegerArray");
    return (STRING*)0;
}
void
Parrot_ResizableIntegerArray_ro_splice(Interp *interp, PMC* pmc, PMC* value, INTVAL offset, INTVAL count)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "splice() in read-only instance of ResizableIntegerArray");
}
void
Parrot_ResizableIntegerArray_ro_thaw(Interp *interp, PMC* pmc, visit_info* info)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "thaw() in read-only instance of ResizableIntegerArray");
}
void
Parrot_ResizableIntegerArray_ro_thawfinish(Interp *interp, PMC* pmc, visit_info* info)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "thawfinish() in read-only instance of ResizableIntegerArray");
}
void
Parrot_ResizableIntegerArray_ro_unshift_float(Interp *interp, PMC* pmc, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "unshift_float() in read-only instance of ResizableIntegerArray");
}
void
Parrot_ResizableIntegerArray_ro_unshift_integer(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "unshift_integer() in read-only instance of ResizableIntegerArray");
}
void
Parrot_ResizableIntegerArray_ro_unshift_pmc(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "unshift_pmc() in read-only instance of ResizableIntegerArray");
}
void
Parrot_ResizableIntegerArray_ro_unshift_string(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "unshift_string() in read-only instance of ResizableIntegerArray");
}
void
Parrot_ResizableIntegerArray_class_init(Parrot_Interp interp, int entry, int pass)
{
    const VTABLE temp_base_vtable = {
        NULL, /* namespace */
        enum_class_ResizableIntegerArray, /* base_type */
        NULL, /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_HAS_READONLY_FLAG, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        NULL,   /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_default_add_attribute,
        Parrot_default_add_method,
        Parrot_default_add_parent,
        Parrot_default_add_role,
        Parrot_default_assign_pmc,
        Parrot_default_assign_string_native,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_can,
        Parrot_default_class_type,
        Parrot_ResizableIntegerArray_clone,
        Parrot_default_clone_pmc,
        Parrot_default_decrement,
        Parrot_default_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_default_delete_keyed,
        Parrot_default_delete_keyed_int,
        Parrot_default_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_FixedIntegerArray_destroy,
        Parrot_default_does,
        Parrot_FixedIntegerArray_elements,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_default_find_method,
        Parrot_FixedIntegerArray_freeze,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_FixedIntegerArray_get_bool,
        Parrot_default_get_class,
        Parrot_FixedIntegerArray_get_integer,
        Parrot_FixedIntegerArray_get_integer_keyed,
        Parrot_ResizableIntegerArray_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_iter,
        Parrot_default_get_number,
        Parrot_FixedIntegerArray_get_number_keyed,
        Parrot_FixedIntegerArray_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_FixedIntegerArray_get_pmc_keyed,
        Parrot_FixedIntegerArray_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_FixedIntegerArray_get_repr,
        Parrot_default_get_string,
        Parrot_FixedIntegerArray_get_string_keyed,
        Parrot_FixedIntegerArray_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_default_hash,
        Parrot_default_i_absolute,
        Parrot_default_i_bitwise_not,
        Parrot_default_i_bitwise_nots,
        Parrot_default_i_logical_not,
        Parrot_default_i_neg,
        Parrot_default_increment,
        Parrot_FixedIntegerArray_init,
        Parrot_default_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_default_instantiate,
        Parrot_default_invoke,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_logical_not,
        Parrot_default_mark,
        Parrot_FixedIntegerArray_morph,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_FixedIntegerArray_new_from_string,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_pmc_namespace,
        Parrot_default_pop_float,
        Parrot_ResizableIntegerArray_pop_integer,
        Parrot_default_pop_pmc,
        Parrot_default_pop_string,
        Parrot_default_push_float,
        Parrot_ResizableIntegerArray_push_integer,
        Parrot_default_push_pmc,
        Parrot_default_push_string,
        Parrot_default_remove_attribute,
        Parrot_default_remove_method,
        Parrot_default_remove_parent,
        Parrot_default_remove_role,
        Parrot_default_set_attr,
        Parrot_default_set_attr_str,
        Parrot_default_set_bignum_int,
        Parrot_default_set_bignum_num,
        Parrot_default_set_bignum_str,
        Parrot_default_set_bool,
        Parrot_FixedIntegerArray_set_integer_keyed,
        Parrot_ResizableIntegerArray_set_integer_keyed_int,
        Parrot_default_set_integer_keyed_str,
        Parrot_ResizableIntegerArray_set_integer_native,
        Parrot_default_set_integer_same,
        Parrot_FixedIntegerArray_set_number_keyed,
        Parrot_FixedIntegerArray_set_number_keyed_int,
        Parrot_default_set_number_keyed_str,
        Parrot_default_set_number_native,
        Parrot_default_set_number_same,
        Parrot_default_set_pmc,
        Parrot_FixedIntegerArray_set_pmc_keyed,
        Parrot_FixedIntegerArray_set_pmc_keyed_int,
        Parrot_default_set_pmc_keyed_str,
        Parrot_default_set_pointer,
        Parrot_default_set_pointer_keyed,
        Parrot_default_set_pointer_keyed_int,
        Parrot_default_set_pointer_keyed_str,
        Parrot_FixedIntegerArray_set_string_keyed,
        Parrot_FixedIntegerArray_set_string_keyed_int,
        Parrot_default_set_string_keyed_str,
        Parrot_default_set_string_native,
        Parrot_default_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_default_shift_float,
        Parrot_ResizableIntegerArray_shift_integer,
        Parrot_default_shift_pmc,
        Parrot_default_shift_string,
        Parrot_default_slice,
        Parrot_default_splice,
        Parrot_default_subclass,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtype,
        Parrot_FixedIntegerArray_thaw,
        Parrot_default_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_type_keyed_int,
        Parrot_default_type_keyed_str,
        Parrot_default_unshift_float,
        Parrot_ResizableIntegerArray_unshift_integer,
        Parrot_default_unshift_pmc,
        Parrot_default_unshift_string,
        Parrot_FixedIntegerArray_visit
    };

    const VTABLE temp_ro_vtable = {
        NULL, /* namespace */
        enum_class_ResizableIntegerArray, /* base_type */
        NULL, /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_IS_READONLY_FLAG, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        NULL,   /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_ResizableIntegerArray_ro_add_attribute,
        Parrot_ResizableIntegerArray_ro_add_method,
        Parrot_ResizableIntegerArray_ro_add_parent,
        Parrot_ResizableIntegerArray_ro_add_role,
        Parrot_ResizableIntegerArray_ro_assign_pmc,
        Parrot_ResizableIntegerArray_ro_assign_string_native,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_can,
        Parrot_default_class_type,
        Parrot_ResizableIntegerArray_clone,
        Parrot_default_clone_pmc,
        Parrot_ResizableIntegerArray_ro_decrement,
        Parrot_default_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_ResizableIntegerArray_ro_delete_keyed,
        Parrot_ResizableIntegerArray_ro_delete_keyed_int,
        Parrot_ResizableIntegerArray_ro_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_FixedIntegerArray_destroy,
        Parrot_default_does,
        Parrot_FixedIntegerArray_elements,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_ResizableIntegerArray_ro_find_method,
        Parrot_FixedIntegerArray_freeze,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_FixedIntegerArray_get_bool,
        Parrot_default_get_class,
        Parrot_FixedIntegerArray_get_integer,
        Parrot_FixedIntegerArray_get_integer_keyed,
        Parrot_ResizableIntegerArray_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_iter,
        Parrot_default_get_number,
        Parrot_FixedIntegerArray_get_number_keyed,
        Parrot_FixedIntegerArray_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_FixedIntegerArray_get_pmc_keyed,
        Parrot_FixedIntegerArray_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_FixedIntegerArray_get_repr,
        Parrot_default_get_string,
        Parrot_FixedIntegerArray_get_string_keyed,
        Parrot_FixedIntegerArray_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_default_hash,
        Parrot_ResizableIntegerArray_ro_i_absolute,
        Parrot_ResizableIntegerArray_ro_i_bitwise_not,
        Parrot_ResizableIntegerArray_ro_i_bitwise_nots,
        Parrot_ResizableIntegerArray_ro_i_logical_not,
        Parrot_ResizableIntegerArray_ro_i_neg,
        Parrot_ResizableIntegerArray_ro_increment,
        Parrot_FixedIntegerArray_init,
        Parrot_default_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_default_instantiate,
        Parrot_default_invoke,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_logical_not,
        Parrot_default_mark,
        Parrot_ResizableIntegerArray_ro_morph,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_FixedIntegerArray_new_from_string,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_pmc_namespace,
        Parrot_ResizableIntegerArray_ro_pop_float,
        Parrot_ResizableIntegerArray_ro_pop_integer,
        Parrot_ResizableIntegerArray_ro_pop_pmc,
        Parrot_ResizableIntegerArray_ro_pop_string,
        Parrot_ResizableIntegerArray_ro_push_float,
        Parrot_ResizableIntegerArray_ro_push_integer,
        Parrot_ResizableIntegerArray_ro_push_pmc,
        Parrot_ResizableIntegerArray_ro_push_string,
        Parrot_ResizableIntegerArray_ro_remove_attribute,
        Parrot_ResizableIntegerArray_ro_remove_method,
        Parrot_ResizableIntegerArray_ro_remove_parent,
        Parrot_ResizableIntegerArray_ro_remove_role,
        Parrot_ResizableIntegerArray_ro_set_attr,
        Parrot_ResizableIntegerArray_ro_set_attr_str,
        Parrot_ResizableIntegerArray_ro_set_bignum_int,
        Parrot_ResizableIntegerArray_ro_set_bignum_num,
        Parrot_ResizableIntegerArray_ro_set_bignum_str,
        Parrot_ResizableIntegerArray_ro_set_bool,
        Parrot_ResizableIntegerArray_ro_set_integer_keyed,
        Parrot_ResizableIntegerArray_ro_set_integer_keyed_int,
        Parrot_ResizableIntegerArray_ro_set_integer_keyed_str,
        Parrot_ResizableIntegerArray_ro_set_integer_native,
        Parrot_ResizableIntegerArray_ro_set_integer_same,
        Parrot_ResizableIntegerArray_ro_set_number_keyed,
        Parrot_ResizableIntegerArray_ro_set_number_keyed_int,
        Parrot_ResizableIntegerArray_ro_set_number_keyed_str,
        Parrot_ResizableIntegerArray_ro_set_number_native,
        Parrot_ResizableIntegerArray_ro_set_number_same,
        Parrot_ResizableIntegerArray_ro_set_pmc,
        Parrot_ResizableIntegerArray_ro_set_pmc_keyed,
        Parrot_ResizableIntegerArray_ro_set_pmc_keyed_int,
        Parrot_ResizableIntegerArray_ro_set_pmc_keyed_str,
        Parrot_ResizableIntegerArray_ro_set_pointer,
        Parrot_ResizableIntegerArray_ro_set_pointer_keyed,
        Parrot_ResizableIntegerArray_ro_set_pointer_keyed_int,
        Parrot_ResizableIntegerArray_ro_set_pointer_keyed_str,
        Parrot_ResizableIntegerArray_ro_set_string_keyed,
        Parrot_ResizableIntegerArray_ro_set_string_keyed_int,
        Parrot_ResizableIntegerArray_ro_set_string_keyed_str,
        Parrot_ResizableIntegerArray_ro_set_string_native,
        Parrot_ResizableIntegerArray_ro_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_ResizableIntegerArray_ro_shift_float,
        Parrot_ResizableIntegerArray_ro_shift_integer,
        Parrot_ResizableIntegerArray_ro_shift_pmc,
        Parrot_ResizableIntegerArray_ro_shift_string,
        Parrot_default_slice,
        Parrot_ResizableIntegerArray_ro_splice,
        Parrot_default_subclass,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtype,
        Parrot_ResizableIntegerArray_ro_thaw,
        Parrot_ResizableIntegerArray_ro_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_type_keyed_int,
        Parrot_default_type_keyed_str,
        Parrot_ResizableIntegerArray_ro_unshift_float,
        Parrot_ResizableIntegerArray_ro_unshift_integer,
        Parrot_ResizableIntegerArray_ro_unshift_pmc,
        Parrot_ResizableIntegerArray_ro_unshift_string,
        Parrot_FixedIntegerArray_visit
    };
    if (pass == 0) {
        /*
         * create vtable - clone it - we have to set a few items
         */
        VTABLE *vt_clone =
            Parrot_clone_vtable(interp, &temp_base_vtable);
        VTABLE *vt_ro_clone =
            Parrot_clone_vtable(interp, &temp_ro_vtable);
        vt_clone->whoami = CONST_STRING(interp, "ResizableIntegerArray");
        vt_clone->isa_str = CONST_STRING(interp, "ResizableIntegerArray FixedIntegerArray");
        vt_clone->does_str = CONST_STRING(interp, "array");
        vt_ro_clone->base_type = entry;
        vt_ro_clone->whoami = vt_clone->whoami;
        vt_ro_clone->isa_str = vt_clone->isa_str;
        vt_ro_clone->does_str = vt_clone->does_str;
        vt_clone->ro_variant_vtable = vt_ro_clone;
        vt_ro_clone->ro_variant_vtable = vt_clone;
        interp->vtables[entry] = vt_clone;
    }
    else { /* pass */
        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        /* create PMC Proxy object */
        Parrot_create_pmc_proxy(interp, entry);
        /* class_init */
        {
        }
    } /* pass */
} /* Parrot_ResizableIntegerArray_class_init */


/*

=back

=head1 SEE ALSO

F<docs/pdds/pdd17_basic_types.pod>.

=head1 HISTORY

Initial version                  - Matt Fowles 2004-06-11
Changed allocator to double size - Matt Fowles 2004-06-15
Added push_integer               - Bernhard Schmalhofer 2004-10-17
moved available size to int_val2 - Matt Fowles 2005-07-22

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
