/*
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/resizablestringarray.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

#line 1 "./src/pmc/resizablestringarray.pmc"
/*
Copyright (C) 2001-2005, The Perl Foundation.
$Id: resizablestringarray.pmc 18394 2007-05-02 06:53:54Z chromatic $

=head1 NAME

src/pmc/resizablestringarray.pmc - resizable array for strings only

=head1 DESCRIPTION

ResizableStringArray implements a resizeable array which stores Parrot
strings only. Any ints or floats assigned to elements of the array will
first be converted to String PMCs and then to native Parrot strings.
PMCs assigned to to elements of the array will be stringified by having
their C<get_string> method called.

=head2 Functions

=over 4

=cut

*/

#include "parrot/parrot.h"

#line 39 "src/pmc/resizablestringarray.c"
#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_resizablestringarray.h"
#include "pmc_fixedstringarray.h"
#include "pmc_default.h"
#include "resizablestringarray.str"

PMC*
Parrot_ResizableStringArray_clone(Interp *interp, PMC* pmc)
#line 247 "./src/pmc/resizablestringarray.pmc"
{
    PMC *copy = Parrot_FixedStringArray_clone(interp, pmc);
    /* copy trimmed extra space */
    PMC_int_val2(copy) = PMC_int_val(pmc);
    return copy;

}
#line 58 "src/pmc/resizablestringarray.c"
void
Parrot_ResizableStringArray_delete_keyed(Interp *interp, PMC* pmc, PMC *key)
#line 532 "./src/pmc/resizablestringarray.pmc"
{
    INTVAL   idx  = key_integer(interp, key);
    STRING **data = PMC_data_typed(pmc, STRING **);
    INTVAL   size = PMC_int_val(pmc);
    INTVAL   i;

    for (i = idx; i < size - 1; ++i)
        data[i] = data[i + 1];

     VTABLE_set_integer_native(interp, pmc, size - 1);

}
#line 74 "src/pmc/resizablestringarray.c"
void
Parrot_ResizableStringArray_delete_keyed_int(Interp *interp, PMC* pmc, INTVAL key)
#line 511 "./src/pmc/resizablestringarray.pmc"
{
    STRING **data = PMC_data_typed(pmc, STRING **);
    INTVAL   size = PMC_int_val(pmc);
    INTVAL   i;

    for (i = key; i < size - 1; ++i)
        data[i] = data[i + 1];

     VTABLE_set_integer_native(interp, pmc, size - 1);

}
#line 89 "src/pmc/resizablestringarray.c"
STRING*
Parrot_ResizableStringArray_get_string_keyed_int(Interp *interp, PMC* pmc, INTVAL key)
#line 39 "./src/pmc/resizablestringarray.pmc"
{
    STRING **data;
    if (key < 0)
    {
        INTVAL size =  VTABLE_elements(interp, pmc);
        if (key < -size)
            real_exception(interp, NULL, E_IndexError,
                "ResizableStringArray: index out of bounds!");
        else
            key += size;
    }
    if (key >= PMC_int_val(pmc))
         VTABLE_set_integer_native(interp, pmc, key+1);

    data = (STRING**)PMC_data(pmc);
    return data[key];

}
#line 111 "src/pmc/resizablestringarray.c"
FLOATVAL
Parrot_ResizableStringArray_pop_float(Interp *interp, PMC* pmc)
#line 171 "./src/pmc/resizablestringarray.pmc"
{
    PMC     *pmcval =  VTABLE_pop_pmc(interp, pmc);
    FLOATVAL value  = VTABLE_get_number(interp, pmcval);
    return value;

}
#line 121 "src/pmc/resizablestringarray.c"
INTVAL
Parrot_ResizableStringArray_pop_integer(Interp *interp, PMC* pmc)
#line 155 "./src/pmc/resizablestringarray.pmc"
{
    PMC   *pmcval =  VTABLE_pop_pmc(interp, pmc);
    INTVAL value  = VTABLE_get_integer(interp, pmcval);
    return value;

}
#line 131 "src/pmc/resizablestringarray.c"
PMC*
Parrot_ResizableStringArray_pop_pmc(Interp *interp, PMC* pmc)
#line 136 "./src/pmc/resizablestringarray.pmc"
{
    STRING *strval =  VTABLE_pop_string(interp, pmc);
    PMC    *value  = pmc_new(interp, enum_class_String);

    VTABLE_set_string_native(interp, value, strval);

    return value;

}
#line 144 "src/pmc/resizablestringarray.c"
STRING*
Parrot_ResizableStringArray_pop_string(Interp *interp, PMC* pmc)
#line 112 "./src/pmc/resizablestringarray.pmc"
{
    INTVAL size;
    STRING* value;

    size = PMC_int_val(pmc);
    if (size == 0) {
        real_exception(interp, NULL, E_IndexError,
                "ResizableStringArray: Can't pop from an empty array!");
    }
    value =  VTABLE_get_string_keyed_int(interp, pmc, size-1);
     VTABLE_set_integer_native(interp, pmc, size - 1);
    return value;

}
#line 162 "src/pmc/resizablestringarray.c"
void
Parrot_ResizableStringArray_push_float(Interp *interp, PMC* pmc, FLOATVAL value)
#line 378 "./src/pmc/resizablestringarray.pmc"
{
    PMC *ret;
    STRING *val;

    ret = pmc_new(interp, enum_class_String);
    VTABLE_set_number_native(interp, ret, value);
    val = VTABLE_get_string(interp, ret);
     VTABLE_push_string(interp, pmc, val);

}
#line 176 "src/pmc/resizablestringarray.c"
void
Parrot_ResizableStringArray_push_integer(Interp *interp, PMC* pmc, INTVAL value)
#line 357 "./src/pmc/resizablestringarray.pmc"
{
    PMC *ret;
    STRING *val;

    ret = pmc_new(interp, enum_class_String);
    VTABLE_set_integer_native(interp, ret, value);
    val = VTABLE_get_string(interp, ret);
     VTABLE_push_string(interp, pmc, val);

}
#line 190 "src/pmc/resizablestringarray.c"
void
Parrot_ResizableStringArray_push_pmc(Interp *interp, PMC* pmc, PMC *value)
#line 341 "./src/pmc/resizablestringarray.pmc"
{
    STRING *strvalue = VTABLE_get_string(interp, value);
     VTABLE_push_string(interp, pmc, strvalue);

}
#line 199 "src/pmc/resizablestringarray.c"
void
Parrot_ResizableStringArray_push_string(Interp *interp, PMC* pmc, STRING* value)
#line 97 "./src/pmc/resizablestringarray.pmc"
{
    INTVAL nextix =  VTABLE_elements(interp, pmc);
     VTABLE_set_string_keyed_int(interp, pmc, nextix, value);

}
#line 208 "src/pmc/resizablestringarray.c"
void
Parrot_ResizableStringArray_set_integer_native(Interp *interp, PMC* pmc, INTVAL size)
#line 187 "./src/pmc/resizablestringarray.pmc"
{
    if (size < 0)
        real_exception(interp, NULL, E_IndexError,
                "ResizableStringArray: Can't resize!");

    if (!PMC_data(pmc)) {
        /* empty - used fixed routine */
        if (size < 8) {
            Parrot_FixedStringArray_set_integer_native(interp, pmc, 8);
            PMC_int_val(pmc) = size;
            PMC_int_val2(pmc) = 8;
        }
        else {
            Parrot_FixedStringArray_set_integer_native(interp, pmc, size);
            PMC_int_val2(pmc) = size;
        }
    }
    else if (size <= PMC_int_val2(pmc)) {
        /* zero out anything that was previously allocated
         * if we're growing the array */
        INTVAL oldsize = PMC_int_val(pmc);
        if (size > oldsize) {
            STRING **data   = (STRING**)PMC_data(pmc);
            INTVAL i;
            for (i=oldsize; i<size; i++)
                data[i] = NULL;
        }

        PMC_int_val(pmc) = size;
        /* we could shrink here if necessary */
        return;
    }
    else {
        INTVAL i, cur;
        i = cur = PMC_int_val2(pmc);
        if (cur < 8192)
            cur = size < 2 * cur ? 2 * cur : size;
        else {
            cur = size + 4096;
            cur &= ~0xfff;
        }
        PMC_data(pmc) = mem_sys_realloc(PMC_data(pmc),
                cur * sizeof (STRING*));
        for (; i < cur; i++)
            ((STRING**)PMC_data(pmc))[i] = NULL;
        PMC_int_val2(pmc) = cur;
        PMC_int_val(pmc) = size;
    }

}
#line 262 "src/pmc/resizablestringarray.c"
void
Parrot_ResizableStringArray_set_string_keyed_int(Interp *interp, PMC* pmc, INTVAL key, STRING* value)
#line 67 "./src/pmc/resizablestringarray.pmc"
{
    STRING **data;
    if (key < 0)
    {
        INTVAL size =  VTABLE_elements(interp, pmc);
        if (key < -size)
            real_exception(interp, NULL, E_IndexError,
                "ResizableStringArray: index out of bounds!");
        else
            key += size;
    }
    if (key >= PMC_int_val(pmc))
         VTABLE_set_integer_native(interp, pmc, key+1);

    data = (STRING**)PMC_data(pmc);
    DOD_WRITE_BARRIER(interp, pmc, data[key], value);
    data[key] = value;

}
#line 285 "src/pmc/resizablestringarray.c"
FLOATVAL
Parrot_ResizableStringArray_shift_float(Interp *interp, PMC* pmc)
#line 323 "./src/pmc/resizablestringarray.pmc"
{
    PMC     *pmcval =  VTABLE_shift_pmc(interp, pmc);
    FLOATVAL value  = VTABLE_get_number(interp, pmcval);
    return value;

}
#line 295 "src/pmc/resizablestringarray.c"
INTVAL
Parrot_ResizableStringArray_shift_integer(Interp *interp, PMC* pmc)
#line 307 "./src/pmc/resizablestringarray.pmc"
{
    PMC   *pmcval =  VTABLE_shift_pmc(interp, pmc);
    INTVAL value  = VTABLE_get_integer(interp, pmcval);
    return value;

}
#line 305 "src/pmc/resizablestringarray.c"
PMC*
Parrot_ResizableStringArray_shift_pmc(Interp *interp, PMC* pmc)
#line 398 "./src/pmc/resizablestringarray.pmc"
{
    INTVAL size;
    PMC *ret;
    STRING* value;

    size = PMC_int_val(pmc);
    if (size == 0)
        real_exception(interp, NULL, E_IndexError,
                "ResizableStringArray: Can't shift from an empty array!");

    value =  VTABLE_get_string_keyed_int(interp, pmc, 0);
    ret = pmc_new(interp, enum_class_String);
    VTABLE_set_string_native(interp, ret, value);
     VTABLE_delete_keyed_int(interp, pmc, 0);
    return ret;

}
#line 326 "src/pmc/resizablestringarray.c"
STRING*
Parrot_ResizableStringArray_shift_string(Interp *interp, PMC* pmc)
#line 264 "./src/pmc/resizablestringarray.pmc"
{
    INTVAL size;
    STRING* value;

    size = PMC_int_val(pmc);
    if (size == 0)
        real_exception(interp, NULL, E_IndexError,
                "ResizableStringArray: Can't shift from an empty array!");

    value =  VTABLE_get_string_keyed_int(interp, pmc, 0);
     VTABLE_delete_keyed_int(interp, pmc, 0);
    return value;

}
#line 344 "src/pmc/resizablestringarray.c"
void
Parrot_ResizableStringArray_splice(Interp *interp, PMC* pmc, PMC* value, INTVAL offset, INTVAL count)
#line 560 "./src/pmc/resizablestringarray.pmc"
{
    INTVAL length, elems, shift, i;

    if (value->vtable->base_type != pmc->vtable->base_type &&
            value->vtable->base_type != enum_class_FixedStringArray)
        real_exception(interp, NULL, E_TypeError,
                "ResizableStringArray: illegal type for splice!");

    length = VTABLE_elements(interp, pmc);
    elems  = VTABLE_elements(interp, value);
    shift  = elems - count;

    /* start from end? */
    if (offset < 0)
        offset += length;
    if (offset < 0)
        internal_exception(OUT_OF_BOUNDS, "illegal splice offset\n");

    /* shrink the array */
    if (shift < 0) {
        /* start at offset so we don't overwrite values we'll need */
        for (i=offset+count; i<length; i++)
            VTABLE_set_pmc_keyed_int(interp, pmc, i + shift,
                VTABLE_get_pmc_keyed_int(interp, pmc, i));

         VTABLE_set_integer_native(interp, pmc, length + shift);
    }
    /* grow the array */
    else if (shift > 0) {
         VTABLE_set_integer_native(interp, pmc, length + shift);

        /* move the existing values */
        /* start at length-1 so we don't overwrite values we'll need */
        for (i=length-1; i>=offset; i--)
            VTABLE_set_pmc_keyed_int(interp, pmc, i + shift,
                VTABLE_get_pmc_keyed_int(interp, pmc, i));
    }

    /* copy the new values */
    for (i=0; i<elems; i++)
        VTABLE_set_pmc_keyed_int(interp, pmc, i + offset,
            VTABLE_get_pmc_keyed_int(interp, value, i));

}
#line 392 "src/pmc/resizablestringarray.c"
void
Parrot_ResizableStringArray_unshift_float(Interp *interp, PMC* pmc, FLOATVAL value)
#line 491 "./src/pmc/resizablestringarray.pmc"
{
    PMC *ret;
    STRING *val;

    ret = pmc_new(interp, enum_class_String);
    VTABLE_set_number_native(interp, ret, value);
    val = VTABLE_get_string(interp, ret);
     VTABLE_unshift_string(interp, pmc, val);

}
#line 406 "src/pmc/resizablestringarray.c"
void
Parrot_ResizableStringArray_unshift_integer(Interp *interp, PMC* pmc, INTVAL value)
#line 470 "./src/pmc/resizablestringarray.pmc"
{
    PMC *ret;
    STRING *val;

    ret = pmc_new(interp, enum_class_String);
    VTABLE_set_integer_native(interp, ret, value);
    val = VTABLE_get_string(interp, ret);
     VTABLE_unshift_string(interp, pmc, val);

}
#line 420 "src/pmc/resizablestringarray.c"
void
Parrot_ResizableStringArray_unshift_pmc(Interp *interp, PMC* pmc, PMC *value)
#line 454 "./src/pmc/resizablestringarray.pmc"
{
    STRING *strvalue = VTABLE_get_string(interp, value);
     VTABLE_unshift_string(interp, pmc, strvalue);

}
#line 429 "src/pmc/resizablestringarray.c"
void
Parrot_ResizableStringArray_unshift_string(Interp *interp, PMC* pmc, STRING *value)
#line 426 "./src/pmc/resizablestringarray.pmc"
{
    STRING **data = PMC_data_typed(pmc, STRING **);
    INTVAL   size = PMC_int_val(pmc);
    INTVAL   i;

     VTABLE_set_integer_native(interp, pmc, size + 1);

    data = PMC_data_typed(pmc, STRING **);

    for (i = size; i; --i)
        data[i] = data[i - 1];

     VTABLE_set_string_keyed_int(interp, pmc, 0, value);

}
#line 449 "src/pmc/resizablestringarray.c"
void
Parrot_ResizableStringArray_ro_add_attribute(Interp *interp, PMC* pmc, STRING* name, PMC* type)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "add_attribute() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_add_method(Interp *interp, PMC* pmc, STRING* method_name, PMC* sub_pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "add_method() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_add_parent(Interp *interp, PMC* pmc, PMC* parent)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "add_parent() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_add_role(Interp *interp, PMC* pmc, PMC* role)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "add_role() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_assign_pmc(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "assign_pmc() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_assign_string_native(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "assign_string_native() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_decrement(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "decrement() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_delete_keyed(Interp *interp, PMC* pmc, PMC* key)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "delete_keyed() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_delete_keyed_int(Interp *interp, PMC* pmc, INTVAL key)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "delete_keyed_int() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_delete_keyed_str(Interp *interp, PMC* pmc, STRING* key)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "delete_keyed_str() in read-only instance of ResizableStringArray");
}
PMC*
Parrot_ResizableStringArray_ro_find_method(Interp *interp, PMC* pmc, STRING* method_name)
 {
    PMC *const method = Parrot_default_find_method(interp, pmc, method_name);
    if (!PMC_IS_NULL(VTABLE_getprop(interp, method, const_string(interp, "write"))))
        return PMCNULL;
    else
        return method;
}
void
Parrot_ResizableStringArray_ro_i_absolute(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_absolute() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_i_bitwise_not(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_bitwise_not() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_i_bitwise_nots(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_bitwise_nots() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_i_logical_not(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_logical_not() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_i_neg(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_neg() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_increment(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "increment() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_morph(Interp *interp, PMC* pmc, INTVAL type)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "morph() in read-only instance of ResizableStringArray");
}
FLOATVAL
Parrot_ResizableStringArray_ro_pop_float(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "pop_float() in read-only instance of ResizableStringArray");
    return (FLOATVAL)0;
}
INTVAL
Parrot_ResizableStringArray_ro_pop_integer(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "pop_integer() in read-only instance of ResizableStringArray");
    return (INTVAL)0;
}
PMC*
Parrot_ResizableStringArray_ro_pop_pmc(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "pop_pmc() in read-only instance of ResizableStringArray");
    return PMCNULL;
}
STRING*
Parrot_ResizableStringArray_ro_pop_string(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "pop_string() in read-only instance of ResizableStringArray");
    return (STRING*)0;
}
void
Parrot_ResizableStringArray_ro_push_float(Interp *interp, PMC* pmc, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "push_float() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_push_integer(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "push_integer() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_push_pmc(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "push_pmc() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_push_string(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "push_string() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_remove_attribute(Interp *interp, PMC* pmc, STRING* name)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "remove_attribute() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_remove_method(Interp *interp, PMC* pmc, STRING* method_name)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "remove_method() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_remove_parent(Interp *interp, PMC* pmc, PMC* parent)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "remove_parent() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_remove_role(Interp *interp, PMC* pmc, PMC* role)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "remove_role() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_set_attr(Interp *interp, PMC* pmc, INTVAL idx, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_attr() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_set_attr_str(Interp *interp, PMC* pmc, STRING* idx, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_attr_str() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_set_bignum_int(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_bignum_int() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_set_bignum_num(Interp *interp, PMC* pmc, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_bignum_num() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_set_bignum_str(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_bignum_str() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_set_bool(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_bool() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_set_integer_keyed(Interp *interp, PMC* pmc, PMC* key, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_keyed() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_set_integer_keyed_int(Interp *interp, PMC* pmc, INTVAL key, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_keyed_int() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_set_integer_keyed_str(Interp *interp, PMC* pmc, STRING* key, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_keyed_str() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_set_integer_native(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_native() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_set_integer_same(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_same() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_set_number_keyed(Interp *interp, PMC* pmc, PMC* key, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_keyed() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_set_number_keyed_int(Interp *interp, PMC* pmc, INTVAL key, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_keyed_int() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_set_number_keyed_str(Interp *interp, PMC* pmc, STRING* key, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_keyed_str() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_set_number_native(Interp *interp, PMC* pmc, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_native() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_set_number_same(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_same() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_set_pmc(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pmc() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_set_pmc_keyed(Interp *interp, PMC* pmc, PMC* key, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pmc_keyed() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_set_pmc_keyed_int(Interp *interp, PMC* pmc, INTVAL key, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_int() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_set_pmc_keyed_str(Interp *interp, PMC* pmc, STRING* key, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_str() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_set_pointer(Interp *interp, PMC* pmc, void* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pointer() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_set_pointer_keyed(Interp *interp, PMC* pmc, PMC* key, void* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pointer_keyed() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_set_pointer_keyed_int(Interp *interp, PMC* pmc, INTVAL key, void* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_int() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_set_pointer_keyed_str(Interp *interp, PMC* pmc, STRING* key, void* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_str() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_set_string_keyed(Interp *interp, PMC* pmc, PMC* key, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_keyed() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_set_string_keyed_int(Interp *interp, PMC* pmc, INTVAL key, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_keyed_int() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_set_string_keyed_str(Interp *interp, PMC* pmc, STRING* key, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_keyed_str() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_set_string_native(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_native() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_set_string_same(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_same() in read-only instance of ResizableStringArray");
}
FLOATVAL
Parrot_ResizableStringArray_ro_shift_float(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "shift_float() in read-only instance of ResizableStringArray");
    return (FLOATVAL)0;
}
INTVAL
Parrot_ResizableStringArray_ro_shift_integer(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "shift_integer() in read-only instance of ResizableStringArray");
    return (INTVAL)0;
}
PMC*
Parrot_ResizableStringArray_ro_shift_pmc(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "shift_pmc() in read-only instance of ResizableStringArray");
    return PMCNULL;
}
STRING*
Parrot_ResizableStringArray_ro_shift_string(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "shift_string() in read-only instance of ResizableStringArray");
    return (STRING*)0;
}
void
Parrot_ResizableStringArray_ro_splice(Interp *interp, PMC* pmc, PMC* value, INTVAL offset, INTVAL count)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "splice() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_thaw(Interp *interp, PMC* pmc, visit_info* info)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "thaw() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_thawfinish(Interp *interp, PMC* pmc, visit_info* info)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "thawfinish() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_unshift_float(Interp *interp, PMC* pmc, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "unshift_float() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_unshift_integer(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "unshift_integer() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_unshift_pmc(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "unshift_pmc() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_unshift_string(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "unshift_string() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_class_init(Parrot_Interp interp, int entry, int pass)
{
    const VTABLE temp_base_vtable = {
        NULL, /* namespace */
        enum_class_ResizableStringArray, /* base_type */
        NULL, /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_HAS_READONLY_FLAG, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        NULL,   /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_default_add_attribute,
        Parrot_default_add_method,
        Parrot_default_add_parent,
        Parrot_default_add_role,
        Parrot_default_assign_pmc,
        Parrot_default_assign_string_native,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_can,
        Parrot_default_class_type,
        Parrot_ResizableStringArray_clone,
        Parrot_default_clone_pmc,
        Parrot_default_decrement,
        Parrot_default_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_ResizableStringArray_delete_keyed,
        Parrot_ResizableStringArray_delete_keyed_int,
        Parrot_default_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_FixedStringArray_destroy,
        Parrot_default_does,
        Parrot_FixedStringArray_elements,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_default_find_method,
        Parrot_FixedStringArray_freeze,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_FixedStringArray_get_bool,
        Parrot_default_get_class,
        Parrot_FixedStringArray_get_integer,
        Parrot_FixedStringArray_get_integer_keyed,
        Parrot_FixedStringArray_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_iter,
        Parrot_default_get_number,
        Parrot_FixedStringArray_get_number_keyed,
        Parrot_FixedStringArray_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_FixedStringArray_get_pmc_keyed,
        Parrot_FixedStringArray_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_default_get_repr,
        Parrot_default_get_string,
        Parrot_FixedStringArray_get_string_keyed,
        Parrot_ResizableStringArray_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_default_hash,
        Parrot_default_i_absolute,
        Parrot_default_i_bitwise_not,
        Parrot_default_i_bitwise_nots,
        Parrot_default_i_logical_not,
        Parrot_default_i_neg,
        Parrot_default_increment,
        Parrot_FixedStringArray_init,
        Parrot_default_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_default_instantiate,
        Parrot_default_invoke,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_logical_not,
        Parrot_FixedStringArray_mark,
        Parrot_FixedStringArray_morph,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_new_from_string,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_pmc_namespace,
        Parrot_ResizableStringArray_pop_float,
        Parrot_ResizableStringArray_pop_integer,
        Parrot_ResizableStringArray_pop_pmc,
        Parrot_ResizableStringArray_pop_string,
        Parrot_ResizableStringArray_push_float,
        Parrot_ResizableStringArray_push_integer,
        Parrot_ResizableStringArray_push_pmc,
        Parrot_ResizableStringArray_push_string,
        Parrot_default_remove_attribute,
        Parrot_default_remove_method,
        Parrot_default_remove_parent,
        Parrot_default_remove_role,
        Parrot_default_set_attr,
        Parrot_default_set_attr_str,
        Parrot_default_set_bignum_int,
        Parrot_default_set_bignum_num,
        Parrot_default_set_bignum_str,
        Parrot_default_set_bool,
        Parrot_FixedStringArray_set_integer_keyed,
        Parrot_FixedStringArray_set_integer_keyed_int,
        Parrot_default_set_integer_keyed_str,
        Parrot_ResizableStringArray_set_integer_native,
        Parrot_default_set_integer_same,
        Parrot_FixedStringArray_set_number_keyed,
        Parrot_FixedStringArray_set_number_keyed_int,
        Parrot_default_set_number_keyed_str,
        Parrot_default_set_number_native,
        Parrot_default_set_number_same,
        Parrot_default_set_pmc,
        Parrot_FixedStringArray_set_pmc_keyed,
        Parrot_FixedStringArray_set_pmc_keyed_int,
        Parrot_default_set_pmc_keyed_str,
        Parrot_default_set_pointer,
        Parrot_default_set_pointer_keyed,
        Parrot_default_set_pointer_keyed_int,
        Parrot_default_set_pointer_keyed_str,
        Parrot_FixedStringArray_set_string_keyed,
        Parrot_ResizableStringArray_set_string_keyed_int,
        Parrot_default_set_string_keyed_str,
        Parrot_default_set_string_native,
        Parrot_default_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_ResizableStringArray_shift_float,
        Parrot_ResizableStringArray_shift_integer,
        Parrot_ResizableStringArray_shift_pmc,
        Parrot_ResizableStringArray_shift_string,
        Parrot_default_slice,
        Parrot_ResizableStringArray_splice,
        Parrot_default_subclass,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtype,
        Parrot_FixedStringArray_thaw,
        Parrot_default_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_type_keyed_int,
        Parrot_default_type_keyed_str,
        Parrot_ResizableStringArray_unshift_float,
        Parrot_ResizableStringArray_unshift_integer,
        Parrot_ResizableStringArray_unshift_pmc,
        Parrot_ResizableStringArray_unshift_string,
        Parrot_default_visit
    };

    const VTABLE temp_ro_vtable = {
        NULL, /* namespace */
        enum_class_ResizableStringArray, /* base_type */
        NULL, /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_IS_READONLY_FLAG, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        NULL,   /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_ResizableStringArray_ro_add_attribute,
        Parrot_ResizableStringArray_ro_add_method,
        Parrot_ResizableStringArray_ro_add_parent,
        Parrot_ResizableStringArray_ro_add_role,
        Parrot_ResizableStringArray_ro_assign_pmc,
        Parrot_ResizableStringArray_ro_assign_string_native,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_can,
        Parrot_default_class_type,
        Parrot_ResizableStringArray_clone,
        Parrot_default_clone_pmc,
        Parrot_ResizableStringArray_ro_decrement,
        Parrot_default_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_ResizableStringArray_ro_delete_keyed,
        Parrot_ResizableStringArray_ro_delete_keyed_int,
        Parrot_ResizableStringArray_ro_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_FixedStringArray_destroy,
        Parrot_default_does,
        Parrot_FixedStringArray_elements,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_ResizableStringArray_ro_find_method,
        Parrot_FixedStringArray_freeze,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_FixedStringArray_get_bool,
        Parrot_default_get_class,
        Parrot_FixedStringArray_get_integer,
        Parrot_FixedStringArray_get_integer_keyed,
        Parrot_FixedStringArray_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_iter,
        Parrot_default_get_number,
        Parrot_FixedStringArray_get_number_keyed,
        Parrot_FixedStringArray_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_FixedStringArray_get_pmc_keyed,
        Parrot_FixedStringArray_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_default_get_repr,
        Parrot_default_get_string,
        Parrot_FixedStringArray_get_string_keyed,
        Parrot_ResizableStringArray_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_default_hash,
        Parrot_ResizableStringArray_ro_i_absolute,
        Parrot_ResizableStringArray_ro_i_bitwise_not,
        Parrot_ResizableStringArray_ro_i_bitwise_nots,
        Parrot_ResizableStringArray_ro_i_logical_not,
        Parrot_ResizableStringArray_ro_i_neg,
        Parrot_ResizableStringArray_ro_increment,
        Parrot_FixedStringArray_init,
        Parrot_default_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_default_instantiate,
        Parrot_default_invoke,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_logical_not,
        Parrot_FixedStringArray_mark,
        Parrot_ResizableStringArray_ro_morph,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_new_from_string,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_pmc_namespace,
        Parrot_ResizableStringArray_ro_pop_float,
        Parrot_ResizableStringArray_ro_pop_integer,
        Parrot_ResizableStringArray_ro_pop_pmc,
        Parrot_ResizableStringArray_ro_pop_string,
        Parrot_ResizableStringArray_ro_push_float,
        Parrot_ResizableStringArray_ro_push_integer,
        Parrot_ResizableStringArray_ro_push_pmc,
        Parrot_ResizableStringArray_ro_push_string,
        Parrot_ResizableStringArray_ro_remove_attribute,
        Parrot_ResizableStringArray_ro_remove_method,
        Parrot_ResizableStringArray_ro_remove_parent,
        Parrot_ResizableStringArray_ro_remove_role,
        Parrot_ResizableStringArray_ro_set_attr,
        Parrot_ResizableStringArray_ro_set_attr_str,
        Parrot_ResizableStringArray_ro_set_bignum_int,
        Parrot_ResizableStringArray_ro_set_bignum_num,
        Parrot_ResizableStringArray_ro_set_bignum_str,
        Parrot_ResizableStringArray_ro_set_bool,
        Parrot_ResizableStringArray_ro_set_integer_keyed,
        Parrot_ResizableStringArray_ro_set_integer_keyed_int,
        Parrot_ResizableStringArray_ro_set_integer_keyed_str,
        Parrot_ResizableStringArray_ro_set_integer_native,
        Parrot_ResizableStringArray_ro_set_integer_same,
        Parrot_ResizableStringArray_ro_set_number_keyed,
        Parrot_ResizableStringArray_ro_set_number_keyed_int,
        Parrot_ResizableStringArray_ro_set_number_keyed_str,
        Parrot_ResizableStringArray_ro_set_number_native,
        Parrot_ResizableStringArray_ro_set_number_same,
        Parrot_ResizableStringArray_ro_set_pmc,
        Parrot_ResizableStringArray_ro_set_pmc_keyed,
        Parrot_ResizableStringArray_ro_set_pmc_keyed_int,
        Parrot_ResizableStringArray_ro_set_pmc_keyed_str,
        Parrot_ResizableStringArray_ro_set_pointer,
        Parrot_ResizableStringArray_ro_set_pointer_keyed,
        Parrot_ResizableStringArray_ro_set_pointer_keyed_int,
        Parrot_ResizableStringArray_ro_set_pointer_keyed_str,
        Parrot_ResizableStringArray_ro_set_string_keyed,
        Parrot_ResizableStringArray_ro_set_string_keyed_int,
        Parrot_ResizableStringArray_ro_set_string_keyed_str,
        Parrot_ResizableStringArray_ro_set_string_native,
        Parrot_ResizableStringArray_ro_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_ResizableStringArray_ro_shift_float,
        Parrot_ResizableStringArray_ro_shift_integer,
        Parrot_ResizableStringArray_ro_shift_pmc,
        Parrot_ResizableStringArray_ro_shift_string,
        Parrot_default_slice,
        Parrot_ResizableStringArray_ro_splice,
        Parrot_default_subclass,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtype,
        Parrot_ResizableStringArray_ro_thaw,
        Parrot_ResizableStringArray_ro_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_type_keyed_int,
        Parrot_default_type_keyed_str,
        Parrot_ResizableStringArray_ro_unshift_float,
        Parrot_ResizableStringArray_ro_unshift_integer,
        Parrot_ResizableStringArray_ro_unshift_pmc,
        Parrot_ResizableStringArray_ro_unshift_string,
        Parrot_default_visit
    };
    if (pass == 0) {
        /*
         * create vtable - clone it - we have to set a few items
         */
        VTABLE *vt_clone =
            Parrot_clone_vtable(interp, &temp_base_vtable);
        VTABLE *vt_ro_clone =
            Parrot_clone_vtable(interp, &temp_ro_vtable);
        vt_clone->whoami = CONST_STRING(interp, "ResizableStringArray");
        vt_clone->isa_str = CONST_STRING(interp, "ResizableStringArray FixedStringArray");
        vt_clone->does_str = CONST_STRING(interp, "array");
        vt_ro_clone->base_type = entry;
        vt_ro_clone->whoami = vt_clone->whoami;
        vt_ro_clone->isa_str = vt_clone->isa_str;
        vt_ro_clone->does_str = vt_clone->does_str;
        vt_clone->ro_variant_vtable = vt_ro_clone;
        vt_ro_clone->ro_variant_vtable = vt_clone;
        interp->vtables[entry] = vt_clone;
    }
    else { /* pass */
        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        /* create PMC Proxy object */
        Parrot_create_pmc_proxy(interp, entry);
        /* class_init */
        {
        }
    } /* pass */
} /* Parrot_ResizableStringArray_class_init */




/*

=back

=head1 SEE ALSO

F<docs/pdds/pdd17_basic_types.pod>.

=head1 HISTORY

Initial version                  - Matt Fowles 2004-06-11
Changed allocator to double size - Matt Fowles 2004-06-15
Added push_string                - Bernhard Schmalhofer 2004-10-17
moved available size to int_val2 - Matt Fowles 2005-07-22

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
