/*
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/role.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

#line 1 "./src/pmc/role.pmc"
/*
Copyright (C) 2001-2007, The Perl Foundation.
$Id: role.pmc 18582 2007-05-18 01:59:37Z chromatic $

=head1 NAME

src/pmc/role.pmc - Role - defines a role

=head1 DESCRIPTION

This class implements the Role PMC, a unit of class composition as outlined in
F<docs/pdds/pdd15_objects.pod>.

Role is not derived from any other PMC.

=head2 Structure

The Role PMC structure (C<Parrot_Role>) consists of five items:

=over 4

=item C<name>

The name of the role -- a STRING.
An empty STRING is allocated during initialization.

=item C<namespace>

The namespace the role is associated with, if any.
A Null PMC is allocated during initialization.

=item C<roles>

The list of roles from which this role is composed, if any.
An empty ResizablePMCArray is allocated during initialization.

=item C<methods>

The directory of method names and methods this role implements.
An empty Hash PMC is allocated during initialization.

=item C<attrib_metadata>

The directory of attribute names and attribute metadata this role contains.
An empty Hash PMC is allocated during initialization.

=cut

*/

#include "parrot/parrot.h"
#define PARROT_ROLE(o) ((Parrot_Role *) PMC_data(o))

/* This is the underlying structure of this PMC. */
typedef struct Parrot_Role {
    STRING *name;         /* The name of the role. */
    PMC *_namespace;      /* The namespace it's linked to, if any. */
    PMC *roles;           /* Any roles that this role is composed from. */
    PMC *methods;         /* Hash of method names to methods in this role. */
    PMC *attrib_metadata; /* Hash of attributes in this role to hashes of metadata. */
} Parrot_Role;


/* Takes a hash and initializes the role based on it. */
static void init_role_from_hash(Parrot_Interp interp, PMC *self, PMC *info)
{
    Parrot_Role *role = PARROT_ROLE(self);
    int have_name, have_ns;
    PMC *old_ns;
    int i;

    /* Ensure we actually have some initialization info. */
    if (PMC_IS_NULL(info))
        return;

    /* Check if we have a name and/or a namespace. */
    have_name = VTABLE_exists_keyed_str(interp, info,
        string_from_const_cstring(interp, "name", 0));
    have_ns = VTABLE_exists_keyed_str(interp, info,
        string_from_const_cstring(interp, "namespace", 0));

    /* Take a copy of the current namespace the role is attached to. */
    old_ns = role->_namespace;

    /* Let's roll (no pun intended!) If we have a namespace and a name,
     * set both. */
    if (have_name && have_ns) {
        /* If we weren't passed a NameSpace PMC, assume it's something we have
         * to look one up with and do so. */
        PMC *_namespace = VTABLE_get_pmc_keyed_str(interp, info,
            string_from_const_cstring(interp, "namespace", 0));
        if (!VTABLE_isa(interp, _namespace, string_from_const_cstring(interp, "NameSpace", 0)))
            _namespace = Parrot_make_namespace_autobase(interp, _namespace);

        /* If we get something null back it's an error; otherwise, store it. */
        if (!PMC_IS_NULL(_namespace))
            role->_namespace = _namespace;
        else
            real_exception(interp, NULL, E_NameError, "Namespace not found");

        /* Set a (string) name. */
        role->name = VTABLE_get_string_keyed_str(interp, info,
            string_from_const_cstring(interp, "name", 0));
    }

    /* Otherwise, we may just have a name. */
    else if (have_name) {
        /* Set the name. */
        role->name = VTABLE_get_string_keyed_str(interp, info,
            string_from_const_cstring(interp, "name", 0));

        /* Namespace is nested in the current namespace and with the name of
         * the role. */
        role->_namespace = Parrot_make_namespace_keyed_str(interp,
            CONTEXT(interp->ctx)->current_namespace, role->name);
    }

    /* Otherwise, we may just have a namespace. */
    else if (have_ns) {
        /* If we weren't passed a NameSpace PMC, assume it's something we have
         * to look one up with and do so. */
        PMC *_namespace = VTABLE_get_pmc_keyed_str(interp, info,
            string_from_const_cstring(interp, "namespace", 0));
        if (!VTABLE_isa(interp, _namespace, string_from_const_cstring(interp, "NameSpace", 0)))
            _namespace = Parrot_make_namespace_autobase(interp, _namespace);

        /* If we get something null back it's an error; otherwise, store it. */
        if (!PMC_IS_NULL(_namespace))
            role->_namespace = _namespace;
        else
            real_exception(interp, NULL, E_NameError, "Namespace not found");

        /* Name is that of the most nested part of the namespace. */
        role->name = VTABLE_get_string(interp, _namespace);
    }

    /* If we were attached to a namespce and are now attached to a new one,
     * need to unset ourselves in the old namespace. */
    if (!PMC_IS_NULL(old_ns) && role->_namespace != old_ns)
        Parrot_PCCINVOKE(interp, old_ns,
            string_from_const_cstring(interp, "set_class", 0),
            "P->", PMCNULL);

    /* Link namespace to this role, if there is one. */
    if (!PMC_IS_NULL(role->_namespace))
        Parrot_PCCINVOKE(interp, role->_namespace,
            string_from_const_cstring(interp, "set_class", 0),
            "P->", self);

    /* Initialize roles, if we have any. */
    if (VTABLE_exists_keyed_str(interp, info,
        string_from_const_cstring(interp, "roles", 0))) {
        /* Loop over roles array and compose them. */
        PMC *role_list = VTABLE_get_pmc_keyed_str(interp, info,
            string_from_const_cstring(interp, "roles", 0));
        int role_count = VTABLE_elements(interp, role_list);
        for (i = 0; i < role_count; i++) {
            PMC *cur_role = VTABLE_get_pmc_keyed_int(interp, role_list, i);
            VTABLE_add_role(interp, self, cur_role);
        }
    }

    /* Initialize attributes, if we have any. */
    if (VTABLE_exists_keyed_str(interp, info,
        string_from_const_cstring(interp, "attributes", 0))) {
        /* Loop over attributes array and add them. */
        PMC *attrib_name_list = VTABLE_get_pmc_keyed_str(interp, info,
            string_from_const_cstring(interp, "attributes", 0));
        int attrib_count = VTABLE_elements(interp, attrib_name_list);
        for (i = 0; i < attrib_count; i++) {
            STRING *attrib_name = VTABLE_get_string_keyed_int(interp,
                attrib_name_list, i);
            VTABLE_add_attribute(interp, self, attrib_name, PMCNULL);
        }
    }

    /* Initialize methods, if we have any. */
    if (VTABLE_exists_keyed_str(interp, info,
        string_from_const_cstring(interp, "methods", 0))) {
        /* Get the methods hash. */
        PMC *methods = VTABLE_get_pmc_keyed_str(interp, info,
            string_from_const_cstring(interp, "methods", 0));

        /* Iterate over the list of methods. */
        PMC *iter = VTABLE_get_iter(interp, methods);
        while (VTABLE_get_bool(interp, iter)) {
            /* Add the method. */
            STRING *method_name = VTABLE_shift_string(interp, iter);
            PMC *method_pmc = VTABLE_get_pmc_keyed_str(interp, methods, method_name);
            VTABLE_add_method(interp, self, method_name, method_pmc);
        }
    }
}


/*

=back

=head2 Functions

=over 4

=cut

*/

#line 220 "src/pmc/role.c"
#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_fixedintegerarray.h"
#include "pmc_role.h"
#include "pmc_default.h"
#include "role.str"

void
Parrot_Role_add_attribute(Interp *interp, PMC* pmc, STRING *name, PMC *type)
#line 303 "./src/pmc/role.pmc"
{
    Parrot_Role *role = PARROT_ROLE(pmc);
    PMC *new_attribute = pmc_new(interp, enum_class_Hash);

    /* Set name and type. */
    VTABLE_set_string_keyed_str(interp, new_attribute, CONST_STRING(interp, "name"), name);
    if (!PMC_IS_NULL(type)) {
        VTABLE_set_pmc_keyed_str(interp, new_attribute, CONST_STRING(interp, "type"), type);
    }

    /* Enter the attribute in the attributes array. */
    VTABLE_set_pmc_keyed_str(interp, role->attrib_metadata, name, new_attribute);

}
#line 246 "src/pmc/role.c"
void
Parrot_Role_add_method(Interp *interp, PMC* pmc, STRING *name, PMC *sub)
#line 328 "./src/pmc/role.pmc"
{
    Parrot_Role *role = PARROT_ROLE(pmc);

    /* If we have already added a method with this name... */
    if (VTABLE_exists_keyed_str(interp, role->methods, name)) {
        /* XXX Need to handle multi methods here. */
        real_exception(interp, NULL, E_NotImplementedError,
            "Currently, adding multiple methods of the same name is not supported.");
    }
    else {
        /* Enter it into the table. */
        VTABLE_set_pmc_keyed_str(interp, role->methods, name, sub);
    }

}
#line 265 "src/pmc/role.c"
void
Parrot_Role_add_role(Interp *interp, PMC* pmc, PMC *role)
#line 355 "./src/pmc/role.pmc"
{
    Parrot_Role *this_role = PARROT_ROLE(pmc);

    /* Do the composition. */
    Parrot_ComposeRole(interp, role, PMCNULL, 0, PMCNULL, 0,
           this_role->methods, this_role->roles);

}
#line 277 "src/pmc/role.c"
void
Parrot_Role_destroy(Interp *interp, PMC* pmc)
#line 262 "./src/pmc/role.pmc"
{
        mem_sys_free(PMC_data(pmc));

}
#line 285 "src/pmc/role.c"
void
Parrot_Role_init(Interp *interp, PMC* pmc)
#line 226 "./src/pmc/role.pmc"
{
    Parrot_Role *role = NULL;

    /* Set flags for custom DOD mark and destroy. */
    PObj_custom_mark_SET(pmc);
    PObj_active_destroy_SET(pmc);

    /* Set up the object. */
    role                  = mem_allocate_zeroed_typed(Parrot_Role);
    role->name            = CONST_STRING(interp, "");
    role->_namespace      = PMCNULL;
    role->roles           = pmc_new(interp, enum_class_ResizablePMCArray);
    role->methods         = pmc_new(interp, enum_class_Hash);
    role->attrib_metadata = pmc_new(interp, enum_class_Hash);
    PMC_data(pmc)        = role;

}
#line 306 "src/pmc/role.c"
void
Parrot_Role_init_pmc(Interp *interp, PMC* pmc, PMC* init_data)
#line 243 "./src/pmc/role.pmc"
{
    /* Create the role. */
    Parrot_Role_init(interp, pmc);

    /* Initialize the role with the supplied data. */
    init_role_from_hash(interp, pmc, init_data);

}
#line 318 "src/pmc/role.c"
PMC*
Parrot_Role_inspect(Interp *interp, PMC* pmc)
#line 435 "./src/pmc/role.pmc"
{
    /* Create a hash, then use inspect_str to get all of the data to
     * fill it up with. */
    PMC *metadata = pmc_new(interp, enum_class_Hash);
    VTABLE_set_pmc_keyed_str(interp, metadata, CONST_STRING(interp, "name"),
        VTABLE_inspect_str(interp, pmc, CONST_STRING(interp, "name")));
    VTABLE_set_pmc_keyed_str(interp, metadata, CONST_STRING(interp, "namespace"),
        VTABLE_inspect_str(interp, pmc, CONST_STRING(interp, "namespace")));
    VTABLE_set_pmc_keyed_str(interp, metadata, CONST_STRING(interp, "attributes"),
        VTABLE_inspect_str(interp, pmc, CONST_STRING(interp, "attributes")));
    VTABLE_set_pmc_keyed_str(interp, metadata, CONST_STRING(interp, "methods"),
        VTABLE_inspect_str(interp, pmc, CONST_STRING(interp, "methods")));
    VTABLE_set_pmc_keyed_str(interp, metadata, CONST_STRING(interp, "roles"),
        VTABLE_inspect_str(interp, pmc, CONST_STRING(interp, "roles")));
    return metadata;

}
#line 339 "src/pmc/role.c"
PMC*
Parrot_Role_inspect_str(Interp *interp, PMC* pmc, STRING *what)
#line 391 "./src/pmc/role.pmc"
{
    Parrot_Role *role  = PARROT_ROLE(pmc);

    /* What should we return? */
    PMC         *found = PMCNULL;

    if (string_equal(interp, what, CONST_STRING(interp, "name")) == 0) {
        found = pmc_new(interp, enum_class_String);
        VTABLE_set_string_native(interp, found, role->name);
    }
    else if (string_equal(interp, what, CONST_STRING(interp, "namespace")) == 0) {
        /* Don't clone the namespace, as it's not part of our state. */
        return role->_namespace;
    }
    else if (string_equal(interp, what, CONST_STRING(interp, "attributes")) == 0) {
        found = role->attrib_metadata;
    }
    else if (string_equal(interp, what, CONST_STRING(interp, "methods")) == 0) {
        found = role->methods;
    }
    else if (string_equal(interp, what, CONST_STRING(interp, "roles")) == 0) {
        found = role->roles;
    }
    else {
        real_exception(interp, NULL, INVALID_OPERATION,
            "Unknown introspection value '%S'", what);
    }

    /* Clone and return. */
    return PMC_IS_NULL(found) ? PMCNULL : VTABLE_clone(interp, found);

}
#line 375 "src/pmc/role.c"
void
Parrot_Role_mark(Interp *interp, PMC* pmc)
#line 277 "./src/pmc/role.pmc"
{
    Parrot_Role *role = PARROT_ROLE(pmc);
    if (role->name)
        pobject_lives(interp, (PObj*)role->name);
    if (role->_namespace)
        pobject_lives(interp, (PObj*)role->_namespace);
    if (role->roles)
        pobject_lives(interp, (PObj*)role->roles);
    if (role->methods)
        pobject_lives(interp, (PObj*)role->methods);
    if (role->attrib_metadata)
        pobject_lives(interp, (PObj*)role->attrib_metadata);

}
#line 393 "src/pmc/role.c"
void
Parrot_Role_nci_name(Interp *interp, PMC* pmc)
{
#line 368 "/home/mandrake/rpm/BUILD/parrot-0.4.13/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    INTVAL   n_regs_used[]   = { 1, 0, 1, 1 };
    opcode_t param_indexes[] = { 0, 0, 0 };
    opcode_t *return_indexes;
    opcode_t *current_args;
    PMC* _type      = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC* param_sig  = Parrot_FixedIntegerArray_new_from_string(interp, _type,
        string_from_const_cstring(interp, "(2, 129, 256)", 0), 0);

    PMC* return_sig              = PMCNULL;

    parrot_context_t *caller_ctx = CONTEXT(interp->ctx);
    PMC* ret_cont                = new_ret_continuation_pmc(interp, NULL);
    parrot_context_t *ctx        = Parrot_push_context(interp, n_regs_used);
    PMC* ccont                   = caller_ctx->current_cont;

    ctx->current_cont            = ret_cont;
    PMC_cont(ret_cont)->from_ctx = ctx;

    current_args                 = interp->current_args;
    interp->current_args         = NULL;

    interp->params_signature     = param_sig;
    parrot_pass_args(interp, caller_ctx, ctx, current_args, param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(ccont) &= ~SUB_FLAG_TAILCALL;
        --ctx->recursion_depth;
        ctx->caller_ctx      = caller_ctx->caller_ctx;
        Parrot_free_context(interp, caller_ctx, 0);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
    PMC* pmc = CTX_REG_PMC(ctx, 0);
    STRING* name = CTX_REG_STR(ctx, 0);
    INTVAL got_name = CTX_REG_INT(ctx, 0);

    /* BEGIN PMETHOD BODY */
#line 476 "./src/pmc/role.pmc"

    Parrot_Role *role = PARROT_ROLE(pmc);
    STRING *ret_name = NULL;

    if (got_name) {
        /* We'll build a hash just containing the name, then give this to
         * init_role_from_hash - saves some code duplication. */
        PMC *naming_hash = pmc_new(interp, enum_class_Hash);
        VTABLE_set_string_keyed_str(interp, naming_hash, CONST_STRING(interp, "name"), name);
        init_role_from_hash(interp, pmc, naming_hash);
    }

    ret_name = role->name;
    {
#line 237 "/home/mandrake/rpm/BUILD/parrot-0.4.13/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
/*BEGIN PCCRETURN STRING *ret_name */
/*BEGIN GENERATED ACCESSORS */
CTX_REG_STR(ctx, 0) = ret_name;

#line 243 "/home/mandrake/rpm/BUILD/parrot-0.4.13/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
/*END GENERATED ACCESSORS */
{
    opcode_t temp_return_indexes[] = { 0 };
    return_indexes = temp_return_indexes;
}
return_sig = Parrot_FixedIntegerArray_new_from_string(interp, _type,
    string_from_const_cstring(interp, "(1)", 0), 0);
goto name_returns;
/*END PCCRETURN STRING *ret_name */
}

#line 413 "/home/mandrake/rpm/BUILD/parrot-0.4.13/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    goto no_return;
    /* END PMETHOD BODY */

name_returns:

    /* if (PMC_cont(ccont)->address) { */
    {
        /* parrot_context_t * const caller_ctx = PMC_cont(ccont)->to_ctx; */
        if (! caller_ctx) {
            /* there is no point calling real_exception here, because
               PDB_backtrace can't deal with a missing to_ctx either. */
            internal_exception(1, "No caller_ctx for continuation %p.", ccont);
        }

        interp->returns_signature = return_sig;
        parrot_pass_args(interp, ctx, caller_ctx, return_indexes,
            caller_ctx->current_results, PARROT_PASS_RESULTS);
    }

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_type);
    PObj_live_CLEAR(param_sig);
    PObj_live_CLEAR(return_sig);
    Parrot_pop_context(interp);

}
#line 502 "src/pmc/role.c"
void
Parrot_Role_nci_pmc_namespace(Interp *interp, PMC* pmc)
{
#line 368 "/home/mandrake/rpm/BUILD/parrot-0.4.13/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    INTVAL   n_regs_used[]   = { 0, 0, 0, 1 };
    opcode_t param_indexes[] = { 0 };
    opcode_t *return_indexes;
    opcode_t *current_args;
    PMC* _type      = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC* param_sig  = Parrot_FixedIntegerArray_new_from_string(interp, _type,
        string_from_const_cstring(interp, "(2)", 0), 0);

    PMC* return_sig              = PMCNULL;

    parrot_context_t *caller_ctx = CONTEXT(interp->ctx);
    PMC* ret_cont                = new_ret_continuation_pmc(interp, NULL);
    parrot_context_t *ctx        = Parrot_push_context(interp, n_regs_used);
    PMC* ccont                   = caller_ctx->current_cont;

    ctx->current_cont            = ret_cont;
    PMC_cont(ret_cont)->from_ctx = ctx;

    current_args                 = interp->current_args;
    interp->current_args         = NULL;

    interp->params_signature     = param_sig;
    parrot_pass_args(interp, caller_ctx, ctx, current_args, param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(ccont) &= ~SUB_FLAG_TAILCALL;
        --ctx->recursion_depth;
        ctx->caller_ctx      = caller_ctx->caller_ctx;
        Parrot_free_context(interp, caller_ctx, 0);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
    PMC* pmc = CTX_REG_PMC(ctx, 0);

    /* BEGIN PMETHOD BODY */
#line 504 "./src/pmc/role.pmc"

    Parrot_Role *role = PARROT_ROLE(pmc);
    PMC *ret_namespace = role->_namespace;
    {
#line 237 "/home/mandrake/rpm/BUILD/parrot-0.4.13/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
/*BEGIN PCCRETURN PMC *ret_namespace */
/*BEGIN GENERATED ACCESSORS */
CTX_REG_PMC(ctx, 0) = ret_namespace;

#line 243 "/home/mandrake/rpm/BUILD/parrot-0.4.13/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
/*END GENERATED ACCESSORS */
{
    opcode_t temp_return_indexes[] = { 0 };
    return_indexes = temp_return_indexes;
}
return_sig = Parrot_FixedIntegerArray_new_from_string(interp, _type,
    string_from_const_cstring(interp, "(2)", 0), 0);
goto pmc_namespace_returns;
/*END PCCRETURN PMC *ret_namespace */
}

#line 413 "/home/mandrake/rpm/BUILD/parrot-0.4.13/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    goto no_return;
    /* END PMETHOD BODY */

pmc_namespace_returns:

    /* if (PMC_cont(ccont)->address) { */
    {
        /* parrot_context_t * const caller_ctx = PMC_cont(ccont)->to_ctx; */
        if (! caller_ctx) {
            /* there is no point calling real_exception here, because
               PDB_backtrace can't deal with a missing to_ctx either. */
            internal_exception(1, "No caller_ctx for continuation %p.", ccont);
        }

        interp->returns_signature = return_sig;
        parrot_pass_args(interp, ctx, caller_ctx, return_indexes,
            caller_ctx->current_results, PARROT_PASS_RESULTS);
    }

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_type);
    PObj_live_CLEAR(param_sig);
    PObj_live_CLEAR(return_sig);
    Parrot_pop_context(interp);

}
#line 595 "src/pmc/role.c"
void
Parrot_Role_nci_attributes(Interp *interp, PMC* pmc)
{
#line 368 "/home/mandrake/rpm/BUILD/parrot-0.4.13/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    INTVAL   n_regs_used[]   = { 0, 0, 0, 1 };
    opcode_t param_indexes[] = { 0 };
    opcode_t *return_indexes;
    opcode_t *current_args;
    PMC* _type      = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC* param_sig  = Parrot_FixedIntegerArray_new_from_string(interp, _type,
        string_from_const_cstring(interp, "(2)", 0), 0);

    PMC* return_sig              = PMCNULL;

    parrot_context_t *caller_ctx = CONTEXT(interp->ctx);
    PMC* ret_cont                = new_ret_continuation_pmc(interp, NULL);
    parrot_context_t *ctx        = Parrot_push_context(interp, n_regs_used);
    PMC* ccont                   = caller_ctx->current_cont;

    ctx->current_cont            = ret_cont;
    PMC_cont(ret_cont)->from_ctx = ctx;

    current_args                 = interp->current_args;
    interp->current_args         = NULL;

    interp->params_signature     = param_sig;
    parrot_pass_args(interp, caller_ctx, ctx, current_args, param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(ccont) &= ~SUB_FLAG_TAILCALL;
        --ctx->recursion_depth;
        ctx->caller_ctx      = caller_ctx->caller_ctx;
        Parrot_free_context(interp, caller_ctx, 0);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
    PMC* pmc = CTX_REG_PMC(ctx, 0);

    /* BEGIN PMETHOD BODY */
#line 522 "./src/pmc/role.pmc"

    PMC *ret_attrib_metadata = VTABLE_inspect_str(interp, pmc, CONST_STRING(interp, "attributes"));
    {
#line 237 "/home/mandrake/rpm/BUILD/parrot-0.4.13/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
/*BEGIN PCCRETURN PMC *ret_attrib_metadata */
/*BEGIN GENERATED ACCESSORS */
CTX_REG_PMC(ctx, 0) = ret_attrib_metadata;

#line 243 "/home/mandrake/rpm/BUILD/parrot-0.4.13/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
/*END GENERATED ACCESSORS */
{
    opcode_t temp_return_indexes[] = { 0 };
    return_indexes = temp_return_indexes;
}
return_sig = Parrot_FixedIntegerArray_new_from_string(interp, _type,
    string_from_const_cstring(interp, "(2)", 0), 0);
goto attributes_returns;
/*END PCCRETURN PMC *ret_attrib_metadata */
}

#line 413 "/home/mandrake/rpm/BUILD/parrot-0.4.13/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    goto no_return;
    /* END PMETHOD BODY */

attributes_returns:

    /* if (PMC_cont(ccont)->address) { */
    {
        /* parrot_context_t * const caller_ctx = PMC_cont(ccont)->to_ctx; */
        if (! caller_ctx) {
            /* there is no point calling real_exception here, because
               PDB_backtrace can't deal with a missing to_ctx either. */
            internal_exception(1, "No caller_ctx for continuation %p.", ccont);
        }

        interp->returns_signature = return_sig;
        parrot_pass_args(interp, ctx, caller_ctx, return_indexes,
            caller_ctx->current_results, PARROT_PASS_RESULTS);
    }

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_type);
    PObj_live_CLEAR(param_sig);
    PObj_live_CLEAR(return_sig);
    Parrot_pop_context(interp);

}
#line 687 "src/pmc/role.c"
void
Parrot_Role_nci_add_attribute(Interp *interp, PMC* pmc)
{
#line 368 "/home/mandrake/rpm/BUILD/parrot-0.4.13/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    INTVAL   n_regs_used[]   = { 1, 0, 1, 2 };
    opcode_t param_indexes[] = { 0, 0, 1, 0 };
    opcode_t *return_indexes;
    opcode_t *current_args;
    PMC* _type      = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC* param_sig  = Parrot_FixedIntegerArray_new_from_string(interp, _type,
        string_from_const_cstring(interp, "(2, 1, 130, 256)", 0), 0);

    PMC* return_sig              = PMCNULL;

    parrot_context_t *caller_ctx = CONTEXT(interp->ctx);
    PMC* ret_cont                = new_ret_continuation_pmc(interp, NULL);
    parrot_context_t *ctx        = Parrot_push_context(interp, n_regs_used);
    PMC* ccont                   = caller_ctx->current_cont;

    ctx->current_cont            = ret_cont;
    PMC_cont(ret_cont)->from_ctx = ctx;

    current_args                 = interp->current_args;
    interp->current_args         = NULL;

    interp->params_signature     = param_sig;
    parrot_pass_args(interp, caller_ctx, ctx, current_args, param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(ccont) &= ~SUB_FLAG_TAILCALL;
        --ctx->recursion_depth;
        ctx->caller_ctx      = caller_ctx->caller_ctx;
        Parrot_free_context(interp, caller_ctx, 0);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
    PMC* pmc = CTX_REG_PMC(ctx, 0);
    STRING* attribute_name = CTX_REG_STR(ctx, 0);
    PMC* attribute_type = CTX_REG_PMC(ctx, 1);
    INTVAL got_type = CTX_REG_INT(ctx, 0);

    /* BEGIN PMETHOD BODY */
#line 540 "./src/pmc/role.pmc"

    VTABLE_add_attribute(interp, pmc, attribute_name,
        got_type ? attribute_type : PMCNULL);

#line 413 "/home/mandrake/rpm/BUILD/parrot-0.4.13/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    goto no_return;
    /* END PMETHOD BODY */

add_attribute_returns:

    /* if (PMC_cont(ccont)->address) { */
    {
        /* parrot_context_t * const caller_ctx = PMC_cont(ccont)->to_ctx; */
        if (! caller_ctx) {
            /* there is no point calling real_exception here, because
               PDB_backtrace can't deal with a missing to_ctx either. */
            internal_exception(1, "No caller_ctx for continuation %p.", ccont);
        }

        interp->returns_signature = return_sig;
        parrot_pass_args(interp, ctx, caller_ctx, return_indexes,
            caller_ctx->current_results, PARROT_PASS_RESULTS);
    }

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_type);
    PObj_live_CLEAR(param_sig);
    PObj_live_CLEAR(return_sig);
    Parrot_pop_context(interp);

}
#line 765 "src/pmc/role.c"
void
Parrot_Role_nci_methods(Interp *interp, PMC* pmc)
{
#line 368 "/home/mandrake/rpm/BUILD/parrot-0.4.13/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    INTVAL   n_regs_used[]   = { 0, 0, 0, 1 };
    opcode_t param_indexes[] = { 0 };
    opcode_t *return_indexes;
    opcode_t *current_args;
    PMC* _type      = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC* param_sig  = Parrot_FixedIntegerArray_new_from_string(interp, _type,
        string_from_const_cstring(interp, "(2)", 0), 0);

    PMC* return_sig              = PMCNULL;

    parrot_context_t *caller_ctx = CONTEXT(interp->ctx);
    PMC* ret_cont                = new_ret_continuation_pmc(interp, NULL);
    parrot_context_t *ctx        = Parrot_push_context(interp, n_regs_used);
    PMC* ccont                   = caller_ctx->current_cont;

    ctx->current_cont            = ret_cont;
    PMC_cont(ret_cont)->from_ctx = ctx;

    current_args                 = interp->current_args;
    interp->current_args         = NULL;

    interp->params_signature     = param_sig;
    parrot_pass_args(interp, caller_ctx, ctx, current_args, param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(ccont) &= ~SUB_FLAG_TAILCALL;
        --ctx->recursion_depth;
        ctx->caller_ctx      = caller_ctx->caller_ctx;
        Parrot_free_context(interp, caller_ctx, 0);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
    PMC* pmc = CTX_REG_PMC(ctx, 0);

    /* BEGIN PMETHOD BODY */
#line 556 "./src/pmc/role.pmc"

    PMC *ret_methods = VTABLE_inspect_str(interp, pmc, CONST_STRING(interp, "methods"));
    {
#line 237 "/home/mandrake/rpm/BUILD/parrot-0.4.13/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
/*BEGIN PCCRETURN PMC *ret_methods */
/*BEGIN GENERATED ACCESSORS */
CTX_REG_PMC(ctx, 0) = ret_methods;

#line 243 "/home/mandrake/rpm/BUILD/parrot-0.4.13/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
/*END GENERATED ACCESSORS */
{
    opcode_t temp_return_indexes[] = { 0 };
    return_indexes = temp_return_indexes;
}
return_sig = Parrot_FixedIntegerArray_new_from_string(interp, _type,
    string_from_const_cstring(interp, "(2)", 0), 0);
goto methods_returns;
/*END PCCRETURN PMC *ret_methods */
}

#line 413 "/home/mandrake/rpm/BUILD/parrot-0.4.13/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    goto no_return;
    /* END PMETHOD BODY */

methods_returns:

    /* if (PMC_cont(ccont)->address) { */
    {
        /* parrot_context_t * const caller_ctx = PMC_cont(ccont)->to_ctx; */
        if (! caller_ctx) {
            /* there is no point calling real_exception here, because
               PDB_backtrace can't deal with a missing to_ctx either. */
            internal_exception(1, "No caller_ctx for continuation %p.", ccont);
        }

        interp->returns_signature = return_sig;
        parrot_pass_args(interp, ctx, caller_ctx, return_indexes,
            caller_ctx->current_results, PARROT_PASS_RESULTS);
    }

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_type);
    PObj_live_CLEAR(param_sig);
    PObj_live_CLEAR(return_sig);
    Parrot_pop_context(interp);

}
#line 858 "src/pmc/role.c"
void
Parrot_Role_nci_add_method(Interp *interp, PMC* pmc)
{
#line 368 "/home/mandrake/rpm/BUILD/parrot-0.4.13/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    INTVAL   n_regs_used[]   = { 0, 0, 1, 2 };
    opcode_t param_indexes[] = { 0, 0, 1 };
    opcode_t *return_indexes;
    opcode_t *current_args;
    PMC* _type      = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC* param_sig  = Parrot_FixedIntegerArray_new_from_string(interp, _type,
        string_from_const_cstring(interp, "(2, 1, 2)", 0), 0);

    PMC* return_sig              = PMCNULL;

    parrot_context_t *caller_ctx = CONTEXT(interp->ctx);
    PMC* ret_cont                = new_ret_continuation_pmc(interp, NULL);
    parrot_context_t *ctx        = Parrot_push_context(interp, n_regs_used);
    PMC* ccont                   = caller_ctx->current_cont;

    ctx->current_cont            = ret_cont;
    PMC_cont(ret_cont)->from_ctx = ctx;

    current_args                 = interp->current_args;
    interp->current_args         = NULL;

    interp->params_signature     = param_sig;
    parrot_pass_args(interp, caller_ctx, ctx, current_args, param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(ccont) &= ~SUB_FLAG_TAILCALL;
        --ctx->recursion_depth;
        ctx->caller_ctx      = caller_ctx->caller_ctx;
        Parrot_free_context(interp, caller_ctx, 0);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
    PMC* pmc = CTX_REG_PMC(ctx, 0);
    STRING* name = CTX_REG_STR(ctx, 0);
    PMC* sub = CTX_REG_PMC(ctx, 1);

    /* BEGIN PMETHOD BODY */
#line 572 "./src/pmc/role.pmc"

    VTABLE_add_method(interp, pmc, name, sub);

#line 413 "/home/mandrake/rpm/BUILD/parrot-0.4.13/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    goto no_return;
    /* END PMETHOD BODY */

add_method_returns:

    /* if (PMC_cont(ccont)->address) { */
    {
        /* parrot_context_t * const caller_ctx = PMC_cont(ccont)->to_ctx; */
        if (! caller_ctx) {
            /* there is no point calling real_exception here, because
               PDB_backtrace can't deal with a missing to_ctx either. */
            internal_exception(1, "No caller_ctx for continuation %p.", ccont);
        }

        interp->returns_signature = return_sig;
        parrot_pass_args(interp, ctx, caller_ctx, return_indexes,
            caller_ctx->current_results, PARROT_PASS_RESULTS);
    }

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_type);
    PObj_live_CLEAR(param_sig);
    PObj_live_CLEAR(return_sig);
    Parrot_pop_context(interp);

}
#line 934 "src/pmc/role.c"
void
Parrot_Role_nci_roles(Interp *interp, PMC* pmc)
{
#line 368 "/home/mandrake/rpm/BUILD/parrot-0.4.13/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    INTVAL   n_regs_used[]   = { 0, 0, 0, 1 };
    opcode_t param_indexes[] = { 0 };
    opcode_t *return_indexes;
    opcode_t *current_args;
    PMC* _type      = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC* param_sig  = Parrot_FixedIntegerArray_new_from_string(interp, _type,
        string_from_const_cstring(interp, "(2)", 0), 0);

    PMC* return_sig              = PMCNULL;

    parrot_context_t *caller_ctx = CONTEXT(interp->ctx);
    PMC* ret_cont                = new_ret_continuation_pmc(interp, NULL);
    parrot_context_t *ctx        = Parrot_push_context(interp, n_regs_used);
    PMC* ccont                   = caller_ctx->current_cont;

    ctx->current_cont            = ret_cont;
    PMC_cont(ret_cont)->from_ctx = ctx;

    current_args                 = interp->current_args;
    interp->current_args         = NULL;

    interp->params_signature     = param_sig;
    parrot_pass_args(interp, caller_ctx, ctx, current_args, param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(ccont) &= ~SUB_FLAG_TAILCALL;
        --ctx->recursion_depth;
        ctx->caller_ctx      = caller_ctx->caller_ctx;
        Parrot_free_context(interp, caller_ctx, 0);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
    PMC* pmc = CTX_REG_PMC(ctx, 0);

    /* BEGIN PMETHOD BODY */
#line 587 "./src/pmc/role.pmc"

    PMC *ret_roles = VTABLE_inspect_str(interp, pmc, CONST_STRING(interp, "roles"));
    {
#line 237 "/home/mandrake/rpm/BUILD/parrot-0.4.13/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
/*BEGIN PCCRETURN PMC *ret_roles */
/*BEGIN GENERATED ACCESSORS */
CTX_REG_PMC(ctx, 0) = ret_roles;

#line 243 "/home/mandrake/rpm/BUILD/parrot-0.4.13/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
/*END GENERATED ACCESSORS */
{
    opcode_t temp_return_indexes[] = { 0 };
    return_indexes = temp_return_indexes;
}
return_sig = Parrot_FixedIntegerArray_new_from_string(interp, _type,
    string_from_const_cstring(interp, "(2)", 0), 0);
goto roles_returns;
/*END PCCRETURN PMC *ret_roles */
}

#line 413 "/home/mandrake/rpm/BUILD/parrot-0.4.13/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    goto no_return;
    /* END PMETHOD BODY */

roles_returns:

    /* if (PMC_cont(ccont)->address) { */
    {
        /* parrot_context_t * const caller_ctx = PMC_cont(ccont)->to_ctx; */
        if (! caller_ctx) {
            /* there is no point calling real_exception here, because
               PDB_backtrace can't deal with a missing to_ctx either. */
            internal_exception(1, "No caller_ctx for continuation %p.", ccont);
        }

        interp->returns_signature = return_sig;
        parrot_pass_args(interp, ctx, caller_ctx, return_indexes,
            caller_ctx->current_results, PARROT_PASS_RESULTS);
    }

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_type);
    PObj_live_CLEAR(param_sig);
    PObj_live_CLEAR(return_sig);
    Parrot_pop_context(interp);

}
#line 1027 "src/pmc/role.c"
void
Parrot_Role_nci_add_role(Interp *interp, PMC* pmc)
{
#line 368 "/home/mandrake/rpm/BUILD/parrot-0.4.13/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    INTVAL   n_regs_used[]   = { 2, 0, 2, 4 };
    opcode_t param_indexes[] = { 0, 1, 0, 2, 0, 1, 3, 1 };
    opcode_t *return_indexes;
    opcode_t *current_args;
    PMC* _type      = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC* param_sig  = Parrot_FixedIntegerArray_new_from_string(interp, _type,
        string_from_const_cstring(interp, "(2, 2, 513, 130, 256, 513, 130, 256)", 0), 0);

    PMC* return_sig              = PMCNULL;

    parrot_context_t *caller_ctx = CONTEXT(interp->ctx);
    PMC* ret_cont                = new_ret_continuation_pmc(interp, NULL);
    parrot_context_t *ctx        = Parrot_push_context(interp, n_regs_used);
    PMC* ccont                   = caller_ctx->current_cont;

    ctx->current_cont            = ret_cont;
    PMC_cont(ret_cont)->from_ctx = ctx;

    current_args                 = interp->current_args;
    interp->current_args         = NULL;

    CTX_REG_STR(ctx, 0) = string_from_const_cstring(interp, "exclude_method", 0);
    CTX_REG_STR(ctx, 1) = string_from_const_cstring(interp, "alias_method", 0);

    interp->params_signature     = param_sig;
    parrot_pass_args(interp, caller_ctx, ctx, current_args, param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(ccont) &= ~SUB_FLAG_TAILCALL;
        --ctx->recursion_depth;
        ctx->caller_ctx      = caller_ctx->caller_ctx;
        Parrot_free_context(interp, caller_ctx, 0);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
    PMC* pmc = CTX_REG_PMC(ctx, 0);
    PMC* role = CTX_REG_PMC(ctx, 1);
    PMC* exclude_method = CTX_REG_PMC(ctx, 2);
    INTVAL got_exclude_method = CTX_REG_INT(ctx, 0);
    PMC* alias_method = CTX_REG_PMC(ctx, 3);
    INTVAL got_alias_method = CTX_REG_INT(ctx, 1);

    /* BEGIN PMETHOD BODY */
#line 611 "./src/pmc/role.pmc"

    Parrot_Role *role_info = PARROT_ROLE(pmc);
    STRING *s_name, *r_name;

/*BEGIN PCCINVOKE pmc */
#line 496 "/home/mandrake/rpm/BUILD/parrot-0.4.13/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
{
  INTVAL   n_regs_used[]    = { 0, 0, 1, 1 };
  opcode_t arg_indexes[]    = { 0 };
  opcode_t result_indexes[] = { 0 };
  PMC* _type                = pmc_new(interp, enum_class_FixedIntegerArray);

  PMC* args_sig         = Parrot_FixedIntegerArray_new_from_string(interp,
        _type, string_from_const_cstring(interp, "(2)", 0), 0);
  PMC* results_sig      = Parrot_FixedIntegerArray_new_from_string(interp,
        _type, string_from_const_cstring(interp, "(1)", 0), 0);
  PMC* ret_cont         = new_ret_continuation_pmc(interp, NULL);

  parrot_context_t *ctx = Parrot_push_context(interp, n_regs_used);
  PMC* pccinvoke_meth;

  opcode_t* save_current_args = interp->current_args;
  PMC* save_args_signature    = interp->args_signature;
  PMC* save_current_object    = interp->current_object;

  interp->current_args        = arg_indexes;
  interp->args_signature      = args_sig;
  ctx->current_results        = result_indexes;
  ctx->results_signature      = results_sig;

CTX_REG_PMC(ctx, 0) = pmc;

  interp->current_object       = pmc;
  interp->current_cont         = NEED_CONTINUATION;
  ctx->current_cont            = ret_cont;
  PMC_cont(ret_cont)->from_ctx = ctx;

  pccinvoke_meth = VTABLE_find_method(interp, pmc, string_from_const_cstring(interp, (const char *) "name", 0));
  if (PMC_IS_NULL(pccinvoke_meth))
      real_exception(interp, NULL, METH_NOT_FOUND,
        "Method '%Ss' not found", string_from_const_cstring(interp, (const char *) "name", 0));
  else
      VTABLE_invoke(interp, pccinvoke_meth, NULL);

s_name = CTX_REG_STR(ctx, 0);

  PObj_live_CLEAR(_type);
  PObj_live_CLEAR(args_sig);
  PObj_live_CLEAR(results_sig);
  Parrot_pop_context(interp);

  interp->current_args   = save_current_args;
  interp->args_signature = save_args_signature;
  interp->current_object = save_current_object;
}
/*END PCCINVOKE string_from_const_cstring(interp, (const char *) "name", 0) */

/*BEGIN PCCINVOKE role */
#line 496 "/home/mandrake/rpm/BUILD/parrot-0.4.13/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
{
  INTVAL   n_regs_used[]    = { 0, 0, 1, 1 };
  opcode_t arg_indexes[]    = { 0 };
  opcode_t result_indexes[] = { 0 };
  PMC* _type                = pmc_new(interp, enum_class_FixedIntegerArray);

  PMC* args_sig         = Parrot_FixedIntegerArray_new_from_string(interp,
        _type, string_from_const_cstring(interp, "(2)", 0), 0);
  PMC* results_sig      = Parrot_FixedIntegerArray_new_from_string(interp,
        _type, string_from_const_cstring(interp, "(1)", 0), 0);
  PMC* ret_cont         = new_ret_continuation_pmc(interp, NULL);

  parrot_context_t *ctx = Parrot_push_context(interp, n_regs_used);
  PMC* pccinvoke_meth;

  opcode_t* save_current_args = interp->current_args;
  PMC* save_args_signature    = interp->args_signature;
  PMC* save_current_object    = interp->current_object;

  interp->current_args        = arg_indexes;
  interp->args_signature      = args_sig;
  ctx->current_results        = result_indexes;
  ctx->results_signature      = results_sig;

CTX_REG_PMC(ctx, 0) = role;

  interp->current_object       = role;
  interp->current_cont         = NEED_CONTINUATION;
  ctx->current_cont            = ret_cont;
  PMC_cont(ret_cont)->from_ctx = ctx;

  pccinvoke_meth = VTABLE_find_method(interp, role, string_from_const_cstring(interp, (const char *) "name", 0));
  if (PMC_IS_NULL(pccinvoke_meth))
      real_exception(interp, NULL, METH_NOT_FOUND,
        "Method '%Ss' not found", string_from_const_cstring(interp, (const char *) "name", 0));
  else
      VTABLE_invoke(interp, pccinvoke_meth, NULL);

r_name = CTX_REG_STR(ctx, 0);

  PObj_live_CLEAR(_type);
  PObj_live_CLEAR(args_sig);
  PObj_live_CLEAR(results_sig);
  Parrot_pop_context(interp);

  interp->current_args   = save_current_args;
  interp->args_signature = save_args_signature;
  interp->current_object = save_current_object;
}
/*END PCCINVOKE string_from_const_cstring(interp, (const char *) "name", 0) */

    Parrot_ComposeRole(interp, role, exclude_method, got_exclude_method,
                       alias_method, got_alias_method,
                       role_info->methods, role_info->roles);

#line 413 "/home/mandrake/rpm/BUILD/parrot-0.4.13/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    goto no_return;
    /* END PMETHOD BODY */

add_role_returns:

    /* if (PMC_cont(ccont)->address) { */
    {
        /* parrot_context_t * const caller_ctx = PMC_cont(ccont)->to_ctx; */
        if (! caller_ctx) {
            /* there is no point calling real_exception here, because
               PDB_backtrace can't deal with a missing to_ctx either. */
            internal_exception(1, "No caller_ctx for continuation %p.", ccont);
        }

        interp->returns_signature = return_sig;
        parrot_pass_args(interp, ctx, caller_ctx, return_indexes,
            caller_ctx->current_results, PARROT_PASS_RESULTS);
    }

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_type);
    PObj_live_CLEAR(param_sig);
    PObj_live_CLEAR(return_sig);
    Parrot_pop_context(interp);

}
#line 1230 "src/pmc/role.c"
void
Parrot_Role_nci_inspect(Interp *interp, PMC* pmc)
{
#line 368 "/home/mandrake/rpm/BUILD/parrot-0.4.13/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    INTVAL   n_regs_used[]   = { 1, 0, 1, 1 };
    opcode_t param_indexes[] = { 0, 0, 0 };
    opcode_t *return_indexes;
    opcode_t *current_args;
    PMC* _type      = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC* param_sig  = Parrot_FixedIntegerArray_new_from_string(interp, _type,
        string_from_const_cstring(interp, "(2, 129, 256)", 0), 0);

    PMC* return_sig              = PMCNULL;

    parrot_context_t *caller_ctx = CONTEXT(interp->ctx);
    PMC* ret_cont                = new_ret_continuation_pmc(interp, NULL);
    parrot_context_t *ctx        = Parrot_push_context(interp, n_regs_used);
    PMC* ccont                   = caller_ctx->current_cont;

    ctx->current_cont            = ret_cont;
    PMC_cont(ret_cont)->from_ctx = ctx;

    current_args                 = interp->current_args;
    interp->current_args         = NULL;

    interp->params_signature     = param_sig;
    parrot_pass_args(interp, caller_ctx, ctx, current_args, param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(ccont) &= ~SUB_FLAG_TAILCALL;
        --ctx->recursion_depth;
        ctx->caller_ctx      = caller_ctx->caller_ctx;
        Parrot_free_context(interp, caller_ctx, 0);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
    PMC* pmc = CTX_REG_PMC(ctx, 0);
    STRING* what = CTX_REG_STR(ctx, 0);
    INTVAL got_what = CTX_REG_INT(ctx, 0);

    /* BEGIN PMETHOD BODY */
#line 633 "./src/pmc/role.pmc"

    PMC *found;

    /* Just delegate to the appropriate vtable method. */
    if (got_what)
        found = VTABLE_inspect_str(interp, pmc, what);
    else
        found = VTABLE_inspect(interp, pmc);

    {
#line 237 "/home/mandrake/rpm/BUILD/parrot-0.4.13/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
/*BEGIN PCCRETURN PMC *found */
/*BEGIN GENERATED ACCESSORS */
CTX_REG_PMC(ctx, 0) = found;

#line 243 "/home/mandrake/rpm/BUILD/parrot-0.4.13/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
/*END GENERATED ACCESSORS */
{
    opcode_t temp_return_indexes[] = { 0 };
    return_indexes = temp_return_indexes;
}
return_sig = Parrot_FixedIntegerArray_new_from_string(interp, _type,
    string_from_const_cstring(interp, "(2)", 0), 0);
goto inspect_returns;
/*END PCCRETURN PMC *found */
}

#line 413 "/home/mandrake/rpm/BUILD/parrot-0.4.13/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    goto no_return;
    /* END PMETHOD BODY */

inspect_returns:

    /* if (PMC_cont(ccont)->address) { */
    {
        /* parrot_context_t * const caller_ctx = PMC_cont(ccont)->to_ctx; */
        if (! caller_ctx) {
            /* there is no point calling real_exception here, because
               PDB_backtrace can't deal with a missing to_ctx either. */
            internal_exception(1, "No caller_ctx for continuation %p.", ccont);
        }

        interp->returns_signature = return_sig;
        parrot_pass_args(interp, ctx, caller_ctx, return_indexes,
            caller_ctx->current_results, PARROT_PASS_RESULTS);
    }

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_type);
    PObj_live_CLEAR(param_sig);
    PObj_live_CLEAR(return_sig);
    Parrot_pop_context(interp);

}
#line 1322 "src/pmc/role.c"
void
Parrot_Role_nci_does(Interp *interp, PMC* pmc)
{
#line 368 "/home/mandrake/rpm/BUILD/parrot-0.4.13/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    INTVAL   n_regs_used[]   = { 1, 0, 1, 1 };
    opcode_t param_indexes[] = { 0, 0 };
    opcode_t *return_indexes;
    opcode_t *current_args;
    PMC* _type      = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC* param_sig  = Parrot_FixedIntegerArray_new_from_string(interp, _type,
        string_from_const_cstring(interp, "(2, 1)", 0), 0);

    PMC* return_sig              = PMCNULL;

    parrot_context_t *caller_ctx = CONTEXT(interp->ctx);
    PMC* ret_cont                = new_ret_continuation_pmc(interp, NULL);
    parrot_context_t *ctx        = Parrot_push_context(interp, n_regs_used);
    PMC* ccont                   = caller_ctx->current_cont;

    ctx->current_cont            = ret_cont;
    PMC_cont(ret_cont)->from_ctx = ctx;

    current_args                 = interp->current_args;
    interp->current_args         = NULL;

    interp->params_signature     = param_sig;
    parrot_pass_args(interp, caller_ctx, ctx, current_args, param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(ccont) &= ~SUB_FLAG_TAILCALL;
        --ctx->recursion_depth;
        ctx->caller_ctx      = caller_ctx->caller_ctx;
        Parrot_free_context(interp, caller_ctx, 0);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
    PMC* pmc = CTX_REG_PMC(ctx, 0);
    STRING* name = CTX_REG_STR(ctx, 0);

    /* BEGIN PMETHOD BODY */
#line 656 "./src/pmc/role.pmc"

    INTVAL  i, count;
    STRING *r_name;
    PMC    *roles, *role;

/*BEGIN PCCINVOKE pmc */
#line 496 "/home/mandrake/rpm/BUILD/parrot-0.4.13/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
{
  INTVAL   n_regs_used[]    = { 0, 0, 1, 1 };
  opcode_t arg_indexes[]    = { 0 };
  opcode_t result_indexes[] = { 0 };
  PMC* _type                = pmc_new(interp, enum_class_FixedIntegerArray);

  PMC* args_sig         = Parrot_FixedIntegerArray_new_from_string(interp,
        _type, string_from_const_cstring(interp, "(2)", 0), 0);
  PMC* results_sig      = Parrot_FixedIntegerArray_new_from_string(interp,
        _type, string_from_const_cstring(interp, "(1)", 0), 0);
  PMC* ret_cont         = new_ret_continuation_pmc(interp, NULL);

  parrot_context_t *ctx = Parrot_push_context(interp, n_regs_used);
  PMC* pccinvoke_meth;

  opcode_t* save_current_args = interp->current_args;
  PMC* save_args_signature    = interp->args_signature;
  PMC* save_current_object    = interp->current_object;

  interp->current_args        = arg_indexes;
  interp->args_signature      = args_sig;
  ctx->current_results        = result_indexes;
  ctx->results_signature      = results_sig;

CTX_REG_PMC(ctx, 0) = pmc;

  interp->current_object       = pmc;
  interp->current_cont         = NEED_CONTINUATION;
  ctx->current_cont            = ret_cont;
  PMC_cont(ret_cont)->from_ctx = ctx;

  pccinvoke_meth = VTABLE_find_method(interp, pmc, string_from_const_cstring(interp, (const char *) "name", 0));
  if (PMC_IS_NULL(pccinvoke_meth))
      real_exception(interp, NULL, METH_NOT_FOUND,
        "Method '%Ss' not found", string_from_const_cstring(interp, (const char *) "name", 0));
  else
      VTABLE_invoke(interp, pccinvoke_meth, NULL);

r_name = CTX_REG_STR(ctx, 0);

  PObj_live_CLEAR(_type);
  PObj_live_CLEAR(args_sig);
  PObj_live_CLEAR(results_sig);
  Parrot_pop_context(interp);

  interp->current_args   = save_current_args;
  interp->args_signature = save_args_signature;
  interp->current_object = save_current_object;
}
/*END PCCINVOKE string_from_const_cstring(interp, (const char *) "name", 0) */

    if (string_equal(interp, r_name, name) == 0)
        {
#line 237 "/home/mandrake/rpm/BUILD/parrot-0.4.13/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
/*BEGIN PCCRETURN INTVAL 1 */
/*BEGIN GENERATED ACCESSORS */
CTX_REG_INT(ctx, 0) = 1;

#line 243 "/home/mandrake/rpm/BUILD/parrot-0.4.13/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
/*END GENERATED ACCESSORS */
{
    opcode_t temp_return_indexes[] = { 0 };
    return_indexes = temp_return_indexes;
}
return_sig = Parrot_FixedIntegerArray_new_from_string(interp, _type,
    string_from_const_cstring(interp, "(0)", 0), 0);
goto does_returns;
/*END PCCRETURN INTVAL 1 */
}

/*BEGIN PCCINVOKE pmc */
#line 496 "/home/mandrake/rpm/BUILD/parrot-0.4.13/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
{
  INTVAL   n_regs_used[]    = { 0, 0, 0, 1 };
  opcode_t arg_indexes[]    = { 0 };
  opcode_t result_indexes[] = { 0 };
  PMC* _type                = pmc_new(interp, enum_class_FixedIntegerArray);

  PMC* args_sig         = Parrot_FixedIntegerArray_new_from_string(interp,
        _type, string_from_const_cstring(interp, "(2)", 0), 0);
  PMC* results_sig      = Parrot_FixedIntegerArray_new_from_string(interp,
        _type, string_from_const_cstring(interp, "(2)", 0), 0);
  PMC* ret_cont         = new_ret_continuation_pmc(interp, NULL);

  parrot_context_t *ctx = Parrot_push_context(interp, n_regs_used);
  PMC* pccinvoke_meth;

  opcode_t* save_current_args = interp->current_args;
  PMC* save_args_signature    = interp->args_signature;
  PMC* save_current_object    = interp->current_object;

  interp->current_args        = arg_indexes;
  interp->args_signature      = args_sig;
  ctx->current_results        = result_indexes;
  ctx->results_signature      = results_sig;

CTX_REG_PMC(ctx, 0) = pmc;

  interp->current_object       = pmc;
  interp->current_cont         = NEED_CONTINUATION;
  ctx->current_cont            = ret_cont;
  PMC_cont(ret_cont)->from_ctx = ctx;

  pccinvoke_meth = VTABLE_find_method(interp, pmc, string_from_const_cstring(interp, (const char *) "roles", 0));
  if (PMC_IS_NULL(pccinvoke_meth))
      real_exception(interp, NULL, METH_NOT_FOUND,
        "Method '%Ss' not found", string_from_const_cstring(interp, (const char *) "roles", 0));
  else
      VTABLE_invoke(interp, pccinvoke_meth, NULL);

roles = CTX_REG_PMC(ctx, 0);

  PObj_live_CLEAR(_type);
  PObj_live_CLEAR(args_sig);
  PObj_live_CLEAR(results_sig);
  Parrot_pop_context(interp);

  interp->current_args   = save_current_args;
  interp->args_signature = save_args_signature;
  interp->current_object = save_current_object;
}
/*END PCCINVOKE string_from_const_cstring(interp, (const char *) "roles", 0) */

    count            = VTABLE_elements(interp, roles);

    for (i = 0; i < count; i++) {
        INTVAL does;
        role          = VTABLE_get_pmc_keyed_int(interp, roles, i);

/*BEGIN PCCINVOKE role */
#line 496 "/home/mandrake/rpm/BUILD/parrot-0.4.13/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
{
  INTVAL   n_regs_used[]    = { 1, 0, 1, 1 };
  opcode_t arg_indexes[]    = { 0, 0 };
  opcode_t result_indexes[] = { 0 };
  PMC* _type                = pmc_new(interp, enum_class_FixedIntegerArray);

  PMC* args_sig         = Parrot_FixedIntegerArray_new_from_string(interp,
        _type, string_from_const_cstring(interp, "(2, 1)", 0), 0);
  PMC* results_sig      = Parrot_FixedIntegerArray_new_from_string(interp,
        _type, string_from_const_cstring(interp, "(0)", 0), 0);
  PMC* ret_cont         = new_ret_continuation_pmc(interp, NULL);

  parrot_context_t *ctx = Parrot_push_context(interp, n_regs_used);
  PMC* pccinvoke_meth;

  opcode_t* save_current_args = interp->current_args;
  PMC* save_args_signature    = interp->args_signature;
  PMC* save_current_object    = interp->current_object;

  interp->current_args        = arg_indexes;
  interp->args_signature      = args_sig;
  ctx->current_results        = result_indexes;
  ctx->results_signature      = results_sig;

CTX_REG_PMC(ctx, 0) = role;
CTX_REG_STR(ctx, 0) = name;

  interp->current_object       = role;
  interp->current_cont         = NEED_CONTINUATION;
  ctx->current_cont            = ret_cont;
  PMC_cont(ret_cont)->from_ctx = ctx;

  pccinvoke_meth = VTABLE_find_method(interp, role, string_from_const_cstring(interp, (const char *) "does", 0));
  if (PMC_IS_NULL(pccinvoke_meth))
      real_exception(interp, NULL, METH_NOT_FOUND,
        "Method '%Ss' not found", string_from_const_cstring(interp, (const char *) "does", 0));
  else
      VTABLE_invoke(interp, pccinvoke_meth, NULL);

does = CTX_REG_INT(ctx, 0);

  PObj_live_CLEAR(_type);
  PObj_live_CLEAR(args_sig);
  PObj_live_CLEAR(results_sig);
  Parrot_pop_context(interp);

  interp->current_args   = save_current_args;
  interp->args_signature = save_args_signature;
  interp->current_object = save_current_object;
}
/*END PCCINVOKE string_from_const_cstring(interp, (const char *) "does", 0) */

        if (does)
            {
#line 237 "/home/mandrake/rpm/BUILD/parrot-0.4.13/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
/*BEGIN PCCRETURN INTVAL 1 */
/*BEGIN GENERATED ACCESSORS */
CTX_REG_INT(ctx, 0) = 1;

#line 243 "/home/mandrake/rpm/BUILD/parrot-0.4.13/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
/*END GENERATED ACCESSORS */
{
    opcode_t temp_return_indexes[] = { 0 };
    return_indexes = temp_return_indexes;
}
return_sig = Parrot_FixedIntegerArray_new_from_string(interp, _type,
    string_from_const_cstring(interp, "(0)", 0), 0);
goto does_returns;
/*END PCCRETURN INTVAL 1 */
}

    }

    {
#line 237 "/home/mandrake/rpm/BUILD/parrot-0.4.13/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
/*BEGIN PCCRETURN INTVAL 0 */
/*BEGIN GENERATED ACCESSORS */
CTX_REG_INT(ctx, 0) = 0;

#line 243 "/home/mandrake/rpm/BUILD/parrot-0.4.13/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
/*END GENERATED ACCESSORS */
{
    opcode_t temp_return_indexes[] = { 0 };
    return_indexes = temp_return_indexes;
}
return_sig = Parrot_FixedIntegerArray_new_from_string(interp, _type,
    string_from_const_cstring(interp, "(0)", 0), 0);
goto does_returns;
/*END PCCRETURN INTVAL 0 */
}

#line 413 "/home/mandrake/rpm/BUILD/parrot-0.4.13/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    goto no_return;
    /* END PMETHOD BODY */

does_returns:

    /* if (PMC_cont(ccont)->address) { */
    {
        /* parrot_context_t * const caller_ctx = PMC_cont(ccont)->to_ctx; */
        if (! caller_ctx) {
            /* there is no point calling real_exception here, because
               PDB_backtrace can't deal with a missing to_ctx either. */
            internal_exception(1, "No caller_ctx for continuation %p.", ccont);
        }

        interp->returns_signature = return_sig;
        parrot_pass_args(interp, ctx, caller_ctx, return_indexes,
            caller_ctx->current_results, PARROT_PASS_RESULTS);
    }

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_type);
    PObj_live_CLEAR(param_sig);
    PObj_live_CLEAR(return_sig);
    Parrot_pop_context(interp);

}
#line 1641 "src/pmc/role.c"
void
Parrot_Role_ro_add_attribute(Interp *interp, PMC* pmc, STRING* name, PMC* type)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "add_attribute() in read-only instance of Role");
}
void
Parrot_Role_ro_add_method(Interp *interp, PMC* pmc, STRING* method_name, PMC* sub_pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "add_method() in read-only instance of Role");
}
void
Parrot_Role_ro_add_parent(Interp *interp, PMC* pmc, PMC* parent)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "add_parent() in read-only instance of Role");
}
void
Parrot_Role_ro_add_role(Interp *interp, PMC* pmc, PMC* role)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "add_role() in read-only instance of Role");
}
void
Parrot_Role_ro_assign_pmc(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "assign_pmc() in read-only instance of Role");
}
void
Parrot_Role_ro_assign_string_native(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "assign_string_native() in read-only instance of Role");
}
void
Parrot_Role_ro_decrement(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "decrement() in read-only instance of Role");
}
void
Parrot_Role_ro_delete_keyed(Interp *interp, PMC* pmc, PMC* key)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "delete_keyed() in read-only instance of Role");
}
void
Parrot_Role_ro_delete_keyed_int(Interp *interp, PMC* pmc, INTVAL key)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "delete_keyed_int() in read-only instance of Role");
}
void
Parrot_Role_ro_delete_keyed_str(Interp *interp, PMC* pmc, STRING* key)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "delete_keyed_str() in read-only instance of Role");
}
PMC*
Parrot_Role_ro_find_method(Interp *interp, PMC* pmc, STRING* method_name)
 {
    PMC *const method = Parrot_default_find_method(interp, pmc, method_name);
    if (!PMC_IS_NULL(VTABLE_getprop(interp, method, const_string(interp, "write"))))
        return PMCNULL;
    else
        return method;
}
void
Parrot_Role_ro_i_absolute(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_absolute() in read-only instance of Role");
}
void
Parrot_Role_ro_i_bitwise_not(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_bitwise_not() in read-only instance of Role");
}
void
Parrot_Role_ro_i_bitwise_nots(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_bitwise_nots() in read-only instance of Role");
}
void
Parrot_Role_ro_i_logical_not(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_logical_not() in read-only instance of Role");
}
void
Parrot_Role_ro_i_neg(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_neg() in read-only instance of Role");
}
void
Parrot_Role_ro_increment(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "increment() in read-only instance of Role");
}
void
Parrot_Role_ro_morph(Interp *interp, PMC* pmc, INTVAL type)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "morph() in read-only instance of Role");
}
FLOATVAL
Parrot_Role_ro_pop_float(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "pop_float() in read-only instance of Role");
    return (FLOATVAL)0;
}
INTVAL
Parrot_Role_ro_pop_integer(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "pop_integer() in read-only instance of Role");
    return (INTVAL)0;
}
PMC*
Parrot_Role_ro_pop_pmc(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "pop_pmc() in read-only instance of Role");
    return PMCNULL;
}
STRING*
Parrot_Role_ro_pop_string(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "pop_string() in read-only instance of Role");
    return (STRING*)0;
}
void
Parrot_Role_ro_push_float(Interp *interp, PMC* pmc, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "push_float() in read-only instance of Role");
}
void
Parrot_Role_ro_push_integer(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "push_integer() in read-only instance of Role");
}
void
Parrot_Role_ro_push_pmc(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "push_pmc() in read-only instance of Role");
}
void
Parrot_Role_ro_push_string(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "push_string() in read-only instance of Role");
}
void
Parrot_Role_ro_remove_attribute(Interp *interp, PMC* pmc, STRING* name)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "remove_attribute() in read-only instance of Role");
}
void
Parrot_Role_ro_remove_method(Interp *interp, PMC* pmc, STRING* method_name)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "remove_method() in read-only instance of Role");
}
void
Parrot_Role_ro_remove_parent(Interp *interp, PMC* pmc, PMC* parent)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "remove_parent() in read-only instance of Role");
}
void
Parrot_Role_ro_remove_role(Interp *interp, PMC* pmc, PMC* role)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "remove_role() in read-only instance of Role");
}
void
Parrot_Role_ro_set_attr(Interp *interp, PMC* pmc, INTVAL idx, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_attr() in read-only instance of Role");
}
void
Parrot_Role_ro_set_attr_str(Interp *interp, PMC* pmc, STRING* idx, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_attr_str() in read-only instance of Role");
}
void
Parrot_Role_ro_set_bignum_int(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_bignum_int() in read-only instance of Role");
}
void
Parrot_Role_ro_set_bignum_num(Interp *interp, PMC* pmc, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_bignum_num() in read-only instance of Role");
}
void
Parrot_Role_ro_set_bignum_str(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_bignum_str() in read-only instance of Role");
}
void
Parrot_Role_ro_set_bool(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_bool() in read-only instance of Role");
}
void
Parrot_Role_ro_set_integer_keyed(Interp *interp, PMC* pmc, PMC* key, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_keyed() in read-only instance of Role");
}
void
Parrot_Role_ro_set_integer_keyed_int(Interp *interp, PMC* pmc, INTVAL key, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_keyed_int() in read-only instance of Role");
}
void
Parrot_Role_ro_set_integer_keyed_str(Interp *interp, PMC* pmc, STRING* key, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_keyed_str() in read-only instance of Role");
}
void
Parrot_Role_ro_set_integer_native(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_native() in read-only instance of Role");
}
void
Parrot_Role_ro_set_integer_same(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_same() in read-only instance of Role");
}
void
Parrot_Role_ro_set_number_keyed(Interp *interp, PMC* pmc, PMC* key, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_keyed() in read-only instance of Role");
}
void
Parrot_Role_ro_set_number_keyed_int(Interp *interp, PMC* pmc, INTVAL key, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_keyed_int() in read-only instance of Role");
}
void
Parrot_Role_ro_set_number_keyed_str(Interp *interp, PMC* pmc, STRING* key, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_keyed_str() in read-only instance of Role");
}
void
Parrot_Role_ro_set_number_native(Interp *interp, PMC* pmc, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_native() in read-only instance of Role");
}
void
Parrot_Role_ro_set_number_same(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_same() in read-only instance of Role");
}
void
Parrot_Role_ro_set_pmc(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pmc() in read-only instance of Role");
}
void
Parrot_Role_ro_set_pmc_keyed(Interp *interp, PMC* pmc, PMC* key, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pmc_keyed() in read-only instance of Role");
}
void
Parrot_Role_ro_set_pmc_keyed_int(Interp *interp, PMC* pmc, INTVAL key, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_int() in read-only instance of Role");
}
void
Parrot_Role_ro_set_pmc_keyed_str(Interp *interp, PMC* pmc, STRING* key, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_str() in read-only instance of Role");
}
void
Parrot_Role_ro_set_pointer(Interp *interp, PMC* pmc, void* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pointer() in read-only instance of Role");
}
void
Parrot_Role_ro_set_pointer_keyed(Interp *interp, PMC* pmc, PMC* key, void* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pointer_keyed() in read-only instance of Role");
}
void
Parrot_Role_ro_set_pointer_keyed_int(Interp *interp, PMC* pmc, INTVAL key, void* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_int() in read-only instance of Role");
}
void
Parrot_Role_ro_set_pointer_keyed_str(Interp *interp, PMC* pmc, STRING* key, void* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_str() in read-only instance of Role");
}
void
Parrot_Role_ro_set_string_keyed(Interp *interp, PMC* pmc, PMC* key, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_keyed() in read-only instance of Role");
}
void
Parrot_Role_ro_set_string_keyed_int(Interp *interp, PMC* pmc, INTVAL key, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_keyed_int() in read-only instance of Role");
}
void
Parrot_Role_ro_set_string_keyed_str(Interp *interp, PMC* pmc, STRING* key, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_keyed_str() in read-only instance of Role");
}
void
Parrot_Role_ro_set_string_native(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_native() in read-only instance of Role");
}
void
Parrot_Role_ro_set_string_same(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_same() in read-only instance of Role");
}
FLOATVAL
Parrot_Role_ro_shift_float(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "shift_float() in read-only instance of Role");
    return (FLOATVAL)0;
}
INTVAL
Parrot_Role_ro_shift_integer(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "shift_integer() in read-only instance of Role");
    return (INTVAL)0;
}
PMC*
Parrot_Role_ro_shift_pmc(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "shift_pmc() in read-only instance of Role");
    return PMCNULL;
}
STRING*
Parrot_Role_ro_shift_string(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "shift_string() in read-only instance of Role");
    return (STRING*)0;
}
void
Parrot_Role_ro_splice(Interp *interp, PMC* pmc, PMC* value, INTVAL offset, INTVAL count)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "splice() in read-only instance of Role");
}
void
Parrot_Role_ro_thaw(Interp *interp, PMC* pmc, visit_info* info)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "thaw() in read-only instance of Role");
}
void
Parrot_Role_ro_thawfinish(Interp *interp, PMC* pmc, visit_info* info)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "thawfinish() in read-only instance of Role");
}
void
Parrot_Role_ro_unshift_float(Interp *interp, PMC* pmc, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "unshift_float() in read-only instance of Role");
}
void
Parrot_Role_ro_unshift_integer(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "unshift_integer() in read-only instance of Role");
}
void
Parrot_Role_ro_unshift_pmc(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "unshift_pmc() in read-only instance of Role");
}
void
Parrot_Role_ro_unshift_string(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "unshift_string() in read-only instance of Role");
}
void
Parrot_Role_class_init(Parrot_Interp interp, int entry, int pass)
{
    const VTABLE temp_base_vtable = {
        NULL, /* namespace */
        enum_class_Role, /* base_type */
        NULL, /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_HAS_READONLY_FLAG, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        NULL,   /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_Role_add_attribute,
        Parrot_Role_add_method,
        Parrot_default_add_parent,
        Parrot_Role_add_role,
        Parrot_default_assign_pmc,
        Parrot_default_assign_string_native,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_can,
        Parrot_default_class_type,
        Parrot_default_clone,
        Parrot_default_clone_pmc,
        Parrot_default_decrement,
        Parrot_default_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_default_delete_keyed,
        Parrot_default_delete_keyed_int,
        Parrot_default_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_Role_destroy,
        Parrot_default_does,
        Parrot_default_elements,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_default_find_method,
        Parrot_default_freeze,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_default_get_bool,
        Parrot_default_get_class,
        Parrot_default_get_integer,
        Parrot_default_get_integer_keyed,
        Parrot_default_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_iter,
        Parrot_default_get_number,
        Parrot_default_get_number_keyed,
        Parrot_default_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_default_get_pmc_keyed,
        Parrot_default_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_default_get_repr,
        Parrot_default_get_string,
        Parrot_default_get_string_keyed,
        Parrot_default_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_default_hash,
        Parrot_default_i_absolute,
        Parrot_default_i_bitwise_not,
        Parrot_default_i_bitwise_nots,
        Parrot_default_i_logical_not,
        Parrot_default_i_neg,
        Parrot_default_increment,
        Parrot_Role_init,
        Parrot_Role_init_pmc,
        Parrot_Role_inspect,
        Parrot_Role_inspect_str,
        Parrot_default_instantiate,
        Parrot_default_invoke,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_logical_not,
        Parrot_Role_mark,
        Parrot_default_morph,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_new_from_string,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_pmc_namespace,
        Parrot_default_pop_float,
        Parrot_default_pop_integer,
        Parrot_default_pop_pmc,
        Parrot_default_pop_string,
        Parrot_default_push_float,
        Parrot_default_push_integer,
        Parrot_default_push_pmc,
        Parrot_default_push_string,
        Parrot_default_remove_attribute,
        Parrot_default_remove_method,
        Parrot_default_remove_parent,
        Parrot_default_remove_role,
        Parrot_default_set_attr,
        Parrot_default_set_attr_str,
        Parrot_default_set_bignum_int,
        Parrot_default_set_bignum_num,
        Parrot_default_set_bignum_str,
        Parrot_default_set_bool,
        Parrot_default_set_integer_keyed,
        Parrot_default_set_integer_keyed_int,
        Parrot_default_set_integer_keyed_str,
        Parrot_default_set_integer_native,
        Parrot_default_set_integer_same,
        Parrot_default_set_number_keyed,
        Parrot_default_set_number_keyed_int,
        Parrot_default_set_number_keyed_str,
        Parrot_default_set_number_native,
        Parrot_default_set_number_same,
        Parrot_default_set_pmc,
        Parrot_default_set_pmc_keyed,
        Parrot_default_set_pmc_keyed_int,
        Parrot_default_set_pmc_keyed_str,
        Parrot_default_set_pointer,
        Parrot_default_set_pointer_keyed,
        Parrot_default_set_pointer_keyed_int,
        Parrot_default_set_pointer_keyed_str,
        Parrot_default_set_string_keyed,
        Parrot_default_set_string_keyed_int,
        Parrot_default_set_string_keyed_str,
        Parrot_default_set_string_native,
        Parrot_default_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_default_shift_float,
        Parrot_default_shift_integer,
        Parrot_default_shift_pmc,
        Parrot_default_shift_string,
        Parrot_default_slice,
        Parrot_default_splice,
        Parrot_default_subclass,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtype,
        Parrot_default_thaw,
        Parrot_default_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_type_keyed_int,
        Parrot_default_type_keyed_str,
        Parrot_default_unshift_float,
        Parrot_default_unshift_integer,
        Parrot_default_unshift_pmc,
        Parrot_default_unshift_string,
        Parrot_default_visit
    };

    const VTABLE temp_ro_vtable = {
        NULL, /* namespace */
        enum_class_Role, /* base_type */
        NULL, /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_IS_READONLY_FLAG, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        NULL,   /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_Role_ro_add_attribute,
        Parrot_Role_ro_add_method,
        Parrot_Role_ro_add_parent,
        Parrot_Role_ro_add_role,
        Parrot_Role_ro_assign_pmc,
        Parrot_Role_ro_assign_string_native,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_can,
        Parrot_default_class_type,
        Parrot_default_clone,
        Parrot_default_clone_pmc,
        Parrot_Role_ro_decrement,
        Parrot_default_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_Role_ro_delete_keyed,
        Parrot_Role_ro_delete_keyed_int,
        Parrot_Role_ro_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_Role_destroy,
        Parrot_default_does,
        Parrot_default_elements,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_Role_ro_find_method,
        Parrot_default_freeze,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_default_get_bool,
        Parrot_default_get_class,
        Parrot_default_get_integer,
        Parrot_default_get_integer_keyed,
        Parrot_default_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_iter,
        Parrot_default_get_number,
        Parrot_default_get_number_keyed,
        Parrot_default_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_default_get_pmc_keyed,
        Parrot_default_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_default_get_repr,
        Parrot_default_get_string,
        Parrot_default_get_string_keyed,
        Parrot_default_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_default_hash,
        Parrot_Role_ro_i_absolute,
        Parrot_Role_ro_i_bitwise_not,
        Parrot_Role_ro_i_bitwise_nots,
        Parrot_Role_ro_i_logical_not,
        Parrot_Role_ro_i_neg,
        Parrot_Role_ro_increment,
        Parrot_Role_init,
        Parrot_Role_init_pmc,
        Parrot_Role_inspect,
        Parrot_Role_inspect_str,
        Parrot_default_instantiate,
        Parrot_default_invoke,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_logical_not,
        Parrot_Role_mark,
        Parrot_Role_ro_morph,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_new_from_string,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_pmc_namespace,
        Parrot_Role_ro_pop_float,
        Parrot_Role_ro_pop_integer,
        Parrot_Role_ro_pop_pmc,
        Parrot_Role_ro_pop_string,
        Parrot_Role_ro_push_float,
        Parrot_Role_ro_push_integer,
        Parrot_Role_ro_push_pmc,
        Parrot_Role_ro_push_string,
        Parrot_Role_ro_remove_attribute,
        Parrot_Role_ro_remove_method,
        Parrot_Role_ro_remove_parent,
        Parrot_Role_ro_remove_role,
        Parrot_Role_ro_set_attr,
        Parrot_Role_ro_set_attr_str,
        Parrot_Role_ro_set_bignum_int,
        Parrot_Role_ro_set_bignum_num,
        Parrot_Role_ro_set_bignum_str,
        Parrot_Role_ro_set_bool,
        Parrot_Role_ro_set_integer_keyed,
        Parrot_Role_ro_set_integer_keyed_int,
        Parrot_Role_ro_set_integer_keyed_str,
        Parrot_Role_ro_set_integer_native,
        Parrot_Role_ro_set_integer_same,
        Parrot_Role_ro_set_number_keyed,
        Parrot_Role_ro_set_number_keyed_int,
        Parrot_Role_ro_set_number_keyed_str,
        Parrot_Role_ro_set_number_native,
        Parrot_Role_ro_set_number_same,
        Parrot_Role_ro_set_pmc,
        Parrot_Role_ro_set_pmc_keyed,
        Parrot_Role_ro_set_pmc_keyed_int,
        Parrot_Role_ro_set_pmc_keyed_str,
        Parrot_Role_ro_set_pointer,
        Parrot_Role_ro_set_pointer_keyed,
        Parrot_Role_ro_set_pointer_keyed_int,
        Parrot_Role_ro_set_pointer_keyed_str,
        Parrot_Role_ro_set_string_keyed,
        Parrot_Role_ro_set_string_keyed_int,
        Parrot_Role_ro_set_string_keyed_str,
        Parrot_Role_ro_set_string_native,
        Parrot_Role_ro_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_Role_ro_shift_float,
        Parrot_Role_ro_shift_integer,
        Parrot_Role_ro_shift_pmc,
        Parrot_Role_ro_shift_string,
        Parrot_default_slice,
        Parrot_Role_ro_splice,
        Parrot_default_subclass,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtype,
        Parrot_Role_ro_thaw,
        Parrot_Role_ro_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_type_keyed_int,
        Parrot_default_type_keyed_str,
        Parrot_Role_ro_unshift_float,
        Parrot_Role_ro_unshift_integer,
        Parrot_Role_ro_unshift_pmc,
        Parrot_Role_ro_unshift_string,
        Parrot_default_visit
    };
    if (pass == 0) {
        /*
         * create vtable - clone it - we have to set a few items
         */
        VTABLE *vt_clone =
            Parrot_clone_vtable(interp, &temp_base_vtable);
        VTABLE *vt_ro_clone =
            Parrot_clone_vtable(interp, &temp_ro_vtable);
        vt_clone->whoami = CONST_STRING(interp, "Role");
        vt_clone->isa_str = CONST_STRING(interp, "Role");
        vt_clone->does_str = CONST_STRING(interp, "scalar");
        vt_ro_clone->base_type = entry;
        vt_ro_clone->whoami = vt_clone->whoami;
        vt_ro_clone->isa_str = vt_clone->isa_str;
        vt_ro_clone->does_str = vt_clone->does_str;
        vt_clone->ro_variant_vtable = vt_ro_clone;
        vt_ro_clone->ro_variant_vtable = vt_clone;
        interp->vtables[entry] = vt_clone;
    }
    else { /* pass */
        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        /* create PMC Proxy object */
        Parrot_create_pmc_proxy(interp, entry);
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_Role_nci_name), "name");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_Role_nci_pmc_namespace), "pmc_namespace");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_Role_nci_attributes), "attributes");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_Role_nci_add_attribute), "add_attribute");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_Role_nci_methods), "methods");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_Role_nci_add_method), "add_method");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_Role_nci_roles), "roles");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_Role_nci_add_role), "add_role");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_Role_nci_inspect), "inspect");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_Role_nci_does), "does");
        /* class_init */
        {
        }
    } /* pass */
} /* Parrot_Role_class_init */
 /* end pmclass Role */


/*

=back

=head1 STABILITY

Unstable. This PMC is under active development; major portions of the
interface have not yet been completed.

=head1 SEE ALSO

F<docs/pdds/pdd15_objects.pod>.

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
