/*
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/scalar.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

#line 1 "./src/pmc/scalar.pmc"
/*
Copyright (C) 2001-2006, The Perl Foundation.
$Id: scalar.pmc 18686 2007-05-30 14:15:01Z petdance $

=head1 NAME

src/pmc/scalar.pmc - Scalar Abstract Superclass

=head1 DESCRIPTION

These are the vtable functions for the scalar base PMC class

=head2 Methods

=over 4

=cut

*/

#include "parrot/parrot.h"

/* XXX This should be declared in a .h file somewhere */
extern PMC *
Parrot_BigInt_bitwise_shl_int(Interp *interp, PMC* pmc, INTVAL value, PMC* dest);

static PMC *
bitwise_left_shift_internal(Interp *interp, PMC *self,
                            PMC *dest, INTVAL shift_amount)
{
    /* This handles both left and right shifts; the sign of shift_amount
       controls the direction, shifting left if positive and right if negative.
       If we get an error (which can only happen for left shifts) and
       PARROT_ERRORS_OVERFLOW_FLAG is set, then we throw an error, else the
       destination is promoted to a BigInt before shifting.  If dest == self,
       then the shift is done in place.  */
    const INTVAL base = VTABLE_get_integer(interp, self);
    INTVAL result;
    int overflow_p = 0;

    /* Compute the shift. */
    if (shift_amount >= 8*INTVAL_SIZE) {
        /* Extreme left shift; no need to do an integer shift first. */
        overflow_p = 1;
    }
    else if (shift_amount >= 0) {
        /* Left shift. */
        result = base << shift_amount;
        overflow_p = (result >> shift_amount) != base;
    }
    else if (shift_amount > -8*INTVAL_SIZE) {
        /* Right shift.  By definition, this can never overflow. */
        result = base >> -shift_amount;
    }
    else {
        /* Extreme right shift. */
        result = 0;
    }

    /* Store the result. */
    if (! overflow_p) {
        if (!dest)
            dest = pmc_new(interp, self->vtable->base_type);
        VTABLE_set_integer_native(interp, dest, result);
    }
    else if (PARROT_ERRORS_test(interp, PARROT_ERRORS_OVERFLOW_FLAG)) {
        real_exception(interp, NULL, ERR_OVERFLOW, "Integer overflow");
    }
    else {
        /* Overflow; must promote dest to BigInt, and do a BigInt shift. */
        if (dest)
            VTABLE_morph(interp, dest, enum_class_BigInt);
        else {
            /* Arguably, we should throw an error here if dest == self and self
             * is not a numeric type.  However, that would require a firmer
             * definition of "numeric type."
             */
            dest = pmc_new(interp, enum_class_BigInt);
        }
        VTABLE_set_integer_native(interp, dest, base);
        Parrot_BigInt_bitwise_shl_int(interp, dest, shift_amount, dest);
    }
    return dest;
}

#line 98 "src/pmc/scalar.c"
#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_scalar.h"
#include "pmc_default.h"
#include "scalar.str"

PMC*
Parrot_scalar_add(Interp *interp, PMC* pmc, PMC* value, PMC* dest)
#line 204 "./src/pmc/scalar.pmc"
{
        if (!dest)
            dest = pmc_new(interp, pmc->vtable->base_type);
        VTABLE_set_number_native(interp, dest,
                 VTABLE_get_number(interp, pmc) + VTABLE_get_number(interp, value));
        return dest;
}
#line 116 "src/pmc/scalar.c"
PMC*
Parrot_scalar_add_Complex(Interp *interp, PMC* pmc, PMC* value, PMC* dest)
{
        const FLOATVAL a =  VTABLE_get_number(interp, pmc);
        if (dest)
            VTABLE_morph(interp, dest, value->vtable->base_type);
        else
            dest = pmc_new(interp, value->vtable->base_type);
        VTABLE_set_number_native(interp, dest,
                a + VTABLE_get_number_keyed_int(interp, value, 0));
        VTABLE_set_number_keyed_int(interp, dest, 1,
                VTABLE_get_number_keyed_int(interp, value, 1));
        return dest;
}
PMC*
Parrot_scalar_add_int(Interp *interp, PMC* pmc, INTVAL value, PMC* dest)
#line 226 "./src/pmc/scalar.pmc"
{
    if (!dest)
        dest = pmc_new(interp, pmc->vtable->base_type);
    VTABLE_set_number_native(interp, dest,
             VTABLE_get_number(interp, pmc) + (FLOATVAL)value);
    return dest;

}
#line 142 "src/pmc/scalar.c"
PMC*
Parrot_scalar_add_float(Interp *interp, PMC* pmc, FLOATVAL value, PMC* dest)
#line 234 "./src/pmc/scalar.pmc"
{
    if (!dest)
        dest = pmc_new(interp, pmc->vtable->base_type);
    VTABLE_set_number_native(interp, dest,
             VTABLE_get_number(interp, pmc) + value);
    return dest;

}
#line 154 "src/pmc/scalar.c"
void
Parrot_scalar_i_add(Interp *interp, PMC* pmc, PMC* value)
#line 242 "./src/pmc/scalar.pmc"
{
        VTABLE_set_number_native(interp, pmc,
             VTABLE_get_number(interp, pmc) + VTABLE_get_number(interp, value));
}
#line 162 "src/pmc/scalar.c"
void
Parrot_scalar_i_add_Complex(Interp *interp, PMC* pmc, PMC* value)
{
        const FLOATVAL a =  VTABLE_get_number(interp, pmc);
        VTABLE_morph(interp, pmc, value->vtable->base_type);
        VTABLE_set_number_native(interp, pmc,
                a + VTABLE_get_number_keyed_int(interp, value, 0));
        VTABLE_set_number_keyed_int(interp, pmc, 1,
                VTABLE_get_number_keyed_int(interp, value, 1));
}
void
Parrot_scalar_i_add_int(Interp *interp, PMC* pmc, INTVAL value)
#line 257 "./src/pmc/scalar.pmc"
{
    VTABLE_set_number_native(interp, pmc,
         VTABLE_get_number(interp, pmc) + (FLOATVAL)value);

}
#line 181 "src/pmc/scalar.c"
void
Parrot_scalar_i_add_float(Interp *interp, PMC* pmc, FLOATVAL value)
#line 262 "./src/pmc/scalar.pmc"
{
    VTABLE_set_number_native(interp, pmc,
         VTABLE_get_number(interp, pmc) + value);

}
#line 190 "src/pmc/scalar.c"
PMC*
Parrot_scalar_subtract(Interp *interp, PMC* pmc, PMC* value, PMC* dest)
#line 290 "./src/pmc/scalar.pmc"
{
        if (!dest)
            dest = pmc_new(interp, pmc->vtable->base_type);
        VTABLE_set_number_native(interp, dest,
                 VTABLE_get_number(interp, pmc) - VTABLE_get_number(interp, value));
        return dest;
}
#line 201 "src/pmc/scalar.c"
PMC*
Parrot_scalar_subtract_Complex(Interp *interp, PMC* pmc, PMC* value, PMC* dest)
{
        const FLOATVAL a =  VTABLE_get_number(interp, pmc);
        if (dest)
            VTABLE_morph(interp, dest, value->vtable->base_type);
        else
            dest = pmc_new(interp, value->vtable->base_type);
        VTABLE_set_number_native(interp, dest,
                a - VTABLE_get_number_keyed_int(interp, value, 0));
        VTABLE_set_number_keyed_int(interp, dest, 1,
                -VTABLE_get_number_keyed_int(interp, value, 1));
        return dest;
}
PMC*
Parrot_scalar_subtract_int(Interp *interp, PMC* pmc, INTVAL value, PMC* dest)
#line 312 "./src/pmc/scalar.pmc"
{
    if (!dest)
        dest = pmc_new(interp, pmc->vtable->base_type);
    VTABLE_set_number_native(interp, dest,
             VTABLE_get_number(interp, pmc) - (FLOATVAL)value);
    return dest;

}
#line 227 "src/pmc/scalar.c"
PMC*
Parrot_scalar_subtract_float(Interp *interp, PMC* pmc, FLOATVAL value, PMC* dest)
#line 320 "./src/pmc/scalar.pmc"
{
    if (!dest)
        dest = pmc_new(interp, pmc->vtable->base_type);
    VTABLE_set_number_native(interp, dest,
             VTABLE_get_number(interp, pmc) - value);
    return dest;

}
#line 239 "src/pmc/scalar.c"
void
Parrot_scalar_i_subtract(Interp *interp, PMC* pmc, PMC* value)
#line 328 "./src/pmc/scalar.pmc"
{
        VTABLE_set_number_native(interp, pmc,
             VTABLE_get_number(interp, pmc) - VTABLE_get_number(interp, value));
}
#line 247 "src/pmc/scalar.c"
void
Parrot_scalar_i_subtract_Complex(Interp *interp, PMC* pmc, PMC* value)
{
        const FLOATVAL a =  VTABLE_get_number(interp, pmc);
        VTABLE_morph(interp, pmc, value->vtable->base_type);
        VTABLE_set_number_native(interp, pmc,
                a - VTABLE_get_number_keyed_int(interp, value, 0));
        VTABLE_set_number_keyed_int(interp, pmc, 1,
                -VTABLE_get_number_keyed_int(interp, value, 1));
}
void
Parrot_scalar_i_subtract_int(Interp *interp, PMC* pmc, INTVAL value)
#line 343 "./src/pmc/scalar.pmc"
{
    VTABLE_set_number_native(interp, pmc,
         VTABLE_get_number(interp, pmc) - (FLOATVAL)value);

}
#line 266 "src/pmc/scalar.c"
void
Parrot_scalar_i_subtract_float(Interp *interp, PMC* pmc, FLOATVAL value)
#line 348 "./src/pmc/scalar.pmc"
{
    VTABLE_set_number_native(interp, pmc,
         VTABLE_get_number(interp, pmc) - value);

}
#line 275 "src/pmc/scalar.c"
PMC*
Parrot_scalar_multiply(Interp *interp, PMC* pmc, PMC* value, PMC* dest)
#line 368 "./src/pmc/scalar.pmc"
{
        if (!dest)
            dest = pmc_new(interp, pmc->vtable->base_type);
        VTABLE_set_number_native(interp, dest,
             VTABLE_get_number(interp, pmc) * VTABLE_get_number(interp, value));
        return dest;
}
#line 286 "src/pmc/scalar.c"
PMC*
Parrot_scalar_multiply_Complex(Interp *interp, PMC* pmc, PMC* value, PMC* dest)
{
        real_exception(interp, NULL, E_NotImplementedError,
                "TODO mul<Float, Complex>");
        return dest;
}
PMC*
Parrot_scalar_multiply_int(Interp *interp, PMC* pmc, INTVAL value, PMC* dest)
#line 383 "./src/pmc/scalar.pmc"
{
    if (!dest)
        dest = pmc_new(interp, pmc->vtable->base_type);
    VTABLE_set_number_native(interp, dest,
         VTABLE_get_number(interp, pmc) * value);
    return dest;

}
#line 305 "src/pmc/scalar.c"
PMC*
Parrot_scalar_multiply_float(Interp *interp, PMC* pmc, FLOATVAL value, PMC* dest)
#line 391 "./src/pmc/scalar.pmc"
{
    if (!dest)
        dest = pmc_new(interp, pmc->vtable->base_type);
    VTABLE_set_number_native(interp, dest,
         VTABLE_get_number(interp, pmc) * value);
    return dest;

}
#line 317 "src/pmc/scalar.c"
void
Parrot_scalar_i_multiply(Interp *interp, PMC* pmc, PMC* value)
#line 399 "./src/pmc/scalar.pmc"
{
        VTABLE_set_number_native(interp, pmc,
             VTABLE_get_number(interp, pmc) * VTABLE_get_number(interp, value));
}
#line 325 "src/pmc/scalar.c"
void
Parrot_scalar_i_multiply_Complex(Interp *interp, PMC* pmc, PMC* value)
{
        real_exception(interp, NULL, E_NotImplementedError,
                "TODO i_mul<Float, Complex>");
}
void
Parrot_scalar_i_multiply_int(Interp *interp, PMC* pmc, INTVAL value)
#line 410 "./src/pmc/scalar.pmc"
{
    VTABLE_set_number_native(interp, pmc,
         VTABLE_get_number(interp, pmc) * (FLOATVAL)value);

}
#line 340 "src/pmc/scalar.c"
void
Parrot_scalar_i_multiply_float(Interp *interp, PMC* pmc, FLOATVAL value)
#line 415 "./src/pmc/scalar.pmc"
{
    VTABLE_set_number_native(interp, pmc,
         VTABLE_get_number(interp, pmc) * value);

}
#line 349 "src/pmc/scalar.c"
PMC*
Parrot_scalar_divide(Interp *interp, PMC* pmc, PMC* value, PMC* dest)
#line 442 "./src/pmc/scalar.pmc"
{
    const FLOATVAL d = VTABLE_get_number(interp, value);

    if (d == 0.0)
        real_exception(interp, NULL, E_ZeroDivisionError,
                "float division by zero");
    if (!dest)
        dest = pmc_new(interp, pmc->vtable->base_type);
    VTABLE_set_number_native(interp, dest,  VTABLE_get_number(interp, pmc) / d);
    return dest;

}
#line 365 "src/pmc/scalar.c"
PMC*
Parrot_scalar_divide_int(Interp *interp, PMC* pmc, INTVAL value, PMC* dest)
#line 454 "./src/pmc/scalar.pmc"
{
    if (value == 0)
        real_exception(interp, NULL, E_ZeroDivisionError,
                "float division by zero");
    if (!dest)
        dest = pmc_new(interp, pmc->vtable->base_type);
    VTABLE_set_number_native(interp, dest,  VTABLE_get_number(interp, pmc) / value);
    return dest;

}
#line 379 "src/pmc/scalar.c"
PMC*
Parrot_scalar_divide_float(Interp *interp, PMC* pmc, FLOATVAL value, PMC* dest)
#line 464 "./src/pmc/scalar.pmc"
{
    if (value == 0.0)
        real_exception(interp, NULL, E_ZeroDivisionError,
                "float division by zero");
    if (!dest)
        dest = pmc_new(interp, pmc->vtable->base_type);
    VTABLE_set_number_native(interp, dest,  VTABLE_get_number(interp, pmc) / value);
    return dest;

}
#line 393 "src/pmc/scalar.c"
void
Parrot_scalar_i_divide(Interp *interp, PMC* pmc, PMC* value)
#line 474 "./src/pmc/scalar.pmc"
{
    const FLOATVAL d = VTABLE_get_number(interp, value);

    if (d == 0.0)
        real_exception(interp, NULL, E_ZeroDivisionError,
                "float division by zero");
    VTABLE_set_number_native(interp, pmc,  VTABLE_get_number(interp, pmc) / d);

}
#line 406 "src/pmc/scalar.c"
void
Parrot_scalar_i_divide_int(Interp *interp, PMC* pmc, INTVAL value)
#line 483 "./src/pmc/scalar.pmc"
{
    if (value == 0)
        real_exception(interp, NULL, E_ZeroDivisionError,
                "float division by zero");
    VTABLE_set_number_native(interp, pmc,  VTABLE_get_number(interp, pmc) / value);

}
#line 417 "src/pmc/scalar.c"
void
Parrot_scalar_i_divide_float(Interp *interp, PMC* pmc, FLOATVAL value)
#line 490 "./src/pmc/scalar.pmc"
{
    if (value == 0.0)
        real_exception(interp, NULL, E_ZeroDivisionError,
                "float division by zero");
    VTABLE_set_number_native(interp, pmc,  VTABLE_get_number(interp, pmc) / value);

}
#line 428 "src/pmc/scalar.c"
PMC*
Parrot_scalar_floor_divide(Interp *interp, PMC* pmc, PMC* value, PMC* dest)
#line 519 "./src/pmc/scalar.pmc"
{
    const FLOATVAL d = VTABLE_get_number(interp, value);

    if (d == 0.0)
        real_exception(interp, NULL, E_ZeroDivisionError,
                "float division by zero");
    if (!dest)
        dest = pmc_new(interp, pmc->vtable->base_type);
    VTABLE_set_number_native(interp, dest,
            floor( VTABLE_get_number(interp, pmc) / d));
    return dest;

}
#line 445 "src/pmc/scalar.c"
PMC*
Parrot_scalar_floor_divide_int(Interp *interp, PMC* pmc, INTVAL value, PMC* dest)
#line 532 "./src/pmc/scalar.pmc"
{
    if (value == 0)
        real_exception(interp, NULL, E_ZeroDivisionError,
                "float division by zero");
    if (!dest)
        dest = pmc_new(interp, pmc->vtable->base_type);
    VTABLE_set_number_native(interp, dest,
            floor( VTABLE_get_number(interp, pmc) / value));
    return dest;

}
#line 460 "src/pmc/scalar.c"
PMC*
Parrot_scalar_floor_divide_float(Interp *interp, PMC* pmc, FLOATVAL value, PMC* dest)
#line 543 "./src/pmc/scalar.pmc"
{
    if (value == 0.0)
        real_exception(interp, NULL, E_ZeroDivisionError,
                "float division by zero");
    if (!dest)
        dest = pmc_new(interp, pmc->vtable->base_type);
    VTABLE_set_number_native(interp, dest,
            floor( VTABLE_get_number(interp, pmc) / value));
    return dest;

}
#line 475 "src/pmc/scalar.c"
void
Parrot_scalar_i_floor_divide(Interp *interp, PMC* pmc, PMC* value)
#line 554 "./src/pmc/scalar.pmc"
{
    const FLOATVAL d = VTABLE_get_number(interp, value);

    if (d == 0.0)
        real_exception(interp, NULL, E_ZeroDivisionError,
                "float division by zero");
    VTABLE_set_number_native(interp, pmc,
            floor( VTABLE_get_number(interp, pmc) / d));

}
#line 489 "src/pmc/scalar.c"
void
Parrot_scalar_i_floor_divide_int(Interp *interp, PMC* pmc, INTVAL value)
#line 564 "./src/pmc/scalar.pmc"
{
    if (value == 0)
        real_exception(interp, NULL, E_ZeroDivisionError,
                "float division by zero");
    VTABLE_set_number_native(interp, pmc,
            floor( VTABLE_get_number(interp, pmc) / value));

}
#line 501 "src/pmc/scalar.c"
void
Parrot_scalar_i_floor_divide_float(Interp *interp, PMC* pmc, FLOATVAL value)
#line 572 "./src/pmc/scalar.pmc"
{
    if (value == 0.0)
        real_exception(interp, NULL, E_ZeroDivisionError,
                "float division by zero");
    VTABLE_set_number_native(interp, pmc,
            floor( VTABLE_get_number(interp, pmc) / value));

}
#line 513 "src/pmc/scalar.c"
PMC*
Parrot_scalar_modulus(Interp *interp, PMC* pmc, PMC* value, PMC* dest)
#line 688 "./src/pmc/scalar.pmc"
{
    const FLOATVAL d = VTABLE_get_number(interp, value);

    if (d == 0.0)
        real_exception(interp, NULL, E_ZeroDivisionError,
                "float modulus by zero");
    if (!dest)
        dest = pmc_new(interp, pmc->vtable->base_type);
    VTABLE_set_number_native(interp, dest,
            floatval_mod( VTABLE_get_number(interp, pmc), d));
    return dest;

}
#line 530 "src/pmc/scalar.c"
PMC*
Parrot_scalar_modulus_int(Interp *interp, PMC* pmc, INTVAL value, PMC* dest)
#line 701 "./src/pmc/scalar.pmc"
{
    if (value == 0)
        real_exception(interp, NULL, E_ZeroDivisionError,
                "float modulus by zero");
    if (!dest)
        dest = pmc_new(interp, pmc->vtable->base_type);
    VTABLE_set_number_native(interp, dest,
            floatval_mod( VTABLE_get_number(interp, pmc), value));
    return dest;

}
#line 545 "src/pmc/scalar.c"
PMC*
Parrot_scalar_modulus_float(Interp *interp, PMC* pmc, FLOATVAL value, PMC* dest)
#line 712 "./src/pmc/scalar.pmc"
{
    if (value == 0.0)
        real_exception(interp, NULL, E_ZeroDivisionError,
                "float modulus by zero");
    if (!dest)
        dest = pmc_new(interp, pmc->vtable->base_type);
    VTABLE_set_number_native(interp, dest,
            floatval_mod( VTABLE_get_number(interp, pmc), value));
    return dest;

}
#line 560 "src/pmc/scalar.c"
void
Parrot_scalar_i_modulus(Interp *interp, PMC* pmc, PMC* value)
#line 723 "./src/pmc/scalar.pmc"
{
    const FLOATVAL d = VTABLE_get_number(interp, value);

    if (d == 0.0)
        real_exception(interp, NULL, E_ZeroDivisionError,
                "float modulus by zero");
    VTABLE_set_number_native(interp, pmc,
            floatval_mod( VTABLE_get_number(interp, pmc) , d));

}
#line 574 "src/pmc/scalar.c"
void
Parrot_scalar_i_modulus_int(Interp *interp, PMC* pmc, INTVAL value)
#line 733 "./src/pmc/scalar.pmc"
{
    if (value == 0)
        real_exception(interp, NULL, E_ZeroDivisionError,
                "float modulus by zero");
    VTABLE_set_number_native(interp, pmc,
            floatval_mod( VTABLE_get_number(interp, pmc) , value));

}
#line 586 "src/pmc/scalar.c"
void
Parrot_scalar_i_modulus_float(Interp *interp, PMC* pmc, FLOATVAL value)
#line 741 "./src/pmc/scalar.pmc"
{
    if (value == 0.0)
        real_exception(interp, NULL, E_ZeroDivisionError,
                "float modulus by zero");
    VTABLE_set_number_native(interp, pmc,
            floatval_mod( VTABLE_get_number(interp, pmc) , value));

}
#line 598 "src/pmc/scalar.c"
PMC*
Parrot_scalar_cmodulus(Interp *interp, PMC* pmc, PMC* value, PMC* dest)
#line 605 "./src/pmc/scalar.pmc"
{
    const FLOATVAL d = VTABLE_get_number(interp, value);

    if (d == 0.0)
        real_exception(interp, NULL, E_ZeroDivisionError,
                "float cmodulus by zero");
    if (!dest)
        dest = pmc_new(interp, pmc->vtable->base_type);
    VTABLE_set_number_native(interp, dest,
            fmod( VTABLE_get_number(interp, pmc), d));
    return dest;

}
#line 615 "src/pmc/scalar.c"
PMC*
Parrot_scalar_cmodulus_float(Interp *interp, PMC* pmc, FLOATVAL value, PMC* dest)
#line 629 "./src/pmc/scalar.pmc"
{
    if (value == 0)
        real_exception(interp, NULL, E_ZeroDivisionError,
                "float cmodulus by zero");
    if (!dest)
        dest = pmc_new(interp, pmc->vtable->base_type);
    VTABLE_set_number_native(interp, dest,
            fmod( VTABLE_get_number(interp, pmc), value));
    return dest;

}
#line 630 "src/pmc/scalar.c"
void
Parrot_scalar_i_cmodulus(Interp *interp, PMC* pmc, PMC* value)
#line 639 "./src/pmc/scalar.pmc"
{
    const FLOATVAL d = VTABLE_get_number(interp, value);

    if (d == 0.0)
        real_exception(interp, NULL, E_ZeroDivisionError,
                "float cmodulus by zero");
    VTABLE_set_number_native(interp, pmc,
            fmod( VTABLE_get_number(interp, pmc) , d));

}
#line 644 "src/pmc/scalar.c"
void
Parrot_scalar_i_cmodulus_int(Interp *interp, PMC* pmc, INTVAL value)
#line 649 "./src/pmc/scalar.pmc"
{
    if (value == 0)
        real_exception(interp, NULL, E_ZeroDivisionError,
                "float cmodulus by zero");
    VTABLE_set_number_native(interp, pmc,
            fmod( VTABLE_get_number(interp, pmc) , value));

}
#line 656 "src/pmc/scalar.c"
void
Parrot_scalar_i_cmodulus_float(Interp *interp, PMC* pmc, FLOATVAL value)
#line 657 "./src/pmc/scalar.pmc"
{
    if (value == 0.0)
        real_exception(interp, NULL, E_ZeroDivisionError,
                "float cmodulus by zero");
    VTABLE_set_number_native(interp, pmc,
            fmod( VTABLE_get_number(interp, pmc) , value));

}
#line 668 "src/pmc/scalar.c"
PMC*
Parrot_scalar_pow(Interp *interp, PMC* pmc, PMC* value, PMC* dest)
#line 772 "./src/pmc/scalar.pmc"
{
    const FLOATVAL d = VTABLE_get_number(interp, value);

    if (!dest)
        dest = pmc_new(interp, pmc->vtable->base_type);
    VTABLE_set_number_native(interp, dest,
            pow( VTABLE_get_number(interp, pmc), d));
    return dest;

}
#line 682 "src/pmc/scalar.c"
PMC*
Parrot_scalar_pow_int(Interp *interp, PMC* pmc, INTVAL value, PMC* dest)
#line 782 "./src/pmc/scalar.pmc"
{
    if (!dest)
        dest = pmc_new(interp, pmc->vtable->base_type);
    VTABLE_set_number_native(interp, dest,
            pow( VTABLE_get_number(interp, pmc), value));
    return dest;

}
#line 694 "src/pmc/scalar.c"
PMC*
Parrot_scalar_pow_float(Interp *interp, PMC* pmc, FLOATVAL value, PMC* dest)
#line 790 "./src/pmc/scalar.pmc"
{
    if (!dest)
        dest = pmc_new(interp, pmc->vtable->base_type);
    VTABLE_set_number_native(interp, dest,
            pow( VTABLE_get_number(interp, pmc), value));
    return dest;

}
#line 706 "src/pmc/scalar.c"
void
Parrot_scalar_i_pow(Interp *interp, PMC* pmc, PMC* value)
#line 798 "./src/pmc/scalar.pmc"
{
    const FLOATVAL d = VTABLE_get_number(interp, value);

    VTABLE_set_number_native(interp, pmc,
            pow( VTABLE_get_number(interp, pmc), d));

}
#line 717 "src/pmc/scalar.c"
void
Parrot_scalar_i_pow_int(Interp *interp, PMC* pmc, INTVAL value)
#line 805 "./src/pmc/scalar.pmc"
{
    VTABLE_set_number_native(interp, pmc,
            pow( VTABLE_get_number(interp, pmc), value));

}
#line 726 "src/pmc/scalar.c"
void
Parrot_scalar_i_pow_float(Interp *interp, PMC* pmc, FLOATVAL value)
#line 810 "./src/pmc/scalar.pmc"
{
    VTABLE_set_number_native(interp, pmc,
            pow( VTABLE_get_number(interp, pmc), value));

}
#line 735 "src/pmc/scalar.c"
PMC*
Parrot_scalar_bitwise_or(Interp *interp, PMC* pmc, PMC* value, PMC* dest)
#line 863 "./src/pmc/scalar.pmc"
{
    const INTVAL result =  VTABLE_get_integer(interp, pmc) | VTABLE_get_integer(interp, value);

    if (!dest)
        dest = pmc_new(interp, pmc->vtable->base_type);
    VTABLE_set_integer_native(interp, dest, result);
    return dest;

}
#line 748 "src/pmc/scalar.c"
PMC*
Parrot_scalar_bitwise_or_int(Interp *interp, PMC* pmc, INTVAL value, PMC* dest)
#line 873 "./src/pmc/scalar.pmc"
{
    const INTVAL result =  VTABLE_get_integer(interp, pmc) | value;
    if (!dest)
        dest = pmc_new(interp, pmc->vtable->base_type);
    VTABLE_set_integer_native(interp, dest, result);
    return dest;

}
#line 760 "src/pmc/scalar.c"
void
Parrot_scalar_i_bitwise_or(Interp *interp, PMC* pmc, PMC* value)
#line 881 "./src/pmc/scalar.pmc"
{
    const INTVAL result =  VTABLE_get_integer(interp, pmc) | VTABLE_get_integer(interp, value);
     VTABLE_set_integer_native(interp, pmc, result);

}
#line 769 "src/pmc/scalar.c"
void
Parrot_scalar_i_bitwise_or_int(Interp *interp, PMC* pmc, INTVAL value)
#line 887 "./src/pmc/scalar.pmc"
{
    const INTVAL result =  VTABLE_get_integer(interp, pmc) | value;
     VTABLE_set_integer_native(interp, pmc, result);

}
#line 778 "src/pmc/scalar.c"
PMC*
Parrot_scalar_bitwise_and(Interp *interp, PMC* pmc, PMC* value, PMC* dest)
#line 910 "./src/pmc/scalar.pmc"
{
    const INTVAL result =  VTABLE_get_integer(interp, pmc) & VTABLE_get_integer(interp, value);
    if (!dest)
        dest = pmc_new(interp, pmc->vtable->base_type);
    VTABLE_set_integer_native(interp, dest, result);
    return dest;

}
#line 790 "src/pmc/scalar.c"
PMC*
Parrot_scalar_bitwise_and_int(Interp *interp, PMC* pmc, INTVAL value, PMC* dest)
#line 918 "./src/pmc/scalar.pmc"
{
    const INTVAL result =  VTABLE_get_integer(interp, pmc) & value;
    if (!dest)
        dest = pmc_new(interp, pmc->vtable->base_type);
    VTABLE_set_integer_native(interp, dest, result);
    return dest;

}
#line 802 "src/pmc/scalar.c"
void
Parrot_scalar_i_bitwise_and(Interp *interp, PMC* pmc, PMC* value)
#line 926 "./src/pmc/scalar.pmc"
{
    const INTVAL result =  VTABLE_get_integer(interp, pmc) & VTABLE_get_integer(interp, value);
     VTABLE_set_integer_native(interp, pmc, result);

}
#line 811 "src/pmc/scalar.c"
void
Parrot_scalar_i_bitwise_and_int(Interp *interp, PMC* pmc, INTVAL value)
#line 932 "./src/pmc/scalar.pmc"
{
    const INTVAL result =  VTABLE_get_integer(interp, pmc) & value;
     VTABLE_set_integer_native(interp, pmc, result);

}
#line 820 "src/pmc/scalar.c"
PMC*
Parrot_scalar_bitwise_xor(Interp *interp, PMC* pmc, PMC* value, PMC* dest)
#line 955 "./src/pmc/scalar.pmc"
{
    const INTVAL result =  VTABLE_get_integer(interp, pmc) ^ VTABLE_get_integer(interp, value);
    if (!dest)
        dest = pmc_new(interp, pmc->vtable->base_type);
    VTABLE_set_integer_native(interp, dest, result);
    return dest;

}
#line 832 "src/pmc/scalar.c"
PMC*
Parrot_scalar_bitwise_xor_int(Interp *interp, PMC* pmc, INTVAL value, PMC* dest)
#line 963 "./src/pmc/scalar.pmc"
{
    const INTVAL result =  VTABLE_get_integer(interp, pmc) ^ value;
    if (!dest)
        dest = pmc_new(interp, pmc->vtable->base_type);
    VTABLE_set_integer_native(interp, dest, result);
    return dest;

}
#line 844 "src/pmc/scalar.c"
void
Parrot_scalar_i_bitwise_xor(Interp *interp, PMC* pmc, PMC* value)
#line 971 "./src/pmc/scalar.pmc"
{
    const INTVAL result =  VTABLE_get_integer(interp, pmc) ^ VTABLE_get_integer(interp, value);
     VTABLE_set_integer_native(interp, pmc, result);

}
#line 853 "src/pmc/scalar.c"
void
Parrot_scalar_i_bitwise_xor_int(Interp *interp, PMC* pmc, INTVAL value)
#line 976 "./src/pmc/scalar.pmc"
{
    const INTVAL result =  VTABLE_get_integer(interp, pmc) ^ value;
     VTABLE_set_integer_native(interp, pmc, result);

}
#line 862 "src/pmc/scalar.c"
PMC*
Parrot_scalar_bitwise_shl(Interp *interp, PMC* pmc, PMC* value, PMC* dest)
#line 1113 "./src/pmc/scalar.pmc"
{
    return bitwise_left_shift_internal(interp, pmc, dest,
                                       VTABLE_get_integer(interp, value));

}
#line 871 "src/pmc/scalar.c"
PMC*
Parrot_scalar_bitwise_shl_int(Interp *interp, PMC* pmc, INTVAL value, PMC* dest)
#line 1118 "./src/pmc/scalar.pmc"
{
    return bitwise_left_shift_internal(interp, pmc, dest, value);

}
#line 879 "src/pmc/scalar.c"
void
Parrot_scalar_i_bitwise_shl(Interp *interp, PMC* pmc, PMC* value)
#line 1122 "./src/pmc/scalar.pmc"
{
    bitwise_left_shift_internal(interp, pmc, pmc,
                                VTABLE_get_integer(interp, value));

}
#line 888 "src/pmc/scalar.c"
void
Parrot_scalar_i_bitwise_shl_int(Interp *interp, PMC* pmc, INTVAL value)
#line 1127 "./src/pmc/scalar.pmc"
{
    bitwise_left_shift_internal(interp, pmc, pmc, value);

}
#line 896 "src/pmc/scalar.c"
PMC*
Parrot_scalar_bitwise_shr(Interp *interp, PMC* pmc, PMC* value, PMC* dest)
#line 1029 "./src/pmc/scalar.pmc"
{
    return bitwise_left_shift_internal(interp, pmc, dest,
                                       -VTABLE_get_integer(interp, value));

}
#line 905 "src/pmc/scalar.c"
PMC*
Parrot_scalar_bitwise_shr_int(Interp *interp, PMC* pmc, INTVAL value, PMC* dest)
#line 1034 "./src/pmc/scalar.pmc"
{
    return bitwise_left_shift_internal(interp, pmc, dest, -value);

}
#line 913 "src/pmc/scalar.c"
void
Parrot_scalar_i_bitwise_shr(Interp *interp, PMC* pmc, PMC* value)
#line 1038 "./src/pmc/scalar.pmc"
{
    bitwise_left_shift_internal(interp, pmc, pmc,
                                -VTABLE_get_integer(interp, value));

}
#line 922 "src/pmc/scalar.c"
void
Parrot_scalar_i_bitwise_shr_int(Interp *interp, PMC* pmc, INTVAL value)
#line 1043 "./src/pmc/scalar.pmc"
{
    bitwise_left_shift_internal(interp, pmc, pmc, -value);

}
#line 930 "src/pmc/scalar.c"
PMC*
Parrot_scalar_bitwise_lsr(Interp *interp, PMC* pmc, PMC* value, PMC* dest)
#line 1065 "./src/pmc/scalar.pmc"
{
    const INTVAL result = (UINTVAL) VTABLE_get_integer(interp, pmc) >>
        VTABLE_get_integer(interp, value);
    if (!dest)
        dest = pmc_new(interp, pmc->vtable->base_type);
    VTABLE_set_integer_native(interp, dest, result);
    return dest;

}
#line 943 "src/pmc/scalar.c"
PMC*
Parrot_scalar_bitwise_lsr_int(Interp *interp, PMC* pmc, INTVAL value, PMC* dest)
#line 1074 "./src/pmc/scalar.pmc"
{
    const INTVAL result = (UINTVAL) VTABLE_get_integer(interp, pmc) >> value;
    if (!dest)
        dest = pmc_new(interp, pmc->vtable->base_type);
    VTABLE_set_integer_native(interp, dest, result);
    return dest;

}
#line 955 "src/pmc/scalar.c"
void
Parrot_scalar_i_bitwise_lsr(Interp *interp, PMC* pmc, PMC* value)
#line 1082 "./src/pmc/scalar.pmc"
{
    const INTVAL result = (UINTVAL) VTABLE_get_integer(interp, pmc) >>
            VTABLE_get_integer(interp, value);
     VTABLE_set_integer_native(interp, pmc, result);

}
#line 965 "src/pmc/scalar.c"
void
Parrot_scalar_i_bitwise_lsr_int(Interp *interp, PMC* pmc, INTVAL value)
#line 1088 "./src/pmc/scalar.pmc"
{
    const INTVAL result = (UINTVAL) VTABLE_get_integer(interp, pmc) >> value;
     VTABLE_set_integer_native(interp, pmc, result);

}
#line 974 "src/pmc/scalar.c"
INTVAL
Parrot_scalar_cmp_num(Interp *interp, PMC* pmc, PMC* value)
#line 1255 "./src/pmc/scalar.pmc"
{
    /* XXX - Floating-point precision errors possible? */
    const FLOATVAL diff = VTABLE_get_number(interp, value) -
                     VTABLE_get_number(interp, pmc);

    return diff == 0.0 ? 0 : diff < 0.0 ? -1 : 1;

}
#line 986 "src/pmc/scalar.c"
INTVAL
Parrot_scalar_cmp_string(Interp *interp, PMC* pmc, PMC* value)
#line 1274 "./src/pmc/scalar.pmc"
{
    return string_compare(interp,  VTABLE_get_string(interp, pmc),
        VTABLE_get_string(interp, value));

}
#line 995 "src/pmc/scalar.c"
PMC*
Parrot_scalar_logical_or(Interp *interp, PMC* pmc, PMC* value,  PMC* dest)
#line 1296 "./src/pmc/scalar.pmc"
{
    if ( VTABLE_get_bool(interp, pmc)) {
        return pmc;
    }
    return value;

}
#line 1006 "src/pmc/scalar.c"
PMC*
Parrot_scalar_logical_and(Interp *interp, PMC* pmc, PMC* value,  PMC* dest)
#line 1314 "./src/pmc/scalar.pmc"
{
    if ( VTABLE_get_bool(interp, pmc)) {
        return value;
    }
    return pmc;

}
#line 1017 "src/pmc/scalar.c"
PMC*
Parrot_scalar_logical_xor(Interp *interp, PMC* pmc, PMC* value,  PMC* dest)
#line 1331 "./src/pmc/scalar.pmc"
{
    const INTVAL my_bool =  VTABLE_get_bool(interp, pmc);
    const INTVAL value_bool = VTABLE_get_bool(interp, value);

    if (my_bool && ! value_bool) {
        return pmc;
    }
    else if (value_bool && ! my_bool) {
        return value;
    }
    dest = pmc_new(interp, pmc->vtable->base_type);
    VTABLE_set_bool(interp, dest, 0);
    return dest;

}
#line 1036 "src/pmc/scalar.c"
PMC*
Parrot_scalar_concatenate(Interp *interp, PMC* pmc, PMC* value,  PMC* dest)
#line 1155 "./src/pmc/scalar.pmc"
{
    STRING* const s = string_concat(interp,
         VTABLE_get_string(interp, pmc),
        VTABLE_get_string(interp, value), 0);
    if (!dest)
        dest = pmc_new(interp, pmc->vtable->base_type);
    VTABLE_set_string_native(interp, dest, s);
    return dest;

}
#line 1050 "src/pmc/scalar.c"
PMC*
Parrot_scalar_concatenate_str(Interp *interp, PMC* pmc, STRING* value,  PMC* dest)
#line 1165 "./src/pmc/scalar.pmc"
{
    STRING* const s = string_concat(interp,
         VTABLE_get_string(interp, pmc), value, 0);
    if (!dest)
        dest = pmc_new(interp, pmc->vtable->base_type);
    VTABLE_set_string_native(interp, dest, s);
    return dest;

}
#line 1063 "src/pmc/scalar.c"
void
Parrot_scalar_i_concatenate(Interp *interp, PMC* pmc, PMC* value)
#line 1174 "./src/pmc/scalar.pmc"
{
    STRING* const s =  VTABLE_get_string(interp, pmc);
    STRING* const v = VTABLE_get_string(interp, value);
     VTABLE_set_string_native(interp, pmc, string_append(interp, s, v));

}
#line 1073 "src/pmc/scalar.c"
void
Parrot_scalar_i_concatenate_str(Interp *interp, PMC* pmc, STRING* value)
#line 1180 "./src/pmc/scalar.pmc"
{
    STRING* const s =  VTABLE_get_string(interp, pmc);
     VTABLE_set_string_native(interp, pmc, string_append(interp, s, value));

}
#line 1082 "src/pmc/scalar.c"
PMC*
Parrot_scalar_repeat(Interp *interp, PMC* pmc, PMC* value,  PMC* dest)
#line 1203 "./src/pmc/scalar.pmc"
{
    STRING* const s =  VTABLE_get_string(interp, pmc);
    const UINTVAL n = (UINTVAL)VTABLE_get_integer(interp, value);
    if (!dest)
        dest = pmc_new(interp, pmc->vtable->base_type);
    VTABLE_set_string_native(interp, dest,
        string_repeat(interp, s, n, NULL));
    return dest;

}
#line 1096 "src/pmc/scalar.c"
PMC*
Parrot_scalar_repeat_int(Interp *interp, PMC* pmc, INTVAL value, PMC* dest)
#line 1213 "./src/pmc/scalar.pmc"
{
    STRING* const s =  VTABLE_get_string(interp, pmc);
    const UINTVAL n = value;
    if (!dest)
        dest = pmc_new(interp, pmc->vtable->base_type);
    VTABLE_set_string_native(interp, dest,
        string_repeat(interp, s, n, NULL));
    return dest;

}
#line 1110 "src/pmc/scalar.c"
void
Parrot_scalar_i_repeat(Interp *interp, PMC* pmc, PMC* value)
#line 1224 "./src/pmc/scalar.pmc"
{
    STRING* const s =  VTABLE_get_string(interp, pmc);
    const UINTVAL n = (UINTVAL)VTABLE_get_integer(interp, value);
     VTABLE_set_string_native(interp, pmc, string_repeat(interp, s, n, NULL));

}
#line 1120 "src/pmc/scalar.c"
void
Parrot_scalar_i_repeat_int(Interp *interp, PMC* pmc, INTVAL value)
#line 1230 "./src/pmc/scalar.pmc"
{
    STRING* const s =  VTABLE_get_string(interp, pmc);
    const UINTVAL n = value;
     VTABLE_set_string_native(interp, pmc, string_repeat(interp, s, n, NULL));

}
#line 1130 "src/pmc/scalar.c"
void
Parrot_scalar_assign_pmc(Interp *interp, PMC* pmc, PMC* value)
#line 114 "./src/pmc/scalar.pmc"
{
    STRING * const s_int = CONST_STRING(interp, "Integer");
    STRING *s_num;
    STRING *s_str;
    if (pmc->vtable->base_type == enum_class_Boolean) {
        /* doesn't morph */
         VTABLE_morph(interp, pmc, value->vtable->base_type);
    }
    if (value->vtable->base_type == enum_class_Undef ||
            value->vtable->base_type == enum_class_Undef) {
         VTABLE_morph(interp, pmc, value->vtable->base_type);
        return;
    }
    if (VTABLE_isa(interp, value, s_int)) {
        const INTVAL v = VTABLE_get_integer(interp, value);
         VTABLE_set_integer_native(interp, pmc, v);
        return;
    }

    s_num = CONST_STRING(interp, "Float");
    if (VTABLE_isa(interp, value, s_num)) {
        const FLOATVAL v = VTABLE_get_number(interp, value);
         VTABLE_set_number_native(interp, pmc, v);
        return;
    }

    s_str = CONST_STRING(interp, "String");
    if (VTABLE_isa(interp, value, s_str)) {
        STRING* const v = VTABLE_get_string(interp, value);
         VTABLE_set_string_native(interp, pmc, v);
        return;
    }
     VTABLE_morph(interp, pmc, enum_class_Ref);
     VTABLE_set_pmc(interp, pmc, value);

}
#line 1170 "src/pmc/scalar.c"
PMC*
Parrot_scalar_bitwise_not(Interp *interp, PMC* pmc, PMC* dest)
#line 993 "./src/pmc/scalar.pmc"
{
    const INTVAL a = ~ VTABLE_get_integer(interp, pmc);
    if (!dest)
        dest = pmc_new(interp, pmc->vtable->base_type);
    VTABLE_set_integer_native(interp, dest, a);
    return dest;

}
#line 1182 "src/pmc/scalar.c"
PMC*
Parrot_scalar_clone(Interp *interp, PMC* pmc)
#line 160 "./src/pmc/scalar.pmc"
{
    PMC* const dest = pmc_new(interp, pmc->vtable->base_type);
    memcpy(&PMC_union(dest), &PMC_union(pmc), sizeof (UnionVal));
    return dest;

}
#line 1192 "src/pmc/scalar.c"
INTVAL
Parrot_scalar_defined(Interp *interp, PMC* pmc)
#line 1381 "./src/pmc/scalar.pmc"
{
    return 1;

}
#line 1200 "src/pmc/scalar.c"
void
Parrot_scalar_i_bitwise_not(Interp *interp, PMC* pmc)
#line 1001 "./src/pmc/scalar.pmc"
{
    VTABLE_set_integer_native(interp, pmc, ~ VTABLE_get_integer(interp, pmc));

}
#line 1208 "src/pmc/scalar.c"
void
Parrot_scalar_i_logical_not(Interp *interp, PMC* pmc)
#line 1367 "./src/pmc/scalar.pmc"
{
    VTABLE_set_bool(interp, pmc, !  VTABLE_get_bool(interp, pmc));

}
#line 1216 "src/pmc/scalar.c"
void
Parrot_scalar_i_neg(Interp *interp, PMC* pmc)
#line 835 "./src/pmc/scalar.pmc"
{
    VTABLE_set_integer_native(interp, pmc, - VTABLE_get_integer(interp, pmc));

}
#line 1224 "src/pmc/scalar.c"
PMC*
Parrot_scalar_logical_not(Interp *interp, PMC* pmc, PMC* dest)
#line 1359 "./src/pmc/scalar.pmc"
{
    const INTVAL a = !  VTABLE_get_bool(interp, pmc);
    if (!dest)
        dest = pmc_new(interp, pmc->vtable->base_type);
    VTABLE_set_bool(interp, dest, a);
    return dest;

}
#line 1236 "src/pmc/scalar.c"
void
Parrot_scalar_morph(Interp *interp, PMC* pmc, INTVAL type)
#line 98 "./src/pmc/scalar.pmc"
{
    if (pmc->vtable->base_type == type)
        return;
    pmc_reuse(interp, pmc, type, 0);

}
#line 1246 "src/pmc/scalar.c"
PMC*
Parrot_scalar_neg(Interp *interp, PMC* pmc, PMC* dest)
#line 827 "./src/pmc/scalar.pmc"
{
    const INTVAL a = - VTABLE_get_integer(interp, pmc);
    if (!dest)
        dest = pmc_new(interp, pmc->vtable->base_type);
    VTABLE_set_integer_native(interp, dest, a);
    return dest;

}
#line 1258 "src/pmc/scalar.c"
PMC*
Parrot_scalar_share_ro(Interp *interp, PMC* pmc)
#line 1411 "./src/pmc/scalar.pmc"
{
    PMC *ret;

    PMC * const _true = pmc_new(interp, enum_class_Integer);
    VTABLE_set_integer_native(interp, _true, 1);

    ret = pt_shared_fixup(interp, pmc);

    /* first set readonly */
    VTABLE_setprop(interp, ret, const_string(interp, "_ro"), _true);

    /* now share; we add a PMC_EXT so we can identify the owning interp */
    add_pmc_sync(interp, ret);
    PObj_is_PMC_shared_SET(ret);

    /* XXX FIXME workaround lack of metadata sharing*/
    PMC_metadata(pmc) = NULL;

    return ret;

}
#line 1284 "src/pmc/scalar.c"
STRING*
Parrot_scalar_substr_str(Interp *interp, PMC* pmc, INTVAL offset, INTVAL length)
#line 1397 "./src/pmc/scalar.pmc"
{
    return string_substr(interp, VTABLE_get_string(interp,pmc),
        offset, length, NULL, 0);

}
#line 1292 "src/pmc/scalar.c"


/*

=back

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
