/*
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/sharedref.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

#line 1 "./src/pmc/sharedref.pmc"
/*
Copyright (C) 2001-2006, The Perl Foundation.
$Id: sharedref.pmc 18207 2007-04-14 21:31:11Z chromatic $

=head1 NAME

src/pmc/sharedref.pmc - Shared PMC Reference

=head1 DESCRIPTION

The vtable functions for the SharedRef base class.

This class wraps locking around PMC access.

All methods not present below get a default body autogenerated inside
C<Parrot::Pmc2c>.

Currently all access is locked. When we have a non-copying GC allocator
we can relax that a bit.

=head2 Methods

=over 4

=cut

*/

#include "parrot/parrot.h"

/*
 * TODO we should catch exceptions around these locks
 *      if the vtable meth throws the lock is never unlocked
 */
#define LOCK_PMC(interp, pmc) LOCK(PMC_sync(pmc)->pmc_lock);
#define UNLOCK_PMC(interp, pmc) UNLOCK(PMC_sync(pmc)->pmc_lock);

#line 50 "src/pmc/sharedref.c"
#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_sharedref.h"
#include "pmc_ref.h"
#include "pmc_default.h"
#include "sharedref.str"

#line 57 "sharedref.c"

PMC*
Parrot_SharedRef_absolute(Interp *interp, PMC* pmc, PMC* dest)
 {
    PMC* ret_val;
    LOCK_PMC(interp, pmc);
    ret_val =  VTABLE_absolute(interp, (PMC *)PMC_pmc_val(pmc), dest);
    UNLOCK_PMC(interp, pmc);

    return ret_val;
}

#line 70 "sharedref.c"

void
Parrot_SharedRef_add_attribute(Interp *interp, PMC* pmc, STRING* name, PMC* type)
 {

    LOCK_PMC(interp, pmc);
     VTABLE_add_attribute(interp, (PMC *)PMC_pmc_val(pmc), name, type);
    UNLOCK_PMC(interp, pmc);

}

#line 83 "sharedref.c"

void
Parrot_SharedRef_add_method(Interp *interp, PMC* pmc, STRING* method_name, PMC* sub_pmc)
 {

    LOCK_PMC(interp, pmc);
     VTABLE_add_method(interp, (PMC *)PMC_pmc_val(pmc), method_name, sub_pmc);
    UNLOCK_PMC(interp, pmc);

}

#line 96 "sharedref.c"

void
Parrot_SharedRef_add_parent(Interp *interp, PMC* pmc, PMC* parent)
 {

    LOCK_PMC(interp, pmc);
     VTABLE_add_parent(interp, (PMC *)PMC_pmc_val(pmc), parent);
    UNLOCK_PMC(interp, pmc);

}

#line 109 "sharedref.c"

void
Parrot_SharedRef_add_role(Interp *interp, PMC* pmc, PMC* role)
 {

    LOCK_PMC(interp, pmc);
     VTABLE_add_role(interp, (PMC *)PMC_pmc_val(pmc), role);
    UNLOCK_PMC(interp, pmc);

}

#line 122 "sharedref.c"

void
Parrot_SharedRef_assign_pmc(Interp *interp, PMC* pmc, PMC* value)
 {

    LOCK_PMC(interp, pmc);
     VTABLE_assign_pmc(interp, (PMC *)PMC_pmc_val(pmc), value);
    UNLOCK_PMC(interp, pmc);

}

#line 135 "sharedref.c"

void
Parrot_SharedRef_assign_string_native(Interp *interp, PMC* pmc, STRING* value)
 {

    LOCK_PMC(interp, pmc);
     VTABLE_assign_string_native(interp, (PMC *)PMC_pmc_val(pmc), value);
    UNLOCK_PMC(interp, pmc);

}

#line 148 "sharedref.c"

PMC*
Parrot_SharedRef_bitwise_not(Interp *interp, PMC* pmc, PMC* dest)
 {
    PMC* ret_val;
    LOCK_PMC(interp, pmc);
    ret_val =  VTABLE_bitwise_not(interp, (PMC *)PMC_pmc_val(pmc), dest);
    UNLOCK_PMC(interp, pmc);

    return ret_val;
}

#line 161 "sharedref.c"

PMC*
Parrot_SharedRef_bitwise_nots(Interp *interp, PMC* pmc, PMC* dest)
 {
    PMC* ret_val;
    LOCK_PMC(interp, pmc);
    ret_val =  VTABLE_bitwise_nots(interp, (PMC *)PMC_pmc_val(pmc), dest);
    UNLOCK_PMC(interp, pmc);

    return ret_val;
}

#line 174 "sharedref.c"

INTVAL
Parrot_SharedRef_can(Interp *interp, PMC* pmc, STRING* method)
 {
    INTVAL ret_val;
    LOCK_PMC(interp, pmc);
    ret_val =  VTABLE_can(interp, (PMC *)PMC_pmc_val(pmc), method);
    UNLOCK_PMC(interp, pmc);

    return ret_val;
}

#line 187 "sharedref.c"

INTVAL
Parrot_SharedRef_class_type(Interp *interp, PMC* pmc)
 {
    INTVAL ret_val;
    LOCK_PMC(interp, pmc);
    ret_val =  VTABLE_class_type(interp, (PMC *)PMC_pmc_val(pmc));
    UNLOCK_PMC(interp, pmc);

    return ret_val;
}

#line 200 "sharedref.c"

PMC*
Parrot_SharedRef_clone(Interp *interp, PMC* pmc)
 {
    PMC* ret_val;
    LOCK_PMC(interp, pmc);
    ret_val =  VTABLE_clone(interp, (PMC *)PMC_pmc_val(pmc));
    UNLOCK_PMC(interp, pmc);

    return ret_val;
}

#line 213 "sharedref.c"

PMC*
Parrot_SharedRef_clone_pmc(Interp *interp, PMC* pmc, PMC* args)
 {
    PMC* ret_val;
    LOCK_PMC(interp, pmc);
    ret_val =  VTABLE_clone_pmc(interp, (PMC *)PMC_pmc_val(pmc), args);
    UNLOCK_PMC(interp, pmc);

    return ret_val;
}

#line 226 "sharedref.c"

void
Parrot_SharedRef_decrement(Interp *interp, PMC* pmc)
 {

    LOCK_PMC(interp, pmc);
     VTABLE_decrement(interp, (PMC *)PMC_pmc_val(pmc));
    UNLOCK_PMC(interp, pmc);

}

#line 239 "sharedref.c"

INTVAL
Parrot_SharedRef_defined(Interp *interp, PMC* pmc)
 {
    INTVAL ret_val;
    LOCK_PMC(interp, pmc);
    ret_val =  VTABLE_defined(interp, (PMC *)PMC_pmc_val(pmc));
    UNLOCK_PMC(interp, pmc);

    return ret_val;
}

#line 252 "sharedref.c"

INTVAL
Parrot_SharedRef_defined_keyed(Interp *interp, PMC* pmc, PMC* key)
 {
    INTVAL ret_val;
    LOCK_PMC(interp, pmc);
    ret_val =  VTABLE_defined_keyed(interp, (PMC *)PMC_pmc_val(pmc), key);
    UNLOCK_PMC(interp, pmc);

    return ret_val;
}

#line 265 "sharedref.c"

INTVAL
Parrot_SharedRef_defined_keyed_int(Interp *interp, PMC* pmc, INTVAL key)
 {
    INTVAL ret_val;
    LOCK_PMC(interp, pmc);
    ret_val =  VTABLE_defined_keyed_int(interp, (PMC *)PMC_pmc_val(pmc), key);
    UNLOCK_PMC(interp, pmc);

    return ret_val;
}

#line 278 "sharedref.c"

INTVAL
Parrot_SharedRef_defined_keyed_str(Interp *interp, PMC* pmc, STRING* key)
 {
    INTVAL ret_val;
    LOCK_PMC(interp, pmc);
    ret_val =  VTABLE_defined_keyed_str(interp, (PMC *)PMC_pmc_val(pmc), key);
    UNLOCK_PMC(interp, pmc);

    return ret_val;
}

#line 291 "sharedref.c"

void
Parrot_SharedRef_delete_keyed(Interp *interp, PMC* pmc, PMC* key)
 {

    LOCK_PMC(interp, pmc);
     VTABLE_delete_keyed(interp, (PMC *)PMC_pmc_val(pmc), key);
    UNLOCK_PMC(interp, pmc);

}

#line 304 "sharedref.c"

void
Parrot_SharedRef_delete_keyed_int(Interp *interp, PMC* pmc, INTVAL key)
 {

    LOCK_PMC(interp, pmc);
     VTABLE_delete_keyed_int(interp, (PMC *)PMC_pmc_val(pmc), key);
    UNLOCK_PMC(interp, pmc);

}

#line 317 "sharedref.c"

void
Parrot_SharedRef_delete_keyed_str(Interp *interp, PMC* pmc, STRING* key)
 {

    LOCK_PMC(interp, pmc);
     VTABLE_delete_keyed_str(interp, (PMC *)PMC_pmc_val(pmc), key);
    UNLOCK_PMC(interp, pmc);

}

#line 330 "sharedref.c"

void
Parrot_SharedRef_delprop(Interp *interp, PMC* pmc, STRING* key)
 {

    LOCK_PMC(interp, pmc);
     VTABLE_delprop(interp, (PMC *)PMC_pmc_val(pmc), key);
    UNLOCK_PMC(interp, pmc);

}

void
Parrot_SharedRef_destroy(Interp *interp, PMC* pmc)
#line 142 "./src/pmc/sharedref.pmc"
{
    PMC * const ref = PMC_pmc_val(pmc);
    if (PObj_active_destroy_TEST(ref))
        VTABLE_destroy(interp, ref);
    if (PMC_sync(pmc)->owner != interp)
        PANIC("SharedRef destroyed by wrong interpreter");
    Parrot_Ref_destroy(interp, pmc);

}
#line 357 "src/pmc/sharedref.c"
#line 356 "sharedref.c"

INTVAL
Parrot_SharedRef_does(Interp *interp, PMC* pmc, STRING* method)
 {
    INTVAL ret_val;
    LOCK_PMC(interp, pmc);
    ret_val =  VTABLE_does(interp, (PMC *)PMC_pmc_val(pmc), method);
    UNLOCK_PMC(interp, pmc);

    return ret_val;
}

#line 369 "sharedref.c"

INTVAL
Parrot_SharedRef_elements(Interp *interp, PMC* pmc)
 {
    INTVAL ret_val;
    LOCK_PMC(interp, pmc);
    ret_val =  VTABLE_elements(interp, (PMC *)PMC_pmc_val(pmc));
    UNLOCK_PMC(interp, pmc);

    return ret_val;
}

#line 382 "sharedref.c"

INTVAL
Parrot_SharedRef_exists_keyed(Interp *interp, PMC* pmc, PMC* key)
 {
    INTVAL ret_val;
    LOCK_PMC(interp, pmc);
    ret_val =  VTABLE_exists_keyed(interp, (PMC *)PMC_pmc_val(pmc), key);
    UNLOCK_PMC(interp, pmc);

    return ret_val;
}

#line 395 "sharedref.c"

INTVAL
Parrot_SharedRef_exists_keyed_int(Interp *interp, PMC* pmc, INTVAL key)
 {
    INTVAL ret_val;
    LOCK_PMC(interp, pmc);
    ret_val =  VTABLE_exists_keyed_int(interp, (PMC *)PMC_pmc_val(pmc), key);
    UNLOCK_PMC(interp, pmc);

    return ret_val;
}

#line 408 "sharedref.c"

INTVAL
Parrot_SharedRef_exists_keyed_str(Interp *interp, PMC* pmc, STRING* key)
 {
    INTVAL ret_val;
    LOCK_PMC(interp, pmc);
    ret_val =  VTABLE_exists_keyed_str(interp, (PMC *)PMC_pmc_val(pmc), key);
    UNLOCK_PMC(interp, pmc);

    return ret_val;
}

#line 421 "sharedref.c"

PMC*
Parrot_SharedRef_find_method(Interp *interp, PMC* pmc, STRING* method_name)
 {
    PMC* ret_val;
    LOCK_PMC(interp, pmc);
    ret_val =  VTABLE_find_method(interp, (PMC *)PMC_pmc_val(pmc), method_name);
    UNLOCK_PMC(interp, pmc);

    return ret_val;
}

#line 434 "sharedref.c"

void
Parrot_SharedRef_freeze(Interp *interp, PMC* pmc, visit_info* info)
 {

    LOCK_PMC(interp, pmc);
     VTABLE_freeze(interp, (PMC *)PMC_pmc_val(pmc), info);
    UNLOCK_PMC(interp, pmc);

}

#line 447 "sharedref.c"

PMC*
Parrot_SharedRef_get_attr(Interp *interp, PMC* pmc, INTVAL idx)
 {
    PMC* ret_val;
    LOCK_PMC(interp, pmc);
    ret_val =  VTABLE_get_attr(interp, (PMC *)PMC_pmc_val(pmc), idx);
    UNLOCK_PMC(interp, pmc);

    return ret_val;
}

#line 460 "sharedref.c"

PMC*
Parrot_SharedRef_get_attr_str(Interp *interp, PMC* pmc, STRING* idx)
 {
    PMC* ret_val;
    LOCK_PMC(interp, pmc);
    ret_val =  VTABLE_get_attr_str(interp, (PMC *)PMC_pmc_val(pmc), idx);
    UNLOCK_PMC(interp, pmc);

    return ret_val;
}

#line 473 "sharedref.c"

PMC*
Parrot_SharedRef_get_bignum(Interp *interp, PMC* pmc)
 {
    PMC* ret_val;
    LOCK_PMC(interp, pmc);
    ret_val =  VTABLE_get_bignum(interp, (PMC *)PMC_pmc_val(pmc));
    UNLOCK_PMC(interp, pmc);

    return ret_val;
}

#line 486 "sharedref.c"

INTVAL
Parrot_SharedRef_get_bool(Interp *interp, PMC* pmc)
 {
    INTVAL ret_val;
    LOCK_PMC(interp, pmc);
    ret_val =  VTABLE_get_bool(interp, (PMC *)PMC_pmc_val(pmc));
    UNLOCK_PMC(interp, pmc);

    return ret_val;
}

#line 499 "sharedref.c"

PMC*
Parrot_SharedRef_get_class(Interp *interp, PMC* pmc)
 {
    PMC* ret_val;
    LOCK_PMC(interp, pmc);
    ret_val =  VTABLE_get_class(interp, (PMC *)PMC_pmc_val(pmc));
    UNLOCK_PMC(interp, pmc);

    return ret_val;
}

#line 512 "sharedref.c"

INTVAL
Parrot_SharedRef_get_integer(Interp *interp, PMC* pmc)
 {
    INTVAL ret_val;
    LOCK_PMC(interp, pmc);
    ret_val =  VTABLE_get_integer(interp, (PMC *)PMC_pmc_val(pmc));
    UNLOCK_PMC(interp, pmc);

    return ret_val;
}

#line 525 "sharedref.c"

INTVAL
Parrot_SharedRef_get_integer_keyed(Interp *interp, PMC* pmc, PMC* key)
 {
    INTVAL ret_val;
    LOCK_PMC(interp, pmc);
    ret_val =  VTABLE_get_integer_keyed(interp, (PMC *)PMC_pmc_val(pmc), key);
    UNLOCK_PMC(interp, pmc);

    return ret_val;
}

#line 538 "sharedref.c"

INTVAL
Parrot_SharedRef_get_integer_keyed_int(Interp *interp, PMC* pmc, INTVAL key)
 {
    INTVAL ret_val;
    LOCK_PMC(interp, pmc);
    ret_val =  VTABLE_get_integer_keyed_int(interp, (PMC *)PMC_pmc_val(pmc), key);
    UNLOCK_PMC(interp, pmc);

    return ret_val;
}

#line 551 "sharedref.c"

INTVAL
Parrot_SharedRef_get_integer_keyed_str(Interp *interp, PMC* pmc, STRING* key)
 {
    INTVAL ret_val;
    LOCK_PMC(interp, pmc);
    ret_val =  VTABLE_get_integer_keyed_str(interp, (PMC *)PMC_pmc_val(pmc), key);
    UNLOCK_PMC(interp, pmc);

    return ret_val;
}

#line 564 "sharedref.c"

PMC*
Parrot_SharedRef_get_iter(Interp *interp, PMC* pmc)
 {
    PMC* ret_val;
    LOCK_PMC(interp, pmc);
    ret_val =  VTABLE_get_iter(interp, (PMC *)PMC_pmc_val(pmc));
    UNLOCK_PMC(interp, pmc);

    return ret_val;
}

#line 577 "sharedref.c"

FLOATVAL
Parrot_SharedRef_get_number(Interp *interp, PMC* pmc)
 {
    FLOATVAL ret_val;
    LOCK_PMC(interp, pmc);
    ret_val =  VTABLE_get_number(interp, (PMC *)PMC_pmc_val(pmc));
    UNLOCK_PMC(interp, pmc);

    return ret_val;
}

#line 590 "sharedref.c"

FLOATVAL
Parrot_SharedRef_get_number_keyed(Interp *interp, PMC* pmc, PMC* key)
 {
    FLOATVAL ret_val;
    LOCK_PMC(interp, pmc);
    ret_val =  VTABLE_get_number_keyed(interp, (PMC *)PMC_pmc_val(pmc), key);
    UNLOCK_PMC(interp, pmc);

    return ret_val;
}

#line 603 "sharedref.c"

FLOATVAL
Parrot_SharedRef_get_number_keyed_int(Interp *interp, PMC* pmc, INTVAL key)
 {
    FLOATVAL ret_val;
    LOCK_PMC(interp, pmc);
    ret_val =  VTABLE_get_number_keyed_int(interp, (PMC *)PMC_pmc_val(pmc), key);
    UNLOCK_PMC(interp, pmc);

    return ret_val;
}

#line 616 "sharedref.c"

FLOATVAL
Parrot_SharedRef_get_number_keyed_str(Interp *interp, PMC* pmc, STRING* key)
 {
    FLOATVAL ret_val;
    LOCK_PMC(interp, pmc);
    ret_val =  VTABLE_get_number_keyed_str(interp, (PMC *)PMC_pmc_val(pmc), key);
    UNLOCK_PMC(interp, pmc);

    return ret_val;
}

PMC*
Parrot_SharedRef_get_pmc(Interp *interp, PMC* pmc)
#line 125 "./src/pmc/sharedref.pmc"
{
    real_exception(interp, NULL, E_ReferenceError,
            "deref not allowed");
    return NULL;

}
#line 640 "src/pmc/sharedref.c"
#line 639 "sharedref.c"

PMC*
Parrot_SharedRef_get_pmc_keyed(Interp *interp, PMC* pmc, PMC* key)
 {
    PMC* ret_val;
    LOCK_PMC(interp, pmc);
    ret_val =  VTABLE_get_pmc_keyed(interp, (PMC *)PMC_pmc_val(pmc), key);
    UNLOCK_PMC(interp, pmc);

    return ret_val;
}

#line 652 "sharedref.c"

PMC*
Parrot_SharedRef_get_pmc_keyed_int(Interp *interp, PMC* pmc, INTVAL key)
 {
    PMC* ret_val;
    LOCK_PMC(interp, pmc);
    ret_val =  VTABLE_get_pmc_keyed_int(interp, (PMC *)PMC_pmc_val(pmc), key);
    UNLOCK_PMC(interp, pmc);

    return ret_val;
}

#line 665 "sharedref.c"

PMC*
Parrot_SharedRef_get_pmc_keyed_str(Interp *interp, PMC* pmc, STRING* key)
 {
    PMC* ret_val;
    LOCK_PMC(interp, pmc);
    ret_val =  VTABLE_get_pmc_keyed_str(interp, (PMC *)PMC_pmc_val(pmc), key);
    UNLOCK_PMC(interp, pmc);

    return ret_val;
}

#line 678 "sharedref.c"

void*
Parrot_SharedRef_get_pointer(Interp *interp, PMC* pmc)
 {
    void* ret_val;
    LOCK_PMC(interp, pmc);
    ret_val =  VTABLE_get_pointer(interp, (PMC *)PMC_pmc_val(pmc));
    UNLOCK_PMC(interp, pmc);

    return ret_val;
}

#line 691 "sharedref.c"

void*
Parrot_SharedRef_get_pointer_keyed(Interp *interp, PMC* pmc, PMC* key)
 {
    void* ret_val;
    LOCK_PMC(interp, pmc);
    ret_val =  VTABLE_get_pointer_keyed(interp, (PMC *)PMC_pmc_val(pmc), key);
    UNLOCK_PMC(interp, pmc);

    return ret_val;
}

#line 704 "sharedref.c"

void*
Parrot_SharedRef_get_pointer_keyed_int(Interp *interp, PMC* pmc, INTVAL key)
 {
    void* ret_val;
    LOCK_PMC(interp, pmc);
    ret_val =  VTABLE_get_pointer_keyed_int(interp, (PMC *)PMC_pmc_val(pmc), key);
    UNLOCK_PMC(interp, pmc);

    return ret_val;
}

#line 717 "sharedref.c"

void*
Parrot_SharedRef_get_pointer_keyed_str(Interp *interp, PMC* pmc, STRING* key)
 {
    void* ret_val;
    LOCK_PMC(interp, pmc);
    ret_val =  VTABLE_get_pointer_keyed_str(interp, (PMC *)PMC_pmc_val(pmc), key);
    UNLOCK_PMC(interp, pmc);

    return ret_val;
}

#line 730 "sharedref.c"

STRING*
Parrot_SharedRef_get_repr(Interp *interp, PMC* pmc)
 {
    STRING* ret_val;
    LOCK_PMC(interp, pmc);
    ret_val =  VTABLE_get_repr(interp, (PMC *)PMC_pmc_val(pmc));
    UNLOCK_PMC(interp, pmc);

    return ret_val;
}

#line 743 "sharedref.c"

STRING*
Parrot_SharedRef_get_string(Interp *interp, PMC* pmc)
 {
    STRING* ret_val;
    LOCK_PMC(interp, pmc);
    ret_val =  VTABLE_get_string(interp, (PMC *)PMC_pmc_val(pmc));
    UNLOCK_PMC(interp, pmc);

    return ret_val;
}

#line 756 "sharedref.c"

STRING*
Parrot_SharedRef_get_string_keyed(Interp *interp, PMC* pmc, PMC* key)
 {
    STRING* ret_val;
    LOCK_PMC(interp, pmc);
    ret_val =  VTABLE_get_string_keyed(interp, (PMC *)PMC_pmc_val(pmc), key);
    UNLOCK_PMC(interp, pmc);

    return ret_val;
}

#line 769 "sharedref.c"

STRING*
Parrot_SharedRef_get_string_keyed_int(Interp *interp, PMC* pmc, INTVAL key)
 {
    STRING* ret_val;
    LOCK_PMC(interp, pmc);
    ret_val =  VTABLE_get_string_keyed_int(interp, (PMC *)PMC_pmc_val(pmc), key);
    UNLOCK_PMC(interp, pmc);

    return ret_val;
}

#line 782 "sharedref.c"

STRING*
Parrot_SharedRef_get_string_keyed_str(Interp *interp, PMC* pmc, STRING* key)
 {
    STRING* ret_val;
    LOCK_PMC(interp, pmc);
    ret_val =  VTABLE_get_string_keyed_str(interp, (PMC *)PMC_pmc_val(pmc), key);
    UNLOCK_PMC(interp, pmc);

    return ret_val;
}

#line 795 "sharedref.c"

PMC*
Parrot_SharedRef_getprop(Interp *interp, PMC* pmc, STRING* key)
 {
    PMC* ret_val;
    LOCK_PMC(interp, pmc);
    ret_val =  VTABLE_getprop(interp, (PMC *)PMC_pmc_val(pmc), key);
    UNLOCK_PMC(interp, pmc);

    return ret_val;
}

#line 808 "sharedref.c"

PMC*
Parrot_SharedRef_getprops(Interp *interp, PMC* pmc)
 {
    PMC* ret_val;
    LOCK_PMC(interp, pmc);
    ret_val =  VTABLE_getprops(interp, (PMC *)PMC_pmc_val(pmc));
    UNLOCK_PMC(interp, pmc);

    return ret_val;
}

#line 821 "sharedref.c"

INTVAL
Parrot_SharedRef_hash(Interp *interp, PMC* pmc, size_t seed)
 {
    INTVAL ret_val;
    LOCK_PMC(interp, pmc);
    ret_val =  VTABLE_hash(interp, (PMC *)PMC_pmc_val(pmc), seed);
    UNLOCK_PMC(interp, pmc);

    return ret_val;
}

#line 834 "sharedref.c"

void
Parrot_SharedRef_i_absolute(Interp *interp, PMC* pmc)
 {

    LOCK_PMC(interp, pmc);
     VTABLE_i_absolute(interp, (PMC *)PMC_pmc_val(pmc));
    UNLOCK_PMC(interp, pmc);

}

#line 847 "sharedref.c"

void
Parrot_SharedRef_i_bitwise_not(Interp *interp, PMC* pmc)
 {

    LOCK_PMC(interp, pmc);
     VTABLE_i_bitwise_not(interp, (PMC *)PMC_pmc_val(pmc));
    UNLOCK_PMC(interp, pmc);

}

#line 860 "sharedref.c"

void
Parrot_SharedRef_i_bitwise_nots(Interp *interp, PMC* pmc)
 {

    LOCK_PMC(interp, pmc);
     VTABLE_i_bitwise_nots(interp, (PMC *)PMC_pmc_val(pmc));
    UNLOCK_PMC(interp, pmc);

}

#line 873 "sharedref.c"

void
Parrot_SharedRef_i_logical_not(Interp *interp, PMC* pmc)
 {

    LOCK_PMC(interp, pmc);
     VTABLE_i_logical_not(interp, (PMC *)PMC_pmc_val(pmc));
    UNLOCK_PMC(interp, pmc);

}

#line 886 "sharedref.c"

void
Parrot_SharedRef_i_neg(Interp *interp, PMC* pmc)
 {

    LOCK_PMC(interp, pmc);
     VTABLE_i_neg(interp, (PMC *)PMC_pmc_val(pmc));
    UNLOCK_PMC(interp, pmc);

}

#line 899 "sharedref.c"

void
Parrot_SharedRef_increment(Interp *interp, PMC* pmc)
 {

    LOCK_PMC(interp, pmc);
     VTABLE_increment(interp, (PMC *)PMC_pmc_val(pmc));
    UNLOCK_PMC(interp, pmc);

}

void
Parrot_SharedRef_init(Interp *interp, PMC* pmc)
#line 41 "./src/pmc/sharedref.pmc"
{
    Parrot_Ref_init(interp, pmc);

}
#line 921 "src/pmc/sharedref.c"
void
Parrot_SharedRef_init_pmc(Interp *interp, PMC* pmc, PMC* initializer)
#line 74 "./src/pmc/sharedref.pmc"
{
    Parrot_Ref_init_pmc(interp, pmc, initializer);
    PObj_active_destroy_SET(pmc);

}
#line 930 "src/pmc/sharedref.c"
#line 929 "sharedref.c"

PMC*
Parrot_SharedRef_inspect(Interp *interp, PMC* pmc)
 {
    PMC* ret_val;
    LOCK_PMC(interp, pmc);
    ret_val =  VTABLE_inspect(interp, (PMC *)PMC_pmc_val(pmc));
    UNLOCK_PMC(interp, pmc);

    return ret_val;
}

#line 942 "sharedref.c"

PMC*
Parrot_SharedRef_inspect_str(Interp *interp, PMC* pmc, STRING* what)
 {
    PMC* ret_val;
    LOCK_PMC(interp, pmc);
    ret_val =  VTABLE_inspect_str(interp, (PMC *)PMC_pmc_val(pmc), what);
    UNLOCK_PMC(interp, pmc);

    return ret_val;
}

#line 955 "sharedref.c"

PMC*
Parrot_SharedRef_instantiate(Interp *interp, PMC* pmc, PMC* sig)
 {
    PMC* ret_val;
    LOCK_PMC(interp, pmc);
    ret_val =  VTABLE_instantiate(interp, (PMC *)PMC_pmc_val(pmc), sig);
    UNLOCK_PMC(interp, pmc);

    return ret_val;
}

#line 968 "sharedref.c"

opcode_t*
Parrot_SharedRef_invoke(Interp *interp, PMC* pmc, void* next)
 {
    opcode_t* ret_val;
    LOCK_PMC(interp, pmc);
    ret_val =  VTABLE_invoke(interp, (PMC *)PMC_pmc_val(pmc), next);
    UNLOCK_PMC(interp, pmc);

    return ret_val;
}

#line 981 "sharedref.c"

INTVAL
Parrot_SharedRef_is_same(Interp *interp, PMC* pmc, PMC* value)
 {
    INTVAL ret_val;
    LOCK_PMC(interp, pmc);
    ret_val =  VTABLE_is_same(interp, (PMC *)PMC_pmc_val(pmc), value);
    UNLOCK_PMC(interp, pmc);

    return ret_val;
}

#line 994 "sharedref.c"

INTVAL
Parrot_SharedRef_isa(Interp *interp, PMC* pmc, STRING* _class)
 {
    INTVAL ret_val;
    LOCK_PMC(interp, pmc);
    ret_val =  VTABLE_isa(interp, (PMC *)PMC_pmc_val(pmc), _class);
    UNLOCK_PMC(interp, pmc);

    return ret_val;
}

#line 1007 "sharedref.c"

PMC*
Parrot_SharedRef_logical_not(Interp *interp, PMC* pmc, PMC* dest)
 {
    PMC* ret_val;
    LOCK_PMC(interp, pmc);
    ret_val =  VTABLE_logical_not(interp, (PMC *)PMC_pmc_val(pmc), dest);
    UNLOCK_PMC(interp, pmc);

    return ret_val;
}

void
Parrot_SharedRef_mark(Interp *interp, PMC* pmc)
#line 102 "./src/pmc/sharedref.pmc"
{
    Parrot_Ref_mark(interp, pmc);

}
#line 1029 "src/pmc/sharedref.c"
#line 1028 "sharedref.c"

void
Parrot_SharedRef_morph(Interp *interp, PMC* pmc, INTVAL type)
 {

    LOCK_PMC(interp, pmc);
     VTABLE_morph(interp, (PMC *)PMC_pmc_val(pmc), type);
    UNLOCK_PMC(interp, pmc);

}

#line 1041 "sharedref.c"

STRING*
Parrot_SharedRef_name(Interp *interp, PMC* pmc)
 {
    STRING* ret_val;
    LOCK_PMC(interp, pmc);
    ret_val =  VTABLE_name(interp, (PMC *)PMC_pmc_val(pmc));
    UNLOCK_PMC(interp, pmc);

    return ret_val;
}

#line 1054 "sharedref.c"

PMC*
Parrot_SharedRef_neg(Interp *interp, PMC* pmc, PMC* dest)
 {
    PMC* ret_val;
    LOCK_PMC(interp, pmc);
    ret_val =  VTABLE_neg(interp, (PMC *)PMC_pmc_val(pmc), dest);
    UNLOCK_PMC(interp, pmc);

    return ret_val;
}

#line 1067 "sharedref.c"

PMC*
Parrot_SharedRef_new_from_string(Interp *interp, PMC* pmc, STRING* rep, INTVAL flags)
 {
    PMC* ret_val;
    LOCK_PMC(interp, pmc);
    ret_val =  VTABLE_new_from_string(interp, (PMC *)PMC_pmc_val(pmc), rep, flags);
    UNLOCK_PMC(interp, pmc);

    return ret_val;
}

#line 1080 "sharedref.c"

PMC*
Parrot_SharedRef_nextkey_keyed(Interp *interp, PMC* pmc, PMC* key, INTVAL what)
 {
    PMC* ret_val;
    LOCK_PMC(interp, pmc);
    ret_val =  VTABLE_nextkey_keyed(interp, (PMC *)PMC_pmc_val(pmc), key, what);
    UNLOCK_PMC(interp, pmc);

    return ret_val;
}

#line 1093 "sharedref.c"

PMC*
Parrot_SharedRef_nextkey_keyed_int(Interp *interp, PMC* pmc, INTVAL key, INTVAL what)
 {
    PMC* ret_val;
    LOCK_PMC(interp, pmc);
    ret_val =  VTABLE_nextkey_keyed_int(interp, (PMC *)PMC_pmc_val(pmc), key, what);
    UNLOCK_PMC(interp, pmc);

    return ret_val;
}

#line 1106 "sharedref.c"

PMC*
Parrot_SharedRef_nextkey_keyed_str(Interp *interp, PMC* pmc, STRING* key, INTVAL what)
 {
    PMC* ret_val;
    LOCK_PMC(interp, pmc);
    ret_val =  VTABLE_nextkey_keyed_str(interp, (PMC *)PMC_pmc_val(pmc), key, what);
    UNLOCK_PMC(interp, pmc);

    return ret_val;
}

#line 1119 "sharedref.c"

PMC*
Parrot_SharedRef_pmc_namespace(Interp *interp, PMC* pmc)
 {
    PMC* ret_val;
    LOCK_PMC(interp, pmc);
    ret_val =  VTABLE_pmc_namespace(interp, (PMC *)PMC_pmc_val(pmc));
    UNLOCK_PMC(interp, pmc);

    return ret_val;
}

#line 1132 "sharedref.c"

FLOATVAL
Parrot_SharedRef_pop_float(Interp *interp, PMC* pmc)
 {
    FLOATVAL ret_val;
    LOCK_PMC(interp, pmc);
    ret_val =  VTABLE_pop_float(interp, (PMC *)PMC_pmc_val(pmc));
    UNLOCK_PMC(interp, pmc);

    return ret_val;
}

#line 1145 "sharedref.c"

INTVAL
Parrot_SharedRef_pop_integer(Interp *interp, PMC* pmc)
 {
    INTVAL ret_val;
    LOCK_PMC(interp, pmc);
    ret_val =  VTABLE_pop_integer(interp, (PMC *)PMC_pmc_val(pmc));
    UNLOCK_PMC(interp, pmc);

    return ret_val;
}

#line 1158 "sharedref.c"

PMC*
Parrot_SharedRef_pop_pmc(Interp *interp, PMC* pmc)
 {
    PMC* ret_val;
    LOCK_PMC(interp, pmc);
    ret_val =  VTABLE_pop_pmc(interp, (PMC *)PMC_pmc_val(pmc));
    UNLOCK_PMC(interp, pmc);

    return ret_val;
}

#line 1171 "sharedref.c"

STRING*
Parrot_SharedRef_pop_string(Interp *interp, PMC* pmc)
 {
    STRING* ret_val;
    LOCK_PMC(interp, pmc);
    ret_val =  VTABLE_pop_string(interp, (PMC *)PMC_pmc_val(pmc));
    UNLOCK_PMC(interp, pmc);

    return ret_val;
}

#line 1184 "sharedref.c"

void
Parrot_SharedRef_push_float(Interp *interp, PMC* pmc, FLOATVAL value)
 {

    LOCK_PMC(interp, pmc);
     VTABLE_push_float(interp, (PMC *)PMC_pmc_val(pmc), value);
    UNLOCK_PMC(interp, pmc);

}

#line 1197 "sharedref.c"

void
Parrot_SharedRef_push_integer(Interp *interp, PMC* pmc, INTVAL value)
 {

    LOCK_PMC(interp, pmc);
     VTABLE_push_integer(interp, (PMC *)PMC_pmc_val(pmc), value);
    UNLOCK_PMC(interp, pmc);

}

#line 1210 "sharedref.c"

void
Parrot_SharedRef_push_pmc(Interp *interp, PMC* pmc, PMC* value)
 {

    LOCK_PMC(interp, pmc);
     VTABLE_push_pmc(interp, (PMC *)PMC_pmc_val(pmc), value);
    UNLOCK_PMC(interp, pmc);

}

#line 1223 "sharedref.c"

void
Parrot_SharedRef_push_string(Interp *interp, PMC* pmc, STRING* value)
 {

    LOCK_PMC(interp, pmc);
     VTABLE_push_string(interp, (PMC *)PMC_pmc_val(pmc), value);
    UNLOCK_PMC(interp, pmc);

}

#line 1236 "sharedref.c"

void
Parrot_SharedRef_remove_attribute(Interp *interp, PMC* pmc, STRING* name)
 {

    LOCK_PMC(interp, pmc);
     VTABLE_remove_attribute(interp, (PMC *)PMC_pmc_val(pmc), name);
    UNLOCK_PMC(interp, pmc);

}

#line 1249 "sharedref.c"

void
Parrot_SharedRef_remove_method(Interp *interp, PMC* pmc, STRING* method_name)
 {

    LOCK_PMC(interp, pmc);
     VTABLE_remove_method(interp, (PMC *)PMC_pmc_val(pmc), method_name);
    UNLOCK_PMC(interp, pmc);

}

#line 1262 "sharedref.c"

void
Parrot_SharedRef_remove_parent(Interp *interp, PMC* pmc, PMC* parent)
 {

    LOCK_PMC(interp, pmc);
     VTABLE_remove_parent(interp, (PMC *)PMC_pmc_val(pmc), parent);
    UNLOCK_PMC(interp, pmc);

}

#line 1275 "sharedref.c"

void
Parrot_SharedRef_remove_role(Interp *interp, PMC* pmc, PMC* role)
 {

    LOCK_PMC(interp, pmc);
     VTABLE_remove_role(interp, (PMC *)PMC_pmc_val(pmc), role);
    UNLOCK_PMC(interp, pmc);

}

#line 1288 "sharedref.c"

void
Parrot_SharedRef_set_attr(Interp *interp, PMC* pmc, INTVAL idx, PMC* value)
 {

    LOCK_PMC(interp, pmc);
     VTABLE_set_attr(interp, (PMC *)PMC_pmc_val(pmc), idx, value);
    UNLOCK_PMC(interp, pmc);

}

#line 1301 "sharedref.c"

void
Parrot_SharedRef_set_attr_str(Interp *interp, PMC* pmc, STRING* idx, PMC* value)
 {

    LOCK_PMC(interp, pmc);
     VTABLE_set_attr_str(interp, (PMC *)PMC_pmc_val(pmc), idx, value);
    UNLOCK_PMC(interp, pmc);

}

#line 1314 "sharedref.c"

void
Parrot_SharedRef_set_bignum_int(Interp *interp, PMC* pmc, INTVAL value)
 {

    LOCK_PMC(interp, pmc);
     VTABLE_set_bignum_int(interp, (PMC *)PMC_pmc_val(pmc), value);
    UNLOCK_PMC(interp, pmc);

}

#line 1327 "sharedref.c"

void
Parrot_SharedRef_set_bignum_num(Interp *interp, PMC* pmc, FLOATVAL value)
 {

    LOCK_PMC(interp, pmc);
     VTABLE_set_bignum_num(interp, (PMC *)PMC_pmc_val(pmc), value);
    UNLOCK_PMC(interp, pmc);

}

#line 1340 "sharedref.c"

void
Parrot_SharedRef_set_bignum_str(Interp *interp, PMC* pmc, STRING* value)
 {

    LOCK_PMC(interp, pmc);
     VTABLE_set_bignum_str(interp, (PMC *)PMC_pmc_val(pmc), value);
    UNLOCK_PMC(interp, pmc);

}

#line 1353 "sharedref.c"

void
Parrot_SharedRef_set_bool(Interp *interp, PMC* pmc, INTVAL value)
 {

    LOCK_PMC(interp, pmc);
     VTABLE_set_bool(interp, (PMC *)PMC_pmc_val(pmc), value);
    UNLOCK_PMC(interp, pmc);

}

#line 1366 "sharedref.c"

void
Parrot_SharedRef_set_integer_keyed(Interp *interp, PMC* pmc, PMC* key, INTVAL value)
 {

    LOCK_PMC(interp, pmc);
     VTABLE_set_integer_keyed(interp, (PMC *)PMC_pmc_val(pmc), key, value);
    UNLOCK_PMC(interp, pmc);

}

#line 1379 "sharedref.c"

void
Parrot_SharedRef_set_integer_keyed_int(Interp *interp, PMC* pmc, INTVAL key, INTVAL value)
 {

    LOCK_PMC(interp, pmc);
     VTABLE_set_integer_keyed_int(interp, (PMC *)PMC_pmc_val(pmc), key, value);
    UNLOCK_PMC(interp, pmc);

}

#line 1392 "sharedref.c"

void
Parrot_SharedRef_set_integer_keyed_str(Interp *interp, PMC* pmc, STRING* key, INTVAL value)
 {

    LOCK_PMC(interp, pmc);
     VTABLE_set_integer_keyed_str(interp, (PMC *)PMC_pmc_val(pmc), key, value);
    UNLOCK_PMC(interp, pmc);

}

#line 1405 "sharedref.c"

void
Parrot_SharedRef_set_integer_native(Interp *interp, PMC* pmc, INTVAL value)
 {

    LOCK_PMC(interp, pmc);
     VTABLE_set_integer_native(interp, (PMC *)PMC_pmc_val(pmc), value);
    UNLOCK_PMC(interp, pmc);

}

#line 1418 "sharedref.c"

void
Parrot_SharedRef_set_integer_same(Interp *interp, PMC* pmc, PMC* value)
 {

    LOCK_PMC(interp, pmc);
     VTABLE_set_integer_same(interp, (PMC *)PMC_pmc_val(pmc), value);
    UNLOCK_PMC(interp, pmc);

}

#line 1431 "sharedref.c"

void
Parrot_SharedRef_set_number_keyed(Interp *interp, PMC* pmc, PMC* key, FLOATVAL value)
 {

    LOCK_PMC(interp, pmc);
     VTABLE_set_number_keyed(interp, (PMC *)PMC_pmc_val(pmc), key, value);
    UNLOCK_PMC(interp, pmc);

}

#line 1444 "sharedref.c"

void
Parrot_SharedRef_set_number_keyed_int(Interp *interp, PMC* pmc, INTVAL key, FLOATVAL value)
 {

    LOCK_PMC(interp, pmc);
     VTABLE_set_number_keyed_int(interp, (PMC *)PMC_pmc_val(pmc), key, value);
    UNLOCK_PMC(interp, pmc);

}

#line 1457 "sharedref.c"

void
Parrot_SharedRef_set_number_keyed_str(Interp *interp, PMC* pmc, STRING* key, FLOATVAL value)
 {

    LOCK_PMC(interp, pmc);
     VTABLE_set_number_keyed_str(interp, (PMC *)PMC_pmc_val(pmc), key, value);
    UNLOCK_PMC(interp, pmc);

}

#line 1470 "sharedref.c"

void
Parrot_SharedRef_set_number_native(Interp *interp, PMC* pmc, FLOATVAL value)
 {

    LOCK_PMC(interp, pmc);
     VTABLE_set_number_native(interp, (PMC *)PMC_pmc_val(pmc), value);
    UNLOCK_PMC(interp, pmc);

}

#line 1483 "sharedref.c"

void
Parrot_SharedRef_set_number_same(Interp *interp, PMC* pmc, PMC* value)
 {

    LOCK_PMC(interp, pmc);
     VTABLE_set_number_same(interp, (PMC *)PMC_pmc_val(pmc), value);
    UNLOCK_PMC(interp, pmc);

}

void
Parrot_SharedRef_set_pmc(Interp *interp, PMC* pmc, PMC* other)
#line 120 "./src/pmc/sharedref.pmc"
{
    Parrot_Ref_set_pmc(interp, pmc, other);
    PObj_active_destroy_SET(pmc);

}
#line 1506 "src/pmc/sharedref.c"
#line 1505 "sharedref.c"

void
Parrot_SharedRef_set_pmc_keyed(Interp *interp, PMC* pmc, PMC* key, PMC* value)
 {

    LOCK_PMC(interp, pmc);
     VTABLE_set_pmc_keyed(interp, (PMC *)PMC_pmc_val(pmc), key, value);
    UNLOCK_PMC(interp, pmc);

}

#line 1518 "sharedref.c"

void
Parrot_SharedRef_set_pmc_keyed_int(Interp *interp, PMC* pmc, INTVAL key, PMC* value)
 {

    LOCK_PMC(interp, pmc);
     VTABLE_set_pmc_keyed_int(interp, (PMC *)PMC_pmc_val(pmc), key, value);
    UNLOCK_PMC(interp, pmc);

}

#line 1531 "sharedref.c"

void
Parrot_SharedRef_set_pmc_keyed_str(Interp *interp, PMC* pmc, STRING* key, PMC* value)
 {

    LOCK_PMC(interp, pmc);
     VTABLE_set_pmc_keyed_str(interp, (PMC *)PMC_pmc_val(pmc), key, value);
    UNLOCK_PMC(interp, pmc);

}

#line 1544 "sharedref.c"

void
Parrot_SharedRef_set_pointer(Interp *interp, PMC* pmc, void* value)
 {

    LOCK_PMC(interp, pmc);
     VTABLE_set_pointer(interp, (PMC *)PMC_pmc_val(pmc), value);
    UNLOCK_PMC(interp, pmc);

}

#line 1557 "sharedref.c"

void
Parrot_SharedRef_set_pointer_keyed(Interp *interp, PMC* pmc, PMC* key, void* value)
 {

    LOCK_PMC(interp, pmc);
     VTABLE_set_pointer_keyed(interp, (PMC *)PMC_pmc_val(pmc), key, value);
    UNLOCK_PMC(interp, pmc);

}

#line 1570 "sharedref.c"

void
Parrot_SharedRef_set_pointer_keyed_int(Interp *interp, PMC* pmc, INTVAL key, void* value)
 {

    LOCK_PMC(interp, pmc);
     VTABLE_set_pointer_keyed_int(interp, (PMC *)PMC_pmc_val(pmc), key, value);
    UNLOCK_PMC(interp, pmc);

}

#line 1583 "sharedref.c"

void
Parrot_SharedRef_set_pointer_keyed_str(Interp *interp, PMC* pmc, STRING* key, void* value)
 {

    LOCK_PMC(interp, pmc);
     VTABLE_set_pointer_keyed_str(interp, (PMC *)PMC_pmc_val(pmc), key, value);
    UNLOCK_PMC(interp, pmc);

}

#line 1596 "sharedref.c"

void
Parrot_SharedRef_set_string_keyed(Interp *interp, PMC* pmc, PMC* key, STRING* value)
 {

    LOCK_PMC(interp, pmc);
     VTABLE_set_string_keyed(interp, (PMC *)PMC_pmc_val(pmc), key, value);
    UNLOCK_PMC(interp, pmc);

}

#line 1609 "sharedref.c"

void
Parrot_SharedRef_set_string_keyed_int(Interp *interp, PMC* pmc, INTVAL key, STRING* value)
 {

    LOCK_PMC(interp, pmc);
     VTABLE_set_string_keyed_int(interp, (PMC *)PMC_pmc_val(pmc), key, value);
    UNLOCK_PMC(interp, pmc);

}

#line 1622 "sharedref.c"

void
Parrot_SharedRef_set_string_keyed_str(Interp *interp, PMC* pmc, STRING* key, STRING* value)
 {

    LOCK_PMC(interp, pmc);
     VTABLE_set_string_keyed_str(interp, (PMC *)PMC_pmc_val(pmc), key, value);
    UNLOCK_PMC(interp, pmc);

}

#line 1635 "sharedref.c"

void
Parrot_SharedRef_set_string_native(Interp *interp, PMC* pmc, STRING* value)
 {

    LOCK_PMC(interp, pmc);
     VTABLE_set_string_native(interp, (PMC *)PMC_pmc_val(pmc), value);
    UNLOCK_PMC(interp, pmc);

}

#line 1648 "sharedref.c"

void
Parrot_SharedRef_set_string_same(Interp *interp, PMC* pmc, PMC* value)
 {

    LOCK_PMC(interp, pmc);
     VTABLE_set_string_same(interp, (PMC *)PMC_pmc_val(pmc), value);
    UNLOCK_PMC(interp, pmc);

}

#line 1661 "sharedref.c"

void
Parrot_SharedRef_setprop(Interp *interp, PMC* pmc, STRING* key, PMC* value)
 {

    LOCK_PMC(interp, pmc);
     VTABLE_setprop(interp, (PMC *)PMC_pmc_val(pmc), key, value);
    UNLOCK_PMC(interp, pmc);

}

void
Parrot_SharedRef_share(Interp *interp, PMC* pmc)
#line 89 "./src/pmc/sharedref.pmc"
{

}
#line 1682 "src/pmc/sharedref.c"
#line 1681 "sharedref.c"

PMC*
Parrot_SharedRef_share_ro(Interp *interp, PMC* pmc)
 {
    PMC* ret_val;
    LOCK_PMC(interp, pmc);
    ret_val =  VTABLE_share_ro(interp, (PMC *)PMC_pmc_val(pmc));
    UNLOCK_PMC(interp, pmc);

    return ret_val;
}

#line 1694 "sharedref.c"

FLOATVAL
Parrot_SharedRef_shift_float(Interp *interp, PMC* pmc)
 {
    FLOATVAL ret_val;
    LOCK_PMC(interp, pmc);
    ret_val =  VTABLE_shift_float(interp, (PMC *)PMC_pmc_val(pmc));
    UNLOCK_PMC(interp, pmc);

    return ret_val;
}

#line 1707 "sharedref.c"

INTVAL
Parrot_SharedRef_shift_integer(Interp *interp, PMC* pmc)
 {
    INTVAL ret_val;
    LOCK_PMC(interp, pmc);
    ret_val =  VTABLE_shift_integer(interp, (PMC *)PMC_pmc_val(pmc));
    UNLOCK_PMC(interp, pmc);

    return ret_val;
}

#line 1720 "sharedref.c"

PMC*
Parrot_SharedRef_shift_pmc(Interp *interp, PMC* pmc)
 {
    PMC* ret_val;
    LOCK_PMC(interp, pmc);
    ret_val =  VTABLE_shift_pmc(interp, (PMC *)PMC_pmc_val(pmc));
    UNLOCK_PMC(interp, pmc);

    return ret_val;
}

#line 1733 "sharedref.c"

STRING*
Parrot_SharedRef_shift_string(Interp *interp, PMC* pmc)
 {
    STRING* ret_val;
    LOCK_PMC(interp, pmc);
    ret_val =  VTABLE_shift_string(interp, (PMC *)PMC_pmc_val(pmc));
    UNLOCK_PMC(interp, pmc);

    return ret_val;
}

#line 1746 "sharedref.c"

PMC*
Parrot_SharedRef_slice(Interp *interp, PMC* pmc, PMC* key, INTVAL flag)
 {
    PMC* ret_val;
    LOCK_PMC(interp, pmc);
    ret_val =  VTABLE_slice(interp, (PMC *)PMC_pmc_val(pmc), key, flag);
    UNLOCK_PMC(interp, pmc);

    return ret_val;
}

#line 1759 "sharedref.c"

void
Parrot_SharedRef_splice(Interp *interp, PMC* pmc, PMC* value, INTVAL offset, INTVAL count)
 {

    LOCK_PMC(interp, pmc);
     VTABLE_splice(interp, (PMC *)PMC_pmc_val(pmc), value, offset, count);
    UNLOCK_PMC(interp, pmc);

}

#line 1772 "sharedref.c"

PMC*
Parrot_SharedRef_subclass(Interp *interp, PMC* pmc, PMC* name)
 {
    PMC* ret_val;
    LOCK_PMC(interp, pmc);
    ret_val =  VTABLE_subclass(interp, (PMC *)PMC_pmc_val(pmc), name);
    UNLOCK_PMC(interp, pmc);

    return ret_val;
}

#line 1785 "sharedref.c"

void
Parrot_SharedRef_substr(Interp *interp, PMC* pmc, INTVAL offset, INTVAL length, PMC* dest)
 {

    LOCK_PMC(interp, pmc);
     VTABLE_substr(interp, (PMC *)PMC_pmc_val(pmc), offset, length, dest);
    UNLOCK_PMC(interp, pmc);

}

#line 1798 "sharedref.c"

STRING*
Parrot_SharedRef_substr_str(Interp *interp, PMC* pmc, INTVAL offset, INTVAL length)
 {
    STRING* ret_val;
    LOCK_PMC(interp, pmc);
    ret_val =  VTABLE_substr_str(interp, (PMC *)PMC_pmc_val(pmc), offset, length);
    UNLOCK_PMC(interp, pmc);

    return ret_val;
}

#line 1811 "sharedref.c"

UINTVAL
Parrot_SharedRef_subtype(Interp *interp, PMC* pmc, INTVAL type)
 {
    UINTVAL ret_val;
    LOCK_PMC(interp, pmc);
    ret_val =  VTABLE_subtype(interp, (PMC *)PMC_pmc_val(pmc), type);
    UNLOCK_PMC(interp, pmc);

    return ret_val;
}

#line 1824 "sharedref.c"

void
Parrot_SharedRef_thaw(Interp *interp, PMC* pmc, visit_info* info)
 {

    LOCK_PMC(interp, pmc);
     VTABLE_thaw(interp, (PMC *)PMC_pmc_val(pmc), info);
    UNLOCK_PMC(interp, pmc);

}

#line 1837 "sharedref.c"

void
Parrot_SharedRef_thawfinish(Interp *interp, PMC* pmc, visit_info* info)
 {

    LOCK_PMC(interp, pmc);
     VTABLE_thawfinish(interp, (PMC *)PMC_pmc_val(pmc), info);
    UNLOCK_PMC(interp, pmc);

}

#line 1850 "sharedref.c"

INTVAL
Parrot_SharedRef_type(Interp *interp, PMC* pmc)
 {
    INTVAL ret_val;
    LOCK_PMC(interp, pmc);
    ret_val =  VTABLE_type(interp, (PMC *)PMC_pmc_val(pmc));
    UNLOCK_PMC(interp, pmc);

    return ret_val;
}

#line 1863 "sharedref.c"

INTVAL
Parrot_SharedRef_type_keyed(Interp *interp, PMC* pmc, PMC* key)
 {
    INTVAL ret_val;
    LOCK_PMC(interp, pmc);
    ret_val =  VTABLE_type_keyed(interp, (PMC *)PMC_pmc_val(pmc), key);
    UNLOCK_PMC(interp, pmc);

    return ret_val;
}

#line 1876 "sharedref.c"

INTVAL
Parrot_SharedRef_type_keyed_int(Interp *interp, PMC* pmc, INTVAL key)
 {
    INTVAL ret_val;
    LOCK_PMC(interp, pmc);
    ret_val =  VTABLE_type_keyed_int(interp, (PMC *)PMC_pmc_val(pmc), key);
    UNLOCK_PMC(interp, pmc);

    return ret_val;
}

#line 1889 "sharedref.c"

INTVAL
Parrot_SharedRef_type_keyed_str(Interp *interp, PMC* pmc, STRING* key)
 {
    INTVAL ret_val;
    LOCK_PMC(interp, pmc);
    ret_val =  VTABLE_type_keyed_str(interp, (PMC *)PMC_pmc_val(pmc), key);
    UNLOCK_PMC(interp, pmc);

    return ret_val;
}

#line 1902 "sharedref.c"

void
Parrot_SharedRef_unshift_float(Interp *interp, PMC* pmc, FLOATVAL value)
 {

    LOCK_PMC(interp, pmc);
     VTABLE_unshift_float(interp, (PMC *)PMC_pmc_val(pmc), value);
    UNLOCK_PMC(interp, pmc);

}

#line 1915 "sharedref.c"

void
Parrot_SharedRef_unshift_integer(Interp *interp, PMC* pmc, INTVAL value)
 {

    LOCK_PMC(interp, pmc);
     VTABLE_unshift_integer(interp, (PMC *)PMC_pmc_val(pmc), value);
    UNLOCK_PMC(interp, pmc);

}

#line 1928 "sharedref.c"

void
Parrot_SharedRef_unshift_pmc(Interp *interp, PMC* pmc, PMC* value)
 {

    LOCK_PMC(interp, pmc);
     VTABLE_unshift_pmc(interp, (PMC *)PMC_pmc_val(pmc), value);
    UNLOCK_PMC(interp, pmc);

}

#line 1941 "sharedref.c"

void
Parrot_SharedRef_unshift_string(Interp *interp, PMC* pmc, STRING* value)
 {

    LOCK_PMC(interp, pmc);
     VTABLE_unshift_string(interp, (PMC *)PMC_pmc_val(pmc), value);
    UNLOCK_PMC(interp, pmc);

}

#line 1954 "sharedref.c"

void
Parrot_SharedRef_visit(Interp *interp, PMC* pmc, visit_info* info)
 {

    LOCK_PMC(interp, pmc);
     VTABLE_visit(interp, (PMC *)PMC_pmc_val(pmc), info);
    UNLOCK_PMC(interp, pmc);

}
void
Parrot_SharedRef_ro_add_attribute(Interp *interp, PMC* pmc, STRING* name, PMC* type)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "add_attribute() in read-only instance of SharedRef");
}
void
Parrot_SharedRef_ro_add_method(Interp *interp, PMC* pmc, STRING* method_name, PMC* sub_pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "add_method() in read-only instance of SharedRef");
}
void
Parrot_SharedRef_ro_add_parent(Interp *interp, PMC* pmc, PMC* parent)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "add_parent() in read-only instance of SharedRef");
}
void
Parrot_SharedRef_ro_add_role(Interp *interp, PMC* pmc, PMC* role)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "add_role() in read-only instance of SharedRef");
}
void
Parrot_SharedRef_ro_assign_pmc(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "assign_pmc() in read-only instance of SharedRef");
}
void
Parrot_SharedRef_ro_assign_string_native(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "assign_string_native() in read-only instance of SharedRef");
}
void
Parrot_SharedRef_ro_decrement(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "decrement() in read-only instance of SharedRef");
}
void
Parrot_SharedRef_ro_delete_keyed(Interp *interp, PMC* pmc, PMC* key)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "delete_keyed() in read-only instance of SharedRef");
}
void
Parrot_SharedRef_ro_delete_keyed_int(Interp *interp, PMC* pmc, INTVAL key)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "delete_keyed_int() in read-only instance of SharedRef");
}
void
Parrot_SharedRef_ro_delete_keyed_str(Interp *interp, PMC* pmc, STRING* key)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "delete_keyed_str() in read-only instance of SharedRef");
}
PMC*
Parrot_SharedRef_ro_find_method(Interp *interp, PMC* pmc, STRING* method_name)
 {
    PMC *const method = Parrot_SharedRef_find_method(interp, pmc, method_name);
    if (!PMC_IS_NULL(VTABLE_getprop(interp, method, const_string(interp, "write"))))
        return PMCNULL;
    else
        return method;
}
void
Parrot_SharedRef_ro_i_absolute(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_absolute() in read-only instance of SharedRef");
}
void
Parrot_SharedRef_ro_i_bitwise_not(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_bitwise_not() in read-only instance of SharedRef");
}
void
Parrot_SharedRef_ro_i_bitwise_nots(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_bitwise_nots() in read-only instance of SharedRef");
}
void
Parrot_SharedRef_ro_i_logical_not(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_logical_not() in read-only instance of SharedRef");
}
void
Parrot_SharedRef_ro_i_neg(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_neg() in read-only instance of SharedRef");
}
void
Parrot_SharedRef_ro_increment(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "increment() in read-only instance of SharedRef");
}
void
Parrot_SharedRef_ro_morph(Interp *interp, PMC* pmc, INTVAL type)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "morph() in read-only instance of SharedRef");
}
FLOATVAL
Parrot_SharedRef_ro_pop_float(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "pop_float() in read-only instance of SharedRef");
    return (FLOATVAL)0;
}
INTVAL
Parrot_SharedRef_ro_pop_integer(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "pop_integer() in read-only instance of SharedRef");
    return (INTVAL)0;
}
PMC*
Parrot_SharedRef_ro_pop_pmc(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "pop_pmc() in read-only instance of SharedRef");
    return PMCNULL;
}
STRING*
Parrot_SharedRef_ro_pop_string(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "pop_string() in read-only instance of SharedRef");
    return (STRING*)0;
}
void
Parrot_SharedRef_ro_push_float(Interp *interp, PMC* pmc, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "push_float() in read-only instance of SharedRef");
}
void
Parrot_SharedRef_ro_push_integer(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "push_integer() in read-only instance of SharedRef");
}
void
Parrot_SharedRef_ro_push_pmc(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "push_pmc() in read-only instance of SharedRef");
}
void
Parrot_SharedRef_ro_push_string(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "push_string() in read-only instance of SharedRef");
}
void
Parrot_SharedRef_ro_remove_attribute(Interp *interp, PMC* pmc, STRING* name)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "remove_attribute() in read-only instance of SharedRef");
}
void
Parrot_SharedRef_ro_remove_method(Interp *interp, PMC* pmc, STRING* method_name)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "remove_method() in read-only instance of SharedRef");
}
void
Parrot_SharedRef_ro_remove_parent(Interp *interp, PMC* pmc, PMC* parent)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "remove_parent() in read-only instance of SharedRef");
}
void
Parrot_SharedRef_ro_remove_role(Interp *interp, PMC* pmc, PMC* role)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "remove_role() in read-only instance of SharedRef");
}
void
Parrot_SharedRef_ro_set_attr(Interp *interp, PMC* pmc, INTVAL idx, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_attr() in read-only instance of SharedRef");
}
void
Parrot_SharedRef_ro_set_attr_str(Interp *interp, PMC* pmc, STRING* idx, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_attr_str() in read-only instance of SharedRef");
}
void
Parrot_SharedRef_ro_set_bignum_int(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_bignum_int() in read-only instance of SharedRef");
}
void
Parrot_SharedRef_ro_set_bignum_num(Interp *interp, PMC* pmc, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_bignum_num() in read-only instance of SharedRef");
}
void
Parrot_SharedRef_ro_set_bignum_str(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_bignum_str() in read-only instance of SharedRef");
}
void
Parrot_SharedRef_ro_set_bool(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_bool() in read-only instance of SharedRef");
}
void
Parrot_SharedRef_ro_set_integer_keyed(Interp *interp, PMC* pmc, PMC* key, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_keyed() in read-only instance of SharedRef");
}
void
Parrot_SharedRef_ro_set_integer_keyed_int(Interp *interp, PMC* pmc, INTVAL key, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_keyed_int() in read-only instance of SharedRef");
}
void
Parrot_SharedRef_ro_set_integer_keyed_str(Interp *interp, PMC* pmc, STRING* key, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_keyed_str() in read-only instance of SharedRef");
}
void
Parrot_SharedRef_ro_set_integer_native(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_native() in read-only instance of SharedRef");
}
void
Parrot_SharedRef_ro_set_integer_same(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_same() in read-only instance of SharedRef");
}
void
Parrot_SharedRef_ro_set_number_keyed(Interp *interp, PMC* pmc, PMC* key, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_keyed() in read-only instance of SharedRef");
}
void
Parrot_SharedRef_ro_set_number_keyed_int(Interp *interp, PMC* pmc, INTVAL key, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_keyed_int() in read-only instance of SharedRef");
}
void
Parrot_SharedRef_ro_set_number_keyed_str(Interp *interp, PMC* pmc, STRING* key, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_keyed_str() in read-only instance of SharedRef");
}
void
Parrot_SharedRef_ro_set_number_native(Interp *interp, PMC* pmc, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_native() in read-only instance of SharedRef");
}
void
Parrot_SharedRef_ro_set_number_same(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_same() in read-only instance of SharedRef");
}
void
Parrot_SharedRef_ro_set_pmc(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pmc() in read-only instance of SharedRef");
}
void
Parrot_SharedRef_ro_set_pmc_keyed(Interp *interp, PMC* pmc, PMC* key, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pmc_keyed() in read-only instance of SharedRef");
}
void
Parrot_SharedRef_ro_set_pmc_keyed_int(Interp *interp, PMC* pmc, INTVAL key, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_int() in read-only instance of SharedRef");
}
void
Parrot_SharedRef_ro_set_pmc_keyed_str(Interp *interp, PMC* pmc, STRING* key, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_str() in read-only instance of SharedRef");
}
void
Parrot_SharedRef_ro_set_pointer(Interp *interp, PMC* pmc, void* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pointer() in read-only instance of SharedRef");
}
void
Parrot_SharedRef_ro_set_pointer_keyed(Interp *interp, PMC* pmc, PMC* key, void* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pointer_keyed() in read-only instance of SharedRef");
}
void
Parrot_SharedRef_ro_set_pointer_keyed_int(Interp *interp, PMC* pmc, INTVAL key, void* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_int() in read-only instance of SharedRef");
}
void
Parrot_SharedRef_ro_set_pointer_keyed_str(Interp *interp, PMC* pmc, STRING* key, void* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_str() in read-only instance of SharedRef");
}
void
Parrot_SharedRef_ro_set_string_keyed(Interp *interp, PMC* pmc, PMC* key, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_keyed() in read-only instance of SharedRef");
}
void
Parrot_SharedRef_ro_set_string_keyed_int(Interp *interp, PMC* pmc, INTVAL key, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_keyed_int() in read-only instance of SharedRef");
}
void
Parrot_SharedRef_ro_set_string_keyed_str(Interp *interp, PMC* pmc, STRING* key, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_keyed_str() in read-only instance of SharedRef");
}
void
Parrot_SharedRef_ro_set_string_native(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_native() in read-only instance of SharedRef");
}
void
Parrot_SharedRef_ro_set_string_same(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_same() in read-only instance of SharedRef");
}
FLOATVAL
Parrot_SharedRef_ro_shift_float(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "shift_float() in read-only instance of SharedRef");
    return (FLOATVAL)0;
}
INTVAL
Parrot_SharedRef_ro_shift_integer(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "shift_integer() in read-only instance of SharedRef");
    return (INTVAL)0;
}
PMC*
Parrot_SharedRef_ro_shift_pmc(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "shift_pmc() in read-only instance of SharedRef");
    return PMCNULL;
}
STRING*
Parrot_SharedRef_ro_shift_string(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "shift_string() in read-only instance of SharedRef");
    return (STRING*)0;
}
void
Parrot_SharedRef_ro_splice(Interp *interp, PMC* pmc, PMC* value, INTVAL offset, INTVAL count)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "splice() in read-only instance of SharedRef");
}
void
Parrot_SharedRef_ro_thaw(Interp *interp, PMC* pmc, visit_info* info)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "thaw() in read-only instance of SharedRef");
}
void
Parrot_SharedRef_ro_thawfinish(Interp *interp, PMC* pmc, visit_info* info)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "thawfinish() in read-only instance of SharedRef");
}
void
Parrot_SharedRef_ro_unshift_float(Interp *interp, PMC* pmc, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "unshift_float() in read-only instance of SharedRef");
}
void
Parrot_SharedRef_ro_unshift_integer(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "unshift_integer() in read-only instance of SharedRef");
}
void
Parrot_SharedRef_ro_unshift_pmc(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "unshift_pmc() in read-only instance of SharedRef");
}
void
Parrot_SharedRef_ro_unshift_string(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "unshift_string() in read-only instance of SharedRef");
}
void
Parrot_SharedRef_class_init(Parrot_Interp interp, int entry, int pass)
{
    const VTABLE temp_base_vtable = {
        NULL, /* namespace */
        enum_class_SharedRef, /* base_type */
        NULL, /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_IS_SHARED_FLAG|VTABLE_HAS_READONLY_FLAG, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        NULL,   /* ro_variant_vtable */
        Parrot_SharedRef_absolute,
        Parrot_SharedRef_add_attribute,
        Parrot_SharedRef_add_method,
        Parrot_SharedRef_add_parent,
        Parrot_SharedRef_add_role,
        Parrot_SharedRef_assign_pmc,
        Parrot_SharedRef_assign_string_native,
        Parrot_SharedRef_bitwise_not,
        Parrot_SharedRef_bitwise_nots,
        Parrot_SharedRef_can,
        Parrot_SharedRef_class_type,
        Parrot_SharedRef_clone,
        Parrot_SharedRef_clone_pmc,
        Parrot_SharedRef_decrement,
        Parrot_SharedRef_defined,
        Parrot_SharedRef_defined_keyed,
        Parrot_SharedRef_defined_keyed_int,
        Parrot_SharedRef_defined_keyed_str,
        Parrot_SharedRef_delete_keyed,
        Parrot_SharedRef_delete_keyed_int,
        Parrot_SharedRef_delete_keyed_str,
        Parrot_SharedRef_delprop,
        Parrot_SharedRef_destroy,
        Parrot_SharedRef_does,
        Parrot_SharedRef_elements,
        Parrot_SharedRef_exists_keyed,
        Parrot_SharedRef_exists_keyed_int,
        Parrot_SharedRef_exists_keyed_str,
        Parrot_SharedRef_find_method,
        Parrot_SharedRef_freeze,
        Parrot_SharedRef_get_attr,
        Parrot_SharedRef_get_attr_str,
        Parrot_SharedRef_get_bignum,
        Parrot_SharedRef_get_bool,
        Parrot_SharedRef_get_class,
        Parrot_SharedRef_get_integer,
        Parrot_SharedRef_get_integer_keyed,
        Parrot_SharedRef_get_integer_keyed_int,
        Parrot_SharedRef_get_integer_keyed_str,
        Parrot_SharedRef_get_iter,
        Parrot_SharedRef_get_number,
        Parrot_SharedRef_get_number_keyed,
        Parrot_SharedRef_get_number_keyed_int,
        Parrot_SharedRef_get_number_keyed_str,
        Parrot_SharedRef_get_pmc,
        Parrot_SharedRef_get_pmc_keyed,
        Parrot_SharedRef_get_pmc_keyed_int,
        Parrot_SharedRef_get_pmc_keyed_str,
        Parrot_SharedRef_get_pointer,
        Parrot_SharedRef_get_pointer_keyed,
        Parrot_SharedRef_get_pointer_keyed_int,
        Parrot_SharedRef_get_pointer_keyed_str,
        Parrot_SharedRef_get_repr,
        Parrot_SharedRef_get_string,
        Parrot_SharedRef_get_string_keyed,
        Parrot_SharedRef_get_string_keyed_int,
        Parrot_SharedRef_get_string_keyed_str,
        Parrot_SharedRef_getprop,
        Parrot_SharedRef_getprops,
        Parrot_SharedRef_hash,
        Parrot_SharedRef_i_absolute,
        Parrot_SharedRef_i_bitwise_not,
        Parrot_SharedRef_i_bitwise_nots,
        Parrot_SharedRef_i_logical_not,
        Parrot_SharedRef_i_neg,
        Parrot_SharedRef_increment,
        Parrot_SharedRef_init,
        Parrot_SharedRef_init_pmc,
        Parrot_SharedRef_inspect,
        Parrot_SharedRef_inspect_str,
        Parrot_SharedRef_instantiate,
        Parrot_SharedRef_invoke,
        Parrot_SharedRef_is_same,
        Parrot_SharedRef_isa,
        Parrot_SharedRef_logical_not,
        Parrot_SharedRef_mark,
        Parrot_SharedRef_morph,
        Parrot_SharedRef_name,
        Parrot_SharedRef_neg,
        Parrot_SharedRef_new_from_string,
        Parrot_SharedRef_nextkey_keyed,
        Parrot_SharedRef_nextkey_keyed_int,
        Parrot_SharedRef_nextkey_keyed_str,
        Parrot_SharedRef_pmc_namespace,
        Parrot_SharedRef_pop_float,
        Parrot_SharedRef_pop_integer,
        Parrot_SharedRef_pop_pmc,
        Parrot_SharedRef_pop_string,
        Parrot_SharedRef_push_float,
        Parrot_SharedRef_push_integer,
        Parrot_SharedRef_push_pmc,
        Parrot_SharedRef_push_string,
        Parrot_SharedRef_remove_attribute,
        Parrot_SharedRef_remove_method,
        Parrot_SharedRef_remove_parent,
        Parrot_SharedRef_remove_role,
        Parrot_SharedRef_set_attr,
        Parrot_SharedRef_set_attr_str,
        Parrot_SharedRef_set_bignum_int,
        Parrot_SharedRef_set_bignum_num,
        Parrot_SharedRef_set_bignum_str,
        Parrot_SharedRef_set_bool,
        Parrot_SharedRef_set_integer_keyed,
        Parrot_SharedRef_set_integer_keyed_int,
        Parrot_SharedRef_set_integer_keyed_str,
        Parrot_SharedRef_set_integer_native,
        Parrot_SharedRef_set_integer_same,
        Parrot_SharedRef_set_number_keyed,
        Parrot_SharedRef_set_number_keyed_int,
        Parrot_SharedRef_set_number_keyed_str,
        Parrot_SharedRef_set_number_native,
        Parrot_SharedRef_set_number_same,
        Parrot_SharedRef_set_pmc,
        Parrot_SharedRef_set_pmc_keyed,
        Parrot_SharedRef_set_pmc_keyed_int,
        Parrot_SharedRef_set_pmc_keyed_str,
        Parrot_SharedRef_set_pointer,
        Parrot_SharedRef_set_pointer_keyed,
        Parrot_SharedRef_set_pointer_keyed_int,
        Parrot_SharedRef_set_pointer_keyed_str,
        Parrot_SharedRef_set_string_keyed,
        Parrot_SharedRef_set_string_keyed_int,
        Parrot_SharedRef_set_string_keyed_str,
        Parrot_SharedRef_set_string_native,
        Parrot_SharedRef_set_string_same,
        Parrot_SharedRef_setprop,
        Parrot_SharedRef_share,
        Parrot_SharedRef_share_ro,
        Parrot_SharedRef_shift_float,
        Parrot_SharedRef_shift_integer,
        Parrot_SharedRef_shift_pmc,
        Parrot_SharedRef_shift_string,
        Parrot_SharedRef_slice,
        Parrot_SharedRef_splice,
        Parrot_SharedRef_subclass,
        Parrot_SharedRef_substr,
        Parrot_SharedRef_substr_str,
        Parrot_SharedRef_subtype,
        Parrot_SharedRef_thaw,
        Parrot_SharedRef_thawfinish,
        Parrot_SharedRef_type,
        Parrot_SharedRef_type_keyed,
        Parrot_SharedRef_type_keyed_int,
        Parrot_SharedRef_type_keyed_str,
        Parrot_SharedRef_unshift_float,
        Parrot_SharedRef_unshift_integer,
        Parrot_SharedRef_unshift_pmc,
        Parrot_SharedRef_unshift_string,
        Parrot_SharedRef_visit
    };

    const VTABLE temp_ro_vtable = {
        NULL, /* namespace */
        enum_class_SharedRef, /* base_type */
        NULL, /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_IS_SHARED_FLAG|VTABLE_IS_READONLY_FLAG, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        NULL,   /* ro_variant_vtable */
        Parrot_SharedRef_absolute,
        Parrot_SharedRef_ro_add_attribute,
        Parrot_SharedRef_ro_add_method,
        Parrot_SharedRef_ro_add_parent,
        Parrot_SharedRef_ro_add_role,
        Parrot_SharedRef_ro_assign_pmc,
        Parrot_SharedRef_ro_assign_string_native,
        Parrot_SharedRef_bitwise_not,
        Parrot_SharedRef_bitwise_nots,
        Parrot_SharedRef_can,
        Parrot_SharedRef_class_type,
        Parrot_SharedRef_clone,
        Parrot_SharedRef_clone_pmc,
        Parrot_SharedRef_ro_decrement,
        Parrot_SharedRef_defined,
        Parrot_SharedRef_defined_keyed,
        Parrot_SharedRef_defined_keyed_int,
        Parrot_SharedRef_defined_keyed_str,
        Parrot_SharedRef_ro_delete_keyed,
        Parrot_SharedRef_ro_delete_keyed_int,
        Parrot_SharedRef_ro_delete_keyed_str,
        Parrot_SharedRef_delprop,
        Parrot_SharedRef_destroy,
        Parrot_SharedRef_does,
        Parrot_SharedRef_elements,
        Parrot_SharedRef_exists_keyed,
        Parrot_SharedRef_exists_keyed_int,
        Parrot_SharedRef_exists_keyed_str,
        Parrot_SharedRef_ro_find_method,
        Parrot_SharedRef_freeze,
        Parrot_SharedRef_get_attr,
        Parrot_SharedRef_get_attr_str,
        Parrot_SharedRef_get_bignum,
        Parrot_SharedRef_get_bool,
        Parrot_SharedRef_get_class,
        Parrot_SharedRef_get_integer,
        Parrot_SharedRef_get_integer_keyed,
        Parrot_SharedRef_get_integer_keyed_int,
        Parrot_SharedRef_get_integer_keyed_str,
        Parrot_SharedRef_get_iter,
        Parrot_SharedRef_get_number,
        Parrot_SharedRef_get_number_keyed,
        Parrot_SharedRef_get_number_keyed_int,
        Parrot_SharedRef_get_number_keyed_str,
        Parrot_SharedRef_get_pmc,
        Parrot_SharedRef_get_pmc_keyed,
        Parrot_SharedRef_get_pmc_keyed_int,
        Parrot_SharedRef_get_pmc_keyed_str,
        Parrot_SharedRef_get_pointer,
        Parrot_SharedRef_get_pointer_keyed,
        Parrot_SharedRef_get_pointer_keyed_int,
        Parrot_SharedRef_get_pointer_keyed_str,
        Parrot_SharedRef_get_repr,
        Parrot_SharedRef_get_string,
        Parrot_SharedRef_get_string_keyed,
        Parrot_SharedRef_get_string_keyed_int,
        Parrot_SharedRef_get_string_keyed_str,
        Parrot_SharedRef_getprop,
        Parrot_SharedRef_getprops,
        Parrot_SharedRef_hash,
        Parrot_SharedRef_ro_i_absolute,
        Parrot_SharedRef_ro_i_bitwise_not,
        Parrot_SharedRef_ro_i_bitwise_nots,
        Parrot_SharedRef_ro_i_logical_not,
        Parrot_SharedRef_ro_i_neg,
        Parrot_SharedRef_ro_increment,
        Parrot_SharedRef_init,
        Parrot_SharedRef_init_pmc,
        Parrot_SharedRef_inspect,
        Parrot_SharedRef_inspect_str,
        Parrot_SharedRef_instantiate,
        Parrot_SharedRef_invoke,
        Parrot_SharedRef_is_same,
        Parrot_SharedRef_isa,
        Parrot_SharedRef_logical_not,
        Parrot_SharedRef_mark,
        Parrot_SharedRef_ro_morph,
        Parrot_SharedRef_name,
        Parrot_SharedRef_neg,
        Parrot_SharedRef_new_from_string,
        Parrot_SharedRef_nextkey_keyed,
        Parrot_SharedRef_nextkey_keyed_int,
        Parrot_SharedRef_nextkey_keyed_str,
        Parrot_SharedRef_pmc_namespace,
        Parrot_SharedRef_ro_pop_float,
        Parrot_SharedRef_ro_pop_integer,
        Parrot_SharedRef_ro_pop_pmc,
        Parrot_SharedRef_ro_pop_string,
        Parrot_SharedRef_ro_push_float,
        Parrot_SharedRef_ro_push_integer,
        Parrot_SharedRef_ro_push_pmc,
        Parrot_SharedRef_ro_push_string,
        Parrot_SharedRef_ro_remove_attribute,
        Parrot_SharedRef_ro_remove_method,
        Parrot_SharedRef_ro_remove_parent,
        Parrot_SharedRef_ro_remove_role,
        Parrot_SharedRef_ro_set_attr,
        Parrot_SharedRef_ro_set_attr_str,
        Parrot_SharedRef_ro_set_bignum_int,
        Parrot_SharedRef_ro_set_bignum_num,
        Parrot_SharedRef_ro_set_bignum_str,
        Parrot_SharedRef_ro_set_bool,
        Parrot_SharedRef_ro_set_integer_keyed,
        Parrot_SharedRef_ro_set_integer_keyed_int,
        Parrot_SharedRef_ro_set_integer_keyed_str,
        Parrot_SharedRef_ro_set_integer_native,
        Parrot_SharedRef_ro_set_integer_same,
        Parrot_SharedRef_ro_set_number_keyed,
        Parrot_SharedRef_ro_set_number_keyed_int,
        Parrot_SharedRef_ro_set_number_keyed_str,
        Parrot_SharedRef_ro_set_number_native,
        Parrot_SharedRef_ro_set_number_same,
        Parrot_SharedRef_ro_set_pmc,
        Parrot_SharedRef_ro_set_pmc_keyed,
        Parrot_SharedRef_ro_set_pmc_keyed_int,
        Parrot_SharedRef_ro_set_pmc_keyed_str,
        Parrot_SharedRef_ro_set_pointer,
        Parrot_SharedRef_ro_set_pointer_keyed,
        Parrot_SharedRef_ro_set_pointer_keyed_int,
        Parrot_SharedRef_ro_set_pointer_keyed_str,
        Parrot_SharedRef_ro_set_string_keyed,
        Parrot_SharedRef_ro_set_string_keyed_int,
        Parrot_SharedRef_ro_set_string_keyed_str,
        Parrot_SharedRef_ro_set_string_native,
        Parrot_SharedRef_ro_set_string_same,
        Parrot_SharedRef_setprop,
        Parrot_SharedRef_share,
        Parrot_SharedRef_share_ro,
        Parrot_SharedRef_ro_shift_float,
        Parrot_SharedRef_ro_shift_integer,
        Parrot_SharedRef_ro_shift_pmc,
        Parrot_SharedRef_ro_shift_string,
        Parrot_SharedRef_slice,
        Parrot_SharedRef_ro_splice,
        Parrot_SharedRef_subclass,
        Parrot_SharedRef_substr,
        Parrot_SharedRef_substr_str,
        Parrot_SharedRef_subtype,
        Parrot_SharedRef_ro_thaw,
        Parrot_SharedRef_ro_thawfinish,
        Parrot_SharedRef_type,
        Parrot_SharedRef_type_keyed,
        Parrot_SharedRef_type_keyed_int,
        Parrot_SharedRef_type_keyed_str,
        Parrot_SharedRef_ro_unshift_float,
        Parrot_SharedRef_ro_unshift_integer,
        Parrot_SharedRef_ro_unshift_pmc,
        Parrot_SharedRef_ro_unshift_string,
        Parrot_SharedRef_visit
    };
    if (pass == 0) {
        /*
         * create vtable - clone it - we have to set a few items
         */
        VTABLE *vt_clone =
            Parrot_clone_vtable(interp, &temp_base_vtable);
        VTABLE *vt_ro_clone =
            Parrot_clone_vtable(interp, &temp_ro_vtable);
        vt_clone->whoami = CONST_STRING(interp, "SharedRef");
        vt_clone->isa_str = CONST_STRING(interp, "SharedRef Ref");
        vt_clone->does_str = CONST_STRING(interp, "ref");
        vt_ro_clone->base_type = entry;
        vt_ro_clone->whoami = vt_clone->whoami;
        vt_ro_clone->isa_str = vt_clone->isa_str;
        vt_ro_clone->does_str = vt_clone->does_str;
        vt_clone->ro_variant_vtable = vt_ro_clone;
        vt_ro_clone->ro_variant_vtable = vt_clone;
        interp->vtables[entry] = vt_clone;
    }
    else { /* pass */
        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        /* create PMC Proxy object */
        Parrot_create_pmc_proxy(interp, entry);
        /* class_init */
        {
        }
    } /* pass */
} /* Parrot_SharedRef_class_init */


/*

=back

=head1 HISTORY

Initial revision by leo 2004.01.14.

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
