/*
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/slice.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

#line 1 "./src/pmc/slice.pmc"
/*
Copyright (C) 2004-2007, The Perl Foundation.
$Id: slice.pmc 18407 2007-05-03 05:08:51Z chromatic $

=head1 NAME

src/pmc/slice.pmc - Slice PMC

=head1 DESCRIPTION

These are the vtable functions for the slice PMC class.

A Slice PMC isa Key PMC, holding a chain of start and/or end values
for slice ranges. Private flags define the meaning of the values:

  [ s .. e ]    s .. KEY_start_slice_FLAG; e .. KEY_end_slice_FLAG
  [ x,     ]    KEY_start_slice_FLAG | KEY_end_slice_FLAG
  [  .. e  ]    KEY_inf_slice_FLAG   | KEY_end_slice_FLAG
  [ s ..   ]    KEY_start_slice_FLAG | KEY_inf_slice_FLAG

Infinite ranges are currently implemented for Array and PerlString only.

Run

  $ parrot -d2000 slice.pasm

to see slice constant flags.

During initialization above key chain gets converted to parrot_range_t
structures.

=head2 Methods

=over 4

=cut

*/

#include "parrot/parrot.h"

/*
 * create range_t structure
 *
 * set the Slice iter state to initial, first position
 * no backwards iterations for now
 *
 * XXX self is a key chain (PMC constant), which shouldn't be modified
 *     finally this stuff should be call from packfiles thaw
 *
 */
static void
set_slice_start(Interp *interp, PMC *self, PMC *key, PMC *agg)
{
    parrot_range_t *range = mem_allocate_typed(parrot_range_t);

    PMC_struct_val(self)  = range;

next_range:
    range->next           = NULL;
    RVal_int(range->step) = 1;

    if (key_type(interp, key) & KEY_integer_FLAG) {
        range->type = enum_type_INTVAL;

        /* integer key */
        if ((PObj_get_FLAGS(key) &
                    (KEY_start_slice_FLAG|KEY_end_slice_FLAG)) ==
                (KEY_start_slice_FLAG|KEY_end_slice_FLAG)) {
            /* start == end */
            RVal_int(range->start) =
                RVal_int(range->end) = key_integer(interp, key);
        }
        else if ((PObj_get_FLAGS(key) &
                    (KEY_inf_slice_FLAG|KEY_end_slice_FLAG)) ==
                (KEY_inf_slice_FLAG|KEY_end_slice_FLAG)) {
            /*
             * first range is ".. end"
             * start at index 0
             * */
            RVal_int(range->start) = 0;
            RVal_int(range->end) = key_integer(interp, key);
        }
        else {
            /*
             * else start at range value
             */
            RVal_int(range->start) = key_integer(interp, key);
            if ((PObj_get_FLAGS(key) &
                    (KEY_inf_slice_FLAG|KEY_start_slice_FLAG)) ==
                (KEY_inf_slice_FLAG|KEY_start_slice_FLAG)) {
                /* last range "start .." */
                RVal_int(range->end) = VTABLE_elements(interp, agg) - 1;
                if (PMC_data(key))
                    internal_exception(1, "Illegal range after start..");
            }
            else {
                /* must have end in next key */
                key = PMC_data_typed(key, PMC *);

                if (!key)
                    internal_exception(1, "no end range specified");

                RVal_int(range->end) = key_integer(interp, key);
            }
        }

        if (agg->vtable->base_type == enum_class_Slice)
            --RVal_int(range->end);
        RVal_int(range->cur) = RVal_int(range->start);

range_end:
        key = PMC_data_typed(key, PMC *);

        if (key) {
            parrot_range_t *n = mem_allocate_typed(parrot_range_t);
            range->next       = n;
            range             = n;
            goto next_range;
        }
        return;
    }
    else {
        if (PObj_get_FLAGS(key) & KEY_inf_slice_FLAG) {
            internal_exception(1,
                               "unlimited slice range for hash "
                               "not implemented");
        }
        range->type = enum_type_STRING;
        /*
         * string assumed
         * start at value
         */
        RVal_str(range->start) =
            RVal_str(range->cur) =
            key_string(interp, key);
        if ((PObj_get_FLAGS(key) &
                    (KEY_start_slice_FLAG|KEY_end_slice_FLAG)) ==
                (KEY_start_slice_FLAG|KEY_end_slice_FLAG)) {
            /* start == end */
            RVal_str(range->end) = RVal_str(range->start);
        }
        else {
            /* must have end in next key */
            key = PMC_data_typed(key, PMC *);

            if (!key)
                internal_exception(1, "no end range specified");

            RVal_str(range->end) = key_string(interp, key);
        }
        goto range_end;
    }
}

/*
 * increment Slice value according to range and/or advance to
 * next range PMC in Key chain
 */
static void
set_slice_next(Interp *interp, PMC *self, PMC *agg)
{
    parrot_range_t *r = (parrot_range_t *)PMC_struct_val(self);

    if (!r || (INTVAL) r == -1)
        real_exception(interp, NULL, E_StopIteration, "StopIteration");

    if (r->type == enum_type_INTVAL) {
        RVal_int(r->cur) += RVal_int(r->step);
        if (RVal_int(r->step) > 0) {
            if (RVal_int(r->cur) > RVal_int(r->end)) {
                parrot_range_t *n;
next_range:
                n = r->next;
                mem_sys_free(r);

                PMC_struct_val(self) = n;

                if (!n)
                    PMC_int_val(self) = -1;
            }
        }
        else {
            if (RVal_int(r->cur) < RVal_int(r->end))
                goto next_range;
        }
    }
    else {
        STRING *cur = RVal_str(r->cur);
        STRING *end = RVal_str(r->end);

        if (string_compare(interp, cur, end) < 0)
            RVal_str(r->cur) = string_increment(interp, cur);
        else
            goto next_range;
    }
}

#line 211 "src/pmc/slice.c"
#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_slice.h"
#include "pmc_key.h"
#include "pmc_default.h"
#include "slice.str"

PMC*
Parrot_Slice_clone(Interp *interp, PMC* pmc)
#line 237 "./src/pmc/slice.pmc"
{
    real_exception(interp, NULL, E_NotImplementedError, "Unimplemented");
    return NULL;

}
#line 228 "src/pmc/slice.c"
void
Parrot_Slice_destroy(Interp *interp, PMC* pmc)
#line 222 "./src/pmc/slice.pmc"
{
    parrot_range_t *r = (parrot_range_t *)PMC_struct_val(pmc);
    parrot_range_t *n;

    /* iteration ended - all is freed */
    if ((INTVAL) r == -1)
        return;

    while (r) {
        n = r->next;
        mem_sys_free(r);
        r = n;
    }

}
#line 247 "src/pmc/slice.c"
INTVAL
Parrot_Slice_elements(Interp *interp, PMC* pmc)
#line 303 "./src/pmc/slice.pmc"
{
    parrot_range_t *r = (parrot_range_t *)PMC_struct_val(pmc);
    /* only start .. end supported so:
     * TODO check flags somewhere
     * */
    INTVAL n = RVal_int(r->start) - RVal_int(r->end);
    return n;

}
#line 260 "src/pmc/slice.c"
INTVAL
Parrot_Slice_get_integer(Interp *interp, PMC* pmc)
#line 256 "./src/pmc/slice.pmc"
{
    parrot_range_t *r = (parrot_range_t *)PMC_struct_val(pmc);

    if (!r || (INTVAL) r == -1)
        real_exception(interp, NULL, E_StopIteration, "StopIteration");

    return RVal_int(r->cur);

}
#line 273 "src/pmc/slice.c"
INTVAL
Parrot_Slice_get_integer_keyed(Interp *interp, PMC* pmc, PMC *key)
#line 312 "./src/pmc/slice.pmc"
{
    parrot_range_t *r = (parrot_range_t *)PMC_struct_val(key);
    return RVal_int(r->cur);

}
#line 282 "src/pmc/slice.c"
PMC*
Parrot_Slice_get_iter(Interp *interp, PMC* pmc)
#line 297 "./src/pmc/slice.pmc"
{
    PMC *iter = pmc_new_init(interp, enum_class_Iterator, pmc);
    PMC_struct_val(iter) = pmc;
    return iter;

}
#line 292 "src/pmc/slice.c"
PMC*
Parrot_Slice_get_pmc_keyed(Interp *interp, PMC* pmc, PMC *key)
#line 322 "./src/pmc/slice.pmc"
{
    parrot_range_t *r = (parrot_range_t *)PMC_struct_val(key);
    PMC *res          = PMC_pmc_val(pmc);
    PMC_int_val(res)  = RVal_int(r->cur);

    return res;

}
#line 304 "src/pmc/slice.c"
STRING*
Parrot_Slice_get_string(Interp *interp, PMC* pmc)
#line 265 "./src/pmc/slice.pmc"
{
    parrot_range_t *r = (parrot_range_t *)PMC_struct_val(pmc);

    return RVal_str(r->cur);

}
#line 314 "src/pmc/slice.c"
STRING*
Parrot_Slice_get_string_keyed(Interp *interp, PMC* pmc, PMC *key)
#line 317 "./src/pmc/slice.pmc"
{
    INTVAL v = VTABLE_get_integer(interp, key);
    return string_from_int(interp, v);

}
#line 323 "src/pmc/slice.c"
void
Parrot_Slice_init(Interp *interp, PMC* pmc)
#line 201 "./src/pmc/slice.pmc"
{
    PMC_struct_val(pmc) = NULL;
    PMC_pmc_val(pmc) = NULL;

}
#line 332 "src/pmc/slice.c"
void
Parrot_Slice_init_pmc(Interp *interp, PMC* pmc, PMC *key)
#line 211 "./src/pmc/slice.pmc"
{
    Parrot_Slice_init(interp, pmc);
    /* that's actually the KEY_number_FLAG - but I can't hardly
     * imagine that we get keyed by FLOATVAL slices on
     * arrays
     */
    PObj_get_FLAGS(pmc) |= PObj_private1_FLAG;
    PObj_custom_mark_destroy_SETALL(pmc);
    set_slice_start(interp, pmc, key, pmc);

}
#line 347 "src/pmc/slice.c"
void
Parrot_Slice_mark(Interp *interp, PMC* pmc)
#line 206 "./src/pmc/slice.pmc"
{
    if (PMC_pmc_val(pmc))
        pobject_lives(interp, (PObj*) PMC_pmc_val(pmc));

}
#line 356 "src/pmc/slice.c"
PMC*
Parrot_Slice_nextkey_keyed(Interp *interp, PMC* pmc, PMC *agg, INTVAL what)
#line 339 "./src/pmc/slice.pmc"
{
    PMC *ret = pmc;

    switch (what) {
        case ITERATE_FROM_START:
        case ITERATE_FROM_START_KEYS:    /* reset key */
            if (!agg) {
                /* xrange implementation - the slice PMC
                 * itself serves as the aggregate. It's already
                 * initialized
                 */
                return pmc;
            }

            /*
             * need a new Slice PMC that hold's the state
             * especially PMC_data() must be zero
             *
             * aggregate call get_integer/get_string on this
             * PMC, because it's marked being a Key PMC
             */
            ret = pmc_new(interp, enum_class_Slice);
            PObj_get_FLAGS(ret) |= KEY_pmc_FLAG;
            /*
             * set start value
             */
            set_slice_start(interp, ret, pmc, agg);
            break;
            /*
             * we are passed now the new PMC, we had created above
             */
        case ITERATE_GET_NEXT:
            set_slice_next(interp, pmc, agg);
            break;
        default:
            real_exception(interp, NULL, E_NotImplementedError,
                    "No backward iteration on slices yet");
            break;
    }
    return ret;

}
#line 402 "src/pmc/slice.c"
PMC*
Parrot_Slice_slice(Interp *interp, PMC* pmc, PMC *key, INTVAL f)
#line 284 "./src/pmc/slice.pmc"
{
    if (f) {
        real_exception(interp, NULL, E_ValueError,
                "Slice: Unknown slice type");
        return NULL;
    }
    else {
        PMC *iter = pmc_new_init(interp, enum_class_Iterator, pmc);
        PMC_struct_val(iter) = key;
        return iter;
    }

}
#line 419 "src/pmc/slice.c"
void
Parrot_Slice_ro_add_attribute(Interp *interp, PMC* pmc, STRING* name, PMC* type)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "add_attribute() in read-only instance of Slice");
}
void
Parrot_Slice_ro_add_method(Interp *interp, PMC* pmc, STRING* method_name, PMC* sub_pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "add_method() in read-only instance of Slice");
}
void
Parrot_Slice_ro_add_parent(Interp *interp, PMC* pmc, PMC* parent)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "add_parent() in read-only instance of Slice");
}
void
Parrot_Slice_ro_add_role(Interp *interp, PMC* pmc, PMC* role)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "add_role() in read-only instance of Slice");
}
void
Parrot_Slice_ro_assign_pmc(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "assign_pmc() in read-only instance of Slice");
}
void
Parrot_Slice_ro_assign_string_native(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "assign_string_native() in read-only instance of Slice");
}
void
Parrot_Slice_ro_decrement(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "decrement() in read-only instance of Slice");
}
void
Parrot_Slice_ro_delete_keyed(Interp *interp, PMC* pmc, PMC* key)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "delete_keyed() in read-only instance of Slice");
}
void
Parrot_Slice_ro_delete_keyed_int(Interp *interp, PMC* pmc, INTVAL key)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "delete_keyed_int() in read-only instance of Slice");
}
void
Parrot_Slice_ro_delete_keyed_str(Interp *interp, PMC* pmc, STRING* key)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "delete_keyed_str() in read-only instance of Slice");
}
PMC*
Parrot_Slice_ro_find_method(Interp *interp, PMC* pmc, STRING* method_name)
 {
    PMC *const method = Parrot_default_find_method(interp, pmc, method_name);
    if (!PMC_IS_NULL(VTABLE_getprop(interp, method, const_string(interp, "write"))))
        return PMCNULL;
    else
        return method;
}
void
Parrot_Slice_ro_i_absolute(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_absolute() in read-only instance of Slice");
}
void
Parrot_Slice_ro_i_bitwise_not(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_bitwise_not() in read-only instance of Slice");
}
void
Parrot_Slice_ro_i_bitwise_nots(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_bitwise_nots() in read-only instance of Slice");
}
void
Parrot_Slice_ro_i_logical_not(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_logical_not() in read-only instance of Slice");
}
void
Parrot_Slice_ro_i_neg(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_neg() in read-only instance of Slice");
}
void
Parrot_Slice_ro_increment(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "increment() in read-only instance of Slice");
}
void
Parrot_Slice_ro_morph(Interp *interp, PMC* pmc, INTVAL type)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "morph() in read-only instance of Slice");
}
FLOATVAL
Parrot_Slice_ro_pop_float(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "pop_float() in read-only instance of Slice");
    return (FLOATVAL)0;
}
INTVAL
Parrot_Slice_ro_pop_integer(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "pop_integer() in read-only instance of Slice");
    return (INTVAL)0;
}
PMC*
Parrot_Slice_ro_pop_pmc(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "pop_pmc() in read-only instance of Slice");
    return PMCNULL;
}
STRING*
Parrot_Slice_ro_pop_string(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "pop_string() in read-only instance of Slice");
    return (STRING*)0;
}
void
Parrot_Slice_ro_push_float(Interp *interp, PMC* pmc, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "push_float() in read-only instance of Slice");
}
void
Parrot_Slice_ro_push_integer(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "push_integer() in read-only instance of Slice");
}
void
Parrot_Slice_ro_push_pmc(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "push_pmc() in read-only instance of Slice");
}
void
Parrot_Slice_ro_push_string(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "push_string() in read-only instance of Slice");
}
void
Parrot_Slice_ro_remove_attribute(Interp *interp, PMC* pmc, STRING* name)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "remove_attribute() in read-only instance of Slice");
}
void
Parrot_Slice_ro_remove_method(Interp *interp, PMC* pmc, STRING* method_name)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "remove_method() in read-only instance of Slice");
}
void
Parrot_Slice_ro_remove_parent(Interp *interp, PMC* pmc, PMC* parent)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "remove_parent() in read-only instance of Slice");
}
void
Parrot_Slice_ro_remove_role(Interp *interp, PMC* pmc, PMC* role)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "remove_role() in read-only instance of Slice");
}
void
Parrot_Slice_ro_set_attr(Interp *interp, PMC* pmc, INTVAL idx, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_attr() in read-only instance of Slice");
}
void
Parrot_Slice_ro_set_attr_str(Interp *interp, PMC* pmc, STRING* idx, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_attr_str() in read-only instance of Slice");
}
void
Parrot_Slice_ro_set_bignum_int(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_bignum_int() in read-only instance of Slice");
}
void
Parrot_Slice_ro_set_bignum_num(Interp *interp, PMC* pmc, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_bignum_num() in read-only instance of Slice");
}
void
Parrot_Slice_ro_set_bignum_str(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_bignum_str() in read-only instance of Slice");
}
void
Parrot_Slice_ro_set_bool(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_bool() in read-only instance of Slice");
}
void
Parrot_Slice_ro_set_integer_keyed(Interp *interp, PMC* pmc, PMC* key, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_keyed() in read-only instance of Slice");
}
void
Parrot_Slice_ro_set_integer_keyed_int(Interp *interp, PMC* pmc, INTVAL key, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_keyed_int() in read-only instance of Slice");
}
void
Parrot_Slice_ro_set_integer_keyed_str(Interp *interp, PMC* pmc, STRING* key, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_keyed_str() in read-only instance of Slice");
}
void
Parrot_Slice_ro_set_integer_native(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_native() in read-only instance of Slice");
}
void
Parrot_Slice_ro_set_integer_same(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_same() in read-only instance of Slice");
}
void
Parrot_Slice_ro_set_number_keyed(Interp *interp, PMC* pmc, PMC* key, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_keyed() in read-only instance of Slice");
}
void
Parrot_Slice_ro_set_number_keyed_int(Interp *interp, PMC* pmc, INTVAL key, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_keyed_int() in read-only instance of Slice");
}
void
Parrot_Slice_ro_set_number_keyed_str(Interp *interp, PMC* pmc, STRING* key, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_keyed_str() in read-only instance of Slice");
}
void
Parrot_Slice_ro_set_number_native(Interp *interp, PMC* pmc, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_native() in read-only instance of Slice");
}
void
Parrot_Slice_ro_set_number_same(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_same() in read-only instance of Slice");
}
void
Parrot_Slice_ro_set_pmc(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pmc() in read-only instance of Slice");
}
void
Parrot_Slice_ro_set_pmc_keyed(Interp *interp, PMC* pmc, PMC* key, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pmc_keyed() in read-only instance of Slice");
}
void
Parrot_Slice_ro_set_pmc_keyed_int(Interp *interp, PMC* pmc, INTVAL key, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_int() in read-only instance of Slice");
}
void
Parrot_Slice_ro_set_pmc_keyed_str(Interp *interp, PMC* pmc, STRING* key, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_str() in read-only instance of Slice");
}
void
Parrot_Slice_ro_set_pointer(Interp *interp, PMC* pmc, void* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pointer() in read-only instance of Slice");
}
void
Parrot_Slice_ro_set_pointer_keyed(Interp *interp, PMC* pmc, PMC* key, void* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pointer_keyed() in read-only instance of Slice");
}
void
Parrot_Slice_ro_set_pointer_keyed_int(Interp *interp, PMC* pmc, INTVAL key, void* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_int() in read-only instance of Slice");
}
void
Parrot_Slice_ro_set_pointer_keyed_str(Interp *interp, PMC* pmc, STRING* key, void* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_str() in read-only instance of Slice");
}
void
Parrot_Slice_ro_set_string_keyed(Interp *interp, PMC* pmc, PMC* key, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_keyed() in read-only instance of Slice");
}
void
Parrot_Slice_ro_set_string_keyed_int(Interp *interp, PMC* pmc, INTVAL key, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_keyed_int() in read-only instance of Slice");
}
void
Parrot_Slice_ro_set_string_keyed_str(Interp *interp, PMC* pmc, STRING* key, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_keyed_str() in read-only instance of Slice");
}
void
Parrot_Slice_ro_set_string_native(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_native() in read-only instance of Slice");
}
void
Parrot_Slice_ro_set_string_same(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_same() in read-only instance of Slice");
}
FLOATVAL
Parrot_Slice_ro_shift_float(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "shift_float() in read-only instance of Slice");
    return (FLOATVAL)0;
}
INTVAL
Parrot_Slice_ro_shift_integer(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "shift_integer() in read-only instance of Slice");
    return (INTVAL)0;
}
PMC*
Parrot_Slice_ro_shift_pmc(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "shift_pmc() in read-only instance of Slice");
    return PMCNULL;
}
STRING*
Parrot_Slice_ro_shift_string(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "shift_string() in read-only instance of Slice");
    return (STRING*)0;
}
void
Parrot_Slice_ro_splice(Interp *interp, PMC* pmc, PMC* value, INTVAL offset, INTVAL count)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "splice() in read-only instance of Slice");
}
void
Parrot_Slice_ro_thaw(Interp *interp, PMC* pmc, visit_info* info)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "thaw() in read-only instance of Slice");
}
void
Parrot_Slice_ro_thawfinish(Interp *interp, PMC* pmc, visit_info* info)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "thawfinish() in read-only instance of Slice");
}
void
Parrot_Slice_ro_unshift_float(Interp *interp, PMC* pmc, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "unshift_float() in read-only instance of Slice");
}
void
Parrot_Slice_ro_unshift_integer(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "unshift_integer() in read-only instance of Slice");
}
void
Parrot_Slice_ro_unshift_pmc(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "unshift_pmc() in read-only instance of Slice");
}
void
Parrot_Slice_ro_unshift_string(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "unshift_string() in read-only instance of Slice");
}
void
Parrot_Slice_class_init(Parrot_Interp interp, int entry, int pass)
{
    const VTABLE temp_base_vtable = {
        NULL, /* namespace */
        enum_class_Slice, /* base_type */
        NULL, /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_HAS_READONLY_FLAG, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        NULL,   /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_default_add_attribute,
        Parrot_default_add_method,
        Parrot_default_add_parent,
        Parrot_default_add_role,
        Parrot_default_assign_pmc,
        Parrot_default_assign_string_native,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_can,
        Parrot_default_class_type,
        Parrot_Slice_clone,
        Parrot_default_clone_pmc,
        Parrot_default_decrement,
        Parrot_default_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_default_delete_keyed,
        Parrot_default_delete_keyed_int,
        Parrot_default_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_Slice_destroy,
        Parrot_default_does,
        Parrot_Slice_elements,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_default_find_method,
        Parrot_Key_freeze,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_default_get_bool,
        Parrot_default_get_class,
        Parrot_Slice_get_integer,
        Parrot_Slice_get_integer_keyed,
        Parrot_default_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_Slice_get_iter,
        Parrot_Key_get_number,
        Parrot_default_get_number_keyed,
        Parrot_default_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_Key_get_pmc,
        Parrot_Slice_get_pmc_keyed,
        Parrot_default_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_default_get_repr,
        Parrot_Slice_get_string,
        Parrot_Slice_get_string_keyed,
        Parrot_default_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_default_hash,
        Parrot_default_i_absolute,
        Parrot_default_i_bitwise_not,
        Parrot_default_i_bitwise_nots,
        Parrot_default_i_logical_not,
        Parrot_default_i_neg,
        Parrot_default_increment,
        Parrot_Slice_init,
        Parrot_Slice_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_default_instantiate,
        Parrot_default_invoke,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_logical_not,
        Parrot_Slice_mark,
        Parrot_default_morph,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_new_from_string,
        Parrot_Slice_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_pmc_namespace,
        Parrot_default_pop_float,
        Parrot_default_pop_integer,
        Parrot_default_pop_pmc,
        Parrot_default_pop_string,
        Parrot_default_push_float,
        Parrot_default_push_integer,
        Parrot_Key_push_pmc,
        Parrot_default_push_string,
        Parrot_default_remove_attribute,
        Parrot_default_remove_method,
        Parrot_default_remove_parent,
        Parrot_default_remove_role,
        Parrot_default_set_attr,
        Parrot_default_set_attr_str,
        Parrot_default_set_bignum_int,
        Parrot_default_set_bignum_num,
        Parrot_default_set_bignum_str,
        Parrot_default_set_bool,
        Parrot_default_set_integer_keyed,
        Parrot_default_set_integer_keyed_int,
        Parrot_default_set_integer_keyed_str,
        Parrot_Key_set_integer_native,
        Parrot_default_set_integer_same,
        Parrot_default_set_number_keyed,
        Parrot_default_set_number_keyed_int,
        Parrot_default_set_number_keyed_str,
        Parrot_Key_set_number_native,
        Parrot_default_set_number_same,
        Parrot_Key_set_pmc,
        Parrot_default_set_pmc_keyed,
        Parrot_default_set_pmc_keyed_int,
        Parrot_default_set_pmc_keyed_str,
        Parrot_default_set_pointer,
        Parrot_default_set_pointer_keyed,
        Parrot_default_set_pointer_keyed_int,
        Parrot_default_set_pointer_keyed_str,
        Parrot_default_set_string_keyed,
        Parrot_default_set_string_keyed_int,
        Parrot_default_set_string_keyed_str,
        Parrot_Key_set_string_native,
        Parrot_default_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_default_shift_float,
        Parrot_default_shift_integer,
        Parrot_Key_shift_pmc,
        Parrot_default_shift_string,
        Parrot_Slice_slice,
        Parrot_default_splice,
        Parrot_default_subclass,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtype,
        Parrot_Key_thaw,
        Parrot_Key_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_type_keyed_int,
        Parrot_default_type_keyed_str,
        Parrot_default_unshift_float,
        Parrot_default_unshift_integer,
        Parrot_default_unshift_pmc,
        Parrot_default_unshift_string,
        Parrot_Key_visit
    };

    const VTABLE temp_ro_vtable = {
        NULL, /* namespace */
        enum_class_Slice, /* base_type */
        NULL, /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_IS_READONLY_FLAG, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        NULL,   /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_Slice_ro_add_attribute,
        Parrot_Slice_ro_add_method,
        Parrot_Slice_ro_add_parent,
        Parrot_Slice_ro_add_role,
        Parrot_Slice_ro_assign_pmc,
        Parrot_Slice_ro_assign_string_native,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_can,
        Parrot_default_class_type,
        Parrot_Slice_clone,
        Parrot_default_clone_pmc,
        Parrot_Slice_ro_decrement,
        Parrot_default_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_Slice_ro_delete_keyed,
        Parrot_Slice_ro_delete_keyed_int,
        Parrot_Slice_ro_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_Slice_destroy,
        Parrot_default_does,
        Parrot_Slice_elements,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_Slice_ro_find_method,
        Parrot_Key_freeze,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_default_get_bool,
        Parrot_default_get_class,
        Parrot_Slice_get_integer,
        Parrot_Slice_get_integer_keyed,
        Parrot_default_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_Slice_get_iter,
        Parrot_Key_get_number,
        Parrot_default_get_number_keyed,
        Parrot_default_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_Key_get_pmc,
        Parrot_Slice_get_pmc_keyed,
        Parrot_default_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_default_get_repr,
        Parrot_Slice_get_string,
        Parrot_Slice_get_string_keyed,
        Parrot_default_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_default_hash,
        Parrot_Slice_ro_i_absolute,
        Parrot_Slice_ro_i_bitwise_not,
        Parrot_Slice_ro_i_bitwise_nots,
        Parrot_Slice_ro_i_logical_not,
        Parrot_Slice_ro_i_neg,
        Parrot_Slice_ro_increment,
        Parrot_Slice_init,
        Parrot_Slice_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_default_instantiate,
        Parrot_default_invoke,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_logical_not,
        Parrot_Slice_mark,
        Parrot_Slice_ro_morph,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_new_from_string,
        Parrot_Slice_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_pmc_namespace,
        Parrot_Slice_ro_pop_float,
        Parrot_Slice_ro_pop_integer,
        Parrot_Slice_ro_pop_pmc,
        Parrot_Slice_ro_pop_string,
        Parrot_Slice_ro_push_float,
        Parrot_Slice_ro_push_integer,
        Parrot_Slice_ro_push_pmc,
        Parrot_Slice_ro_push_string,
        Parrot_Slice_ro_remove_attribute,
        Parrot_Slice_ro_remove_method,
        Parrot_Slice_ro_remove_parent,
        Parrot_Slice_ro_remove_role,
        Parrot_Slice_ro_set_attr,
        Parrot_Slice_ro_set_attr_str,
        Parrot_Slice_ro_set_bignum_int,
        Parrot_Slice_ro_set_bignum_num,
        Parrot_Slice_ro_set_bignum_str,
        Parrot_Slice_ro_set_bool,
        Parrot_Slice_ro_set_integer_keyed,
        Parrot_Slice_ro_set_integer_keyed_int,
        Parrot_Slice_ro_set_integer_keyed_str,
        Parrot_Slice_ro_set_integer_native,
        Parrot_Slice_ro_set_integer_same,
        Parrot_Slice_ro_set_number_keyed,
        Parrot_Slice_ro_set_number_keyed_int,
        Parrot_Slice_ro_set_number_keyed_str,
        Parrot_Slice_ro_set_number_native,
        Parrot_Slice_ro_set_number_same,
        Parrot_Slice_ro_set_pmc,
        Parrot_Slice_ro_set_pmc_keyed,
        Parrot_Slice_ro_set_pmc_keyed_int,
        Parrot_Slice_ro_set_pmc_keyed_str,
        Parrot_Slice_ro_set_pointer,
        Parrot_Slice_ro_set_pointer_keyed,
        Parrot_Slice_ro_set_pointer_keyed_int,
        Parrot_Slice_ro_set_pointer_keyed_str,
        Parrot_Slice_ro_set_string_keyed,
        Parrot_Slice_ro_set_string_keyed_int,
        Parrot_Slice_ro_set_string_keyed_str,
        Parrot_Slice_ro_set_string_native,
        Parrot_Slice_ro_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_Slice_ro_shift_float,
        Parrot_Slice_ro_shift_integer,
        Parrot_Slice_ro_shift_pmc,
        Parrot_Slice_ro_shift_string,
        Parrot_Slice_slice,
        Parrot_Slice_ro_splice,
        Parrot_default_subclass,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtype,
        Parrot_Slice_ro_thaw,
        Parrot_Slice_ro_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_type_keyed_int,
        Parrot_default_type_keyed_str,
        Parrot_Slice_ro_unshift_float,
        Parrot_Slice_ro_unshift_integer,
        Parrot_Slice_ro_unshift_pmc,
        Parrot_Slice_ro_unshift_string,
        Parrot_Key_visit
    };
    if (pass == 0) {
        /*
         * create vtable - clone it - we have to set a few items
         */
        VTABLE *vt_clone =
            Parrot_clone_vtable(interp, &temp_base_vtable);
        VTABLE *vt_ro_clone =
            Parrot_clone_vtable(interp, &temp_ro_vtable);
        vt_clone->whoami = CONST_STRING(interp, "Slice");
        vt_clone->isa_str = CONST_STRING(interp, "Slice Key");
        vt_clone->does_str = CONST_STRING(interp, "scalar");
        vt_ro_clone->base_type = entry;
        vt_ro_clone->whoami = vt_clone->whoami;
        vt_ro_clone->isa_str = vt_clone->isa_str;
        vt_ro_clone->does_str = vt_clone->does_str;
        vt_clone->ro_variant_vtable = vt_ro_clone;
        vt_ro_clone->ro_variant_vtable = vt_clone;
        interp->vtables[entry] = vt_clone;
    }
    else { /* pass */
        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        /* create PMC Proxy object */
        Parrot_create_pmc_proxy(interp, entry);
        /* class_init */
        {
        }
    } /* pass */
} /* Parrot_Slice_class_init */


/*

=back

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
