/*
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/sub.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

#line 1 "./src/pmc/sub.pmc"
/*
Copyright (C) 2001-2007, The Perl Foundation.
$Id: sub.pmc 19092 2007-06-18 21:38:33Z petdance $

=head1 NAME

src/pmc/sub.pmc - Subroutine

=head1 DESCRIPTION

These are the vtable functions for the Sub (subroutine) base class

=head2 Functions

=over 4

=cut

*/

#include "parrot/parrot.h"
#include "parrot/oplib/ops.h"
#include "sub.str"
#include <assert.h>

static void
print_sub_name(Interp* interp, PMC* sub)
{
    Interp * const tracer =
        interp->debugger ? interp->debugger : interp;

        /* sub was located via globals */
    PIO_eprintf(tracer, "# Calling sub '%Ss'\n# ",
        Parrot_full_sub_name(interp, sub));
    print_pbc_location(interp);
}

/*
 * A sub now contains more data like namespace, which makes it
 * effectively a container. Therefore need_ext has to be set
 */
#line 54 "src/pmc/sub.c"
#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_sub.h"
#include "pmc_default.h"
#include "sub.str"

INTVAL
Parrot_Sub_is_equal(Interp *interp, PMC* pmc, PMC* value)
#line 420 "./src/pmc/sub.pmc"
{
    return pmc->vtable == value->vtable &&
        (PMC_sub(pmc))->start_offs == (PMC_sub(value))->start_offs &&
        (PMC_sub(pmc))->seg == (PMC_sub(value))->seg;

}
#line 71 "src/pmc/sub.c"
void
Parrot_Sub_assign_pmc(Interp *interp, PMC* pmc, PMC* other)
#line 372 "./src/pmc/sub.pmc"
{
    /* only handle the case where the other PMC is the same type */
    if (other->vtable->base_type == pmc->vtable->base_type) {
        /* copy the sub struct */
        memcpy(PMC_sub(pmc), PMC_sub(other), sizeof (struct Parrot_sub));
        /* copy the name so it's a different string in memory */
        PMC_sub(pmc)->name = string_copy(interp, PMC_sub(pmc)->name);
    }
    else {
        real_exception(interp, NULL, E_TypeError,
                       "Can't assign a non-Sub type to a Sub");
    }

}
#line 89 "src/pmc/sub.c"
PMC*
Parrot_Sub_clone(Interp *interp, PMC* pmc)
#line 341 "./src/pmc/sub.pmc"
{
    struct Parrot_sub *sub;
    PMC * const ret = pmc_new_noinit(interp, pmc->vtable->base_type);

    /* we have to mark it ourselves */
    PObj_custom_mark_destroy_SETALL(ret);
    sub = mem_allocate_typed(struct Parrot_sub);

    /* first set the sub struct, string_copy may cause GC */
    PMC_struct_val(ret) = sub;
    PMC_pmc_val(ret)    = NULL;
    memcpy(sub, PMC_sub(pmc), sizeof (struct Parrot_sub));
    sub->name           = string_copy(interp, sub->name);

    return ret;

}
#line 110 "src/pmc/sub.c"
INTVAL
Parrot_Sub_defined(Interp *interp, PMC* pmc)
#line 193 "./src/pmc/sub.pmc"
{
    return 1;

}
#line 118 "src/pmc/sub.c"
void
Parrot_Sub_destroy(Interp *interp, PMC* pmc)
#line 93 "./src/pmc/sub.pmc"
{
    struct Parrot_sub * const sub = PMC_sub(pmc);
    if (!sub)
        return;
#if 0
    {
        STRING *n = Parrot_full_sub_name(interp, pmc);
        fprintf(stderr, "DESTROY sub %p %s\n", pmc,
                n && n->strstart ? (char*)n->strstart : "???");
    }
#endif
    mem_sys_free(sub);
    PMC_struct_val(pmc) = NULL;

}
#line 137 "src/pmc/sub.c"
void
Parrot_Sub_freeze(Interp *interp, PMC* pmc, visit_info *info)
#line 462 "./src/pmc/sub.pmc"
{
    IMAGE_IO * const io = info->image_io;
    struct Parrot_sub * const sub = PMC_sub(pmc);
    int i;

    Parrot_default_freeze(interp, pmc, info);
    /*
     * we currently need to write these items:
     * - start offset in byte-code segment
     * - end   offset in byte-code segment
     * - segment TODO ???
     * - flags  (i.e. :load pragma and such)
     * - name of the sub's label
     * - namespace
     * - HLL_id
     * - multi_signature
     * - n_regs_used[i]
     * - lex_info
     * - vtable_index
     */

     VTABLE_push_integer(interp, io, (INTVAL) sub->start_offs);
     VTABLE_push_integer(interp, io, (INTVAL) sub->end_offs);
     VTABLE_push_integer(interp, io, PObj_get_FLAGS(pmc) & SUB_FLAG_PF_MASK);
     VTABLE_push_string(interp, io, sub->name);
     VTABLE_push_integer(interp, io, sub->HLL_id);
     VTABLE_push_integer(interp, io, sub->comp_flags);
     VTABLE_push_integer(interp, io, sub->vtable_index);
    for (i = 0; i < 4; ++i)
         VTABLE_push_integer(interp, io, sub->n_regs_used[i]);

}
#line 173 "src/pmc/sub.c"
INTVAL
Parrot_Sub_get_bool(Interp *interp, PMC* pmc)
#line 197 "./src/pmc/sub.pmc"
{
    return 1;

}
#line 181 "src/pmc/sub.c"
INTVAL
Parrot_Sub_get_integer_keyed(Interp *interp, PMC* pmc, PMC* key)
#line 177 "./src/pmc/sub.pmc"
{
    return (INTVAL) ((PMC_sub(pmc))->seg->base.data);

}
#line 189 "src/pmc/sub.c"
void*
Parrot_Sub_get_pointer(Interp *interp, PMC* pmc)
#line 160 "./src/pmc/sub.pmc"
{
    const struct Parrot_sub * const sub = PMC_sub(pmc);
    return sub->seg->base.data + sub->start_offs;

}
#line 198 "src/pmc/sub.c"
STRING*
Parrot_Sub_get_string(Interp *interp, PMC* pmc)
#line 122 "./src/pmc/sub.pmc"
{
    const struct Parrot_sub * const sub = PMC_sub(pmc);
    return Parrot_make_COW_reference(interp, sub->name);

}
#line 207 "src/pmc/sub.c"
void
Parrot_Sub_init(Interp *interp, PMC* pmc)
#line 72 "./src/pmc/sub.pmc"
{
    PMC_struct_val(pmc) = new_sub(interp);
    PMC_pmc_val(pmc) = NULL;
    PObj_custom_mark_destroy_SETALL(pmc);
#if 0
    if (Interp_flags_TEST(interp, PARROT_DEBUG_FLAG))
        printf("Address of base segment is %p\n",
            ((struct Parrot_sub *)PMC_sub(pmc))->seg->base.pf->base.data);
#endif

}
#line 222 "src/pmc/sub.c"
opcode_t*
Parrot_Sub_invoke(Interp *interp, PMC* pmc, void *next)
#line 211 "./src/pmc/sub.pmc"
{
    struct Parrot_sub     * const sub = PMC_sub(pmc);
    parrot_context_t      *caller_ctx;
    Parrot_Context        *context;
    PMC                   *ccont;
    opcode_t              *pc;

    if (Interp_trace_TEST(interp, PARROT_TRACE_SUB_CALL_FLAG))
        print_sub_name(interp, pmc);

    /*
     * A remark WRT tail calls
     *
     * we have:
     * sub A:
     *    ...
     *    B()
     *    ...
     * sub B:
     *    ...
     *    .return C(...)
     *
     * that is the sub B() returns whatever C() returns.
     *
     * We are just calling the sub C().
     * If the private2 flag is set, this code is called by a
     * tailcall opcode.
     *
     * We allocate a new register frame and recycle it
     * immediately after argument passing.
     *
     */
    pc                   = sub->seg->base.data + sub->start_offs;
    caller_ctx           = CONTEXT(interp->ctx);
    ccont                = interp->current_cont;
    interp->current_cont = NULL;

    if (ccont == NEED_CONTINUATION)
        ccont = new_ret_continuation_pmc(interp, (opcode_t *)next);

    assert(!PMC_IS_NULL(ccont));

    /*
     * plain subroutine call
     * create new context, place it in interpreter
     */
#define PREMATURE_OPT
#ifdef PREMATURE_OPT
    if (caller_ctx->current_sub == pmc)
        context = Parrot_dup_context(interp, caller_ctx);
    else
#endif
    context               = Parrot_alloc_context(interp, sub->n_regs_used);
    context->current_sub  = pmc;
    context->caller_ctx   = caller_ctx;
    context->current_pc   = pc;
    context->current_cont = ccont;

    /* check recursion/call depth */
    if (++context->recursion_depth >
            interp->recursion_limit) {
        real_exception(interp, next, E_RuntimeError,
                "maximum recursion depth exceeded");
    }

    /* and copy set context variables */
    PMC_cont(ccont)->from_ctx = context;

    /* set context of the sub */
    sub->ctx = context;

    /* don't destroy context */
    if (PObj_get_FLAGS(pmc) & SUB_FLAG_IS_OUTER)
        ccont->vtable = interp->vtables[enum_class_Continuation];

    /* reference counting should work */
    context->ref_count++;

    if (!PMC_IS_NULL(interp->current_object)) {
        context->current_object = interp->current_object;
        interp->current_object = NULL;
    }

    context->current_HLL       = sub->HLL_id;
    context->current_namespace = sub->namespace_stash;

    /* create pad if needed
     * TODO move this up in front of argument passing
     *      and factor out common code with coroutine pmc
     */
    if (!PMC_IS_NULL(sub->lex_info)) {
        context->lex_pad = pmc_new_init(interp,
                Parrot_get_ctx_HLL_type(interp,
                    enum_class_LexPad),
                sub->lex_info);
        VTABLE_set_pointer(interp, context->lex_pad, context);
    }

    /* switch code segment if needed */
    if (interp->code != sub->seg)
        Parrot_switch_to_cs(interp, sub->seg, 1);

    if (PObj_get_FLAGS(ccont) & SUB_FLAG_TAILCALL) {
        if (!(*pc == PARROT_OP_get_params_pc ||
                    (*pc == PARROT_OP_push_eh_ic &&
                     pc[2] == PARROT_OP_get_params_pc))) {

            /* TODO keep it or resize it */
            --context->recursion_depth;

            PObj_get_FLAGS(ccont) &= ~SUB_FLAG_TAILCALL;
            context->caller_ctx    = caller_ctx->caller_ctx;

            Parrot_free_context(interp, caller_ctx, 0);
        }
    }

    return pc;

}
#line 346 "src/pmc/sub.c"
void
Parrot_Sub_mark(Interp *interp, PMC* pmc)
#line 396 "./src/pmc/sub.pmc"
{
    const struct Parrot_sub * const sub = PMC_sub(pmc);
    if (!sub)
        return;
    if (sub->name)
        pobject_lives(interp, (PObj *) sub->name);
    if (!PMC_IS_NULL(sub->namespace_name))
        pobject_lives(interp, (PObj *) sub->namespace_name);
    if (!PMC_IS_NULL(sub->multi_signature))
        pobject_lives(interp, (PObj *) sub->multi_signature);
    if (!PMC_IS_NULL(sub->eval_pmc))
        pobject_lives(interp, (PObj *) sub->eval_pmc);

}
#line 364 "src/pmc/sub.c"
void
Parrot_Sub_set_pmc(Interp *interp, PMC* pmc, PMC* other)
#line 368 "./src/pmc/sub.pmc"
{
     VTABLE_assign_pmc(interp, pmc, other);

}
#line 372 "src/pmc/sub.c"
void
Parrot_Sub_set_pointer(Interp *interp, PMC* pmc, void* value)
#line 144 "./src/pmc/sub.pmc"
{
    real_exception(interp, NULL, E_NotImplementedError,
            "Don't set the address of a sub\n"
            "use .Sub constants instead");

}
#line 382 "src/pmc/sub.c"
void
Parrot_Sub_set_string_native(Interp *interp, PMC* pmc, STRING *subname)
#line 127 "./src/pmc/sub.pmc"
{
    struct Parrot_sub * const sub = PMC_sub(pmc);
    sub->name = string_copy(interp, subname);

}
#line 391 "src/pmc/sub.c"
void
Parrot_Sub_thaw(Interp *interp, PMC* pmc, visit_info *info)
#line 504 "./src/pmc/sub.pmc"
{
    IMAGE_IO * const io = info->image_io;
    Parrot_default_thaw(interp, pmc, info);

    if (info->extra_flags == EXTRA_IS_NULL) {
        struct Parrot_sub * const sub = PMC_sub(pmc);
        INTVAL flags;
        int i;
        /*
         * we get relative offsets
         */
        sub->start_offs = (size_t)  VTABLE_shift_integer(interp, io);
        sub->end_offs   = (size_t)  VTABLE_shift_integer(interp, io);
        flags =  VTABLE_shift_integer(interp, io);
        PObj_get_FLAGS(pmc) |= flags & SUB_FLAG_PF_MASK;
        sub->name =  VTABLE_shift_string(interp, io);
        sub->HLL_id  =  VTABLE_shift_integer(interp, io);
        sub->comp_flags =  VTABLE_shift_integer(interp, io);
        sub->vtable_index =  VTABLE_shift_integer(interp, io);
        for (i = 0; i < 4; ++i)
            sub->n_regs_used[i] =  VTABLE_shift_integer(interp, io);
    }

}
#line 419 "src/pmc/sub.c"
void
Parrot_Sub_visit(Interp *interp, PMC* pmc, visit_info *info)
#line 440 "./src/pmc/sub.pmc"
{
    struct Parrot_sub * const sub = PMC_sub(pmc);

    info->thaw_ptr = &sub->namespace_name;
    (info->visit_pmc_now)(interp, sub->namespace_name, info);
    info->thaw_ptr = &sub->multi_signature;
    (info->visit_pmc_now)(interp, sub->multi_signature, info);
    info->thaw_ptr = &sub->outer_sub;
    (info->visit_pmc_now)(interp, sub->outer_sub, info);
    /*
     * XXX visit_pmc_now is wrong, because it breaks
     *     depth-first visit inside the todo list
     * TODO change all user visit functions to use
     *    visit_pmc (the todo renamed visit_pm_later)
     *
     * Therefore the hash must be last during visit for now.
     */
    info->thaw_ptr = &sub->lex_info;
    (info->visit_pmc_now)(interp, sub->lex_info, info);
    Parrot_default_visit(interp, pmc, info);

}
#line 445 "src/pmc/sub.c"
PMC*
Parrot_Sub_nci_get_namespace(Interp *interp, PMC* pmc)
#line 559 "./src/pmc/sub.pmc"
{
    struct Parrot_sub * const sub = PMC_sub(pmc);

    return sub->namespace_stash;

}
#line 455 "src/pmc/sub.c"
INTVAL
Parrot_Sub_nci___get_regs_used(Interp *interp, PMC* pmc, char *kind)
#line 565 "./src/pmc/sub.pmc"
{
    struct Parrot_sub * const sub = PMC_sub(pmc);
    /* TODO switch to canonical NiSP order
     * see also imcc/reg_alloc.c
     */
    static const char types[] = "INSP";
    char *p;

    assert(sub->n_regs_used);
    if (!*kind || kind[1])
        real_exception(interp, NULL, E_ValueError,
            "illegal register kind '%s'", kind);
    p = strchr(types, *kind);
    if (!p)
        real_exception(interp, NULL, E_ValueError,
            "illegal register kind '%s'", kind);
    return sub->n_regs_used[p - types];

}
#line 478 "src/pmc/sub.c"
PMC*
Parrot_Sub_nci_get_lexinfo(Interp *interp, PMC* pmc)
#line 584 "./src/pmc/sub.pmc"
{
    const struct Parrot_sub * const sub = PMC_sub(pmc);
    return sub->lex_info ? sub->lex_info : PMCNULL;

}
#line 487 "src/pmc/sub.c"
PMC*
Parrot_Sub_nci_get_outer(Interp *interp, PMC* pmc)
#line 589 "./src/pmc/sub.pmc"
{
    const struct Parrot_sub * const sub = PMC_sub(pmc);
    return sub->outer_sub ? sub->outer_sub : PMCNULL;

}
#line 496 "src/pmc/sub.c"
PMC*
Parrot_Sub_nci_get_multisig(Interp *interp, PMC* pmc)
#line 594 "./src/pmc/sub.pmc"
{
    const struct Parrot_sub * const sub = PMC_sub(pmc);
    return sub->multi_signature ? sub->multi_signature : PMCNULL;

}
#line 505 "src/pmc/sub.c"
void
Parrot_Sub_ro_add_attribute(Interp *interp, PMC* pmc, STRING* name, PMC* type)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "add_attribute() in read-only instance of Sub");
}
void
Parrot_Sub_ro_add_method(Interp *interp, PMC* pmc, STRING* method_name, PMC* sub_pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "add_method() in read-only instance of Sub");
}
void
Parrot_Sub_ro_add_parent(Interp *interp, PMC* pmc, PMC* parent)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "add_parent() in read-only instance of Sub");
}
void
Parrot_Sub_ro_add_role(Interp *interp, PMC* pmc, PMC* role)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "add_role() in read-only instance of Sub");
}
void
Parrot_Sub_ro_assign_pmc(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "assign_pmc() in read-only instance of Sub");
}
void
Parrot_Sub_ro_assign_string_native(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "assign_string_native() in read-only instance of Sub");
}
void
Parrot_Sub_ro_decrement(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "decrement() in read-only instance of Sub");
}
void
Parrot_Sub_ro_delete_keyed(Interp *interp, PMC* pmc, PMC* key)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "delete_keyed() in read-only instance of Sub");
}
void
Parrot_Sub_ro_delete_keyed_int(Interp *interp, PMC* pmc, INTVAL key)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "delete_keyed_int() in read-only instance of Sub");
}
void
Parrot_Sub_ro_delete_keyed_str(Interp *interp, PMC* pmc, STRING* key)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "delete_keyed_str() in read-only instance of Sub");
}
PMC*
Parrot_Sub_ro_find_method(Interp *interp, PMC* pmc, STRING* method_name)
 {
    PMC *const method = Parrot_default_find_method(interp, pmc, method_name);
    if (!PMC_IS_NULL(VTABLE_getprop(interp, method, const_string(interp, "write"))))
        return PMCNULL;
    else
        return method;
}
void
Parrot_Sub_ro_i_absolute(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_absolute() in read-only instance of Sub");
}
void
Parrot_Sub_ro_i_bitwise_not(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_bitwise_not() in read-only instance of Sub");
}
void
Parrot_Sub_ro_i_bitwise_nots(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_bitwise_nots() in read-only instance of Sub");
}
void
Parrot_Sub_ro_i_logical_not(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_logical_not() in read-only instance of Sub");
}
void
Parrot_Sub_ro_i_neg(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_neg() in read-only instance of Sub");
}
void
Parrot_Sub_ro_increment(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "increment() in read-only instance of Sub");
}
void
Parrot_Sub_ro_morph(Interp *interp, PMC* pmc, INTVAL type)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "morph() in read-only instance of Sub");
}
FLOATVAL
Parrot_Sub_ro_pop_float(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "pop_float() in read-only instance of Sub");
    return (FLOATVAL)0;
}
INTVAL
Parrot_Sub_ro_pop_integer(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "pop_integer() in read-only instance of Sub");
    return (INTVAL)0;
}
PMC*
Parrot_Sub_ro_pop_pmc(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "pop_pmc() in read-only instance of Sub");
    return PMCNULL;
}
STRING*
Parrot_Sub_ro_pop_string(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "pop_string() in read-only instance of Sub");
    return (STRING*)0;
}
void
Parrot_Sub_ro_push_float(Interp *interp, PMC* pmc, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "push_float() in read-only instance of Sub");
}
void
Parrot_Sub_ro_push_integer(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "push_integer() in read-only instance of Sub");
}
void
Parrot_Sub_ro_push_pmc(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "push_pmc() in read-only instance of Sub");
}
void
Parrot_Sub_ro_push_string(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "push_string() in read-only instance of Sub");
}
void
Parrot_Sub_ro_remove_attribute(Interp *interp, PMC* pmc, STRING* name)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "remove_attribute() in read-only instance of Sub");
}
void
Parrot_Sub_ro_remove_method(Interp *interp, PMC* pmc, STRING* method_name)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "remove_method() in read-only instance of Sub");
}
void
Parrot_Sub_ro_remove_parent(Interp *interp, PMC* pmc, PMC* parent)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "remove_parent() in read-only instance of Sub");
}
void
Parrot_Sub_ro_remove_role(Interp *interp, PMC* pmc, PMC* role)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "remove_role() in read-only instance of Sub");
}
void
Parrot_Sub_ro_set_attr(Interp *interp, PMC* pmc, INTVAL idx, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_attr() in read-only instance of Sub");
}
void
Parrot_Sub_ro_set_attr_str(Interp *interp, PMC* pmc, STRING* idx, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_attr_str() in read-only instance of Sub");
}
void
Parrot_Sub_ro_set_bignum_int(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_bignum_int() in read-only instance of Sub");
}
void
Parrot_Sub_ro_set_bignum_num(Interp *interp, PMC* pmc, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_bignum_num() in read-only instance of Sub");
}
void
Parrot_Sub_ro_set_bignum_str(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_bignum_str() in read-only instance of Sub");
}
void
Parrot_Sub_ro_set_bool(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_bool() in read-only instance of Sub");
}
void
Parrot_Sub_ro_set_integer_keyed(Interp *interp, PMC* pmc, PMC* key, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_keyed() in read-only instance of Sub");
}
void
Parrot_Sub_ro_set_integer_keyed_int(Interp *interp, PMC* pmc, INTVAL key, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_keyed_int() in read-only instance of Sub");
}
void
Parrot_Sub_ro_set_integer_keyed_str(Interp *interp, PMC* pmc, STRING* key, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_keyed_str() in read-only instance of Sub");
}
void
Parrot_Sub_ro_set_integer_native(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_native() in read-only instance of Sub");
}
void
Parrot_Sub_ro_set_integer_same(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_same() in read-only instance of Sub");
}
void
Parrot_Sub_ro_set_number_keyed(Interp *interp, PMC* pmc, PMC* key, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_keyed() in read-only instance of Sub");
}
void
Parrot_Sub_ro_set_number_keyed_int(Interp *interp, PMC* pmc, INTVAL key, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_keyed_int() in read-only instance of Sub");
}
void
Parrot_Sub_ro_set_number_keyed_str(Interp *interp, PMC* pmc, STRING* key, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_keyed_str() in read-only instance of Sub");
}
void
Parrot_Sub_ro_set_number_native(Interp *interp, PMC* pmc, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_native() in read-only instance of Sub");
}
void
Parrot_Sub_ro_set_number_same(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_same() in read-only instance of Sub");
}
void
Parrot_Sub_ro_set_pmc(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pmc() in read-only instance of Sub");
}
void
Parrot_Sub_ro_set_pmc_keyed(Interp *interp, PMC* pmc, PMC* key, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pmc_keyed() in read-only instance of Sub");
}
void
Parrot_Sub_ro_set_pmc_keyed_int(Interp *interp, PMC* pmc, INTVAL key, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_int() in read-only instance of Sub");
}
void
Parrot_Sub_ro_set_pmc_keyed_str(Interp *interp, PMC* pmc, STRING* key, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_str() in read-only instance of Sub");
}
void
Parrot_Sub_ro_set_pointer(Interp *interp, PMC* pmc, void* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pointer() in read-only instance of Sub");
}
void
Parrot_Sub_ro_set_pointer_keyed(Interp *interp, PMC* pmc, PMC* key, void* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pointer_keyed() in read-only instance of Sub");
}
void
Parrot_Sub_ro_set_pointer_keyed_int(Interp *interp, PMC* pmc, INTVAL key, void* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_int() in read-only instance of Sub");
}
void
Parrot_Sub_ro_set_pointer_keyed_str(Interp *interp, PMC* pmc, STRING* key, void* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_str() in read-only instance of Sub");
}
void
Parrot_Sub_ro_set_string_keyed(Interp *interp, PMC* pmc, PMC* key, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_keyed() in read-only instance of Sub");
}
void
Parrot_Sub_ro_set_string_keyed_int(Interp *interp, PMC* pmc, INTVAL key, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_keyed_int() in read-only instance of Sub");
}
void
Parrot_Sub_ro_set_string_keyed_str(Interp *interp, PMC* pmc, STRING* key, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_keyed_str() in read-only instance of Sub");
}
void
Parrot_Sub_ro_set_string_native(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_native() in read-only instance of Sub");
}
void
Parrot_Sub_ro_set_string_same(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_same() in read-only instance of Sub");
}
FLOATVAL
Parrot_Sub_ro_shift_float(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "shift_float() in read-only instance of Sub");
    return (FLOATVAL)0;
}
INTVAL
Parrot_Sub_ro_shift_integer(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "shift_integer() in read-only instance of Sub");
    return (INTVAL)0;
}
PMC*
Parrot_Sub_ro_shift_pmc(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "shift_pmc() in read-only instance of Sub");
    return PMCNULL;
}
STRING*
Parrot_Sub_ro_shift_string(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "shift_string() in read-only instance of Sub");
    return (STRING*)0;
}
void
Parrot_Sub_ro_splice(Interp *interp, PMC* pmc, PMC* value, INTVAL offset, INTVAL count)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "splice() in read-only instance of Sub");
}
void
Parrot_Sub_ro_thaw(Interp *interp, PMC* pmc, visit_info* info)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "thaw() in read-only instance of Sub");
}
void
Parrot_Sub_ro_thawfinish(Interp *interp, PMC* pmc, visit_info* info)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "thawfinish() in read-only instance of Sub");
}
void
Parrot_Sub_ro_unshift_float(Interp *interp, PMC* pmc, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "unshift_float() in read-only instance of Sub");
}
void
Parrot_Sub_ro_unshift_integer(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "unshift_integer() in read-only instance of Sub");
}
void
Parrot_Sub_ro_unshift_pmc(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "unshift_pmc() in read-only instance of Sub");
}
void
Parrot_Sub_ro_unshift_string(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "unshift_string() in read-only instance of Sub");
}
void
Parrot_Sub_class_init(Parrot_Interp interp, int entry, int pass)
{
    const VTABLE temp_base_vtable = {
        NULL, /* namespace */
        enum_class_Sub, /* base_type */
        NULL, /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_HAS_READONLY_FLAG, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        NULL,   /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_default_add_attribute,
        Parrot_default_add_method,
        Parrot_default_add_parent,
        Parrot_default_add_role,
        Parrot_Sub_assign_pmc,
        Parrot_default_assign_string_native,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_can,
        Parrot_default_class_type,
        Parrot_Sub_clone,
        Parrot_default_clone_pmc,
        Parrot_default_decrement,
        Parrot_Sub_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_default_delete_keyed,
        Parrot_default_delete_keyed_int,
        Parrot_default_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_Sub_destroy,
        Parrot_default_does,
        Parrot_default_elements,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_default_find_method,
        Parrot_Sub_freeze,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_Sub_get_bool,
        Parrot_default_get_class,
        Parrot_default_get_integer,
        Parrot_Sub_get_integer_keyed,
        Parrot_default_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_iter,
        Parrot_default_get_number,
        Parrot_default_get_number_keyed,
        Parrot_default_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_default_get_pmc_keyed,
        Parrot_default_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_Sub_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_default_get_repr,
        Parrot_Sub_get_string,
        Parrot_default_get_string_keyed,
        Parrot_default_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_default_hash,
        Parrot_default_i_absolute,
        Parrot_default_i_bitwise_not,
        Parrot_default_i_bitwise_nots,
        Parrot_default_i_logical_not,
        Parrot_default_i_neg,
        Parrot_default_increment,
        Parrot_Sub_init,
        Parrot_default_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_default_instantiate,
        Parrot_Sub_invoke,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_logical_not,
        Parrot_Sub_mark,
        Parrot_default_morph,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_new_from_string,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_pmc_namespace,
        Parrot_default_pop_float,
        Parrot_default_pop_integer,
        Parrot_default_pop_pmc,
        Parrot_default_pop_string,
        Parrot_default_push_float,
        Parrot_default_push_integer,
        Parrot_default_push_pmc,
        Parrot_default_push_string,
        Parrot_default_remove_attribute,
        Parrot_default_remove_method,
        Parrot_default_remove_parent,
        Parrot_default_remove_role,
        Parrot_default_set_attr,
        Parrot_default_set_attr_str,
        Parrot_default_set_bignum_int,
        Parrot_default_set_bignum_num,
        Parrot_default_set_bignum_str,
        Parrot_default_set_bool,
        Parrot_default_set_integer_keyed,
        Parrot_default_set_integer_keyed_int,
        Parrot_default_set_integer_keyed_str,
        Parrot_default_set_integer_native,
        Parrot_default_set_integer_same,
        Parrot_default_set_number_keyed,
        Parrot_default_set_number_keyed_int,
        Parrot_default_set_number_keyed_str,
        Parrot_default_set_number_native,
        Parrot_default_set_number_same,
        Parrot_Sub_set_pmc,
        Parrot_default_set_pmc_keyed,
        Parrot_default_set_pmc_keyed_int,
        Parrot_default_set_pmc_keyed_str,
        Parrot_Sub_set_pointer,
        Parrot_default_set_pointer_keyed,
        Parrot_default_set_pointer_keyed_int,
        Parrot_default_set_pointer_keyed_str,
        Parrot_default_set_string_keyed,
        Parrot_default_set_string_keyed_int,
        Parrot_default_set_string_keyed_str,
        Parrot_Sub_set_string_native,
        Parrot_default_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_default_shift_float,
        Parrot_default_shift_integer,
        Parrot_default_shift_pmc,
        Parrot_default_shift_string,
        Parrot_default_slice,
        Parrot_default_splice,
        Parrot_default_subclass,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtype,
        Parrot_Sub_thaw,
        Parrot_default_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_type_keyed_int,
        Parrot_default_type_keyed_str,
        Parrot_default_unshift_float,
        Parrot_default_unshift_integer,
        Parrot_default_unshift_pmc,
        Parrot_default_unshift_string,
        Parrot_Sub_visit
    };

    const VTABLE temp_ro_vtable = {
        NULL, /* namespace */
        enum_class_Sub, /* base_type */
        NULL, /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_IS_READONLY_FLAG, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        NULL,   /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_Sub_ro_add_attribute,
        Parrot_Sub_ro_add_method,
        Parrot_Sub_ro_add_parent,
        Parrot_Sub_ro_add_role,
        Parrot_Sub_ro_assign_pmc,
        Parrot_Sub_ro_assign_string_native,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_can,
        Parrot_default_class_type,
        Parrot_Sub_clone,
        Parrot_default_clone_pmc,
        Parrot_Sub_ro_decrement,
        Parrot_Sub_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_Sub_ro_delete_keyed,
        Parrot_Sub_ro_delete_keyed_int,
        Parrot_Sub_ro_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_Sub_destroy,
        Parrot_default_does,
        Parrot_default_elements,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_Sub_ro_find_method,
        Parrot_Sub_freeze,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_Sub_get_bool,
        Parrot_default_get_class,
        Parrot_default_get_integer,
        Parrot_Sub_get_integer_keyed,
        Parrot_default_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_iter,
        Parrot_default_get_number,
        Parrot_default_get_number_keyed,
        Parrot_default_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_default_get_pmc_keyed,
        Parrot_default_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_Sub_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_default_get_repr,
        Parrot_Sub_get_string,
        Parrot_default_get_string_keyed,
        Parrot_default_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_default_hash,
        Parrot_Sub_ro_i_absolute,
        Parrot_Sub_ro_i_bitwise_not,
        Parrot_Sub_ro_i_bitwise_nots,
        Parrot_Sub_ro_i_logical_not,
        Parrot_Sub_ro_i_neg,
        Parrot_Sub_ro_increment,
        Parrot_Sub_init,
        Parrot_default_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_default_instantiate,
        Parrot_Sub_invoke,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_logical_not,
        Parrot_Sub_mark,
        Parrot_Sub_ro_morph,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_new_from_string,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_pmc_namespace,
        Parrot_Sub_ro_pop_float,
        Parrot_Sub_ro_pop_integer,
        Parrot_Sub_ro_pop_pmc,
        Parrot_Sub_ro_pop_string,
        Parrot_Sub_ro_push_float,
        Parrot_Sub_ro_push_integer,
        Parrot_Sub_ro_push_pmc,
        Parrot_Sub_ro_push_string,
        Parrot_Sub_ro_remove_attribute,
        Parrot_Sub_ro_remove_method,
        Parrot_Sub_ro_remove_parent,
        Parrot_Sub_ro_remove_role,
        Parrot_Sub_ro_set_attr,
        Parrot_Sub_ro_set_attr_str,
        Parrot_Sub_ro_set_bignum_int,
        Parrot_Sub_ro_set_bignum_num,
        Parrot_Sub_ro_set_bignum_str,
        Parrot_Sub_ro_set_bool,
        Parrot_Sub_ro_set_integer_keyed,
        Parrot_Sub_ro_set_integer_keyed_int,
        Parrot_Sub_ro_set_integer_keyed_str,
        Parrot_Sub_ro_set_integer_native,
        Parrot_Sub_ro_set_integer_same,
        Parrot_Sub_ro_set_number_keyed,
        Parrot_Sub_ro_set_number_keyed_int,
        Parrot_Sub_ro_set_number_keyed_str,
        Parrot_Sub_ro_set_number_native,
        Parrot_Sub_ro_set_number_same,
        Parrot_Sub_ro_set_pmc,
        Parrot_Sub_ro_set_pmc_keyed,
        Parrot_Sub_ro_set_pmc_keyed_int,
        Parrot_Sub_ro_set_pmc_keyed_str,
        Parrot_Sub_ro_set_pointer,
        Parrot_Sub_ro_set_pointer_keyed,
        Parrot_Sub_ro_set_pointer_keyed_int,
        Parrot_Sub_ro_set_pointer_keyed_str,
        Parrot_Sub_ro_set_string_keyed,
        Parrot_Sub_ro_set_string_keyed_int,
        Parrot_Sub_ro_set_string_keyed_str,
        Parrot_Sub_ro_set_string_native,
        Parrot_Sub_ro_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_Sub_ro_shift_float,
        Parrot_Sub_ro_shift_integer,
        Parrot_Sub_ro_shift_pmc,
        Parrot_Sub_ro_shift_string,
        Parrot_default_slice,
        Parrot_Sub_ro_splice,
        Parrot_default_subclass,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtype,
        Parrot_Sub_ro_thaw,
        Parrot_Sub_ro_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_type_keyed_int,
        Parrot_default_type_keyed_str,
        Parrot_Sub_ro_unshift_float,
        Parrot_Sub_ro_unshift_integer,
        Parrot_Sub_ro_unshift_pmc,
        Parrot_Sub_ro_unshift_string,
        Parrot_Sub_visit
    };

    const  MMD_init _temp_mmd_init[] = {
        { MMD_EQ, 0, enum_type_PMC, (funcptr_t) Parrot_Sub_is_equal }
    };
    /*  Dynamic PMCs need the runtime type
    which is passed in entry to class_init.
    */
    if (pass == 0) {
        /*
         * create vtable - clone it - we have to set a few items
         */
        VTABLE *vt_clone =
            Parrot_clone_vtable(interp, &temp_base_vtable);
        VTABLE *vt_ro_clone =
            Parrot_clone_vtable(interp, &temp_ro_vtable);
        vt_clone->whoami = CONST_STRING(interp, "Sub");
        vt_clone->isa_str = CONST_STRING(interp, "Sub");
        vt_clone->does_str = CONST_STRING(interp, "scalar");
        vt_ro_clone->base_type = entry;
        vt_ro_clone->whoami = vt_clone->whoami;
        vt_ro_clone->isa_str = vt_clone->isa_str;
        vt_ro_clone->does_str = vt_clone->does_str;
        vt_clone->ro_variant_vtable = vt_ro_clone;
        vt_ro_clone->ro_variant_vtable = vt_clone;
        interp->vtables[entry] = vt_clone;
    }
    else { /* pass */
        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        /* create PMC Proxy object */
        Parrot_create_pmc_proxy(interp, entry);
        register_nci_method(interp, entry,
                F2DPTR(Parrot_Sub_nci_get_namespace),
                "get_namespace", "PJO");
        register_nci_method(interp, entry,
                F2DPTR(Parrot_Sub_nci___get_regs_used),
                "__get_regs_used", "IJOt");
        register_nci_method(interp, entry,
                F2DPTR(Parrot_Sub_nci_get_lexinfo),
                "get_lexinfo", "PJO");
        register_nci_method(interp, entry,
                F2DPTR(Parrot_Sub_nci_get_outer),
                "get_outer", "PJO");
        register_nci_method(interp, entry,
                F2DPTR(Parrot_Sub_nci_get_multisig),
                "get_multisig", "PJO");
        /* class_init */
        {
#define N_MMD_INIT (sizeof(_temp_mmd_init)/sizeof(_temp_mmd_init[0]))
            Parrot_mmd_register_table(interp, entry,
                _temp_mmd_init, N_MMD_INIT);
        }
    } /* pass */
} /* Parrot_Sub_class_init */


/*

=back

=head1 HISTORY

Initial version by Melvin on 2002/06/06.

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
