/*
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/tqueue.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

#line 1 "./src/pmc/tqueue.pmc"
/*
Copyright (C) 2001-2003, The Perl Foundation.
$Id: tqueue.pmc 18407 2007-05-03 05:08:51Z chromatic $

=head1 NAME

src/pmc/tqueue.pmc - Threadsafe Queue

=head1 DESCRIPTION

Threadsafe queue class for inter thread communication. If you have an
unthreaded program then please use a PerlArray.

     new P0, .TQueue
     push P0, some
     new P2, .ParrotThread
     ...

and in other thread (at least, when shared PMCs work :)

     shift P1, P0

Note: The TQueue must always be emptied before program exit.

=head2 Methods

=over 4

=cut

*/

#include "parrot/parrot.h"
#include <assert.h>

#line 48 "src/pmc/tqueue.c"
#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_tqueue.h"
#include "pmc_default.h"
#include "tqueue.str"

PMC*
Parrot_TQueue_clone(Interp *interp, PMC* pmc)
#line 64 "./src/pmc/tqueue.pmc"
{
    /* XXX fake a shared PMC */
    return pmc;

}
#line 64 "src/pmc/tqueue.c"
INTVAL
Parrot_TQueue_defined(Interp *interp, PMC* pmc)
#line 136 "./src/pmc/tqueue.pmc"
{
    return Parrot_TQueue_get_integer(interp, pmc) != 0;

}
#line 72 "src/pmc/tqueue.c"
void
Parrot_TQueue_destroy(Interp *interp, PMC* pmc)
#line 106 "./src/pmc/tqueue.pmc"
{
    if (PMC_data(pmc)) {
        QUEUE *queue = PMC_data_typed(pmc, QUEUE *);
#if 0
        /*
         * wait til queue is empty
         * XXX implement a time wait and PANIC if queue
         * isn't empty after some TIMEOUT
         */
        while (Parrot_TQueue_elements(interp, pmc)) {
            queue_lock(queue);
            queue_wait(queue);
            queue_unlock(queue);
        }
#endif
        mem_sys_free(queue);
        PMC_data(pmc) = NULL;
    }

}
#line 96 "src/pmc/tqueue.c"
INTVAL
Parrot_TQueue_elements(Interp *interp, PMC* pmc)
#line 162 "./src/pmc/tqueue.pmc"
{
    return Parrot_TQueue_get_integer(interp, pmc);

}
#line 104 "src/pmc/tqueue.c"
INTVAL
Parrot_TQueue_get_integer(Interp *interp, PMC* pmc)
#line 148 "./src/pmc/tqueue.pmc"
{
    return PMC_int_val(pmc);

}
#line 112 "src/pmc/tqueue.c"
void
Parrot_TQueue_init(Interp *interp, PMC* pmc)
#line 48 "./src/pmc/tqueue.pmc"
{
    PMC_int_val(pmc) = 0;
    PMC_data(pmc) = queue_init(0);
    PObj_custom_mark_destroy_SETALL(pmc);

}
#line 122 "src/pmc/tqueue.c"
void
Parrot_TQueue_mark(Interp *interp, PMC* pmc)
#line 79 "./src/pmc/tqueue.pmc"
{
    QUEUE       *queue = PMC_data_typed(pmc, QUEUE *);
    QUEUE_ENTRY *entry;

    queue_lock(queue);
    entry = queue->head;

    while (entry) {
        pobject_lives(interp, (PObj*) entry->data);
        if (entry == queue->tail)
            break;
        entry = entry->next;
    }

    queue_unlock(queue);

}
#line 143 "src/pmc/tqueue.c"
void
Parrot_TQueue_push_pmc(Interp *interp, PMC* pmc, PMC *item)
#line 176 "./src/pmc/tqueue.pmc"
{
    QUEUE_ENTRY *entry = mem_allocate_typed(QUEUE_ENTRY);
    QUEUE       *queue = PMC_data_typed(pmc, QUEUE *);

    /*
     * if item isn't shared nor const, then make
     *       a shared item
     */
    if (!(item->vtable->flags &
                (VTABLE_IS_CONST_FLAG | VTABLE_IS_SHARED_FLAG)))
        VTABLE_share(interp, item);

    DOD_WRITE_BARRIER(interp, pmc, NULL, item);
    entry->data = item;
    entry->type = QUEUE_ENTRY_TYPE_NONE;
    /* s. tsq.c:queue_push */
    queue_lock(queue);
    ++PMC_int_val(pmc);
    /* Is there something in the queue? */
    if (queue->tail) {
        queue->tail->next = entry;
        queue->tail = entry;
    }
    else {
        queue->head = entry;
        queue->tail = entry;
    }
    queue_broadcast(queue);        /* signal all waiters */
    queue_unlock(queue);

}
#line 178 "src/pmc/tqueue.c"
PMC*
Parrot_TQueue_shift_pmc(Interp *interp, PMC* pmc)
#line 217 "./src/pmc/tqueue.pmc"
{
    QUEUE_ENTRY *entry;
    QUEUE       *queue = PMC_data_typed(pmc, QUEUE *);
    PMC         *ret;

    queue_lock(queue);
    while (queue->head == NULL) {
        queue_wait(queue);
    }

    entry = nosync_pop_entry(queue);
    --PMC_int_val(pmc);
    queue_unlock(queue);
    ret   = (PMC *)entry->data;
    mem_sys_free(entry);

    return ret;

}
#line 201 "src/pmc/tqueue.c"
void
Parrot_TQueue_ro_add_attribute(Interp *interp, PMC* pmc, STRING* name, PMC* type)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "add_attribute() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_add_method(Interp *interp, PMC* pmc, STRING* method_name, PMC* sub_pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "add_method() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_add_parent(Interp *interp, PMC* pmc, PMC* parent)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "add_parent() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_add_role(Interp *interp, PMC* pmc, PMC* role)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "add_role() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_assign_pmc(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "assign_pmc() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_assign_string_native(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "assign_string_native() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_decrement(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "decrement() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_delete_keyed(Interp *interp, PMC* pmc, PMC* key)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "delete_keyed() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_delete_keyed_int(Interp *interp, PMC* pmc, INTVAL key)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "delete_keyed_int() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_delete_keyed_str(Interp *interp, PMC* pmc, STRING* key)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "delete_keyed_str() in read-only instance of TQueue");
}
PMC*
Parrot_TQueue_ro_find_method(Interp *interp, PMC* pmc, STRING* method_name)
 {
    PMC *const method = Parrot_default_find_method(interp, pmc, method_name);
    if (!PMC_IS_NULL(VTABLE_getprop(interp, method, const_string(interp, "write"))))
        return PMCNULL;
    else
        return method;
}
void
Parrot_TQueue_ro_i_absolute(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_absolute() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_i_bitwise_not(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_bitwise_not() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_i_bitwise_nots(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_bitwise_nots() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_i_logical_not(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_logical_not() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_i_neg(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_neg() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_increment(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "increment() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_morph(Interp *interp, PMC* pmc, INTVAL type)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "morph() in read-only instance of TQueue");
}
FLOATVAL
Parrot_TQueue_ro_pop_float(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "pop_float() in read-only instance of TQueue");
    return (FLOATVAL)0;
}
INTVAL
Parrot_TQueue_ro_pop_integer(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "pop_integer() in read-only instance of TQueue");
    return (INTVAL)0;
}
PMC*
Parrot_TQueue_ro_pop_pmc(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "pop_pmc() in read-only instance of TQueue");
    return PMCNULL;
}
STRING*
Parrot_TQueue_ro_pop_string(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "pop_string() in read-only instance of TQueue");
    return (STRING*)0;
}
void
Parrot_TQueue_ro_push_float(Interp *interp, PMC* pmc, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "push_float() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_push_integer(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "push_integer() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_push_pmc(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "push_pmc() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_push_string(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "push_string() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_remove_attribute(Interp *interp, PMC* pmc, STRING* name)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "remove_attribute() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_remove_method(Interp *interp, PMC* pmc, STRING* method_name)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "remove_method() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_remove_parent(Interp *interp, PMC* pmc, PMC* parent)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "remove_parent() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_remove_role(Interp *interp, PMC* pmc, PMC* role)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "remove_role() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_set_attr(Interp *interp, PMC* pmc, INTVAL idx, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_attr() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_set_attr_str(Interp *interp, PMC* pmc, STRING* idx, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_attr_str() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_set_bignum_int(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_bignum_int() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_set_bignum_num(Interp *interp, PMC* pmc, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_bignum_num() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_set_bignum_str(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_bignum_str() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_set_bool(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_bool() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_set_integer_keyed(Interp *interp, PMC* pmc, PMC* key, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_keyed() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_set_integer_keyed_int(Interp *interp, PMC* pmc, INTVAL key, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_keyed_int() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_set_integer_keyed_str(Interp *interp, PMC* pmc, STRING* key, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_keyed_str() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_set_integer_native(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_native() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_set_integer_same(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_same() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_set_number_keyed(Interp *interp, PMC* pmc, PMC* key, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_keyed() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_set_number_keyed_int(Interp *interp, PMC* pmc, INTVAL key, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_keyed_int() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_set_number_keyed_str(Interp *interp, PMC* pmc, STRING* key, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_keyed_str() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_set_number_native(Interp *interp, PMC* pmc, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_native() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_set_number_same(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_same() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_set_pmc(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pmc() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_set_pmc_keyed(Interp *interp, PMC* pmc, PMC* key, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pmc_keyed() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_set_pmc_keyed_int(Interp *interp, PMC* pmc, INTVAL key, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_int() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_set_pmc_keyed_str(Interp *interp, PMC* pmc, STRING* key, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_str() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_set_pointer(Interp *interp, PMC* pmc, void* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pointer() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_set_pointer_keyed(Interp *interp, PMC* pmc, PMC* key, void* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pointer_keyed() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_set_pointer_keyed_int(Interp *interp, PMC* pmc, INTVAL key, void* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_int() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_set_pointer_keyed_str(Interp *interp, PMC* pmc, STRING* key, void* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_str() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_set_string_keyed(Interp *interp, PMC* pmc, PMC* key, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_keyed() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_set_string_keyed_int(Interp *interp, PMC* pmc, INTVAL key, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_keyed_int() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_set_string_keyed_str(Interp *interp, PMC* pmc, STRING* key, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_keyed_str() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_set_string_native(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_native() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_set_string_same(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_same() in read-only instance of TQueue");
}
FLOATVAL
Parrot_TQueue_ro_shift_float(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "shift_float() in read-only instance of TQueue");
    return (FLOATVAL)0;
}
INTVAL
Parrot_TQueue_ro_shift_integer(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "shift_integer() in read-only instance of TQueue");
    return (INTVAL)0;
}
PMC*
Parrot_TQueue_ro_shift_pmc(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "shift_pmc() in read-only instance of TQueue");
    return PMCNULL;
}
STRING*
Parrot_TQueue_ro_shift_string(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "shift_string() in read-only instance of TQueue");
    return (STRING*)0;
}
void
Parrot_TQueue_ro_splice(Interp *interp, PMC* pmc, PMC* value, INTVAL offset, INTVAL count)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "splice() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_thaw(Interp *interp, PMC* pmc, visit_info* info)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "thaw() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_thawfinish(Interp *interp, PMC* pmc, visit_info* info)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "thawfinish() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_unshift_float(Interp *interp, PMC* pmc, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "unshift_float() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_unshift_integer(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "unshift_integer() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_unshift_pmc(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "unshift_pmc() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_unshift_string(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "unshift_string() in read-only instance of TQueue");
}
void
Parrot_TQueue_class_init(Parrot_Interp interp, int entry, int pass)
{
    const VTABLE temp_base_vtable = {
        NULL, /* namespace */
        enum_class_TQueue, /* base_type */
        NULL, /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_IS_SHARED_FLAG|VTABLE_HAS_READONLY_FLAG, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        NULL,   /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_default_add_attribute,
        Parrot_default_add_method,
        Parrot_default_add_parent,
        Parrot_default_add_role,
        Parrot_default_assign_pmc,
        Parrot_default_assign_string_native,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_can,
        Parrot_default_class_type,
        Parrot_TQueue_clone,
        Parrot_default_clone_pmc,
        Parrot_default_decrement,
        Parrot_TQueue_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_default_delete_keyed,
        Parrot_default_delete_keyed_int,
        Parrot_default_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_TQueue_destroy,
        Parrot_default_does,
        Parrot_TQueue_elements,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_default_find_method,
        Parrot_default_freeze,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_default_get_bool,
        Parrot_default_get_class,
        Parrot_TQueue_get_integer,
        Parrot_default_get_integer_keyed,
        Parrot_default_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_iter,
        Parrot_default_get_number,
        Parrot_default_get_number_keyed,
        Parrot_default_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_default_get_pmc_keyed,
        Parrot_default_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_default_get_repr,
        Parrot_default_get_string,
        Parrot_default_get_string_keyed,
        Parrot_default_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_default_hash,
        Parrot_default_i_absolute,
        Parrot_default_i_bitwise_not,
        Parrot_default_i_bitwise_nots,
        Parrot_default_i_logical_not,
        Parrot_default_i_neg,
        Parrot_default_increment,
        Parrot_TQueue_init,
        Parrot_default_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_default_instantiate,
        Parrot_default_invoke,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_logical_not,
        Parrot_TQueue_mark,
        Parrot_default_morph,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_new_from_string,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_pmc_namespace,
        Parrot_default_pop_float,
        Parrot_default_pop_integer,
        Parrot_default_pop_pmc,
        Parrot_default_pop_string,
        Parrot_default_push_float,
        Parrot_default_push_integer,
        Parrot_TQueue_push_pmc,
        Parrot_default_push_string,
        Parrot_default_remove_attribute,
        Parrot_default_remove_method,
        Parrot_default_remove_parent,
        Parrot_default_remove_role,
        Parrot_default_set_attr,
        Parrot_default_set_attr_str,
        Parrot_default_set_bignum_int,
        Parrot_default_set_bignum_num,
        Parrot_default_set_bignum_str,
        Parrot_default_set_bool,
        Parrot_default_set_integer_keyed,
        Parrot_default_set_integer_keyed_int,
        Parrot_default_set_integer_keyed_str,
        Parrot_default_set_integer_native,
        Parrot_default_set_integer_same,
        Parrot_default_set_number_keyed,
        Parrot_default_set_number_keyed_int,
        Parrot_default_set_number_keyed_str,
        Parrot_default_set_number_native,
        Parrot_default_set_number_same,
        Parrot_default_set_pmc,
        Parrot_default_set_pmc_keyed,
        Parrot_default_set_pmc_keyed_int,
        Parrot_default_set_pmc_keyed_str,
        Parrot_default_set_pointer,
        Parrot_default_set_pointer_keyed,
        Parrot_default_set_pointer_keyed_int,
        Parrot_default_set_pointer_keyed_str,
        Parrot_default_set_string_keyed,
        Parrot_default_set_string_keyed_int,
        Parrot_default_set_string_keyed_str,
        Parrot_default_set_string_native,
        Parrot_default_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_default_shift_float,
        Parrot_default_shift_integer,
        Parrot_TQueue_shift_pmc,
        Parrot_default_shift_string,
        Parrot_default_slice,
        Parrot_default_splice,
        Parrot_default_subclass,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtype,
        Parrot_default_thaw,
        Parrot_default_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_type_keyed_int,
        Parrot_default_type_keyed_str,
        Parrot_default_unshift_float,
        Parrot_default_unshift_integer,
        Parrot_default_unshift_pmc,
        Parrot_default_unshift_string,
        Parrot_default_visit
    };

    const VTABLE temp_ro_vtable = {
        NULL, /* namespace */
        enum_class_TQueue, /* base_type */
        NULL, /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_IS_SHARED_FLAG|VTABLE_IS_READONLY_FLAG, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        NULL,   /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_TQueue_ro_add_attribute,
        Parrot_TQueue_ro_add_method,
        Parrot_TQueue_ro_add_parent,
        Parrot_TQueue_ro_add_role,
        Parrot_TQueue_ro_assign_pmc,
        Parrot_TQueue_ro_assign_string_native,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_can,
        Parrot_default_class_type,
        Parrot_TQueue_clone,
        Parrot_default_clone_pmc,
        Parrot_TQueue_ro_decrement,
        Parrot_TQueue_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_TQueue_ro_delete_keyed,
        Parrot_TQueue_ro_delete_keyed_int,
        Parrot_TQueue_ro_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_TQueue_destroy,
        Parrot_default_does,
        Parrot_TQueue_elements,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_TQueue_ro_find_method,
        Parrot_default_freeze,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_default_get_bool,
        Parrot_default_get_class,
        Parrot_TQueue_get_integer,
        Parrot_default_get_integer_keyed,
        Parrot_default_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_iter,
        Parrot_default_get_number,
        Parrot_default_get_number_keyed,
        Parrot_default_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_default_get_pmc_keyed,
        Parrot_default_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_default_get_repr,
        Parrot_default_get_string,
        Parrot_default_get_string_keyed,
        Parrot_default_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_default_hash,
        Parrot_TQueue_ro_i_absolute,
        Parrot_TQueue_ro_i_bitwise_not,
        Parrot_TQueue_ro_i_bitwise_nots,
        Parrot_TQueue_ro_i_logical_not,
        Parrot_TQueue_ro_i_neg,
        Parrot_TQueue_ro_increment,
        Parrot_TQueue_init,
        Parrot_default_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_default_instantiate,
        Parrot_default_invoke,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_logical_not,
        Parrot_TQueue_mark,
        Parrot_TQueue_ro_morph,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_new_from_string,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_pmc_namespace,
        Parrot_TQueue_ro_pop_float,
        Parrot_TQueue_ro_pop_integer,
        Parrot_TQueue_ro_pop_pmc,
        Parrot_TQueue_ro_pop_string,
        Parrot_TQueue_ro_push_float,
        Parrot_TQueue_ro_push_integer,
        Parrot_TQueue_ro_push_pmc,
        Parrot_TQueue_ro_push_string,
        Parrot_TQueue_ro_remove_attribute,
        Parrot_TQueue_ro_remove_method,
        Parrot_TQueue_ro_remove_parent,
        Parrot_TQueue_ro_remove_role,
        Parrot_TQueue_ro_set_attr,
        Parrot_TQueue_ro_set_attr_str,
        Parrot_TQueue_ro_set_bignum_int,
        Parrot_TQueue_ro_set_bignum_num,
        Parrot_TQueue_ro_set_bignum_str,
        Parrot_TQueue_ro_set_bool,
        Parrot_TQueue_ro_set_integer_keyed,
        Parrot_TQueue_ro_set_integer_keyed_int,
        Parrot_TQueue_ro_set_integer_keyed_str,
        Parrot_TQueue_ro_set_integer_native,
        Parrot_TQueue_ro_set_integer_same,
        Parrot_TQueue_ro_set_number_keyed,
        Parrot_TQueue_ro_set_number_keyed_int,
        Parrot_TQueue_ro_set_number_keyed_str,
        Parrot_TQueue_ro_set_number_native,
        Parrot_TQueue_ro_set_number_same,
        Parrot_TQueue_ro_set_pmc,
        Parrot_TQueue_ro_set_pmc_keyed,
        Parrot_TQueue_ro_set_pmc_keyed_int,
        Parrot_TQueue_ro_set_pmc_keyed_str,
        Parrot_TQueue_ro_set_pointer,
        Parrot_TQueue_ro_set_pointer_keyed,
        Parrot_TQueue_ro_set_pointer_keyed_int,
        Parrot_TQueue_ro_set_pointer_keyed_str,
        Parrot_TQueue_ro_set_string_keyed,
        Parrot_TQueue_ro_set_string_keyed_int,
        Parrot_TQueue_ro_set_string_keyed_str,
        Parrot_TQueue_ro_set_string_native,
        Parrot_TQueue_ro_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_TQueue_ro_shift_float,
        Parrot_TQueue_ro_shift_integer,
        Parrot_TQueue_ro_shift_pmc,
        Parrot_TQueue_ro_shift_string,
        Parrot_default_slice,
        Parrot_TQueue_ro_splice,
        Parrot_default_subclass,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtype,
        Parrot_TQueue_ro_thaw,
        Parrot_TQueue_ro_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_type_keyed_int,
        Parrot_default_type_keyed_str,
        Parrot_TQueue_ro_unshift_float,
        Parrot_TQueue_ro_unshift_integer,
        Parrot_TQueue_ro_unshift_pmc,
        Parrot_TQueue_ro_unshift_string,
        Parrot_default_visit
    };
    if (pass == 0) {
        /*
         * create vtable - clone it - we have to set a few items
         */
        VTABLE *vt_clone =
            Parrot_clone_vtable(interp, &temp_base_vtable);
        VTABLE *vt_ro_clone =
            Parrot_clone_vtable(interp, &temp_ro_vtable);
        vt_clone->whoami = CONST_STRING(interp, "TQueue");
        vt_clone->isa_str = CONST_STRING(interp, "TQueue");
        vt_clone->does_str = CONST_STRING(interp, "scalar");
        vt_ro_clone->base_type = entry;
        vt_ro_clone->whoami = vt_clone->whoami;
        vt_ro_clone->isa_str = vt_clone->isa_str;
        vt_ro_clone->does_str = vt_clone->does_str;
        vt_clone->ro_variant_vtable = vt_ro_clone;
        vt_ro_clone->ro_variant_vtable = vt_clone;
        interp->vtables[entry] = vt_clone;
    }
    else { /* pass */
        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        /* create PMC Proxy object */
        Parrot_create_pmc_proxy(interp, entry);
        /* class_init */
        {
        }
    } /* pass */
} /* Parrot_TQueue_class_init */


/*

=back

=head1 HISTORY

2003.12.19 leo initial rev.

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
