/*
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/unmanagedstruct.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

#line 1 "./src/pmc/unmanagedstruct.pmc"
/*
Copyright (C) 2001-2006, The Perl Foundation.
$Id: unmanagedstruct.pmc 16275 2006-12-28 01:20:44Z particle $

=head1 NAME

src/pmc/unmanagedstruct.pmc - C struct with unmanaged memory

=head1 DESCRIPTION

PMC class to hold C C<struct>s that parrot's not responsible for
disposing of.

Buffer can be accessed using keyed assignments to PMC. Out of
bounds access will very likely segfault.

=head2 Functions

=over 4

=cut

*/

#include "parrot/parrot.h"
#include "parrot/compiler.h"
#include <assert.h>


static INTVAL key_2_idx(Interp *interp, PMC *pmc, PMC *key);
static size_t calc_offsets(Interp *interp, PMC*,
    PMC *init, size_t toff);

/*

=item C<static char *
char_offset_int(Interp *interp, PMC *pmc, INTVAL ix, int *type)>

Returns the pointer for the element at index C<ix>, and sets the element
type in C<*type>.

=cut

*/

static char *
char_offset_int(Interp *interp, PMC *pmc, INTVAL ix, int *type)
{
    size_t offs, n;
    ix *= 3;

    if (!PMC_pmc_val(pmc))
        real_exception(interp, NULL, E_ValueError,
                "Missing struct initializer");
    n = (size_t)VTABLE_elements(interp, PMC_pmc_val(pmc));
    if ((size_t)ix >= n)
        real_exception(interp, NULL, E_ValueError,
                "Non existent elements in struct "
                "ix = %d n=%d", (int)ix, (int)n);
    /* use structure init */
    *type = (int) VTABLE_get_integer_keyed_int(interp,
        PMC_pmc_val(pmc), ix);
    offs = (size_t) VTABLE_get_integer_keyed_int(interp,
        PMC_pmc_val(pmc), ix + 2);
    return ((char *)PMC_data(pmc)) + offs;
}

/*

=item C<static INTVAL
key_2_idx(Interp *interp, PMC *pmc, PMC *key)>

Returns the index for the element associated with key C<*key>. Raises an
exception if the key doesn't exist.

=cut

*/

static INTVAL
key_2_idx(Interp *interp, PMC *pmc, PMC *key)
{
    int ix;
    ix = 0;

    if (!PMC_pmc_val(pmc))
        real_exception(interp, NULL, E_ValueError,
                "Missing struct initializer");
    if (PObj_get_FLAGS(key) & KEY_string_FLAG) {
        PMC * const types = PMC_pmc_val(pmc);
        if (types->vtable->base_type == enum_class_OrderedHash) {
            Hash * const hash = (Hash*)PMC_struct_val(types);
            HashBucket * const b = parrot_hash_get_bucket(interp, hash,
                key_string(interp, key));
            if (!b)
                real_exception(interp, NULL, E_KeyError,
                        "key doesn't exist");
            ix = b - hash->bs;
        }
        else
            real_exception(interp, NULL, E_TypeError,
                    "unhandled type aggregate");
        ix /= 3;
    }
    else
        ix = key_integer(interp, key);
    return ix;
}

/*

=item C<static char *
char_offset_key(Interp *interp, PMC *pmc, PMC *key, int *type)>

Returns the pointer for the element associated with key C<*key>, and
sets the element type in C<*type>.

=cut

*/

static char *
char_offset_key(Interp *interp, PMC *pmc, PMC *key, int *type)
{
    size_t offs, count, size, max;
    PMC *next, *init, *outer_init;
    int ix;
    char *p;

#ifdef STRUCT_DEBUG
    trace_key_dump(interp, key);
#endif
    ix = key_2_idx(interp, pmc, key);
    next = key_next(interp, key);
    p = char_offset_int(interp, pmc, ix, type);
    ix *= 3;
    if (!next)
        return p;
    count = 1;
    if (PObj_get_FLAGS(next) & KEY_integer_FLAG)
        count = key_integer(interp, next);
    else
        count = 1;
    outer_init = init = PMC_pmc_val(pmc);
    max = (size_t) VTABLE_get_integer_keyed_int(interp, init, ix + 1);
#ifdef STRUCT_DEBUG
    PIO_eprintf(interp, " count = %d ix = %d max = %d\n",
            (int)count, (int)ix, (int)max);
#endif

    if (*type == enum_type_struct_ptr || *type == enum_type_struct) {
        /* the struct PMC is hanging off the initializer element
         * as property "_struct"
         */
        PMC * const ptr = VTABLE_get_pmc_keyed_int(interp, init, ix);
        init = VTABLE_getprop(interp, ptr,
            string_from_cstring(interp, "_struct", 0));
        assert(init && (init->vtable->base_type == enum_class_UnManagedStruct
            ||  init->vtable->base_type == enum_class_ManagedStruct));

        if (max > 1) {  /* array of structs */

            if (key_next(interp, next))
                next = key_next(interp, next);
            offs = PMC_int_val(init);
#ifdef STRUCT_DEBUG
            PIO_eprintf(interp, "offs = %d\n", (int)offs);
#endif
            p += offs * count;
        }
        if (init->vtable->base_type == enum_class_UnManagedStruct) {
            /*
             * now point PMC_data of this struct to the real data
             */
            if (*type == enum_type_struct_ptr) {
                /* that is either a pointer */
                assert((PTR2INTVAL(p) & (PARROT_PTR_ALIGNMENT - 1)) == 0);
                PMC_data(init) = *(void**)p;
            }
            else {
                /* or just an offset for nested structs */
                PMC_data(init) = p;
            }
        }
        else if (init->vtable->base_type == enum_class_ManagedStruct &&
            *type == enum_type_struct_ptr) {
            /* a nested struct pointer belonging to us
             * p is the location of the struct pointer in the
             * outer struct, the inner is at PMC_data(init)
             */
            assert((PTR2INTVAL(p) & (PARROT_PTR_ALIGNMENT - 1)) == 0);
            *(void**)p = PMC_data(init);
        }
        return char_offset_key(interp, init, next, type);
    }
    if (count >= max)
        real_exception(interp, NULL, E_LookupError,
                "Non existent array element in struct: "
                "count = %d max=%d", (int)count, (int)max);
    size = data_types[*type - enum_first_type].size;
    return p + count * size;
}

/*

=item C<static INTVAL
ret_int(const char *p, int type)>

Returns the element of type C<type> starting at C<*p> as an C<INTVAL>.

If, for example, C<char> or c<short> type size doesn't match, this will fail
we need some more configure support for type sizes.

=cut

*/

static INTVAL
ret_int(const char *p, int type)
    __attribute__nonnull__(1);

static INTVAL
ret_int(const char *p, int type)
{
    switch (type) {
        case enum_type_INTVAL:
            return *(const INTVAL*) p;
#if INT_SIZE == 4
        case enum_type_int32:
        case enum_type_uint32:
#endif
#if INT_SIZE == 8
        case enum_type_int64:
        case enum_type_uint64:
#endif
        case enum_type_int:
            return *(const int*) p;
#if (LONG_SIZE == 4) && !(INT_SIZE == 4) /* Unlikely combination. */
        case enum_type_int32:
        case enum_type_uint32:
#endif
#if (LONG_SIZE == 8) && !(INT_SIZE == 8)
        case enum_type_int64:
        case enum_type_uint64:
#endif
        case enum_type_long:
        case enum_type_ulong:
            return *(const long*) p;
#if SHORT_SIZE == 2
        case enum_type_int16:
        case enum_type_uint16:
#endif
        /* If SHORT_SIZE != 2 getting int16s requires extra tricks. */
        case enum_type_short:
            return *(const short*) p;
        case enum_type_uint8:
        case enum_type_int8:
        case enum_type_char:
        case enum_type_uchar:
            return *p;
        default:
            internal_exception(1, "returning unhandled int type in struct");
    }
    return -1;
}

/*

=item C<static FLOATVAL
ret_float(const char *p, int type)>

Returns the element of type C<type> starting at C<*p> as a C<FLOATVAL>.

=cut

*/

static FLOATVAL
ret_float(const char *p, int type)
    __attribute__nonnull__(1);

static FLOATVAL
ret_float(const char *p, int type)
{
    switch (type) {
        case enum_type_FLOATVAL:
            return (FLOATVAL) *(const FLOATVAL*) p;
        case enum_type_float:
            return (FLOATVAL) *(const float*) p;
        case enum_type_double:
            return (FLOATVAL) *(const double*) p;
        default:
            internal_exception(1, "returning unhandled float type in struct");
    }
    return -1.0;
}

/*

=item C<static STRING*
ret_string(Interp *interp, char *p, int type)>

Returns the element of type C<type> starting at C<*p> as a Parrot string.

=cut

*/

static STRING*
ret_string(Interp *interp, char *p, int type)
{
    char *cstr;
    size_t len;

    switch (type) {
        case enum_type_cstr:
            cstr = *(char **) p;
            len = strlen(cstr);
            return string_make(interp, cstr, len, "iso-8859-1",
                PObj_external_FLAG);
        default:
            real_exception(interp, NULL, E_TypeError,
                    "returning unhandled string type in struct");
    }
    return NULL;
}

/*

=item C<static PMC*
ret_pmc(Interp *interp, PMC* pmc, char *p, int type, INTVAL idx)>

Returns the element of type C<type> starting at C<*p> as a PMC.

=cut

*/

static PMC*
ret_pmc(Interp *interp, PMC* pmc, char *p, int type, INTVAL idx)
{
    PMC *ret = NULL, *init, *ptr;

    switch (type) {
        case enum_type_func_ptr:
            /* this is a raw function pointer - not a PMC */
            ret = *(PMC**) p;
            /* now check if initializer has a signature attached */
            init = PMC_pmc_val(pmc);
            ptr = VTABLE_get_pmc_keyed_int(interp, init, idx*3);
            if (ptr->pmc_ext && PMC_metadata(ptr)) {
                PMC *sig = VTABLE_getprop(interp, ptr,
                        string_from_cstring(interp, "_signature", 0));
                if (VTABLE_defined(interp, sig)) {
                    STRING *sig_str = VTABLE_get_string(interp, sig);
                    ret = pmc_new(interp, enum_class_NCI);
                    VTABLE_set_pointer_keyed_str(interp, ret, sig_str,
                            *(PMC**)p);
                }
            }
            return ret;
        case enum_type_struct_ptr:

            /* check the metadata for an initializer */
            init = PMC_pmc_val(pmc);
            ptr  = VTABLE_get_pmc_keyed_int(interp, init, idx * 3);

            /* grab the struct from the metadata */
            if (ptr->pmc_ext && PMC_metadata(ptr))
            {
                ret = VTABLE_getprop(interp, ptr,
                        const_string(interp, "_struct"));
            }
            else
            {
                real_exception(interp, NULL, E_TypeError,
                        "no initializer available for nested struct");
            }

            /* assign the pointer */
            PMC_data(ret) = *(void**)p;

            return ret;
        default:
            real_exception(interp, NULL, E_TypeError,
                    "returning unhandled pmc type (%d) in struct",
                    type);
    }
    return NULL;
}

/*

=item C<static void
set_int(char *p, int type, INTVAL value)>

=cut

*/

static void
set_int(char *p, int type, INTVAL value)
{
    switch (type) {
        case enum_type_uint8:
        case enum_type_int8:
        case enum_type_char:
        case enum_type_uchar:
            *(char*) p = (char)value & 0xff;
            break;
        case enum_type_INTVAL:
            *(INTVAL*) p = value;
            break;
        case enum_type_int:
            *(int*) p = value;
            break;
        case enum_type_int16:
        case enum_type_uint16:
        case enum_type_short:
            *(short*)p = (short)value;
            break;
        default:
            internal_exception(1, "setting unhandled int type in struct");
            break;
    }
}

/*

=item C<static void
set_float(char *p, int type, FLOATVAL value)>

Sets the value of the element of type C<type> starting at C<*p> to
C<value>.

=cut

*/

static void
set_float(char *p, int type, FLOATVAL value)
{
    switch (type) {
        case enum_type_FLOATVAL:
            *(FLOATVAL*) p = (FLOATVAL) value;
            break;
        case enum_type_float:
            *(float*) p = (float) value;
            break;
        case enum_type_double:
            *(double*) p = (double) value;
            break;
        default:
            internal_exception(1, "setting unhandled float type in struct");
            break;
    }
}

/*

=item C<static void
set_string(char *p, int type, STRING *value)>

Sets the value of the element of type C<type> starting at C<*p> to
C<*value>.

=cut

*/

static void
set_string(char *p, int type, STRING* value)
{
    char *cstr;
    switch (type) {
        case enum_type_cstr:
            /* XXX assumes 0-terminate C-string here
             *     we can't use string_to_cstring easily
             */
            cstr = value->strstart;
            *(char **) p = cstr;
            break;
        default:
            internal_exception(1, "setting unhandled string type in struct (%d)", type);
            break;
    }
}

/*

=item C<static int
calc_align(Interp *interp, PMC *pmc, PMC *type_pmc,
        int type, int offs)>

Alignment of contained structures is the alignment of the
biggest item in that C<struct>.

i386: C<long long> or C<double> is aligned on 4.

This is recursive as structure definitions.

=cut

*/

static int
calc_align(Interp *interp, PMC* pmc, PMC* type_pmc,
        int type, int offs)
{
    int align = data_types[type - enum_first_type].size;
    PMC *nested, *nested_init;

    nested = nested_init = NULL;
    if (type == enum_type_struct || type == enum_type_struct_ptr) {
        /* a nested structs alignment is the biggest item in it
         * so go through that struct and check
         */
        nested = VTABLE_getprop(interp, type_pmc,
            string_from_cstring(interp, "_struct", 0));
        nested_init = PMC_pmc_val(nested);
    }
    if (type == enum_type_struct) {
        size_t i, n = (size_t)VTABLE_elements(interp, nested_init);
        int a_max = 0;
        int new_offs;

        if (n % 3)
            real_exception(interp, NULL, E_TypeError,
                    "Illegal initializer for struct");

        for (i = 0; i < n; i += 3) {
                PMC* nested_type_pmc = VTABLE_get_pmc_keyed_int(interp,
                        nested_init, i);
                int nested_type = (int) VTABLE_get_integer(interp,
                        nested_type_pmc);
                new_offs = calc_align(interp, nested,
                        nested_type_pmc, nested_type, offs);
                if (new_offs > a_max)
                    a_max = new_offs;
        }
        align = a_max;
    }

    if (align && offs % align) {
        const int diff = align - (offs % align);
        offs += diff;
    }

    if (type == enum_type_struct || type == enum_type_struct_ptr) {
        calc_offsets(interp, nested, nested_init, 0);
    }
    return offs;
}

/*

=item C<static size_t
calc_offsets(Interp *interp, PMC *pmc, PMC *value, size_t toff)>

Calculates the offsets for the C<struct>. See C<init_pmc()> for a
description of C<*value>.

=cut

*/

static size_t
calc_offsets(Interp *interp, PMC* pmc, PMC *value, size_t toff)
{
    size_t i, n = (size_t)VTABLE_elements(interp, value);
    int size;

    if (n % 3)
        real_exception(interp, NULL, E_TypeError,
                "Illegal initializer for struct");

    for (i = 0; i < n; i += 3) {
        PMC* type_pmc = VTABLE_get_pmc_keyed_int(interp,
            value, i);
        int type = (int) VTABLE_get_integer(interp, type_pmc);
        int count= (int) VTABLE_get_integer_keyed_int(interp,
            value, i+1);
        int offs = (int) VTABLE_get_integer_keyed_int(interp,
            value, i+2);

        if (type < enum_first_type || type >= enum_last_type)
            real_exception(interp, NULL, E_TypeError,
                    "Illegal type in initializer for struct");
        if (count <= 0) {
            count = 1;
            VTABLE_set_integer_keyed_int(interp, value, i+1, count);
        }
        if (offs <= 0) {
            offs = toff = calc_align(interp, pmc, type_pmc, type, toff);
            VTABLE_set_integer_keyed_int(interp, value, i+2, offs);
        }
        else
            toff = offs;
            if (type == enum_type_struct) {
                PMC *nested = VTABLE_getprop(interp, type_pmc,
                        string_from_cstring(interp, "_struct", 0));
                size = PMC_int_val(nested);
            }
            else
                size = data_types[type - enum_first_type].size;
        toff += count * size;
            /* set / allocate size */
        if (i == n - 3)
            VTABLE_set_integer_native(interp, pmc, toff);
    }
    return toff;
}

#line 626 "src/pmc/unmanagedstruct.c"
#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_unmanagedstruct.h"
#include "pmc_default.h"
#include "unmanagedstruct.str"

INTVAL
Parrot_UnManagedStruct_is_equal(Interp *interp, PMC* pmc, PMC* value)
#line 710 "./src/pmc/unmanagedstruct.pmc"
{
    return (pmc->vtable == value->vtable &&
        PMC_data(pmc) == PMC_data(value));

}
#line 642 "src/pmc/unmanagedstruct.c"
INTVAL
Parrot_UnManagedStruct_defined(Interp *interp, PMC* pmc)
#line 725 "./src/pmc/unmanagedstruct.pmc"
{
    return PMC_data(pmc) != NULL;

}
#line 650 "src/pmc/unmanagedstruct.c"
INTVAL
Parrot_UnManagedStruct_get_integer(Interp *interp, PMC* pmc)
#line 739 "./src/pmc/unmanagedstruct.pmc"
{
    return PMC_int_val(pmc);

}
#line 658 "src/pmc/unmanagedstruct.c"
INTVAL
Parrot_UnManagedStruct_get_integer_keyed(Interp *interp, PMC* pmc, PMC* key)
#line 783 "./src/pmc/unmanagedstruct.pmc"
{
    int type;
    char *p = char_offset_key(interp, pmc, key, &type);
    return ret_int(p, type);

}
#line 668 "src/pmc/unmanagedstruct.c"
INTVAL
Parrot_UnManagedStruct_get_integer_keyed_int(Interp *interp, PMC* pmc, INTVAL ix)
#line 767 "./src/pmc/unmanagedstruct.pmc"
{
    int type;
    char *p = char_offset_int(interp, pmc, ix, &type);
    return ret_int(p, type);

}
#line 678 "src/pmc/unmanagedstruct.c"
FLOATVAL
Parrot_UnManagedStruct_get_number_keyed(Interp *interp, PMC* pmc, PMC* key)
#line 815 "./src/pmc/unmanagedstruct.pmc"
{
    int type;
    char *p = char_offset_key(interp, pmc, key, &type);
    return ret_float(p, type);

}
#line 688 "src/pmc/unmanagedstruct.c"
FLOATVAL
Parrot_UnManagedStruct_get_number_keyed_int(Interp *interp, PMC* pmc, INTVAL key)
#line 799 "./src/pmc/unmanagedstruct.pmc"
{
    int type;
    char *p = char_offset_int(interp, pmc, key, &type);
    return ret_float(p, type);

}
#line 698 "src/pmc/unmanagedstruct.c"
PMC*
Parrot_UnManagedStruct_get_pmc_keyed(Interp *interp, PMC* pmc, PMC* key)
#line 879 "./src/pmc/unmanagedstruct.pmc"
{
    int type;
    char *p = char_offset_key(interp, pmc, key, &type);
    return ret_pmc(interp, pmc, p, type,
        key_2_idx(interp, pmc, key));

}
#line 709 "src/pmc/unmanagedstruct.c"
PMC*
Parrot_UnManagedStruct_get_pmc_keyed_int(Interp *interp, PMC* pmc, INTVAL key)
#line 863 "./src/pmc/unmanagedstruct.pmc"
{
    int type;
    char *p = char_offset_int(interp, pmc, key, &type);
    return ret_pmc(interp, pmc, p, type, key);

}
#line 719 "src/pmc/unmanagedstruct.c"
void*
Parrot_UnManagedStruct_get_pointer(Interp *interp, PMC* pmc)
#line 896 "./src/pmc/unmanagedstruct.pmc"
{
    return PMC_data(pmc);

}
#line 727 "src/pmc/unmanagedstruct.c"
STRING*
Parrot_UnManagedStruct_get_string_keyed(Interp *interp, PMC* pmc, PMC* key)
#line 847 "./src/pmc/unmanagedstruct.pmc"
{
    int type;
    char *p = char_offset_key(interp, pmc, key, &type);
    return ret_string(interp, p, type);

}
#line 737 "src/pmc/unmanagedstruct.c"
STRING*
Parrot_UnManagedStruct_get_string_keyed_int(Interp *interp, PMC* pmc, INTVAL key)
#line 831 "./src/pmc/unmanagedstruct.pmc"
{
    int type;
    char *p = char_offset_int(interp, pmc, key, &type);
    return ret_string(interp, p, type);

}
#line 747 "src/pmc/unmanagedstruct.c"
void
Parrot_UnManagedStruct_init(Interp *interp, PMC* pmc)
#line 632 "./src/pmc/unmanagedstruct.pmc"
{
    PMC_pmc_val(pmc) = NULL;

}
#line 755 "src/pmc/unmanagedstruct.c"
void
Parrot_UnManagedStruct_init_pmc(Interp *interp, PMC* pmc, PMC* value)
#line 665 "./src/pmc/unmanagedstruct.pmc"
{
    Parrot_UnManagedStruct_set_pmc(interp, pmc, value);

}
#line 763 "src/pmc/unmanagedstruct.c"
void
Parrot_UnManagedStruct_mark(Interp *interp, PMC* pmc)
#line 695 "./src/pmc/unmanagedstruct.pmc"
{
    if (PMC_pmc_val(pmc))
        pobject_lives(interp, (PObj *) PMC_pmc_val(pmc));

}
#line 772 "src/pmc/unmanagedstruct.c"
void
Parrot_UnManagedStruct_set_integer_keyed(Interp *interp, PMC* pmc, PMC* key, INTVAL value)
#line 942 "./src/pmc/unmanagedstruct.pmc"
{
    int type;
    char *p = char_offset_key(interp, pmc, key, &type);
    set_int(p, type, value);

}
#line 782 "src/pmc/unmanagedstruct.c"
void
Parrot_UnManagedStruct_set_integer_keyed_int(Interp *interp, PMC* pmc, INTVAL ix, INTVAL value)
#line 924 "./src/pmc/unmanagedstruct.pmc"
{
    int type;
    char *p = char_offset_int(interp, pmc, ix, &type);
    set_int(p, type, value);

}
#line 792 "src/pmc/unmanagedstruct.c"
void
Parrot_UnManagedStruct_set_integer_native(Interp *interp, PMC* pmc, INTVAL size)
#line 753 "./src/pmc/unmanagedstruct.pmc"
{
    PMC_int_val(pmc) = size;

}
#line 800 "src/pmc/unmanagedstruct.c"
void
Parrot_UnManagedStruct_set_number_keyed(Interp *interp, PMC* pmc, PMC *key, FLOATVAL value)
#line 974 "./src/pmc/unmanagedstruct.pmc"
{
    int type;
    char *p = char_offset_key(interp, pmc, key, &type);
    set_float(p, type, value);

}
#line 810 "src/pmc/unmanagedstruct.c"
void
Parrot_UnManagedStruct_set_number_keyed_int(Interp *interp, PMC* pmc, INTVAL key, FLOATVAL value)
#line 958 "./src/pmc/unmanagedstruct.pmc"
{
    int type;
    char *p = char_offset_int(interp, pmc, key, &type);
    set_float(p, type, value);

}
#line 820 "src/pmc/unmanagedstruct.c"
void
Parrot_UnManagedStruct_set_pmc(Interp *interp, PMC* pmc, PMC* value)
#line 679 "./src/pmc/unmanagedstruct.pmc"
{
    PMC_pmc_val(pmc) = value;
    calc_offsets(interp, pmc, value, 0);
    PObj_custom_mark_SET(pmc);

}
#line 830 "src/pmc/unmanagedstruct.c"
void
Parrot_UnManagedStruct_set_pointer(Interp *interp, PMC* pmc, void* value)
#line 910 "./src/pmc/unmanagedstruct.pmc"
{
    PMC_data(pmc) = value;

}
#line 838 "src/pmc/unmanagedstruct.c"
void
Parrot_UnManagedStruct_set_string_keyed(Interp *interp, PMC* pmc, PMC *key, STRING* value)
#line 1006 "./src/pmc/unmanagedstruct.pmc"
{
    int type;
    char *p = char_offset_key(interp, pmc, key, &type);
    set_string(p, type, value);

}
#line 848 "src/pmc/unmanagedstruct.c"
void
Parrot_UnManagedStruct_set_string_keyed_int(Interp *interp, PMC* pmc, INTVAL key, STRING* value)
#line 990 "./src/pmc/unmanagedstruct.pmc"
{
    int type;
    char *p = char_offset_int(interp, pmc, key, &type);
    set_string(p, type, value);

}
#line 858 "src/pmc/unmanagedstruct.c"
void
Parrot_UnManagedStruct_ro_add_attribute(Interp *interp, PMC* pmc, STRING* name, PMC* type)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "add_attribute() in read-only instance of UnManagedStruct");
}
void
Parrot_UnManagedStruct_ro_add_method(Interp *interp, PMC* pmc, STRING* method_name, PMC* sub_pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "add_method() in read-only instance of UnManagedStruct");
}
void
Parrot_UnManagedStruct_ro_add_parent(Interp *interp, PMC* pmc, PMC* parent)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "add_parent() in read-only instance of UnManagedStruct");
}
void
Parrot_UnManagedStruct_ro_add_role(Interp *interp, PMC* pmc, PMC* role)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "add_role() in read-only instance of UnManagedStruct");
}
void
Parrot_UnManagedStruct_ro_assign_pmc(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "assign_pmc() in read-only instance of UnManagedStruct");
}
void
Parrot_UnManagedStruct_ro_assign_string_native(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "assign_string_native() in read-only instance of UnManagedStruct");
}
void
Parrot_UnManagedStruct_ro_decrement(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "decrement() in read-only instance of UnManagedStruct");
}
void
Parrot_UnManagedStruct_ro_delete_keyed(Interp *interp, PMC* pmc, PMC* key)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "delete_keyed() in read-only instance of UnManagedStruct");
}
void
Parrot_UnManagedStruct_ro_delete_keyed_int(Interp *interp, PMC* pmc, INTVAL key)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "delete_keyed_int() in read-only instance of UnManagedStruct");
}
void
Parrot_UnManagedStruct_ro_delete_keyed_str(Interp *interp, PMC* pmc, STRING* key)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "delete_keyed_str() in read-only instance of UnManagedStruct");
}
PMC*
Parrot_UnManagedStruct_ro_find_method(Interp *interp, PMC* pmc, STRING* method_name)
 {
    PMC *const method = Parrot_default_find_method(interp, pmc, method_name);
    if (!PMC_IS_NULL(VTABLE_getprop(interp, method, const_string(interp, "write"))))
        return PMCNULL;
    else
        return method;
}
void
Parrot_UnManagedStruct_ro_i_absolute(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_absolute() in read-only instance of UnManagedStruct");
}
void
Parrot_UnManagedStruct_ro_i_bitwise_not(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_bitwise_not() in read-only instance of UnManagedStruct");
}
void
Parrot_UnManagedStruct_ro_i_bitwise_nots(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_bitwise_nots() in read-only instance of UnManagedStruct");
}
void
Parrot_UnManagedStruct_ro_i_logical_not(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_logical_not() in read-only instance of UnManagedStruct");
}
void
Parrot_UnManagedStruct_ro_i_neg(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "i_neg() in read-only instance of UnManagedStruct");
}
void
Parrot_UnManagedStruct_ro_increment(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "increment() in read-only instance of UnManagedStruct");
}
void
Parrot_UnManagedStruct_ro_morph(Interp *interp, PMC* pmc, INTVAL type)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "morph() in read-only instance of UnManagedStruct");
}
FLOATVAL
Parrot_UnManagedStruct_ro_pop_float(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "pop_float() in read-only instance of UnManagedStruct");
    return (FLOATVAL)0;
}
INTVAL
Parrot_UnManagedStruct_ro_pop_integer(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "pop_integer() in read-only instance of UnManagedStruct");
    return (INTVAL)0;
}
PMC*
Parrot_UnManagedStruct_ro_pop_pmc(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "pop_pmc() in read-only instance of UnManagedStruct");
    return PMCNULL;
}
STRING*
Parrot_UnManagedStruct_ro_pop_string(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "pop_string() in read-only instance of UnManagedStruct");
    return (STRING*)0;
}
void
Parrot_UnManagedStruct_ro_push_float(Interp *interp, PMC* pmc, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "push_float() in read-only instance of UnManagedStruct");
}
void
Parrot_UnManagedStruct_ro_push_integer(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "push_integer() in read-only instance of UnManagedStruct");
}
void
Parrot_UnManagedStruct_ro_push_pmc(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "push_pmc() in read-only instance of UnManagedStruct");
}
void
Parrot_UnManagedStruct_ro_push_string(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "push_string() in read-only instance of UnManagedStruct");
}
void
Parrot_UnManagedStruct_ro_remove_attribute(Interp *interp, PMC* pmc, STRING* name)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "remove_attribute() in read-only instance of UnManagedStruct");
}
void
Parrot_UnManagedStruct_ro_remove_method(Interp *interp, PMC* pmc, STRING* method_name)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "remove_method() in read-only instance of UnManagedStruct");
}
void
Parrot_UnManagedStruct_ro_remove_parent(Interp *interp, PMC* pmc, PMC* parent)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "remove_parent() in read-only instance of UnManagedStruct");
}
void
Parrot_UnManagedStruct_ro_remove_role(Interp *interp, PMC* pmc, PMC* role)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "remove_role() in read-only instance of UnManagedStruct");
}
void
Parrot_UnManagedStruct_ro_set_attr(Interp *interp, PMC* pmc, INTVAL idx, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_attr() in read-only instance of UnManagedStruct");
}
void
Parrot_UnManagedStruct_ro_set_attr_str(Interp *interp, PMC* pmc, STRING* idx, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_attr_str() in read-only instance of UnManagedStruct");
}
void
Parrot_UnManagedStruct_ro_set_bignum_int(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_bignum_int() in read-only instance of UnManagedStruct");
}
void
Parrot_UnManagedStruct_ro_set_bignum_num(Interp *interp, PMC* pmc, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_bignum_num() in read-only instance of UnManagedStruct");
}
void
Parrot_UnManagedStruct_ro_set_bignum_str(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_bignum_str() in read-only instance of UnManagedStruct");
}
void
Parrot_UnManagedStruct_ro_set_bool(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_bool() in read-only instance of UnManagedStruct");
}
void
Parrot_UnManagedStruct_ro_set_integer_keyed(Interp *interp, PMC* pmc, PMC* key, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_keyed() in read-only instance of UnManagedStruct");
}
void
Parrot_UnManagedStruct_ro_set_integer_keyed_int(Interp *interp, PMC* pmc, INTVAL key, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_keyed_int() in read-only instance of UnManagedStruct");
}
void
Parrot_UnManagedStruct_ro_set_integer_keyed_str(Interp *interp, PMC* pmc, STRING* key, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_keyed_str() in read-only instance of UnManagedStruct");
}
void
Parrot_UnManagedStruct_ro_set_integer_native(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_native() in read-only instance of UnManagedStruct");
}
void
Parrot_UnManagedStruct_ro_set_integer_same(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_integer_same() in read-only instance of UnManagedStruct");
}
void
Parrot_UnManagedStruct_ro_set_number_keyed(Interp *interp, PMC* pmc, PMC* key, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_keyed() in read-only instance of UnManagedStruct");
}
void
Parrot_UnManagedStruct_ro_set_number_keyed_int(Interp *interp, PMC* pmc, INTVAL key, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_keyed_int() in read-only instance of UnManagedStruct");
}
void
Parrot_UnManagedStruct_ro_set_number_keyed_str(Interp *interp, PMC* pmc, STRING* key, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_keyed_str() in read-only instance of UnManagedStruct");
}
void
Parrot_UnManagedStruct_ro_set_number_native(Interp *interp, PMC* pmc, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_native() in read-only instance of UnManagedStruct");
}
void
Parrot_UnManagedStruct_ro_set_number_same(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_number_same() in read-only instance of UnManagedStruct");
}
void
Parrot_UnManagedStruct_ro_set_pmc(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pmc() in read-only instance of UnManagedStruct");
}
void
Parrot_UnManagedStruct_ro_set_pmc_keyed(Interp *interp, PMC* pmc, PMC* key, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pmc_keyed() in read-only instance of UnManagedStruct");
}
void
Parrot_UnManagedStruct_ro_set_pmc_keyed_int(Interp *interp, PMC* pmc, INTVAL key, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_int() in read-only instance of UnManagedStruct");
}
void
Parrot_UnManagedStruct_ro_set_pmc_keyed_str(Interp *interp, PMC* pmc, STRING* key, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_str() in read-only instance of UnManagedStruct");
}
void
Parrot_UnManagedStruct_ro_set_pointer(Interp *interp, PMC* pmc, void* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pointer() in read-only instance of UnManagedStruct");
}
void
Parrot_UnManagedStruct_ro_set_pointer_keyed(Interp *interp, PMC* pmc, PMC* key, void* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pointer_keyed() in read-only instance of UnManagedStruct");
}
void
Parrot_UnManagedStruct_ro_set_pointer_keyed_int(Interp *interp, PMC* pmc, INTVAL key, void* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_int() in read-only instance of UnManagedStruct");
}
void
Parrot_UnManagedStruct_ro_set_pointer_keyed_str(Interp *interp, PMC* pmc, STRING* key, void* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_str() in read-only instance of UnManagedStruct");
}
void
Parrot_UnManagedStruct_ro_set_string_keyed(Interp *interp, PMC* pmc, PMC* key, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_keyed() in read-only instance of UnManagedStruct");
}
void
Parrot_UnManagedStruct_ro_set_string_keyed_int(Interp *interp, PMC* pmc, INTVAL key, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_keyed_int() in read-only instance of UnManagedStruct");
}
void
Parrot_UnManagedStruct_ro_set_string_keyed_str(Interp *interp, PMC* pmc, STRING* key, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_keyed_str() in read-only instance of UnManagedStruct");
}
void
Parrot_UnManagedStruct_ro_set_string_native(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_native() in read-only instance of UnManagedStruct");
}
void
Parrot_UnManagedStruct_ro_set_string_same(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "set_string_same() in read-only instance of UnManagedStruct");
}
FLOATVAL
Parrot_UnManagedStruct_ro_shift_float(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "shift_float() in read-only instance of UnManagedStruct");
    return (FLOATVAL)0;
}
INTVAL
Parrot_UnManagedStruct_ro_shift_integer(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "shift_integer() in read-only instance of UnManagedStruct");
    return (INTVAL)0;
}
PMC*
Parrot_UnManagedStruct_ro_shift_pmc(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "shift_pmc() in read-only instance of UnManagedStruct");
    return PMCNULL;
}
STRING*
Parrot_UnManagedStruct_ro_shift_string(Interp *interp, PMC* pmc)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "shift_string() in read-only instance of UnManagedStruct");
    return (STRING*)0;
}
void
Parrot_UnManagedStruct_ro_splice(Interp *interp, PMC* pmc, PMC* value, INTVAL offset, INTVAL count)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "splice() in read-only instance of UnManagedStruct");
}
void
Parrot_UnManagedStruct_ro_thaw(Interp *interp, PMC* pmc, visit_info* info)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "thaw() in read-only instance of UnManagedStruct");
}
void
Parrot_UnManagedStruct_ro_thawfinish(Interp *interp, PMC* pmc, visit_info* info)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "thawfinish() in read-only instance of UnManagedStruct");
}
void
Parrot_UnManagedStruct_ro_unshift_float(Interp *interp, PMC* pmc, FLOATVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "unshift_float() in read-only instance of UnManagedStruct");
}
void
Parrot_UnManagedStruct_ro_unshift_integer(Interp *interp, PMC* pmc, INTVAL value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "unshift_integer() in read-only instance of UnManagedStruct");
}
void
Parrot_UnManagedStruct_ro_unshift_pmc(Interp *interp, PMC* pmc, PMC* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "unshift_pmc() in read-only instance of UnManagedStruct");
}
void
Parrot_UnManagedStruct_ro_unshift_string(Interp *interp, PMC* pmc, STRING* value)
 {
    internal_exception(WRITE_TO_CONSTCLASS,
            "unshift_string() in read-only instance of UnManagedStruct");
}
void
Parrot_UnManagedStruct_class_init(Parrot_Interp interp, int entry, int pass)
{
    const VTABLE temp_base_vtable = {
        NULL, /* namespace */
        enum_class_UnManagedStruct, /* base_type */
        NULL, /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_HAS_READONLY_FLAG, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        NULL,   /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_default_add_attribute,
        Parrot_default_add_method,
        Parrot_default_add_parent,
        Parrot_default_add_role,
        Parrot_default_assign_pmc,
        Parrot_default_assign_string_native,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_can,
        Parrot_default_class_type,
        Parrot_default_clone,
        Parrot_default_clone_pmc,
        Parrot_default_decrement,
        Parrot_UnManagedStruct_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_default_delete_keyed,
        Parrot_default_delete_keyed_int,
        Parrot_default_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_default_destroy,
        Parrot_default_does,
        Parrot_default_elements,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_default_find_method,
        Parrot_default_freeze,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_default_get_bool,
        Parrot_default_get_class,
        Parrot_UnManagedStruct_get_integer,
        Parrot_UnManagedStruct_get_integer_keyed,
        Parrot_UnManagedStruct_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_iter,
        Parrot_default_get_number,
        Parrot_UnManagedStruct_get_number_keyed,
        Parrot_UnManagedStruct_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_UnManagedStruct_get_pmc_keyed,
        Parrot_UnManagedStruct_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_UnManagedStruct_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_default_get_repr,
        Parrot_default_get_string,
        Parrot_UnManagedStruct_get_string_keyed,
        Parrot_UnManagedStruct_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_default_hash,
        Parrot_default_i_absolute,
        Parrot_default_i_bitwise_not,
        Parrot_default_i_bitwise_nots,
        Parrot_default_i_logical_not,
        Parrot_default_i_neg,
        Parrot_default_increment,
        Parrot_UnManagedStruct_init,
        Parrot_UnManagedStruct_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_default_instantiate,
        Parrot_default_invoke,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_logical_not,
        Parrot_UnManagedStruct_mark,
        Parrot_default_morph,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_new_from_string,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_pmc_namespace,
        Parrot_default_pop_float,
        Parrot_default_pop_integer,
        Parrot_default_pop_pmc,
        Parrot_default_pop_string,
        Parrot_default_push_float,
        Parrot_default_push_integer,
        Parrot_default_push_pmc,
        Parrot_default_push_string,
        Parrot_default_remove_attribute,
        Parrot_default_remove_method,
        Parrot_default_remove_parent,
        Parrot_default_remove_role,
        Parrot_default_set_attr,
        Parrot_default_set_attr_str,
        Parrot_default_set_bignum_int,
        Parrot_default_set_bignum_num,
        Parrot_default_set_bignum_str,
        Parrot_default_set_bool,
        Parrot_UnManagedStruct_set_integer_keyed,
        Parrot_UnManagedStruct_set_integer_keyed_int,
        Parrot_default_set_integer_keyed_str,
        Parrot_UnManagedStruct_set_integer_native,
        Parrot_default_set_integer_same,
        Parrot_UnManagedStruct_set_number_keyed,
        Parrot_UnManagedStruct_set_number_keyed_int,
        Parrot_default_set_number_keyed_str,
        Parrot_default_set_number_native,
        Parrot_default_set_number_same,
        Parrot_UnManagedStruct_set_pmc,
        Parrot_default_set_pmc_keyed,
        Parrot_default_set_pmc_keyed_int,
        Parrot_default_set_pmc_keyed_str,
        Parrot_UnManagedStruct_set_pointer,
        Parrot_default_set_pointer_keyed,
        Parrot_default_set_pointer_keyed_int,
        Parrot_default_set_pointer_keyed_str,
        Parrot_UnManagedStruct_set_string_keyed,
        Parrot_UnManagedStruct_set_string_keyed_int,
        Parrot_default_set_string_keyed_str,
        Parrot_default_set_string_native,
        Parrot_default_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_default_shift_float,
        Parrot_default_shift_integer,
        Parrot_default_shift_pmc,
        Parrot_default_shift_string,
        Parrot_default_slice,
        Parrot_default_splice,
        Parrot_default_subclass,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtype,
        Parrot_default_thaw,
        Parrot_default_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_type_keyed_int,
        Parrot_default_type_keyed_str,
        Parrot_default_unshift_float,
        Parrot_default_unshift_integer,
        Parrot_default_unshift_pmc,
        Parrot_default_unshift_string,
        Parrot_default_visit
    };

    const VTABLE temp_ro_vtable = {
        NULL, /* namespace */
        enum_class_UnManagedStruct, /* base_type */
        NULL, /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_IS_READONLY_FLAG, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        NULL,   /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_UnManagedStruct_ro_add_attribute,
        Parrot_UnManagedStruct_ro_add_method,
        Parrot_UnManagedStruct_ro_add_parent,
        Parrot_UnManagedStruct_ro_add_role,
        Parrot_UnManagedStruct_ro_assign_pmc,
        Parrot_UnManagedStruct_ro_assign_string_native,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_can,
        Parrot_default_class_type,
        Parrot_default_clone,
        Parrot_default_clone_pmc,
        Parrot_UnManagedStruct_ro_decrement,
        Parrot_UnManagedStruct_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_UnManagedStruct_ro_delete_keyed,
        Parrot_UnManagedStruct_ro_delete_keyed_int,
        Parrot_UnManagedStruct_ro_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_default_destroy,
        Parrot_default_does,
        Parrot_default_elements,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_UnManagedStruct_ro_find_method,
        Parrot_default_freeze,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_default_get_bool,
        Parrot_default_get_class,
        Parrot_UnManagedStruct_get_integer,
        Parrot_UnManagedStruct_get_integer_keyed,
        Parrot_UnManagedStruct_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_iter,
        Parrot_default_get_number,
        Parrot_UnManagedStruct_get_number_keyed,
        Parrot_UnManagedStruct_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_UnManagedStruct_get_pmc_keyed,
        Parrot_UnManagedStruct_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_UnManagedStruct_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_default_get_repr,
        Parrot_default_get_string,
        Parrot_UnManagedStruct_get_string_keyed,
        Parrot_UnManagedStruct_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_default_hash,
        Parrot_UnManagedStruct_ro_i_absolute,
        Parrot_UnManagedStruct_ro_i_bitwise_not,
        Parrot_UnManagedStruct_ro_i_bitwise_nots,
        Parrot_UnManagedStruct_ro_i_logical_not,
        Parrot_UnManagedStruct_ro_i_neg,
        Parrot_UnManagedStruct_ro_increment,
        Parrot_UnManagedStruct_init,
        Parrot_UnManagedStruct_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_default_instantiate,
        Parrot_default_invoke,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_logical_not,
        Parrot_UnManagedStruct_mark,
        Parrot_UnManagedStruct_ro_morph,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_new_from_string,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_pmc_namespace,
        Parrot_UnManagedStruct_ro_pop_float,
        Parrot_UnManagedStruct_ro_pop_integer,
        Parrot_UnManagedStruct_ro_pop_pmc,
        Parrot_UnManagedStruct_ro_pop_string,
        Parrot_UnManagedStruct_ro_push_float,
        Parrot_UnManagedStruct_ro_push_integer,
        Parrot_UnManagedStruct_ro_push_pmc,
        Parrot_UnManagedStruct_ro_push_string,
        Parrot_UnManagedStruct_ro_remove_attribute,
        Parrot_UnManagedStruct_ro_remove_method,
        Parrot_UnManagedStruct_ro_remove_parent,
        Parrot_UnManagedStruct_ro_remove_role,
        Parrot_UnManagedStruct_ro_set_attr,
        Parrot_UnManagedStruct_ro_set_attr_str,
        Parrot_UnManagedStruct_ro_set_bignum_int,
        Parrot_UnManagedStruct_ro_set_bignum_num,
        Parrot_UnManagedStruct_ro_set_bignum_str,
        Parrot_UnManagedStruct_ro_set_bool,
        Parrot_UnManagedStruct_ro_set_integer_keyed,
        Parrot_UnManagedStruct_ro_set_integer_keyed_int,
        Parrot_UnManagedStruct_ro_set_integer_keyed_str,
        Parrot_UnManagedStruct_ro_set_integer_native,
        Parrot_UnManagedStruct_ro_set_integer_same,
        Parrot_UnManagedStruct_ro_set_number_keyed,
        Parrot_UnManagedStruct_ro_set_number_keyed_int,
        Parrot_UnManagedStruct_ro_set_number_keyed_str,
        Parrot_UnManagedStruct_ro_set_number_native,
        Parrot_UnManagedStruct_ro_set_number_same,
        Parrot_UnManagedStruct_ro_set_pmc,
        Parrot_UnManagedStruct_ro_set_pmc_keyed,
        Parrot_UnManagedStruct_ro_set_pmc_keyed_int,
        Parrot_UnManagedStruct_ro_set_pmc_keyed_str,
        Parrot_UnManagedStruct_ro_set_pointer,
        Parrot_UnManagedStruct_ro_set_pointer_keyed,
        Parrot_UnManagedStruct_ro_set_pointer_keyed_int,
        Parrot_UnManagedStruct_ro_set_pointer_keyed_str,
        Parrot_UnManagedStruct_ro_set_string_keyed,
        Parrot_UnManagedStruct_ro_set_string_keyed_int,
        Parrot_UnManagedStruct_ro_set_string_keyed_str,
        Parrot_UnManagedStruct_ro_set_string_native,
        Parrot_UnManagedStruct_ro_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_UnManagedStruct_ro_shift_float,
        Parrot_UnManagedStruct_ro_shift_integer,
        Parrot_UnManagedStruct_ro_shift_pmc,
        Parrot_UnManagedStruct_ro_shift_string,
        Parrot_default_slice,
        Parrot_UnManagedStruct_ro_splice,
        Parrot_default_subclass,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtype,
        Parrot_UnManagedStruct_ro_thaw,
        Parrot_UnManagedStruct_ro_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_type_keyed_int,
        Parrot_default_type_keyed_str,
        Parrot_UnManagedStruct_ro_unshift_float,
        Parrot_UnManagedStruct_ro_unshift_integer,
        Parrot_UnManagedStruct_ro_unshift_pmc,
        Parrot_UnManagedStruct_ro_unshift_string,
        Parrot_default_visit
    };

    const  MMD_init _temp_mmd_init[] = {
        { MMD_EQ, 0, enum_type_PMC, (funcptr_t) Parrot_UnManagedStruct_is_equal }
    };
    /*  Dynamic PMCs need the runtime type
    which is passed in entry to class_init.
    */
    if (pass == 0) {
        /*
         * create vtable - clone it - we have to set a few items
         */
        VTABLE *vt_clone =
            Parrot_clone_vtable(interp, &temp_base_vtable);
        VTABLE *vt_ro_clone =
            Parrot_clone_vtable(interp, &temp_ro_vtable);
        vt_clone->whoami = CONST_STRING(interp, "UnManagedStruct");
        vt_clone->isa_str = CONST_STRING(interp, "UnManagedStruct");
        vt_clone->does_str = CONST_STRING(interp, "scalar");
        vt_ro_clone->base_type = entry;
        vt_ro_clone->whoami = vt_clone->whoami;
        vt_ro_clone->isa_str = vt_clone->isa_str;
        vt_ro_clone->does_str = vt_clone->does_str;
        vt_clone->ro_variant_vtable = vt_ro_clone;
        vt_ro_clone->ro_variant_vtable = vt_clone;
        interp->vtables[entry] = vt_clone;
    }
    else { /* pass */
        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        /* create PMC Proxy object */
        Parrot_create_pmc_proxy(interp, entry);
        /* class_init */
        {
#define N_MMD_INIT (sizeof(_temp_mmd_init)/sizeof(_temp_mmd_init[0]))
            Parrot_mmd_register_table(interp, entry,
                _temp_mmd_init, N_MMD_INIT);
        }
    } /* pass */
} /* Parrot_UnManagedStruct_class_init */


/*

=back

=head1 HISTORY

Initial revision by sean 2002/08/04

=head1 SEE ALSO

F<docs/pmc/struct.pod>

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
